Quick installation notes for running Chipster service in a single Linux system.


Requirements
============
- Java 1.5+
- R-2.6.1
- the following tcp ports open in the firewall
	- 61616 for message broker service
	- 8080 for file broker service
	- 8081 for webstart service (optional)


1) Installing needed R libraries
================================
To install the R libraries needed by Chipster, run (as root if needed):

	./install_r_pkg.sh


2) Configuring Chipster services
================================
To configure the Chipster services, run the following to scripts. Both 
scripts will ask for confirmation before writing changes to files. 
Defaults should be fine for a local installation. 

	./configure.sh
	./genpasswd.sh
	

3) Starting and stopping Chipster services
==========================================
To start all the Chipster services, run:

	./chipster start
	
In addition to 'start', 'stop', 'restart', and 'status' can also be used.


4) Testing the installation with the client
===========================================
To start the client locally (on the same machine as the services), run:

	./client/bin/chipster-client

To start the client from other machines using Java Web Start, go to the 
Web Start address specified when running the configure.sh. Default address is:

	http://hostname-of-this-machine:8081 

The default username/password is chipster/chipster.
	

Welcome to Apache ActiveMQ 
=======================================================================
Apache ActiveMQ is a high performance Apache 2.0 licensed Message 
Broker and JMS 1.1 implementation.

Getting Started
===============
To help you get started, try the following links:-

Getting Started
http://activemq.apache.org/getting-started.html

Building
http://activemq.apache.org/getting-started.html#GettingStarted-WindowsSourceInstallation
http://activemq.apache.org/getting-started.html#GettingStarted-UnixSourceInstallation

Examples
http://activemq.apache.org/examples.html

We welcome contributions of all kinds, for details of how you can help
http://activemq.apache.org/contributing.html

Please refer to the website for details of finding the issue tracker, 
email lists, wiki or IRC channel at http://activemq.apache.org/

Please help us make Apache ActiveMQ better - we appreciate any feedback 
you may have.

Enjoy!

Licensing
=======================================================================

   This software is licensed under the terms you may find in the file 
   named "LICENSE.txt" in this directory.

   This distribution includes cryptographic software.  The country in 
   which you currently reside may have restrictions on the import, 
   possession, use, and/or re-export to another country, of 
   encryption software.  BEFORE using any encryption software, please 
   check your country's laws, regulations and policies concerning the
   import, possession, or use, and re-export of encryption software, to 
   see if this is permitted.  See <http://www.wassenaar.org/> for more
   information.

   The U.S. Government Department of Commerce, Bureau of Industry and
   Security (BIS), has classified this software as Export Commodity 
   Control Number (ECCN) 5D002.C.1, which includes information security
   software using or performing cryptographic functions with asymmetric
   algorithms.  The form and manner of this Apache Software Foundation
   distribution makes it eligible for export under the License Exception
   ENC Technology Software Unrestricted (TSU) exception (see the BIS 
   Export Administration Regulations, Section 740.13) for both object 
   code and source code.

   The following provides more details on the included cryptographic
   software:
   
   ActiveMQ supports the use of SSL TCP connections when used with 
   with a JVM supporting the Java Cryptography extensions
   <http://java.sun.com/javase/technologies/security/>.  ActiveMQ does 
   not include these libraries itself, but is designed to use them.

Transactions Demo
=================
This example is an ActiveMQ implementation of the "TransactedExample" from
Sun's JMS Tutorial (http://java.sun.com/products/jms/tutorial/index.html).

The example simulates a simplified eCommerce application with four parts:
the retailer who places the orders, the vendor who assemples the computers,
and two suppliers--one for hard drives and another for monitors.

The retailer sends a message to the vendor's queue and awaits a reply.
The vendor receives the message and sends a message to each of the
supplier's queues. It does this in a single transaction, and will randomly
throw an exception simulating a database error, triggering a rollback.
Each supplier receives the order, checks inventory and replies to the
message stating how many items were sent.
The vendor collects both responses and responds to the retailer, notifying
wheather it cna fulfill the complete order or not.
The retailer receives the message from the vendor.

Running the Example
===================
To run the complete demo in a single JVM, with ActiveMQ running on the local
computer:
  ant transactions_demo

If you are running ActiveMQ on a non-standard port, or on a different host,
you can pass a url on the commandline:
  ant -Durl=tcp://localhost:61616 transactions_demo

If your ActiveMQ instance is password-protected, you can also pass a
username and password on the command line:
  ant -Duser=myusername -Dpassword=supersecret transactions_demo

You can also run the individual components seperately, again with optional
url and/or authentication parameters:
  ant retailer &
  ant vendor &
  ant hdsupplier &
  ant monitorsupplier &

Prereqs
=======

- Install RubyGems see: http://docs.rubygems.org/
- Install the stomp gem.  Run: gem install stomp

Overview of stompcat.rb and catstomp.rb 
==========================================

The basic idea behind these scripts to to create something like netcat except over JMS destinations.

catstomp - takes stdin and sends it to a stomp destination
stompcat - outputs data received from a stomp destination

A simple example usage:

In console 1 run:
cat | ./catstomp.rb

In console 2 run:
./stompcat.rb

now any line you enter into console 1 will get sent to console 2.

Hopefully these to scripts can get merged together in the future and the command line arguments can change
so that it look more like netcat.

# TOOL tagcleaner-statistics.R: "Statistics for primers/adaptors" (Prints the number of tag (i.e. the primer/adapter\) sequences matching for different numbers of mismatches. No trimming will be performed. This tool is based on TagCleaner.)
# INPUT reads: "FASTQ/FASTA file" TYPE GENERIC
# OUTPUT tag.statistics.tsv
# PARAMETER input.type: "Input type" TYPE [FASTQ, FASTA] DEFAULT FASTQ (Input type.)
# PARAMETER tag5: "Tag sequence at 5'-end" TYPE STRING DEFAULT "-" (Tag sequence at 5'-end.)
# PARAMETER tag3: "Tag sequence at 3'-end" TYPE STRING DEFAULT "-" (Tag sequence at 3'-end.)


# AMS 2013.02.18

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads")

# binary
tagcleaner.binary <- c(file.path(chipster.tools.path, "tagcleaner", "tagcleaner.pl"))

# options
options <- paste("")
if (input.type == "FASTQ"){
	options <- paste(options, "-fastq reads")
}
if (input.type == "FASTA"){
	options <- paste(options, "-fasta reads")
}
# options for parameters
notags <- TRUE
if (tag3 != "-"){
	options <- paste(options, "-tag3", tag3)
	notags <- FALSE	
}
if (tag5 != "-"){
	options <- paste(options, "-tag5", tag5)
	notags <- FALSE
}
if (notags){
	stop('CHIPSTER-NOTE: No tag sequence specified. If tags are unknow, you can first use the "Predict primers/adaptors" tool.')
}
# common options
options <- paste(options, "-64")
options <- paste(options, "-stats")

# command
command <- paste(tagcleaner.binary, options, "> tag.statistics.tsv")

# run
system(command)

# TOOL samtools-snp-indel-single.R: "Call SNPs and short INDELs" (Calls SNPs and short INDELs for one or more diploid individuals. Alignment records are grouped by sample identifiers in @RG header lines. If sample identifiers are absent, each input file is regarded as one sample. You can provide your own reference sequence in FASTA format or choose one of the provided reference genomes. This tool is based on the SAMtools package.)
# INPUT alignment{...}.bam: "Sorted BAM files" TYPE BAM 
# INPUT OPTIONAL ownref.fa: "Reference sequence FASTA" TYPE GENERIC
# OUTPUT variants.vcf
# PARAMETER ref: "Reference sequence" TYPE [hg19.fa: "Human (hg19\)", mm9.fa: "Mouse (mm9\)", mm10.fa: "Mouse (mm10\)", rn4.fa: "Rat (rn4\)", Sus_scrofa.Sscrofa10.2.69.dna.toplevel.fa: "Pig (Sscrofa10.2.69\)", Gallus_gallus.Gallus_gallus-4.0.pre.fa: "Chicken (4.0\)", Bos_taurus.UMD3.1.69.dna.toplevel.fa: "Cow (UMD3.1.69\)"] DEFAULT hg19.fa (Reference sequence. Please note that the chr-versions of reference genomes are not available for pig, chicken and cow.)
# PARAMETER chr: "Chromosome names in my BAM file look like" TYPE [yes: "chr1", no: "1"] DEFAULT no (Chromosome names must match in the BAM file and in the reference sequence. Check your BAM and choose accordingly. This only applies to provided reference genomes.)
# PARAMETER mpileup.r: "Call variants only for a certain region" TYPE STRING DEFAULT all (Only generate pileup in defined region. Region given as chromosome:start-end, e.g. 20:131505-131550.)
# PARAMETER OPTIONAL mpileup.ub: "Disable probabilistic realignment for computation of BAC" TYPE [yes, no] DEFAULT no (Disable probabilistic realignment for the computation of base alignment quality (BAQ\). BAQ is the Phred-scaled probability of a read base being misaligned. Applying this option greatly helps to reduce false SNPs caused by misalignments.)
# PARAMETER OPTIONAL mpileup.uc: "Downgrading coefficient" TYPE INTEGER DEFAULT 0 (Coefficient for downgrading mapping quality for reads containing excessive mismatches. The recommended value for BWA is 50. A zero value disables this functionality.)
# PARAMETER OPTIONAL mpileup.q: "Minimum mapping quality for an alignment to be used" TYPE INTEGER DEFAULT 0 (Minimum mapping quality for an alignment to be used. Default is 0.)
# PARAMETER OPTIONAL mpileup.uq: "Minimum base quality for a base to be considered" TYPE INTEGER DEFAULT 13 (Minimum base quality for a base to be considered. Default is 13.)
# PARAMETER OPTIONAL mpileup.ud: "Output per sample read depth" TYPE [yes, no] DEFAULT no (Output per-sample read depth.)
# PARAMETER OPTIONAL mpileup.us: "Output per sample strand bias P-value" TYPE [yes, no] DEFAULT no (Output per-sample Phred-scaled strand bias P-value.)
# PARAMETER OPTIONAL mpileup.ui: "Call only SNPs, indels not considered" TYPE [yes, no] DEFAULT no (Do not perform INDEL calling.)
# PARAMETER OPTIONAL bfctools.un: "Skip sites where reference is ambiguous" TYPE [yes, no] DEFAULT no (Skip sites where the REF field is not A/C/G/T.)
# PARAMETER OPTIONAL bfctools.e: "Use maximum likelihood to score variants, and perform HWE analysis" TYPE [yes, no] DEFAULT no (Perform max-likelihood inference only, including estimating the site allele frequency, testing Hardy-Weinberg equlibrium and testing associations with LRT.)
# PARAMETER OPTIONAL vcfutils.d: "Minimum read depth" TYPE INTEGER DEFAULT 2 (Minimum read depth.)
# PARAMETER OPTIONAL vcfutils.ud: "Maximum read depth" TYPE INTEGER DEFAULT 100 (Maximum read depth. Should be adjusted to about twice the average read depth.)

# AMS 30.5.2012
# AMS 17.08.2012: Additional parameters as suggested by Jarno

# binaries
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))
bcftools.binary <- c(file.path(chipster.tools.path, "samtools", "bcftools", "bcftools"))
vcfutils.binary <- c(file.path(chipster.tools.path, "samtools", "bcftools", "vcfutils.pl"))

# path to internal reference sequences
path.refseqs <- c(file.path(chipster.tools.path, "bowtie", "indexes"))

# check which reference sequence to use: own/internal
ref.seq <- ""
input_files <- dir()
is_own <- (length(grep("ownref.fa", input_files))>0)
if (is_own) {
	ref.seq <- paste("ownref.fa")	
} else {
	if (chr == "yes"){
		ref.seq <- c(file.path(path.refseqs, ref))
	}else{
		ref.seq <- c(file.path(path.refseqs, "nochr", ref))
	}
}


# mpileup otions
mpileup.options <- paste("mpileup -u")
if (mpileup.r != "all"){
	mpileup.options <- paste(mpileup.options, "-r", mpileup.r)
}
if (mpileup.ub == "yes") {
	mpileup.options <- paste(mpileup.options, "-B")
}
mpileup.options <- paste(mpileup.options, "-C", mpileup.uc)
mpileup.options <- paste(mpileup.options, "-q", mpileup.q)
mpileup.options <- paste(mpileup.options, "-Q", mpileup.uq)
if (mpileup.ud == "yes") {
	mpileup.options <- paste(mpileup.options, "-D")
}
if (mpileup.us == "yes") {
	mpileup.options <- paste(mpileup.options, "-S")
}
if (mpileup.ui == "yes") {
	mpileup.options <- paste(mpileup.options, "-I")
}


# bcftools options
bcftools.options <- paste("view -bcg")
if (bfctools.un == "yes") {
	bcftools.options <- paste(bcftools.options, "-N")
}
if (bfctools.e == "yes") {
	bcftools.options <- paste(bcftools.options, "-e")
}


# vcfutils otions
vcfutils.options <- paste("varFilter", "-d", vcfutils.d,"-D", vcfutils.ud)


# commands
command1 <- paste(samtools.binary, mpileup.options, "-f", ref.seq, "*.bam", "|", bcftools.binary, bcftools.options, "- > var.raw.bcf")
command2 <- paste(bcftools.binary, "view var.raw.bcf |", vcfutils.binary, vcfutils.options, "> variants.vcf")

# run
#stop(paste('CHIPSTER-NOTE: ', command1))
system(command1)
system(command2)

## Use install utility functions
source("/opt/chipster/comp/modules/admin/R-2.14/smip.R")

## Install packages, and dependencies, from CRAN
install.packages(repos="http://ftp.sunet.se/pub/lang/CRAN", dependencies=TRUE, pkgs="locfit")

## Install packages from Bioconductor

source("http://bioconductor.org/biocLite.R")

# Bionductor core packages
biocLite()

# Bioconductor specific packages
biocLite("DESeq")
biocLite("RPA")

# hdrcde
biocLite(c("locfit", "ash", "ks")) # install hdrcde dependencies manually
smart.install.packages(url.package="http://cran.r-project.org/src/contrib/00Archive/hdrcde/hdrcde_2.15.tar.gz") # install hdrcde manually because correct version is needed for R-2.14

# methylumi packages
biocLite(c("lumi", "methylumi", "annotate")) # install hdrcde dependencies manually
biocLite("IlluminaHumanMethylation450k.db") # annotation package, not needed if all annotation packages from the repository are installed
biocLite("IlluminaHumanMethylation27k.db") # annotation package, not needed if all annotation packages from the repository are installed

# TOOL qc-cdna.R: cDNA (cDNA quality control using boxplots, density plots, and MA plots. This tool should be run on normalized data.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT boxplot.pdf: boxplot.pdf 
# OUTPUT densityplot.pdf: densityplot.pdf 
# OUTPUT OPTIONAL MA-plot.pdf: MA-plot.pdf 
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)

# Quality control of cDNA chips
# 30.6.2006 JTT
# modified, IS, 12.10.2012, to cope with tables with gene descriptions (that typically contain 's)

# Loads the libraries
library(limma)

# Renaming variables
w<-image.width
h<-image.height

# Reads in the data
file <- 'normalized.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, check.names=FALSE)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]
A<-dat[,grep("average", names(dat))]

# Producing some basic plots of the data

# Boxplot
pdf(file="boxplot.pdf", width=w/72, height=h/72)
boxplot(as.data.frame(dat2), las=2, cex.axis=0.5)
dev.off()

# Density plot
pdf(file="densityplot.pdf", width=w/72, height=h/72)
x<-c()
y<-c()
for(i in 1:ncol(dat2)) {
   x<-cbind(x, density(dat2[,i])$x)
   y<-cbind(y, density(dat2[,i])$y)
}
plot(x[,1], y[,1], col=1, ylim=c(0, max(y)), main="M intensities", type="l", lwd=2, lty=1, xlab = "M", ylab = "Density")
for(i in 2:ncol(dat2)) {
   lines(x[,i], y[,i], col=i, lwd=2, lty=1)
}
legend(legend=colnames(dat2), x="topright", lty=1, cex=0.75, col=c(1:ncol(dat2)))
dev.off()

# MA plot
if (ncol(A) > 0) {
  pdf(file="MA-plot.pdf", width=w/72, height=h/72)
  par(mfrow=c(ceiling(sqrt(ncol(dat2))), ceiling(sqrt(ncol(dat2)))))
  ylim<-c(min(na.omit(dat2)), max(na.omit(dat2)))
  for(i in 1:ncol(dat2)) {
    par(mar=c(0, 1, 1, 0)+0.1)
    plot(A[,i], dat2[,i], xaxt="n", xlab=NULL, ylab=NULL, main=paste("Chip", i, sep=" "), cex.main=0.75, cex.axis=0.7, cex.lab=0.75, tck=-0.01, mgp=c(3,0.2,0), ylim=ylim)
    d<-na.omit(data.frame(A=A[,i], dat=dat2[,i]))
    lines(lowess(d$A, d$dat), col="red")
  }
  dev.off()
}

# EOF

# TOOL ngs-up-down-analysis-mirna.R: "Up-down analysis of miRNA targets" (Given a dataset of miRNA expression and a dataset of gene expression for a two-group comparison experiment, this tool identifies the genes whose expression is upregulated in response to an downregulated miRNA, or vice-versa. It is recommended that the two data sets have been filtered to exclude low quality and or invariable data and subjected to statistical testing for significant differences in expression between the two experiment groups. NOTE you need to assign a higher number to the samples belonging to the treatment grop in the column describing the experiment group for the calculations to be correct.)
# INPUT normalized_mirna.tsv: normalized_mirna.tsv TYPE GENE_EXPRS 
# INPUT normalized_gene.tsv: normalized_gene.tsv TYPE GENE_EXPRS 
# INPUT phenodata_mirna.tsv: phenodata_mirna.tsv TYPE GENERIC 
# INPUT phenodata_gene.tsv: phenodata_gene.tsv TYPE GENERIC 
# OUTPUT mirna-up-gene-down.tsv: mirna-up-gene-down.tsv 
# OUTPUT mirna-down-gene-up.tsv: mirna-down-gene-up.tsv 
# PARAMETER average.method: average.method TYPE [mean: mean, median: median] DEFAULT median (The method to calculate the average of samples in each experiment group.)
# PARAMETER groups.column.mirna: groups.column.mirna TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the experiment groups of the samples in the miRNA expression dataset.)
# PARAMETER groups.column.gene: groups.column.gene TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the experiment groups of the samples in the gene expression dataset.)
# PARAMETER id.type: id.type TYPE [probe_id: probe_id, entrez_id: entrez_id] DEFAULT probe_id (Defines the type of gene identifier to use. For supported array types from Affymetrix, Agilent or Illumina probe_id should be used, whereas for custom arrays entrez_id should be used.)

# Up-down analysis of miRNA targets
# MG, 25.2.2010
# MG, 10.2.2011, now gets the gene symbols from the org.HS.eg.db package and adds rownames the output tables to allow use of Venn diagram

# Loads the libraries
library(RmiR)
library(org.Hs.eg.db)

# Loads the normalized data and phenodata files
data_1 <- read.table(file="normalized_mirna.tsv", header=T, sep="\t", row.names=1)
data_2 <- read.table(file="normalized_gene.tsv", header=T, sep="\t", row.names=1)
phenodata_1 <- read.table("phenodata_mirna.tsv", header=T, sep="\t")
phenodata_2 <- read.table("phenodata_gene.tsv", header=T, sep="\t")

# Figure out which is the miRNA data
if (phenodata_1$chiptype[1] == "miRNA") {
	mirna.phenodata <- phenodata_1
	mirna.data <- data_1
	gene.phenodata <- phenodata_2
	gene.data <- data_2
}
if (phenodata_2$chiptype[1] == "miRNA") {
	mirna.phenodata <- phenodata_2
	mirna.data <- data_2
	gene.phenodata <- phenodata_1
	gene.data <- data_1
}

# Separates expression values and flags
mirna.data.2 <- mirna.data[,grep("chip", names(mirna.data))]
gene.data.2 <- gene.data[,grep("chip", names(gene.data))]

# Get experiment groups from for the two datasets
mirna.groups <- mirna.phenodata[,grep(groups.column.mirna, colnames(mirna.phenodata))]
gene.groups <- gene.phenodata[,grep(groups.column.gene, colnames(gene.phenodata))]

# Sanity checks to make sure only two experiment groups exist in the two datasets
if(length(unique(mirna.groups))==1 | length(unique(mirna.groups))>=3) {
	stop("You need to have exactly two groups in the miRNA expression dataset to run this analysis")
}
if(length(unique(gene.groups))==1 | length(unique(gene.groups))>=3) {
	stop("You need to have exactly two groups in the gene expression dataset to run this analysis")
}

# Calculate the average expression for the different experiment groups
mirna.average.1 <- mirna.data.2[,mirna.groups==sort(unique(mirna.groups), decreasing=TRUE)[1]]
mirna.average.1 <- apply(mirna.average.1, FUN=average.method, MARGIN=1)
mirna.average.2 <- mirna.data.2[,mirna.groups==sort(unique(mirna.groups), decreasing=TRUE)[2]]
mirna.average.2 <- apply(mirna.average.2, FUN=average.method, MARGIN=1)
mirna.ratio <- mirna.average.1-mirna.average.2
gene.average.1 <- gene.data.2[,gene.groups==sort(unique(gene.groups), decreasing=TRUE)[1]]
gene.average.1 <- apply(gene.average.1, FUN=average.method, MARGIN=1)
gene.average.2 <- gene.data.2[,gene.groups==sort(unique(gene.groups),decreasing=TRUE)[2]]
gene.average.2 <- apply(gene.average.2, FUN=average.method, MARGIN=1)
gene.ratio <- gene.average.1-gene.average.2

# Read the chiptype that was used for the gene expression data
if (id.type=="probe_id") {
	chip.type <- as.character(gene.phenodata[1,grep("chiptype", names(gene.phenodata))])
}
if (id.type=="entrez_id") {
	chip.type <- "org.Hs.eg.db"
}

# Construct datasets suitable for read.mir() function
mirna.data.3 <- cbind(names(mirna.ratio),as.numeric(mirna.ratio))
gene.data.3 <- cbind(names(gene.ratio),as.numeric(gene.ratio))
mirna.data.4 <- as.data.frame(mirna.data.3)
gene.data.4 <- as.data.frame(gene.data.3)
mirna.data.4[,2] <- as.numeric(mirna.data.3[,2])
gene.data.4[,2] <- as.numeric(gene.data.3[,2])

# Check that the gene list actually contain at least one miRNA target
try(merged.table <- read.mir(gene=gene.data.4, mirna=mirna.data.4,
				annotation=chip.type), silent=FALSE)
if (match("merged.table",ls(),nomatch=0)==0) {
	stop("There were no targets found in either TarBase or PicTar databases
					for the supplied list of miRNA:s in the gene list selected.
					Try again by selecting a longer list of genes!")
}
merged.table <- read.mir(gene=gene.data.4, mirna=mirna.data.4,
		annotation=chip.type, verbose=TRUE)

# Change the symbols that come from the read.mir() function into
# the ones that come from the org.Hs.eg.db package
all_genes <- org.Hs.egSYMBOL
mapped_genes <- mappedkeys(all_genes)
mapped_genes  <- as.list(all_genes[mapped_genes])
symbols_list <- unlist(mapped_genes[as.character(merged.table$gene_id) ])
merged.table$symbol <- symbols_list

# Change the column names for sake of consistency with other tools
colnames (merged.table) [1] <- "entrez_id"
colnames (merged.table) [2] <- "miRNA"

# Add rownames to allow use of Venn diagrams
# Construct the names from combining the miRNA nameand the target gene symbol
rownames (merged.table) <- paste (merged.table[,2],"_",merged.table[,4],sep="")

# Identify the miRNA-gene pairs that are behaving oppositely
mirna.ratio <- merged.table$mirExpr
gene.ratio <- merged.table$geneExpr
up.mirna.down.gene <- merged.table[(mirna.ratio>=0 & gene.ratio<0),1:5]
down.mirna.up.gene <- merged.table[(mirna.ratio<0 & gene.ratio>=0),1:5]

# Write the results to tables to be read into Chipster
write.table(up.mirna.down.gene, file="mirna-up-gene-down.tsv", sep="\t", quote=FALSE, row.names=TRUE)
write.table(down.mirna.up.gene, file="mirna-down-gene-up.tsv", sep="\t", quote=FALSE, row.names=TRUE)

# EOF

# TOOL annotate-genelist2html.R: "Agilent, Affymetrix or Illumina genelist" (Annotates the genes, and creates a web page of the result. Currently, this function only works with Agilent, Affymetrix and Illumina data if annotation packages for the used chip types are available.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT annotations.html: annotations.html 
# OUTPUT annotations.tsv: annotations.tsv 
# PARAMETER expression.column: expression.column TYPE COLUMN_SEL DEFAULT EMPTY (Column that contains the expression values)
# PARAMETER p.value.column: p.value.column TYPE COLUMN_SEL DEFAULT EMPTY (Column that contains the p-values)


# Creates an HTML file of Affymetrix genelist annotations
# JTT 13.6.2006

# Parameter settings (default) for testing purposes
#expression.column<-"EMPTY"
#p.value.column<-"EMPTY"

# Reads the chiptype from phenodata table
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
if(phenodata$chiptype[1]!="cDNA" | phenodata$chiptype[1]!="Illumina") {
   # Saves the chiptype into object lib
   lib<-phenodata$chiptype[1]
   lib<-as.character(lib)
}

# Account for the fact that annotation packages are from version 2.3 of Bioconductor
# named with an ".db" suffix. Add the suffix when missing to support data files
# from Chipster 1.3 and earlier. 
if (length(grep(".db", lib)) == 0 & length(grep("pmcdf", lib)) == 0) {
        lib <- paste(lib, ".db", sep="")
}

# Loads the correct annotation library
library(package=lib, character.only=T)
library(annaffy)

# Loads the data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Creating annotations from the library
if(expression.column=="EMPTY" & p.value.column=="EMPTY") {
   annot.cols<-aaf.handler()
   annot.table<-aafTableAnn(row.names(dat), lib, annot.cols)
   saveHTML(annot.table, "annotations.html", title="Annotations for the selected gene list")
   saveText(annot.table, "annotations.tsv")
}

if(expression.column!="EMPTY" & p.value.column=="EMPTY") {
   annot.cols<-aaf.handler()
   annot.table<-aafTableAnn(row.names(dat), lib, annot.cols)
   expression<-data.frame(FoldChange=dat[,grep(expression.column, colnames(dat))])
   rownames(expression)<-rownames(dat)
   expression<-aafTable(items=expression, signed=T)
   expression@probeids<-rownames(dat)
   annot.table2<-merge(annot.table, expression)
   saveHTML(annot.table2, "annotations.html", title="Annotations for the selected gene list")
   saveText(annot.table2, "annotations.tsv")
}

if(expression.column=="EMPTY" & p.value.column!="EMPTY") {
   annot.cols<-aaf.handler()
   annot.table<-aafTableAnn(row.names(dat), lib, annot.cols)
   pvalues<-data.frame(P.Adjusted=dat[,grep(p.value.column, colnames(dat))])
   rownames(pvalues)<-rownames(dat)
   pvalues<-aafTable(items=pvalues)
   pvalues@probeids<-rownames(dat)
   annot.table2<-merge(annot.table, pvalues)
   saveHTML(annot.table2, "annotations.html", title="Annotations for the selected gene list")
   saveText(annot.table2, "annotations.tsv")
}

if(expression.column!="EMPTY" & p.value.column!="EMPTY") {
   annot.cols<-aaf.handler()
   annot.table<-aafTableAnn(row.names(dat), lib, annot.cols)
   expression<-data.frame(FoldChange=dat[,grep(expression.column, colnames(dat))])
   rownames(expression)<-rownames(dat)
   expression<-aafTable(items=expression, signed=T)
   expression@probeids<-rownames(dat)
   annot.table2<-merge(annot.table, expression)
   pvalues<-data.frame(P.Adjusted=dat[,grep(p.value.column, colnames(dat))])
   rownames(pvalues)<-rownames(dat)
   pvalues<-aafTable(items=pvalues)
   pvalues@probeids<-rownames(dat)
   annot.table3<-merge(annot.table2, pvalues)
   saveHTML(annot.table3, "annotations.html", title="Annotations for the selected gene list")
   saveText(annot.table3, "annotations.tsv")
}

# TOOL norm-affy-RPA.R: Affymetrix (Affymetrix preprocessing using CEL-files. Probe sets are automatically flagged using P A M flags. Variance stabilization can be applied only with MAS5 or Plier preprocessing methods. Custom chiptype can't be used with Plier preprocessing.)
# INPUT microarray{...}.cel: microarray{...}.cel TYPE AFFY 
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# PARAMETER normalization.method: normalization.method TYPE [mas5: mas5, plier: plier, rma: rma, rpa: rpa, gcrma: gcrma, li-wong: li-wong] DEFAULT rma (Preprocessing method)
# PARAMETER stabilize.variance: stabilize.variance TYPE [yes: yes, no: no] DEFAULT no (Variance stabilazing normalization)
# PARAMETER custom.chiptype: custom.chiptype TYPE [empty: empty, hgu133ahsentrezg(hgu133a): hgu133ahsentrezg(hgu133a), hgu133a2hsentrezg(hgu133av2): hgu133a2hsentrezg(hgu133av2), hgu133phsentrezg(hgu133plus): hgu133phsentrezg(hgu133plus), hgu133plus2hsentrezg(hgu133plus2): hgu133plus2hsentrezg(hgu133plus2), hgu133bhsentrezg(hgu133b): hgu133bhsentrezg(hgu133b), hgu95av2hsentrezg(hgu95av2): hgu95av2hsentrezg(hgu95av2), moe430ammentrezg(moe430a): moe430ammentrezg(moe430a), moe430bmmentrezg(moe430b): moe430bmmentrezg(moe430b), mouse430a2mmentrezg(mouse430a2): mouse430a2mmentrezg(mouse430a2), mouse4302mmentrezg(mouse4302): mouse4302mmentrezg(mouse4302), mm74av1mmentrezg(mgu74a): mm74av1mmentrezg(mgu74a), mgu74av2mmentrezg(mgu74av2): mgu74av2mmentrezg(mgu74av2), mgu74bv2mmentrezg(mgu74bv2): mgu74bv2mmentrezg(mgu74bv2), mgu74cv2mmentrezg(mgu74cv2): mgu74cv2mmentrezg(mgu74cv2), rae230arnentrezg(rae230a): rae230arnentrezg(rae230a), rae230brnentrezg(rae230b): rae230brnentrezg(rae230b), rat2302rnentrezg(rat2302): rat2302rnentrezg(rat2302), rgu34arnentrezg(rgu34a): rgu34arnentrezg(rgu34a), rgu34brnentrezg(rgu34b): rgu34brnentrezg(rgu34b), rgu34crnentrezg(rgu34c): rgu34crnentrezg(rgu34c)] DEFAULT empty (custom chiptype)


# Affymetrix normalization
# JTT 8.6.2006
# Changes to column naming on 29.6.2006
# Changes to phenodata table writing on 29.1.2007
# Modified to work with R 2.9.0 on 12th May 2009
# Modifications by MG
# Changes to custom.chiptype PARAMETER to account for changes in naming of custom CDF packages (version 12), 23.9.2009
# Changes to cope with dropped custom package support for certain array types, 12.11.2009
# RPA method added 4.1.2011 (Leo Lahti)

# Renaming variables
norm<-normalization.method
stabvar<-stabilize.variance


# Initializes analyses
library(affy)
library(gcrma)
library(RPA)

# Reads in data
dat<-ReadAffy()

# Modifies the data objects to take custom chiptype into account
if(custom.chiptype!="empty") {
   chiptype<-custom.chiptype
   library(Biostrings)
   chiptype<-substr(x=chiptype, start=1, stop=(matchPattern("(", chiptype)@start-1))
   dat@annotation<-chiptype
   dat@cdfName<-chiptype
} else {
   chiptype<-dat@annotation
}

# Since custom annotation packages are no longer supported for hgu133plu
# and for mm74av1 the packages for hgu133plu2 and for mm74av2 are going to
# be used instead
if (chiptype=="hgu133phsentrezg") {
	chiptype <- "hgu133plus2hsentrezg("
}
if (chiptype=="mm74av1mmentrezg") {
	chiptype <- "mm74av2mmentrezg"
}

# Normalizations (MAS5, RMA, GCRMA or Li-Wong (dChip))

# MAS5 normalization
if(norm=="mas5") {
   dat2<-exprs(mas5(dat))
   calls<-exprs(mas5calls(dat))
   if(stabvar=="yes") {
      if(ncol(dat2)<2) {
         stop("You need to have at least two chip to be able to use VSN!")
      }
      library(vsn)
      dat2<-exprs(vsn(dat2))
   } else {
      dat2<-log2(dat2)
   }
   dat2<-as.data.frame(round(dat2, digits=2))
   calls<-as.data.frame(calls)
   names(dat2)<-paste("chip.", names(dat2), sep="")
   names(calls)<-paste("flag.", names(calls), sep="")
   dat2<-data.frame(dat2, calls)
}

# PLIER normalization
if(norm=="plier" & custom.chiptype=="empty") {
   library(plier)
   dat2<-exprs(justPlier(eset=dat,replicate=1:length(dat),get.affinities=FALSE,normalize=FALSE,norm.type=c("together"),augmentation=0.1,defaultaffinity=1.0,defaultconcentration=1.0,attenuation=0.005,seaconvergence=0.000001,seaiteration=3000,gmcutoff=0.15,probepenalty=0.001,concpenalty=0.000001,usemm=TRUE,usemodel=FALSE,fitaffinity=T,plierconvergence=0.000001,plieriteration=3000,dropmax=3.0,lambdalimit=0.01,optimization=0))
   calls<-exprs(mas5calls(dat))
   if(stabvar=="yes") {
      if(ncol(dat2)<2) {
         stop("You need to have at least two chip to be able to use VSN!")
      }
      library(vsn)
      dat2<-exprs(vsn(dat2))
   } else {
      dat2<-log2(dat2)
   }
   dat2<-as.data.frame(round(dat2, digits=2))
   calls<-as.data.frame(calls)
   names(dat2)<-paste("chip.", names(dat2), sep="")
   names(calls)<-paste("flag.", names(calls), sep="")
   dat2<-data.frame(dat2, calls)
}
if(norm=="plier" & custom.chiptype!="empty") {
   stop("Custom chipstypes can't be used with Plier! Use some other preprocessing method.")
}

# RMA normalization
if(norm=="rma" & custom.chiptype=="empty") {
   dat2<-exprs(justRMA())
   calls<-exprs(mas5calls(dat))
   dat2<-as.data.frame(round(dat2, digits=2))
   calls<-as.data.frame(calls)
   names(dat2)<-paste("chip.", names(dat2), sep="")
   names(calls)<-paste("flag.", names(calls), sep="")
   dat2<-data.frame(dat2, calls)
}
if(norm=="rma" & custom.chiptype!="empty") {
   dat2<-exprs(rma(dat))
   calls<-exprs(mas5calls(dat))
   dat2<-as.data.frame(round(dat2, digits=2))
   calls<-as.data.frame(calls)
   names(dat2)<-paste("chip.", names(dat2), sep="")
   names(calls)<-paste("flag.", names(calls), sep="")
   dat2<-data.frame(dat2, calls)
}

# RPA normalization
if(norm=="rpa" & custom.chiptype=="empty") {
   dat2<-exprs(rpa(dat))
   calls<-exprs(mas5calls(dat))
   dat2<-as.data.frame(round(dat2, digits=2))
   calls<-as.data.frame(calls)
   names(dat2)<-paste("chip.", names(dat2), sep="")
   names(calls)<-paste("flag.", names(calls), sep="")
   dat2<-data.frame(dat2, calls)
}
if(norm=="rpa" & custom.chiptype!="empty") {
   dat2<-exprs(rpa(dat))
   calls<-exprs(mas5calls(dat))
   dat2<-as.data.frame(round(dat2, digits=2))
   calls<-as.data.frame(calls)
   names(dat2)<-paste("chip.", names(dat2), sep="")
   names(calls)<-paste("flag.", names(calls), sep="")
   dat2<-data.frame(dat2, calls)
}

# GCRMA normalization
if(norm=="gcrma" & custom.chiptype=="empty") {
   dat2<-exprs(justGCRMA(type=c("fullmodel"), fast=T, optimize.by=c("speed")))
   calls<-exprs(mas5calls(dat))
   dat2<-as.data.frame(round(dat2, digits=2))
   calls<-as.data.frame(calls)
   names(dat2)<-paste("chip.", names(dat2), sep="")
   names(calls)<-paste("flag.", names(calls), sep="")
   dat2<-data.frame(dat2, calls)
}
if(norm=="gcrma" & custom.chiptype!="empty") {
   dat2<-exprs(gcrma(dat))
   calls<-exprs(mas5calls(dat))
   dat2<-as.data.frame(round(dat2, digits=2))
   calls<-as.data.frame(calls)
   names(dat2)<-paste("chip.", names(dat2), sep="")
   names(calls)<-paste("flag.", names(calls), sep="")
   dat2<-data.frame(dat2, calls)
}


# Li-Wong (dChip) normalization
if(norm=="li-wong") {
   dat2<-exprs(expresso(dat, normalize.method="invariantset", bg.correct=FALSE, pmcorrect.method="pmonly", summary.method="liwong"))
   calls<-exprs(mas5calls(dat))
   dat2<-as.data.frame(round(dat2, digits=2))
   calls<-as.data.frame(calls)
   names(dat2)<-paste("chip.", names(dat2), sep="")
   names(calls)<-paste("flag.", names(calls), sep="")
   dat2<-data.frame(dat2, calls)
}

# Writes out a phenodata table
sample<-rownames(pData(dat))
group<-c(rep("", nrow(pData(dat))))
training<-c(rep("", nrow(pData(dat))))
time<-c(rep("", nrow(pData(dat))))
random<-c(rep("", nrow(pData(dat))))
chiptype<-paste(chiptype, ".db", sep="")
write.table(data.frame(sample=sample, chiptype=chiptype, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# Writing out data
a<-try(library(chiptype, character.only=T))
if(chiptype!="empty" & class(a)!="try-error") {
   # Including gene names to data
   lib2<-sub('.db','',chiptype)
   symbol<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "SYMBOL", sep="")))))[rownames(dat2),])
   genename<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "GENENAME", sep="")))))[rownames(dat2),])
	# Fxes an issue introduced in BioC2.4 where the "#" character is introduced in some gene names
	genename <- gsub("#", "", genename)
	symbol <- gsub("'", "", symbol)
	genename <- gsub("'", "", genename)
	# Writes the results into a file
   write.table(data.frame(symbol, description=genename, dat2), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
} 

if(chiptype=="empty" | class(a)=="try-error") {
   write.table(data.frame(dat2), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
}

# TOOL cna-bin-hits.R: "Count reads in fixed bins" (Divide the genome into non-overlapping bins of fixed size, calculate reads in each bin, and correct for GC content.)
# INPUT alignment.bam: "Input BAM file" TYPE GENERIC
# OUTPUT binned-hits.tsv: "Binned hits"
# PARAMETER organism: "organism" TYPE [human: human] DEFAULT human (Organism.)
# PARAMETER genome.build: "genome build" TYPE [GRCh37: GRCh37] DEFAULT GRCh37 (Genome build.)
# PARAMETER bin.size: "bin size" TYPE [1: "1 kbp", 5: "5 kbp", 10: "10 kbp", 15: "15 kbp", 30: "30 kbp", 50: "50 kbp", 100: "100 kbp"] DEFAULT 30 (Bin size.)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-03-20

bin.size <- as.integer(bin.size)
bin.bp <- bin.size * 1000

system(paste(file.path(chipster.tools.path, 'samtools', 'samtools'), ' view -F 0x0404 -q 1 alignment.bam | cut -f3,4 | tr -d chr > hits.txt', sep=''))

chromosomes <- c(1:22, 'X', 'Y', 'MT')
genomes <- list(GRCh37=c(249250621, 243199373, 198022430, 191154276, 180915260, 171115067, 159138663, 146364022, 141213431, 135534747, 135006516, 133851895, 115169878, 107349540, 102531392, 90354753, 81195210, 78077248, 59128983, 63025520, 48129895, 51304566, 155270560, 59373566, 16571))
names(genomes[['GRCh37']]) <- chromosomes
start <- end <- count <- integer()
for (chromosome in chromosomes) {
  chromosome.size <- genomes[['GRCh37']][chromosome]
  chromosome.starts <- seq(from=1, to=chromosome.size, by=bin.bp)
  chromosome.ends <- chromosome.starts + bin.bp - 1
  chromosome.ends[length(chromosome.ends)] <- chromosome.size
  chromosome.breaks <- c(chromosome.starts, chromosome.size)
  start <- c(start, chromosome.starts)
  end <- c(end, chromosome.ends)
}
bins <- data.frame(chromosome=rep(chromosomes, ceiling(genomes[['GRCh37']] / bin.bp)), start, end, count=0, stringsAsFactors=FALSE)
f <- file('hits.txt')
skip <- 0
chunk <- 100000000
while(1) {
  hits <- as.data.frame(scan('hits.txt', what=list(chromosome=character(), pos=integer()), sep='\t', nmax=chunk, skip=skip, quiet=TRUE))
  if (nrow(hits) == 0)
    break
  for (chromosome in unique(hits$chromosome)) {
    if (!chromosome %in% chromosomes)
      next
    chromosome.size <- genomes[['GRCh37']][chromosome]
    chromosome.starts <- seq(from=1, to=chromosome.size, by=bin.bp)
    chromosome.breaks <- c(chromosome.starts, chromosome.size)
    count <- hist(hits[hits$chromosome==chromosome, 'pos'], breaks=chromosome.breaks, plot=FALSE)$count
    bins[bins$chromosome==chromosome, 'count'] <- bins[bins$chromosome==chromosome, 'count'] + count
  }
  skip <- skip + chunk
  rm(hits, count); gc(FALSE)
}
close(f)
unlink('hits.txt')

library(limma)
gc.correct <- function(x) {
  means <- numeric(length=length(gc.intervals))
  for (i in 1:length(gc.intervals))
    means[i] <- mean(x[!is.na(gc$permil) & gc$permil == gc.intervals[i]], na.rm=TRUE)
  loess.means <- loessFit(means, gc.intervals)$fitted
  correction <- median(loess.means, na.rm=TRUE) - loess.means
  corrected <- numeric(length=length(x))
  for (i in 1:length(gc.intervals))
    corrected[!is.na(gc$permil) & gc$permil == gc.intervals[i]] <- x[!is.na(gc$permil) & gc$permil == gc.intervals[i]] + correction[i]
  corrected <- round(corrected)
  corrected <- corrected - min(corrected, na.rm=TRUE)
  corrected
}
gc <- read.table(file.path(chipster.tools.path, 'MPScall', genome.build, paste('gc.', bin.size, 'kbp.txt.gz', sep='')), header=TRUE, sep='\t', as.is=TRUE, colClasses=c('character', 'integer', 'integer', 'numeric'))
gc$permil <- as.integer(round(gc$gc*1000))
gc.intervals <<- seq(from=range(gc$permil, finite=TRUE)[1], to=range(gc$permil, finite=TRUE)[2])
bins$corrected <- gc.correct(bins$count)

rownames(bins) <- paste('bin-', 1:nrow(bins), sep='')
options(scipen=10)
write.table(bins, 'binned-hits.tsv', quote=FALSE, sep='\t', na='')

# EOF

# TOOL cna-segment-and-call-aberrations.R: "Segment and call copy number aberrations" (This tool segments and calls copy number aberrations from NGS data.)
# INPUT cna-data-table.tsv: "Data table with read counts" TYPE GENE_EXPRS
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT aberrations.tsv: aberrations.tsv
# OUTPUT aberration-frequencies.pdf: aberration-frequencies.pdf
# PARAMETER organism: "organism" TYPE [human: human] DEFAULT human (Organism.)
# PARAMETER genome.build: "human genome build" TYPE [GRCh37: GRCh37] DEFAULT GRCh37 (Genome build.)
# PARAMETER breakpoint.threshold: "breakpoint threshold" TYPE DECIMAL DEFAULT 0.8 (Threshold for segmentation of normalized profiles. Use something like 0.6 to get more segments, and thus more predicted CNVs.)
# PARAMETER min.mappability: "mimimum mappability" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.85 (The bins with lower mappability will be removed.)
# PARAMETER ploidy: "phenodata column with ploidy of samples" TYPE METACOLUMN_SEL DEFAULT EMPTY (Phenodata column with ploidy)
# PARAMETER cellularity: "phenodata column with cellularity of samples" TYPE METACOLUMN_SEL DEFAULT EMPTY (Phenodata column with the proportion of tumor cells in the sample)
# PARAMETER unique.match: "unique match" TYPE [FALSE: no, TRUE: yes] DEFAULT FALSE (Use a mappability profile to correct read counts.)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-03-20

source(file.path(chipster.common.path, 'CGHcallPlus.R'))
freec.path <- file.path(chipster.tools.path, 'FREEC_Linux64')
options(scipen=10)

input <- read.table('cna-data-table.tsv', header=TRUE, sep='\t', as.is=TRUE, row.names=1)
input <- input[input$chromosome %in% c(1:22, 'X', 'Y'),]
input <- input[order(input$chromosome, input$start),]
binsize <- input$end[1] - input$start[1] + 1

phenodata <- read.table('phenodata.tsv', header=TRUE, sep='\t')

if (ploidy == 'EMPTY') {
  ploidy <- rep(2, ncol(input)-3)
} else {
  ploidy <- as.numeric(phenodata[,ploidy])
  ploidy[is.na(ploidy)] <- 2
}
names(ploidy) <- colnames(input)[-(1:3)]
if (cellularity == 'EMPTY') {
  cellularity <- rep(1, ncol(input)-3)
} else {
  cellularity <- as.numeric(phenodata[,cellularity])
  cellularity[is.na(cellularity)] <- 1
}
names(cellularity) <- colnames(input)[-(1:3)]
contamination <- 1 - cellularity

anno <- input[,1:3]
ratios <- matrix(nrow=nrow(input), ncol=ncol(input)-3)
colnames(ratios) <- colnames(input)[-(1:3)]
rownames(ratios) <- rownames(input)
calls <- cn <- segmented <- ratios
for (s in colnames(input)[-(1:3)]) {
  cat('[general]\n', file='config.txt', sep='')
  cat('\n', file='config.txt', sep='', append=TRUE)
  cat('breakPointThreshold = ', breakpoint.threshold, '\n', file='config.txt', sep='', append=TRUE)
  cat('chrLenFile = ', file.path(freec.path, genome.build, 'chr.len'), '\n', file='config.txt', sep='', append=TRUE)
  if (contamination[s] > 0) {
    cat('contamination = ', contamination[s], '\n', file='config.txt', sep='', append=TRUE)
    cat('contaminationAdjustment = TRUE\n', file='config.txt', sep='', append=TRUE)
  }
  cat('GCcontentProfile = ', file.path(freec.path, genome.build, paste('GC_profile_', binsize / 1000, 'kb.cnp', sep='')), '\n', file='config.txt', sep='', append=TRUE)
  cat('gemMappabilityFile = ', file.path(freec.path, genome.build, 'GEM_mapp', 'out50.gem'), '\n', file='config.txt', sep='', append=TRUE)
  # cat('minCNAlength = 1\n', file='config.txt', sep='', append=TRUE)
  cat('minMappabilityPerWindow = ', min.mappability, '\n', file='config.txt', sep='', append=TRUE)
  cat('ploidy = ', ploidy[s], '\n', file='config.txt', sep='', append=TRUE)
  # cat('telocentromeric = 50000\n', file='config.txt', sep='', append=TRUE)
  cat('uniqueMatch = ', unique.match, '\n', file='config.txt', sep='', append=TRUE)
  cat('window = ', binsize, '\n', file='config.txt', sep='', append=TRUE)
  cat('\n', file='config.txt', sep='', append=TRUE)
  cat('[sample]\n', file='config.txt', sep='', append=TRUE)
  cat('\n', file='config.txt', sep='', append=TRUE)
  cat('mateCopyNumberFile = sample.cnp\n', file='config.txt', sep='', append=TRUE)
  cat('mateOrientation = 0\n', file='config.txt', sep='', append=TRUE)

  write.table(data.frame(input$chromosome, input$start-1, input[,s], stringsAsFactors=FALSE), 'sample.cnp', sep='\t', row.names=FALSE, col.names=FALSE, quote=FALSE)
  system(paste(file.path(freec.path, 'freec'), ' -conf config.txt', sep=''))
  out <- read.table('sample.cnp_ratio.txt', header=TRUE, sep='\t', as.is=TRUE)
  ratios[,s] <- out$Ratio
  segmented[,s] <- out$MedianRatio
  cn[,s] <- out$CopyNumber
  calls[cn[,s] <  ploidy, s] <- -1
  calls[cn[,s] == ploidy, s] <-  0
  calls[cn[,s] >  ploidy, s] <-  1
  # XX
  # XY
  unlink(c('sample.cnp', 'sample.cnp_CNVs', 'sample.cnp_ratio.txt'))
}
unlink(c('config.txt', 'GC_profile'))

anno$chromosome[anno$chromosome == 'X'] <- '23'
anno$chromosome[anno$chromosome == 'Y'] <- '24'
anno$chromosome[anno$chromosome == 'MT'] <- '25'
anno$chromosome <- as.integer(anno$chromosome)

o <- order(anno$chromosome, anno$start)
anno <- anno[o,]
ratios <- as.matrix(ratios[o,])
segmented <- as.matrix(segmented[o,])
cn <- as.matrix(cn[o,])
calls <- as.matrix(calls[o,])
colnames(ratios) <- colnames(segmented) <- colnames(cn) <- colnames(calls) <- colnames(input)[-(1:3)]

ratios[ratios == -1] <- NA
segmented[segmented == -1] <- NA
ratios <- log2(ratios)
segmented <- log2(segmented)
ratios[ratios == -10] <- NA # or NA
segmented[segmented == -10] <- NA # or NA

identifiers <- sub('^chip\\.', '', colnames(ratios))
colnames(segmented) <- paste('segmented.', identifiers, sep='')
colnames(cn) <- paste('copynumber.', identifiers, sep='')
colnames(calls) <- paste('flag.', identifiers, sep='')
dat <- cbind(anno, calls, cn, ratios, segmented)

.getChromosomeLengths <- function(build) {
    build <- as.integer(gsub('[^0-9]', '', build))
    if (build == 34 || build == 16) {
       chromosome.lengths <- c(246127941, 243615958, 199344050, 191731959, 181034922, 170914576, 158545518, 146308819, 136372045, 135037215, 134482954, 132078379, 113042980, 105311216, 100256656, 90041932, 81860266, 76115139, 63811651, 63741868, 46976097, 49396972, 153692391, 50286555)
    } else if (build == 35 || build == 17) {
       chromosome.lengths <- c(245522847, 243018229, 199505740, 191411218, 180857866, 170975699, 158628139, 146274826, 138429268, 135413628, 134452384, 132449811, 114142980, 106368585, 100338915, 88827254, 78774742, 76117153, 63811651, 62435964, 46944323, 49554710, 154824264, 57701691)
    } else if (build == 36 || build == 18) {
       chromosome.lengths <- c(247249719, 242951149, 199501827, 191273063, 180857866, 170899992, 158821424, 146274826, 140273252, 135374737, 134452384, 132349534, 114142980, 106368585, 100338915, 88827254, 78774742, 76117153, 63811651, 62435964, 46944323, 49691432, 154913754, 57772954)
    } else {
       chromosome.lengths <- c(249250621, 243199373, 198022430, 191154276, 180915260, 171115067, 159138663, 146364022, 141213431, 135534747, 135006516, 133851895, 115169878, 107349540, 102531392, 90354753, 81195210, 78077248, 59128983, 63025520, 48129895, 51304566, 155270560, 59373566)
    }
    names(chromosome.lengths) <- 1:24
    chromosome.lengths
}

frequencyPlot.freec <- 
function (x, main='Frequency Plot', gaincol='blue', losscol='red', misscol=NA, build='GRCh37',... )
{
  chrom <- x$chromosome
  pos <- x$start
  pos2 <- x$end
  uni.chrom <- unique(chrom)
  chrom.lengths <- .getChromosomeLengths(build)[as.character(uni.chrom)]
  chrom.ends <- integer()
  cumul <- 0
  for (j in uni.chrom) {
    pos[chrom > j] <- pos[chrom > j] + chrom.lengths[as.character(j)]
    pos2[chrom > j] <- pos2[chrom > j] + chrom.lengths[as.character(j)]
    cumul <- cumul + chrom.lengths[as.character(j)]
    chrom.ends <- c(chrom.ends, cumul)
  }
  names(chrom.ends) <- names(chrom.lengths)
  calls <- as.matrix(dat[,grep("^flag\\.", names(dat))])
  loss.freq <- rowMeans(calls < 0)
  gain.freq <- rowMeans(calls > 0)
  plot(NA, xlim=c(0, max(pos2)), ylim=c(-1,1), type='n', xlab='chromosomes', ylab='frequency', xaxs='i', xaxt='n', yaxs='i', yaxt='n', main=main,...)
  if (!is.na(misscol)) {
    rect(0, -1, max(pos2), 1, col=misscol, border=NA)
    rect(pos, -1, pos2, 1, col='white', border=NA)
  }
  rect(pos, 0, pos2, gain.freq, col=gaincol, border=gaincol)
  rect(pos, 0, pos2, -loss.freq, col=losscol, border=losscol)
  box()
  abline(h=0)
  if (length(chrom.ends) > 1)
    for (j in names(chrom.ends)[-length(chrom.ends)])
      abline(v=chrom.ends[j], lty='dashed')
  ax <- (chrom.ends + c(0, chrom.ends[-length(chrom.ends)])) / 2
  axis(side=1,at=ax,labels=uni.chrom,cex=.2,lwd=.5,las=1,cex.axis=1,cex.lab=1)
  axis(side=2, at=c(-1, -0.5, 0, 0.5, 1), labels=c('100 %', ' 50 %', '0 %', '50 %', '100 %'), las=1)
  mtext('gains', side=2, line=3, at=0.5)
  mtext('losses', side=2, line=3, at=-0.5)
  ### number of data points
  str <- paste(round(nrow(x) / 1000), 'k x ', sep='')
  probe <- median(x$end-x$start+1)
  if (probe < 1000) {
    str <- paste(str, probe, ' bp', sep='')
  } else {
    str <- paste(str, round(probe / 1000), ' kbp', sep='')
  }
  mtext(str, side=3, line=0, adj=0)
}


# write outputs

pdf(file='aberration-frequencies.pdf', paper='a4r', width=0, height=0)
frequencyPlot.freec(dat)
dev.off()

dat$chromosome <- as.character(dat$chromosome)
dat$chromosome[dat$chromosome=='23'] <- 'X'
dat$chromosome[dat$chromosome=='24'] <- 'Y'
dat$chromosome[dat$chromosome=='25'] <- 'MT'

write.table(dat, file='aberrations.tsv', quote=FALSE, sep='\t')

# EOF

# TOOL acgh-cluster.R: "Cluster called copy number data" (Perform clustering of copy number data.)
# INPUT regions.tsv: regions.tsv TYPE GENERIC 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT wecca.pdf: wecca.pdf 
# PARAMETER type.of.calls: type.of.calls TYPE [hard: hard, soft: soft] DEFAULT soft (Whether to cluster the arrays based on soft or hard calls. Hard calls are losses, normals, and gains, whereas soft calls refer to the respective probabilities of these calls. The preferred choice is to use soft calls whenever they are available.)
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column to include in the output plot.)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2013-04-04

library(WECCA)

file <- 'regions.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, as.is=TRUE, check.names=FALSE)
phenodata <- read.table("phenodata.tsv", header=TRUE, sep="\t", as.is=TRUE, check.names=FALSE)

dat$chromosome[dat$chromosome=='X'] <- '23'
dat$chromosome[dat$chromosome=='Y'] <- '24'
dat$chromosome[dat$chromosome=='MT'] <- '25'
dat$chromosome <- as.integer(dat$chromosome)

ann <- dat[,c('chromosome', 'start', 'end')]
colnames(ann) <- c('Chromosome', 'Start', 'End')
hardcalls <- as.matrix(dat[,grep("^flag", names(dat))])
if (ncol(hardcalls)==0)
  stop('CHIPSTER-NOTE: No copy number calls were found. Please run tools Call copy number aberrations from aCGH data and Identify common regions from called aCGH data first.')
colnames(hardcalls) <- phenodata$description
softcalls <- as.matrix(dat[,grep("^prob", names(dat))])
if (ncol(softcalls)==0) {
  if (type.of.calls == 'soft')
    stop('CHIPSTER-NOTE: No soft calls were found. Please try running with parameter type.of.calls=hard.')
  # the size of the softcalls matrix is used to detect whether calling was performed with 3 or 4 copy number states.
  # therefore we will construct such a matrix
  if (2 %in% hardcalls) {
    softcalls <- cbind(hardcalls, hardcalls, hardcalls, hardcalls)
  } else {
    softcalls <- cbind(hardcalls, hardcalls, hardcalls)
  }
}
colnames(softcalls) <- sub('\\.', '_', colnames(softcalls))

regions <- list(ann=ann, hardcalls=hardcalls, softcalls=softcalls)

if (type.of.calls == 'hard') {
  dendrogram <- WECCAhc(regions)
} else {
  dendrogram <- WECCAsc(regions)
}

# overriding the plotting function
WECCA.heatmap <- function (cghdata.regioned, dendrogram,...) 
{
    nclass <- dim(cghdata.regioned$softcalls)[2]/dim(cghdata.regioned$hardcalls)[2]
    chr.color <- rep("green3", dim(cghdata.regioned$hardcalls)[1])
    ids <- ((cghdata.regioned$ann[, 1]%%2) == 0)
    chr.color[ids] <- c("gray")
    Y <- rep(FALSE, dim(cghdata.regioned$hardcalls)[1])
    for (i in 2:(dim(cghdata.regioned$ann)[1])) {
        if ((cghdata.regioned$ann[i - 1, 1] != cghdata.regioned$ann[i, 
            1])) {
            Y[i] <- TRUE
        }
    }
    Y[1] <- TRUE
    begin.chr <- rep("", dim(cghdata.regioned$ann)[1])
    begin.chr[Y] <- cghdata.regioned$ann[Y, 1]
    color.coding <- c("red", "black", "blue", "white")[1:nclass]
    heatmap(cghdata.regioned$hardcalls, Colv = as.dendrogram(dendrogram), 
        Rowv = NA, col = color.coding, labRow = begin.chr, RowSideColors = chr.color, 
        scale = "none",...)
}

pdf(file='wecca.pdf', paper='a4', width=0, height=0)
if (column == 'EMPTY') {
  WECCA.heatmap(regions, dendrogram, margins=c(10,1))
} else {
  WECCA.heatmap(regions, dendrogram, margins=c(10,1), ColSideColors=palette()[as.factor(phenodata[,column])])
}
dev.off()

# EOF

# TOOL change-interpretation.R: "Change interpretation" (Let's user to transform the expression values.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT change-interpretation.tsv: change-interpretation.tsv 
# PARAMETER transform: transform TYPE [log2-linear: log2-linear, linear-log2: linear-log2, log10-linear: log10-linear, linear-log10: linear-log10, ln-linear: ln-linear, linear-ln: linear-ln] DEFAULT log2-linear (From which to transform to what)


# Change interpretation
# JTT 26.4.2008

# Parameter settings (default) for testing purposes
#transform<-c("log2-linear")

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]
annotations<-dat[,grep("annotations", names(dat))]

# Transforms the data
if(transform=="log2-linear") {
	dat2<-2^dat2
}
if(transform=="linear-log2") {
	if(any(dat2<0)) {
		stop("Negative values in the data! Can't log-transform.")
	}
	dat2<-log2(dat2)
}

if(transform=="log10-linear") {
	dat2<-10^dat2
}
if(transform=="linear-log10") {
	if(any(dat2<0)) {
		stop("Negative values in the data! Can't log-transform.")
	}
	dat2<-log10(dat2)
}

if(transform=="ln-linear") {
	dat2<-exp(dat2)
}
if(transform=="linear-ln") {
	if(any(dat2<0)) {
		stop("Negative values in the data! Can't log-transform.")
	}
	dat2<-log(dat2)
}

# Add the annotations and flags back into the data table
dat3 <- cbind(annotations,dat2)
dat4 <- cbind(dat3,calls)

# Writing the data to disk
write.table(dat4, "change-interpretation.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL norm-specific-samples.R: "Normalize to specific samples" (Normalizes data to specific samples. The samples to be normalized are coded with 1 in one column of the phenodata. The samples to be normalized to are coded with 0 in the same column.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT normalized2samples.tsv: normalized2samples.tsv 
# PARAMETER column.to.normalize.by: column.to.normalize.by TYPE METACOLUMN_SEL DEFAULT group (Phenodata column containing the samples to be normalized)


# Normalize the data to specific samples
# JTT 5.12.2008

# Loads the data file
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
dat2<-dat[,grep("chip", names(dat))]

# Loads phenodata
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")

# Extract the data from the phenodata column
extract<-phenodata[,grep(column.to.normalize.by, colnames(phenodata))]

# Sanity checks
if(length(unique(extract))>2) {
   stop("You have specified more than two groups! You need to define exactly two groups.")
}
if(max(extract>1)) {
   stop("The groups should be defined with 0s and 1s! You have numbers larger than 1 in the definitions.")
}

# Extracting the samples
dat0<-as.data.frame(dat2[,which(extract==0)])
dat1<-as.data.frame(dat2[,which(extract==1)])

# Normalization values
nv<-(rowSums(dat0)/ncol(dat0))

# Normalization
for(i in 1:ncol(dat2)) {
   dat2[,i]<-dat2[,i]-nv
}

# Replace the data in the original object with normalized values
datacols<-grep("chip.", colnames(dat))
for(i in 1:length(datacols)) {
   dat[,(datacols[i])]<-dat2[,i]
}

# Write out data
write.table(data.frame(dat), file="normalized2samples.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL mothur-precluster.R: "Precluster aligned sequences with Mothur" (Preclusters aligned sequences in order to remove sequences that are likely to contain sequencing errors. This tool is based on the Mothur package. In addition to the alignment, you need to supply the names file that was created by the tool \"Extract unique aligned sequences with Mothur\".)
# INPUT a.fasta: "FASTA file" TYPE FASTA
# INPUT a.names: "Names file" TYPE MOTHUR_NAMES
# OUTPUT preclustered.fasta
# OUTPUT preclustered.names
# OUTPUT preclustered-summary.tsv


# EK 18.06.2013

# binary
binary <- c(file.path(chipster.tools.path, "mothur", "mothur"))

# batch file
write("pre.cluster(fasta=a.fasta, name=a.names, diffs=1)", "batch.mth", append=F)

# command
command <- paste(binary, "batch.mth", "> log_raw.txt 2>&1")

#run
system(command)

# Post process output
system("mv a.precluster.fasta preclustered.fasta")
system("mv a.precluster.names preclustered.names")

#stool.trim.unique.good.filter.unique.precluster.map

# batch file 2
write("summary.seqs(fasta=preclustered.fasta)", "summary.mth", append=F)

# command 2
command2 <- paste(binary, "summary.mth", "> log_raw.txt")

# run
system(command2)

# Post process output
system("grep -A 9 Start log_raw.txt > preclustered-summary.tsv")

# TOOL bedtools-pairtopair.R: "Compare two BEDPE files" (Compares two BEDPE files in search of overlaps where each end of a BEDPE feature in A overlaps with the ends of a feature in B. This tool is based on the BEDTools package.)
# INPUT file.a: "BEDPE file A" TYPE GENERIC
# INPUT file.b: "BEDPE file B" TYPE GENERIC
# OUTPUT pairtopair.bed 
# PARAMETER OPTIONAL f: "Minimum overlap" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.000000001 (Minimum overlap required as a fraction of A. Default is 1E-9 (effectively 1bp\))
# PARAMETER OPTIONAL type: "Approach to reporting overlaps" TYPE [either, neither, both] DEFAULT both (either: Report overlaps if either ends of A overlap B. neither: Report A if neither end of A overlaps B. both: Report overlaps if both ends of A overlap B.)
# PARAMETER OPTIONAL is: "Ignore strands when searching for overlaps" TYPE [yes, no] DEFAULT no (Ignore strands when searching for overlaps. By default, strands are enforced.)
# PARAMETER OPTIONAL rdn: "Require different names" TYPE [yes, no] DEFAULT no (Require the hits to have different names (i.e. avoid self-hits\). By default, same names are allowed.)
# PARAMETER OPTIONAL addslop: "Add slop" TYPE [yes, no] DEFAULT no (Note: Slop is subtracted from start1 and start2 and added to end1 and end2.)
# PARAMETER OPTIONAL slop: "The amount of slop in bp to be added to each footprint" TYPE INTEGER DEFAULT 0 (The amount of slop in bp to be added to each footprint.)
# PARAMETER OPTIONAL ss: "Add slop based to each BEDPE footprint based on strand" TYPE [yes, no] DEFAULT no (Add slop based to each BEDPE footprint based on strand. If strand is +, slop is only added to the end coordinates. If strand is -, slop is only added to the start coordinates. By default, slop is added in both directions.) 

# AMS 23.4.2012

# binary
binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "pairToPair"))

# optional options
options <- paste("")
if (is == "yes") {options <- paste(options, "-si")}
if (rdn == "yes") {options <- paste(options, "-rdn")}
options <- paste(options, "-f", f) 
options <- paste(options,"-type", type)
if (addslop == "yes"){
	options <- paste(options, "-slop", slop)
	if (ss == "yes") {options <- paste(options, "-ss")}
}
# input files
options <- paste(options,"-a file.a -b file.b")

# command
command <- paste(binary, options, " > pairtopair.bed")

# run
system(command)
if (file.info("pairtopair.bed")$size == 0) {system("echo \"No results found\" > pairtopair.bed")}

# TOOL acgh-pathways-go.R: "GO enrichment for called gene copy numbers" (Performs a statistical test for enrichment of GO terms in frequently aberrated genes. The input should be the output from the tool Detect genes from called copy number data.)
# INPUT gene-aberrations.tsv: gene-aberrations.tsv TYPE GENE_EXPRS 
# OUTPUT hypergeo-go.tsv: hypergeo-go.tsv 
# OUTPUT hypergeo-go.html: hypergeo-go.html 
# PARAMETER aberrations: aberrations TYPE [losses: losses, gains: gains, amplifications: amplifications, gains_and_amplifications: gains_and_amplifications, all_aberrations: all_aberrations] DEFAULT all_aberrations (Whether to test enrichment of GO terms in frequently lost, gained or amplified genes.)
# PARAMETER frequency.threshold: frequency.threshold TYPE DECIMAL DEFAULT 0.5 (The minimum proportion of samples containing the particular type of aberration.)
# PARAMETER ontology: ontology TYPE [all: all, biological_process: biological_process, molecular_function: molecular_function, cellular_component: cellular_component] DEFAULT biological_process (The ontology to be analyzed.)
# PARAMETER p.value.threshold: p.value.threshold TYPE DECIMAL DEFAULT 0.05 (P-value threshold.)
# PARAMETER minimum.population: minimum.population TYPE INTEGER FROM 1 TO 1000000 DEFAULT 2 (Minimum number of genes required to be in a pathway.)
# PARAMETER conditional.testing: conditional.testing TYPE [yes: yes, no: no] DEFAULT yes (Conditional testing means that when a significant GO term is found, i.e. p-value is smaller than the specified thershold, that GO term is removed when testing the significance of its parent.)
# PARAMETER p.adjust.method: p.adjust.method TYPE [none: none, BH: BH, BY: BY] DEFAULT none (Method for adjusting the p-value in order to account for multiple testing. Because of the structure of GO, multiple testing is theoretically problematic, and using conditional.testing is a generally the preferred method. The correction can only be applied when no conditional.testing is performed.)
# PARAMETER over.or.under.representation: over.or.under.representation TYPE [over: over, under: under] DEFAULT over (Should over or under-represented classes be seeked?)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2013-02-24

# load packages
library(org.Hs.eg.db)
library(GOstats)
library(R2HTML)

# read input
file <- 'gene-aberrations.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, as.is=TRUE, check.names=FALSE)

# convert list of reference genes from Ensembl to Entrez IDs
ensembl.to.entrez <- as.list(org.Hs.egENSEMBL2EG)
reference.genes <- unique(unlist(ensembl.to.entrez[rownames(dat)]))

# check that we have something (i.e. that input file was in fact Ensembl IDs)
if (length(reference.genes)==0)
  stop('CHIPSTER-NOTE: The input file should contain a list of Ensembl Gene IDs. Usually as a result of running the tool Detect genes from called copy number data.')

# detect the frequency column to use
if (aberrations == 'all_aberrations') {
  if ('amp.freq' %in% colnames(dat))
    dat$gain.freq <- dat$gain.freq + dat$amp.freq
  dat$loss.freq <- dat$loss.freq + dat$gain.freq
  column <- 'loss.freq'
} else if (aberrations == 'gains_and_amplifications') {
  if ('amp.freq' %in% colnames(dat))
    dat$gain.freq <- dat$gain.freq + dat$amp.freq
  column <- 'gain.freq'
} else if (aberrations == 'amplifications') {
  column <- 'amp.freq'
} else if (aberrations == 'gains') {
  column <- 'gain.freq'
} else {
  column <- 'loss.freq'
}

# check that the frequency column exists
if (!column %in% colnames(dat))
  stop('CHIPSTER-NOTE: The required frequency column not found in file: ', column)

# extract the list of frequently aberrated genes
selected.genes <- unique(unlist(ensembl.to.entrez[rownames(dat[dat[,column] >= frequency.threshold,])]))

# check that we have a list of genes to test
if (length(reference.genes)==0)
  stop('CHIPSTER-NOTE: There were no aberrated genes above the selected threshold (', frequency.threshold, '). Please choose a lower threshold.')

# check for conditional testing and multiple testing correction
if (conditional.testing == 'no') {
  conditional <- FALSE
} else {
  if (p.adjust.method != 'none')
    stop('CHIPSTER-NOTE: Multiple testing correction can be applied only when performing unconditional testing. Please set conditional.testing to no, or p.adjust.method to none. Usually the preferred method is to use conditional testing.')
  conditional <- TRUE
}

# define the output variable
output <- data.frame(total=integer(0), expected=numeric(0), observed=integer(0), p.value=numeric(0), description=character(0), ontology=character(0))

if (ontology == 'biological_process' || ontology == 'all') {
  params <- new('GOHyperGParams', geneIds=selected.genes, universeGeneIds=reference.genes, annotation='org.Hs.eg.db', ontology='BP', pvalueCutoff=p.value.threshold, conditional=conditional, testDirection=over.or.under.representation)
  go <- hyperGTest(params)
  go.table <- summary(go, pvalue=2)
  if (nrow(go.table)>0) {
    go.table$Pvalue <- p.adjust(go.table$Pvalue, method=p.adjust.method)
    go.table <- go.table[go.table$Pvalue <= p.value.threshold & go.table$Size >= minimum.population,]
    if (nrow(go.table)>0) {
      rownames(go.table) <- go.table[,1]
      go.table <- go.table[,c(6, 4, 5, 2, 7)]
      go.table$ontology <- 'biological process'
      colnames(go.table) <- colnames(output)
      output <- rbind(output, go.table)
      go.table$description <- paste('<a href="http://amigo.geneontology.org/cgi-bin/amigo/term-details.cgi?term=', rownames(go.table), '">', go.table$description, '</a>', sep='')
      HTML(go.table, file='hypergeo-go.html', append=TRUE, Border=0, innerBorder=1)
    }
  }
}

if (ontology == 'molecular_function' || ontology == 'all') {
  params <- new('GOHyperGParams', geneIds=selected.genes, universeGeneIds=reference.genes, annotation='org.Hs.eg.db', ontology='MF', pvalueCutoff=p.value.threshold, conditional=conditional, testDirection=over.or.under.representation)
  go <- hyperGTest(params)
  go.table <- summary(go, pvalue=2)
  if (nrow(go.table)>0) {
    go.table$Pvalue <- p.adjust(go.table$Pvalue, method=p.adjust.method)
    go.table <- go.table[go.table$Pvalue <= p.value.threshold & go.table$Size >= minimum.population,]
    if (nrow(go.table)>0) {
      rownames(go.table) <- go.table[,1]
      go.table <- go.table[,c(6, 4, 5, 2, 7)]
      go.table$ontology <- 'molecular function'
      colnames(go.table) <- colnames(output)
      output <- rbind(output, go.table)
      go.table$description <- paste('<a href="http://amigo.geneontology.org/cgi-bin/amigo/term-details.cgi?term=', rownames(go.table), '">', go.table$description, '</a>', sep='')
      HTML(go.table, file='hypergeo-go.html', append=TRUE, Border=0, innerBorder=1)
    }
  }
}

if (ontology == 'cellular_component' || ontology == 'all') {
  params <- new('GOHyperGParams', geneIds=selected.genes, universeGeneIds=reference.genes, annotation='org.Hs.eg.db', ontology='CC', pvalueCutoff=p.value.threshold, conditional=conditional, testDirection=over.or.under.representation)
  go <- hyperGTest(params)
  go.table <- summary(go, pvalue=2)
  if (nrow(go.table)>0) {
    go.table$Pvalue <- p.adjust(go.table$Pvalue, method=p.adjust.method)
    go.table <- go.table[go.table$Pvalue <= p.value.threshold & go.table$Size >= minimum.population,]
    if (nrow(go.table)>0) {
      rownames(go.table) <- go.table[,1]
      go.table <- go.table[,c(6, 4, 5, 2, 7)]
      go.table$ontology <- 'cellular component'
      colnames(go.table) <- colnames(output)
      output <- rbind(output, go.table)
      go.table$description <- paste('<a href="http://amigo.geneontology.org/cgi-bin/amigo/term-details.cgi?term=', rownames(go.table), '">', go.table$description, '</a>', sep='')
      HTML(go.table, file='hypergeo-go.html', append=TRUE, Border=0, innerBorder=1)
    }
  }
}

# write outputs
options(scipen=10)
write.table(output, file='hypergeo-go.tsv', quote=FALSE, sep='\t')
if (nrow(output)==0)
  write('<html>\n\t<body>\n\t\tNo significant results found!</br />\n\t</body>\n</html>', file='hypergeo-go.html')

# EOF

# TOOL cluster-som.R: "Self-organizing map (SOM\)" (Self-organizing map clustering of genes. Note that you need to have at least two chips, and columns times rows number of genes in order to able to execute the analysis.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT som.tsv: som.tsv 
# OUTPUT som.pdf: som.pdf 
# PARAMETER number.of.columns: number.of.columns TYPE INTEGER FROM 1 TO 100 DEFAULT 4 (Number of SOM grid columns)
# PARAMETER number.of.rows: number.of.rows TYPE INTEGER FROM 1 TO 100 DEFAULT 3 (Number of SOM grid rows)
# PARAMETER coloring.scheme: coloring.scheme TYPE [Red-Green: Red-Green, Blue-Yellow: Blue-Yellow, Black-White: Black-White] DEFAULT Blue-Yellow (Coloring scheme for the SOM map)
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the resampling image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the resampling image)


# Self-organizing map
# JTT 22.6.2006

# Parameter settings (default) for testing purposes
#number.of.columns<-4
#number.of.rows<-3
#coloring.scheme<-c("Blue-Yellow")
#image.width<-600
#image.height<-600

# Renaming variables
x<-number.of.columns
y<-number.of.rows
colpar<-coloring.scheme
w<-image.width
h<-image.height

# Loads the data file
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Loads the libraries
library(kohonen)
library(RColorBrewer)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Sanity checks
if(x*y>=nrow(dat2)) {
   stop("The number of nodes is larger than the number of genes! Please use a smaller grid.")
}
if(ncol(dat2)<2) {
   stop("You have have at least two chips to run this analysis!")
}

# Calculating the SOM-result
iter<-c(10000)
top<-c("hexagonal")
kohmap<-som(as.matrix(dat2), grid=somgrid(xdim=x, ydim=y, topo=top), rlen=iter)
dists <- unit.distances(kohmap$grid, toroidal=F)

# Makes colors for plotting purposes
dif.dists<-unique(as.vector(names(table(dists[1,]))))
if(colpar=="Red-Green") {
   heatcol<-colorRampPalette(c("Red", "Green"))(length(dif.dists))
}
if(colpar=="Blue-Yellow") {
   heatcol<-colorRampPalette(c("Blue", "Yellow"))(length(dif.dists))
}
if(colpar=="Black-White") {
   heatcol<-colorRampPalette(c("Black", "LightGrey"))(length(dif.dists))
}
heatcol2<-dists[1,]
for(i in 1:length(dif.dists)) {
   heatcol2[heatcol2==dif.dists[i]]<-heatcol[i]
}

# Plotting the SOM map
pdf(file="som.pdf", width=w/72, height=h/72)
par(mfrow=c(2,2), mar=c(2,2,0,0))
plot.kohonen(kohmap, type="property", property=dists[1,], palette.name=heat.colors, main="Property")
plot.kohonen(kohmap, type="codes", property=dists[1,], palette.name=heat.colors, main="Codes")
plot.kohonen(kohmap, type="counts", property=dists[1,], palette.name=heat.colors, main="Counts")
plot.kohonen(kohmap, type="mapping", property=dists[1,], palette.name=heat.colors, pch=19, main="Mapping")
dev.off()

# Makes a dataframe of data, SOM result (cell membership and distance to first cell), and colors
# Dists, cols, and griddim are not of data length, ends are padded with white spaces (" ")
dists<-c(dists[1,], rep(" ", (dim(dat)[[1]]-length(dists[1,]))))
cols<-c(heatcol2, rep(" ", (dim(dat)[[1]]-length(heatcol2))))
griddim<-c(x, y, rep(" ", (dim(dat)[[1]]-2)))
write.table(data.frame(dat, cluster=kohmap$unit.classif, distance2first=dists, colours=cols, griddim=griddim), "som.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL ordination-pca.R: PCA (Principal component analysis. Creates principal components using genes or samples. The number of principal component to save is controlled through the explained variablity. All principal components are saved until the explained variability is exceeded, but at least 3 components are always saved. Components are saved as new variables that can be used in further analyses.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT pca.tsv: pca.tsv 
# PARAMETER do.pca.on: do.pca.on TYPE [genes: genes, chips: chips] DEFAULT genes (Data to use for the analysis)
# PARAMETER explained.variation: explained.variation TYPE PERCENT DEFAULT 80 (Amount of experimental variation to explain)
# PARAMETER scaling: scaling TYPE [yes: yes, no: no] DEFAULT no (Scale the data to have a unit variance)
# PARAMETER centering: centering TYPE [yes: yes, no: no] DEFAULT yes (Scale the data to have the same mean)


# Principal component analysis
# Calculates principal components, and saves them for further analyses
# JTT 27.6.2006
#
# modified by MG, 29.3.2010 to enable coloring by cluster feature 

# Parameter settings (default) for testing purposes
do.pca.on<-c("chips")
explained.variation<-c(80)
scaling<-c("no")
centering<-c("yes")

# Renaming variables
pcaon<-do.pca.on
expvar<-explained.variation

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# PCA calculations
if(scaling=="yes" & centering=="yes") {
	if(pcaon=="genes") {
		pc<-prcomp(dat2, scale=T, center=T)
	}
	if(pcaon=="chips") {
		# Transpose the matrix for sample-wise PCA 
		pc<-prcomp(t(dat2), scale=T, center=T)
	}
}
if(scaling=="yes" & centering=="no") {
	if(pcaon=="genes") {
		pc<-prcomp(dat2, scale=T, center=F)
	}
	if(pcaon=="chips") {
		# Transpose the matrix for sample-wise PCA 
		pc<-prcomp(t(dat2), scale=T, center=F)
	}
}
if(scaling=="no" & centering=="yes") {
	if(pcaon=="genes") {
		pc<-prcomp(dat2, scale=F, center=T)
	}
	if(pcaon=="chips") {
		# Transpose the matrix for sample-wise PCA 
		pc<-prcomp(t(dat2), scale=F, center=T)
	}
}
if(scaling=="no" & centering=="no") {
	if(pcaon=="genes") {
		pc<-prcomp(dat2, scale=F, center=F)
	}
	if(pcaon=="chips") {
		# Transpose the matrix for sample-wise PCA 
		pc<-prcomp(t(dat2), scale=F, center=F)
	}
}

# How many PCs to save?
no<-as.vector(head(which(summary(pc)$importance[3,]>=(expvar/100)), n=1)[1])
if(no<3) {
	no<-c(3)
}
if(pcaon=="genes") {
	pcs<-pc$x[,1:no]
}
if(pcaon=="chips") {
	pcs<-pc$x[,1:no]
}

# Converting PCs from matrix format into data frame
pcs<-as.data.frame(pcs)

# Giving the PC headers new names
names(pcs)<-paste("chip.", names(pcs), sep="")
pcs<-round(pcs,digits=2)

# Add expression and other column values
if (pcaon=="genes") {
	dat4 <- cbind(dat,pcs)
}
if (pcaon=="chips") {
	dat4 <- pcs
}

# Saving the PCs with data
write.table(data.frame(dat4), "pca.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL bedtools-test.R: "Bedtools test tool" (Heippa hei!)
# INPUT reads.fastq TYPE GENERIC
# OUTPUT result.txt 
# PARAMETER first: "First base to keep" TYPE INTEGER FROM 1 TO 100 DEFAULT 1 (First base to keep.)
# PARAMETER last: "Last base to keep" TYPE INTEGER FROM 1 TO 100 DEFAULT 50 (Last base to keep.)




# EK 17.6.2011

# binary
binary <- "ls > result.txt"

# run
system(binary)

# TOOL ngs-annotate-miRNA-targets.R: "Find miRNA targets" (Fetches the predicted gene targets of a list of miRNA ID:s in one of the following databases: miRanda, miRbase, miRtarget2, PicTar, TarBase or targetScan.)
# INPUT normalized_mirna.tsv: normalized_mirna.tsv TYPE GENERIC 
# OUTPUT mirna_targets.tsv: mirna_targets.tsv 
# PARAMETER species: species TYPE [human: human] DEFAULT human (The species for which the miRNA:s have been analyzed. Mouse and rat will be supported as soon as the RmiR package from Bioconductor supports this.)
# PARAMETER database: database TYPE [miranda: miranda, mirbase: mirbase, mirtarget2: mirtarget2, pictar: pictar, tarbase: tarbase, targetscan: targetscan] DEFAULT mirtarget2 (The database from which to search for predicted target genes.)

# miRNA hypergeometric test for GO
# MG, 22.2.2010
# IS, 13.10.2010, added rownames of miRNA-target-pairs to allow intersecting through Venn diagrams

# Load the required libraries
library(RmiR.Hs.miRNA)
library(biomaRt)

# Reads the data
mirna_data <- read.table("normalized_mirna.tsv", sep="\t", header=T)

# Extracts the identifiers
mirna_id <- as.character(rownames(mirna_data))

# Fetch the complete set of target genes for a specified database
full_database <- dbReadTable(RmiR.Hs.miRNA_dbconn(), database)[, 1:2]
target_genes <- full_database[full_database$mature_miRNA %in% mirna_id,]
gene_id <- target_genes$gene_id
mirna_id_2 <- target_genes$mature_miRNA

# Fetch the gene symbols and descriptions
if (species=="human") {
	dataset <- "hsapiens_gene_ensembl"
}
if (species=="mouse") {
	dataset <- "mmusculus_gene_ensembl"
}
if (species=="rat") {
	dataset <- "rnorvegicus_gene_ensembl"
}
ensembl <- useMart("ensembl", dataset=dataset)
annotated_genes <- getBM(mart=ensembl, attributes=c("entrezgene","hgnc_symbol","description"), filters="entrezgene", values=gene_id)

# Match the list of transcripts with the annotations
gene_entrezid <- character(length(gene_id))
gene_symbol <- character(length(gene_id))
gene_description <- character(length(gene_id))
result_table <- data.frame(mirna_id_2, gene_id, gene_symbol, gene_description, stringsAsFactors = FALSE)
for (gene_count in 1:length(annotated_genes [,1])) {
	gene_entrezid <- annotated_genes[gene_count,1]
	gene_symbol <- annotated_genes[gene_count,2]
	gene_description <- annotated_genes[gene_count,3] 
	result_table [gene_id==gene_entrezid,3] <- gene_symbol
	result_table [gene_id==gene_entrezid,4] <- gene_description
}	
names(result_table) <- c("miRNA","entrez_id","symbol","description")

# add rownames to allow use of Venn diagrams
concatenate.if.not.equal <- function(x) {
  x <- unique(x)
  paste(x, collapse=';')
}
result_table$pair <- paste(result_table$miRNA, result_table$entrez_id, sep=';')
result_table2 <- aggregate(result_table[,-5], list(result_table[,5]), concatenate.if.not.equal)
result_table2$count <- aggregate(result_table[,5], list(result_table[,5]), length)$x
rownames(result_table2) <- result_table2[,1]
result_table2[,1] <- NULL

# Write out the output file
write.table(result_table2, file="mirna_targets.tsv", sep="\t", quote=FALSE)

# EOF

# TOOL dexseq-exoncount.R: "Count aligned reads per exons for DEXSeq" (Given mapped reads in a BAM file, this tool counts the reads that fall into each non-overlapping exonic part using the script dexseq-count.py. In order to use the output in DEXSeq, you need to select all samples and run the tool \"Utilities - Define NGS experiment\".)
# INPUT alignment.bam: "BAM alignment file" TYPE GENERIC
# OUTPUT exon-counts.tsv
# PARAMETER paired: "Does the alignment file contain paired-end data" TYPE [yes, no] DEFAULT no (Does the alignment data contain paired end or single end reads?)
# PARAMETER organism: "Organism" TYPE [Homo_sapiens.GRCh37.68.chr.DEXSeq.gtf: "Human (hg19.68)", Mus_musculus.GRCm38.68.chr.DEXSeq.gtf: "Mouse (mm10.68)", Rattus_norvegicus.RGSC3.4.68.chr.DEXSeq.gtf: "Rat (rn4.68)"] DEFAULT Homo_sapiens.GRCh37.68.chr.DEXSeq.gtf (Which organism is your data from.)

# 18.9.2012 TH and EK 
# 16.7.2013 EK, BAM sorting changed

# convert bam to sam, sort bam if the data is paired-end
samtools.binary <- file.path(chipster.tools.path, "samtools", "samtools")
samtools.sort <- ifelse(paired == "yes", paste(samtools.binary, "sort -on alignment.bam sorted-by-name"), "cat alignment.bam")

samtools.view <- paste(samtools.binary, "view alignment.bam")

# gtf
gtf <- file.path(chipster.tools.path, "genomes", "gtf", organism)

# exoncount
dexseq.binary <- file.path(chipster.tools.path, "dexseq-exoncounts", "dexseq_count.py")
paired.end.data <- ifelse(paired == "yes", paste("-p yes"), "")
dexseq.command <- paste("python", dexseq.binary, paired.end.data, gtf,"- exon-counts.tsv")

# run 
command <- paste(samtools.view, "|", dexseq.command)
system(command)


# bring in file to R environment for formating
file <- c("exon-counts.tsv")
dat <- read.table(file, header=F, sep="\t")
names(dat) <- c("id", "count")

# write result table to output
write.table(dat, file="exon-counts.tsv", col.names=T, quote=F, sep="\t", row.names=F)


# EOF

# TOOL sample-size-with-bh.R: "Sample size calculations with an adapted BH method" (Perform sample size calculations using an adapted Benjamini-Hochberg method.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT skewness.pdf: skewness.pdf 
# OUTPUT kurtosis.pdf: kurtosis.pdf 
# OUTPUT p-density.pdf: p-density.pdf 
# OUTPUT lambda.pdf: lambda.pdf 
# OUTPUT g.pdf: g.pdf 
# OUTPUT gamma.pdf: gamma.pdf 
# OUTPUT power.pdf: power.pdf 
# OUTPUT power.txt: power.txt 
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (The phenodata column that divides the samples into exactly two groups.)
# PARAMETER assume.equal.variances: assume.equal.variances TYPE [yes: yes, no: no] DEFAULT no (Whether to treat the variances of the two groups as equal.)
# PARAMETER distribution: distribution TYPE [normal: normal, student: student] DEFAULT normal (Whether to use the normal or the t distribution to calculate p values.)
# PARAMETER false.discovery.rate: false.discovery.rate TYPE DECIMAL DEFAULT 0.1 (False discovery rate.)
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 6400 DEFAULT 2400 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 6400 DEFAULT 2400 (Height of the plotted network image)

# sample-size-with-bh.R
# Ilari Scheinin <firstname.lastname@gmail.com>
# 2011-03-28

dat <- read.table('normalized.tsv', header=TRUE, sep='\t', as.is=TRUE, row.names=1)
phenodata <- read.table("phenodata.tsv", header=TRUE, sep="\t")
groups <- phenodata[,column]

if(length(unique(groups[!is.na(groups)]))!=2)
   stop('CHIPSTER-NOTE: You need to have exactly two groups to run this analysis')

example.data = list(x=dat[,grep('chip', colnames(dat))], y=groups, genenames=rownames(dat), geneid=1:nrow(dat), samplelabels=phenodata$description)

# This program implements the method proposed in the article "Approximate sample size calculations
# with microarray data: an illustration", by J.A. Ferreira and A.H. Zwinderman, and references
# therein. The notation follows closely that of the article.
# This is a reworking of an earlier version written for S-plus. Among other things, this version
# uses t-statistics rather than z-statistics, so it requires the loading of the library QRMlib,
# which makes it possible to compute the modified Bessel function of the 3rd kind (in terms of
# which the characteristic function of the Student distribution is expressed: see Heyde and
# Leonenko (2005), Advances in Applied Probability, 37, 342-365).
# Date: 19/02/2008
#
################################################################################################################################################
# 1. Uploading and preliminary analysis of data
################################################################################################################################################
#library(PAMr)
#library(golubEsets)
#
#help(Golub_Merge)
#data(Golub_Merge)
library(moments)
#gene.expressions<-exprs(Golub_Merge)
#Golub.data<-list(x=matrix(gene.expressions,nrow=7129,ncol=72,dimnames=NULL),y=Golub_Merge$ALL.AML,
#genenames=row.names(gene.expressions),geneid=(1:7129),samplelabels=colnames(gene.expressions))
#
#example.data<-khan.data # khan.data, Golub.data
n<-nrow(example.data$x) 
Sample.of.test.statistics<-rep(0,n)
class.names<-unique(example.data$y)
samples1<-as.matrix(example.data$x[,example.data$y==class.names[1] & !is.na(example.data$y)]) # now works with samples
samples2<-as.matrix(example.data$x[,example.data$y==class.names[2] & !is.na(example.data$y)]) # with missing group information
N1<-ncol(samples1)
N2<-ncol(samples2)
N<-1/(1/N1+1/N2)
for(i in 1:n){
  prob <- TRUE
  try({
    Sample.of.test.statistics[i]<-t.test(samples1[i,],samples2[i,],alternative="two.sided",mu=0,paired=FALSE,var.equal=(assume.equal.variances=='yes'))$statistic
    prob <- FALSE
  }, silent=TRUE)
  if (prob)
    Sample.of.test.statistics[i] <- 0
}
#
#tests.of.normality<-matrix(0,nrow=n,ncol=2)
#sample.variances<-matrix(0,nrow=n,ncol=2)
sample.skewness<-matrix(0,nrow=n,ncol=2)
sample.kurtosis<-matrix(0,nrow=n,ncol=2)
for(i in 1:n){
  #sample.means<-c(mean(samples1[i,]),mean(samples2[i,]))
  #sample.variances[i,]<-c(var(samples1[i,]),var(samples2[i,]))
  #tests.of.normality[i,]<-c(shapiro.test(samples1[i,])$p.value,shapiro.test(samples2[i,])$p.value)
  sample.skewness[i,] <- c(skewness(samples1[i,]), skewness(samples2[i,]))
  sample.kurtosis[i,] <- c(kurtosis(samples1[i,]), kurtosis(samples2[i,]))
}
normal.skewness<-matrix(0,nrow=1000,ncol=2)
normal.kurtosis<-matrix(0,nrow=1000,ncol=2)
for (i in 1:1000) {
  rnd1 <- rnorm(ncol(samples1))
  rnd2 <- rnorm(ncol(samples2))
  normal.skewness[i,] <- c(skewness(rnd1), skewness(rnd2))
  normal.kurtosis[i,] <- c(kurtosis(rnd1), kurtosis(rnd2))
}
hist.norm <- function(x, norm = NULL, ...) {
  u <- seq(min(x, na.rm=TRUE)-1, max(x, na.rm=TRUE)+1, length=401)
  if (is.null(norm)) {
    d <- dnorm(u)
  } else {
    d <- dnorm(u, mean=mean(norm), sd=sd(norm))
  }
  h <- hist(x, plot=FALSE)
  hist(x, prob=TRUE, ylim=c(0,max(h$density, d)), ...)
  lines(u, d, col='red')
}
#par(mfrow=c(1,2))
#hist(tests.of.normality[,1],prob=TRUE,xlab="p-value of Shapiro test",main=as.character(class.names[1]))
#hist(tests.of.normality[,2],prob=TRUE,xlab="p-value of Shapiro test",main=as.character(class.names[2]))
#
#windows()
#aux<-c(min(log(sample.variances[,1]),log(sample.variances[,2])),max(log(sample.variances[,1]),log(sample.variances[,2])))
#plot(log(sample.variances[,1]),log(sample.variances[,2]),xlab=paste("log of variances in",as.character(class.names[1]),""),
#ylab=paste("log of variances in",as.character(class.names[2]),""),xlim=aux,ylim=aux)
#lines((aux[1]:aux[2]),(aux[1]:aux[2]),col=2)
#
#windows()
#aux1<-c(min(Sample.of.test.statistics),max(Sample.of.test.statistics))
#aux2<-c(min(log(sample.variances[,1]/sample.variances[,2])),max(log(sample.variances[,1]/sample.variances[,2])))
#plot(Sample.of.test.statistics,log(sample.variances[,1]/sample.variances[,2]),xlab="t-statistic",ylab="log of variance ratio",
#  xlim=aux1,ylim=aux2)
#
#for(j in 1:2){
#  aux1<-c(min(log(sample.variances[,1]/sample.variances[,2])),max(log(sample.variances[,1]/sample.variances[,2])))
#  aux2<-c(min(-log(tests.of.normality[,j])),max(-log(tests.of.normality[,j])))
#  plot(log(sample.variances[,1]/sample.variances[,2]),-log(tests.of.normality[,j]),xlab="log of variance ratio",
#    ylab="-log of p-value of Shapiro test",xlim=aux1,ylim=aux2,main=as.character(class.names[j]))
#  if(j==1){windows()}
#}
#
#for(j in 1:2){
#  aux1<-c(min(Sample.of.test.statistics),max(Sample.of.test.statistics))
#  aux2<-c(min(-log(tests.of.normality[,j])),max(-log(tests.of.normality[,j])))
#  plot(Sample.of.test.statistics,-log(tests.of.normality[,j]),xlab="t-statistic",ylab="-log of p-value of Shapiro test",xlim=aux1,ylim=aux2,
#    main=as.character(class.names[j]))
#  if(j==1){windows()}
#}
# pdf(file='skewness.pdf', width=image.width/72, height=image.height/72)
pdf(file='skewness.pdf')
par(mfrow=c(1,2))
hist.norm(sample.skewness[,1], normal.skewness[,1], main=as.character(class.names[1]), xlab='skewness')
hist.norm(sample.skewness[,2], normal.skewness[,2], main=as.character(class.names[2]), xlab='skewness')
dev.off()
# pdf(file='kurtosis.pdf', width=image.width/72, height=image.height/72)
pdf(file='kurtosis.pdf')
par(mfrow=c(1,2))
hist.norm(sample.kurtosis[,1], normal.kurtosis[,1], main=as.character(class.names[1]), xlab='kurtosis')
hist.norm(sample.kurtosis[,2], normal.kurtosis[,2], main=as.character(class.names[2]), xlab='kurtosis')
dev.off()
# Reducing the data by considering only those genes with "good" goodness-of-fit results (those with p-values of the Shapiro test
# above a certain small value)
#n
#small.value<-70/n
#example.data<-reduce.data(small.value,example.data,tests.of.normality)
#nrow(example.data$x)
#
# Auxiliary function:
#reduce.data<-function(small.value,data,tests.of.normality)
#{
#  new.p.values<-1-(1-apply(tests.of.normality,1,min))^2
#  ratios.of.variances<-sample.variances[,1]/sample.variances[,2]
#  aux1<-(1:length(new.p.values))
#  #indices<-aux1[new.p.values>=small.value]
#  indices<-aux1[ratios.of.variances>=2/3 & ratios.of.variances<=3/2 & new.p.values>=small.value]
#  reduced.data<-list(x=data$x[indices,],y=data$y,genenames=data$genenames[indices],
#    geneid=data$geneid[indices],samplelabels=data$samplelabels,batchlabels=data$batchlabels)
#  return(reduced.data)
#}
#
################################################################################################################################################
# 2. Computing the sample of p-values, and plotting a density estimate of the p-values
################################################################################################################################################
# Auxiliary function:
beta.kernel.density.at.x<-function(x,data,a.n){
  return(ifelse(min(x,1-x)<=0,0,mean(dbeta(data,(x/a.n)+1,((1-x)/a.n)+1))))
}
#
if (distribution == 'student') {
    Sample.of.p.values<-2*(1-pt(abs(Sample.of.test.statistics),N1+N2-2,0)) # student
} else {
    Sample.of.p.values<-2*(1-pnorm(abs(Sample.of.test.statistics),0)) # normal
}
#
resolution<-100
c<-1
a.n<-n^((c-1)/2) #Smoothing parameter 
x<-seq(1/resolution,1-1/resolution,1/resolution)
density.estimate.of.p.values<-sapply(x,beta.kernel.density.at.x,Sample.of.p.values,a.n)
# pdf(file='p-density.pdf', width=image.width/72, height=image.height/72)
pdf(file='p-density.pdf')
plot(x,density.estimate.of.p.values,type='l',xlab="p-value",ylab="density",col=1,xlim=c(0,1),
ylim=c(0,1.1*max(density.estimate.of.p.values)))
rough.estimate.of.gamma<-beta.kernel.density.at.x(1-0.0001,Sample.of.p.values,a.n)
rough.estimate.of.gamma
lines(x,rep(rough.estimate.of.gamma,length(x)),col=2)
dev.off()
#
################################################################################################################################################
# 3. Definition of the integrands involved in the calculation of the estimate of lambda
################################################################################################################################################
# Auxiliary function:
Student.characteristic.function<-function(t,nu){
   aux<-ifelse(t==0,0,log(besselK(abs(t)*sqrt(nu),nu/2,expon.scaled=FALSE)*((abs(t)*sqrt(nu))^(nu/2))*(2^(1-nu/2)))-lgamma(nu/2))
   return(exp(aux))
}
#
first.integrand.at.t<-function(t,theta,statistics,n,a.n,N,nu){   
   cosine.t.theta<-cos(t*theta*sqrt(N))
   sine.t.theta<-sin(t*theta*sqrt(N))
   if (distribution == 'student') {
      Phi.star.t<-max(Student.characteristic.function(t,nu),0.000000000000001) # student, can sometimes be zero
   } else {
      Phi.star.t<-exp(-(t^2)/2) # normal
   }
#  Note the two choices available for Kappa.star.a.n.t
#  Kappa.star.a.n.t<-max(0,1.0-abs(a.n*t))
   Kappa.star.a.n.t<-pmax(0,1.0-abs(a.n*t)^2)^3
   Re.M.star.t<-rep(0,length(t))
   Im.M.star.t<-rep(0,length(t))
   for(i in 1:length(t)){
   Re.M.star.t[i]<-mean(cos(t[i]*statistics))
   Im.M.star.t[i]<-mean(sin(t[i]*statistics))
   }
   first.integrand<-Kappa.star.a.n.t*(cosine.t.theta*Re.M.star.t+sine.t.theta*Im.M.star.t)/Phi.star.t
   return(first.integrand)
}
#
second.integrand.at.t<-function(t,theta,statistics,n,a.n,N){   
   cosine.t.theta<-cos(t*theta*sqrt(N))
#  Note the two choices available for Kappa.star.a.n.t
#  Kappa.star.a.n.t<-max(0,1.0-abs(a.n*t))
   Kappa.star.a.n.t<-pmax(0,1.0-abs(a.n*t)^2)^3
   second.integrand<-Kappa.star.a.n.t*cosine.t.theta
   return(second.integrand)
}
#
# Examples of calls:
nu<-N1+N2-2
M<-1000
d.n<-1/(a.n*M)
t<-seq(from=-d.n*M,by=d.n,to=d.n*M)
a.n<-1.0/sqrt(log(n)) #a.n is the smoothing parameter used to smooth the empirical c.f.
first.integrand.at.t(t,0,Sample.of.test.statistics,n,a.n,N,nu)
second.integrand.at.t(t,0,Sample.of.test.statistics,n,a.n,N)
#
################################################################################################################################################
# 4. Computing and plotting estimates of lambda; each estimate is obtained by choosing a value of "initial.gamma"
################################################################################################################################################
# Auxiliary function:
estimate.of.lambda.at.theta<-function(theta,a.n,statistics,n,N,nu){
  first.integral<-integrate(first.integrand.at.t,lower=-1/a.n,upper=1/a.n,theta=theta,
  subdivisions=100000,abs.tol=0.00001,statistics=statistics,n=n,a.n=a.n,N=N,nu=nu)$value
  second.integral<-integrate(second.integrand.at.t,lower=-1/a.n,upper=1/a.n,theta=theta,
  subdivisions=100000,abs.tol=0.00001,statistics=statistics,n=n,a.n=a.n,N=N)$value
  return(c(first.integral,second.integral))
}
#
nu<-N1+N2-2
step.theta<-0.01
theta.vector<-seq(-6,6,step.theta) #Points at which lambda is to be estimated
a.n<-0.5*sqrt(nu)/log(n) #a.n is the smoothing parameter used to smooth the empirical c.f.
statistics<-Sample.of.test.statistics
initial.gamma<-0.7
#
# NB: "components.lambda" needs to be computed only ONCE; it is to be used in everything that follows
components.lambda<-t(apply(as.matrix(theta.vector),1,estimate.of.lambda.at.theta,a.n,statistics,n,N,nu))
estimate.lambda.of.theta<-sqrt(N)*(components.lambda[,1]-initial.gamma*components.lambda[,2])/((1-initial.gamma)*(2*pi))
estimate.lambda.of.theta<-pmax(rep(0,length(theta.vector)),estimate.lambda.of.theta)
Const<-sum(estimate.lambda.of.theta)*step.theta
estimate.lambda.of.theta<-estimate.lambda.of.theta/Const
#Plotting estimate.lambda.of.theta
# pdf(file='lambda.pdf', width=image.width/72, height=image.height/72)
pdf(file='lambda.pdf')
plot(theta.vector,estimate.lambda.of.theta,type='l',col=3,ylim=c(0,1.2*max(estimate.lambda.of.theta)),xlab=quote(theta),
ylab=quote(lambda(theta)))
title("Estimated density of effect sizes")
dev.off()
#
################################################################################################################################################
# 5. Computing and comparing G.n and G.hat.n
################################################################################################################################################
# First auxiliary function:
edf.at.a.point<-function(x,random.sample)
{
  sample.size<-length(random.sample)
  edf.at.x<-length(random.sample[random.sample<=x])/sample.size
  return(edf.at.x)
}
#
# Second auxiliary function:
Big.gamma.at.theta<-function(theta,u,nu,N)
{
  if (distribution == 'student') {
    return(1-pt(qt(1-u/2,nu)-theta*sqrt(N),nu)+pt(-qt(1-u/2,nu)-theta*sqrt(N),nu)) # student
  } else {
    return(1-pnorm(qnorm(1-u/2)-theta*sqrt(N))+pnorm(-qnorm(1-u/2)-theta*sqrt(N))) # normal
  }
}
#
# Third auxiliary function:
G.hat.n.at.a.point<-function(u,theta.vector,step.theta,estimate.lambda.of.theta,nu,N)
{
  aux<-sapply(as.matrix(theta.vector),Big.gamma.at.theta,u,nu,N)
  return(aux%*%estimate.lambda.of.theta*step.theta)
}
#
initial.gamma<-0.54
step.u<-0.01
u<-seq(0,1,step.u)
#
estimate.lambda.of.theta<-sqrt(N)*(components.lambda[,1]-initial.gamma*components.lambda[,2])/((1-initial.gamma)*(2*pi))
estimate.lambda.of.theta<-pmax(rep(0,length(theta.vector)),estimate.lambda.of.theta)
Const<-sum(estimate.lambda.of.theta)*step.theta
estimate.lambda.of.theta<-estimate.lambda.of.theta/Const
#
G.n.hat.u<-sapply(as.matrix(u),G.hat.n.at.a.point,theta.vector,step.theta,estimate.lambda.of.theta,nu,N)
H.n.u<-sapply(u,edf.at.a.point,Sample.of.p.values)
G.n.tilde.u<-(H.n.u-initial.gamma*u)/(1-initial.gamma)
# pdf(file='g.pdf', width=image.width/72, height=image.height/72)
pdf(file='g.pdf')
plot(u,G.n.tilde.u,type='l',xlab=quote(u),ylab=quote(G(u)),lty=c(1,3),col=c(3,2),xlim=c(0,1),ylim=c(0,max(G.n.tilde.u)))
lines(u,G.n.hat.u,col=2)
legend(c(0.6,0.8),c(0.6,0.8),c("non-parametric","semi-parametric"),lty=c(1,3),col=c(3,2),bty="n")
title("Estimates of G")
dev.off()
distance<-sum(abs(G.n.hat.u-G.n.tilde.u))*step.u
#
################################################################################################################################################
# 6. Determination of the value of Gamma.hat that minimizes D.n
################################################################################################################################################
# Auxiliary function:
distance.between.estimates.of.G.n<-function(gamma.hat,u,step.u,theta.vector,step.theta,components.lambda.of.theta,nu,N)
{
  estimate.lambda.of.theta<-sqrt(N)*(components.lambda[,1]-gamma.hat*components.lambda[,2])/((1-gamma.hat)*(2*pi))
  estimate.lambda.of.theta<-pmax(rep(0,length(theta.vector)),estimate.lambda.of.theta)
  Const<-sum(estimate.lambda.of.theta)*step.theta
  estimate.lambda.of.theta<-estimate.lambda.of.theta/Const
  G.n.hat.u<-sapply(as.matrix(u),G.hat.n.at.a.point,theta.vector,step.theta,estimate.lambda.of.theta,nu,N)
  H.n.u<-sapply(u,edf.at.a.point,Sample.of.p.values)
  G.n.tilde.u<-(H.n.u-gamma.hat*u)/(1-gamma.hat)
  distance<-sum(abs(G.n.hat.u-G.n.tilde.u))*step.u
  return(distance)
}
#
step.gamma<-0.01
gamma.vector<-seq(step.gamma,1-step.gamma,step.gamma)
distances<-sapply(as.matrix(gamma.vector),distance.between.estimates.of.G.n,u,step.u,theta.vector,step.theta,components.lambda.of.theta,nu,N)
#
minimum.distance<-min(distances)
gamma.hat<-gamma.vector[distances<=minimum.distance]
#
# pdf(file='gamma.pdf', width=image.width/72, height=image.height/72)
pdf(file='gamma.pdf')
plot(gamma.vector,distances,type='l',xlab=quote(~~gamma),ylab=quote(D[n](gamma)),col=1,ylim=c(0,1))
dev.off()
#
################################################################################################################################################
# 7. Computation of the sample size required to achieve a certain power subject to a given false discovery rate (f.d.r.)
################################################################################################################################################
Gamma<-gamma.hat
#delta<-0.1 # nominal f.d.r.
delta<-false.discovery.rate
r<-delta*(1-Gamma)/(Gamma*(1-delta))
#
step.u<-0.01
u<-seq(0,1,step.u)
#Nprime<-N
#
estimate.lambda.of.theta<-sqrt(N)*(components.lambda[,1]-initial.gamma*components.lambda[,2])/((1-initial.gamma)*(2*pi))
estimate.lambda.of.theta<-pmax(rep(0,length(theta.vector)),estimate.lambda.of.theta)
Const<-sum(estimate.lambda.of.theta)*step.theta
estimate.lambda.of.theta<-estimate.lambda.of.theta/Const
#
samplesize.coefs <- c(0.25, 0.5, 0.75, 1:30)
samplesize.N <- 1/(1/N1/samplesize.coefs + 1/N2/samplesize.coefs)
samplesize <- samplesize.coefs * (N1+N2)
if (samplesize[length(samplesize)-1] > 300) {
  last <- max(which(samplesize <= 300)) + 1
  samplesize.N <- samplesize.N[1:last]
  samplesize <- samplesize[1:last]
}
power <- numeric(length=length(samplesize.N))
names(power) <- samplesize.N
for(Nprime in samplesize.N) {
    G.n.hat.u<-sapply(as.matrix(u),G.hat.n.at.a.point,theta.vector,step.theta,estimate.lambda.of.theta,nu,Nprime)
    #
    u.star<-max(u[G.n.hat.u>u/r])
    this.power<-u.star/r # laske tama
    power[as.character(Nprime)] <- this.power
    #plot(u,G.n.hat.u,type='l',xlab=quote(u),ylab=quote(G(u)),lty=c(1,3),col=c(3,2),xlim=c(0,u.star*1.5),ylim=c(0,max(G.n.tilde.u)))
    #lines(u,u/r)
    #title(paste("Power calculation for N'=",round(Nprime,digits=1),""))
}
# pdf(file='power.pdf', width=image.width/72, height=image.height/72)
pdf(file='power.pdf')
plot(samplesize, power, type='b', main=paste('Power calculation for FDR = ', round(100*delta), '%', sep=''),
  xlim=c(0, 300), ylim=0:1, ylab='Average power',
  xlab=paste('Number of samples (', round(100*N1/(N1+N2)), '% ', class.names[1], ', ', round(100*N2/(N1+N2)), '% ', class.names[2], ')', sep=''))
dev.off()
#
write.table(data.frame(samplesize, power), file="power.txt", quote=FALSE, col.names=TRUE, row.names=FALSE, sep='\t')
#
################################################################################################################################################

# EOF

# TOOL cna-define-experiment.R: "Define CNA-seq experiment" (This tool creates a phenodata file containing descriptive information about samples and experiment setup.)
# INPUT binned-hits-{...}.tsv: "Individual files with binned hits" TYPE GENERIC
# OUTPUT cna-data-table.tsv: "Data table with log-transformed read counts"
# OUTPUT META phenodata.tsv: "Experiment description file"

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-12-20

filenames <- list.files(pattern='^binned-hits-[0-9]*\\.tsv$')
dat <- read.table(filenames[1], header=TRUE, sep='\t', row.names=1, as.is=TRUE)
total.reads <- sum(dat$count, na.rm=TRUE)
dat$count <- log2(dat$count+1)

if (length(filenames) > 1) {
  for (i in 2:length(filenames)) {
    x <- read.table(filenames[i], header=TRUE, sep='\t', row.names=1, as.is=TRUE)
    if (nrow(x) != nrow(dat))
      stop("CHIPSTER-NOTE: All input files need to be binned using the same bin size.")
    total.reads <- c(total.reads, sum(x$count, na.rm=TRUE))
    dat <- cbind(dat, log2(x$count+1))
  }
}

identifiers <- gsub('tsv$', '', filenames)
identifiers <- gsub('\\.', '', identifiers)
identifiers <- gsub('-', '', identifiers)
colnames(dat)[-(1:5)] <- paste('chip.', identifiers, sep='')

# generate phenodata
phenodata <- data.frame(sample=filenames, chiptype='not applicable', experiment='cna_seq', reads=total.reads, group='', stringsAsFactors=FALSE)

# write outputs
options(scipen=10)
write.table(dat, 'cna-data-table.tsv', quote=FALSE, sep='\t', na='')
write.table(phenodata, file='phenodata.tsv', quote=FALSE, sep='\t', row.names=FALSE)

# EOF

# TOOL cluster-hierarchical.R: Hierarchical (Hierarchical clustering of genes or chips. Specify the distance measure and the clustering method. The clustering result can be validated using bootstrapping. Validation is computationally very expensive, and works for approximately less than 100 genes.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT hc.tre: hc.tre 
# OUTPUT resample.pdf: resample.pdf 
# PARAMETER cluster: cluster TYPE [genes: genes, chips: chips] DEFAULT genes (What to cluster)
# PARAMETER distance.method: distance.method TYPE [euclidian: euclidian, manhattan: manhattan, pearson: pearson, spearman: spearman] DEFAULT pearson (Distance measure)
# PARAMETER tree.method: tree.method TYPE [single: single, average: average, complete: complete, ward: ward] DEFAULT average (Clustering method)
# PARAMETER resampling: resampling TYPE [none: none, bootstrap: bootstrap] DEFAULT none (Validation)
# PARAMETER number.of.replicates: number.of.replicates TYPE INTEGER FROM 1 TO 10000 DEFAULT 1000 (Number of pseudoreplicates to use in validation)
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the resampling image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the resampling image)

# Hierarchical clustering, permutation testing 
# JTT 22.6.2006
#
# MG 25.11.2010
# Increased the gene/sample limit to 20000

# Parameter settings (default) for testing purposes
#cluster<-c("chips")
#distance.method<-c("euclidian")
#tree.method<-c("ward")
#resampling<-c("none")
#number.of.replicates<-c(100)
#image.width<-600
#image.height<-600


# Renaming variables
margin<-cluster
distmeth<-distance.method
treemeth<-tree.method
doresample<-resampling
perms<-number.of.replicates
w<-image.width
h<-image.height
do.sample<-c("all")

if(distmeth=="pearson") {
   distmeth<-"correlation"
}

# Loads the libraries
library(amap)
library(ape)

# Loads the data file
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Check that resampling is not applied to dataset larger than 1000 genes
if (resampling == "bootstrap" && nrow(dat)>1000) {
	stop("CHIPSTER-NOTE: Bootstrap resampling on datasets larger than 1000 genes is not possible due to computing time limitations. Please note that you can run hierarchical clustering on datasets including up to 20000 genes, provided the resampling option is turned off.")
}

# Takes a sample of the data
# PARAMETER do.sample [25, 50, 75, 100, 125, 150, 175, 200, all] DEFAULT 100 (If the data is large, should the image be generated from a specified number of random genes)
if(do.sample!="all") {
   sample.size<-as.numeric(do.sample)
   if(nrow(dat2)<sample.size) {
      do.sample<-"all"
   }
   if(do.sample=="25") {
      dat2<-dat2[sample(nrow(dat2), 25),]
   }
   if(do.sample=="50") {
      dat2<-dat2[sample(nrow(dat2), 50),]
   }
   if(do.sample=="75") {
      dat2<-dat2[sample(nrow(dat2), 75),]
   }
   if(do.sample=="100") {
      dat2<-dat2[sample(nrow(dat2), 100),]
   }
   if(do.sample=="125") {
      dat2<-dat2[sample(nrow(dat2), 125),]
   }
   if(do.sample=="150") {
      dat2<-dat2[sample(nrow(dat2), 150),]
   }
   if(do.sample=="175") {
      dat2<-dat2[sample(nrow(dat2), 175),]
   }
   if(do.sample=="200") {
      dat2<-dat2[sample(nrow(dat2), 200),]
   }
}

# Manipulate data depending on what to cluster
if(margin=="chips") {
   dat2<-t(dat2)        
}

if (nrow(dat2) > 20000) {
  stop("Hierarchical clustering can be run on maximum 20000 of genes/samples");
}

# Tree calculation, no resampling
if(doresample=="none") {
   clust<-hcluster(x=dat2, method=distmeth, link=treemeth)
   phylo.clust<-as.phylo(clust)
   write.tree(phylo.clust, "hc.tre")
   # write.table(data.frame(dat, order=clust$order, mergex=c(clust$merge[,1], 0), mergey=c(clust$merge[,2], 0), height=c(clust$height, 0)), "hc.tre", sep="\t", row.names=T, col.names=T, quote=F)
}

# Tree calculation, with resampling
if(doresample=="none"){
   pdf(file="resample.pdf", width=w/72, height=h/72)
   plot(1, 1, col=0)
   text(1, 1, "This is a dummy image.", col=1)
   text(1, 0.9, "To generate a real image, turn on the bootstrapping option.", col=1)
   text(1, 0.8, "Note, that bootstrapping is not necessary, and might take a very long time to complete.", col=1)
   dev.off()
}
if(doresample=="bootstrap"){
   library(pvclust)
   clust<-hcluster(x=dat2, method=distmeth, link=treemeth)
   phylo.clust<-as.phylo(clust)
   write.tree(phylo.clust, "hc.tre")
   if(distmeth=="spearman" | distmeth=="manhattan") {
      stop("Resampling can only be applied if Pearson correlation or euclidian distance is used! If appropriate, change the settings accordingly.")
   }
   dat2<-t(dat2)
   pv.clust<-pvclust(dat2, method.dist=distmeth, method.hclust=treemeth, nboot=perms, r=1)
   pdf(file="resample.pdf", width=w/72, height=h/72)
   plot(pv.clust, cex.pv=0.75, font.pv=0.75, cex=0.75)
   dev.off()
}

# TOOL norm-cdna.R: cDNA (cDNA data preprocessing. Automatically averages all the rows, i.e., genes that have the same name.)
# INPUT microarray{...}.tsv: microarray{...}.tsv TYPE CDNA 
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# PARAMETER background.treatment: background.treatment TYPE [none: none, subtract: subtract, edwards: edwards, normexp: normexp] DEFAULT normexp (Background treatment method)
# PARAMETER background.offset: background.offset TYPE [0: 0, 50: 50] DEFAULT 50 (Background offset)
# PARAMETER normalize.arrays: normalize.arrays TYPE [none: none, median: median, loess: loess] DEFAULT loess (Within array normalization method)
# PARAMETER normalize.genes: normalize.genes TYPE [none: none, scale: scale, quantile: quantile, Aquantile: Aquantile, vsn: vsn] DEFAULT none (Between arrays normalization method)


# cDNA chip normalization
# JTT 9.6.2006

#background.treatment<-"normexp"
#background.offset<-c(50)
#normalize.arrays<-"loess"
#normalize.genes<-"none"

# Loads the libraries
library(limma)

# Renaming variables
bg<-background.treatment
normwa<-normalize.arrays
normba<-normalize.genes

# Reading data
columns<-list(R="sample", Rb="samplebg", G="control", Gb="controlbg")
annotation<-c("annotation", "identifier")
columns.other<-c("flag")

files<-dir()
files<-files[files!="phenodata.tsv"]
dat<-read.maimages(files=files, columns=columns, annotation=annotation, other.columns=columns.other) 

# Normalization within arrays
dat2<-normalizeWithinArrays(dat, method=normwa, bc.method=bg, offset=as.numeric(background.offset))

# Normalization across arrays
dat3<-normalizeBetweenArrays(dat2, method=normba)

# Modifies the phenodata table by writing one more row to it ((Affymetrix) chip type)
sample<-paste(colnames(dat2$M), ".tsv", sep="")
group<-c(rep("", length(sample)))
training<-c(rep("", length(sample)))
time<-c(rep("", length(sample)))
random<-c(rep("", length(sample)))
chiptype<-c("cDNA")
write.table(data.frame(sample=sample, chiptype=chiptype, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# Constructs and writes out a table of data
M<-dat3$M
A<-dat3$A
rownames(M)<-dat3$genes$identifier
rownames(A)<-dat3$genes$identifier
M<-aggregate(M, list(rownames(M)), mean)
A<-aggregate(A, list(rownames(A)), mean)
rownames(M)<-M$Group.1
rownames(A)<-A$Group.1
genes<-rownames(M)
M<-M[,-1]
A<-A[,-1]
if(length(dat$other$flag)!=0) {
   flags<-as.data.frame(dat$other$flag)
   names(flags)<-paste("flag.", names(flags), sep="")
}
if(length(dat$other$flag)==0) {
   flags<-matrix(nrow=0, ncol=0)
}
names(M)<-paste("chip.", names(M), sep="")
names(A)<-paste("average.", names(A), sep="")

A<-data.frame(round(A, digits=2))
M<-data.frame(round(M, digits=2))

if(nrow(flags)!=nrow(A) | nrow(flags)!=nrow(M)) {
   D<-data.frame(M, A)
} else {
   D<-data.frame(M, A, flags)
}
rownames(D)<-genes

write.table(D, file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)

# TOOL acgh-plot-combined-profile.R: "Plot profiles of matched copy number and expression" (Plot profiles of two priorly matched data sets of copy number and expression. This tool must be run on the output from the tool Match copy number and expression features.)
# INPUT matched-cn-and-expression.tsv: matched-cn-and-expression.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT matched-cn-and-expression-profile.pdf: matched-cn-and-expression-profile.pdf 
# PARAMETER samples: samples TYPE STRING DEFAULT 1 (The numbers of the samples to be plotted, separated by commas. Ranges are also supported (e.g. 1,3,7-10\).)
# PARAMETER chromosome: chromosome TYPE INTEGER DEFAULT 0 (The chromosome to plot. Use 0 for all.)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2013-03-20

source(file.path(chipster.common.path, 'CGHcallPlus.R'))
library(intCNGEan)

# read the input files
file <- 'matched-cn-and-expression.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, as.is=TRUE, check.names=FALSE)
phenodata <- read.table('phenodata.tsv', header=TRUE, sep='\t', as.is=TRUE)

# check if the matched data was produced with an old version
if (length(grep("^exprs\\.", names(dat)))!=0)
  stop('CHIPSTER-NOTE: The input file matched-cn-and-expression.tsv has been produced with an old version of the Match copy number and expression probes script. Please re-run that script first, and use the output from the new version.')

# check that the input file seems to be coming from the script used to match the two data sets
pos <- c('chromosome','cn.start','cn.end','exp.start','exp.end')
if (length(setdiff(pos, colnames(dat)))!=0)
  stop('CHIPSTER-NOTE: This tool can only be run on the output file from the tool Match copy number and expression probes (matched-cn-and-expression.tsv).')

# parse samples to be plotted
samples <- gsub('[^0-9,-]', ',', samples)
items <- strsplit(samples, ',')[[1]]
samples.to.plot <- integer()
for (item in items) {
  item <- item[item!='']
  if (length(item)==0) next
  range <- strsplit(item, '-')[[1]]
  range <- range[range!='']
  if (length(range)==0) next
  samples.to.plot <- c(samples.to.plot, seq(range[1], range[length(range)]))
}
samples.to.plot <- unique(samples.to.plot)

# build the necessary object
dat$chromosome[dat$chromosome=='X'] <- 23
dat$chromosome[dat$chromosome=='Y'] <- 24
dat$chromosome[dat$chromosome=='MT'] <- 25
dat$chromosome <- as.integer(dat$chromosome)

exprs <- as.matrix(dat[,grep("^chip\\.", names(dat))])
calls <- as.matrix(dat[,grep("^flag\\.", names(dat))])
copynumber <- as.matrix(dat[,grep("^logratio\\.", names(dat))])
segmented <- as.matrix(dat[,grep("^segmented\\.", names(dat))])
probloss <- as.matrix(dat[,grep("^probloss\\.", names(dat))])
probnorm <- as.matrix(dat[,grep("^probnorm\\.", names(dat))])
probgain <- as.matrix(dat[,grep("^probgain\\.", names(dat))])

cgh <- new('cghCall', assayData=assayDataNew(calls=calls, copynumber=copynumber, segmented=segmented, probloss=probloss, probnorm=probnorm, probgain=probgain), featureData=new('AnnotatedDataFrame', data=data.frame(Chromosome=dat$chromosome, Start=dat$cn.start, End=dat$cn.end, row.names=row.names(dat))))
sampleNames(cgh) <- phenodata$description_cgh

exp <- new("ExpressionSet", exprs=exprs, featureData=new("AnnotatedDataFrame", data=data.frame(Chromosome=dat$chromosome, Start=dat$exp.start, End=dat$exp.end, row.names=row.names(dat))))
sampleNames(exp) <- phenodata$description

matched <- list(CNdata.matched=cgh, GEdata.matched=exp)

# remove samples that are out of bounds
samples.to.plot <- samples.to.plot[samples.to.plot<=length(sampleNames(matched$CNdata.matched))]

# check that we have something to plot
if (length(samples.to.plot)==0)
  stop('CHIPSTER-NOTE: Nothing to plot.')

# plot
pdf(file='matched-cn-and-expression-profile.pdf', paper='a4r', width=0, height=0)
for (sample in samples.to.plot)
  intCNGEan.profilesPlot(matched$CNdata.matched, matched$GEdata.matched, sampleNo=sample, chr=chromosome)
dev.off()

# EOF

# TOOL combine-probes-to-genes.R: "Combine probes to genes" (Calculates an average for probes or probesets for each gene in the dataset. The data file has to have a symbol column for this to work correctly.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT combined.tsv: combined.tsv 
# PARAMETER produce.identifiers: produce.identifiers TYPE [no: no, yes: yes] DEFAULT no (Should approximate identifiers for the gene be returned)


# Combine probes or probeset to genes
# 18.12.2008 JTT
#
# modified 3.3.2010, MG, to include symbol and description columns in the output
# if present in the input data table
#
# modified 15.4.2010 MG to make the script compatible with output from "Add annotations to data" tool

# Parameter settings (default) for testing purposes
#produce.identifiers<-"no"

# Loads the file
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Make sure that column names for symbols and descriptions do not begin
# with a capital letter
colnames (dat) [colnames(dat)=="Symbol"] <- "symbol"
colnames (dat) [colnames(dat)=="Description"] <- "description"

# Check whether there are symbols at all 
symbols <- dat[,grep("symbol", names(dat))]
descriptions <- dat[,grep("descriptions", names(dat))]
if (length(symbols)==0) {
	stop("CHIPSTER-NOTE: You must provide gene symbols for this tool to work! Try first to add these using the \"Add annotations to data\" tool.")
}

# Remove data rows where the there is no symbol information
dat <- dat[symbols!="",]
symbols <- dat[,grep("symbol", names(dat))]

# Separates expression values from other data
dat2<-dat[,grep("chip", names(dat))]

# Preparations
test1<-aggregate(dat2[,1], list(symbols), mean)
dat3<-matrix(ncol=ncol(dat2), nrow=nrow(test1), data=NA)
# dat4<-matrix(ncol=ncol(dat2), nrow=nrow(test1), data=NA)

# Combination
for(i in 1:ncol(dat2)) {
	m<-aggregate(dat2[,i], list(dat$symbol), mean)
	# s<-aggregate(dat2[,i], list(dat$symbol), sd)
	# s$x[is.na(s$x)]<-0
	dat3[,i]<-m$x
	# dat4[,i]<-s$x
}

# Second round of combination
if(produce.identifiers=="yes") {
	
	symbol<-m$Group.1
	
	# Generating rownames
	genes<-rep(NA, length(symbol)) 
	for(i in 1:length(symbol)) {
		genes[i]<-rownames(dat)[grep(symbol[i], dat$symbol)][1]
	}
	
	# Second round of combination, now according to rownames
	test2<-aggregate(dat3[,1], list(genes), mean)
	dat6<-matrix(ncol=ncol(dat2), nrow=nrow(test2), data=NA)
	
	for(i in 1:ncol(dat2)) {
		m<-aggregate(dat3[,i], list(genes), mean)
		dat6[,i]<-m$x
	}
	
	rownames(dat6)<-genes[!duplicated(genes)]
	colnames(dat6)<-colnames(dat2)
	
	# Fetch back the symbol and description column, if present
	# in the original data
	if (length(symbols)>0) {
		symbols2 <- as.character(dat$symbol[match (rownames(dat6), rownames(dat))])
		descriptions2 <- as.character(dat$description[match (rownames(dat6), rownames(dat))])
		annotations <- cbind(symbols2, descriptions2)
		dat6 <- data.frame(annotations, dat6)
		names(dat6) [1:2] <- c("symbol", "description")
	}
	
	write.table(data.frame(dat6), file="combined.tsv", col.names=T, quote=F, sep="\t", row.names=T)
	
} else {
	
	# Putting a data file together
	colnames(dat3)<-colnames(dat2)
	# colnames(dat4)<-paste("sd.", colnames(dat2), sep="")
	symbol<-m$Group.1
	# dat5<-data.frame(symbol, dat3, dat4) 
	dat5<-data.frame(dat3) 
	rownames(dat5)<-symbol
	
	# Fetch back the description column, if present
	# in the original data
	if (length(descriptions)>0) {
		descriptions2 <- as.character(dat$description[match (rownames(dat5), dat$symbol)])
		dat5 <- data.frame(descriptions2, dat5)
		names(dat5) [1] <- "description"
	}
	
	# Writing data to disk
	write.table(data.frame(dat5), file="combined.tsv", col.names=T, quote=F, sep="\t", row.names=T)
}

# TOOL ordination-ca.R: DCA (Does a detrended correspondence analysis for the data. Can be used for, e.g., quality control.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT ca.png: ca.png 
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Non-metric multidimensional scaling
# JTT 30.1.2009

# Parameter settings (default) for testing purposes
#image.width<-c(600)
#image.height<-c(600)

# Renaming variables
w<-image.width
h<-image.height

# Loads the libraries
library(vegan)
library(MASS)

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Loads phenodata
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")

# Decorana can't handle negative values
if(any(dat2<0)) {
   dat2<-na.omit(dat2)
   dat2<-dat2+abs(min(dat2))
}

# Detrended correspondence analysis
fit<-decorana(dat2)

# Plotting the image
bitmap(file="ca.png", width=w/72, height=h/72)
plot(fit, main="Detrended correspondence analysis", type="n")
points(fit, display=c("species"), pch=15, col=phenodata$group)
points(fit, display=c("sites"), pch=20, col=c("black"), cex=0.6)
text(fit, display=c("species"), labels=phenodata$description, cex=0.75, adj=1)
dev.off()

# TOOL stat-correlate-with-phenodata.R: "Correlate with phenodata" (Finds genes that correlate highly with the specified phenodata column.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT correlate-with-phenodata.tsv: correlate-with-phenodata.tsv 
# PARAMETER correlation.cutoff: correlation.cutoff TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.95 (Correlation cut-off for similar expression)
# PARAMETER correlation.method: correlation.method TYPE [pearson: pearson, spearman: spearman] DEFAULT pearson (Correlation method)
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column containing the data to correlate genes with)


# Find genes that correlate with phenodata
# JTT 19.7.2007

# Parameter settings (default) for testing purposes
#correlation.cutoff<-c(0.95)
#correlation.method<-c("pearson")
#column<-c("group")

# Renaming variables
cutoff<-correlation.cutoff
meth<-correlation.method

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Test needs a parameter "groups" that specifies the grouping of the samples
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
groups<-phenodata[,pmatch(column,colnames(phenodata))]

# Sanity checks
if(nrow(phenodata)!=ncol(dat2)) {
   stop("Dimensions of data and phenodata do not match! Can't execute the analysis.")
}

# Calculating the correlations
p<-rep(0, nrow(dat2))
for(i in 1:nrow(dat2)) {
   p[i]<-cor(groups, as.numeric(dat2[i,]), method=meth)
}

# Filtering the data on the correlation
dat<-dat[abs(p)>=cutoff,]
p<-p[abs(p)>=cutoff]

# Saving the results
write.table(data.frame(dat, corr=round(p, digits=6)), file="correlate-with-phenodata.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL htseq-count.R: "Map aligned reads to genes with HTSeq" (Calculates how many reads in a BAM file map to each gene. If you would like to map reads against your own GTF files, please use the tool \"Map aligned reads to genes with HTSeq using own GTF\". This tool is based on the HTSeq package. In order to use the output in edgeR or DESeq, you need to select all samples and run the tool \"Utilities - Define NGS experiment\".)
# INPUT alignment.bam: "BAM alignment file" TYPE GENERIC
# OUTPUT htseq-counts.tsv 
# OUTPUT OPTIONAL htseq-count-info.txt
# PARAMETER paired: "Does the alignment file contain paired-end data" TYPE [yes, no] DEFAULT no (Does the alignment data contain paired end or single end reads?)
# PARAMETER stranded: "Was the data produced with a strand-specific RNA-seq protocol" TYPE [yes, no, reverse] DEFAULT no (If you select no, a read is considered overlapping with a feature regardless of whether it is mapped to the same or the opposite strand as the feature. If you select yes, the read has to be mapped to the same strand as the feature. You have to say no, if your was not made with a strand-specific RNA-seq protocol, because otherwise half your reads will be lost.)
# PARAMETER organism: "Organism" TYPE [Homo_sapiens.GRCh37.68.chr.gtf: "Human (hg19.68)", Mus_musculus.GRCm38.68.chr.gtf: "Mouse (mm10.68)", Mus_musculus.NCBIM37.62.chr.gtf: "Mouse (mm9.62)", Rattus_norvegicus.RGSC3.4.68.chr.gtf: "Rat (rn4.68)"] DEFAULT Homo_sapiens.GRCh37.68.chr.gtf (Which organism is your data from.)
# PARAMETER OPTIONAL mode: "Mode to handle reads overlapping more than one feature" TYPE [union, intersection-strict, intersection-nonempty] DEFAULT union (How to deal with reads that overlap more than one gene or exon?)
# PARAMETER OPTIONAL minaqual: "Minimum alignment quality" TYPE INTEGER FROM 0 TO 100 DEFAULT 0 (Skip all reads with alignment quality lower than the given minimum value.)
# PARAMETER OPTIONAL feature.type: "Feature type to count" TYPE [exon, CDS] DEFAULT exon (Which feature type to use, all features of other type are ignored.)
# PARAMETER OPTIONAL id.attribute: "Feature ID to use" TYPE [gene_id, transcript_id, gene_name, transcript_name, protein_name] DEFAULT gene_id (GFF attribute to be used as feature ID. Several GFF lines with the same feature ID will be considered as parts of the same feature. The feature ID is used to identify the counts in the output table.)

# TH and EK 18.1.2012
# EK changed to use Ensembl GTFs 17.4.2012

# bash wrapping
python.path <- paste(sep="", "PYTHONPATH=", file.path(chipster.tools.path, "lib", "python2.6", "site-packages"), ":$PYTHONPATH")
command.start <- paste("bash -c '", python.path, ";")
command.end <- "'"

# sort bam if the data is paired-end
samtools.binary <- file.path(chipster.tools.path, "samtools", "samtools")
samtools.sort <- ifelse(paired == "yes", paste(samtools.binary, "sort -on alignment.bam sorted-by-name"), "cat alignment.bam")

# convert bam to sam
samtools.view <- paste(samtools.binary, "view -")

# htseq-count
htseq.binary <- file.path(chipster.tools.path, "htseq", "htseq-count")
gtf <- file.path(chipster.tools.path, "genomes", "gtf", organism)
htseq <- paste(htseq.binary, "-q -m", mode, "-s", stranded, "-a", minaqual, "-t", feature.type, "-i", id.attribute, "-", gtf, " > htseq-counts-out.txt")

# run
command <- paste(command.start, samtools.sort, " | ", samtools.view, " | ", htseq, command.end)
system(command)

# separate result file
system("head -n -5 htseq-counts-out.txt > htseq-counts.tsv")
system("tail -n 5 htseq-counts-out.txt > htseq-count-info.txt")

# bring in file to R environment for formating
file <- c("htseq-counts.tsv")
dat <- read.table(file, header=F, sep="\t")
names(dat) <- c("id", "count")

# write result table to output
write.table(dat, file="htseq-counts.tsv", col.names=T, quote=F, sep="\t", row.names=F)

# EOF

# TOOL samtools-merge.R: "Merge BAM" (Merges sorted BAM files and creates an index for the result file, so that it is possible to view it in the Chipster genome browser. This tool is based on the SAMtools package.)
# INPUT alignment{...}.bam: alignment{...}.bam TYPE GENERIC 
# OUTPUT merged.bam 
# OUTPUT merged.bam.bai

# EK 27.10.2011

# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

# convert sam to bam
system(paste(samtools.binary, "merge merged-not-sorted.bam alignment*.bam"))

# sort bam
system(paste(samtools.binary, "sort merged-not-sorted.bam merged"))

# index bam
system(paste(samtools.binary, "index merged.bam"))

# TOOL stat-linear-modelling-designmat.R: "Linear modelling using user-defined design matrix" (Analyzes the data using linear modelling as implemented in the R package limma and users-define design-matrix. Fold changes and p-values are reported for all effects and interactions. If desired, technical replication can be blocket by settting a blocking variable.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT design.tsv: design.tsv TYPE GENERIC
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC
# OUTPUT limma.tsv: limma.tsv
# OUTPUT foldchange.tsv: foldchange.tsv 
# OUTPUT pvalues.tsv: pvalues.tsv 
# PARAMETER technical.replication: technical.replication TYPE METACOLUMN_SEL DEFAULT EMPTY (Technical replication)
# PARAMETER cont.string: contrasts TYPE STRING DEFAULT empty (List of contrasts to be compared separated by commas)
# PARAMETER p.value.adjustment.method: p.value.adjustment.method TYPE [none: none, bonferroni: bonferroni, holm: holm, hochberg: hochberg, BH: BH, BY: BY] DEFAULT BH (Multiple testing correction method)

# MK, 24.06.2013 created linear Modelling using limma
 
# Loads the libraries
library(limma)

# Loads the normalized data
file	<- c("normalized.tsv")
dat		<- read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls	<- dat[,grep("flag", names(dat))]
dat2	<- dat[,grep("chip", names(dat))]

# Loads phenodata
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")

# Loads design-matrix
design	<- read.table("design.tsv", header=T, sep="\t", row.names=1)
colnames(design) <- paste("x", colnames(design), sep="")
rownames(design) <- colnames(dat2)

# Fit linear models
if(technical.replication == "EMPTY") {
	fit				<- lmFit(dat2, design);
} else {
	techrep			<- phenodata[,grep(technical.replication, colnames(phenodata))]
	corfit			<- duplicateCorrelation(dat2, ndups=1, block=techrep)
	fit				<- lmFit(dat2, design, block=techrep, cor=corfit$consensus)
}

# Create a contrast mat and check validity
if(cont.string != "empty") {
	cont.string 	<- gsub("\\s+", "", cont.string)
	contrast.string <- paste("x", unlist(strsplit(cont.string, ",")), sep="")
	contrast.string <- gsub("-", "-x", contrast.string)
		
	for(i in 1:length(contrast.string)) {
		col.names <- unlist(strsplit(contrast.string[i], "-"))
		if(length(col.names) == 1) {
			if(!(col.names[1] %in% colnames(design))) {
				stop("CHIPSTER-NOTE: Design-matrix has no column for one of the given constrast")
			}
		} else {
			if(!(col.names[1] %in% colnames(design)) | !(col.names[2] %in% colnames(design))) {
				stop("CHIPSTER-NOTE: Design-matrix has no column for one of the given constrast")
			}
		}
	}
		
	contrasts.mat	<- makeContrasts(contrasts=contrast.string, levels=design)	
	fit2            <- contrasts.fit(fit, contrasts.mat);	
	fit				<- fit2
}

# Compute p-values
fit     			<- eBayes(fit)
colnames(fit$coef)  <- gsub("^x", "", colnames(fit$coef))
colnames(fit$coef)  <- gsub("-x", "-", colnames(fit$coef))

# Extracting data
m		<- matrix(nrow=nrow(fit$coef), ncol=ncol(fit$coef))
mm		<- matrix(nrow=nrow(fit$coef), ncol=ncol(fit$coef))
for(i in 1:ncol(fit$coef)) {
	pp			<-toptable(fit, coef=i, number=nrow(dat2), adjust.method=p.value.adjustment.method, sort.by="none")
	m[,(i)] 	<-pp$P.Value
	mm[,(i)] 	<-pp$logFC
}

# Fold change
fc					<- data.frame(mm)
fc					<- data.frame(round(fc, digits=2))
colnames(fc)		<- paste("FC.", colnames(fit$coef), sep="")
rownames(fc)		<- rownames(dat)
fc2					<- data.frame(fc)
colnames(fc2)		<- paste("chip.FC.", colnames(fit$coef), sep="")

# P-values
pvalues				<- data.frame(m)
pvalues				<- data.frame(round(pvalues, digits=6))
colnames(pvalues)	<- paste("p.adjusted.", colnames(fit$coef), sep="")
rownames(pvalues)	<- rownames(dat)
pvalues2			<- data.frame(pvalues)
colnames(pvalues2)	<- paste("chip.p.adjusted.", colnames(fit$coef), sep="")

# Create data frames
dat3				<- cbind(dat, pvalues, fc)

# Write data to disk
write.table(dat3, file="limma.tsv", sep="\t", row.names=T, col.names=T, quote=F)
write.table(fc2, file="foldchange.tsv", sep="\t", row.names=T, col.names=T, quote=F)
write.table(pvalues2, file="pvalues.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# This install script is run in bare R installation and 
# it installs all packages required to run Chipster.
# The script uses install functions that check each package
# before installation, meaning that it can be rerun if needed
# and only missing packages are installed.

# Configure paths and repos (change if you need)
chipster.path <- "/opt/chipster/"
repo.cran <- "http://ftp.sunet.se/pub/lang/CRAN"
repo.bioc <- "http://www.bioconductor.org"

# Use smart.* install utility functions
# They skip all packages that already have been installed
source(file(chipster.path, "comp/modules/admin/R-3.0/smip.R"))

# Install packages, and their dependencies, from CRAN
smart.install.packages(package="amap", mirror=repo.cran)
smart.install.packages(package="ape", mirror=repo.cran)
smart.install.packages(package="flexclust", mirror=repo.cran)
smart.install.packages(package="kohonen", mirror=repo.cran)
smart.install.packages(package="e1071", mirror=repo.cran)
smart.install.packages(package="fastICA", mirror=repo.cran)
smart.install.packages(package="aplpack", mirror=repo.cran)
smart.install.packages(package="corrgram", mirror=repo.cran)
smart.install.packages(package="deal", mirror=repo.cran)
smart.install.packages(package="outliers", mirror=repo.cran)
smart.install.packages(package="pvclust", mirror=repo.cran)
smart.install.packages(package="zoo", mirror=repo.cran)
smart.install.packages(package="scrime", mirror=repo.cran)
smart.install.packages(package="XML", mirror=repo.cran)
smart.install.packages(package="R2HTML", mirror=repo.cran)
smart.install.packages(package="moments", mirror=repo.cran)
smart.install.packages(package="snowfall", mirror=repo.cran)
smart.install.packages(package="sm", mirror=repo.cran)
smart.install.packages(package="rda", mirror=repo.cran)
smart.install.packages(package="flexmix", mirror=repo.cran) ## required by WECCA
smart.install.packages(package="MKmisc", mirror=repo.cran)
smart.install.packages(package="multicore", mirror=repo.cran) # required by zinba
smart.install.packages(package="doMC", mirror=repo.cran) # required by zinba
smart.install.packages(package="foreach", mirror=repo.cran) # required by zinba
smart.install.packages(package="quantreg", mirror=repo.cran) # required by zinba
smart.install.packages(package="R.utils", mirror=repo.cran) # required by zinba


# Install packages, and their dependencies, from Bioconductor
smart.install.packages(bioconductor.package="Biobase", mirror=repo.bioc)
smart.install.packages(bioconductor.package="IRanges", mirror=repo.bioc)
smart.install.packages(bioconductor.package="AnnotationDbi", mirror=repo.bioc)
smart.install.packages(bioconductor.package="affy", mirror=repo.bioc)
smart.install.packages(bioconductor.package="affydata", mirror=repo.bioc)
smart.install.packages(bioconductor.package="affyPLM", mirror=repo.bioc)
smart.install.packages(bioconductor.package="affyQCReport", mirror=repo.bioc)
smart.install.packages(bioconductor.package="annaffy", mirror=repo.bioc)
smart.install.packages(bioconductor.package="annotate", mirror=repo.bioc)
smart.install.packages(bioconductor.package="biomaRt", mirror=repo.bioc)
smart.install.packages(bioconductor.package="Biostrings", mirror=repo.bioc)
smart.install.packages(bioconductor.package="DynDoc", mirror=repo.bioc)
smart.install.packages(bioconductor.package="gcrma", mirror=repo.bioc)
smart.install.packages(bioconductor.package="genefilter", mirror=repo.bioc)
smart.install.packages(bioconductor.package="geneplotter", mirror=repo.bioc)
smart.install.packages(bioconductor.package="GenomicRanges", mirror=repo.bioc)
smart.install.packages(bioconductor.package="hgu95av2.db", mirror=repo.bioc)
smart.install.packages(bioconductor.package="limma", mirror=repo.bioc)
smart.install.packages(bioconductor.package="marray", mirror=repo.bioc)
smart.install.packages(bioconductor.package="multtest", mirror=repo.bioc)
smart.install.packages(bioconductor.package="vsn", mirror=repo.bioc)
smart.install.packages(bioconductor.package="xtable", mirror=repo.bioc)
smart.install.packages(bioconductor.package="ctc", mirror=repo.bioc)
smart.install.packages(bioconductor.package="oligo", mirror=repo.bioc)
smart.install.packages(bioconductor.package="ssize", mirror=repo.bioc)
smart.install.packages(bioconductor.package="LPE", mirror=repo.bioc)
smart.install.packages(bioconductor.package="graph", mirror=repo.bioc)
smart.install.packages(bioconductor.package="affyQCReport", mirror=repo.bioc)
smart.install.packages(bioconductor.package="GlobalAncova", mirror=repo.bioc)
smart.install.packages(bioconductor.package="impute", mirror=repo.bioc)
smart.install.packages(bioconductor.package="idiogram", mirror=repo.bioc)
smart.install.packages(bioconductor.package="GOstats", mirror=repo.bioc)
smart.install.packages(bioconductor.package="beadarray", mirror=repo.bioc)
smart.install.packages(bioconductor.package="simpleaffy", mirror=repo.bioc)
smart.install.packages(bioconductor.package="globaltest", mirror=repo.bioc)
smart.install.packages(bioconductor.package="geneplotter", mirror=repo.bioc)
smart.install.packages(bioconductor.package="biomaRt", mirror=repo.bioc)
smart.install.packages(bioconductor.package="locfit", mirror=repo.bioc) # required by hdrcde 
smart.install.packages(bioconductor.package="ash", mirror=repo.bioc) # required by hdrcde
smart.install.packages(bioconductor.package="ks", mirror=repo.bioc) # required by hdrcde
smart.install.packages(bioconductor.package="hdrcde", mirror=repo.bioc)
smart.install.packages(bioconductor.package="lumi", mirror=repo.bioc)
smart.install.packages(bioconductor.package="prada", mirror=repo.bioc)
smart.install.packages(bioconductor.package="siggenes", mirror=repo.bioc)
smart.install.packages(bioconductor.package="plier", mirror=repo.bioc)
#smart.install.packages(bioconductor.package="cosmo", mirror=repo.bioc) # missing
smart.install.packages(bioconductor.package="beadarraySNP", mirror=repo.bioc)
smart.install.packages(bioconductor.package="GEOquery", mirror=repo.bioc)
smart.install.packages(bioconductor.package="ArrayExpress", mirror=repo.bioc)
smart.install.packages(bioconductor.package="GeneCycle", mirror=repo.bioc)
smart.install.packages(bioconductor.package="GeneNet", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="GenomeGraphs", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="MLInterfaces", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="GOstats", mirror=repo.bioc)
smart.install.packages(bioconductor.package="PAnnBuilder", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="oligoClasses", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="statmod", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="vegan", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="safe", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="CGHbase", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="CGHcall", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="CGHregions", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="DNAcopy", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="MLInterfaces", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="MEDIPS", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="microRNA", mirror=repo.bioc)
smart.install.packages(bioconductor.package="RmiR", mirror=repo.bioc)
smart.install.packages(bioconductor.package="biomaRt", mirror=repo.bioc)
smart.install.packages(bioconductor.package="ChIPpeakAnno", mirror=repo.bioc)
smart.install.packages(bioconductor.package="rGADEM", mirror=repo.bioc)
smart.install.packages(bioconductor.package="MotIV", mirror=repo.bioc)
smart.install.packages(bioconductor.package="PICS", mirror=repo.bioc)
smart.install.packages(bioconductor.package="seqLogo", mirror=repo.bioc)
smart.install.packages(bioconductor.package="GenomicRanges", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="Biostrings", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="ChIPpeakAnno", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="chipseq", mirror=repo.bioc)
smart.install.packages(bioconductor.package="Rsamtools", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="ShortRead", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="lumiHumanIDMapping", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="lumiMouseIDMapping", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="lumiRatIDMapping", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="edgeR", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="rtracklayer", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="maSigPro", mirror=repo.bioc) 
smart.install.packages(bioconductor.package="qvalue", mirror=repo.bioc)
smart.install.packages(bioconductor.package="DESeq", mirror=repo.bioc)
smart.install.packages(bioconductor.package="RPA", mirror=repo.bioc)
smart.install.packages(bioconductor.package="methylumi", mirror=repo.bioc)
smart.install.packages(bioconductor.package="IlluminaHumanMethylation450k.db", mirror=repo.bioc) # annotation package, not needed if all annotation packages from the repository are installed
smart.install.packages(bioconductor.package="IlluminaHumanMethylation27k.db", mirror=repo.bioc) # annotation package, not needed if all annotation packages from the repository are installed
smart.install.packages(bioconductor.package="VariantAnnotation", mirror=repo.bioc)
smart.install.packages(bioconductor.package="TxDb.Hsapiens.UCSC.hg19.knownGene", mirror=repo.bioc)
smart.install.packages(bioconductor.package="DEXSeq", mirror=repo.bioc)
smart.install.packages(bioconductor.package="BSgenome.Hsapiens.UCSC.hg19", mirror=repo.bioc)
smart.install.packages(bioconductor.package="rich", mirror=repo.bioc)
smart.install.packages(bioconductor.package="BiodiversityR", mirror=repo.bioc)
smart.install.packages(bioconductor.package="pegas", mirror=repo.bioc)
smart.install.packages(bioconductor.package="labdsv", mirror=repo.bioc)
smart.install.packages(bioconductor.package="sva", mirror=repo.bioc)



# SNP 5.0 / 6.0
smart.install.packages(bioconductor.package="crlmm", mirror=repo.bioc)
smart.install.packages(bioconductor.package="oligo", mirror=repo.bioc)
smart.install.packages(bioconductor.package="pd.mapping50k.hind240", mirror=repo.bioc)
smart.install.packages(bioconductor.package="pd.mapping50k.xba240", mirror=repo.bioc)
smart.install.packages(bioconductor.package="pd.mapping250k.nsp", mirror=repo.bioc)
smart.install.packages(bioconductor.package="pd.mapping250k.sty", mirror=repo.bioc)
smart.install.packages(bioconductor.package="pd.genomewidesnp.5", mirror=repo.bioc)
smart.install.packages(bioconductor.package="pd.genomewidesnp.6", mirror=repo.bioc)

smart.install.packages(bioconductor.package="genomewidesnp6Crlmm", mirror=repo.bioc)
smart.install.packages(bioconductor.package="genomewidesnp5Crlmm", mirror=repo.bioc)

smart.install.packages(bioconductor.package="human1mduov3bCrlmm", mirror=repo.bioc)          #Illumina
smart.install.packages(bioconductor.package="human1mv1cCrlmm", mirror=repo.bioc)             #Illumina
smart.install.packages(bioconductor.package="human370quadv3cCrlmm", mirror=repo.bioc)        #Illumina
smart.install.packages(bioconductor.package="human370v1cCrlmm", mirror=repo.bioc)            #Illumina
smart.install.packages(bioconductor.package="human550v3bCrlmm", mirror=repo.bioc)            #Illumina
smart.install.packages(bioconductor.package="human610quadv1bCrlmm", mirror=repo.bioc)        #Illumina
smart.install.packages(bioconductor.package="human650v3aCrlmm", mirror=repo.bioc)            #Illumina
smart.install.packages(bioconductor.package="human660quadv1aCrlmm", mirror=repo.bioc)        #Illumina
smart.install.packages(bioconductor.package="humanomni1quadv1bCrlmm", mirror=repo.bioc)      #Illumina
smart.install.packages(bioconductor.package="humanomniexpress12v1bCrlmm", mirror=repo.bioc)  #Illumina



# Install non-repo packages
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/NoWaves_0.4.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/FruitFlyAgilent.db.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/hgug4851a.db.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/CGHtest_1.1.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/CGHtestpar_0.0.tar.gz")
smart.install.packages(url.package="http://addictedtor.free.fr/packages/fpc_1.1-5.tar.gz")
smart.install.packages(url.package="http://www.math.utu.fi/projects/software/bio/ROTS_1.1.1.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/A2R_0.0-4.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/exon.pmcdf_1.1.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/mouseexonpmcdf_1.1.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/ratexonpmcdf_1.1.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/intCNGEan_0.54.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/CORNA_1.2.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/WECCA_0.30.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/zinba_2.02.03.tar.gz")


# affy_20 for R-2.12"
		
		# TAIR annotations for Arabidosis 1.0 and 1.1
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/tairg.download/aragene11stattairgcdf_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/tairg.download/aragene11stattairgprobe_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/tairg.download/aragene10stattairgcdf_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/tairg.download/aragene10stattairgprobe_17.0.0.tar.gz'
		
		# Entrez annotations for human
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/hugene20sthsentrezgcdf_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/hugene20sthsentrezgprobe_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/hugene21sthsentrezgcdf_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/hugene21sthsentrezgprobe_17.0.0.tar.gz'
		
		# Entrez annotations for Arabidosis 1.0 and 1.1
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/aragene10statentrezgcdf_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/aragene10statentrezgprobe_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/aragene11statentrezgprobe_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/aragene11statentrezgcdf_17.0.0.tar.gz'
		
		# Entrez annotations for ragene_20 and ragene_21
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/ragene20strnentrezgcdf_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/ragene20strnentrezgprobe_17.0.0.tar.gz'
		##wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/ragene20strnentrezg.db_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/ragene21strnentrezgprobe_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/ragene21strnentrezgcdf_17.0.0.tar.gz'
		
		# Entrez annotations for mouse_20 and mouse_21
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/mogene20stmmentrezgcdf_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/mogene20stmmentrezgprobe_17.0.0.tar.gz'
		##wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/mogene20stmmentrezg.db_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/mogene21stmmentrezgcdf_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/mogene21stmmentrezgprobe_17.0.0.tar.gz'
		##wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/mogene21stmmentrezg.db_17.0.0.tar.gz'
		
		# Entrez annotations for Danio rerio 1.0 and 1.1
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/zebgene10stdrentrezgcdf_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/zebgene10stdrentrezgprobe_17.0.0.tar.gz'
		##wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/zebgene10stdrentrezg.db_17.0.0.tar.gz'
		
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/zebgene11stdrentrezgprobe_17.0.0.tar.gz'
		##wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/zebgene11stdrentrezg.db_17.0.0.tar.gz'
		#wget 'http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.0.0/entrezg.download/zebgene11stdrentrezgcdf_17.0.0.tar.gz'
		
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/aragene11stattairgcdf_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/aragene11stattairgprobe_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/aragene10stattairgcdf_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/aragene10stattairgprobe_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/hugene20sthsentrezgcdf_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/hugene20sthsentrezgprobe_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/hugene21sthsentrezgcdf_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/hugene21sthsentrezgprobe_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/aragene10statentrezgcdf_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/aragene10statentrezgprobe_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/aragene11statentrezgprobe_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/aragene11statentrezgcdf_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/ragene20strnentrezgcdf_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/ragene20strnentrezgprobe_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/ragene21strnentrezgprobe_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/ragene21strnentrezgcdf_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/mogene20stmmentrezgcdf_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/mogene20stmmentrezgprobe_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/mogene21stmmentrezgcdf_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/mogene21stmmentrezgprobe_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/zebgene10stdrentrezgcdf_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/zebgene10stdrentrezgprobe_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/zebgene11stdrentrezgprobe_17.0.0.tar.gz")
smart.install.packages(url.package="http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/tools_extras/R_libraries/affy_20/zebgene11stdrentrezgcdf_17.0.0.tar.gz")












# Install the whole annotation repository from Bioconductor
smart.install.bioconductor.repo(repo.index = 3, mirror=repo.bioc) # for R 3.0.0, repo number 3 is annotations (might change)


# Install BrainArray custom CDF's
smart.install.scavenge.web.packages("http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.1.0/entrezg.asp")
smart.install.scavenge.web.packages("http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/17.1.0/tairg.asp")

# TOOL tophat2.R: "TopHat2 for paired end reads" (Aligns paired end Illumina RNA-Seq reads to a genome in order to identify exon-exon splice junctions. TopHat2 first identifies potential exons by mapping the reads to the genome. Using this initial mapping, it builds a database of possible splice junctions, and then maps the reads against these junctions to confirm them. The alignment results are given in a BAM file which is automatically indexed and hence ready to be viewed in Chipster genome browser.)
# INPUT reads1.fq: "Reads to align" TYPE GENERIC
# INPUT reads2.fq: "Reads to align" TYPE GENERIC
# INPUT OPTIONAL genes.gtf: "Optional GTF file" TYPE GENERIC
# OUTPUT tophat.bam
# OUTPUT tophat.bam.bai
# OUTPUT OPTIONAL junctions.bed
# OUTPUT OPTIONAL insertions.bed
# OUTPUT OPTIONAL deletions.bed
# PARAMETER genome: "Genome" TYPE [hg19: "Human (hg19\)", mm10: "Mouse (mm10\)", mm9: "Mouse (mm9\)", rn4: "Rat (rn4\)", athaliana.TAIR10: "A. thaliana genome (TAIR10\)", Gasterosteus_aculeatus.BROADS1.67: "Gasterosteus aculeatus (BROADS1.67\)", Halorubrum_lacusprofundi_ATCC_49239: "Halorubrum lacusprofundi (ATCC 49239\)", ovis_aries_texel: "Sheep genome (oar3.1\)"] DEFAULT hg19 (Genome that you would like to align your reads against.)
# PARAMETER mate.inner.distance: "Expected inner distance between mate pairs" TYPE INTEGER DEFAULT 200 (Expected mean inner distance between mate pairs. For example, if your fragment size is 300 bp and read length is 50 bp, the inner distance is 200.)
# PARAMETER OPTIONAL mate.std.dev: "Standard deviation for the inner distances between mate pairs" TYPE INTEGER DEFAULT 20 (The standard deviation for the distribution on inner distances between mate pairs. The default is 20bp.)
# PARAMETER OPTIONAL min.anchor.length: "Minimum anchor length" TYPE INTEGER FROM 3 TO 1000 DEFAULT 8 (TopHat2 will report junctions spanned by reads with at least this many bases on each side of the junction. Note that individual spliced alignments may span a junction with fewer than this many bases on one side. However, every junction involved in spliced alignments is supported by at least one read with this many bases on each side.)
# PARAMETER OPTIONAL splice.mismatches: "Maximum number of mismatches allowed in the anchor" TYPE INTEGER FROM 0 TO 2 DEFAULT 0 (The maximum number of mismatches that may appear in the anchor region of a spliced alignment.)
# PARAMETER OPTIONAL min.intron.length: "Minimum intron length" TYPE INTEGER FROM 10 TO 1000 DEFAULT 70 (TopHat2 will ignore donor-acceptor pairs closer than this many bases apart.)
# PARAMETER OPTIONAL max.intron.length: "Maximum intron length" TYPE INTEGER FROM 1000 TO 1000000 DEFAULT 500000 (TopHat2 will ignore donor-acceptor pairs farther than this many bases apart, except when such a pair is supported by a split segment alignment of a long read.)
# PARAMETER OPTIONAL max.multihits: "How many hits is a read allowed to have" TYPE INTEGER FROM 1 TO 1000000 DEFAULT 20 (Instructs TopHat to allow up to this many alignments to the reference for a given read, and suppresses all alignments for reads with more than this many alignments.)
# PARAMETER OPTIONAL use.gtf: "Use annotation GTF" TYPE [yes, no] DEFAULT yes (If this option is provided, TopHat will first extract the transcript sequences and use Bowtie to align reads to this virtual transcriptome first. Only the reads that do not fully map to the transcriptome will then be mapped on the genome. The reads that did map on the transcriptome will be converted to genomic mappings (spliced as needed\) and merged with the novel mappings and junctions in the final tophat output. If no GTF file is provided by user, internal annotation file wil be used if available. Internal annotation is provided for human, mouse and rat.)
# PARAMETER OPTIONAL no.novel.juncs: "When GTF file is used, ignore novel junctions" TYPE [yes, no] DEFAULT yes (If annotation GTF is used, TopHat will extract the transcript sequences and use Bowtie to align reads to this virtual transcriptome first. Only the reads that do not fully map to the transcriptome will then be mapped on the genome. The reads that did map on the transcriptome will be converted to genomic mappings (spliced as needed\) and merged with the novel mappings and junctions in the final TopHat output. If no GTF file is provided by the user, internal annotation file will be used if available. Internal annotation is provided for human, mouse and rat.)

# EK 17.4.2012 added -G and -g options
# MG 24.4.2012 added ability to use gtf files from Chipster server
# AMS 19.6.2012 Added unzipping
# AMS 27.6.2012 Added parameter mate.std.dev, allow negative values for mate.inner.distance
# AMS 4.10.2012 added BED sorting


# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads1.fq")
unzipIfGZipFile("reads2.fq")

options(scipen = 10)
# max.intron.length <- formatC(max.intron.length, "f", digits = 0)

# setting up TopHat
tophat.binary <- c(file.path(chipster.tools.path, "tophat2", "tophat2"))
path.bowtie <- c(file.path(chipster.tools.path, "bowtie2"))
path.samtools <- c(file.path(chipster.tools.path, "samtools"))
set.path <-paste(sep="", "PATH=", path.bowtie, ":", path.samtools, ":$PATH")
path.bowtie.index <- c(file.path(path.bowtie, "indexes", genome))

# command start
command.start <- paste("bash -c '", set.path, tophat.binary)

# parameters
#command.parameters <- paste("--bowtie1 -r", mate.inner.distance, "--mate-std-dev", mate.std.dev, "-a", min.anchor.length, "-m", splice.mismatches, "-i", min.intron.length, "-I", max.intron.length, "-g", max.multihits, "--library-type fr-unstranded")
command.parameters <- paste("-r", mate.inner.distance, "--mate-std-dev", mate.std.dev, "-a", min.anchor.length, "-m", splice.mismatches, "-i", min.intron.length, "-I", max.intron.length, "-g", max.multihits, "--library-type fr-unstranded")

# optional GTF command, if a GTF file has been provided by user
command.gtf <- ""
input_files <- dir()
is_gtf <- (length(grep("genes.gtf", input_files))>0)
if (is_gtf) {
	if (no.novel.juncs == "yes") {
		command.gtf <- paste("-G", "genes.gtf", "--no-novel-juncs")
	} else {
		command.gtf <- paste("-G", "genes.gtf")
	}
}

# optional GTF command, if a GTF file has NOT been provided by user
# BUT is avaliable from Chipster server
genome_available <- FALSE
if (genome == "hg19" ||	genome == "mm9" || genome == "mm10" || genome == "rn4") genome_available <- TRUE
if (!is_gtf && genome_available) {

	# annotation file setup
	if (genome == "hg19") {
		annotation.file <- "Homo_sapiens.GRCh37.68.chr.gtf"
	}
	if (genome == "mm10") {
		annotation.file <- "Mus_musculus.GRCm38.68.chr.gtf"
	}
	if (genome == "mm9") {
		annotation.file <- "Mus_musculus.NCBIM37.62.chr.gtf"
	}
	if (genome == "rn4") {
		annotation.file <- "Rattus_norvegicus.RGSC3.4.62.chr.gtf"
	}
	annotation.file <- c(file.path(chipster.tools.path, "genomes", "gtf", annotation.file))	
	
	if (no.novel.juncs == "yes") {
		command.gtf <- paste("-G", annotation.file, "--no-novel-juncs")
	} else {
		command.gtf <- paste("-G", annotation.file)
	}
}

# command ending
command.end <- paste(path.bowtie.index, "reads1.fq reads2.fq'")

# run tophat
if (use.gtf == "yes"){ 
	command <- paste(command.start, command.parameters, command.gtf, command.end)
}else{
	command <- paste(command.start, command.parameters, command.end)
}
system(command)

# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

# sort bam
system(paste(samtools.binary, "sort tophat_out/accepted_hits.bam tophat"))

# index bam
system(paste(samtools.binary, "index tophat.bam"))

system("mv tophat_out/junctions.bed junctions.u.bed")
system("mv tophat_out/insertions.bed insertions.u.bed")
system("mv tophat_out/deletions.bed deletions.u.bed")

# sorting BEDs
source(file.path(chipster.common.path, "bed-utils.R"))

size <- 0
size <- file.info("junctions.u.bed")$size
if (size > 100){	
	bed <- read.table(file="junctions.u.bed", skip=1, sep="\t")
	colnames(bed)[1:2] <- c("chr", "start")
	sorted.bed <- sort.bed(bed)
	write.table(sorted.bed, file="junctions.bed", sep="\t", row.names=F, col.names=F, quote=F)
}

size <- file.info("insertions.u.bed")$size
if (size > 100){
	bed <- read.table(file="insertions.u.bed", skip=1, sep="\t")
	colnames(bed)[1:2] <- c("chr", "start")
	sorted.bed <- sort.bed(bed)
	write.table(sorted.bed, file="insertions.bed", sep="\t", row.names=F, col.names=F, quote=F)
}

size <- file.info("deletions.u.bed")$size
if (size > 100){
	bed <- read.table(file="deletions.u.bed", skip=1, sep="\t")
	colnames(bed)[1:2] <- c("chr", "start")
	sorted.bed <- sort.bed(bed)
	write.table(sorted.bed, file="deletions.bed", sep="\t", row.names=F, col.names=F, quote=F)
}

# TOOL medips.R: "MEDIPS - methylation analysis" (Methylation analysis for sequencing data.)
# INPUT MEDIPS-input1.tsv: "Converted BAM data files" TYPE GENERIC
# INPUT META phenodata.tsv: "Phenodata describing the experiment" TYPE GENERIC 
# OUTPUT OPTIONAL saturationplot.pdf: "Saturation plot"
# OUTPUT OPTIONAL coverageplot.pdf: "Coverage plot"
# OUTPUT OPTIONAL calibrationplot.png: "Calibration plot"
# OUTPUT OPTIONAL CpGdensities.pdf: "CpG density plot"
# OUTPUT OPTIONAL RPMsignal.pdf: "RPM plot"
# OUTPUT OPTIONAL AMSsignal.pdf: "AMS plot"
# OUTPUT OPTIONAL rois.tsv: "Promoter regions"
# OUTPUT OPTIONAL output.bed: "BED file"
# OUTPUT output.tsv: "Enrichment data"
# PARAMETER species TYPE [human] DEFAULT human (Select the species)
# PARAMETER promoters.only TYPE [yes, no] DEFAULT no (Should the analyses be restricted to promoter regions only)
# PARAMETER coverage.resolution TYPE [25,50,100,200] DEFAULT  50 (Targeted data resolution, in base pairs, when the genome-wide coverage is calculated)
# PARAMETER smoothing.extension TYPE [200,400,800,1200] DEFAULT 400 (The amount of data smoothing, in base pairs, by extending the reads)
# PARAMETER fragment.length TYPE [400,800,1600,2400] DEFAULT 800 (Length of the fragment for calculation of local CpGs)
# PARAMETER save.bed TYPE [yes, no] DEFAULT yes (Should the normalized data, as rpm, be saved as a BED file)
# PARAMETER promoter.upstream TYPE [1000,2000,5000] DEFAULT 1000 (How much upstream, in base pairs, from the transcription start site does the promoter extend)
# PARAMETER promoter.downstream TYPE [250,500,750,1000] DEFAULT 500 (How much downstream, in base pairs, from the transcription start site does the promoter extend)
# PARAMETER image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Parameters for testing purposes only
#species<-"human"
#promoters.only<-"no"
#coverage.resolution<-"100"
#smoothing.extension<-"1200"
#fragment.length<-2400
#save.bed<-"yes"
#promoter.upstream<-"1000"
#promoter.downstream<-"500"
#image.width<-600
#image.height<-600

# Processing of the parameters
if(species=="human") {
	genome<-c("BSgenome.Hsapiens.UCSC.hg18")
	pgenome<-"hg19"  
	library(BSgenome.Hsapiens.UCSC.hg18)
}
w<-image.width
h<-image.height

# Input files
files<-dir(pattern="MEDIPS-input")

# Reading phenodata
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")

# Analysis type
analtype<-length(unique(phenodata$group ))
repl<-table(phenodata$group)
if(any(repl>1)) {
	repltype<-c(2)
} else {
	repltype<-c(1)
}

if(analtype==1 & repltype==1) {
	# Reading the MEDIPS input file
	library(MEDIPS)
	dat<-MEDIPS.readAlignedSequences(BSgenome=genome, file=files)
	
	# Creating the genome vector
	dat<-MEDIPS.genomeVector(data=dat, bin_size=as.numeric(coverage.resolution), extend=as.numeric(smoothing.extension))
	
	# Cleaning up to save some memory
	gc()
	
	# Saturation analysis
	sr<-MEDIPS.saturationAnalysis(data=dat, bin_size=as.numeric(coverage.resolution), extend=as.numeric(smoothing.extension), no_iterations=10, no_random_iterations=1)
	pdf(file="saturationplot.pdf", width=w/72, height=h/72)
	par(mar=c(5,5,5,5))
	MEDIPS.plotSaturation(sr)
	dev.off()
	
	# Pattern Positions
	dat<-MEDIPS.getPositions(data=dat, pattern="CG")
	
	# Coverage analysis
	cr<-MEDIPS.coverageAnalysis(data=dat, extend=as.numeric(smoothing.extension), no_iterations=10)
	pdf(file="coverageplot.pdf", width=w/72, height=h/72)
	par(mar=c(5,5,5,5))
	MEDIPS.plotCoverage(cr)
	dev.off()
	
	# Coupling vector
	dat<-MEDIPS.couplingVector(data=dat, fragmentLength=as.numeric(fragment.length), func="count")
	
	# Calibration curve plot
	dat<-MEDIPS.calibrationCurve(data=dat)
	bitmap(file="calibrationplot.png", width=w/72, height=h/72)
	par(mar=c(5,5,5,5))
	MEDIPS.plotCalibrationPlot(dat)
	dev.off()
	
	# Normalization
	dat<-MEDIPS.normalize(data=dat)
	
	# Save the bed file
	if(save.bed=="yes") {
		source(file.path(chipster.common.path, "bed-utils.R"))
		MEDIPS.exportWIG(file="output.bed", data=dat, raw=T, descr=files)
		library(rtracklayer)
		wig<-import("output.bed", format="wig")
		export(wig, "output.bed", format="bed")
		wig<-read.table("output.bed", header=F, sep="\t")
		wig<-wig[wig[,5]>0,]
		wig <- sort.bed(wig)
		write.table(wig, "output.bed", col.names=F, row.names=F, sep="\t", quote=F)
	}
	
	if(promoters.only=="yes") {
		library(rtracklayer)
		session <- browserSession()
		genome(session) <- pgenome
		query <- ucscTableQuery(session, "refGene")
		refGene<-getTable(query)
		sta<-refGene$txStart
		sta[refGene$strand=="+"]<-sta[refGene$strand=="+"]-1000
		sta[refGene$strand=="-"]<-sta[refGene$strand=="-"]-500
		sto<-refGene$txStart
		sto[refGene$strand=="+"]<-sto[refGene$strand=="+"]+500
		sto[refGene$strand=="-"]<-sto[refGene$strand=="-"]+1000
		rois<-data.frame(refGene$chrom, sta, sto, make.unique(as.character(refGene$name)))
		rois<-rois[rois[,1] %in% unique(dat@genome_chr),]
		write.table(rois, "rois.tsv", sep="\t", quote=F, col.names=F, row.names=F)
		frames<-MEDIPS.methylProfiling(data1=dat, ROI_file="rois.tsv", math=mean, select=2)
		write.table(frames, "output.tsv", sep="\t", quote=F, col.names=T, row.names=F)
	}
	
	if(promoters.only=="no") {
		frames<-MEDIPS.methylProfiling(data1=dat, frame_size=as.numeric(smoothing.extension), step=as.numeric(smoothing.extension)/2, math=mean, select=2)
		write.table(frames, "output.tsv", sep="\t", quote=F, col.names=T, row.names=F)
	}
	
	# Some plots of the enrichment results
	pdf(file="CpGdensities.pdf", width=w/72, height=h/72)
	par(mar=c(5,5,5,5))
	hist(frames$coupling, breaks=100, main="CpG densities", xlab="CpG coupling factors") 
	dev.off()
	
	pdf(file="RPMsignal.pdf", width=w/72, height=h/72)
	par(mar=c(5,5,5,5))
	hist(frames$rpm_A[frames$rpm_A!=0], breaks=100, main="RPM signals", xlab="reads/bin") 
	dev.off()
	
	pdf(file="AMSsignal.pdf", width=w/72, height=h/72)
	par(mar=c(5,5,5,5))
	hist(frames$ams_A[frames$ams_A!=0], breaks=100, main="AMS signals", xlab="absolute methylation score (ams)") 
	dev.off()
	
	# Do not delete the following curly bracket - it ends the if-clause for analysis and replication types
}





if(analtype==2 & repltype==1) {
	library(MEDIPS)
	
	# Assign the files to control and treatment based on the group column from phenodata
	cfile<-as.character(phenodata$sample[phenodata$group==head(sort(phenodata$group), n=1)])
	tfile<-as.character(phenodata$sample[phenodata$group==tail(sort(phenodata$group), n=1)])
	
	# Reads the data
	control<-MEDIPS.readAlignedSequences(BSgenome=genome, file=cfile)
	treatment<-MEDIPS.readAlignedSequences(BSgenome=genome, file=tfile)
	
	# Creating the genome vector
	control<-MEDIPS.genomeVector(data=control, bin_size=as.numeric(coverage.resolution), extend=as.numeric(smoothing.extension))
	treatment<-MEDIPS.genomeVector(data=treatment, bin_size=as.numeric(coverage.resolution), extend=as.numeric(smoothing.extension))
	
	# Pattern Positions
	control<-MEDIPS.getPositions(data=control, pattern="CG")
	treatment<-MEDIPS.getPositions(data=treatment, pattern="CG")
	
	# Coupling vector
	control<-MEDIPS.couplingVector(data=control, fragmentLength=as.numeric(fragment.length), func="count")
	treatment<-MEDIPS.couplingVector(data=treatment, fragmentLength=as.numeric(fragment.length), func="count")
	
	# Calibration curve
	control<-MEDIPS.calibrationCurve(data=control)
	treatment<-MEDIPS.calibrationCurve(data=treatment)
	
	# Normalization
	control<-MEDIPS.normalize(data=control)
	treatment<-MEDIPS.normalize(data=treatment)
	
	# Comparing experiments
	if(promoters.only=="yes") {
		library(rtracklayer)
		session <- browserSession()
		genome(session) <- pgenome
		query <- ucscTableQuery(session, "refGene")
		refGene<-getTable(query)
		sta<-refGene$txStart
		sta[refGene$strand=="+"]<-sta[refGene$strand=="+"]-1000
		sta[refGene$strand=="-"]<-sta[refGene$strand=="-"]-500
		sto<-refGene$txStart
		sto[refGene$strand=="+"]<-sto[refGene$strand=="+"]+500
		sto[refGene$strand=="-"]<-sto[refGene$strand=="-"]+1000
		rois<-data.frame(refGene$chrom, sta, sto, make.unique(as.character(refGene$name)))
		rois<-rois[rois[,1] %in% unique(c(control@genome_chr), treatment@genome_chr),]
		write.table(rois, "rois.tsv", sep="\t", quote=F, col.names=F, row.names=F)
		diff.meth<-MEDIPS.methylProfiling(data1=control, data2=treatment, select=2, frame_size=400, ROI_file="rois.tsv")
		write.table(diff.meth, "output.tsv", sep="\t", quote=F, col.names=T, row.names=F)
	}
	
	if(promoters.only=="no") {
		diff.meth<-MEDIPS.methylProfiling(data1=control, data2=treatment, select=2, frame_size=400)
		write.table(diff.meth, file="output.tsv", sep="\t", quote=F, col.names=T, row.names=F)
	}
	
	# Do not delete the following curly bracket - it ends the if-clause for analysis and replication types
}





if( (analtype==1 | analtype==2) & repltype==2) {
	library(MEDIPS)
	
	# Assign the files to control and treatment based on the group column from phenodata
	cfiles<-as.character(phenodata$sample[phenodata$group==head(sort(phenodata$group), n=1)])
	tfiles<-as.character(phenodata$sample[phenodata$group==tail(sort(phenodata$group), n=1)])
	
	# Combining the replicates
	for(i in 1:length(cfiles)) {
		d<-read.table(cfiles, header=F, sep="\t")
		write.table(d, "group1.tsv", col.names=F, row.names=F, sep="\t", quote=F, append=TRUE)
	}
	for(i in 1:length(cfiles)) {
		d<-read.table(tfiles, header=F, sep="\t")
		write.table(d, "group2.tsv", col.names=F, row.names=F, sep="\t", quote=F, append=TRUE)
	}
	
	# Reads the data
	control<-MEDIPS.readAlignedSequences(BSgenome=genome, file="group1.tsv")
	treatment<-MEDIPS.readAlignedSequences(BSgenome=genome, file="group2.tsv")
	
	# Creating the genome vector
	control<-MEDIPS.genomeVector(data=control, bin_size=as.numeric(coverage.resolution), extend=as.numeric(smoothing.extension))
	treatment<-MEDIPS.genomeVector(data=treatment, bin_size=as.numeric(coverage.resolution), extend=as.numeric(smoothing.extension))
	
	# Pattern Positions
	control<-MEDIPS.getPositions(data=control, pattern="CG")
	treatment<-MEDIPS.getPositions(data=treatment, pattern="CG")
	
	# Coupling vector
	control<-MEDIPS.couplingVector(data=control, fragmentLength=as.numeric(fragment.length), func="count")
	treatment<-MEDIPS.couplingVector(data=treatment, fragmentLength=as.numeric(fragment.length), func="count")
	
	# Calibration curve
	control<-MEDIPS.calibrationCurve(data=control)
	treatment<-MEDIPS.calibrationCurve(data=treatment)
	
	# Normalization
	control<-MEDIPS.normalize(data=control)
	treatment<-MEDIPS.normalize(data=treatment)
	
	# Comparing experiments
	if(promoters.only=="yes") {
		library(rtracklayer)
		session <- browserSession()
		genome(session) <- pgenome
		query <- ucscTableQuery(session, "refGene")
		refGene<-getTable(query)
		sta<-refGene$txStart
		sta[refGene$strand=="+"]<-sta[refGene$strand=="+"]-1000
		sta[refGene$strand=="-"]<-sta[refGene$strand=="-"]-500
		sto<-refGene$txStart
		sto[refGene$strand=="+"]<-sto[refGene$strand=="+"]+500
		sto[refGene$strand=="-"]<-sto[refGene$strand=="-"]+1000
		rois<-data.frame(refGene$chrom, sta, sto, make.unique(as.character(refGene$name)))
		rois<-rois[rois[,1] %in% unique(c(control@genome_chr), treatment@genome_chr),]
		write.table(rois, "rois.tsv", sep="\t", quote=F, col.names=F, row.names=F)
		diff.meth<-MEDIPS.methylProfiling(data1=control, data2=treatment, select=2, frame_size=400, ROI_file="rois.tsv")
		write.table(diff.meth, "output.tsv", sep="\t", quote=F, col.names=T, row.names=F)
	}
	
	if(promoters.only=="no") {
		diff.meth<-MEDIPS.methylProfiling(data1=control, data2=treatment, select=2, frame_size=400)
		write.table(diff.meth, file="output.tsv", sep="\t", quote=F, col.names=T, row.names=F)
	}
	
	# Do not delete the following curly bracket - it ends the if-clause for analysis and replication types
}

# TOOL samtools-rmdup.R: "Remove duplicate reads from BAM" (Removes potential PCR duplicates. You have to indicate if your data is single end or paired end. In the paired end mode the ISIZE has to be correctly set. This tool is based on the SAMtools package.)
# INPUT alignment.bam TYPE GENERIC 
# OUTPUT duplicates-removed.bam
# PARAMETER end.type: "Is the data paired end or single end reads" TYPE [paired, single] DEFAULT paired (Does the data come from paired end or single end sequencing?)


# EK 12.1.2012

# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

# parameters
single.end <- ifelse(end.type == "paired", "", "-s")

# command
system(paste(samtools.binary, "rmdup", single.end, "alignment.bam duplicates-removed.bam"))

# TOOL norm-affy-exon.R: "Affymetrix exon arrays" (Affymetrix RMA preprocessing for CEL-files. YOU HAVE TO SPECIFY THE CHIPTYPE.)
# INPUT microarray{...}.cel: microarray{...}.cel TYPE AFFY 
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# PARAMETER chiptype: chiptype TYPE [empty: empty, human: human, mouse: mouse, rat: rat] DEFAULT empty (Chiptype)
# PARAMETER summary.feature: summary.feature TYPE [gene: gene, exon: exon] DEFAULT gene (Output summary type)

# Affymetrix normalization
# JTT 8.6.2006
# Changes to column naming on 29.6.2006
# Changes to phenodata table writing on 29.1.2007
#
# modified 11.11.2009, MG
# Changes to CDF package names to match BRainArray version 12
# 
# modified 25.11.2009, MG
# Gene symbols and gene names are now incorporated to the table
# of normalized values when using "gene" as summary feature
# but not for "exon", since the annotation packages do not
# support this

# Initializes analyses
library(affy)

# Reads in data
dat<-ReadAffy()
if(chiptype=="empty") {
	stop("You need to specify the chiptype. Please run the script again.")
}
if(chiptype=="human" & summary.feature=="exon") {
	dat@cdfName<-"exon.pmcdf"
	dat@annotation<-"exon.pmcdf"
}
if(chiptype=="mouse" & summary.feature=="exon") {
	dat@cdfName<-"mouseexonpmcdf"
	dat@annotation<-"mouseexonpmcdf"
}
if(chiptype=="rat" & summary.feature=="exon") {
	dat@cdfName<-"ratexonpmcdf"
	dat@annotation<-"ratexonpmcdf"
}

if(chiptype=="human" & summary.feature=="gene") {
	dat@cdfName<-"huex10stv2hsentrezgcdf"
	dat@annotation<-"huex10stv2hsentrezg.db"
}
if(chiptype=="mouse" & summary.feature=="gene") {
	dat@cdfName<-"moex10stv1mmentrezgcdf"
	dat@annotation<-"moex10stv1mmentrezg.db"
}
if(chiptype=="rat" & summary.feature=="gene") {
	dat@cdfName<-"raex10stv1rnentrezgcdf"
	dat@annotation<-"raex10stv1rnentrezg.db"
}
chiptype<-dat@annotation

# Normalizations
dat2<-exprs(rma(dat))
dat2<-as.data.frame(round(dat2, digits=2))
names(dat2)<-paste("chip.", names(dat2), sep="")

# Writes out a phenodata
sample<-rownames(pData(dat))
group<-c(rep("", nrow(pData(dat))))
training<-c(rep("", nrow(pData(dat))))
time<-c(rep("", nrow(pData(dat))))
random<-c(rep("", nrow(pData(dat))))
chiptype<-dat@annotation
write.table(data.frame(sample=sample, chiptype=chiptype, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# Writing out data
a<-try(library(chiptype, character.only=T))
if(chiptype!="empty" & class(a)!="try-error") {
	if (summary.feature=="exon") {
		# Writes the results into a file
		write.table(data.frame(dat2), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
	}
	if (summary.feature=="gene") {
		
		# Including gene names to data
		lib2<-sub('.db','',chiptype)
		symbol<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "SYMBOL", sep="")))))[rownames(dat2),])
		genename<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "GENENAME", sep="")))))[rownames(dat2),])
		
		# Fixes an issue introduced in BioC2.4 where the "#" character is introduced in some gene names
		genename <- gsub("#", "", genename)
		symbol <- gsub("'", "", symbol)
		genename <- gsub("'", "", genename)
		
		# Writes the results into a file
		write.table(data.frame(symbol, description=genename, dat2), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
	}
} 

# TOOL stat-ROTS.R: ROTS (Reproducibility-optimized test statistic for comparing the expression levels between two groups; Elo et al. 2008)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT ROTS.tsv: ROTS.tsv 
# OUTPUT ROTSparameters.tsv: ROTSparameters.tsv 
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to test)
# PARAMETER fdr.threshold: fdr.threshold TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (FDR cut-off for significant results)
# PARAMETER B: B TYPE INTEGER FROM 10 TO 100000 DEFAULT 500 (Number of bootstrap and permutation resamplings)
# PARAMETER K: K TYPE INTEGER FROM 1000 TO 100000 DEFAULT 5000 (Largest top list size considered)



# Reproducibility-optimized two-group test

# LLE 23.9.2008



# Loads the ROTS library.

library(ROTS)



# Loads the normalized data

file <- c("normalized.tsv")
dat <- read.table(file, header=T, sep="\t", row.names=1)



# Separates expression values and flags

calls <- dat[,grep("flag", names(dat))]
data <- dat[,grep("chip", names(dat))]



# Test needs a parameter "groups" that specifies the grouping of the samples

phenodata <- read.table("phenodata.tsv", header=T, sep="\t")
groups <- phenodata[,grep(column, colnames(phenodata))]



# Sanity checks

if(length(unique(groups))==1 | length(unique(groups))>=3) {
   stop("You need to have exactly two groups to run this analysis")
}



# Testing

result <- ROTS(data, groups, B, K) 
  
d <- result$d
FDR <- result$FDR
FDR[FDR > fdr.threshold] <- NA
write.table(na.omit(data.frame(dat, d=round(d, digits=2), FDR=round(FDR, digits=6))), file="ROTS.tsv", sep="\t", row.names=T, col.names=T, quote=F)
  
param<- round(c(result$a1, result$a2, result$k, result$R, result$Z, result$B),2)
names(param)<- c("a1","a2","Top list size","Reproducibility value","Z-score","Number of resamplings")
write.table(param, file="ROTSparameters.tsv", sep="\t", row.names=T, col.names=F, quote=F)

# TOOL plot-dendrogram.R: Dendrogram (Creates a dendrogram of samples using normalized data with Pearson correlation and average linkage method. The branches of the tree are colored according to the selected number of groups. Clustering is done using the function hcluster in which the parameter correlation envokes computation of pearson type of distances.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT dendrogram-color.pdf: dendrogram-color.pdf 
# OUTPUT dendrogram-bw.pdf: dendrogram-bw.pdf 
# PARAMETER cluster: cluster TYPE [genes: genes, chips: chips] DEFAULT chips (What to cluster)
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to color next to the tree)
# PARAMETER number.of.groups: number.of.groups TYPE INTEGER FROM 2 TO 20 DEFAULT 2 (How many groups to color to the tree)
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Dendrogram
# JTT 3.10.2007
#
# MG 25.11.2010
# Increased the gene/sample limit to 20000

# Renaming variables
w<-image.width
h<-image.height
gr<-number.of.groups 
margin<-cluster

# Loading the libraries
library(fpc)
library(A2R)
library(amap)

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Loads the phenodata
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
groups<-phenodata[,pmatch(column,colnames(phenodata))]

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]
colnames(dat2)<-gsub(" ", "", phenodata$description)

# Manipulate data depending on what to cluster
if(margin=="chips") {
dat2<-t(dat2) 
}

if (nrow(dat2) > 20000) {
stop("Hierarchical clustering dendrogram can be plotted on maximum 2000 of genes/samples");
}

# Does the clustering
clust<-hcluster(x=dat2, method="correlation", link="average")
ct<-cutree(clust, gr)


# A2Rplot code from http://addictedtor.free.fr/packages/A2R/lastVersion/R/A2R
.packageName <- "A2R"
arimaSelect <- function(
  serie,                # the time serie to fit
  order,                # see stats::arima
  include.mean = FALSE, # idem
  alpha = 0.05          # risk
  ){

   n_max <- sum( order[ c(1,3) ] )
   n     <- length(serie)
   
   #! the matrix of coeffs, each row for each step
   coeff     <- matrix( NA , nrow = n_max , ncol = n_max )
   
   #! same with t-stat p-value's
   pval      <- coeff
   aic       <- rep(NA, n_max)
   liste     <- rep( list(NULL) , n_max )
   fixed     <- aic
   
   go <- TRUE
   i  <- 1
   while(go){
     
     arima.out <- arima(serie,
                        order        = order,
                        include.mean = include.mean,
                        method       = "ML", 
                        fixed        = fixed)
     liste[[i]] <- arima.out
     
     .coeff <- arima.out$coef
     .sd    <- rep(0, n_max)
     .sd[arima.out$mask] <- sqrt(diag(arima.out$var.coef))

     .pval  <- round( 2 * (1 - pt(abs( .coeff / .sd  ),
                                  df = n - n_max - 1 ) ) , 5)

     coeff[i,] <- .coeff
     pval[i,]  <- .pval
     aic[i]    <- arima.out$aic
     fixed[which.max(.pval)] <- 0
     go     <- any(.pval > alpha, na.rm = TRUE)
     i      <- i+1

     
   }
   
   
res <- list(coeff     = coeff,
            pval      = pval,
            aic       = aic, 
            listArima = liste)
class(res) <- "arimaSelect"
res
            
}

plot.arimaSelect <- function(x, choix, ...){
	noms <- names(x$listArima[[1]]$coef)
	coeff <- x$coeff
	k <- min(which(is.na(coeff[,1])))-1
	coeff <- coeff[1:k,]
	pval  <- x$pval[1:k,]
	aic   <- x$aic[1:k]
	coeff[coeff==0] <- NA
	n <- ncol(coeff)
	if(missing(choix)) choix <- k
	
	layout(matrix(c(1,1,1,2,
	                3,3,3,2,
			3,3,3,4,
			5,6,7,7),nr=4),
               widths=c(10,35,45,15),
	       heights=c(30,30,15,15))
	couleurs <- rainbow(75)[1:50]#(50)
	ticks <- pretty(coeff)
	
	### graph AIC
	par(mar=c(1,1,3,1))
	plot(aic,k:1-.5,type="o",pch=21,bg="blue",cex=2,axes=FALSE,lty=2,xpd=NA)
	points(aic[choix],k-choix+.5,pch=21,cex=4,bg=2,xpd=NA)
	#axis(3)
	title("aic",line=2)
	
	par(mar=c(3,0,0,0))	
	plot(0,axes=FALSE,xlab="",ylab="",xlim=range(ticks),ylim=c(.1,1))
	rect(xleft  = min(ticks) + (0:49)/50*(max(ticks)-min(ticks)),
	     xright = min(ticks) + (1:50)/50*(max(ticks)-min(ticks)),
	     ytop   = rep(1,50),
	     ybottom= rep(0,50),col=couleurs,border=NA)
	axis(1,ticks)
	rect(xleft=min(ticks),xright=max(ticks),ytop=1,ybottom=0)
	text(mean(coeff,na.rm=T),.5,"coefficients",cex=2,font=2)
	
	
	par(mar=c(1,1,3,1))
	image(1:n,1:k,t(coeff[k:1,]),axes=FALSE,col=couleurs,zlim=range(ticks))
	for(i in 1:n) for(j in 1:k) if(!is.na(coeff[j,i])) {
		if(pval[j,i]<.01)                            symb = "green"
		else if( (pval[j,i]<.05) & (pval[j,i]>=.01)) symb = "orange"
		else if( (pval[j,i]<.1)  & (pval[j,i]>=.05)) symb = "red"
		else                                         symb = "black"
		polygon(c(i+.5   ,i+.2   ,i+.5   ,i+.5),
		        c(k-j+0.5,k-j+0.5,k-j+0.8,k-j+0.5),
			col=symb)
		
		#points(i+.4,k-j+.6,pch=21,bg=symb)
		#text(i+.5,k-j+.8,round(pval[j,i],2),pos=2,cex=.8)
		if(j==choix)  {
			rect(xleft=i-.5,
			     xright=i+.5,
			     ybottom=k-j+1.5,
			     ytop=k-j+.5,
			     lwd=4)
			text(i,
			     k-j+1,
			     round(coeff[j,i],2),
			     cex=1.2,
			     font=2)
		}
		else{
			rect(xleft=i-.5,xright=i+.5,ybottom=k-j+1.5,ytop=k-j+.5)
			text(i,k-j+1,round(coeff[j,i],2),cex=1.2,font=1)
		}
	}
	axis(3,1:n,noms)


	par(mar=c(0.5,0,0,0.5))	
	plot(0,axes=FALSE,xlab="",ylab="",type="n",xlim=c(0,8),ylim=c(-.2,.8))
	cols <- c("green","orange","red","black")
	niv  <- c("0","0.01","0.05","0.1")
	for(i in 0:3){
		polygon(c(1+2*i   ,1+2*i   ,1+2*i-.5   ,1+2*i),
		        c(.4      ,.7      , .4        , .4),
			col=cols[i+1])
		text(2*i,0.5,niv[i+1],cex=1.5)	
		}
	text(8,.5,1,cex=1.5)
	text(4,0,"p-value",cex=2)
	box()
	
	residus <- x$listArima[[choix]]$res
	
	par(mar=c(1,2,4,1))
	acf(residus,main="")
	title("acf",line=.5)
	
	par(mar=c(1,2,4,1))
	pacf(residus,main="")
	title("pacf",line=.5)
	
	par(mar=c(2,2,4,1))
	qqnorm(residus,main="")
	title("qq-norm",line=.5)
	
}

"._a2r_hclu"       <- NULL # to receive an hclust object when 
                           # A2Rplot.hclust is called

"._a2r_counter"       <- NA # a counter used in A2Rplot.hclust
"._a2r_height_cut"    <- NA

"._a2r_envir"         <- NA
"._a2r_group"         <- NA


#===============================================================================
"A2Rplot" <- function(x,...){
  UseMethod("A2Rplot")
}
#===============================================================================
"A2Rplot.default" <- function(x,...){
  plot(x,...)
}
#===============================================================================
"A2Rplot.hclust" <- function(
  x ,             # an hclust object to draw
  k        = 2,   # the number of groups
  col.up   = "black",
  col.down = rainbow(k),
  lty.up   = 2,
  lty.down = 1,
  lwd.up   = 1,
  lwd.down = 2,
  type     = c("rectangle","triangle"),
  knot.pos = c("mean","bary","left","right","random"),
  criteria,
  fact.sup,
  show.labels=TRUE,
  only.tree=FALSE,
  main     = paste("Colored Dendrogram (",k," groups)"),
  boxes    = TRUE,
  members,
  ...
){

  if(missing(members)) members <- NULL
  opar <- par(no.readonly=TRUE)
  knot.pos <- match.arg(knot.pos)
  type     <- match.arg(type)
  # tests
  if(k<2) 
    stop("k must be at least 2")  
    
  ._a2r_counter    <<- 0
  ._a2r_hclu       <<- x

  ._a2r_envir      <<- environment()
  nn <- length(x$order) - 1

  ._a2r_height_cut <<- mean(x$height[nn-k+1:2])
  ._a2r_group      <<- 0
  
  n.indiv   <- length(x$order)
  groups.o  <- cutree.order(x, k=k)[x$order]
  
  bottom <- if(is.null(members)) 0 else x$height[nn] * -.2 
  
  if(only.tree){
    if(is.null(members)) plot(0,type="n",xlim=c(0.5,n.indiv+.5), ylim=c(bottom,x$height[nn]), xaxs="i", axes=FALSE, xlab="",ylab="") 
    else                 plot(0,type="n",xlim=c(0.5,sum(members)+.5), ylim=c(bottom,x$height[nn]), xaxs="i", axes=FALSE, xlab="",ylab="")
    #call to the ** recursive function ** .rec.hclust
    .rec.hclust(nn, col=col.up, lty=lty.up, lwd=lwd.up)
    
    if(boxes){
      axis(2)
      box()
    }
    return(NULL)
  }
  
  # prepare the layout
  matlayout <- matrix(c(2,4,6,1,3,5), nc=2, nr=3)
  widths    <- c(1,9)
  heights   <- c(8,1,1)
  if(!show.labels){
      matlayout <- matrix(c(2,4,1,3), nc=2, nr=2)
      widths    <- c(1,9)
      heights   <- c(9,1)
  }
  if(!missing(fact.sup) ) {
    heights   <- c(8,1,1)
  }
  if(missing(criteria) & missing(fact.sup)){
    matlayout <- matrix(c(2,4,1,3), nc=2, nr=2)
      widths    <- c(1,9)
      heights   <- c(9,1)
    
  }
  layout(matlayout, width=widths, height=heights)
  
  
  
  #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ The tree (1)
  par(mar=c(0,0,3,4))
  if(is.null(members)) plot(0,type="n",xlim=c(0.5,n.indiv+.5), ylim=c(bottom,x$height[nn]), xaxs="i", axes=FALSE, xlab="",ylab="") 
  else plot(0,type="n",xlim=c(0.5,sum(members)+.5), ylim=c(bottom,x$height[nn]), xaxs="i", axes=FALSE, xlab="",ylab="") 
  #call to the ** recursive function ** .rec.hclust
  .rec.hclust(nn, col=col.up, lty=lty.up, lwd=lwd.up)
  title(main)
  if(boxes){
    box()
    axis(4)
  }
  
  #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Criteria (2)
  if(!missing(criteria)){
    par(mar=c(0,0,3,0))
    plot(0,
         type="n",
         xlim=range(criteria), 
         ylim=c(0,x$height[nn]), 
         axes=FALSE, 
         xlab="",
         ylab="")
    par(las=2)
    n.crit <- length(criteria)
    heights.cut <- ( tail(x$height,n.crit) + 
                     tail(x$height,n.crit+1)[-(n.crit+1)] ) / 2
    heights.cut <- rev(heights.cut)
                   
    points(criteria   , heights.cut   , pch=21, bg="red", type="o")
    points(criteria[k-1], heights.cut[k-1], pch=21, cex=2, bg="blue", xpd=NA)
    if(boxes){
      axis(3)
      box()
    }
  }
  else{
    par(mar=c(0,0,3,0))
    plot(0,
         type="n",
         xlim=c(0,1), 
         ylim=c(0,1), 
         axes=FALSE, 
         xlab="",
         ylab="")
  }

  if(show.labels){
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Name of the observations (3)
    par(mar=c(0,0,0,4))
    par(srt=90)
    obs.labels <- toupper(substr(x$labels[x$order],1,6))
    if(is.null(members)) {
      plot(0,type="n",xlim=c(0.5,n.indiv+.5), ylim=c(0,1), xaxs="i", axes=FALSE, xlab="",ylab="") 
      text(1:n.indiv            , 0, obs.labels, pos=4, col=col.down[groups.o])
    }
    else{
      plot(0,type="n",xlim=c(0.5,sum(members)+.5), ylim=c(0,1), xaxs="i", axes=FALSE, xlab="",ylab="") 
      xo <-   members[x$order]
      text(cumsum(xo)-xo/2, 0, obs.labels, pos=4, col=col.down[groups.o])
    }
    par(srt=0)
    if(boxes){
      box()
    }
  
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Labels (4)
    par(mar=c(0,0,0,0))
    plot(0,type="n",xlim=c(0,1), ylim=c(0,1), xaxs="i", axes=FALSE, xlab="",ylab="") 
    text(.5,.5,"Labels")
    if(boxes){
      box()
    }
      
  }
  
  #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Quali (5,6)
  if(!missing(fact.sup)){
    quali  <- as.factor(fact.sup)[x$order]
    quanti <- as.numeric(quali)

    par(mar=c(1,0,0,4))
    n.levels <- length(levels(quali))
    plot(0,type="n",
         xlim=c(0.5,n.indiv+.5), 
         ylim=c(0,n.levels), 
         xaxs="i", yaxs="i",axes=FALSE, xlab="",ylab="") 
        
    rect(xleft    = (1:n.indiv)-.5,
         xright   = (1:n.indiv)+.5,
         ybottom  = quanti-1, 
         ytop     = quanti,
         col      = col.down[groups.o])
    par(las=1)
    axis(4, (1:n.levels)-.5,levels(quali), tick=FALSE)
      
    if(boxes){
      box()
    }
    
    
    par(mar=c(1,0,0,0))
    plot(0,type="n",xlim=c(0,1), ylim=c(0,1), xaxs="i", axes=FALSE, xlab="",ylab="") 
    text(.5,.5,deparse(substitute(fact.sup)))
    if(boxes){
      box()
    }
  }
  
  
  par(opar) # reset parameter
}

#===============================================================================

".rec.hclust" <- function(
  index, # index of the current tree to draw
  lwd = 1,
  lty = 1,
  col = "black"){

  members <- get('members', envir= ._a2r_envir) 
  bottom  <- get('bottom',  envir= ._a2r_envir) 
  if(index<0){ # it is a leaf
    if(is.null(members)){
       ._a2r_counter <<- ._a2r_counter + 1
       return(list( x = ._a2r_counter,
                    n = 1))       
    }
    else{
      cc <- ._a2r_counter
      mm <- members[-index]
      polygon(x  = c(cc, cc+mm/2, cc+mm),
              y  = c(bottom, 0, bottom),
              col= col, 
              border = col, 
              lwd=lwd)
      ._a2r_counter <<- ._a2r_counter + mm
      return(list(x = cc+mm/2,
                  n = mm))
    }
  }
  
  h.m   <- ._a2r_hclu$height[index]

  
  #~~~~~~~~~~~~~~~~~~~~~~~~~~ do left
  index.l  <- ._a2r_hclu$merge[index,1]
  
  h.l <- if(index.l<0) 0 else ._a2r_hclu$height[index.l]
  if(h.l<._a2r_height_cut & h.m > ._a2r_height_cut){
      ._a2r_group <<- ._a2r_group + 1
      col.l <- get("col.down",envir=._a2r_envir)[._a2r_group]
      lwd.l <- get("lwd.down",envir=._a2r_envir)
      lty.l <- get("lty.down",envir=._a2r_envir)
  }
  else{
      col.l <- col
      lwd.l <- lwd
      lty.l <- lty
  }
  out.l   <- .rec.hclust(index.l, col=col.l, lty=lty.l, lwd=lwd.l)
  x.l     <- out.l$x
  n.l     <- out.l$n
  
  
  #~~~~~~~~~~~~~~~~~~~~~~~~~~~ do right
  index.r  <- ._a2r_hclu$merge[index,2]
  h.r <- if(index.r<0) 0 else ._a2r_hclu$height[index.r]
  if(h.r<._a2r_height_cut & h.m > ._a2r_height_cut){
      ._a2r_group <<- ._a2r_group + 1
      col.r <- get("col.down",envir=._a2r_envir)[._a2r_group]
      lwd.r <- get("lwd.down",envir=._a2r_envir)
      lty.r <- get("lty.down",envir=._a2r_envir)
  }
  else{
      col.r <- col
      lwd.r <- lwd
      lty.r <- lty
  }
  out.r   <- .rec.hclust(index.r, col=col.r, lty=lty.r, lwd=lwd.r)
  x.r     <- out.r$x
  n.r     <- out.r$n
  
  
  #~~~~~~~~~~~~~~~~~~~~~~~~~~~ draw what you have to draw
  
  type <- get("type",envir=._a2r_envir)
  x.m  <- (x.r + x.l) / 2  
  n    <- n.r + n.l
  x.b  <- (n.r * x.r + n.l * x.l) / n

  
  knot.pos <- get("knot.pos",envir=._a2r_envir) 
  
  x <- switch(knot.pos,
          mean = x.m,
          left = x.l,
          right= x.r,
          random = x.l + runif(1)*(x.r-x.l),
          bary   = x.b)

          
          
  if(type=="rectangle"){
    segments(x0  = c(x.l, x.l, x.r),
             x1  = c(x.l, x.r, x.r),
             y0  = c(h.l, h.m, h.r),
             y1  = c(h.m, h.m, h.m),
             col = col,
             lty = lty,
             lwd = lwd)
  }
  if(type =="triangle"){
    segments(x0  = c(x.l, x.r),
             x1  = c(x  , x),
             y0  = c(h.l, h.r),
             y1  = c(h.m, h.m),
             col = col,
             lty = lty,
             lwd = lwd)
  }
          
          
  list(x=x,n=n)
}
#===============================================================================
"cutree.order" <- function(hclu, k=NULL, h=NULL){
  
  coupe <- cutree(hclu,k=k, h=h)

  coupe.or <- coupe[hclu$order]
  coupe.out<- rep(NA,length(coupe))
  j <-  1 #
  k <-  coupe.or[1]
  for(i in 1:length(coupe)){
    if(coupe.or[i]==k) next
    else{
      coupe.out[which(coupe==k)] <- j
      j <- j + 1
      k <- coupe.or[i]
    }
  }
  coupe.out[is.na(coupe.out)] <- j
  names(coupe.out) <- names(coupe)
  coupe.out
}
#===============================================================================

"spie" <- function(firstPartition, secondPartition){
  
  if(length(firstPartition)!=length(secondPartition)) 
    stop("'firstPartition' and 'secondPartition' have different lengths")
  
  if(sum(firstPartition)!=sum(secondPartition))
    stop("'firstPartition' and 'secondPartition' doesn't sum the same")
  
  angles <- cumsum(c(0, 2 * pi * firstPartition / sum(firstPartition)))
  
  radii  <- sqrt( (secondPartition / sum(secondPartition)) /
                  (firstPartition  / sum(firstPartition)) )
  
  namesSlices <- if(is.null(names(firstPartition))) 
                   1:length(firstPartition) 
                 else 
                   names(firstPartition)  
  
  structure(list(angles=angles, 
                 radii=radii, 
                 firstPartition=firstPartition,
                 secondPartition=secondPartition, 
                 namesSlices = namesSlices), 
            class="spie")
}

"plot.spie" <- 
  function(
  x, 
  multi, 
  col = rainbow(length(x$radii)),
  ...){
  
    maxRadii <- max(x$radii)
  
  grid.newpage()
  
  pushViewport(viewport(layout=grid.layout(1,1,respect=TRUE)))
  pushViewport(dataViewport(maxRadii*c(-1.1,1.1), 
                            maxRadii*c(-1.1,1.1),
                            layout.pos.col=1,
                            layout.pos.row=1))
    
  
  if(!missing(multi)){
    
      grid.circle(x=0, y=0, r=sqrt(multi), gp=gpar(col="gray"), default.units="native")
    
  
  }  
  
  
  for(i in 1:length(x$radii)){
    
    theta <- seq(x$angles[i], x$angles[i+1], length=100)
    
    grid.polygon(x   = c(0,  cos(theta) ,0),
                 y   = c(0,  sin(theta) ,0) , 
                 gp  = gpar(fill=col[i]),
                 default.units="native")    

    grid.polygon(x   = c(0, x$radii[i] * cos(theta) ,0),
                 y   = c(0, x$radii[i] * sin(theta) ,0) , 
                 gp  = gpar(fill=col[i], lwd=2),
                 default.units="native")    
           
                 
    angleAnn <- mean(x$angles[i+0:1])
    maxx <- max(1, x$radii[i])+maxRadii/10
    
    
    grid.rect( x = cos(angleAnn)*maxx,
               y = sin(angleAnn)*maxx, 
               width = 1.5*stringWidth(x$namesSlices[i]),
               height = 1.5*stringHeight(x$namesSlices[i]),
               default.units="native",
               gp = gpar(col=col[i], fill="white", lwd=2))

    
    grid.text(x$namesSlices[i], 
              x=cos(angleAnn)*maxx, 
              y=sin(angleAnn)*maxx,
              default.units="native")
    
  }
  
  
  
  
  if(!missing(multi)){ 
    
      grid.lines(x=unit(0,"native"), 
                 y=unit(c(0, max(sqrt(multi))), "native"), gp=gpar(col="gray"))
    
    for(i in multi){
      st <- paste("x", i)
      sw <- stringWidth(st)
      sh <- stringHeight(st)
      

      grid.rect( x = unit(0, "native"),
               y = unit(sqrt(i),"native"), 
               width = 1.5*sw,
               height = 1.5*sh , gp=gpar(fill="white", col="gray"))
               
      grid.text( st , 0, sqrt(i), default.units="native")
      
    }
    
  }
  
  upViewport(2)
 
}


# Plotting
pdf(file="dendrogram-color.pdf", width=w/72, height=h/72)
if(margin=="chips") {
A2Rplot(clust, k=gr, fact.sup=groups) 
} else {
A2Rplot(clust, k=gr) 
}
dev.off()

pdf(file="dendrogram-bw.pdf", width=w/72, height=h/72)
plot(clust, hang=0.1)
dev.off()

library(CGHcall)
library(CGHregions)
library(WECCA)

setMethod("frequencyPlot", signature(x="cghCall", y="missing"), frequencyPlotCalls)

setMethod("frequencyPlot", signature(x="cghRegions", y="missing"),
function (x, y, main='Frequency Plot', gaincol='blue', losscol='red', misscol=NA, build='GRCh37',... )
{
  chrom <- chromosomes(x)
  pos <- bpstart(x)
  pos2 <- bpend(x)
  uni.chrom <- unique(chrom)
  chrom.lengths <- CGHbase:::.getChromosomeLengths(build)[as.character(uni.chrom)]
  chrom.ends <- integer()
  cumul <- 0
  for (j in uni.chrom) {
    pos[chrom > j] <- pos[chrom > j] + chrom.lengths[as.character(j)]
    pos2[chrom > j] <- pos2[chrom > j] + chrom.lengths[as.character(j)]
    cumul <- cumul + chrom.lengths[as.character(j)]
    chrom.ends <- c(chrom.ends, cumul)
  }
  names(chrom.ends) <- names(chrom.lengths)
  calls <- regions(x)
  loss.freq <- rowMeans(calls < 0)
  gain.freq <- rowMeans(calls > 0)
  plot(NA, xlim=c(0, max(pos2)), ylim=c(-1,1), type='n', xlab='chromosomes', ylab='frequency', xaxs='i', xaxt='n', yaxs='i', yaxt='n', main=main,...)
  if (!is.na(misscol)) {
    rect(0, -1, max(pos2), 1, col=misscol, border=NA)
    rect(pos, -1, pos2, 1, col='white', border=NA)
  }
  rect(pos, 0, pos2, gain.freq, col=gaincol, border=gaincol)
  rect(pos, 0, pos2, -loss.freq, col=losscol, border=losscol)
  box()
  abline(h=0)
  if (length(chrom.ends) > 1)
    for (j in names(chrom.ends)[-length(chrom.ends)])
      abline(v=chrom.ends[j], lty='dashed')
  ax <- (chrom.ends + c(0, chrom.ends[-length(chrom.ends)])) / 2
  axis(side=1,at=ax,labels=uni.chrom,cex=.2,lwd=.5,las=1,cex.axis=1,cex.lab=1)
  axis(side=2, at=c(-1, -0.5, 0, 0.5, 1), labels=c('100 %', ' 50 %', '0 %', '50 %', '100 %'), las=1)
  mtext('gains', side=2, line=3, at=0.5)
  mtext('losses', side=2, line=3, at=-0.5)
  ### number of data points
  mtext(paste(nrow(x), 'regions'), side=3, line=0, adj=0)
})

segmentDataWeighted <-
function (input, method = "DNAcopy", ...) 
{
    if (method == "DNAcopy") {
        CNA.object <- DNAcopy::CNA(copynumber(input), chromosomes(input), 
            bpstart(input), data.type = "logratio")
        cat("Start data segmentation .. \n")
        segmented <- segment(CNA.object, ...)
        numclone <- segmented$output$num.mark
        smrat <- segmented$output$seg
        numsmrat <- cbind(smrat, numclone)
        repdata <- function(row) {
            rep(row[1], row[2])
        }
        makelist <- apply(numsmrat, 1, repdata)
        joined <- unlist(makelist)
        rm(makelist)
        joined <- matrix(joined, ncol = ncol(input), byrow = FALSE)
        joined <- CGHcall:::.assignNames(joined, input)
        result <- CGHcall:::.segFromRaw(input, joined)
    }
    result
}

CGHregionsPlus <- function(input, ...) {
  regions <- CGHregions:::CGHregions(input, ...)
  # End positions of regions should be the end position of the last data point of that region,
  # but instead CGHregions returns the start position of the last data point.
  # Check if that is indeed the case:
  if (class(input) == 'cghCall') {
    if (sum(regions@featureData@data$End %in% input@featureData@data$Start) > sum(regions@featureData@data$End %in% input@featureData@data$End))
      for (row in rownames(regions@featureData@data))
        regions@featureData@data[row, 'End'] <- input@featureData@data[input@featureData@data$Chromosome == regions@featureData@data[row, 'Chromosome'] & input@featureData@data$Start == regions@featureData@data[row, 'End'], 'End'][1]
  }
  regions
}
environment(CGHregionsPlus) <- environment(CGHregions:::CGHregions)
CGHregions <- CGHregionsPlus

regioningPlus <- function (cghdata.called, threshold = 0.00001, cghdata.regions = NULL) 
{
    find.reg.modus <- function(x) {
        if (nrow(x) == 1)
            return(x)
        splitter <- list()
        splitter[[1]] <- c(1)
        index.temp <- 1
        j <- 1
        for (i in 1:(dim(x)[1] - 1)) {
            if (all(x[i, ] == x[i + 1, ])) {
                index.temp <- c(index.temp, i + 1)
                splitter[[j]] <- index.temp
            }
            else {
                index.temp <- i + 1
                j <- j + 1
                splitter[[j]] <- index.temp
            }
        }
        region.details <- NULL
        for (i in 1:length(splitter)) {
            region.details <- rbind(region.details, c(min(splitter[[i]]), 
                max(splitter[[i]])))
        }
        modus <- which.max(region.details[, 2] - region.details[, 
            1] + 1)
        return(x[region.details[modus[1], 1], ])
    }
    cat("CGHregions of hard call data...")
    if (is.null(cghdata.regions))
        cghdata.regions <- CGHregionsPlus(cghdata.called, averror = threshold)
    cat("...done", "\n")
    print(paste("threshold used:", threshold, sep = " "))
    calls.annotation <- pData(featureData(cghdata.called))
    regions.annotation <- pData(featureData(cghdata.regions))
    cat("Map regions to clones...")
    reg.to.clones <- list()
    counter <- 0
    for (chr in unique(regions.annotation[, 1])) {
        reg.ann.temp <- regions.annotation[regions.annotation[, 
            1] == chr, 1:4]
        for (r in 1:dim(reg.ann.temp)[1]) {
            counter <- counter + 1
            A1 <- which(calls.annotation[, 1] == chr)
            A2 <- which(calls.annotation[, 2] >= reg.ann.temp[r, 
                2])
            A3 <- which(calls.annotation[, 3] <= reg.ann.temp[r, 
                3])
            reg.to.clones[[counter]] <- intersect(intersect(A1, 
                A2), A3)
        }
    }
    cat("...done", "\n")
    cghdata.probs <- numeric()
    for (i in 1:dim(calls(cghdata.called))[2]) {
        cghdata.probs <- cbind(cghdata.probs, cbind(probloss(cghdata.called)[, 
            i], probnorm(cghdata.called)[, i], probgain(cghdata.called)[, 
            i], probamp(cghdata.called)[, i]))
    }
    cat("Calculate mode soft call signature for each region...")
    cghdata.regprobs <- numeric()
    for (i in 1:length(reg.to.clones)) {
        cghdata.regprobs <- rbind(cghdata.regprobs, find.reg.modus(cghdata.probs[reg.to.clones[[i]], 
            , drop = FALSE]))
    }
    cat("...done", "\n")
    softcalls.samplenames <- character()
    for (i in 1:dim(calls(cghdata.called))[2]) {
        if (dim(cghdata.regprobs)[2]/dim(calls(cghdata.called))[2] == 
            3) {
            softcalls.samplenames <- c(softcalls.samplenames, 
                paste(c("probloss_", "probnorm_", "probgain_"), 
                  colnames(regions(cghdata.regions))[i], sep = ""))
        }
        if (dim(cghdata.regprobs)[2]/dim(calls(cghdata.called))[2] == 
            4) {
            softcalls.samplenames <- c(softcalls.samplenames, 
                paste(c("probloss_", "probnorm_", "probgain_", 
                  "probamp_"), colnames(regions(cghdata.regions))[i], 
                  sep = ""))
        }
    }
    colnames(cghdata.regprobs) <- softcalls.samplenames
    rownames(cghdata.regprobs) <- rownames(regions(cghdata.regions))
    regdata <- list()
    regdata$ann <- regions.annotation
    regdata$hardcalls <- regions(cghdata.regions)
    regdata$softcalls <- cghdata.regprobs
    return(regdata)
}
environment(regioningPlus) <- environment(WECCA:::regioning)
regioning <- regioningPlus

WECCA.heatmapPlus <- function (cghdata.regioned, dendrogram, build='GRCh37', ...) 
{
    nclass <- dim(cghdata.regioned$softcalls)[2]/dim(cghdata.regioned$hardcalls)[2]

    cols <- c('lightgreen', 'darkgreen', 'lightgray', 'darkslategray')
    chr.color <- rep(1, nrow(cghdata.regioned$ann))
    centromeres <- CGHbase:::.getCentromere(build)
    for (chr in unique(cghdata.regioned$ann$Chromosome))
      chr.color[cghdata.regioned$ann$Chromosome == chr &
               (cghdata.regioned$ann$Start + cghdata.regioned$ann$End) / 2 > centromeres[chr]] <- 2
    even <- cghdata.regioned$ann$Chromosome %% 2 == 0
    chr.color[even] <- chr.color[even] + 2
    chr.color <- cols[chr.color]

    Y <- rep(FALSE, dim(cghdata.regioned$hardcalls)[1])
    for (i in 2:(dim(cghdata.regioned$ann)[1])) {
        if ((cghdata.regioned$ann[i - 1, 1] != cghdata.regioned$ann[i, 
            1])) {
            Y[i] <- TRUE
        }
    }
    Y[1] <- TRUE
    begin.chr <- rep("", dim(cghdata.regioned$ann)[1])
    begin.chr[Y] <- cghdata.regioned$ann[Y, 1]
    color.coding <- c("red", "black", "blue", "white")[1:nclass]
    heatmap(cghdata.regioned$hardcalls, Colv = as.dendrogram(dendrogram), 
        Rowv = NA, col = color.coding, labRow = begin.chr, RowSideColors = chr.color, 
        scale = "none", ...)
}
environment(WECCA.heatmapPlus) <- environment(WECCA:::WECCA.heatmap)
WECCA.heatmap <- WECCA.heatmapPlus

# EOF

# TOOL export-soft.R: "Export GEO's SOFT format" (Writes out a text file in GEO's SOFT format. This file is suitable for batch submission to GEO database. Before submission to GEO, you need to fill in the missing information of sample descriptions and the series description.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT soft.txt: soft.txt 


# Writes out an empty SOFT formatted file for that is suitable for batch submission to NCBI's GEO database once filled in
#
# JTT 7.72006
# GEO SOFT validator:
# http://www.ncbi.nlm.nih.gov/projects/geo/submission/depslip.cgi?subm=0

# Renaming variables
meth<-c("blank")
file<-c("normalized.tsv")

# Reads data
dat<-read.table(file, header=T, sep="\t", row.names=1)
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Writes a blank SOFT file with obligatory fields only
if(meth=="blank" & ncol(calls)>0) {
   for(i in 1:length(phenodata$sample)) {
      write(file="soft.txt", paste("^SAMPLE = ", phenodata$sample[i], sep=""), append=T)
      write(file="soft.txt", paste("!Sample_title = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_source_name_ch1 = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_organism_ch1 = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_characteristics_ch1 = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_molecule_ch1 = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_extract_protocol = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_label_ch1 = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_label_protocol = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_hyb_protocol = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_scan_protocol = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_description = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_data_processing = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_platform_id = ", "", sep=""), append=T)
      write(file="soft.txt", paste("#ID_REF = ", "", sep=""), append=T)
      write(file="soft.txt", paste("#VALUE = ", "", sep=""), append=T)
      write(file="soft.txt", paste("#ABS_CALL = ", "the call in an absolute analysis that indicates if the transcript was present (P), absent (A), or marginal (M)" , sep=""), append=T)
      write(file="soft.txt", paste("!Sample_table_begin" , "", sep=""), append=T)
      dat2<-data.frame(row.names(dat2), dat2[,1], calls[,i])
      names(dat2)<-c("ID_REF", "VALUE", "ABS_CALL")
      write.table(dat2, "soft.txt", sep="\t", quote=F, row.names=F, col.names=T, append=T)
      write(file="soft.txt", paste("!Sample_table_end" , sep=""), append=T)
   }
   # Series description
   write(file="soft.txt", paste("^SERIES = ", phenodata$chiptype[1], "_",  substr(as.character(Sys.time()), 1, 10), "_", substr(date(), 12,19), sep=""), append=T)
   write(file="soft.txt", paste("!Series_title = ", "", sep=""), append=T)
   write(file="soft.txt", paste("!Series_type = ", "", sep=""), append=T)
   write(file="soft.txt", paste("!Series_summary = ", "", sep=""), append=T)
   write(file="soft.txt", paste("!Series_overall_design = ", "", sep=""), append=T)
   for(i in 1:length(phenodata$sample)) {
      write(file="soft.txt", paste("!Series_sample_id = ", phenodata$sample[i], sep=""), append=T)
   }
}

if(meth=="blank" & ncol(calls)==0) {
   for(i in 1:length(phenodata$sample)) {
      write(file="soft.txt", paste("^SAMPLE = ", phenodata$sample[i], sep=""), append=T)
      write(file="soft.txt", paste("!Sample_title = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_source_name_ch1 = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_organism_ch1 = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_characteristics_ch1 = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_molecule_ch1 = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_extract_protocol = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_label_ch1 = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_label_protocol = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_hyb_protocol = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_scan_protocol = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_description = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_data_processing = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_platform_id = ", "", sep=""), append=T)
      write(file="soft.txt", paste("#ID_REF = ", "", sep=""), append=T)
      write(file="soft.txt", paste("#VALUE = ", "", sep=""), append=T)
      write(file="soft.txt", paste("!Sample_table_begin" , "", sep=""), append=T)
      dat2<-data.frame(row.names(dat2), dat2[,1])
      names(dat2)<-c("ID_REF", "VALUE")
      write.table(dat2, "soft.txt", sep="\t", quote=F, row.names=F, col.names=T, append=T)
      write(file="soft.txt", paste("!Sample_table_end" , sep=""), append=T)
   }
   # Series description
   write(file="soft.txt", paste("^SERIES = ", phenodata$chiptype[1], "_",  substr(as.character(Sys.time()), 1, 10), "_", substr(date(), 12,19), sep=""), append=T)
   write(file="soft.txt", paste("!Series_title = ", "", sep=""), append=T)
   write(file="soft.txt", paste("!Series_type = ", "", sep=""), append=T)
   write(file="soft.txt", paste("!Series_summary = ", "", sep=""), append=T)
   write(file="soft.txt", paste("!Series_overall_design = ", "", sep=""), append=T)
   for(i in 1:length(phenodata$sample)) {
      write(file="soft.txt", paste("!Series_sample_id = ", phenodata$sample[i], sep=""), append=T)
   }
}

# TOOL head.R: "Get first lines" (Get first lines of a dataset. Similar to Unix command head.)
# INPUT input-file: input-file TYPE GENERIC 
# OUTPUT first-lines.tsv: first-lines.tsv 
# PARAMETER count:  TYPE INTEGER FROM 0 (Number of lines to get)

system(paste("head -n", count, "input-file > first-lines.tsv"))

# TOOL tagcleaner-trim.R: "Trim primers/adaptors" (Trim tags (i.e. the primers/adapters\) from sequences. This tool is based on TagCleaner.)
# INPUT reads: "FASTQ/FASTA file" TYPE GENERIC
# INPUT OPTIONAL qual: "QUAL file" TYPE GENERIC
# OUTPUT trim.log.txt
# OUTPUT OPTIONAL trimmed.fastq
# OUTPUT OPTIONAL trimmed.fasta
# OUTPUT OPTIONAL trimmed.qual
# PARAMETER input.type: "Input type" TYPE [FASTQ, FASTA] DEFAULT FASTQ (Input type. If using a FASTA file you can provide an optional QUAL file to trim sequences and their quality scores.)
# PARAMETER tag5: "Tag sequence at 5'-end" TYPE STRING DEFAULT "-" (Tag sequence at 5'-end.)
# PARAMETER tag3: "Tag sequence at 3'-end" TYPE STRING DEFAULT "-" (Tag sequence at 3'-end.)
# PARAMETER OPTIONAL mm5: "Maximum  mismatches at the 5'-end" TYPE INTEGER DEFAULT 0 (Maximum number of allowed mismatches at the 5'-end.)
# PARAMETER OPTIONAL mm3: "Maximum  mismatches at the 3'-end" TYPE INTEGER DEFAULT 0 (Maximum number of allowed mismatches at the 3'-end.)
# PARAMETER OPTIONAL trimwithin: "Trim within" TYPE INTEGER DEFAULT 0 (The sequence of the tag could occur not only at the sequence end, but also at any other position of the sequence. To assure that only tags are trimmed, the tag sequences can be defined to occur only at the ends allowing a certain number of variable bases. If specified, the value has to be at least the number of bases in the tag sequence. 0 value means option is ignored.)
# PARAMETER OPTIONAL split: "Split fragment-to-fragment concatenations" TYPE [yes, no] DEFAULT yes (This option removes tag contaminations inside the sequences and splist fragment-to-fragment concatenations into separate sequences. This feature should be used with caution for inputs with only a 5' or 3' tag sequence (likely splits too many false positive that naturally occur for single tags compared to much longer concatenated 5' and 3' tags\).)
# PARAMETER OPTIONAL split.mismatch: "Allowed mismatches" TYPE INTEGER DEFAULT 0 (Maximum number of allowed mismatches for the internal (concatenated\) tag sequence(s\).)

# AMS 2013.02.18

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads")
unzipIfGZipFile("qual")

# binary
tagcleaner.binary <- c(file.path(chipster.tools.path, "tagcleaner", "tagcleaner.pl"))

# options
options <- paste("")
# options for input type
if (input.type == "FASTQ"){
	options <- paste(options, "-fastq reads")
}
if (input.type == "FASTA"){
	options <- paste(options, "-fasta reads")
	if (file.exists("qual")){
		options <- paste(options, "-qual qual")
	}
}
# options for parameters
notags <- TRUE
if (tag3 != "-"){
	options <- paste(options, "-tag3", tag3)
	options <- paste(options, "-mm3", mm3)
	notags <- FALSE	
}
if (tag5 != "-"){
	options <- paste(options, "-tag5", tag5)
	options <- paste(options, "-mm5", mm5)
	notags <- FALSE
}
if (notags){
	stop('CHIPSTER-NOTE: No tag sequence specified. If tags are unknow, you can first use the "Predict primers/adaptors" tool.')
}
if (trimwithin > 0){
	if (trimwithin < max(nchar(tag3),nchar(tag5))){
		stop('CHIPSTER-NOTE: Value for "Allowed variable bases" has to be at least the number of bases in the tag sequence.')
	}
	options <- paste(options, "-trim_within", trimwithin)
}
if (split == "yes"){
	options <- paste(options, "-split", split.mismatch)
}
# common options
options <- paste(options, "-64")
options <- paste(options, "-verbose -log trim.log.txt")
options <- paste(options, "-out trimmed")

# command
command <- paste(tagcleaner.binary, options)

# run
system(command)

# Utility function for padding a vector of strings to all have same length (maximum length found from the vector).
pad.with.zeroes <- function(str.vector) {
	len <- max(nchar(as.character(str.vector)))
	str.vector.2 <- paste(paste(rep("0", len), collapse=""), str.vector, sep="")
	return( substr(str.vector.2, nchar(str.vector.2)-(len-1), nchar(str.vector.2)) )
}


# First sort by chromosome, then by start coordinate.
# Chromosomes that are numeric are compated numerically. Chromosomes that
# are non-numeric are compared lexically (in their normalised form).
# Numeric names are always considered smaller than non-numeric.
# This is the same sorting principle that Chipster genome browser has, hence
# using this function guarantees that BED files are compatible with it.
#
# R does not have flexible sorting functionalities, so we need to resort to a hackish solution.
# We create alphabetic presentation of the values and use that for sorting.    
#
# Usage:
#  bed <- read.table(file="sortme.bed", skip=0, sep="\t") # assume file has no header
#  colnames(bed)[1:2] <- c("chr", "start")  # these named columns are required for sorting 
#  sorted.bed <- sort.bed(bed)
#  write.table(sorted.bed, file="sorted.bed", sep="\t", row.names=F, col.names=F, quote=F)
# 
sort.bed <- function(bed) {

	# Check inputs
	if (!'chr' %in% colnames(bed)) {
		stop('BED is missing column chr');
	}
	if (!'start' %in% colnames(bed)) {
		stop('BED is missing column start');
	}
	
	# Normalise chromosome names
	chr.without.postfix <- gsub('(.*)\\..*', '\\1', as.character(bed$chr))
	chr.normalised <- gsub('chr(.*)', '\\1', chr.without.postfix)

	# Convert all fields to right format
	chr.is.nonnumeric <- ifelse(is.na(as.numeric(chr.normalised)), '1', '0')
	chr.padded <- pad.with.zeroes(chr.normalised)
	start.padded <- pad.with.zeroes(as.character(bed$start))
	
	# Create the strings to be sorted
	string.matrix <- rbind(chr.is.nonnumeric, chr.padded, start.padded)
	string.vector <- apply(string.matrix, 2, function(row) paste(row[1], row[2], row[3], sep=""))
	
	# Sort the bed, using the generated strings
	so <- order(string.vector)
	sorted.bed <- bed[so,]
	
	return(sorted.bed)
}

# TOOL calculate-fold-change.R: "Calculate fold change" (Calculates a geometric or arithmetic average of gene expression for replicate chips and then
# calculates a difference or ratio between the averages. The output fold change can be represented either in log2 or linear scale. Note that
# the tool is only applicable if you have exactly two groups of samples, and the reference group is determined by the order-parameter, not by a smaller group number.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT fold-change.tsv: fold-change.tsv 
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to average.)
# PARAMETER geometric TYPE [yes, no] DEFAULT yes (Should the geometric or arithmetic mean be used in the calculation of average expression for the sample groups?)
# PARAMETER scale TYPE [log2, linear] DEFAULT log2 (What scale to use for expressing the results. Log2 yields a symmetric distribution around zero with no change being equal to 0, up-regulation taking positive values and down-regulation negative values. Conversely, in linear scale 
# up-regulation is represented by values greater than 1 and down-regulation values being between 0 and 1.)
# PARAMETER order TYPE [normal, reversed] DEFAULT normal (Defines which samples to treat as the reference group. In the normal mode the group belonging
# of the first sample is assumed to be the reference, whereas in the reversed mode the situation is reversed. Note that this is different to how
# FC values are calculated in the various statistical testing tool, where the reference group is defined by the lower group number or alphabetical order.)

# Calculate fold changes between groups of samples
# JTT 30.7.2007
# MG, 3.5.2011, added parameters for choosing aritmetic or geometric mean
# and for choosing linear or log scale
# OH, 30.11.2011, support for names as group categories
# MG, 30.11.2011, added parameter do define reference group

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Test needs a parameter "groups" that specifies the grouping of the samples
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
groups<-phenodata[,pmatch(column,colnames(phenodata))]

# Sanity checks
if(length(unique(groups))==1) {
	stop("CHIPSTER-NOTE: You do not have any replicates to average!")
}
if(length(unique(groups))>2) {
	stop("CHIPSTER-NOTE: You have more than two groups! I don't know how to calculate fold change.")
}

# If arithmetic mean, then transform values to linear scale
if (geometric == "no") {
	dat2 <- as.data.frame (2^dat2)
}

# Calculating averages
columnnames<-c()
dat3<-matrix(nrow=nrow(dat2), ncol=length(unique(groups)), NA)
#for(i in 1:length(unique(groups))) {
index=1
for( i in unique(groups) ) {
	dat3[,index]<-rowSums(data.frame(dat2[,which(groups==i)]))/ncol(data.frame(dat2[,which(groups==i)]))
	columnnames<-c(columnnames, paste("group", i, sep=""))
	index=index+1
}
columnnames<-paste("chip.", columnnames, sep="")
colnames(dat3)<-columnnames
rownames(dat3)<-rownames(dat2)

# Put the reference group values in the first column
if (order=="reversed") dat3 <- dat3[,order(c(2,1))]

# Calculating the fold change
# Treatment divided by the control
if (geometric == "yes") {
	FC <- dat3[,2]-dat3[,1]
} else {
	FC <- dat3[,2] / dat3 [,1]
}

# If arithmetic mean and log2 scale, then transform values back to log2 scale
if (geometric == "no" && scale == "log2") {
	FC <- log2(FC)
}

# If geometric mean and linear scale, then transform values to linear scale
if (geometric == "yes" && scale == "linear") {
	FC <- 2^FC
}

# Saving the results
write.table(data.frame(dat, FC=FC), file="fold-change.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# EOF

# TOOL plot-volcano-data-exists.R: "Volcano plot from existing results" (Plots a Volcano plot from results of a statistical test. A suitable output for this tool can be generated by running a two-group or a several-group statistical test or a linear model using empiricalBayes.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT volcanoP.pdf: volcanoP.pdf 
# PARAMETER fold.change.column: fold.change.column TYPE COLUMN_SEL (Column that contains the fold change values)
# PARAMETER p.value.column: p.value.column TYPE COLUMN_SEL (Column that contains the p-values)
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Volcano plot from existing results
# JTT 8.11.2007
# modified MG 21.9.2009

# Parameter settings (default) for testing purposes
#fold.change.column<-"FC"
#p.value.column<-"p.adjusted"
#image.width<-600
#image.height<-600

# Renaming variables
w<-image.width
h<-image.height

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Sanity checks
if(fold.change.column=="empty") {
   stop("CHIPSTER-NOTE: You haven't selected a column for fold change! Tool cannot be executed.")
}
if(p.value.column=="empty") {
   stop("CHIPSTER-NOTE: You haven't selected a column for p-value! Tool cannot be executed.")
}
if(sum(grep("p.adjusted", colnames(dat)))==0) {
   stop("CHIPSTER-NOTE: You don't have any P-value columns in the dataset! Please run some statistical test first.")
}

# Extracts the data
expression<-dat[,grep(fold.change.column, colnames(dat))]
pvalues<-dat[,grep(p.value.column, colnames(dat))]

# Plotting
pdf(file="volcanoP.pdf", width=w/72, height=h/72)
plot(expression, -log10(pvalues), xlim=c(-max(expression), max(expression)), main="Volcano plot", pch=19, xlab="log2 (fold change)", ylab="-log10 (p)")
dev.off()

# TOOL stat-geneset.R: "Gene set test" (Testing the significance of a bunch of genes as group, not separately. This tool makes a global test of gene expression, and gives the significance of the expression of a group of genes. You can use your own genelist or search for the most sigficant KEGG or GO pathways. Searching for the most significant pathways works only, if the whole dataset is used, i.e, data should not be prefiltered.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT multtest.pdf: multtest.pdf 
# OUTPUT globaltest-result-table.tsv: globaltest-result-table.tsv 
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to test)
# PARAMETER pathway.or.genelist: pathway.or.genelist TYPE [KEGG: KEGG, GO: GO, current: current] DEFAULT KEGG (Which gene list to test)
# PARAMETER use.multiple.testing.correction: use.multiple.testing.correction TYPE [yes: yes, no: no] DEFAULT yes (Should multiple testing correction be used)
# PARAMETER number.of.groups.to.visualize: number.of.groups.to.visualize TYPE [4: 4, 9: 9, 16: 16] DEFAULT 4 (Number of most significant groups to visualize)
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Testing the statistical significance of several genes as a group or using KEGG or GO pathways
# This only works with KEGG and GO for the whole normalized data (no pre-filtering allowed)
# JTT 14.6.2006
#
# modified by MG 31.12.2009
#
# modified by MG, 3.5.2010 to exclude single gene genesets and added group labels in plots
# added more info columns in results table

#column<-"group"
#pathway.or.genelist <-"KEGG"
#use.multiple.testing.correction <-"yes"
#number.of.groups.to.visualize <-16
#image.width <-600
#image.height <-600

# Loading the libraries
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
if(phenodata$chiptype[1]!="cDNA" | phenodata$chiptype[1]!="Illumina") {
   # Saves the chiptype into object lib
   lib<-phenodata$chiptype[1]
   lib<-as.character(lib)
}

# Account for the fact that annotation packages are from version 2.3 of Bioconductor
# named with an ".db" suffix. Add the suffix when missing to support data files
# from Chipster 1.3 and earlier. 
if (length(grep(".db", lib)) == 0 & length(grep("pmcdf", lib)) == 0) {
        lib <- paste(lib, ".db", sep="")
}

library(package=lib, character.only=T)
library(KEGG.db)
library(GO.db)
library(globaltest)

# Renaming variables
pathways<-pathway.or.genelist
mt<-use.multiple.testing.correction
x<-number.of.groups.to.visualize
w<-image.width
h<-image.height

# Reading in data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Needs a vector groups that specifies which sample to compare
groups<-phenodata[,pmatch(column,colnames(phenodata))]

# Actual testing and plotting
x<-as.numeric(x) 

# Testing with KEGG pathways
if(pathways=="KEGG") {
   # Calculating the test
   lib2<-sub('.db','',lib)
   env<-paste(lib2, "PATH2PROBE", sep="")
   pathway2probe<-get(env)
   kegg<-as.list(pathway2probe)
   test.kegg<-globaltest(as.matrix(dat2), groups, kegg)
   if(mt=="yes") {
      test.kegg<-gt.multtest(test.kegg)
      test.kegg<-sort(test.kegg)
   }
   if(mt=="no") {
      test.kegg<-sort(test.kegg)
   }
#   table.out<-data.frame(pathway=names(test.kegg), pvalue=p.value(test.kegg))
   table.out<-data.frame(pathwayID=names(test.kegg), test.kegg@res)
   names(test.kegg)<-as.list(KEGGPATHID2NAME)[names(test.kegg)]
   table.out<-data.frame(table.out, Description=names(test.kegg))
   table.out<-table.out[order(table.out$P.value),]
   # Find out if there are categories including a single gene
	# and if so remove them
   indices <- 1:length(table.out$Tested)
   indices <- indices[table.out$Tested>1]
   table.out <- table.out[table.out$Tested>1,]
   write.table(table.out, file="globaltest-result-table.tsv", sep="\t", row.names=T, col.names=T, quote=F)
   s<-c(sqrt(x), sqrt(x))
   pdf(file="multtest.pdf", width=w/72, height=h/72)
   split.screen(c(sqrt(x), sqrt(x)))
   if (length (indices) < x) {
	   x <- length(indices)
   } 
   for(i in 1:x) {
	   y<-geneplot(test.kegg[indices[i]], plot=F, addlegend=T)
	   env2<-paste(lib2, "SYMBOL", sep="")
	   env2<-get(env2)
	   names(y)<-as.list(env2)[names(y)]
	   screen(i)
	   par(mar=c(2,0,2,0)+0.1, yaxt="n", cex=0.75)
	   plot(y, main=substr(names(test.kegg[i]), 1, 25), cex.main=1.5, cex.axis=1.25)
   } 
  dev.off()
}

# Testing with GO pathways
if(pathways=="GO") {
	# The same with GO-terms
	lib2<-sub('.db','',lib)
	env<-paste(lib2, "GO2ALLPROBES", sep="")
	go2allprobes<-get(env)
	go<-as.list(go2allprobes)
	test.go<-globaltest(as.matrix(dat2), groups, go)
	
	if (mt=="yes") {
		test.go <- gt.multtest(test.go)
		test.go <- sort(test.go)
	}
	if (mt=="no") {
		test.go <- sort(test.go)
	}

	
#	test.go<-sort(test.go)
	test.go2<-test.go[1:x,]
	table.out<-data.frame(ontologyID=names(test.go2), test.go2@res)
	n<-c()
	for(i in 1:x) {
		n<-c(n, get(names(test.go2[i,]),GOTERM)@Term)
	}
	names(test.go2)<-n
	table.out<-data.frame(table.out, Description=names(test.go2))
	table.out<-table.out[order(table.out$P.value),]
# Find out if there are categories including a single gene
# and if so remove them
	indices <- 1:length(table.out$Tested)
	indices <- indices[table.out$Tested>1]
	table.out <- table.out[table.out$Tested>1,]
	write.table(table.out, file="globaltest-result-table.tsv", sep="\t", row.names=T, col.names=T, quote=F)
	s<-c(sqrt(x), sqrt(x)) 
	pdf(file="multtest.pdf", width=w/72, height=h/72)
	split.screen(c(sqrt(x), sqrt(x)))
	if (length (indices) < x) {
		x <- length(indices)
	} 
	for(i in 1:x) {
		y<-geneplot(test.go[indices[i]], plot=F, addlegend=T)
		env2<-paste(lib2, "SYMBOL", sep="")
		env2<-get(env2)
		names(y)<-as.list(env2)[names(y)]
		screen(i)
		par(mar=c(2,0,2,0)+0.1, yaxt="n", cex=0.5)
		plot(y, main=substr(names(test.go2[i]), 1, 25), cex.main=1.5, cex.axis=1.25)
	}
	dev.off()
}

if(pathways=="current") {
   test.current<-globaltest(X=as.matrix(dat2), Y=groups, genesets=rep(1, nrow(dat2)))
   pdf(file="multtest.pdf", width=w/72, height=h/72)
   geneplot(test.current)
   dev.off()
   write(x="Dont't worry! You've run the analysis using current gene list. Thus, this file should be empty.", file="globaltest-result-table.tsv")
}

# TOOL generate-phenodata.R: "Generate phenodata" (If run on a prenormalized file, generates a blank phenodata for it.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# OUTPUT normalized.tsv: normalized.tsv 
# PARAMETER chiptype: chiptype TYPE STRING DEFAULT empty ()


# Combines two different tables using gene names
# JTT 6.7.2006
#
# modified by MG 19.1.2010

# Parameter settings (default) for testing purposes
#chiptype<-c("hgu133a")

# Figure out how the data is organized and load it
file<-c("normalized.tsv")
dat <- read.table(file, header=T, sep="\t", row.names=1, nrows=1)
ind.calls <- grep("flag", names(dat))
ind.flags <- grep("chip", names(dat))
ind.dat <- grep("chip", names(dat))
colclasses <- c(rep("numeric", length(ind.dat)), rep("character", 
				length(ind.calls)))
number.annotations <- length(names(dat))-length(ind.calls)-length(ind.flags)
colclasses <- append(rep("factor",1+number.annotations),colclasses)
dat <- read.table(file, header=T, sep="\t", row.names=1, colClasses=colclasses)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-data.frame(dat[,grep("chip", names(dat))])

# Check whether column names contain "chip." and, if so, remove from name
sample<-colnames(dat2)
if (length (grep("chip.", sample)) >= 1) {
	sample<-sub("chip.","",sample)
}

# Generates the variables
# sample<-colnames(dat2)
group<-c(rep("", ncol(dat2)))
if(chiptype=="empty") {
   chiptype<-c("empty")
} else {
   chiptype<-chiptype
}

# Writes out the data and the phenodata table
write.table(dat, file="normalized.tsv", sep="\t", row.names=T, col.names=T, quote=F)
write.table(data.frame(sample=sample, chiptype=chiptype, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# TOOL norm-combat.R: "ComBat - batch normalisation" (Batch normalisation using Phenotype file. You may use this method after the ordinary normalisation to remove batch effects from the data.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT batch_corrected.tsv: batch_corrected.tsv
# PARAMETER batch1: batch1 TYPE METACOLUMN_SEL DEFAULT EMPTY (Phenodata column describing the main batch to correct)
# PARAMETER batch2: batch2 TYPE METACOLUMN_SEL DEFAULT EMPTY (Phenodata column describing addittional batches to correct.)
# PARAMETER batch3: batch3 TYPE METACOLUMN_SEL DEFAULT EMPTY (Phenodata column describing addittional batches to correct.)

# ComBat batch correction analysis
# MK 25.06.2013

# Loading libraries
library(sva)

# Loads the normalized data
file <- "normalized.tsv";
dat <- read.table(file, header=T, sep="\t", row.names=1)

# Loads Batch information
file <- "phenodata.tsv";
phenodata <- read.table(file, header=T, sep="\t")

# Merge batches to matrix
if(batch1 == "EMPTY" & batch2 == "EMPTY" & batch3 == "EMPTY") { stop("CHIPSTER-NOTE: no batches defined"); }

batch <- NULL;
if(batch1 != "EMPTY") { 
	batch <- cbind(batch, phenodata[,pmatch(batch1,colnames(phenodata))]);
}
if(batch2 != "EMPTY") { 
	batch <- cbind(batch, phenodata[,pmatch(batch2,colnames(phenodata))]);
}
if(batch3 != "EMPTY") { 
	batch <- cbind(batch, phenodata[,pmatch(batch3,colnames(phenodata))]);
}

dat2  <- as.matrix(dat[,grep("chip", names(dat))])
combat_edata = ComBat(dat=dat2, batch=batch, mod=NULL)

#pheno = pData(bladderEset)
#batch = pheno$batch
#mod = model.matrix(~as.factor(cancer), data=pheno)

## Correct for batch using ComBat

cols <- grep("chip", names(dat));
dat[, cols] <- as.matrix(combat_edata);
write.table(data.frame(dat), file="batch_corrected.tsv", sep="\t", row.names=TRUE, col.names=TRUE, quote=FALSE)

# TOOL cuffdiff2.R: "Differential expression using Cuffdiff" (Given GTF and BAM files, Cuffdiff performs differential expression analysis of genes and transcripts using the Cufflinks algorithm. It is currently not possible to use replicate samples in Chipster, so you have to merge all samples belonging to the same experiment group into a single BAM file.)
# INPUT treatment1.bam: "Treatment BAM" TYPE BAM
# INPUT control1.bam: "Control BAM" TYPE BAM
# INPUT OPTIONAL annotation.gtf: "Annotation GTF" TYPE GTF
# OUTPUT OPTIONAL de-genes-cufflinks.tsv
# OUTPUT OPTIONAL de-isoforms-cufflinks.tsv
# OUTPUT OPTIONAL cufflinks-log.txt
# OUTPUT OPTIONAL de-genes-cufflinks.bed
# OUTPUT OPTIONAL de-isoforms-cufflinks.bed
# OUTPUT OPTIONAL cds.count_tracking.tsv
# OUTPUT OPTIONAL cds.diff.tsv
# OUTPUT OPTIONAL cds.fpkm_tracking.tsv
# OUTPUT OPTIONAL cds.read_group_tracking.tsv
# OUTPUT OPTIONAL cds_exp.diff.tsv
# OUTPUT OPTIONAL gene_exp.diff.tsv
# OUTPUT OPTIONAL genes.count_tracking.tsv
# OUTPUT OPTIONAL genes.fpkm_tracking.tsv
# OUTPUT OPTIONAL genes.read_group_tracking.tsv
# OUTPUT OPTIONAL isoform_exp.diff.tsv
# OUTPUT OPTIONAL isoforms.count_tracking.tsv
# OUTPUT OPTIONAL isoforms.fpkm_tracking.tsv
# OUTPUT OPTIONAL isoforms.read_group_tracking.tsv
# OUTPUT OPTIONAL promoters.diff.tsv
# OUTPUT OPTIONAL read_groups.info.txt
# OUTPUT OPTIONAL run.info.txt
# OUTPUT OPTIONAL splicing.diff.tsv
# OUTPUT OPTIONAL tss_group_exp.diff.tsv
# OUTPUT OPTIONAL tss_groups.count_tracking.tsv
# OUTPUT OPTIONAL tss_groups.fpkm_tracking.tsv
# OUTPUT OPTIONAL tss_groups.read_group_tracking.tsv
# PARAMETER output.type: "Output type" TYPE [concise, complete] DEFAULT concise (Cuffdiff produces a large number of output files (over 20\). You can choose to see the complete output or just concise processed output.)
# PARAMETER internalgtf: "Annotation GTF" TYPE [hg19: "Human (hg19\)", mm9: "Mouse (mm9\)", mm10: "Mouse (mm10\)", rn4: "Rat (rn4\)"] DEFAULT hg19 (You can use own GTF file or one of those provided on the server.)
# PARAMETER chr: "Chromosome names in my BAM file look like" TYPE [chr1: "chr1", 1: "1"] DEFAULT chr1 (Chromosome names must match in the BAM file and in the reference annotation. Check your BAM and choose accordingly.)
# PARAMETER OPTIONAL fdr: "Allowed false discovery rate" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (FDR-adjusted p-values (q-values\) are calculated. The concise output files include only those genes or transcripts which have a q-value lower than the given FDR. The value of the Significant-column is adjusted accordingly (yes/no\) in all output files.) 
# PARAMETER OPTIONAL mmread: "Enable multi-mapped read correction" TYPE [yes, no] DEFAULT no (By default, Cufflinks will uniformly divide each multi-mapped read to all of the positions it maps to. If multi-mapped read correction is enabled, Cufflinks will re-estimate the transcript abundances dividing each multi-mapped read probabilistically based on the initial abundance estimation, the inferred fragment length and fragment bias, if bias correction is enabled.)
# PARAMETER OPTIONAL bias: "Bias correction for stranded data" TYPE [yes, no] DEFAULT no (Cuffdiff can detect sequence-specific bias and correct for it in abundance estimation. Note that bias correction works only if your data was produced with a strand specific protocol.)
# PARAMETER OPTIONAL genome: "Genome used for bias correction" TYPE [hg19: "Human genome (hg19\)", mm9: "Mouse genome (mm9\)", mm10: "Mouse genome (mm10\)", rn4: "Rat genome (rn4\)"] DEFAULT hg19 (Genome used for bias correction.)

# AMS 21.1.2013
# check column renaming when replicates are enabled
# This parameter is not yet functional due to a bug in Cuffdiff itself. PARAMETER OPTIONAL normalize: "Upper-quartile normalization " TYPE [yes, no] DEFAULT yes (Upper quartile normalization can improve robustness of differential expression calls for less abundant genes and transcripts. It excludes very abundant genes when normalizing expression values for the number of reads in each sample by using the upper quartile of the number of fragments mapping to individual loci.)
# AMS 02.07.2013 Added chr1/1 option, fixed handling of errors when no results are found.

# binary
cuffdiff.binary <- c(file.path(chipster.tools.path, "cufflinks2", "cuffdiff"))

# options
cuffdiff.options <- ""
cuffdiff.options <- paste(cuffdiff.options, "-FDR", fdr)
# if (normalize == "yes") {
#	cuffdiff.options <- paste(cuffdiff.options, "-N")
# }
if (mmread == "yes") {
	cuffdiff.options <- paste(cuffdiff.options, "-u")
}
if (bias == "yes") {
	if (genome == "hg19"){
		genomefile <- "hg19.fa"
	}
	if (genome == "mm9"){
		genomefile <- "mm9.fa"
	}
	if (genome == "mm10"){
		genomefile <- "mm10.fa"
	}
	if (genome == "rn4"){
		genomefile <- "rn4.fa"
	}
	if (chr == "chr1"){
		genomefile <- c(file.path(chipster.tools.path, "genomes", "fasta", genomefile))
	}else{
		genomefile <- c(file.path(chipster.tools.path, "genomes", "fasta", "nochr", genomefile))
	}
	cuffdiff.options <- paste(cuffdiff.options, "-b", genomefile)
}
if (file.exists("annotation.gtf")){
	cuffdiff.options <- paste(cuffdiff.options, "annotation.gtf")
}else{
	if (internalgtf == "hg19") {
		if (chr == 1){
			annotation.file <- "Homo_sapiens.GRCh37.68.gtf"
		}else {
			annotation.file <- "Homo_sapiens.GRCh37.68.chr.gtf"
		}		
	}
	if (internalgtf == "mm9") {
		if (chr == 1){
			annotation.file <- "Mus_musculus.NCBIM37.62.gtf"
		}else {
			annotation.file <- "Mus_musculus.NCBIM37.62.chr.gtf"
		}
	}
	if (internalgtf == "mm10") {
		if (chr == 1){
			annotation.file <- "Mus_musculus.GRCm38.68.gtf"
		}else{
			annotation.file <- "Mus_musculus.GRCm38.68.chr.gtf"
		}
	}
	if (internalgtf == "rn4") {
		if (chr == 1){
			annotation.file <- "Rattus_norvegicus.RGSC3.4.68.gtf"
		}else{
			annotation.file <- "Rattus_norvegicus.RGSC3.4.68.chr.gtf"
		}
	}
	annotation.file <- c(file.path(chipster.tools.path, "genomes", "gtf", annotation.file))
	cuffdiff.options <- paste(cuffdiff.options, annotation.file)
}

# command
command <- paste(cuffdiff.binary, "-q", "-o tmp", cuffdiff.options, "treatment1.bam", "control1.bam")

# run
#stop(paste('CHIPSTER-NOTE: ', command))
system(command)

# The following code copied from dea-cufflinks.R
#
source(file.path(chipster.common.path, "bed-utils.R")) # bed sort

# Only do post-processing if file exists
if (file.exists("tmp/gene_exp.diff") && file.info("tmp/gene_exp.diff")$size > 0){
#if (file.exists("tmp/gene_exp.diff")){
	# DE genes
	# Extract chromosome locations and add in the first three table columns
	dat <- read.table(file="tmp/gene_exp.diff", header=T, sep="\t")
	regions_list <- as.character(dat$locus)
	chr_list <- character(length(regions_list))
	start_list <- numeric(length(regions_list))
	end_list <- numeric(length(regions_list))
	for (count in 1:length(regions_list)) {
		chr_list[count] <- unlist(strsplit (regions_list[count], split=":")) [1]
		start_list[count] <- unlist(strsplit(unlist(strsplit(regions_list[count], split=":"))[2], split="-")) [1]
		end_list[count] <- unlist(strsplit(unlist(strsplit(regions_list[count], split=":"))[2], split="-")) [2]	
	}
	dat2 <- data.frame(chr=chr_list, start=start_list, end=end_list, dat)

	# Rename gene to symbol for compatibility with venn diagram
	# colnames (dat2) [5] <- "ID"
	colnames (dat2) [6] <- "symbol"
	colnames (dat2) [11] <- "FPKM_1"
	colnames (dat2) [12] <- "FPKM_2"
	colnames (dat2) [13] <- "log2_FC"

	# Filter the gene output based on status and significant columns
	dat2 <- dat2[dat2$status=="OK",]
	results_list <- dat2
	results_list <- results_list[results_list$significant=="yes",]
	
	# Write output only if signicant results exist
	if (dim(results_list)[1] > 0) {
	
		# order according to increasing q-value
		results_list <- results_list[order(results_list$q_value, decreasing=FALSE),]
		number_genes <- dim (results_list) [1]
		row_names <- 1:number_genes
		rownames(results_list) <- row_names
		write.table(results_list, file="de-genes-cufflinks.tsv", sep="\t", row.names=TRUE, col.names=T, quote=F)
	
		# Also output a BED file for visualization and region matching tools
		bed_output <- results_list[,c("chr","start","end","gene_id","log2_FC")]
		# sort according to chromosome location
		write.table(bed_output, file="sortme.bed", sep="\t", row.names=F, col.names=T, quote=F)
		bed <- read.table(file="sortme.bed", skip=1, sep="\t") # assume file has 1 line header
		colnames(bed)[1:2] <- c("chr", "start")  # these named columns are required for sorting 
		sorted.bed <- sort.bed(bed)
		write.table(sorted.bed, file="de-genes-cufflinks.bed", sep="\t", row.names=F, col.names=F, quote=F)
	}	

	# Report numbers to the log file
	number_genes_tested <- dim(dat)[1]
	sink(file="cufflinks-log.txt")
	if (dim(results_list)[1] > 0) {
		number_filtered <- number_genes_tested-dim(results_list)[1]
		number_significant <- dim(results_list)[1]
		cat("GENE TEST SUMMARY\n")
		cat("In total,", number_genes_tested, "genes were tested for differential expression.\n")
		cat("Of these,", number_filtered, "didn't fulfill the technical criteria for testing or the significance cut-off specified.\n")
		cat(number_significant, "genes were found to be statistically significantly differentially expressed.\n")	
	} else {
		cat("GENE TEST SUMMARY\n")
		cat("Out of the", number_genes_tested, "genes tested, there were no statistically significantly differentially expressed ones found.")
	}
	sink()
}else{
	write("Cuffdiff did not complete succesfully. Please check your input files.", "cufflinks-log.txt", append=F)
}

# Only do post-processing if file exists
if (file.exists("tmp/isoform_exp.diff") && file.info("tmp/isoform_exp.diff")$size > 0) {
	# DE isoforms
	# Extract chromosome locations and add in the first three table columns
	dat <- read.table(file="tmp/isoform_exp.diff", header=T, sep="\t")
	regions_list <- as.character(dat$locus)
	chr_list <- character(length(regions_list))
	start_list <- numeric(length(regions_list))
	end_list <- numeric(length(regions_list))
	for (count in 1:length(regions_list)) {
		chr_list[count] <- unlist(strsplit (regions_list[count], split=":")) [1]
		start_list[count] <- unlist(strsplit(unlist(strsplit(regions_list[count], split=":"))[2], split="-")) [1]
		end_list[count] <- unlist(strsplit(unlist(strsplit(regions_list[count], split=":"))[2], split="-")) [2]	
	}
	dat2 <- data.frame(chr=chr_list, start=start_list, end=end_list, dat)
	
	# Rename gene to symbol for compability with venn diagram
	# colnames (dat2) [5] <- "ID"
	colnames (dat2) [6] <- "symbol"
	colnames (dat2) [11] <- "FPKM_1"
	colnames (dat2) [12] <- "FPKM_2"
	colnames (dat2) [13] <- "log2_FC"

	# Filter the gene output based on status and significant columns
	dat2 <- dat2[dat2$status=="OK",]
	results_list <- dat2
	results_list <- results_list[results_list$significant=="yes",]
	
	# Write output only if signicant results exist
	if (dim(results_list)[1] > 0) {
	
		# order according to increasing q-value
		results_list <- results_list[order(results_list$q_value, decreasing=FALSE),]
		number_genes <- dim (results_list) [1]
		row_names <- 1:number_genes
		rownames(results_list) <- row_names
		write.table(results_list, file="de-isoforms-cufflinks.tsv", sep="\t", row.names=TRUE, col.names=T, quote=F)
	
		# Also output a BED file for visualization and region matching tools
		bed_output <- results_list[,c("chr","start","end","gene_id","log2_FC")]
		write.table(bed_output, file="", sep="\t", row.names=F, col.names=T, quote=F)
		# sort according to chromosome location
		write.table(bed_output, file="sortme.bed", sep="\t", row.names=F, col.names=T, quote=F)
		bed <- read.table(file="sortme.bed", skip=1, sep="\t") # assume file has 1 line header
		colnames(bed)[1:2] <- c("chr", "start")  # these named columns are required for sorting 
		sorted.bed <- sort.bed(bed)
		write.table(sorted.bed, file="de-isoforms-cufflinks.bed", sep="\t", row.names=F, col.names=F, quote=F)
	}
	
	# Report numbers to the log file
	sink(file="cufflinks-log.txt", append=TRUE)
	number_genes_tested <- dim(dat)[1]
	if (dim(results_list)[1] > 0) {
		number_filtered <- number_genes_tested-dim(results_list)[1]
		number_significant <- dim(results_list)[1]
		cat("\n\nTRANSCRIPT ISOFORMS TEST SUMMARY\n")
		cat("In total,", number_genes_tested, "transcript isoforms were tested for differential expression.\n")
		cat("Of these,", number_filtered, "didn't fulfill the technical criteria for testing or the significance cut-off specified.\n")
		cat(number_significant, "transcripts were found to be statistically significantly differentially expressed.\n")	
	} else {
		cat("\n\nTRANSCRIPT ISOFORMS TEST SUMMARY\n")
		cat("Out of the", number_genes_tested, "transcripts tested, there were no statistically significantly differentially expressed ones found.\n")
	}
	sink()
}

# Rename files
# Non-processed cuffdiff output shown only when complete output selected
if (output.type == "complete"){
	if (file.exists("tmp/cds.count_tracking") && file.info("tmp/cds.count_tracking")$size > 12) {
		system("mv tmp/cds.count_tracking cds.count_tracking.tsv")
	}
	if (file.exists("tmp/cds.diff") && file.info("tmp/cds.diff")$size > 115) {
		system("mv tmp/cds.diff cds.diff.tsv")
	}
	if (file.exists("tmp/cds.fpkm_tracking") && file.info("tmp/cds.fpkm_tracking")$size > 91) {
		system("mv tmp/cds.fpkm_tracking cds.fpkm_tracking.tsv")
	}
	if (file.exists("tmp/cds.read_group_tracking") && file.info("tmp/cds.read_group_tracking")$size > 115) {
		system("mv tmp/cds.read_group_tracking cds.read_group_tracking.tsv")
	}
	if (file.exists("tmp/cds_exp.diff") && file.info("tmp/cds_exp.diff")$size > 124) {
		system("mv tmp/cds_exp.diff cds_exp.diff.tsv")
	}
	if (file.exists("tmp/gene_exp.diff") && file.info("tmp/gene_exp.diff")$size > 124) {
		system("mv tmp/gene_exp.diff gene_exp.diff.tsv")
	}
	if (file.exists("tmp/genes.count_tracking") && file.info("tmp/genes.count_tracking")$size > 184) {
		system("mv tmp/genes.count_tracking genes.count_tracking.tsv")
	}
	if (file.exists("tmp/genes.fpkm_tracking") && file.info("tmp/genes.fpkm_tracking")$size > 171) {
		system("mv tmp/genes.fpkm_tracking genes.fpkm_tracking.tsv")
	}
	if (file.exists("tmp/genes.read_group_tracking") && file.info("tmp/genes.read_group_tracking")$size > 115) {
		system("mv tmp/genes.read_group_tracking genes.read_group_tracking.tsv")
	}
	if (file.exists("tmp/isoform_exp.diff") && file.info("tmp/isoform_exp.diff")$size > 124) {
		system("mv tmp/isoform_exp.diff isoform_exp.diff.tsv")
	}
	if (file.exists("tmp/isoforms.count_tracking") && file.info("tmp/isoforms.count_tracking")$size > 184) {
		system("mv tmp/isoforms.count_tracking isoforms.count_tracking.tsv")
	}
	if (file.exists("tmp/isoforms.fpkm_tracking") && file.info("tmp/isoforms.fpkm_tracking")$size > 171) {
		system("mv tmp/isoforms.fpkm_tracking isoforms.fpkm_tracking.tsv")
	}
	if (file.exists("tmp/isoforms.read_group_tracking") && file.info("tmp/isoforms.read_group_tracking")$size > 115) {
		system("mv tmp/isoforms.read_group_tracking isoforms.read_group_tracking.tsv")
	}
	if (file.exists("tmp/promoters.diff") && file.info("tmp/promoters.diff")$size > 115) {
		system("mv tmp/promoters.diff promoters.diff.tsv")
	}
	if (file.exists("tmp/read_groups.info") && file.info("tmp/read_groups.info")$size > 0) {
		system("mv tmp/read_groups.info read_groups.info.txt")
	}
	if (file.exists("tmp/run.info") && file.info("tmp/run.info")$size > 0) {
		system("mv tmp/run.info run.info.txt")
	}
	if (file.exists("tmp/splicing.diff") && file.info("tmp/splicing.diff")$size > 115) {
		system("mv tmp/splicing.diff splicing.diff.tsv")
	}
	if (file.exists("tmp/tss_group_exp.diff") && file.info("tmp/tss_group_exp.diff")$size > 124) {
		system("mv tmp/tss_group_exp.diff tss_group_exp.diff.tsv")
	}
	if (file.exists("tmp/tss_groups.count_tracking") && file.info("tmp/tss_groups.count_tracking")$size > 12) {
		system("mv tmp/tss_groups.count_tracking tss_groups.count_tracking.tsv")
	}
	if (file.exists("tmp/tss_groups.fpkm_tracking") && file.info("tmp/tss_groups.fpkm_tracking")$size > 91) {
		system("mv tmp/tss_groups.fpkm_tracking tss_groups.fpkm_tracking.tsv")
	}
	if (file.exists("tmp/tss_groups.read_group_tracking") && file.info("tmp/tss_groups.read_group_tracking")$size > 115) {
		system("mv tmp/tss_groups.read_group_tracking tss_groups.read_group_tracking.tsv")
	}
}

# TOOL fastx-trimmer.R: "Trim reads" (Trims reads to a user-specified length. This tool is based on the FASTA/Q Trimmer tool of the FASTX package.)
# INPUT reads.fastq TYPE GENERIC
# OUTPUT trimmed.fastq 
# PARAMETER first: "First base to keep" TYPE INTEGER FROM 1 TO 100 DEFAULT 1 (First base to keep.)
# PARAMETER last: "Last base to keep" TYPE INTEGER FROM 1 TO 300 DEFAULT 75 (Last base to keep.)
# PARAMETER quality.format: "Quality value format used" TYPE [sanger: Sanger, illuminaold: "Illumina GA v1.3-1.5"] DEFAULT sanger (What quality encoding is used in your FASTQ file. Select Sanger if your data comes from Illumina 1.8 or later, SOLiD or 454.)




# EK 17.6.2011

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads.fastq")

# binary
binary <- c(file.path(chipster.tools.path, "fastx", "bin", "fastx_trimmer"))

# command
quality.scale <- ifelse(quality.format == "sanger", "-Q 33", "")
command <- paste(binary, "-f", first, "-l", last, quality.scale, "-i reads.fastq -o trimmed.fastq")

# run
system(command)

# TOOL ngs-find-peaks-macs-two.R: "Find peaks using MACS, treatment vs. control" (This tool will search for statistically significantly enriched genomic regions in sequencing data from a ChIP-seq experiment. The analysis is performed on one or more treatment samples relative to one or more control samples.)
# INPUT treatment.bam: "Treatment data file" TYPE GENERIC 
# INPUT control.bam: "Control data file" TYPE GENERIC 
# OUTPUT positive-peaks.tsv: "True enriched peaks" 
# OUTPUT positive-peaks.bed: "True enriched peaks in a format compatible with the Genome Browser"
# OUTPUT OPTIONAL model-plot.pdf: "A plot of the fitted peak model" 
# OUTPUT OPTIONAL negative-peaks.tsv: "The false enriched peaks" 
# OUTPUT analysis-log.txt: "Summary of analysis settings and run" 
# PARAMETER file.format: "File format" TYPE [ELAND, BAM, BED] DEFAULT BAM (The format of the input files.)
# PARAMETER species: Genome TYPE [human, mouse, rat] DEFAULT human (the species of the samples.)
# PARAMETER read.length: "Read length" TYPE INTEGER FROM 1 TO 200 DEFAULT 25 (The length in nucleotides of the sequence reads)
# PARAMETER band.with: "Bandwidth" TYPE INTEGER FROM 1 TO 1000 DEFAULT 200 (The scanning window size, typically half the average fragment size of the DNA)
# PARAMETER p.value.threshold: "P-value cutoff" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.00001 (The cutoff for statistical significance. Since the p-values are not adjusted to account for multiple testing correction, the cutoff needs to be substantially more conservative than what is usually applied.)
# PARAMETER build.model: "Peak model" TYPE [yes, no] DEFAULT yes (If enabled, a peak model is built from the data. Disabling model building means the shiftsize has to be guessed. In Chipster the shift size is set to half the bandwidth.)
# PARAMETER m.fold.upper: "Upper M-fold cutoff" TYPE INTEGER FROM 1 TO 100 DEFAULT 30 (Sets the cutoff used to determine peak regions for model building. A too high value may result in not enough peaks being identified for building the model. Notice that if the peak model is disabled this parameter has no effect.)
# PARAMETER m.fold.lower: "Lower M-fold cutoff" TYPE INTEGER FROM 1 TO 100 DEFAULT 10 (Sets the cutoff used to determine peak regions for model building. A too low value may result in the inclusion of many false peaks being used for building the model. Notice that if the peak model is disabled this parameter has no effect.)

#####################################################
#                                                   #
# MG, 26.5.2010                                     #
#                                                   #
# Tool that searches for genomic regions that are   #
# significantly enriched in sequence reads from a   #
# ChIP-chip or ChIP-seq experiment. The tool uses   #
# the MACS algorithm for identifying the enriched   #
# regions and uses a p-value cutoff for determining #
# the statistical significance.                     #
#                                                   #
# This version of the tool works for experiments    #
# with two experiment condition, like treatment and #
# control.                                          #
#                                                   #
#####################################################

#####################################################
#                                                   #
# MG, 1.12.2010                                     #
#                                                   #
# Modified to take BAM files as input.              #
#                                                   #
# Modified to run version 1.4 of MACS.              #
#                                                   #
#####################################################

#####################################################
#                                                   #
# MG, 8.3.2011                                      #
#                                                   #
# Modified to disable wiggle output.                #
#                                                   #
#####################################################

#####################################################
#                                                   #
# The following inputs and parameters are needed    #
# if determining the experiment setup from the      #
# phenodata file, like is done for microarray data. #
#                                                   #
#####################################################

# INPUT sequence{...}.txt: "Sequence data files" TYPE GENERIC
# INPUT phenodata.tsv: "The file containing pehnotype data" TYPE GENERIC
# PARAMETER groups.column: "Column with group labels" TYPE METACOLUMN_SEL DEFAULT groups (Phenodata column describing the experiment groups of the samples. Use "2" for treatment and "1" for control.)
# PARAMETER treatment.group: "The group label used for the treatment samples" TYPE STRING DEFAULT "empty"
# PARAMETER control.group: "The group label used for the control samples" TYPE STRING DEFAULT "empty"

# This parameter is no longer needed, as MACS automatically lowers the m-fold cut-off if needed as of version 1.4.0
# PARAMETER adjust.mfold: "Adjust m-fold" TYPE [yes, no] DEFAULT yes (Enabling this option, when building peak model is selected, the m-fold cutoff is automatically adjusted down in case the user-selected value is to stringent for finding peaks for modeling.)

# This parameter has been disabled since its functionality is quite well emulated by the separate strand coverage track in the Genome Browser
# PARAMETER produce.wiggle: "Produce wiggle" TYPE [yes, no] DEFAULT no (Determines if WIGGLE type files should be output or not. By default this option is turned off due to the significantly longer run times it causes. However, for displaying p-values in one track of the Genome Browser, this paramter should be set to indicate the chromosome for which to produce the wiggle file.)

# This output is now obsolete since Chipster can view the .tsv output file in Genome Browser
# OUTPUT positive-peaks.bed: "True enriched peaks in a format compatible with the Genome Browser"

##################################
#                                #
# PARAMETER SETTINGS FOR TESTING #
#                                #
##################################

# groups.column <- "group"
# treatment.group <- "1"
# control.group <- "2"
# file.format <- "ELAND"
# produce.wiggle <- "no"
# species <- "human"
# read.length <- 25
# band.with <- 250
# p.value.threshold <- 0.05
# build.model <- "yes"
# m.fold <- 32
# adjust.mfold <- "yes"

# MACS settings
macs.binary <- file.path(chipster.tools.path, "macs", "macs14")

# Set up approximate mappable genome size depending on species
if (species == "human") {
	genome.size <- as.character(3.5e+9*0.978*.9)
}
if (species == "mouse") {
	genome.size <- as.character(3.25e+9*0.978*.9)
}
if (species == "rat") {
	genome.size <- as.character(3.05e+9*0.978*.9)
}

# Check whether control sample is available
control.available <- "no"
if (length(grep ("control.bam",dir())) != 0) {
	control.available <- "yes"
}

# Set up some parameters in case building peak model is disabled
if (build.model == "no") {
	no.model <- TRUE
	shift.size <- band.with / 2
}

# Set up some parameters in case building peak model is enabled
if (build.model == "yes") {
	no.model <- FALSE
}

# Set up the m-fold limits
mfold.limits <- paste (as.character(m.fold.lower),",",as.character(m.fold.upper), sep="")

# Turn on the option that leaves the mfold auto adjust to MACS
adjust.mfold <- "no"

####################################################
#                                                  #
# The following code could be used if reading the  #
# the experiment setup from the phenodata file,    #
# like is done for microarray data.                #
#                                                  #
# The code allows multiple samples per treatment   #
# group and will automatically merge all samples   #
# into a single file per treatment group.          #
#                                                  #
####################################################

# Loads the  phenodata file and set up groups (for mulitple treatment and control files approach)
# phenodata <- read.table("phenodata.tsv", header=T, sep="\t")
# groups<-phenodata[,pmatch(groups.column,colnames(phenodata))]
# indices <- seq(1,length(groups),step=1)
# treatment.indices <- indices[groups==treatment.group]
# if (control.group != "empty") {
#	control.indices <- indices[groups==control.group]
#}
# Sanity checks
# if(length(unique(groups))==1 | length(unique(groups))>=3) {
#	stop("You need to have exactly two groups to run this analysis")
#}
# If multiple samples per experiment group merge into one single file
#if (length(treatment.indices) > 1) {
#	command <- "cat"
#	command <- paste (command, paste("sequence",treatment.indices[1], sep=""))
#	command <- paste(command, ".txt", sep="")
#	for (count in 2:length(treatment.indices)) {
#		command <- paste(command, " ", sep="")
#		command_2 <- paste("sequence", treatment.indices[count], sep="")
#		command_2 <- paste(command_2, ".txt", sep="")
#		command <- paste(command, command_2, sep="")
#	#	assign (paste("data_", count, sep=""), read.table(files[count], header=T, sep="\t")) 
#	}
#	command <- paste (command, "> treatment.txt")
#	system (command)
#}
#if (length(treatment.indices) == 1) {
#	command <- "mv"
#	command <- paste(command, paste("sequence", treatment.indices[1], sep=""))
#	command <- paste (command, "> treatment.txt")
#	system*command()
#}
#if (length(control.indices) > 1) {
#	command <- "cat"
#	command <- paste (command, paste("sequence",control.indices[1], sep=""))
#	command <- paste(command, ".txt", sep="")
#	for (count in 2:length(control.indices)) {
#		command <- paste(command, " ", sep="")
#		command_2 <- paste("sequence", control.indices[count], sep="")
#		command_2 <- paste(command_2, ".txt", sep="")
#		command <- paste(command, command_2, sep="")
#		#	assign (paste("data_", count, sep=""), read.table(files[count], header=T, sep="\t")) 
#	}
#	command <- paste (command, "> control.txt")
#	system (command)
#}
#if (length(control.indices) == 1) {
#	command <- "mv"
#	command <- paste(command, paste("sequence", control.indices[1], sep=""))
#	command <- paste (command, "> control.txt")
#	system(command)
#}
#
# Remove unmappable reads belonging to random chromosomes or hapmap (multiple file approach)
#system("grep -v random treatment.txt > treatment_2.txt")
#system("grep -v hap treatment.txt > treatment_3.txt")
#system ("rm -f treatment.txt")
#system("rm -f treatment_2.txt")
#if (control.group != "empty") {
#	system("grep -v random control.txt > control_2.txt")
#	system("grep -v hap control.txt > control_3.txt")
#	system ("rm -f control.txt")
#	system("rm -f control_2.txt")
#}


# Remove unmappable reads belonging to random chromosomes or hapmap (single file approach)
# system("grep -v random treatment.txt > treatment_2.txt")
# system("grep -v hap treatment_2.txt > treatment_3.txt")
# system ("rm -f treatment.txt")
# system("rm -f treatment_2.txt")
# if (control.available == "yes") {
#	system("grep -v random control.txt > control_2.txt")
#	system("grep -v hap control_2.txt > control_3.txt")
#	system ("rm -f control.txt")
#	system("rm -f control_2.txt")
#}

# Define function for running MACS
runMACS <- function(..., logFile="/dev/null") {
	
	# Parameter values (character vector)
	params <- c(...) ## Nice :)
	if (!is.null(params)) {
		
		# Flags
		flags <- paste("--", names(params), sep="")
		
		# Remove the parameter names
		names(params) <- NULL
		
		# Switches that are on (value is "TRUE" or "T")
		switchOnParams <- NULL
		switchOn <- which(params == "T" | params == "TRUE")
		if (!identical(switchOn, integer(0))) {
			switchOnParams <- flags[switchOn]
			params <- params[-switchOn]
			flags <- flags[-switchOn]
		}
		
		# Switches that are off are ignored (value is "FALSE" or "F")        
		switchOff <- which(params == "F" | params == "FALSE")
		if (!identical(switchOff, integer(0))) {
			params <- params[-switchOff]
			flags <- flags[-switchOff]
		}
		
		# Command
		command <- paste(macs.binary, paste(flags, params, collapse=" "))
		if (!is.null(switchOnParams)) {
			switchOnParams <-  paste(switchOnParams, collapse=" ")
			command <- paste(command, switchOnParams)
		}
		
		# Run macs. Macs writes its output to stderr (stream number 2)
		# &> redirects both stderr and stdout
		# Iterates through mfold values to find low enough that works
		if (build.model == "yes" & adjust.mfold == "yes") {
			for (mfold in list(32, 24, 16, 8)) {
				system.output <- system(paste(command, paste("--mfold=", mfold, sep=""), "2>", logFile))
#				system.output <- system(paste(command, paste("--mfold=", mfold, sep=""), "2>", logFile))
				if (system.output == 0) {
					break; # was succesfull, don't lower mfold value any more
				}
			}
		}
		if (build.model == "yes" & adjust.mfold == "no") {
			system.output <- system(paste(command, "2>", logFile))
			if (system.output != 0) {
				stop("CHIPSTER-NOTE: Building the peak model failed. Retry by lowering the m-fold value or enabling the automatic m-fold adjustment.") 
			}
			if (length(grep ("results_model.r",dir())) == 0) {
				stop("CHIPSTER-NOTE: Building the peak model failed. Retry by lowering the m.fold.lower value or rerun with model builing turned off.") 
			}
		}
		if (build.model == "no") {
			system.output <- system(paste(command, "2>", logFile))
			if (system.output != 0) {
				stop("CHIPSTER-NOTE: Building the peak model failed. Retry by lowering the m-fold value or enabling the automatic m-fold adjustment.") 
			}
		}
		return((system.output))
	}
}

# Run MACS with specified parameters for the data set
if (build.model == "no") {
	runMACS(treatment="treatment.bam", 
		control="control.bam", 
		name="results", 
		format = file.format,
		bw=band.with,
		pvalue=p.value.threshold,
		mfold=mfold.limits,
		tsize=read.length,
		gsize=genome.size,
		verbose=3, 
		logFile="results.log", 
		nomodel=no.model,
		shiftsize=shift.size,
		help=FALSE, 
		version=FALSE)
}
if (build.model == "yes") {
	runMACS(treatment="treatment.bam", 
			control="control.bam", 
			name="results", 
			format = file.format,
			bw=band.with,
			pvalue=p.value.threshold,
			mfold=mfold.limits,
			tsize=read.length,
			gsize=genome.size,
			verbose=3, 
			logFile="results.log", 
			nomodel=no.model,
			help=FALSE, 
			version=FALSE)
}


# Read in and parse the results

## If final == FALSE, parse the bootsrap results. Else parse the final results
## This feature is not yet implemented.
## <name> is the experiment name and it must be same than in the runMACS
## 10xlog10(pvalue) values are sorted decreasingly"

parseMACSResultsPOS <- function(name, final=FALSE){
	if( final ) {
		output <- read.table(file=paste(name, "_peaks.xls", sep=""), skip=0, header=TRUE, stringsAsFactors=FALSE)
		## Choose columns
#		output <- output[c("chr","start","end","length","fold_enrichment", "X.10.log10.pvalue.","tags","summit","FDR(%)")]
		## Fix colnames
		colnames(output)[7] <- "neg10xlog10pvalue"
		## Sort the result according to the -10xlog10(pvalue)
		output <- output[ order(output[,5], decreasing=TRUE), ]
		return(output)
	}
}


parseMACSResultsNEG <- function(name, final=FALSE){
	if( final ) {
		output <- read.table(file=paste(name, "_negative_peaks.xls", sep=""), skip=0, header=TRUE, stringsAsFactors=FALSE)
		## Choose columns
#		output <- output[c("chr","start","end","length","fold_enrichment", "X.10.log10.pvalue.","tags","summit")]
		## Fix colnames
		colnames(output)[7] <- "neg10xlog10pvalue"
		## Sort the result according to the -10xlog10(pvalue)
		output <- output[ order(output[,5], decreasing=TRUE), ]
		return(output)
	}
}

## Read in the results for the TRUE peaks
results_TRUE <- parseMACSResultsPOS (name="results",final=TRUE)

## Read in the results for the FALSE, or NEGATIVE, peaks
results_FALSE <- parseMACSResultsNEG (name="results", final=TRUE)


# Read summary info of results
# analysis_summary <- readLines ("results.log",n=11)
# write.table(file="analysis-summary.txt", unlist(analysis_summary), sep="", row.names=F, quote=F)

# Write the results to tables to be read into Chipster but first order the rows to physical location
results_TRUE$chr <- sub(".fa", "", results_TRUE$chr)
results_TRUE$chr <- sub("chr", "", results_TRUE$chr)
results_TRUE_ordered <- results_TRUE[order(results_TRUE$chr, results_TRUE$start),]
write.table(results_TRUE_ordered, file="positive-peaks.tsv", sep="\t", quote=FALSE, row.names=FALSE)
if (control.available == "yes") {
	results_FALSE$chr <- sub(".fa", "", results_FALSE$chr)
	results_FALSE$chr <- sub("chr", "", results_FALSE$chr)
	results_FALSE_ordered <- results_FALSE[order(results_FALSE$chr, results_FALSE$start),]
	write.table(results_FALSE_ordered, file="negative-peaks.tsv", sep="\t", quote=FALSE, row.names=FALSE)
}

# Convert the name of some files to make it compatible with chipster output
system("mv results.log analysis-log.txt")
#system ("mv results_peaks.bed positive-peaks.bed")

# Sort the BED
source(file.path(chipster.common.path, "bed-utils.R"))
#if (system("cat results_peaks.bed | wc -l") > 1){	
if (file.exists("results_peaks.bed")){
	bed <- read.table(file="results_peaks.bed", skip=0, sep="\t")
	colnames(bed)[1:2] <- c("chr", "start")
	sorted.bed <- sort.bed(bed)
	write.table(sorted.bed, file="positive-peaks.bed", sep="\t", row.names=F, col.names=F, quote=F)
}


# Source the R code for plotting the MACS model and convert the PDF file to PNG
if (build.model == "yes") {
	source("results_model.r")
	system("mv results_model.pdf model-plot.pdf")
}

# TOOL samtools-sort-index-BAM.R: "Sort and index BAM" (Sorts BAM by chromosomal location and builds an index for it. This tool is based on the SAMtools package.)
# INPUT alignment.bam: "BAM file to sort and index" TYPE GENERIC 
# OUTPUT alignment-sorted.bam 
# OUTPUT alignment-sorted.bam.bai 

# EK 10.1.2012

# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

# sort bam
system(paste(samtools.binary, "sort alignment.bam alignment-sorted"))

# index bam
system(paste(samtools.binary, "index alignment-sorted.bam"))

# TOOL convert-bam-to-medips.R: "Convert BAM file to MEDIPS input format" (Converts a BAM file to the MEDIPS input format.)
# INPUT bam{...}.bam: "BAM data diles" TYPE GENERIC 
# OUTPUT MEDIPS-input{...}.tsv: "A converted BAM file suitable for MEDIPS analysis" 
# OUTPUT META phenodata.tsv: "Phenodata file needed for MEDIPS analysis" 

# Reads the input files, converts them to the MEDIPS format, and writes the converted files on the disk
library(Rsamtools)
files<-dir(pattern=".bam")
outfiles<-paste("MEDIPS-input", 1:length(files), ".tsv", sep="")
for(i in 1:length(files)) {
   aln<-readBamGappedAlignments(files[i])
   toMEDIPS<-data.frame(rep(rname(aln)@values, rname(aln)@lengths), start(aln), end(aln), rep(strand(aln)@values, strand(aln)@lengths))
   write.table(toMEDIPS, outfiles[i], col.names=F, row.names=F, quote=F, sep="\t")
   rm(aln, toMEDIPS)
   gc()
}

# Writes out a phenodata table
sample<-outfiles
group<-rep("", length(files))
chiptype<-rep("MeDIP", length(files))
write.table(data.frame(sample=sample, chiptype=chiptype, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# TOOL samtools-snp-indel-multiple.R: "Call SNPs and short INDELs for multiple diploid individuals" (Call SNPs and short INDELs for multiple diploid individuals. You can provide your own reference sequence in FASTA format or choose one of the provided reference genomes. This tool is based on the SAMtools package.)
# INPUT alignment{...}.bam: "Sorted BAM file" TYPE BAM 
# INPUT OPTIONAL ownref.fa: "Reference sequence FASTA" TYPE FASTA
# OUTPUT var.flt.vcf
# PARAMETER ref: "Reference sequence" TYPE [hg19.fa: "Human (hg19\)", mm9.fa: "Mouse (mm9\)", rn4.fa: "Rat (rn4\)", e_coli.fa: "E. coli"] DEFAULT hg19.fa (Reference sequence)
# PARAMETER chr: "Chromosome names in my BAM file look like" TYPE [yes: "chr1", no: "1"] DEFAULT no (Chromosome names must match in the BAM file and in the reference sequence. Check your BAM and choose accordingly. This only applies to provided reference genomes.)
# PARAMETER p: "Call indels only from platform" TYPE [CAPILLARY, HELICOS, IONTORRENT, ILLUMINA, IONTORRENT, LS454, PACBIO, SOLID] DEFAULT ILLUMINA (Platform/technology used to produce the reads.)
# PARAMETER c: "Downgrading coefficient" TYPE INTEGER DEFAULT 0 (Coefficient for downgrading mapping quality for reads containing excessive mismatches. Given a read with a phred-scaled probability q of being generated from the mapped position, the new mapping quality is about sqrt( (INT-q\)\/INT\)\*INT. A zero value disables this functionality. If enabled, the recommended value for BWA is 50.)
# PARAMETER d: "Maximum read depth" TYPE INTEGER DEFAULT 2000 (Maximum read depth. Should be adjusted to about twice the average read depth.)

# AMS 15.6.2012

# binaries
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))
bcftools.binary <- c(file.path(chipster.tools.path, "samtools", "bcftools", "bcftools"))
vcfutils.binary <- c(file.path(chipster.tools.path, "samtools", "bcftools", "vcfutils.pl"))

# path to internal reference sequences
path.refseqs <- c(file.path(chipster.tools.path, "bowtie", "indexes"))

# check which reference sequence to use: own/internal
ref.seq <- ""
input_files <- dir()
is_own <- (length(grep("ownref.fa", input_files))>0)
if (is_own) {
	ref.seq <- paste("ownref.fa")	
} else {
	if (chr == "yes"){
		ref.seq <- c(file.path(path.refseqs, ref))
	}else{
		ref.seq <- c(file.path(path.refseqs, "nochr", ref))
	}
}


# commands
command1 <- paste(samtools.binary, "mpileup", "-P", p, "-ugf", ref.seq, "*.bam", "-C", c, "|", bcftools.binary, "view -bvcg - > var.raw.bcf")
command2 <- paste(bcftools.binary, "view var.raw.bcf |", vcfutils.binary, "varFilter -D", d, "> var.flt.vcf")

# run
#stop(paste('CHIPSTER-NOTE: ', command1))
system(command1)
system(command2)

# TOOL mothur-classifyseqs.R: "Classify sequences to taxonomic units with Mothur" (Classify 16S rRNA sequences to taxonomic units using the Wang method with Silva reference set and taxonomy. This tool is based on the Mothur package.)
# INPUT a.fasta: "FASTA file" TYPE FASTA
# OUTPUT reads-taxonomy-assignment.txt
# OUTPUT classification-summary.txt


# EK 18.06.2013

# binary
binary <- c(file.path(chipster.tools.path, "mothur", "mothur"))
data.path <- c(file.path(chipster.tools.path, "mothur-data"))
template.path <- c(file.path(data.path, "silva.bacteria.fasta"))
taxonomy.path <- c(file.path(data.path, "silva.bacteria.silva.tax"))

# batch file
write(paste("classify.seqs(fasta=a.fasta, iters=1000, template=", template.path, ", taxonomy=", taxonomy.path, ")", sep=""), "batch.mth", append=F)

# command
command <- paste(binary, "batch.mth", "> log.txt 2>&1")

# run
system(command)

# Post process output
system("mv a.silva.wang.taxonomy reads-taxonomy-assignment.txt")
system("mv a.silva.wang.tax.summary classification-summary.txt")

# TOOL acgh-count-overlapping-cnvs.R: "Count overlapping CNVs" (Counts overlapping CNVs from the database of genomic variants.)
# INPUT normalized.tsv: normalized.tsv TYPE GENERIC 
# OUTPUT cnvs.tsv: cnvs.tsv 
# PARAMETER genome.build: genome.build TYPE [GRCh37: GRCh37, NCBI36: NCBI36, NCBI35: NCBI35] DEFAULT GRCh37 (The genome build to use. GRCh37 = hg19, NCBI36 = hg18, NCBI35 = hg17, NCBI34 = hg16.)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-10-12

file <- 'normalized.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, as.is=TRUE, check.names=FALSE)

pos <- c('chromosome','start','end')
if (length(setdiff(pos, colnames(dat)))!=0)
  stop('CHIPSTER-NOTE: This script can only be run on files that have the following columns: chromosome, start, end.')

dat$chromosome <- factor(dat$chromosome, levels=c(1:22, 'X', 'Y', 'MT'), ordered=TRUE)

first.data.col <- max(0, min(grep('chip', names(dat)), grep('flag', names(dat))))

if (first.data.col > 0) {
  dat2 <- dat[1:first.data.col-1]
} else {
  dat2 <- dat
}

# load cnvs
if (genome.build=='NCBI35') {
  # cnv <- read.table('http://projects.tcag.ca/variation/downloads/variation.hg17.v10.nov.2010.txt', header=TRUE, sep='\t', as.is=TRUE)
  cnv <- read.table(file.path(chipster.tools.path, 'DGV', 'variation.hg17.v10.nov.2010.txt'), header=TRUE, sep='\t', as.is=TRUE)
} else if (genome.build=='NCBI36') {
  # cnv <- read.table('http://projects.tcag.ca/variation/downloads/variation.hg18.v10.nov.2010.txt', header=TRUE, sep='\t', as.is=TRUE)
  cnv <- read.table(file.path(chipster.tools.path, 'DGV', 'variation.hg18.v10.nov.2010.txt'), header=TRUE, sep='\t', as.is=TRUE)
} else {
  # cnv <- read.table('http://projects.tcag.ca/variation/downloads/variation.hg19.v10.nov.2010.txt', header=TRUE, sep='\t', as.is=TRUE)
  cnv <- read.table(file.path(chipster.tools.path, 'DGV', 'variation.hg19.v10.nov.2010.txt'), header=TRUE, sep='\t', as.is=TRUE)
}
cnv <- cnv[cnv$VariationType == 'CopyNumber',]
cnv$Chr <- factor(substr(cnv$Chr, 4, 5), levels=c(1:22, 'X', 'Y', 'MT'), ordered=TRUE)

cnv <- cnv[order(cnv$Chr, cnv$Start, cnv$End), c('Chr', 'Start', 'End')]
joined <- data.frame()
prev <- cnv[1,]
for (i in 2:nrow(cnv)) {
  if (cnv[i, 'Chr'] != prev$Chr || cnv[i, 'Start'] > (prev$End + 1)) {
    joined <- rbind(joined, prev)
    prev <- cnv[i,]
  } else
    prev$End <- max(prev$End, cnv[i, 'End'])
}
joined <- rbind(joined, prev)

cnv.counter <- function(x) {
  chr <- x['chromosome']
  start <- as.integer(x['start'])
  end <- as.integer(x['end'])

  count <- nrow(cnv[cnv$Chr   == chr &
                    cnv$Start <= end &
                    cnv$End   >= start,])
  overlaps <- joined[joined$Chr   == chr &
                     joined$Start <= end &
                     joined$End   >= start,]
  bases <- 0
  for (j in rownames(overlaps))
    bases <- bases + min(end, overlaps[j, 'End']) - max(start, overlaps[j, 'Start']) + 1
  c(count, round(bases / (end - start + 1), digits=3))
}

# first try parallel computing
prob <- TRUE
try({
  library(snowfall)
  sfInit(parallel=TRUE, cpus=4)
  sfExport(list=c('cnv', 'joined'))
  dat2[,c('cnv.count', 'cnv.proportion')] <- t(sfApply(dat2, 1, cnv.counter))
  sfStop()
  prob <- FALSE
}, silent=TRUE)
# if problems, fall back to sequential computing
if (prob)
  dat2[,c('cnv.count', 'cnv.proportion')] <- t(apply(dat2, 1, cnv.counter))

if (first.data.col > 0)
  dat2 <- cbind(dat2, dat[,first.data.col:ncol(dat)])

options(scipen=10)
write.table(dat2, file='cnvs.tsv', quote=FALSE, sep='\t', col.names=TRUE, row.names=TRUE)

# EOF

# TOOL bwa-paired-end-with-index-building.R: "BWA for paired-end reads and own genome" (BWA aligns reads to genomes and transcriptomes. Results are sorted and indexed bam files, which are ready for viewing in the Chipster genome browser. 
# Note that this BWA tool requires that you have imported the reference genome to Chipster in fasta format. If you would like to align reads against publicly available genomes, please use the tool \"BWA for paired-end reads\".)
# INPUT reads1.txt: "Paired-end read set 1 to align" TYPE GENERIC 
# INPUT reads2.txt: "Paired-end read set 2 to align" TYPE GENERIC 
# INPUT genome.txt: "Reference genome" TYPE GENERIC
# OUTPUT bwa.bam 
# OUTPUT bwa.bam.bai 
# OUTPUT bwa.log 
# PARAMETER seed.length: "Seed length" TYPE INTEGER DEFAULT 32 (Number of first nucleotides to be used as a seed. If the seed length is longer than query sequences, then seeding will be disabled. Corresponds to the command line parameter -l) 
# PARAMETER seed.edit:"Maximum of differences in the seed" TYPE INTEGER DEFAULT 2 (Maximum differences in the seed. Corresponds to the command line parameter -k )
# PARAMETER total.edit: "Maximum edit distance for the whole read" TYPE DECIMAL DEFAULT 0.04 ( Maximum edit distance if the value is more than one. If the value is between 1 and 0 then it defines the fraction of missing alignments given 2% uniform base error rate. In the latter case, the maximum edit distance is automatically chosen for different read lengths. Corresponds to the command line parameter -n.)
# PARAMETER quality.format: "Quality value format used" TYPE [solexa1_3: "Illumina GA v1.3 or later", sanger: Sanger] DEFAULT sanger (Note that this parameter is taken into account only if you chose to apply the mismatch limit to the seed region. Are the quality values in the Sanger format (ASCII characters equal to the Phred quality plus 33\) or in the Illumina Genome Analyzer Pipeline v1.3 or later format (ASCII characters equal to the Phred quality plus 64\)? Please see the manual for details. Corresponds to the command line parameter -I.)
# PARAMETER OPTIONAL num.gaps: "Maximum number of gap openings" TYPE INTEGER DEFAULT 1 (Maximum number of gap openings for one read. Corresponds to the command line parameter -o.)
# PARAMETER OPTIONAL num.extensions: "Maximum number of gap extensions" TYPE INTEGER DEFAULT -1 (Maximum number of gap extensions, -1 for disabling long gaps. Corresponds to the command line parameter -e.)
# PARAMETER OPTIONAL gap.opening: "Gap open penalty " TYPE INTEGER DEFAULT 11 (Gap opening penalty. Corresponds to the command line parameter -O.)
# PARAMETER OPTIONAL gap.extension: "Gap extension penalty " TYPE INTEGER DEFAULT 4 (Gap extension penalty. Corresponds to the command line parameter -E.)
# PARAMETER OPTIONAL mismatch.penalty: "Mismatch penalty threshold" TYPE INTEGER DEFAULT 3 (BWA will not search for suboptimal hits with a score lower than defined. Corresponds to the command line parameter -M.)
# PARAMETER OPTIONAL disallow.gaps: "Disallow gaps in region"  TYPE INTEGER DEFAULT 16 (Disallow a long deletion within the given number of bp towards the 3\’-end. Corresponds to the command line parameter -d.)
# PARAMETER OPTIONAL disallow.indel: "Disallow an indel within the given number of pb towards the ends"  TYPE INTEGER DEFAULT 5 (Do not put an indel within the defined value of bp towards the ends. Corresponds to the command line parameter -i.)
# PARAMETER OPTIONAL trim.threshold: "Quality trimming threshold" TYPE INTEGER DEFAULT 0 (Quality threshold for read trimming down to 35bp. Corresponds to the command line parameter -q.)
# PARAMETER OPTIONAL barcode.length: "Barcode length"  TYPE INTEGER DEFAULT 0 (Length of barcode starting from the 5 pime-end. The barcode of each read will be trimmed before mapping. Corresponds to the command line parameter -B.)
# PARAMETER OPTIONAL alignment.no: "Maximum hits to output for paired reads" TYPE INTEGER DEFAULT 3 (Maximum number of alignments to output in the XA tag for reads paired properly. If a read has more than the given amount of hits, the XA tag will not be written. Corresponds to the command line parameter bwa sampe -n.)
# PARAMETER OPTIONAL max.discordant: "Maximum hits to output for discordant pairs" TYPE INTEGER DEFAULT 10 (Maximum number of alignments to output in the XA tag for disconcordant read pairs, excluding singletons. If a read has more than INT hits, the XA tag will not be written. Corresponds to the command line parameter bwa sampe -N.) 
# PARAMETER OPTIONAL max.insert: "Maximum insert size" TYPE INTEGER DEFAULT 500 (Maximum insert size for a read pair to be considered being mapped properly. This option is only used when there are not enough good alignments to infer the distribution of insert sizes. Corresponds to the command line parameter bwa sampe -a.)
# PARAMETER OPTIONAL max.occurrence: "Maximum occurrences for one end" TYPE INTEGER DEFAULT 100000 (Maximum occurrences of a read for pairing. A read with more occurrneces will be treated as a single-end read. Reducing this parameter helps faster pairing. The default value is 100000. For reads shorter than 30bp, applying a smaller value is recommended to get a sensible speed at the cost of pairing accuracy. Corresponds to the command line parameter bwa sampe -o.)

# KM 26.8.2011
# AMS 19.6.2012 Added unzipping

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads1.txt")
unzipIfGZipFile("reads2.txt")
unzipIfGZipFile("genome.txt")

##
# bwa settings
##
bwa.binary <- file.path(chipster.tools.path, "bwa", "bwa")

# bwa settings
bwa.binary <- file.path(chipster.tools.path, "bwa", "bwa")
bwa.index.binary <- file.path(chipster.tools.path, "bwa", "check_bwa_index.sh")
command.start <- paste("bash -c '", bwa.binary)

# Do indexing
print("Indexing the genome...")
system("echo Indexing the genome... > bwa.log")
check.command <- paste ( bwa.index.binary, "genome.txt| tail -1 ")
genome.dir <- system(check.command, intern = TRUE)
bwa.genome <- file.path( genome.dir , "genome.txt")


###
# common parameters for bwa runs
###
# mode specific parameters
if (total.edit >= 1) {
	total.edit <- round(total.edit)
}
command.start <- paste("bash -c '", bwa.binary)
quality.parameter <- ifelse(quality.format == "solexa1_3", "-I", "")
mode.parameters <- paste("aln -t 2 -o", num.gaps, "-e", num.extensions, "-d", disallow.gaps, "-i" , disallow.indel , "-l" , seed.length , "-k" , seed.edit , "-O" , gap.opening , "-E" , gap.extension , "-q" , trim.threshold, "-B" , barcode.length , "-M" , mismatch.penalty , "-n" , total.edit , quality.parameter)

###
# run the first set
###
echo.command <- paste("echo '", bwa.binary , mode.parameters, bwa.genome, "reads1.txt ' > bwa.log" )
#stop(paste('CHIPSTER-NOTE: ', bwa.command))
system(echo.command)
command.end <- paste(bwa.genome, "reads1.txt 1> alignment1.sai 2>> bwa.log'")
bwa.command <- paste(command.start, mode.parameters, command.end)
#stop(paste('CHIPSTER-NOTE: ', bwa.command))
system(bwa.command)


###
# run the second set
###
echo.command <- paste("echo '", bwa.binary , mode.parameters, bwa.genome, "reads2.txt ' >> bwa.log" )
#stop(paste('CHIPSTER-NOTE: ', bwa.command))
system(echo.command)
command.end <- paste(bwa.genome, "reads2.txt 1> alignment2.sai 2>> bwa.log'")
bwa.command <- paste(command.start, mode.parameters, command.end)
#stop(paste('CHIPSTER-NOTE: ', bwa.command))
system(bwa.command)

###
# sai to sam conversion
###
sampe.parameters <- paste("sampe -n", alignment.no, "-a", max.insert, "-o" , max.occurrence , "-N" , max.discordant )
sampe.end <- paste(bwa.genome, "alignment1.sai alignment2.sai reads1.txt reads1.txt 1> alignment.sam 2>>bwa.log'" )
sampe.command <- paste( command.start, sampe.parameters , sampe.end )
system(sampe.command)

		
# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

# convert sam to bam
system(paste(samtools.binary, "view -bS alignment.sam -o alignment.bam"))

# sort bam
system(paste(samtools.binary, "sort alignment.bam alignment.sorted"))

# index bam
system(paste(samtools.binary, "index alignment.sorted.bam"))

# rename result files
system("mv alignment.sorted.bam bwa.bam")
system("mv alignment.sorted.bam.bai bwa.bam.bai")

# TOOL samtools-convert-SAMtoBAM-sort-index.R: "Convert SAM to BAM, sort and index" (Converts SAM file to BAM, sorts it by chromosomal location, and builds an index for it. This tool is based on the SAMtools package.)
# INPUT alignment.sam: "SAM file to convert" TYPE GENERIC 
# OUTPUT alignment.bam 
# OUTPUT alignment.bam.bai 

# EK 10.1.2012

# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

# convert sam to bam
system(paste(samtools.binary, "view -bS alignment.sam -o alignmentUnsorted.bam"))

# sort bam
system(paste(samtools.binary, "sort alignmentUnsorted.bam alignment"))

# index bam
system(paste(samtools.binary, "index alignment.bam"))

# TOOL annotate-variant.R: "Annotate variants" (Annotate variants listed in a VCF file using the Bioconductor package VariantAnnotation. Coding, UTR, intronic and promoter variants are annotated, intergenic variants are ignored.)
# INPUT input.vcf: "Sorted or unsorted VCF file" TYPE GENERIC
# OUTPUT all-variants.tsv
# OUTPUT coding-variants.tsv
# PARAMETER genome: "Genome" TYPE [hg19: "Human (hg19\)"] DEFAULT hg19 (Reference sequence)


# 31.8.2012 JTT
# 15.11.2012 Uses VariantAnnotation package 1.4.3. JTT,EK 

#input.vcf<-system.file("extdata", "chr22.vcf.gz", package="VariantAnnotation")
#input.vcf<-"var.flt2.vcf"
#genome<-"hg19"
#setwd("C:/Users/Jarno Tuimala/Desktop/c")


# Read data
library(VariantAnnotation)
vcf<-readVcf("input.vcf", genome)

# Correct the chromosome names 
#vcf@rowData@seqnames@values
newnames<-c("1"="chr1", "2"="chr2", "3"="chr3", "4"="chr4", "5"="chr5", "6"="chr6", "7"="chr7", "8"="chr8", "9"="chr9", "10"="chr10",
                                     "11"="chr11", "12"="chr12", "13"="chr13", "14"="chr14", "15"="chr15", "16"="chr16", "17"="chr17", "18"="chr18", "19"="chr19", "20"="chr20",
                                     "21"="chr21", "22"="chr22", "Y"="chrY", "X"="chrX")
if(length(grep("chr", vcf@rowData@seqnames@values))>=1) {
   vcf2<-vcf
   rd<-rowData(vcf)
} else {
   #vcf@rowData@seqnames@values<-paste("chr", vcf@rowData@seqnames@values, sep="")
   if(genome=="hg19") {
      vcf2 <- renameSeqlevels(vcf, newnames)
      rd<-rowData(vcf)
      rd2  <- renameSeqlevels(rd, newnames)
   }
}

# Exon isoform database
library("TxDb.Hsapiens.UCSC.hg19.knownGene")
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene

# Locate coding variant
# loc <- locateVariants(rd, txdb, CodingVariants())

# Locate splicing variants
# spl<-locateVariants(rd, txdb, SpliceSiteVariants())

# Locate all variants
codvar <- locateVariants(vcf2, txdb, CodingVariants())
intvar <- locateVariants(vcf2, txdb, IntronVariants())
utr5var <- locateVariants(vcf2, txdb, FiveUTRVariants())
utr3var <- locateVariants(vcf2, txdb, ThreeUTRVariants())
#intgvar <- locateVariants(vcf2, txdb, IntergenicVariants())
spsgvar <- locateVariants(vcf2, txdb, SpliceSiteVariants())
promvar <- locateVariants(vcf2, txdb, PromoterVariants())
allvar<-c(codvar, intvar, utr5var, utr3var, spsgvar, promvar)
#rd<-rowData(vcf2)
#allvar <- locateVariants(rd, txdb, AllVariants())
allvar2<-as.data.frame(allvar)
colnames(allvar2)<-toupper(colnames(allvar2))

# Get gene annotations from EntrezIDs
ig<-allvar2[!is.na(allvar2$GENEID),]
nig<-allvar2[is.na(allvar2$GENEID),]
library(org.Hs.eg.db)
symbol <- select(org.Hs.eg.db, keys=unique(ig[ig$LOCATION=="coding",]$GENEID), keytype="ENTREZID", cols="SYMBOL")
genename <- select(org.Hs.eg.db, keys=unique(ig[ig$LOCATION=="coding",]$GENEID), keytype="ENTREZID", cols="GENENAME")
ensg <- select(org.Hs.eg.db, keys=unique(ig[ig$LOCATION=="coding",]$GENEID), keytype="ENTREZID", cols="ENSEMBL")
ig2<-merge(ig, symbol, by.x="GENEID", by.y="ENTREZID", all.x=TRUE)
ig3<-merge(ig2, genename, by.x="GENEID", by.y="ENTREZID", all.x=TRUE)
ig4<-merge(ig3, ensg, by.x="GENEID", by.y="ENTREZID", all.x=TRUE)
nig$SYMBOL<-rep(NA, nrow(nig))
nig$GENENAME<-rep(NA, nrow(nig))
nig$ENSEMBL<-rep(NA, nrow(nig))
allvar3<-rbind(ig4, nig)

# Predict coding amino acid changes
library(BSgenome.Hsapiens.UCSC.hg19)
coding <- predictCoding(vcf2, txdb, seqSource=Hsapiens)
cod<-elementMetadata(coding)
cod2<-as.list(cod)
names(cod2)<-toupper(names(cod2))
#cod3<-data.frame(cod2$GENEID, cod2$CDSID, cod2$TXID, cod2$CONSEQUENCE, as.data.frame(cod2$PROTEINLOC), as.data.frame(cod2$CDSLOC)[1], as.data.frame(cod2$CDSLOC)[2], as.data.frame(cod2$CDSLOC)[3], as.data.frame(cod2$varAllele), as.data.frame(cod2$REFCODON), as.data.frame(cod2$VARCODON))
cod3<-data.frame(geneID=cod2$GENEID, cdsID=cod2$CDSID, txID=cod2$TXID, consequence=cod2$CONSEQUENCE, cdsStart=as.data.frame(cod2$CDSLOC)[,1], cdsEnd=as.data.frame(cod2$CDSLOC)[,2], width=as.data.frame(cod2$CDSLOC)[,3], varAllele=as.data.frame(cod2$VARALLELE)[,1], refCodon=as.data.frame(cod2$REFCODON)[,1], varCodon=as.data.frame(cod2$VARCODON)[,1], refAA=as.data.frame(cod2$REFAA)[,1], varAA=as.data.frame(cod2$VARAA)[,1])
symbol <- select(org.Hs.eg.db, keys=unique(cod3$geneID), keytype="ENTREZID", cols="SYMBOL")
genename <- select(org.Hs.eg.db, keys=unique(cod3$geneID), keytype="ENTREZID", cols="GENENAME")
ensg <- select(org.Hs.eg.db, keys=unique(cod3$geneID), keytype="ENTREZID", cols="ENSEMBL")
cod32<-merge(cod3, symbol, by.x="geneID", by.y="ENTREZID", all.x=TRUE)
cod33<-merge(cod32, genename, by.x="geneID", by.y="ENTREZID", all.x=TRUE)
cod34<-merge(cod33, ensg, by.x="geneID", by.y="ENTREZID", all.x=TRUE)

# Write results to disk
write.table(allvar3, "all-variants.tsv", col.names=T, row.names=F, sep="\t", quote=FALSE)
write.table(cod34, "coding-variants.tsv", col.names=T, row.names=F, sep="\t", quote=FALSE)

# TOOL bedtools-subtractbed.R: "Subtract BED" (Removes the portion(s\) of an interval that is overlapped by another feature(s\). This tool is based on the BEDTools package.)
# INPUT file.a: "Input file A" TYPE GENERIC
# INPUT file.b: "Input file B" TYPE GENERIC
# OUTPUT subtractbed.bed 
# PARAMETER OPTIONAL f: "Minimum overlap required as a fraction of A" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.000000001 (Minimum overlap required as a fraction of A. Default is 1E-9 (effectively 1bp\))
# PARAMETER OPTIONAL s: "Force strandedness" TYPE [yes, no] DEFAULT no (Only report hits in B that overlap A on the same strand. By default, overlaps are reported without respect to strand.)

# AMS 23.4.2012

# binary
binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "subtractBed"))

# options
options <- paste("")
options <- paste(options, "-f", f)
if (s == "yes") {options <- paste(options, "-s")}


# input files
options <- paste(options, "-a file.a -b file.b")

# command
command <- paste(binary, options, "> subtractbed.bed")

# run
system(command)
if (file.info("subtractbed.bed")$size == 0) {system("echo \"No results found\" > subtractbed.bed")}

# TOOL acgh-call-aberrations.R: "Call aberrations from segmented copy number data" (Call copy number aberrations from aCGH log ratios or NGS data.)
# INPUT segmented.tsv: segmented.tsv TYPE GENE_EXPRS
# OUTPUT aberrations.tsv: aberrations.tsv
# OUTPUT aberration-frequencies.pdf: aberration-frequencies.pdf
# PARAMETER number.of.copy.number.states: "number of copy number states" TYPE [3: 3, 4: 4] DEFAULT 3 (Three states means calling loss vs. normal vs. gain, four states calls amplifications separately, and five also homozygous deletions.)
# PARAMETER organism: organism TYPE [human: human, other: other] DEFAULT human (Organism.)
# PARAMETER genome.build: "genome build" TYPE [GRCh37: GRCh37, NCBI36: NCBI36, NCBI35: NCBI35, NCBI34: NCBI34] DEFAULT GRCh37 (The genome build to use. GRCh37 = hg19, NCBI36 = hg18, NCBI35 = hg17, NCBI34 = hg16. Not used unless organism is set to human.)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2013-04-12

source(file.path(chipster.common.path, 'CGHcallPlus.R'))

file <- 'segmented.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, as.is=TRUE, check.names=FALSE)

if (length(grep("^segmented\\.", names(dat))) == 0)
  stop('CHIPSTER-NOTE: This tool needs segmented input, so please first run the tool Segment copy number data.')

dat$chromosome[dat$chromosome=='X'] <- '23'
dat$chromosome[dat$chromosome=='Y'] <- '24'
dat$chromosome[dat$chromosome=='MT'] <- '25'
dat$chromosome <- as.integer(dat$chromosome)

logratios <- as.matrix(dat[,grep("^chip\\.", names(dat))])
segmented <- as.matrix(dat[,grep("^segmented\\.", names(dat))])

logratios[logratios==-Inf] <- -10
segmented[segmented==-Inf] <- -10

cgh.seg <- new('cghSeg', assayData=assayDataNew(copynumber=logratios, segmented=segmented), featureData=new('AnnotatedDataFrame', data=data.frame(Chromosome=dat$chromosome, Start=dat$start, End=dat$end, row.names=row.names(dat))))

remove <- rowSums(is.na(logratios)) + rowSums(is.na(segmented))
cgh.seg <- cgh.seg[remove == 0,]
cgh.seg <- cgh.seg[chromosomes(cgh.seg) < 24,]

# identify different matrices (chip, flag, ...) present in the data
x <- colnames(dat)
suffix <- sub('^chip\\.', '', x[grep('^chip\\.', x)[1]])
matrices <- sub(suffix, '', x[grep(suffix, x)])
annotations <- 1:length(x)
for (m in matrices) {
  annotations <- setdiff(annotations, grep(m, x))
}

dat3 <- dat[featureNames(cgh.seg), annotations]

chips <- colnames(dat)[grep("^chip\\.", names(dat))]

# clean up to save memory
rm(file, dat, logratios, segmented, remove, x, suffix, matrices, annotations, m)
gc()

cgh.psn <- postsegnormalize(cgh.seg)

rm(cgh.seg)
gc()

cgh.cal <- CGHcall(cgh.psn, nclass=as.integer(number.of.copy.number.states), organism=organism, build=genome.build, ncpus=4)
cgh <- ExpandCGHcall(cgh.cal, cgh.psn)

rm(cgh.psn, cgh.cal)
gc()

#dat3 <- fData(cgh)
#colnames(dat3) <- c('chromosome', 'start', 'end')
#dat3 <- dat3[featureNames(cgh),]

#for (col in c('cytoband', 'symbol', 'description', 'cnvs'))
#  if (col %in% colnames(dat))
#    dat3[,col] <- dat[rownames(dat3), col]

calls <- calls(cgh)

if (-2 %in% calls)
  dat3$del.freq <- round(rowMeans(calls == -2), digits=3)
dat3$loss.freq <- round(rowMeans(calls == -1), digits=3)
dat3$gain.freq <- round(rowMeans(calls == 1), digits=3)
if (2 %in% calls)
  dat3$amp.freq <- round(rowMeans(calls == 2), digits=3)

cols <- colnames(dat3)

dat3 <- cbind(dat3, calls)
cols <- c(cols, sub('chip.', 'flag.', chips))
rm(calls)
gc()

dat3 <- cbind(dat3, copynumber(cgh))
cols <- c(cols, chips)
gc()

dat3 <- cbind(dat3, segmented(cgh))
cols <- c(cols, sub('chip.', 'segmented.', chips))
gc()

if (number.of.copy.number.states=='5') {
  dat3 <- cbind(dat3, probdloss(cgh))
  cols <- c(cols, sub('chip.', 'probdel.', chips))
  gc()
}

dat3 <- cbind(dat3, probloss(cgh))
cols <- c(cols, sub('chip.', 'probloss.', chips))
gc()

dat3 <- cbind(dat3, probnorm(cgh))
cols <- c(cols, sub('chip.', 'probnorm.', chips))
gc()

dat3 <- cbind(dat3, probgain(cgh))
cols <- c(cols, sub('chip.', 'probgain.', chips))
gc()

if (number.of.copy.number.states=='4') {
  dat3 <- cbind(dat3, probamp(cgh))
  cols <- c(cols, sub('chip.', 'probamp.', chips))
  gc()
}

colnames(dat3) <- cols

dat3$chromosome <- as.character(dat3$chromosome)
dat3$chromosome[dat3$chromosome=='23'] <- 'X'
dat3$chromosome[dat3$chromosome=='24'] <- 'Y'
dat3$chromosome[dat3$chromosome=='25'] <- 'MT'

options(scipen=10)
write.table(dat3, file='aberrations.tsv', quote=FALSE, sep='\t', col.names=TRUE, row.names=TRUE)

# bitmap(file='aberration-frequencies.png', width=image.width/72, height=image.height/72)
pdf(file='aberration-frequencies.pdf', paper='a4r', width=0, height=0)
frequencyPlot(cgh)
dev.off()

# EOF

# TOOL cluster-kmeans-testK.R: "K-Means - estimate K" (K-means clustering of genes. Divides the genes in the selected data set into a specified number of clusters. Tests a number of different Ks and gives back a report.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT kmeans-test.pdf: kmeans-test.pdf 
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the resampling image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the resampling image)


# K-means clustering
# JTT 6.6.2008

# Parameter settings (default) for testing purposes
#image.width<-600
#image.height<-600

# Renaming variables
w<-image.width
h<-image.height

# Loads the data file
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Calculates the K-means clustering result with a number of different K
kmax<-c(100)
if(nrow(dat2)<100) {
   kmax<-nrow(dat2)
}
km<-rep(NA, (kmax-1))
i<-c(2)
while(i<kmax) {
   km[i]<-sum(kmeans(dat2, i, iter.max=20000, nstart=10)$withinss)
   if(i>=3 & km[i-1]/km[i]<=1.01) {
      i<-kmax
   } else {
      i<-i+1
   }
}

# Plotting the clustering
pdf(file="kmeans-test.pdf", width=w/72, height=h/72)
plot(2:kmax, km, xlab="K", ylab="sum(withinss)", type="b", pch="+", main="Terminated when change less than 1%")
dev.off()

# TOOL data-throughput.R: DataThroughput (Send prefix + input back as output)
# INPUT input.dat: input.dat TYPE GENERIC 
# OUTPUT output.dat: output.dat 

input<-readLines("input.dat")
output<-paste("INPUT WAS:", input)
writeLines(output, "output.dat")

# TOOL extract-target-gene-expression.R: "Extract data for miRNA targets" (This tools provides a means of extracting the expression data for a set of target genes identified from an integrative analysis of miRNA and gene expression. Two files need to be selected,the result file from an integrative analysis and the file containing the gene expression data to be extracted.)
# INPUT normalized_gene.tsv: normalized_gene.tsv TYPE GENE_EXPRS 
# INPUT normalized_mirna.tsv: normalized_mirna.tsv TYPE GENERIC 
# INPUT phenodata_gene.tsv: phenodata_gene.tsv TYPE GENERIC 
# OUTPUT target-gene-expression.tsv: target-gene-expression.tsv 
# OUTPUT phenodata-target-gene.tsv: phenodata-target-gene.tsv 
# PARAMETER common.column: common.column TYPE STRING DEFAULT empty (The name of the column that is common to the data tables.)

# Setting up test parameter settings
# common.column <- "symbol"

# Loads the normalized data and phenodata files
data_1 <- read.table(file="normalized_mirna.tsv", header=T, sep="\t", row.names=1)
data_2 <- read.table(file="normalized_gene.tsv", header=T, sep="\t", row.names=1)
phenodata <- read.table("phenodata_gene.tsv", header=T, sep="\t")

# Figure out which is the miRNA data
if (length (grep ("miRNA", names (data_1))) == 1) {
	mirna.data <- data_1
	gene.data <- data_2
}
if (length (grep ("miRNA", names (data_2))) == 1) {
	mirna.data <- data_2
	gene.data <- data_1
}

# Extract the common columns from the input data and condense
# to unique values to get rid of multiple entries
attach(mirna.data)
mirna.symbols <- get(common.column)
mirna.symbols <- unique(mirna.symbols)
detach(mirna.data)
attach(gene.data)
gene.symbols <- get(common.column)
detach(gene.data)
gene.data.2 <- gene.data [match(mirna.symbols, gene.symbols, nomatch=0),]

# write files
write.table(gene.data.2, file='target-gene-expression.tsv', quote=FALSE, sep='\t', row.names=TRUE, col.names=TRUE)
write.table(phenodata, file='phenodata-target-gene.tsv', quote=FALSE, sep='\t', na='', row.names=FALSE, col.names=TRUE)

# EOF

# TOOL Test-multiple-file-output.R: "Takes a table of data, extracts the first 3 rows and returns them as individual 1-row tables" (Takes a table of data, extracts the first 3 rows and returns them as individual 1-row tables)
# INPUT table.tsv: "Data file" TYPE GENERIC 
# OUTPUT result-test-{...}.tsv: "testing multiple file output" 
# OUTPUT table_1.tsv: "also one at a time, first row" 
# OUTPUT table_2.tsv: "also one at a time, second row" 
# OUTPUT table_3.tsv: "also one at a time, thirs row" 

#####################################################
#                                                   #
# MG, 24.6.2010                                     #
#                                                   #
# For debugging purposes only                       #
#                                                   #
#####################################################

# Read in data and convert to BED format
data_table <- read.table (file="table.tsv", sep="\t", header=T, row.names=1)

# Extract the first three rows into individual variables
first_row <- data_table[1,]
second_row <- data_table[2,]
third_row <- data_table[3,]

# Create the multiple files output
write.table(first_row, "result-test-1.tsv", sep="\t", row.names=T, col.names=T, quote=F)
write.table(second_row, "result-test-2.tsv", sep="\t", row.names=T, col.names=T, quote=F)
write.table(third_row, "result-test-3.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# Create the individual files output
write.table(first_row, "table_1.tsv", sep="\t", row.names=T, col.names=T, quote=F)
write.table(second_row, "table_2.tsv", sep="\t", row.names=T, col.names=T, quote=F)
write.table(third_row, "table_3.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# The end

# TOOL filter-by-column-term.R: "Filter using a column term" (Allows the user to filter the genes on the basis of one column with textual terms, such as gene symbol, gene description or GO term.)
# INPUT normalized.tsv: normalized.tsv TYPE GENERIC 
# OUTPUT column-term-filter.tsv: column-term-filter.tsv 
# PARAMETER column: column TYPE COLUMN_SEL (Data column to filter by)
# PARAMETER match.term: match.term TYPE STRING DEFAULT empty (String to search for)
# PARAMETER exact.match: exact.match TYPE [yes: yes, no: no] DEFAULT yes (Should only exact matches be retained?)

# Tool that allows the data to be filtered according to text terms in a column
# MG 9.3.2010
# IS 1.11.2010, small fix to column matching
# JTT 30.3.2010, added a parameter to control matching
# modified, IS, 12.10.2012, to cope with tables with gene descriptions (that typically contain 's)

# Loads the normalized data
file <- 'normalized.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, check.names=FALSE)

# Only exact matches?
if(exact.match=="yes") {
	match.term<-paste("^", match.term, "$", sep="")
}

# grep the desired rows
dat2 <- dat[grep(match.term, dat[,column]),]

# write output
options(scipen=10)
write.table(dat2, 'column-term-filter.tsv', sep='\t', quote=FALSE)

# EOF

# TOOL import-soft2.R: "Import from GEO" (Import a data set directly from GEO. Be sure to specify the chiptype as an Affymetrix chip name, or either Illumina or cDNA.)
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# PARAMETER GDS.name: accession TYPE STRING DEFAULT GSE (GDS or GSE number of the experiment.)
# PARAMETER platform: platform TYPE STRING DEFAULT GPL (In case the series contains multiple platforms, specify the accession of the platform to import. If there is just one, this platform is ignored.)
# PARAMETER chiptype: "Affymetrix/Illumina chiptype" TYPE STRING DEFAULT other (If the microarray platform used is an Affymetrix one, the name of the Bioconductor annotation package. For Illumina arrays, fill in Illumina. For everything else, either cDNA or other.)

# 2013-03-18
# Ilari Scheinin <firstname.lastname@gmail.com>

# JTT 9.8.2007

# check for valid accession
GDS.name <- toupper(GDS.name)
if (length(grep('^(GDS|GSE|)[0-9]+$', GDS.name)) == 0)
  stop('CHIPSTER-NOTE: Not a valid accession: ', GDS.name)

if (chiptype=='other')
  chiptype <- 'cDNA'

# load data
library(GEOquery)

gds <- getGEO(GDS.name)
if (class(gds) == 'GDS') {
  eset <- GDS2eSet(gds)
} else if (length(gds) == 1) {
  eset <- gds[[1]]
} else {
  w <- grep(platform, names(gds))
  if (length(w) != 1)
    stop('CHIPSTER-NOTE: Please use the platform argument (currently set to "', platform, '") to specify which data set to load. Available data sets:\n', paste(names(gds), collapse='\n')) 
  eset <- gds[[w]]
}

# clean up phenodata
pdata <- pData(eset)
for (x in colnames(pdata))
  pdata[,x] <- gsub('"|\'|#|\t', '', pdata[,x])

# generate phenodata
if ('geo_accession' %in% colnames(pdata)) {
  sample <- pdata$geo_accession
} else if ('sample' %in% colnames(pdata)) {
  sample <- pdata$sample
} else {
  sample <- sprintf('microarray%.3i', 1:ncol(eset))
}
group <- rep('', length(sample))
phenodata <- data.frame(sample=sample, original_name=sample, chiptype=chiptype, group=group, description=sample, pdata)

dat <- data.frame(chromosome=NA, start=NA, end=NA, cytoband=NA, symbol=NA, description=NA, exprs(eset))
colnames(dat)[-(1:6)] <- paste('chip.', sample, sep='')

# annotation columns
plat <- eset@featureData@data
colnames(plat) <- toupper(colnames(plat))

# GDS
if ('Gene symbol' %in% colnames(plat))
  dat$symbol <- plat[, 'Gene symbol']
if ('Gene title' %in% colnames(plat))
  dat$description <- plat[, 'Gene title']

# Agilent
if ('CHROMOSOMAL_LOCATION' %in% colnames(plat)) {
  dat$chromosome <- gsub('chr|_random|_hla_hap1|_hla_hap2|:.*','', plat$CHROMOSOMAL_LOCATION)
  dat$start <- as.integer(gsub('.*:|-.*','', plat$CHROMOSOMAL_LOCATION))
  dat$end <- as.integer(gsub('.*-|','', plat$CHROMOSOMAL_LOCATION))
}
if (all(is.na(dat$chromosome)) && 'SYSTEMATICNAME' %in% colnames(plat)) {
  plat$SYSTEMATICNAME[grep('^.*:[0-9]*-[0-9]*$', plat$SYSTEMATICNAME, invert=TRUE)] <- ''
  dat$chromosome <- gsub('chr|_random|_hla_hap1|_hla_hap2|:.*','', plat$SYSTEMATICNAME)
  dat$start <- as.integer(gsub('.*:|-.*','', plat$SYSTEMATICNAME))
  dat$end <- as.integer(gsub('.*-|','', plat$SYSTEMATICNAME))
}
if (all(is.na(dat$cytoband)) && 'CYTOBAND' %in% colnames(plat))
  dat$cytoband <- gsub('hs\\|', '', plat$CYTOBAND)
if (all(is.na(dat$symbol)) && 'GENE_SYMBOL' %in% colnames(plat))
  dat$symbol <- plat$GENE_SYMBOL
if (all(is.na(dat$description)) && 'GENE_NAME' %in% colnames(plat))
  dat$description <- plat$GENE_NAME
if (all(is.na(dat$description)) && 'DESCRIPTION' %in% colnames(plat))
  dat$description <- plat$DESCRIPTION

# Nimblegen
if (all(is.na(dat$chromosome)) && 'CHROMOSOME' %in% colnames(plat))
  dat$chromosome <- plat$CHROMOSOME
if (all(is.na(dat$start)) && 'RANGE_START' %in% colnames(plat))
  dat$start <- as.integer(plat$RANGE_START)
if (all(is.na(dat$end)) && 'RANGE_END' %in% colnames(plat))
  dat$end <- as.integer(plat$RANGE_END)

# other
if (all(is.na(dat$chromosome)) && 'CHROMOSOME_NR' %in% colnames(plat))
  dat$chromosome <- plat$CHROMOSOME_NR
if (all(is.na(dat$start)) && 'START' %in% colnames(plat))
  dat$start <- as.integer(plat$START)
if (all(is.na(dat$start)) && 'POSITION' %in% colnames(plat))
  dat$start <- as.integer(plat$POSITION)
if (all(is.na(dat$start)) && 'KB POSITION' %in% colnames(plat))
  dat$start <- as.integer(plat$'KB POSITION') * 1000
if (all(is.na(dat$end)) && 'END' %in% colnames(plat))
  dat$end <- as.integer(plat$END)
if (all(is.na(dat$symbol)) && 'SYMBOL' %in% colnames(plat))
  dat$symbol <- plat$SYMBOL
if (all(is.na(dat$description)) && 'GENE_DESCRIPTION' %in% colnames(plat))
  dat$description <- plat$GENE_DESCRIPTION

# if missing, impute end column from start (assuming 60 bp probes)
if (all(is.na(dat$end)))
  dat$end <- dat$start + 60

# remove empty annotation columns and clean up
for (x in c('chromosome', 'start', 'end', 'cytoband', 'symbol', 'description')) {
  if (all(is.na(dat[,x]))) {
    dat[,x] <- NULL
  } else {
    dat[,x] <- gsub('"|\'|#|\t', '', dat[,x])
  }
}

# write output files
options(scipen=10)
write.table(dat, file='normalized.tsv', quote=FALSE, sep='\t')
write.table(phenodata, file='phenodata.tsv', quote=FALSE, sep='\t', row.names=FALSE)

# EOF

# TOOL filter-cv.R: "Filter by CV" (Filter genes by their coefficient of variation.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT cv-filter.tsv: cv-filter.tsv 
# PARAMETER percentage.to.filter.out: percentage.to.filter.out TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.5 (Percentage to filter out)


# JTT, 14.1.2008

# Parameter settings (default) for testing purposes
#percentage.to.filter.out<-c(0.5)

# Renaming variables
percentage<-percentage.to.filter.out

# Loading the libraries
library(genefilter)

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]
calls<-data.frame(calls)
dat2<-data.frame(dat2)

# Sanity checks
if(ncol(dat2)==1) {
   stop("You need to have at least two chips to apply filtering by genes!")
}

# Filter
colno<-ncol(dat2)
g.mean <- rowSums(dat2)/colno
g.sd <- rowSds(dat2)
g.cv <- g.sd / g.mean
sel<-(g.cv>quantile(g.cv,percentage,na.rm=TRUE))
set<-dat[sel, ]

# Saving the results
write.table(data.frame(set), file=("cv-filter.tsv"), sep="\t", row.names=T, col.names=T, quote=F)

# TOOL merge-fasta-qual.R: "Merge FASTA or QUAL files" (Merge two or more FASTA or QUAL files together. You should take care to only merge files of the same type.)
# INPUT file{...}.tmp: "Files to be merged" TYPE GENERIC
# OUTPUT OPTIONAL merged.fasta
# OUTPUT OPTIONAL merged.qual
# PARAMETER type: "File type" TYPE [FASTA, QUAL] DEFAULT FASTA (Type of files to be merged.)

# AMS 19.06.2013

if (type == "FASTA"){
	system("cat *.tmp > merged.fasta")
}
if (type == "QUAL"){
	system("cat *.tmp > merged.qual")
}

# TOOL cna-correct.R: "Correct for GC content" (This tool corrects NGS data for GC content for copy number analysis.)
# INPUT cna-data-table.tsv: "Data table with log-transformed read counts" TYPE GENE_EXPRS
# OUTPUT corrected-cna-data-table.tsv: "Data table with log-transformed read counts corrected for GC content"
# PARAMETER span: "degree of smoothing" TYPE DECIMAL DEFAULT 0.65 (The alpha/span parameter for the degree of smoothing, controls the neighboorhood used for the fitting. For alpha < 1, the neighbourhood includes proportion alpha of the points, and these have tricubic weighting. For alpha > 1, all points are used, with the ‘maximum distance’ assumed to be alpha^1/2.)
# PARAMETER family: family TYPE [gaussian: gaussian, symmetric: symmetric] DEFAULT gaussian (Family used for the fitting. For gaussian, fittins is done by weighted least squares. For symmetric, a few iterations of an M-estimation procedure with Tukey's biweight are used.)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2013-03-20

file <- 'cna-data-table.tsv'
input <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, as.is=TRUE, check.names=FALSE)

bins <- input[,-grep("^chip\\.", colnames(input))]
counts <- as.matrix(input[,grep("^chip\\.", colnames(input))])
if (ncol(counts) == 1)
  colnames(counts) <- grep("^chip\\.", colnames(input), value=TRUE)
counts <- 2^counts - 1
dat <- list(bins=bins, counts=counts)

correct <- function(dat, family='gaussian', span=0.35, ...) {
  dat[['corrected']] <- dat[['counts']]
  dat[['corrected']][] <- NA
  gc <- round(dat[['bins']]$gc)
  median.counts <- aggregate(dat[['counts']][dat[['bins']]$chromosome %in% 1:22,], by=list(gc=gc[dat[['bins']]$chromosome %in% 1:22]), median)
  median.counts <- median.counts[!is.na(median.counts$gc),]
  rownames(median.counts) <- median.counts$gc
  residuals <- matrix(nrow=nrow(median.counts), ncol=ncol(dat[['counts']]), dimnames=list(rownames(median.counts), colnames(dat[['counts']])))
  for (i in 1:ncol(dat[['counts']])) {
    vals <- median.counts[,i+1]
    l <- loess(vals ~ median.counts$gc, family=family, span=span) #, ...)
    correction <- median(l$fitted, na.rm=TRUE) - l$fitted
    names(correction) <- median.counts$gc
    corvals <- dat[['counts']][,i] + correction[as.character(gc)]
    corvals <- corvals - min(corvals, na.rm=TRUE) # to prevent negative values
    dat[['corrected']][,i] <- corvals
    residuals[,i] <- l$residuals
  }
  dat[['bins']]$mean.residual <- apply(residuals, 1, mean)[as.character(gc)]
  dat
}

dat <- correct(dat, span=span, family=family)
dat2 <- cbind(dat[['bins']], log2(dat[['corrected']]+1), stringsAsFactors=FALSE)

# write outputs
options(scipen=10)
write.table(dat2, 'corrected-cna-data-table.tsv', quote=FALSE, sep='\t', na='')

# EOF

# TOOL promoter-retrprom.R: "Retrieve promoters" (Retrieves promoters of the selected genes from UCSC genome database.Currently works only for human, mouse, rat, drosophila, and yeast data.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT seqs.txt: seqs.txt 
# PARAMETER species: species TYPE [human: human, mouse: mouse, rat: rat, drosophila: drosophila, yeast: yeast] DEFAULT human ()
# PARAMETER promoter.size: promoter.size TYPE [small: small, medium: medium, large: large] DEFAULT small (Length of upstream sequences)


# JTT 17.7.2007

# Sets up the path to the promoter sequences
path.seq<-c(file.path(chipster.tools.path, "weeder", "seqs"))

# Recodes the variable names
size<-promoter.size

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Read phenodata and extracts chip information
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
chip<-phenodata$chiptype[1]

# Creates a variable for environement
if(species=="drosophila") {
   env<-paste(chip, "ACCNUM", sep="")
} else {
   env<-paste(chip, "REFSEQ", sep="")
}
env <- sub( ".db", "", env) # if chip contained ".db", remove it

# Creates a list of genes
genes<-row.names(dat)

# Loads the annotation library
lib<-as.character(chip)

# Account for the fact that annotation packages are from version 2.3 of Bioconductor
# named with an ".db" suffix. Add the suffix when missing to support data files
# from Chipster 1.3 and earlier. 
if (length(grep(".db", lib)) == 0 & length(grep("pmcdf", lib)) == 0) {
        lib <- paste(lib, ".db", sep="")
}

library(package=lib, character.only=T)

# Creating a list of RefSeq IDs for promoter retrieval
refseq<-as.vector(unlist(mget(genes, envir=get(env))))
refseq<-unique(refseq)

# Retrieving promoters
if(species=="human" & size=="small") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36.1_hg18_upstream1000.tsv"), header=T, sep="\t")
}
if(species=="human" & size=="medium") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36.1_hg18_upstream2000.tsv"), header=T, sep="\t")
}
if(species=="human" & size=="large") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36.1_hg18_upstream5000.tsv"), header=T, sep="\t")
}
if(species=="mouse" & size=="small") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36_mm8_upstream1000.tsv"), header=T, sep="\t")
}
if(species=="mouse" & size=="medium") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36_mm8_upstream2000.tsv"), header=T, sep="\t")
}
if(species=="mouse" & size=="large") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36_mm8_upstream5000.tsv"), header=T, sep="\t")
}
if(species=="rat" & size=="small") {
   upstream<-read.table(file.path(path.seq, "UCSC_rn4_upstream1000.tsv"), header=T, sep="\t")
}
if(species=="rat" & size=="medium") {
   upstream<-read.table(file.path(path.seq, "UCSC_rn4_upstream2000.tsv"), header=T, sep="\t")
}
if(species=="rat" & size=="large") {
   upstream<-read.table(file.path(path.seq, "UCSC_rn4_upstream5000.tsv"), header=T, sep="\t")
}
if(species=="drosophila" & size=="small") {
   upstream<-read.table(file.path(path.seq, "Drosophila_upstream1000.tsv"), header=T, sep="\t")
}
if(species=="drosophila" & size=="medium") {
   upstream<-read.table(file.path(path.seq, "Drosophila_upstream2000.tsv"), header=T, sep="\t")
}
if(species=="drosophila" & size=="large") {
   upstream<-read.table(file.path(path.seq, "Drosophila_upstream5000.tsv"), header=T, sep="\t")
}
if(species=="yeast" & size=="small") {
   upstream<-read.table(file.path(path.seq, "NCBI_sc_upstream500.tsv"), header=T, sep="\t")
}
if(species=="yeast" & size=="medium") {
   upstream<-read.table(file.path(path.seq, "NCBI_sc_upstream1000.tsv"), header=T, sep="\t")
}
if(species=="yeast" & size=="large") {
   upstream<-read.table(file.path(path.seq, "NCBI_sc_upstream2500.tsv"), header=T, sep="\t")
}

# Retrieving the sequences
w<-c()
for(i in 1:length(refseq)) {
   w<-c(w, which(upstream$RefSeq==refseq[i]))
}
unlink("seqs.txt")
for(i in 1:length(w)) {
   write(file="seqs.txt", paste(">", upstream[w[i],]$RefSeq, sep=""), append=T)
   write(file="seqs.txt", paste(upstream[w[i],]$Sequence, sep=""), append=T)
}

# TOOL mothur-sffinfo.R: "Extract sequences from a SFF file" (Extract a FASTA sequence file and a QUAL quality file from a SFF file. Sequences can optionally be trimmed for quality. This tool is based on the Mothur package.)
# INPUT reads.sff: "SFF file" TYPE GENERIC
# OUTPUT OPTIONAL reads.fasta
# OUTPUT OPTIONAL reads.qual
# OUTPUT OPTIONAL reads.raw.fasta
# OUTPUT OPTIONAL reads.raw.qual
# PARAMETER OPTIONAL trim: "Trim reads for quality" TYPE [yes, no] DEFAULT no (Trim sequences and quality scores to the clipQualLeft and clipQualRight values.)

# AMS 19.06.2013

# binary
binary <- c(file.path(chipster.tools.path, "mothur", "mothur"))

# Options
sffinfo.options <- ""
sffinfo.options <- paste(sffinfo.options, "sffinfo(sff=reads.sff")
if (trim == "no"){
	sffinfo.options <- paste(sffinfo.options, " trim=F", sep=",")
}
sffinfo.options <- paste(sffinfo.options, ")", sep="")

#stop(paste('CHIPSTER-NOTE: ', ssfinfo.options))

# Write batch file
write(sffinfo.options, "sffinfo.mth", append=F)

# command
command <- paste(binary, "sffinfo.mth")

# run
system(command)

# TOOL estimate-samplesize.R: "Sample size estimation" (Estimates sample size on the basis of a set of normalized control samples.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT size.pdf: size.pdf 
# OUTPUT power.pdf: power.pdf 
# OUTPUT delta.pdf: delta.pdf 
# PARAMETER effect.size: effect.size TYPE DECIMAL FROM 0 TO 100 DEFAULT 2 (Fold change)
# PARAMETER alpha: alpha TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 ()
# PARAMETER beeta: beeta TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.8 ()
# PARAMETER group.size: group.size TYPE INTEGER FROM 1 TO 1000 DEFAULT 4 (Sample size)


# JTT 15.12.2006

# Parameter settings (default) for testing purposes
#effect.size<-c(2)
#alpha<-c(0.05)
#beeta<-c(0.80)
#group.size<-c(4)

# Loads the libraries
library(genefilter)
library(ssize)

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Calculate standard deviation row-wise
sds<-rowSds(dat2)

# Calculate the sample size, power and delta
size<-ssize(sd=sds, delta=log2(effect.size), sig.level=alpha, power=beeta)
po<-pow(sd=sds, n=group.size, delta=log2(effect.size), sig.level=alpha)
del<-delta(sd=sds, n=group.size, power=beeta, sig.level=alpha)

pdf(file="size.pdf", width=600/72, height=600/72)
ssize.plot(size, xlim=c(0,20), main=paste("Sample size to detect ", effect.size, "-fold change", sep=""))
dev.off()

pdf(file="power.pdf", width=600/72, height=600/72)
power.plot(po, main=paste("Power to detect ", effect.size, "-fold change", sep=""))
dev.off()

pdf(file="delta.pdf", width=600/72, height=600/72)
delta.plot(del, xlim=c(0,20), main=paste("Fold change to achieve ", beeta*100, "% power", sep=""))
dev.off()

# TOOL cna-bin-hits.R: "Count reads in fixed bins" (Divide the genome into non-overlapping bins of fixed size, calculate reads in each bin, and correct for GC content.)
# INPUT alignment.bam: "Input BAM file" TYPE GENERIC
# OUTPUT binned-hits.tsv: "Binned hits"
# PARAMETER organism: "organism" TYPE [human: human] DEFAULT human (Organism.)
# PARAMETER genome.build: "genome build" TYPE [GRCh37: GRCh37, NCBI36: NCBI36] DEFAULT GRCh37 (Genome build.)
# PARAMETER bin.size: "bin size" TYPE [1: "1 kbp", 5: "5 kbp", 10: "10 kbp", 15: "15 kbp", 30: "30 kbp", 50: "50 kbp", 100: "100 kbp"] DEFAULT 30 (Bin size.)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-12-18

options(scipen=10)
bin.size <- as.integer(bin.size)
binbp <- bin.size * 1000

.get.genome <- function(organism='human', genome.build='GRCh37') {
  genome.build <- as.integer(gsub('[^0-9]', '', genome.build))
  chromosomes <- c(1:22, 'X', 'Y')
  genomes <- list(GRCh37=c(249250621, 243199373, 198022430, 191154276, 180915260, 171115067, 159138663, 146364022, 141213431, 135534747, 135006516, 133851895, 115169878, 107349540, 102531392, 90354753, 81195210, 78077248, 59128983, 63025520, 48129895, 51304566, 155270560, 59373566), NCBI36=c(247249719, 242951149, 199501827, 191273063, 180857866, 170899992, 158821424, 146274826, 140273252, 135374737, 134452384, 132349534, 114142980, 106368585, 100338915, 88827254, 78774742, 76117153, 63811651, 62435964, 46944323, 49691432, 154913754, 57772954))
  names(genomes[['GRCh37']]) <- chromosomes
  names(genomes[['NCBI36']]) <- chromosomes
  if (genome.build == 37 || genome.build == 19) {
    genome <- genomes[['GRCh37']]
  } else if (genome.build == 36 || genome.build == 18) {
    genome <- genomes[['NCBI36']]
  } else {
    stop('Unknown genome build.')
  }
  genome
}

.create.bins <- function(binbp, ...) {
  genome <- .get.genome(...)
  start <- end <- count <- integer()
  for (chromosome in names(genome)) {
    chromosome.size <- genome[chromosome]
    chromosome.starts <- seq(from=1, to=chromosome.size, by=binbp)
    chromosome.ends <- chromosome.starts + binbp - 1
    chromosome.ends[length(chromosome.ends)] <- chromosome.size
    chromosome.breaks <- c(chromosome.starts, chromosome.size)
    start <- c(start, chromosome.starts)
    end <- c(end, chromosome.ends)
  }
  bins <- data.frame(chromosome=rep(names(genome), ceiling(genome / binbp)), start, end, stringsAsFactors=FALSE)
}

genome <- .get.genome('human', genome.build)
bins <- .create.bins(binbp, 'human', genome.build)

# update file paths and add parameters for read length and number of mismatches !!!
gc <- read.table(file.path(chipster.tools.path, 'MPScall', genome.build, paste('gc.', bin.size, 'kbp.txt.gz', sep='')), header=TRUE, sep='\t', as.is=TRUE)
mappability <- read.table(file.path(chipster.tools.path, 'MPScall', genome.build, paste('mappability.', bin.size, 'kbp.txt.gz', sep='')), header=TRUE, sep='\t', as.is=TRUE)
gc <- gc[gc$chromosome != 'MT',]
mappability <- mappability[mappability$chromosome != 'MT',]
bins$gc <- round(gc$gc * 100, digits=1)
bins$mappability <- round(mappability$mappability, digits=1)

bins$count <- 0

system(paste(file.path(chipster.tools.path, 'samtools', 'samtools'), ' view -F 0x0404 -q 1 alignment.bam | cut -f3,4 | tr -d chr > hits.txt', sep=''))

skip <- 0
chunk <- 100000000
while(1) {
  hits <- as.data.frame(scan('hits.txt', what=list(chromosome=character(), pos=integer()), sep='\t', nmax=chunk, skip=skip, quiet=TRUE), stringsAsFactors=FALSE)
  if (nrow(hits) == 0)
    break
  for (chromosome in unique(hits$chromosome)) {
    if (!chromosome %in% names(genome))
      next
    chromosome.size <- genome[chromosome]
    chromosome.starts <- seq(from=1, to=chromosome.size, by=binbp)
    chromosome.breaks <- c(chromosome.starts, chromosome.size)
    count <- hist(hits[hits$chromosome==chromosome, 'pos'], breaks=chromosome.breaks, plot=FALSE)$count
    bins[bins$chromosome==chromosome, 'count'] <- bins[bins$chromosome==chromosome, 'count'] + count
  }
  skip <- skip + chunk
  rm(hits, count); gc(FALSE)
}
unlink('hits.txt')

rownames(bins) <- paste(bins$chromosome, ':', bins$start, '-', bins$end, sep='')

write.table(bins, 'binned-hits.tsv', quote=FALSE, sep='\t', na='')

# EOF

# TOOL add-locations-to-data.R: "Add genomic location to data" (Annotates genes with chromosomal location information, and adds the results to the datafile. The result file can be visualized using the Genome browser.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT data-with-locations.tsv: data-with-locations.tsv 
# PARAMETER annotate_with: "annotate using" TYPE [probe_id: "probe ID", gene_symbol: "gene symbols"] DEFAULT gene_symbol (Should the probe identifiers be used to fetch the location of the corresponding gene targets or should gene symbols be used directly, if available.)
# PARAMETER species: species TYPE [human: human, mouse: mouse, rat: rat] DEFAULT human (The species needs to be specified in order to map genes to the genomic coordinates.)

# MG 16.3.2012

# Loads libraries into memory
library(biomaRt)

# Reads the chiptype from phenodata table
if (annotate_with == "probe_id") {
	phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
	if(phenodata$chiptype[1]!="cDNA" | phenodata$chiptype[1]!="Illumina") {
		# Saves the chiptype into object lib
		lib<-phenodata$chiptype[1]
		lib<-as.character(lib)
	}
	# Account for the fact that annotation packages are from version 2.3 of Bioconductor
	# named with an ".db" suffix. Add the suffix when missing to support data files
	# from Chipster 1.3 and earlier. 
	if (length(grep(".db", lib)) == 0 & length(grep("pmcdf", lib)) == 0) {
		lib <- paste(lib, ".db", sep="")
	}
	# Checks that the package actually exists
	is_package_available <- try (library(package=lib, character.only=T))
	if (length(grep("no package", is_package_available[1])) > 0) {
		stop("CHIPSTER-NOTE: It appears that your data was not acquired using one of the array types supported in Chipster. If the input data already has a 'symbol' column, please rerun the tool with the 'annotate using' parameter set to 'gene symbols'.")
	}
	# Loads the correct annotation library
	library(package=lib, character.only=T)
	library(annaffy)
}

# Loads the data
file <- c("normalized.tsv")
dat <- read.table(file, header=T, sep="\t", row.names=1)

# Do sanity check if gene symbol is to be used
if (annotate_with == "gene_symbol") {
	gene_symbols <- dat[,grep("symbol", names(dat))]
	if (length(unique(gene_symbols)) < 1) {
		stop("CHIPSTER-NOTE: You need to have at least one gene symbol in your data table to use that information for fetching chromosome location information. For supported array designs the user can opt to use the probe ID instead.")
	}
}

# Covert probe id to gene symbols using appropriate annotation package
probes_query <- rownames(dat)
if (annotate_with == "probe_id") {
	probes_query <- rownames(dat)
	lib2 <- sub('.db','',lib)
	lib3 <- paste(lib2, "SYMBOL", sep="")
	env <- get(lib3)
	gene_symbols <- unlist(mget(probes_query, env))
}

# Fetch the gene symbols and descriptions from ENSEMBL using biomaRt
if (species=="human") {
	dataset <- "hsapiens_gene_ensembl"
}
if (species=="mouse") {
	dataset <- "mmusculus_gene_ensembl"
}
if (species=="rat") {
	dataset <- "rnorvegicus_gene_ensembl"
}
ensembl <- useMart("ensembl", dataset=dataset)
annotated_genes <- getBM(mart=ensembl, attributes=c("hgnc_symbol","chromosome_name","start_position","end_position"), filters="hgnc_symbol", values=gene_symbols)

# Remove chromosome entries containing the "_" character
annotated_genes <- annotated_genes [-grep( pattern="_", annotated_genes$chromosome_name),]

# Match the list of input gene ids with the annotations
chr_name <- character(length(probes_query))
chr_start <- character(length(probes_query))
chr_end <- character(length(probes_query))
result_table <- data.frame(chr=chr_name, start=chr_start, end=chr_end, dat, stringsAsFactors = FALSE)
for (gene_count in 1:length(gene_symbols)) {
	chr_name[gene_count] <- annotated_genes[annotated_genes$hgnc_symbol==gene_symbols[gene_count],2][1]
	chr_start[gene_count] <- annotated_genes[annotated_genes$hgnc_symbol==gene_symbols[gene_count],3][1]
	chr_end[gene_count] <- annotated_genes[annotated_genes$hgnc_symbol==gene_symbols[gene_count],4][1]
}	
result_table <- data.frame(chr=chr_name, start=chr_start, end=chr_end, dat, stringsAsFactors = FALSE)

# Order the output based on chromosome and start position
result_table <- result_table[order(result_table$chr, result_table$start),]

# Output the data table with added chromosome location info
write.table(result_table, file="data-with-locations.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# EOF

# TOOL ngs-find-nearest-genes.R: "Find the nearest genes for regions" (This tool takes set of genomic regions, such as ChIP-seq peaks, and fetches the nearest gene for each.)
# INPUT regions-list.tsv: "Table with genomic regions" TYPE GENERIC 
# OUTPUT nearest-genes.tsv: "Table listing the nearest gene feature for each input region." 
# PARAMETER species: "Genome" TYPE [Human_hg18: "Human (hg18\)", Human_hg19: "Human (hg19\)", Mouse: "Mouse (mm9\)", Rat: "Rat (rn4\)"] DEFAULT none (The genome to use for fetching annotations.)

#####################################################
#                                                   #
# MG, 28.10.2010                                    #
# EK, 9.2.2012                                      #
#                                                   #
# Tool that fetches the nearest gene, exon or miRNA #
# for a set of genomic regions, such as the output  #
# from a peak detection algorithm for ChIP-seq data #
#                                                   #
#####################################################

# Possible additional parameters and output
# OUTPUT unique-genes-list.tsv: "Table listing the unique genes that can be mapped with gene symbols and entrez gene ids." 
# OUTPUT logo-plot-{...}.png: "Logo plots for each consensus motif"
# PARAMETER feature: "Genomic feature" TYPE [TSS, exon, miRNA] DEFAULT TSS (The genomic feature to look for in each region. Currently, transcription start site, exon or miRNA are supported feature types)
# PARAMETER e.value.cutoff: "E-value cutoff" TYPE DECIMAL FROM 0 TO 100 DEFAULT 0.01 (This parameter controls the alignment stringency, where a lower value means better alignment.)

# Set up testing parameters
# species <- "Human"

# Load the libraries
library(ChIPpeakAnno)
library(biomaRt)

# Load the annotation data
if (species == "Human_hg18") {
	data(TSS.human.NCBI36)
	annotations <- TSS.human.NCBI36
	ensembl_dataset <- "hsapiens_gene_ensembl"
	filter <- "ens_hs_gene"
}
if (species == "Human_hg19") {
	data(TSS.human.GRCh37)
	annotations <- TSS.human.GRCh37
	ensembl_dataset <- "hsapiens_gene_ensembl"
	filter <- "ens_hs_gene"
}
if (species == "Nouse") {
	data(TSS.mouse.NCBIM37)
	annotations <- TSS.mouse.NCBIM37
	ensembl_dataset <- "mmusculus_gene_ensembl"
	filter <- "ens_mm_gene"
}
if (species == "Rat") {
	data(TSS.rat.RGSC3.4)
	annotations <- TSS.rat.RGSC3.4
	ensembl_dataset <- "rnorvegicus_gene_ensembl"
	filter <- "ens_rn_gene"
}

# Read in data and convert to BED format
results_file <- read.table (file="regions-list.tsv", sep="\t", header=T)
results_bed <- results_file[,1:3]
results_bed[,1] <- paste("chr",results_bed[,1], sep="")

# Convert to Ranged data
results_ranged <- BED2RangedData(results_bed)

# Annotate the data
results_annotated = annotatePeakInBatch(results_ranged, AnnotationData = annotations)

# Convert into a table and extract the useful columns
results_table <- as.data.frame(results_annotated)
# rownames(results_table) <- sub (" ", "_", results_table$name)
results_table <- results_table[,c(-5,-13,-14)]
table_header <- c("chromosome","region_start","region_end","region_width",
	"region_id","strand","ensembl_id","gene_start","gene_end","location",
	"distance")
names(results_table) <- table_header

# Write output
# write.table(results_table, file="nearest-genes.tsv", sep="\t", col.names=T, row.names=T, quote=F)
write.table(results_table, file="nearest-genes.tsv", sep="\t", col.names=T, row.names=F, quote=F)

# EOF

# Utilities for dealing with compressed files


unzipIfGZipFile <- function(file.name) {
	
	# if gzip, unzip it
	if (isGZipFile(file.name)) {
		zipfile.name <- paste(file.name, ".gz", sep="")
		system(paste("mv", file.name, zipfile.name, "; gzip -d", zipfile.name))
	}
}


isGZipFile <- function(file.name) {
	
	# get file type with the unix file command
	file.type = system(paste("file -Lb --mime", file.name), intern=TRUE)
	
	if (!is.na(pmatch("application/x-gzip", file.type))) {
		return(TRUE);
	} else { 
		return(FALSE);
	}
}

# TOOL stat-hyperG-safe.R: "SAFE test for KEGG pathway enrichment" (Finds pathways from the Kyoto Encyclopedia of Genes and Genomes, KEGG, that are over- or under-represented in the selected gene list.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT safeplot.png: safeplot.png 
# OUTPUT safe.tsv: safe.tsv 
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to test)
# PARAMETER p.value.threshold: p.value.threshold TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (P-value cut-off for significant results)
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)
# PARAMETER minimum.category.size: minimum.category.size TYPE INTEGER FROM 1 TO 100 DEFAULT 10 (Minimum size for categories to be evaluated)

# Modified 5.11.2009, MG
# Accounting for changes in SparseM package regarding matrix.csr class


# PARAMETER which.ontology [KEGG, GO] DEFAULT KEGG (Which ontology to use in the test?)
# Parameter settings (default) for testing purposes
#column<-"group"
#which.ontology<-"KEGG"
#p.value.threshold<-1
#image.width<-600
#image.height<-600
#minimum.category.size<-10

# Translating the variables
w<-image.width
h<-image.height

# Loads the libraries
library(SparseM)
library(safe)
library(multtest)

# Reads the chiptype from phenodata table
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
if(phenodata$chiptype[1]!="cDNA" | phenodata$chiptype[1]!="Illumina") {
	# Saves the chiptype into object lib
	lib<-phenodata$chiptype[1]
	lib<-as.character(lib)
}

# Account for the fact that annotation packages are from version 2.3 of Bioconductor
# named with an ".db" suffix. Add the suffix when missing to support data files
# from Chipster 1.3 and earlier. 
if (length(grep(".db", lib)) == 0 & length(grep("pmcdf", lib)) == 0) {
	lib <- paste(lib, ".db", sep="")
}

# Loads the correct annotation library
library(package=lib, character.only=T)

# Loads the data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Experimental design
groups<-phenodata[,pmatch(column,colnames(phenodata))]

# Creates a C matrix
#if(which.ontology=="KEGG") {
	lib2<-sub('.db','',lib)
	env<-paste(lib2, "PATH", sep="")
	alleg<-get(env)
	alleg<-as.list(alleg)
	cmatrix<-getCmatrix(gene.list=alleg, present.genes=rownames(dat), min.size=minimum.category.size)
	#cmatrix<-getCmatrix(gene.list=alleg, present.genes=rownames(dat))
#}

#if(which.ontology=="GO") {
#	lib2<-sub('.db','',lib)
#	env<-paste(lib2, "GO2ALLPROBES", sep="")
#	alleg<-get(env)
#	alleg<-as.list(alleg)
#	tcmatrix<-getCmatrix(alleg)
#	tcmatrix<-tcmatrix[,dimnames(tcmatrix)[[2]] %in% rownames(dat2)]
#	cmatrix<-matrix(0, dim(dat2)[[1]], dim(tcmatrix)[[1]])
#	dimnames(cmatrix)<-list(dimnames(dat2)[[1]], dimnames(tcmatrix)[[1]]) 
#	cmatrix[match(dimnames(tcmatrix)[[2]], dimnames(dat2)[[1]]), ] <- t(tcmatrix)
#	cmatrix2<-cmatrix[,apply(cmatrix, 2, sum) >= minimum.category.size]
#}

# Runs the analysis
result<-safe(dat2, groups, cmatrix, alpha=p.value.threshold, min.size=minimum.category.size)

# Are there any significant results?
# The following check is not valid any more: you always get p-values, but they are just below the threshold. 
# Instead one should check if result@C.mat exists?
if(length(result@global.pval)==0) {
	bitmap(file="safeplot.png", width=w/72, height=h/72)
	plot(1, 1, col=0)
	text(1, 1, "This is a dummy image.", col=1)
	text(1, 0.9, "This has been generated, because no significant results were found.", col=1)
	text(1, 0.8, "These things happen.", col=1)
	dev.off()
	result.table <- data.frame(Category=names(result@global.pval), Size=rowSums(as.matrix(t(result@C.mat))), P.Value=result@global.pval)
	result.table <- result.table[result.table$P.Value<p.value.threshold,]
	result.table <- result.table[order(result.table$P.Value),]
	write.table(result.table, file="safe.tsv", sep="\t", row.names=F, col.names=T, quote=F)
} else {
	# Plotting the results
	bitmap(file="safeplot.png", width=w/72, height=h/72)
	safeplot(result)
	dev.off()
	# Writing a result table
	result.table <- data.frame(Category=names(result@global.pval), Size=rowSums(as.matrix(t(result@C.mat))), P.Value=result@global.pval)
	result.table <- result.table[result.table$P.Value<p.value.threshold,]
	result.table <- result.table[order(result.table$P.Value),]
	write.table(result.table, file="safe.tsv", sep="\t", row.names=F, col.names=T, quote=F)
}

# TOOL bedtools-closestbed.R: "Closest BED" (For each feature in A, finds the closest feature (upstream or downstream\) in B. This tool is based on the BEDTools package.)
# INPUT file.a: "BED file A" TYPE GENERIC
# INPUT file.b: "BED file B" TYPE GENERIC
# OUTPUT closestbed.bed 
# PARAMETER OPTIONAL s: "Force strandedness" TYPE [yes, no] DEFAULT no (Force strandedness. That is, find the closest feature in B that overlaps A on the same strand. By default, overlaps are reported without respect to strand.)
# PARAMETER OPTIONAL d: "Report distance" TYPE [yes, no] DEFAULT no (In addition to the closest feature in B, report its distance to A as an extra column. The reported distance for overlapping features will be 0.)
# PARAMETER OPTIONAL t: "Approach to reporting multiple overlaps" TYPE [all, first, last] DEFAULT all (How ties for closest feature are handled. This occurs when two features in B have exactly the same overlap with A. By default, all such features in B are reported. The options are: all (Report all ties\), first (Report the first tie that occurred in the B file\) and  last (Report the last tie that occurred in the B file\).)

# AMS 23.4.2012

# binary
binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "closestBed"))

# optional options
options <- paste("")
if (s == "yes") {options <- paste(options, "-s")}
if (d == "yes") {options <- paste(options, "-d")}
options <- paste(options, "-t", t)

# input files
options <- paste(options,"-a file.a -b file.b")

# command
command <- paste(binary, options, " > closestbed.bed")

# run
system(command)
if (file.info("closestbed.bed")$size == 0) {system("echo \"No results found\" > closestbed.bed")}

# TOOL tophat-single-end.R: "TopHat for single end reads" (Aligns Illumina RNA-Seq reads to a genome in order to identify exon-exon splice junctions. TopHat first identifies potential exons by mapping the reads to the genome. Using this initial mapping, TopHat builds a database of possible splice junctions, and then maps the reads against these junctions to confirm them. The alignment results are given in a BAM file, which is automatically indexed and hence ready to be viewed in Chipster genome browser.)
# INPUT reads1.fq: "Reads to align" TYPE GENERIC
# INPUT OPTIONAL genes.gtf: "Optional GTF file" TYPE GENERIC
# OUTPUT tophat.bam
# OUTPUT tophat.bam.bai
# OUTPUT OPTIONAL junctions.bed
# OUTPUT OPTIONAL insertions.bed
# OUTPUT OPTIONAL deletions.bed
# PARAMETER genome: "Genome" TYPE [hg19: "Human (hg19\)", mm10: "Mouse (mm10\)", mm9: "Mouse (mm9\)", rn4: "Rat (rn4\)", athaliana.TAIR10: "A. thaliana genome (TAIR10\)", ovis_aries_texel: "Sheep genome"] DEFAULT hg19 (Genome that you would like to align your reads against.)
# PARAMETER OPTIONAL min.anchor.length: "Minimum anchor length" TYPE INTEGER FROM 3 TO 1000 DEFAULT 8 (TopHat will report junctions spanned by reads with at least this many bases on each side of the junction. Note that individual spliced alignments may span a junction with fewer than this many bases on one side. However, every junction involved in spliced alignments is supported by at least one read with this many bases on each side.)
# PARAMETER OPTIONAL splice.mismatches: "Maximum number of mismatches allowed in the anchor" TYPE INTEGER FROM 0 TO 2 DEFAULT 0 (The maximum number of mismatches that may appear in the anchor region of a spliced alignment.)
# PARAMETER OPTIONAL min.intron.length: "Minimum intron length" TYPE INTEGER FROM 10 TO 1000 DEFAULT 70 (TopHat will ignore donor-acceptor pairs closer than this many bases apart.)
# PARAMETER OPTIONAL max.intron.length: "Maximum intron length" TYPE INTEGER FROM 1000 TO 1000000 DEFAULT 500000 (TopHat will ignore donor-acceptor pairs farther than this many bases apart, except when such a pair is supported by a split segment alignment of a long read.)
# PARAMETER OPTIONAL min.isoform.fraction: "Minimum isoform fraction" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.15 (TopHat filters out junctions supported by too few alignments. Suppose a junction spanning two exons, is supported by S reads. Let the average depth of coverage of exon A be D, and assume that it is higher than B. If S divided by D is less than the minimum isoform fraction, the junction is not reported. A value of zero disables the filter.)
# PARAMETER OPTIONAL max.multihits: "How many hits is a read allowed to have" TYPE INTEGER FROM 1 TO 1000000 DEFAULT 20 (Instructs TopHat to allow up to this many alignments to the reference for a given read, and suppresses all alignments for reads with more than this many alignments.)
# PARAMETER OPTIONAL use.gtf: "Use annotation GTF" TYPE [yes, no] DEFAULT yes (If this option is provided, TopHat will first extract the transcript sequences and use Bowtie to align reads to this virtual transcriptome first. Only the reads that do not fully map to the transcriptome will then be mapped on the genome. The reads that did map on the transcriptome will be converted to genomic mappings (spliced as needed\) and merged with the novel mappings and junctions in the final tophat output. If no GTF file is provided by user, internal annotation file wil be used if available. Internal annotation is provided for human, mouse and rat.)
# PARAMETER OPTIONAL no.novel.juncs: "When GTF file is used, ignore novel junctions" TYPE [yes, no] DEFAULT yes (If annotation GTF is used, TopHat will extract the transcript sequences and use Bowtie to align reads to this virtual transcriptome first. Only the reads that do not fully map to the transcriptome will then be mapped on the genome. The reads that did map on the transcriptome will be converted to genomic mappings (spliced as needed\) and merged with the novel mappings and junctions in the final TopHat output. If no GTF file is provided by the user, internal annotation file will be used if available. Internal annotation is provided for human, mouse and rat.)

# EK 17.4.2012 added -G and -g options
# MG 24.4.2012 added ability to use GTF files from Chipster server
# AMS 19.6.2012 added unzipping
# EK 19.9.2012 added mm10 and new GTFs (Ensembl 68)
# AMS 4.10.2012 added BED sorting
# AMS 4.2.2013 added option to use no GTF


# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads1.fq")

options(scipen = 10)
# max.intron.length <- formatC(max.intron.length, "f", digits = 0)

# setting up TopHat
tophat.binary <- c(file.path(chipster.tools.path, "tophat", "tophat"))
path.bowtie <- c(file.path(chipster.tools.path, "bowtie"))
path.samtools <- c(file.path(chipster.tools.path, "samtools"))
set.path <-paste(sep="", "PATH=", path.bowtie, ":", path.samtools, ":$PATH")
path.bowtie.index <- c(file.path(path.bowtie, "indexes", genome))


# command start
command.start <- paste("bash -c '", set.path, tophat.binary)

# parameters
command.parameters <- paste("-a", min.anchor.length, "-m", splice.mismatches, "-i", min.intron.length, "-I", max.intron.length, "-F", min.isoform.fraction, "-g", max.multihits, "--library-type fr-unstranded")

# optional GTF command
command.gtf <- ""
input_files <- dir()
is_gtf <- (length(grep("genes.gtf", input_files))>0)
if (is_gtf) {
	if (no.novel.juncs == "yes") {
	command.gtf <- paste("-G", "genes.gtf", "--no-novel-juncs")
	} else {
		command.gtf <- paste("-G", "genes.gtf")
	}
}


# optional GTF command, if a GTF file has NOT been provided by user
# BUT is avaliable from Chipster server
genome_available <- FALSE
if (genome == "hg19" ||	genome == "mm9" || genome == "rn4" || genome == "mm10") genome_available <- TRUE
if (!is_gtf && genome_available) {
	
	# annotation file setup
	if (genome == "hg19") {
		annotation.file <- "Homo_sapiens.GRCh37.68.chr.gtf"
	}
	if (genome == "mm9") {
		annotation.file <- "Mus_musculus.NCBIM37.62.chr.gtf"
	}
	if (genome == "mm10") {
		annotation.file <- "Mus_musculus.GRCm38.68.chr.gtf"
	}
	if (genome == "rn4") {
		annotation.file <- "Rattus_norvegicus.RGSC3.4.68.chr.gtf"
	}
	annotation.file <- c(file.path(chipster.tools.path, "genomes", "gtf", annotation.file))
	
	if (no.novel.juncs == "yes") {
		command.gtf <- paste("-G", annotation.file, "--no-novel-juncs")
	} else {
		command.gtf <- paste("-G", annotation.file)
	}
}

# command ending
command.end <- paste(path.bowtie.index, "reads1.fq'")

# run tophat
if (use.gtf == "yes"){ 
	command <- paste(command.start, command.parameters, command.gtf, command.end)
}else{
	command <- paste(command.start, command.parameters, command.end)
}
system(command)

# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

# sort bam
system(paste(samtools.binary, "sort tophat_out/accepted_hits.bam tophat"))

# index bam
system(paste(samtools.binary, "index tophat.bam"))

system("mv tophat_out/junctions.bed junctions.u.bed")
system("mv tophat_out/insertions.bed insertions.u.bed")
system("mv tophat_out/deletions.bed deletions.u.bed")

# sorting BEDs
source(file.path(chipster.common.path, "bed-utils.R"))

size <- file.info("junctions.u.bed")$size
if (size > 100){	
#if (file.info("juctions.u.bed")$size > 100) {
	bed <- read.table(file="junctions.u.bed", skip=1, sep="\t")
	colnames(bed)[1:2] <- c("chr", "start")
	sorted.bed <- sort.bed(bed)
	write.table(sorted.bed, file="junctions.bed", sep="\t", row.names=F, col.names=F, quote=F)
}

size <- file.info("insertions.u.bed")$size
if (size > 100){
	bed <- read.table(file="insertions.u.bed", skip=1, sep="\t")
	colnames(bed)[1:2] <- c("chr", "start")
	sorted.bed <- sort.bed(bed)
	write.table(sorted.bed, file="insertions.bed", sep="\t", row.names=F, col.names=F, quote=F)
}

size <- file.info("deletions.u.bed")$size
if (size > 100){
	bed <- read.table(file="deletions.u.bed", skip=1, sep="\t")
	colnames(bed)[1:2] <- c("chr", "start")
	sorted.bed <- sort.bed(bed)
	write.table(sorted.bed, file="deletions.bed", sep="\t", row.names=F, col.names=F, quote=F)
}

# TOOL cna-plot-profile.R: "Plot copy number profile" (Plot copy number profiles of individual samples.)
# INPUT aberrations.tsv: aberrations.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT cna-profile.pdf: "Copy number profile"
# PARAMETER samples: samples TYPE STRING DEFAULT 1 (The numbers of the samples to be plotted, separated by commas. Ranges are also supported (e.g. 1,3,7-10\).)
# PARAMETER chromosomes: chromosomes TYPE STRING DEFAULT 0 (The numbers of the chromosomes to be plotted, separated by commas. 0 means all chromosomes. Ranges are also supported (e.g. 1,3,7-10\).)
# PARAMETER resolution: resolution TYPE DECIMAL FROM 0 TO 1 DEFAULT 1 (Proportion of data points to draw. Lower values lead to smaller file sizes and faster processing.)
# PARAMETER ploidy: "phenodata column with ploidy of samples" TYPE METACOLUMN_SEL DEFAULT EMPTY (Phenodata column with ploidy)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-03-20

source(file.path(chipster.common.path, 'CGHcallPlus.R'))

# read input files
dat <- read.table('aberrations.tsv', header=TRUE, sep='\t', row.names=1, as.is=TRUE)
phenodata <- read.table("phenodata.tsv", header=TRUE, sep="\t", as.is=TRUE)

if (ploidy == 'EMPTY') {
  ploidy <- rep(2, nrow(phenodata))
} else {
  ploidy <- as.numeric(phenodata[,ploidy])
  ploidy[is.na(ploidy)] <- 2
}

# parse samples to be plotted
if (samples=='0')
  samples <- paste('1-', nrow(phenodata), sep='')
samples <- gsub('[^0-9,-]', ',', samples)
items <- strsplit(samples, ',')[[1]]
samples.to.plot <- integer()
for (item in items) {
  item <- item[item!='']
  if (length(item)==0) next
  range <- strsplit(item, '-')[[1]]
  range <- range[range!='']
  if (length(range)==0) next
  samples.to.plot <- c(samples.to.plot, seq(range[1], range[length(range)]))
}
samples.to.plot <- unique(samples.to.plot)

# remove samples that are out of bounds
samples.to.plot <- samples.to.plot[samples.to.plot<=nrow(phenodata)]

# check that we have something to plot
if (length(samples.to.plot)==0)
  stop('CHIPSTER-NOTE: Nothing to plot.')

if (0 %in% samples.to.plot)
  samples.to.plot <- 1:nrow(phenodata)

# parse chromosomes to be plotted
chromosomes <- gsub('X', '23', chromosomes, ignore.case=TRUE)
chromosomes <- gsub('Y', '24', chromosomes, ignore.case=TRUE)
chromosomes <- gsub('MT', '25', chromosomes, ignore.case=TRUE)
chromosomes <- gsub('[^0-9,-]', ',', chromosomes)
items <- strsplit(chromosomes, ',')[[1]]
chrs.to.plot <- integer()
for (item in items) {
  item <- item[item!='']
  if (length(item)==0) next
  range <- strsplit(item, '-')[[1]]
  range <- range[range!='']
  if (length(range)==0) next
  chrs.to.plot <- c(chrs.to.plot, seq(range[1], range[length(range)]))
}
chrs.to.plot <- unique(chrs.to.plot)
chrs.to.plot <- chrs.to.plot[chrs.to.plot %in% dat$chromosome]
if (length(chrs.to.plot)==0)
  chrs.to.plot <- 0

dat$chromosome[dat$chromosome=='X'] <- 23
dat$chromosome[dat$chromosome=='Y'] <- 24
dat$chromosome[dat$chromosome=='MT'] <- 25
dat$chromosome <- as.integer(dat$chromosome)

if (! 0 %in% chrs.to.plot)
  dat <- dat[dat$chromosome %in% chrs.to.plot,]

calls <- as.matrix(dat[,grep("^flag\\.", names(dat))])
cn <- as.matrix(dat[,grep("^copynumber\\.", names(dat))])
ratios <- as.matrix(dat[,grep("^chip\\.", names(dat))])
segmented <- as.matrix(dat[,grep("^segmented\\.", names(dat))])
ratios <- 2^ratios
segmented <- 2^segmented

.getChromosomeLengths <- function(build) {
    build <- as.integer(gsub('[^0-9]', '', build))
    if (build == 34 || build == 16) {
       chromosome.lengths <- c(246127941, 243615958, 199344050, 191731959, 181034922, 170914576, 158545518, 146308819, 136372045, 135037215, 134482954, 132078379, 113042980, 105311216, 100256656, 90041932, 81860266, 76115139, 63811651, 63741868, 46976097, 49396972, 153692391, 50286555)
    } else if (build == 35 || build == 17) {
       chromosome.lengths <- c(245522847, 243018229, 199505740, 191411218, 180857866, 170975699, 158628139, 146274826, 138429268, 135413628, 134452384, 132449811, 114142980, 106368585, 100338915, 88827254, 78774742, 76117153, 63811651, 62435964, 46944323, 49554710, 154824264, 57701691)
    } else if (build == 36 || build == 18) {
       chromosome.lengths <- c(247249719, 242951149, 199501827, 191273063, 180857866, 170899992, 158821424, 146274826, 140273252, 135374737, 134452384, 132349534, 114142980, 106368585, 100338915, 88827254, 78774742, 76117153, 63811651, 62435964, 46944323, 49691432, 154913754, 57772954)
    } else {
       chromosome.lengths <- c(249250621, 243199373, 198022430, 191154276, 180915260, 171115067, 159138663, 146364022, 141213431, 135534747, 135006516, 133851895, 115169878, 107349540, 102531392, 90354753, 81195210, 78077248, 59128983, 63025520, 48129895, 51304566, 155270560, 59373566)
    }
    names(chromosome.lengths) <- 1:24
    chromosome.lengths
}

plot.freec <- 
function (x, i, dotres=1, ploidy=2, ylab='copy number', build="GRCh37",... )
{
    ylimit <- c(0, 3*ploidy)
    chrom <- x$chromosome
    pos <- x$start
    uni.chrom <- unique(chrom)
    chrom.lengths <- .getChromosomeLengths(build)[as.character(uni.chrom)]
    chrom.ends <- integer()
    cumul <- 0
    for (j in uni.chrom) {
        pos[chrom > j] <- pos[chrom > j] + chrom.lengths[as.character(j)]
        cumul <- cumul + chrom.lengths[as.character(j)]
        chrom.ends <- c(chrom.ends, cumul)
    }
    names(chrom.ends) <- names(chrom.lengths)
    nclone <- nrow(x)
    whichtoplot <- seq(1,nclone,by=dotres)
    cols <- c('red', 'black', 'blue')
    names(cols) <- -1:1
    # for (i in colnames(cn)) {
        plot(pos[whichtoplot], ploidy*ratios[whichtoplot,i], cex=.1, main=phenodata$description[i], ylab=ylab, xlab="chromosomes", ylim=ylimit, xaxt="n", xaxs="i", col='dimgray')
        if (dotres != 1)
            mtext(paste('Plot resolution: ', 100/dotres, '%', sep=''), side=3, line=0)
        abline(h=ploidy)
        if (length(chrom.ends) > 1)
            for (j in names(chrom.ends)[-length(chrom.ends)])
                abline(v=chrom.ends[j], lty='dashed')
        ax <- (chrom.ends + c(0, chrom.ends[-length(chrom.ends)])) / 2
        axis(side=1,at=ax,labels=uni.chrom,cex=.2,lwd=.5,las=1,cex.axis=1,cex.lab=1)
        points(pos[whichtoplot], cn[whichtoplot,i], cex=.3, col=cols[as.character(calls[whichtoplot,i])])
        amps <- cn[,i]
        amps[amps >  ylimit[2]] <- ylimit[2]+0.15
        amps[amps <= ylimit[2]] <- NA
        points(pos, amps, pch=24, col='blue', bg='blue', cex=0.5)
        dels <- cn[,i]
        dels[dels <  ylimit[1]] <- ylimit[1]-0.15
        dels[dels >= ylimit[1]] <- NA
        points(pos, dels, pch=25, col='red', bg='red', cex=0.5)
        ### MAD
        mad.value <- round(mad(ratios[chrom < 23,i], na.rm=TRUE), digits=2)
        mtext(paste('MAD =', mad.value), side=3, line=0, adj=1)
        ### number of data points
        str <- paste(round(nclone / 1000), 'k x ', sep='')
        probe <- median(x$end - x$start + 1)
        if (probe < 1000) {
            str <- paste(str, probe, ' bp', sep='')
        } else {
            str <- paste(str, round(probe / 1000), ' kbp', sep='')
        }
        mtext(str, side=3, line=0, adj=0)
    # }
}

# plot
pdf(file='cna-profile.pdf', paper='a4r', width=0, height=0)
for (sample in samples.to.plot)
  plot.freec(dat, sample, dotres=1/resolution, ploidy=ploidy[sample])
dev.off()

# EOF

# TOOL norm-prenormalized.R: "Process prenormalized" (If you import prenormalized data that is not in Chipster format, you need to import it through Import tool, and then use this tool for preprocessing it. Every column containing normalized expression values need to be specified as Sample in the Import tool. If you want to be able to use annotation, you need to SPECIFY THE CHIPTYPE.)
# INPUT microarray{...}.tsv: microarray{...}.tsv TYPE CDNA 
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# PARAMETER chiptype: chiptype TYPE STRING DEFAULT empty ()
# PARAMETER keep.annotations: keep.annotations TYPE [yes: yes, no: no] DEFAULT no (Keep or discard annotation column after preprocessing)


# Process prenormalized
# JTT 26.1.2009
# MG 21.10.2009
# EK 23.4.2013 added .tsv ending to expression column names so that sample renaming is possible in interactive visualizations

# Loads the libraries
library(limma)

# Reading data
columns<-list(R="sample", Rb="sample", G="sample", Gb="sample")
annotation<-c("identifier")
columns.other<-c("flag", "annotation")

files<-dir()
files<-files[files!="phenodata.tsv"]
dat<-read.maimages(files=files, columns=columns, annotation=annotation, other.columns=columns.other) 

# Extract annotations
if (keep.annotations=="yes") {
	annotation.info <- dat$other[[1]]
	annotation.info <- as.character (annotation.info[,1])
}

# Mock normalization
dat2<-normalizeBetweenArrays(dat$R, method="none")

# Writes out a phenodata table
sample<-paste(colnames(dat2), ".tsv", sep="")
group<-c(rep("", length(sample)))
training<-c(rep("", length(sample)))
time<-c(rep("", length(sample)))
random<-c(rep("", length(sample)))
if(chiptype=="empty") {
	chiptype<-c("cDNA")
}
write.table(data.frame(sample=sample, chiptype=chiptype, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# Preparing data for export
M<-data.frame(dat2)
colnames(M)<-paste("chip.", colnames(M), ".tsv", sep="")
M2<-aggregate(M, as.list(dat$genes), mean)
rownames(M2)<-M2$identifier
M2<-M2[,-1]

# Match annotations to identifiers

if (keep.annotations=="yes") {
	matching_table <- cbind (as.character (dat$genes[,1]), annotation.info)
	rownames (matching_table) <- as.character (dat$genes[,1])
	matching_table <- as.data.frame (matching_table)
	annotations <- as.character (matching_table[rownames(M2),2])
}

if(chiptype!="cDNA") {
	
	# Including gene names to data
	lib2<-sub('.db','',chiptype)
	library(chiptype, character.only=T)
	symbol<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "SYMBOL", sep="")))))[rownames(M2),])
	genename<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "GENENAME", sep="")))))[rownames(M2),])
	
	# Fixes an issue introduced in BioC2.4 where the "#" character is introduced in some gene names
	genename <- gsub("#", "", genename)
	
	# Write data out
	write.table(data.frame(symbol, description=genename, round(M2, digits=2)), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
}

if(chiptype=="cDNA" & keep.annotations=="no") {
	write.table(data.frame(round(M2, digits=8)), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
}

if(chiptype=="cDNA" & keep.annotations=="yes") {
	write.table(data.frame(annotations, round(M2, digits=8)), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
}

# TOOL calculate-descriptive-statistics.R: "Calculate descriptive statistics" (Calculates basic descriptive statistics for all genes. These include parametric and non-parametric location and spread descriptives.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT descr-stats.tsv: descr-stats.tsv 
# OUTPUT descriptives.tsv: descriptives.tsv 
# PARAMETER calculate.descriptives.for: calculate.descriptives.for TYPE [genes: genes, chips: chips] DEFAULT genes (Descriptive statistics are calculated for...)


# Two-group parametric and non-parametric tests
# JTT 31.1.2008
# IS 1.20.2010: modified behavior for chips: now calculates the statistics for all columns

# Parameter settings (default) for testing purposes
#calculate.descriptives.for<-c("chips")

# Loads the libraries
library(genefilter)

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

if(calculate.descriptives.for=="chips") {
   dat2 <- t(dat[,sapply(dat, is.numeric)])
} else {
   dat2 <- dat[,grep("^chip\\.", names(dat))]
}

# Calculates the descriptive statistics
nc<-ncol(dat2)
rsum<-rowSums(dat2)
rmean<-rsum/nc
rsd<-rowSds(dat2)
rcv<-rsd/rmean
rstexp<-rmean/rsd
rmin<-apply(X=dat2, MARGIN=1, FUN=min)
rmax<-apply(X=dat2, MARGIN=1, FUN=max)
rrange<-rmax-rmin
rmedian<-apply(X=dat2, MARGIN=1, FUN=median)
riqr<-apply(X=dat2, MARGIN=1, FUN=IQR)

# Saving the results
if(calculate.descriptives.for=="chips") {
   write.table(data.frame(average=rmean, median=rmedian, sd=rsd, cv=rcv, st.exp=rstexp, min=rmin, max=rmax, range=rrange, iqr=riqr), file="descr-stats.tsv", sep="\t", row.names=T, col.names=T, quote=F)
   write.table(data.frame(chip.average=rmean, chip.median=rmedian, chip.sd=rsd, chip.cv=rcv, chip.st.exp=rstexp, chip.min=rmin, chip.max=rmax, chip.range=rrange, chip.iqr=riqr), file="descriptives.tsv", sep="\t", row.names=T, col.names=T, quote=F)
} else {
   write.table(data.frame(dat, average=rmean, median=rmedian, sd=rsd, cv=rcv, st.exp=rstexp, min=rmin, max=rmax, range=rrange, iqr=riqr), file="descr-stats.tsv", sep="\t", row.names=T, col.names=T, quote=F)
   write.table(data.frame(gene.average=rmean, gene.median=rmedian, gene.sd=rsd, gene.cv=rcv, gene.st.exp=rstexp, gene.min=rmin, gene.max=rmax, gene.range=rrange, gene.iqr=riqr), file="descriptives.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}

# EOF

# TOOL mothur-combine-results.R: mothur-combine-results (Combine results from two or more sequence processing runs.)
# INPUT file.txt: "Groups and taxonomy files from mothur runs" TYPE GENERIC
# INPUT phenodata.tsv: "Phenodata files for the mothur runs" TYPE GENERIC  
# OUTPUT all.tax: all.tax
# OUTPUT all.grp: all.grp
# OUTPUT phenodata-merged.tsv: phenodata.tsv


# JTT 2012-11-05


# Check the file types
files<-dir()
files<-files[-c(grep("phenodata", files))]
types<-rep(NA, length(files))
for(i in 1:length(files)) {
	d<-readLines(files[i], n=1)
	if(length(grep("Bacteria", d))==0) {
		types[i]<-"tax"
	} else {
		types[i]<-"grp"
	}
}

# Append data files
for(i in 1:length(files)) {
	d<-readLines(files[i])   
	if(types[i]=="tax") {
		write(d, "all.tax", append=TRUE)
	}
	if(types[i]=="grp") {
		write(d, "all.grp", append=TRUE)
	}
}

# Combine phenodata tables
files<-dir(pattern="phenodata")
p<-list()
for(i in 1:length(files)) {
	p[[i]]<-read.table(files[i], header=T, sep="\t")[-c(1,2),]
}
pdata<-NULL 
for(i in 1:length(p)) {
	pdata<-rbind(pdata, p[[i]])
}
write.table(pdata, file="phenodata-merged.tsv", quote=FALSE, sep="\t", na="", row.names=FALSE, col.names=TRUE)

# TOOL impute.R: "Impute missing values" (Imputation of missing values. If the maximum specified number of missing values is exceeded, the missing values for that stratum of data are not replaced with imputed values.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT imputed.tsv: imputed.tsv 
# PARAMETER imputation.method: imputation.method TYPE [mean: mean, median: median, knn: knn] DEFAULT knn (Imputation method)
# PARAMETER number.of.neighbors: number.of.neighbors TYPE INTEGER FROM 1 TO 100000 DEFAULT 5 (Number of neighbors to use for knn imputation)
# PARAMETER missing.row.max: missing.row.max TYPE PERCENT DEFAULT 20 (Maximum number of missing values on a row)
# PARAMETER missing.column.max: missing.column.max TYPE PERCENT DEFAULT 20 (Maximum number of missing values on a column)


# Imputation of missing values by mean or median
# JTT 22.6.2006
# modified, IS, 12.10.2012, to cope with tables with gene descriptions (that typically contain 's)

# Parameter settings (default) for testing purposes
#imputation.method<-c("mean")
#number.of.neighbors<-c(5)
#missing.row.max<-c(20)
#missing.column.max<-c(20)

# Renaming variables
method<-imputation.method
K<-number.of.neighbors
rmax<-missing.row.max/100
cmax<-missing.column.max/100

# Loads the file
file <- 'normalized.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, check.names=FALSE)

# Separates expression values and flags
calls <- dat[,grep('^flag', names(dat))]
dat2 <- dat[,grep('^chip', names(dat))]
# annotations<-dat[,grep("annotations", names(dat))]
annotations <- dat[,grep('^flag|^chip|^average', names(dat), invert=TRUE)]
A <- dat[,grep('^average', names(dat))]

# Inf/-Inf values replaced by NAs
dat2[is.infinite(as.matrix(dat2))]<-NA

# Imputation
if(method=="mean" | method=="median") {
	library(e1071)
	dat.impute<-impute(dat2, method)
	dat.impute<-data.frame(dat.impute, calls)
}
if(method=="knn") {
	library(impute)
	dat.impute<-impute.knn(as.matrix(dat2), k = K, rowmax = rmax, colmax = cmax, maxp = "p")
	dat.impute<-data.frame(dat.impute$data, calls)
}
if(ncol(A)>0) {
	dat.impute<-data.frame(dat.impute, A)
}

# Add the annotations and flags back into the data table
dat3 <- cbind(annotations,dat.impute)
dat4 <- cbind(dat3,calls)

# Writes a table 
options(scipen=10)
write.table(dat4, file=("imputed.tsv"), sep="\t", row.names=T, col.names=T, quote=F)

# EOF

# TOOL bwa-with-index-building.R: "BWA for single end reads and own genome" (BWA aligns reads to genomes and transcriptomes. Unlike Bowtie, it supports gapped alignments. Results are sorted and indexed bam files. 
# Note that this BWA tool requires that you have imported the reference genome to Chipster in fasta format. If you would like to align reads against publicly available genomes, please use the tool \"BWA for single end reads\".)
# INPUT reads.txt: "Reads to align" TYPE GENERIC 
# INPUT genome.txt: "Reference genome" TYPE GENERIC
# OUTPUT bwa.bam 
# OUTPUT bwa.bam.bai 
# OUTPUT bwa.log 
# PARAMETER seed.length: "Length of the seed region" TYPE INTEGER DEFAULT 32 (How many bases of the left, good quality part of the read should be used as the seed region. If the seed length is longer than the reads, the seeding will be disabled. Corresponds to the command line parameter -l.) 
# PARAMETER seed.edit: "Maximum number of of differences in the seed region" TYPE INTEGER DEFAULT 2 (Maximum number of differences such as mismatches or indels in the seed region. Corresponds to the command line parameter -k.)
# PARAMETER total.edit: "Maximum edit distance for the whole read" TYPE DECIMAL DEFAULT 0.04 ( Maximum edit distance if the value is more than one. If the value is between 1 and 0 then it defines the fraction of missing alignments given 2% uniform base error rate. In the latter case, the maximum edit distance is automatically chosen for different read lengths. Corresponds to the command line parameter -n.)
# PARAMETER quality.format: "Quality value format used" TYPE [solexa1_3: "Illumina GA v1.3 or later", sanger: Sanger] DEFAULT sanger (Note that this parameter is taken into account only if you chose to apply the mismatch limit to the seed region. Are the quality values in the Sanger format (ASCII characters equal to the Phred quality plus 33\) or in the Illumina Genome Analyzer Pipeline v1.3 or later format (ASCII characters equal to the Phred quality plus 64\)? Please see the manual for details.)
# PARAMETER OPTIONAL num.gaps: "Maximum number of gaps" TYPE INTEGER DEFAULT 1 (Maximum number of gap openings for one read. Corresponds to the command line parameter -o.)
# PARAMETER OPTIONAL num.extensions: "Maximum number of gap extensions" TYPE INTEGER DEFAULT -1 (Maximum number of gap extensions, -1 for disabling long gaps. Corresponds to the command line parameter -e.)
# PARAMETER OPTIONAL gap.opening: "Gap opening penalty " TYPE INTEGER DEFAULT 11 (Gap opening penalty. Corresponds to the command line parameter -O.)
# PARAMETER OPTIONAL gap.extension: "Gap extension penalty " TYPE INTEGER DEFAULT 4 (Gap extension penalty. Corresponds to the command line parameter -E.)
# PARAMETER OPTIONAL mismatch.penalty: "Mismatch penalty threshold" TYPE INTEGER DEFAULT 4 (BWA will not search for suboptimal hits with a score lower than the alignment score minus this. Corresponds to the command line parameter -M.)
# PARAMETER OPTIONAL disallow.gaps: "Maximum occurrences for extending a long deletion"  TYPE INTEGER DEFAULT 10 (Maximum occurrences for extending a long deletion. Corresponds to the command line parameter -d.)
# PARAMETER OPTIONAL disallow.indel: "Disallow an indel within the given number of bp towards the ends"  TYPE INTEGER DEFAULT 5 (Do not put an indel within the defined value of bp towards the ends. Corresponds to the command line parameter -i.)
# PARAMETER OPTIONAL trim.threshold: "Quality trimming threshold" TYPE INTEGER DEFAULT 0 (Quality threshold for read trimming down to 35bp. Corresponds to the command line parameter -q.)
# PARAMETER OPTIONAL barcode.length: "Barcode length"  TYPE INTEGER DEFAULT 0 (Length of barcode starting from the 5 prime end. The barcode of each read will be trimmed before mapping. Corresponds to the command line parameter -B.)
# PARAMETER OPTIONAL alignment.no: "How many valid alignments are reported per read" TYPE  INTEGER DEFAULT 3 (Maximum number of alignments to report. Corresponds to the samse command line parameter -n.)

# KM 24.8.2011
# AMS 19.6.2012 Added unzipping

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads.txt")
unzipIfGZipFile("genome.txt")

# bwa settings
bwa.binary <- file.path(chipster.tools.path, "bwa", "bwa")
bwa.index.binary <- file.path(chipster.tools.path, "bwa", "check_bwa_index.sh")
command.start <- paste("bash -c '", bwa.binary)


# Do indexing
print("Indexing the genome...")
system("echo Indexing the genome... > bwa.log")
check.command <- paste ( bwa.index.binary, "genome.txt| tail -1 ")
genome.dir <- system(check.command, intern = TRUE)
bwa.genome <- file.path( genome.dir , "genome.txt")

# mode specific parameters
if (total.edit >= 1) {
	total.edit <- round(total.edit)
}
quality.parameter <- ifelse(quality.format == "solexa1_3", "-I", "")
mode.parameters <- paste("aln -t 2 -o", num.gaps, "-e", num.extensions, "-d", disallow.gaps, "-i" , disallow.indel , "-l" , seed.length , "-k" , seed.edit , "-O" , gap.opening , "-E" , gap.extension , "-q" , trim.threshold, "-B" , barcode.length, "-M" , mismatch.penalty , "-n" , total.edit , quality.parameter)


# command ending
command.end <- paste( bwa.genome , "reads.txt 1> alignment.sai 2>> bwa.log'")
system("echo Running the alignment with command: >> bwa.log")

# run bwa alignment
bwa.command <- paste(command.start, mode.parameters, command.end)
echo.command <- paste("echo '",bwa.command ,"'  >> bwa.log")
system(echo.command)
#stop(paste('CHIPSTER-NOTE: ', bwa.command))
system(bwa.command)


# sai to sam conversion
samse.parameters <- paste("samse -n", alignment.no )
samse.end <- paste(bwa.genome, "alignment.sai reads.txt 1> alignment.sam 2>> bwa.log'" )
samse.command <- paste( command.start, samse.parameters , samse.end )
system(samse.command)

		
# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

# convert sam to bam
system(paste(samtools.binary, "view -bS alignment.sam -o alignment.bam"))

# sort bam
system(paste(samtools.binary, "sort alignment.bam alignment.sorted"))

# index bam
system(paste(samtools.binary, "index alignment.sorted.bam"))

# rename result files
system("mv alignment.sorted.bam bwa.bam")
system("mv alignment.sorted.bam.bai bwa.bam.bai")

# TOOL acgh-fetch-probe-positions-from-geo.R: "Fetch probe positions from GEO" (Fetches microarray probe positions from the GEO database.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS
# OUTPUT probe-positions.tsv: probe-positions.tsv
# PARAMETER platform: platform TYPE STRING DEFAULT GPL (The accession of the platform.)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2013-03-18

# check for valid accession
platform <- toupper(platform)
if (length(grep('^GPL[0-9]+$', platform)) == 0)
  stop('CHIPSTER-NOTE: Not a valid accession: ', platform)

file <- 'normalized.tsv'
dat2 <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, as.is=TRUE, check.names=FALSE)

# remove probe positions if already present
dat2$chromosome <- NULL
dat2$start <- NULL
dat2$end <- NULL
dat2$cytoband <- NULL

# load data
library(GEOquery)

gds <- getGEO(platform)

dat <- gds@dataTable@table
dat$chromosome <- NA
dat$start <- NA
dat$end <- NA
dat$cytoband <- NA
dat$symbol <- NA
dat$description <- NA

# annotation columns
plat <- gds@dataTable@table
colnames(plat) <- toupper(colnames(plat))

# Agilent
if ('CHROMOSOMAL_LOCATION' %in% colnames(plat)) {
  dat$chromosome <- gsub('chr|_random|_hla_hap1|_hla_hap2|:.*','', plat$CHROMOSOMAL_LOCATION)
  dat$start <- as.integer(gsub('.*:|-.*','', plat$CHROMOSOMAL_LOCATION))
  dat$end <- as.integer(gsub('.*-|','', plat$CHROMOSOMAL_LOCATION))
}
if (all(is.na(dat$chromosome)) && 'SYSTEMATICNAME' %in% colnames(plat)) {
  plat$SYSTEMATICNAME[grep('^.*:[0-9]*-[0-9]*$', plat$SYSTEMATICNAME, invert=TRUE)] <- ''
  dat$chromosome <- gsub('chr|_random|_hla_hap1|_hla_hap2|:.*','', plat$SYSTEMATICNAME)
  dat$start <- as.integer(gsub('.*:|-.*','', plat$SYSTEMATICNAME))
  dat$end <- as.integer(gsub('.*-|','', plat$SYSTEMATICNAME))
}
if (all(is.na(dat$cytoband)) && 'CYTOBAND' %in% colnames(plat))
  dat$cytoband <- gsub('hs\\|', '', plat$CYTOBAND)
if (all(is.na(dat$symbol)) && 'GENE_SYMBOL' %in% colnames(plat))
  dat$symbol <- plat$GENE_SYMBOL
if (all(is.na(dat$description)) && 'GENE_NAME' %in% colnames(plat))
  dat$description <- plat$GENE_NAME
if (all(is.na(dat$description)) && 'DESCRIPTION' %in% colnames(plat))
  dat$description <- plat$DESCRIPTION

# Nimblegen
if (all(is.na(dat$chromosome)) && 'CHROMOSOME' %in% colnames(plat))
  dat$chromosome <- plat$CHROMOSOME
if (all(is.na(dat$start)) && 'RANGE_START' %in% colnames(plat))
  dat$start <- as.integer(plat$RANGE_START)
if (all(is.na(dat$end)) && 'RANGE_END' %in% colnames(plat))
  dat$end <- as.integer(plat$RANGE_END)

# other
if (all(is.na(dat$chromosome)) && 'CHROMOSOME_NR' %in% colnames(plat))
  dat$chromosome <- plat$CHROMOSOME_NR
if (all(is.na(dat$start)) && 'START' %in% colnames(plat))
  dat$start <- as.integer(plat$START)
if (all(is.na(dat$start)) && 'POSITION' %in% colnames(plat))
  dat$start <- as.integer(plat$POSITION)
if (all(is.na(dat$start)) && 'KB POSITION' %in% colnames(plat))
  dat$start <- as.integer(plat$'KB POSITION') * 1000
if (all(is.na(dat$end)) && 'END' %in% colnames(plat))
  dat$end <- as.integer(plat$END)
if (all(is.na(dat$symbol)) && 'SYMBOL' %in% colnames(plat))
  dat$symbol <- plat$SYMBOL
if (all(is.na(dat$description)) && 'GENE_DESCRIPTION' %in% colnames(plat))
  dat$description <- plat$GENE_DESCRIPTION

# if missing, impute end column from start (assuming 60 bp probes)
if (all(is.na(dat$end)))
  dat$end <- dat$start + 60

dat3 <- cbind(dat[rownames(dat2), c('chromosome', 'start', 'end', 'cytoband', 'symbol', 'description')], dat2, row.names=rownames(dat2))

# remove empty annotation columns and clean up
for (x in c('chromosome', 'start', 'end', 'cytoband', 'symbol', 'description')) {
  if (all(is.na(dat3[,x]))) {
    dat3[,x] <- NULL
  } else {
    dat3[,x] <- gsub('"|\'|#|\t', '', dat3[,x])
  }
}

options(scipen=10)
write.table(dat3, file='probe-positions.tsv', quote=FALSE, sep='\t', col.names=TRUE, row.names=TRUE)

# EOF

# TOOL samtools-idxstats.R: "Statistics for BAM" (Counts how many alignments there are per each chromosome. Please note that in addition to BAM file you have to provide an index file for it. You can create the index file using the tool Index BAM. This tool is based on the SAMtools package.)
# INPUT alignment.bam: "BAM file" TYPE GENERIC 
# INPUT alignment.bai: "Index file .bai" TYPE GENERIC
# OUTPUT bam-stats.tsv

# EK 26.10.2011

# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

# convert sam to bam
system(paste(samtools.binary, "idxstats alignment.bam > bam-out.tsv"))

# read into R to prettify table
dat <- read.table(file="bam-out.tsv", header=FALSE, sep="\t")
colnames (dat) [1] <- "chr"
colnames (dat) [2] <- "chr_length"
colnames (dat) [3] <- "reads_mapped"
colnames (dat) [4] <- "reads_unmapped"

# output table with headers
write.table(dat, file="bam-stats.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# EOF

# TOOL edgeR-multivariate.R: "Differential expression using edgeR for multivariate experiments" (Differential expression analysis for multifactor experiments using the generalized linear models based statistical methods of the edgeR Bioconductor package. You can create the input count table and phenodata file using the tool "\Utilities - Define NGS experiment\".)
# INPUT data.tsv TYPE GENERIC
# INPUT phenodata.tsv TYPE GENERIC
# OUTPUT OPTIONAL edger-glm.tsv
# OUTPUT OPTIONAL dispersion-edger-glm.pdf
# PARAMETER main.effect1: "Main effect 1" TYPE METACOLUMN_SEL DEFAULT group (Main effect 1)
# PARAMETER OPTIONAL main.effect2: "Main effect 2" TYPE METACOLUMN_SEL DEFAULT EMPTY (Main effect 2)
# PARAMETER OPTIONAL main.effect3: "Main effect 3" TYPE METACOLUMN_SEL DEFAULT EMPTY (Main effect 3)
# PARAMETER OPTIONAL treat.main.effect1.as.factor: "Treat main effect 1 as factor" TYPE [no: no, yes: yes] DEFAULT yes (Should main.effect1 be treated as a factor)
# PARAMETER OPTIONAL treat.main.effect2.as.factor: "Treat main effect 2 as factor" TYPE [no: no, yes: yes] DEFAULT yes (Should main.effect2 be treated as a factor)
# PARAMETER OPTIONAL treat.main.effect3.as.factor: "Treat main effect 3 as factor" TYPE [no: no, yes: yes] DEFAULT yes (Should main.effect3 be treated as a factor)
# PARAMETER OPTIONAL interactions: "Include interactions in the model" TYPE [main: "no", all: "yes"] DEFAULT main (Should interactions be included in the model in addition to the main effects.)
# PARAMETER OPTIONAL normalization: "Apply TMM normalization" TYPE [yes, no] DEFAULT yes (Should normalization based on the trimmed mean of M-values \(TMM\) be performed to reduce the RNA composition effect.)
# PARAMETER OPTIONAL filter: "Analyze only genes which have counts in at least this many samples" TYPE INTEGER FROM 0 TO 1000 DEFAULT 0 (Analyze only genes which have at least 5 counts in at least this many samples)
# PARAMETER OPTIONAL w: "Plot width" TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted image)
# PARAMETER OPTIONAL h: "Plot height" TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted image)


# JTT 8.7.2012
# EK 28.4.2013 rounding added, main effect treated as factor by default
# EK 2.5.2013 updated to BioC2.11
# EK 4.5.2013 added dispersion plot and filtering


# Loads the libraries
library(edgeR)

# Loads the count data
dat <- read.table("data.tsv", header=T, sep="\t", row.names=1)

# Extracts expression value columns
annotations <- dat[,-grep("chip", names(dat))]
dat2 <- dat[,grep("chip", names(dat))]

# Reads the phenodata
phenodata <- read.table("phenodata.tsv", header=T, sep="\t")

# Forms the DGElist object
dge<-DGEList(counts=dat2)

# filter out genes which have less than 5 counts in user-defined number of samples 
if (filter > 0) {
	keep <- rowSums(dge$counts>5) >= filter
	dge <- dge[keep,]
	dge$lib.size <- colSums(dge$counts)
}

# Calculate normalization factors
if(normalization=="yes") {
   dge<-calcNormFactors(dge)
}
# For later use: filter out genes which have less than 1 cpm in user-defined number of samples 
# if (filter > 0) {
# 	keep <- rowSums(cpm(dge)>1) >= filter
# 	dge <- dge[keep,]
# 	dge$lib.size <- colSums(dge$counts)
# }

# Form a model matrix
formula<-"~"
if(main.effect1!="EMPTY" & treat.main.effect1.as.factor=="no") {
   formula<-paste(formula, main.effect1, sep="")
}
if(main.effect1!="EMPTY" & treat.main.effect1.as.factor=="yes") {
   formula<-paste(formula, "as.factor(", main.effect1, ")", sep="")
}

if(interactions=="main" & main.effect2!="EMPTY") {
   formula<-paste(formula, "+", sep="")
} 
if(interactions=="all" & main.effect2!="EMPTY") {
   formula<-paste(formula, "*", sep="")
} 
  
if(main.effect2!="EMPTY" & treat.main.effect2.as.factor=="no") {
   formula<-paste(formula, main.effect2, sep="")
}
if(main.effect2!="EMPTY" & treat.main.effect2.as.factor=="yes") {
   formula<-paste(formula, "as.factor(", main.effect2, ")", sep="")
}

if(interactions=="main" & main.effect3!="EMPTY") {
   formula<-paste(formula, "+", sep="")
} 
if(interactions=="all" & main.effect3!="EMPTY") {
   formula<-paste(formula, "*", sep="")
} 
 
if(main.effect3!="EMPTY" & treat.main.effect3.as.factor=="no") {
   formula<-paste(formula, main.effect3, sep="")
}
if(main.effect3!="EMPTY" & treat.main.effect3.as.factor=="yes") {
   formula<-paste(formula, "as.factor(", main.effect3, ")", sep="")
}

design<-with(phenodata, model.matrix(as.formula(formula)))

# Estimate dispersions
dge <- estimateGLMCommonDisp(dge, design)
dge <- estimateGLMTrendedDisp(dge, design)
dge <- estimateGLMTagwiseDisp(dge, design)

# Dispersion plot
pdf(file="dispersion-edger-glm.pdf", width=w/72, height=h/72)
plotBCV(dge, main="Biological coefficient of variation")
dev.off()

# Estimate DE genes
fit<-glmFit(dge, design)

# LRT
lrt<-glmLRT(fit, coef=1)
tt<-topTags(lrt, n=nrow(dat2))
tt<-tt@.Data[[1]]
colnames(tt)<-paste(colnames(tt), colnames(design)[1], sep="-")
ttres<-tt[order(rownames(tt)),]

for(i in 2:ncol(design)) {
   lrt<-glmLRT(fit, coef=i)
   tt<-topTags(lrt, n=nrow(dat2))
   tt<-tt@.Data[[1]]
   colnames(tt)<-paste(colnames(tt), colnames(design)[i], sep="-")
   tt<-tt[order(rownames(tt)),]
   ttres<-cbind(ttres, tt)
}

# Rounding, etc.
ttres2<-round(ttres,6)
#ttres3<-merge(dat, ttres2, by.x=0, by.y=0)

write.table(ttres2, file="edger-glm.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL combineMEDIPS.R: "Combine several MEDIPS formatted files" (Combines MEDIPS formatted files.)
# INPUT MEDIPS-input{...}.tsv: "MEDIPS files" TYPE GENERIC
# OUTPUT MEDIPS-input.tsv: "A converted BAM file suitable for MEDIPS analysis"

files<-dir(pattern=".tsv")
for(i in 1:length(files)) {
   dat<-read.table(files[i], header=F, sep="\t")
   write.table(dat, "MEDIPS-input.tsv", append=TRUE, quote=F, sep="\t", row.names=FALSE, col.names=FALSE)
}

# TOOL mothur-trimseqs-uniqueseqs.R: "Trim and filter sequences with Mothur" (Removes primers and barcodes, trims and filters reads for several criteria, and removes duplicate reads. This tool is based on the Mothur package.)
# INPUT reads.fasta: "FASTA file" TYPE FASTA
# INPUT reads.oligos: "Oligos" TYPE MOTHUR_OLIGOS
# INPUT OPTIONAL reads.qual: "QUAL file" TYPE GENERIC
# OUTPUT OPTIONAL reads.trim.unique.fasta
# OUTPUT OPTIONAL reads.trim.unique.qual
# OUTPUT OPTIONAL reads.groups
# OUTPUT OPTIONAL reads.trim.names
# OUTPUT OPTIONAL summary.trim.unique.tsv
# PARAMETER OPTIONAL flip: "Use reverse complement" TYPE [yes, no] DEFAULT no (Use reverse complement of the sequences.)
# PARAMETER OPTIONAL qaverage: "Minimum average quality of sequence" TYPE INTEGER FROM 0 TO 40 (Minimum average quality of the sequence. Sequences that have a lower average quality are dropped.)
# PARAMETER OPTIONAL qwindowaverage: "Minimum average quality of window" TYPE INTEGER (Minimum average quality score allowed over a window)
# PARAMETER OPTIONAL qwindowsize: "Window size" TYPE INTEGER (Number of bases in a window)
# PARAMETER OPTIONAL qstepsize: "Window step size" TYPE INTEGER (Number of bases to move the window over.)
# PARAMETER OPTIONAL maxambig: "Maximum ambiguous bases" TYPE INTEGER FROM 0 TO 10 (Maximum number of ambiguous bases allowed in any sequence)
# PARAMETER OPTIONAL maxhomop: "Maximum homopolymer length" TYPE INTEGER FROM 0 TO 50 (Maximum length of a homopolymer allowed in any sequence)
# PARAMETER OPTIONAL minlength: "Minimum sequence length" TYPE INTEGER FROM 0 TO 1000 (Minimum length of an allowed sequence)
# PARAMETER OPTIONAL maxlength: "Maximum sequence length" TYPE INTEGER FROM 0 TO 1000 (Maximum length of an allowed sequence)
# PARAMETER OPTIONAL pdiffs: "Maximum differences to primer sequences" TYPE INTEGER FROM 0 TO 10 (Maximum number of allowed differences to primer sequences)
# PARAMETER OPTIONAL bdiffs: "Maximum differences to barcode sequences" TYPE INTEGER FROM 0 TO 10 (Maximum number of allowed differences to barcode sequences)

# AMS 05.06.2013

# binary
binary <- c(file.path(chipster.tools.path, "mothur", "mothur"))

# Add options
trimseqs.options <- ""
trimseqs.options <- paste(trimseqs.options, "trim.seqs(fasta=reads.fasta, oligos=reads.oligos")
if (file.exists("reads.qual")){
	trimseqs.options <- paste(trimseqs.options, " qfile=reads.qual", sep=",")
}
if (flip == "yes"){
	trimseqs.options <- paste(trimseqs.options, " flip=T", sep=",")
}
if (!is.na(qaverage)){
	trimseqs.options <- paste(trimseqs.options, ", qaverage=", qaverage, sep="")
}
if (!is.na(qwindowaverage)){
	trimseqs.options <- paste(trimseqs.options, ", qwindowaverage=", qwindowaverage, sep="")
}
if (!is.na(qwindowsize)){
	trimseqs.options <- paste(trimseqs.options, ", qwindowsize=", qwindowsize, sep="")
}
if (!is.na(qstepsize)){
	trimseqs.options <- paste(trimseqs.options, ", qstepsize=", qstepsize, sep="")
}
if (!is.na(maxambig)){
	trimseqs.options <- paste(trimseqs.options, ", maxambig=", maxambig, sep="")
}
if (!is.na(maxhomop)){
	trimseqs.options <- paste(trimseqs.options, ", maxhomop=", maxhomop, sep="")
}
if (!is.na(minlength)){
	trimseqs.options <- paste(trimseqs.options, ", minlength=", minlength, sep="")
}
if (!is.na(maxlength)){
	trimseqs.options <- paste(trimseqs.options, ", maxlength=", maxlength, sep="")
}
if (!is.na(pdiffs)){
	trimseqs.options <- paste(trimseqs.options, ", pdiffs=", pdiffs, sep="")
}
if (!is.na(bdiffs)){
	trimseqs.options <- paste(trimseqs.options, ", bdiffs=", bdiffs, sep="")
}
trimseqs.options <- paste(trimseqs.options, ")", sep="")

#stop(paste('CHIPSTER-NOTE: ', trimseqs.options))

# Write batch file
write(trimseqs.options, "trim.mth", append=F)
write("unique.seqs(fasta=reads.trim.fasta)", "trim.mth", append=T)

# command
command <- paste(binary, "trim.mth")

# run
system(command)


# batch file
write("summary.seqs(fasta=reads.trim.unique.fasta)", "summary.mth", append=F)

# command
command <- paste(binary, "summary.mth", "> log_raw.txt")

# run
system(command)

# Make reads.trim.unique.qual
if (file.exists("reads.trim.qual")){
	system("grep '>' reads.trim.unique.fasta | cut -c 2- > reads.trim.unique.list")
	system("perl -ne 'if(/^>(\\S+)/){$c=$i{$1}}$c?print:chomp;$i{$_}=1 if @ARGV' reads.trim.unique.list reads.trim.qual > reads.trim.unique.qual")
}

# Postprocess output files
system("grep -A 9 Start log_raw.txt > summary.trim.unique.tsv")
#system("mv reads.trim.names reads.trim.names.txt")
#system("mv reads.groups reads.groups.txt")

# TOOL extract-features-from-BED.R: "Extract features from BED" (This tool extracts the description column, usually gene identifiers, removes duplicate entries and creates a table containing only the extracted features. The output is compatible with downstream tools.)
# INPUT bedfile.bed: "BED file with description column to extract" TYPE GENERIC 
# OUTPUT extracted-features.tsv: "Table listing the unique features found in the description column of the bed file." 

#######################################################
#                                                     #
# MG, 1.11.2011                                       #
#                                                     #
# Tool that extracts a column with genomic features   #
# from a BED file in order to make it suitable to     #
# downstream analysis.                                #
#                                                     #
#######################################################

file <- "bedfile.bed"
dat <- read.table(file=file, header=TRUE, sep="\t")
list_ids <- dat[,4]
unique_ids <- unique(list_ids)
output_table <- as.data.frame(unique_ids)
rownames(output_table) <- unique_ids
colnames(output_table) <- "id"
write.table(output_table, file="extracted-features.tsv", row.names=TRUE, col.names=TRUE, sep="\t", quote=FALSE)

# EOF

# TOOL pathways-mirna-hyperg-go.R: "GO enrichment for miRNA targets" (Performs a statistical test for enrichments of GO terms in the predicted gene targets of a list of miRNA ID:s.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT hyperg_go.tsv: hyperg_go.tsv 
# OUTPUT hyperg_go.html: hyperg_go.html 
# PARAMETER ontology: ontology TYPE [all: all, biological_process: biological_process, molecular_function: molecular_function, cellular_component: cellular_component] DEFAULT biological_process (The ontology to be analyzed.)
# PARAMETER p.value.threshold: p.value.threshold TYPE DECIMAL DEFAULT 0.05 (P-value threshold.)
# PARAMETER minimum.population: minimum.population TYPE INTEGER FROM 1 TO 1000000 DEFAULT 5 (Minimum number of genes required to be in a pathway.)
# PARAMETER conditional.testing: conditional.testing TYPE [yes: yes, no: no] DEFAULT yes (Conditional testing means that when a significant GO term is found, i.e. p-value is smaller than the specified thershold, that GO term is removed when testing the significance of its parent.)
# PARAMETER p.adjust.method: p.adjust.method TYPE [none: none, BH: BH, BY: BY] DEFAULT none (Method for adjusting the p-value in order to account for multiple testing. Because of the structure of GO, multiple testing is theoretically problematic, and using conditional.testing is a generally the preferred method. The correction can only be applied when no conditional.testing is performed.)
# PARAMETER over.or.under.representation: over.or.under.representation TYPE [over: over, under: under] DEFAULT over (Should over or under-represented classes be seeked?)
# PARAMETER species: species TYPE [human: human, mouse: mouse, rat: rat] DEFAULT human (The species for which the miRNA:s have been analyzed.)
# PARAMETER database: database TYPE [PicTar: PicTar, TargetScan: TargetScan, both: both] DEFAULT both (For human data this parameter defines whether to fetch predicted gene targets from either PicTar or TargetScan databases, or whether to restrict the enrichment analysis to those targets that are common to both databases. To last option is recommended to minimize the occurrence of false positives.)

# miRNA hypergeometric test for GO
# MG, 4.11.2009
# IS, 1.10.2010, rewritten to use GOstats
# MG, 7.3.2011, added the "database" parameter

# load packages
library(GOstats)
library(R2HTML)

# read input
dat <- read.table('normalized.tsv', header=TRUE, sep='\t', row.names=1)

# extracts identifiers
mirna_ids <- as.character(rownames(dat))

# check for conditional testing and multiple testing correction
if (conditional.testing == 'no') {
  conditional <- FALSE
} else {
  if (p.adjust.method != 'none')
    stop('CHIPSTER-NOTE: Multiple testing correction can be applied only when performing unconditional testing. Please set conditional.testing to no, or p.adjust.method to none. Usually the preferred method is to use conditional testing.')
  conditional <- TRUE
}

if (species == 'mouse') {
  library(org.Mm.eg.db)
  # targets <- miRBase2df.fun(url="ftp://ftp.sanger.ac.uk/pub/mirbase/targets/v5/arch.v5.txt.mus_musculus.zip")
  targets <- read.table(file.path(chipster.tools.path, "miRNA_mappings", "mirna_mappings_mmusculus.txt"), sep="\t")

  ensembl.to.entrez <- as.list(org.Mm.egENSEMBLTRANS2EG)
  reference.genes <- unique(unlist(ensembl.to.entrez[unique(targets$tran)]))
  selected.genes <- unique(unlist(ensembl.to.entrez[unique(targets[targets$mir %in% mirna_ids, 'tran'])]))
  
  # check that it was indeed possible to identify any targets for the
  # input list of miRNA names
  if (length (selected.genes) == 0) {
	  stop("CHIPSTER-NOTE: No target genes were found for the input list of miRNA names. Please make sure that you are using official miRNA names.")
  }
     
  annotpkg <- 'org.Mm.eg.db'
} else if (species == 'rat') {
  library(org.Rn.eg.db)
  # targets <- miRBase2df.fun(url="ftp://ftp.sanger.ac.uk/pub/mirbase/targets/v5/arch.v5.txt.rattus_norvegicus.zip")
  targets <- read.table(file.path(chipster.tools.path, "miRNA_mappings", "mirna_mappings_rnorvegicus.txt"), sep="\t")
  
  ensembl.to.entrez <- as.list(org.Rn.egENSEMBLTRANS2EG)
  reference.genes <- unique(unlist(ensembl.to.entrez[unique(targets$tran)]))
  selected.genes <- unique(unlist(ensembl.to.entrez[unique(targets[targets$mir %in% mirna_ids, 'tran'])]))

    # check that it was indeed possible to identify any targets for the
  # input list of miRNA names
  if (length (selected.genes) == 0) {
	  stop("CHIPSTER-NOTE: No target genes were found for the input list of miRNA names. Please make sure that you are using official miRNA names.")
  }
      
  annotpkg <- 'org.Rn.eg.db'
} else {
  library(RmiR.Hs.miRNA)
  library(org.Hs.eg.db)
  # load target predictions from pictar and targescan, intersect to build list of reference genes
  pictar <- dbReadTable(RmiR.Hs.miRNA_dbconn(), 'pictar')[,1:2]
  targetscan <- dbReadTable(RmiR.Hs.miRNA_dbconn(), 'targetscan')[,1:2]
  if (database == "PicTar") {
	reference.genes <- unique(pictar$gene_id)
  }
  if (database == "TargetScan") {
	reference.genes <- unique(targetscan$gene_id)
  }
  if (database == "both") {
  	reference.genes <- unique(intersect(pictar$gene_id, targetscan$gene_id))
  }

  # pick targets of the specified miRNAs
  pictar <- pictar[pictar[,1] %in% mirna_ids,]
  targetscan <- targetscan[targetscan[,1] %in% mirna_ids,]
  if (database == "PicTar") {
	  selected.genes <- unique(pictar$gene_id)
  }
  if (database == "TargetScan") {
	  selected.genes <- unique(targetscan$gene_id)
  }
  if (database == "both") {
	  selected.genes <- unique(intersect(pictar$gene_id, targetscan$gene_id))
  }  
  
  # check that it was indeed possible to identify any targets for the
  # input list of miRNA names
  if (length (selected.genes) == 0) {
	  stop("CHIPSTER-NOTE: No target genes were found for the input list of miRNA names. Please make sure that you are using official miRNA names.")
  }
    
  annotpkg <- 'org.Hs.eg.db'
}

# define the output variable
output <- data.frame(total=integer(0), expected=numeric(0), observed=integer(0), p.value=numeric(0), description=character(0), ontology=character(0))
if (ontology == 'biological_process' || ontology == 'all') {
  params <- new('GOHyperGParams', geneIds=selected.genes, universeGeneIds=reference.genes, annotation=annotpkg, ontology='BP', pvalueCutoff=p.value.threshold, conditional=conditional, testDirection=over.or.under.representation)
  go <- hyperGTest(params)
  go.table <- summary(go, pvalue=2)
  if (nrow(go.table)>0) {
    go.table$Pvalue <- p.adjust(go.table$Pvalue, method=p.adjust.method)
    go.table <- go.table[go.table$Pvalue <= p.value.threshold & go.table$Size >= minimum.population,]
    if (nrow(go.table)>0) {
      rownames(go.table) <- go.table[,1]
      go.table <- go.table[,c(6, 4, 5, 2, 7)]
      go.table$ontology <- 'biological process'
      colnames(go.table) <- colnames(output)
      output <- rbind(output, go.table)
      go.table$description <- paste('<a href="http://amigo.geneontology.org/cgi-bin/amigo/term-details.cgi?term=', rownames(go.table), '">', go.table$description, '</a>', sep='')
      HTML(go.table, file='hyperg_go.html', append=TRUE, Border=0, innerBorder=1)
    }
  }
}

if (ontology == 'molecular_function' || ontology == 'all') {
  params <- new('GOHyperGParams', geneIds=selected.genes, universeGeneIds=reference.genes, annotation=annotpkg, ontology='MF', pvalueCutoff=p.value.threshold, conditional=conditional, testDirection=over.or.under.representation)
  go <- hyperGTest(params)
  go.table <- summary(go, pvalue=2)
  if (nrow(go.table)>0) {
    go.table$Pvalue <- p.adjust(go.table$Pvalue, method=p.adjust.method)
    go.table <- go.table[go.table$Pvalue <= p.value.threshold & go.table$Size >= minimum.population,]
    if (nrow(go.table)>0) {
      rownames(go.table) <- go.table[,1]
      go.table <- go.table[,c(6, 4, 5, 2, 7)]
      go.table$ontology <- 'molecular function'
      colnames(go.table) <- colnames(output)
      output <- rbind(output, go.table)
      go.table$description <- paste('<a href="http://amigo.geneontology.org/cgi-bin/amigo/term-details.cgi?term=', rownames(go.table), '">', go.table$description, '</a>', sep='')
      HTML(go.table, file='hyperg_go.html', append=TRUE, Border=0, innerBorder=1)
    }
  }
}

if (ontology == 'cellular_component' || ontology == 'all') {
  params <- new('GOHyperGParams', geneIds=selected.genes, universeGeneIds=reference.genes, annotation=annotpkg, ontology='CC', pvalueCutoff=p.value.threshold, conditional=conditional, testDirection=over.or.under.representation)
  go <- hyperGTest(params)
  go.table <- summary(go, pvalue=2)
  if (nrow(go.table)>0) {
    go.table$Pvalue <- p.adjust(go.table$Pvalue, method=p.adjust.method)
    go.table <- go.table[go.table$Pvalue <= p.value.threshold & go.table$Size >= minimum.population,]
    if (nrow(go.table)>0) {
      rownames(go.table) <- go.table[,1]
      go.table <- go.table[,c(6, 4, 5, 2, 7)]
      go.table$ontology <- 'cellular component'
      colnames(go.table) <- colnames(output)
      output <- rbind(output, go.table)
      go.table$description <- paste('<a href="http://amigo.geneontology.org/cgi-bin/amigo/term-details.cgi?term=', rownames(go.table), '">', go.table$description, '</a>', sep='')
      HTML(go.table, file='hyperg_go.html', append=TRUE, Border=0, innerBorder=1)
    }
  }
}

# write outputs
write.table(output, file='hyperg_go.tsv', quote=FALSE, sep='\t')
if (nrow(output)==0)
  write('<html>\n\t<body>\n\t\tNo significant results found!</br />\n\t</body>\n</html>', file='hyperg_go.html')

# EOF

# TOOL norm-illumina-methylumi.R: "Illumina - methylumi pipeline" (Illumina methylation assay normalization using FinalReport files and lumi methodology. TO USE THIS, YOU NEED TO IMPORT THE FinalReport FILE DIRECTLY, NOT USING THE IMPORT TOOL.)
# INPUT chip.tsv: chip.tsv TYPE GENERIC 
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT unmethylated.tsv: unmethylated.tsv 
# OUTPUT methylated.tsv: methylated.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# OUTPUT OPTIONAL QC-plot.pdf: QC-plot.pdf 
# PARAMETER color.balance.adjustment: color.balance.adjustment TYPE [none: none, quantile: quantile, ssn: ssn] DEFAULT quantile (Adjustment of color balance)
# PARAMETER background.correction: background.correction TYPE [none: none, bgAdjust2C: bgAdjust2C, forcePositive: forcePositive] DEFAULT none (Should background adjustment be applied)
# PARAMETER normalization: normalization TYPE [none: none, quantile: quantile, ssn: ssn] DEFAULT quantile ()
# PARAMETER chiptype: chiptype TYPE [HumanMethylation27: HumanMethylation27, HumanMethylation450: HumanMethylation450] DEFAULT HumanMethylation27 (Select the correct BeadChip type)
# PARAMETER QCplots: QCplots [yes: yes, no: no] DEFAULT yes (Do you want quality control plots)
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the QC image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the QC image)


# Illumina methylation array data preprocessing and normalization for FinalReport file
# JTT 2.2.2011
# Modified 18.5.2012 by JTT


# color.balance.adjustment<-c("quantile")
# background.correction<-c("none")
# normalization<-c("quantile")
# chiptype<-c("HumanMethylation27")
# image.width<-c(600)
# image.height<-c(600)

# Renaming variables
w<-image.width
h<-image.height

# Loading libraries
library(lumi)
library(methylumi)
library(annotate)

# Converting to the correct chiptype
if(chiptype=="HumanMethylation27") {
	chiptype<-c("IlluminaHumanMethylation27k")
}
if(chiptype=="HumanMethylation450") {
	chiptype<-c("IlluminaHumanMethylation450k")
}
chiptype<-paste(chiptype, ".db", sep="")

# Loading data files
dat<-lumiMethyR("chip.tsv", lib=chiptype)

# Color balance adjustment
dat2<-lumiMethyC(dat, method=color.balance.adjustment)

# Background adjustment
if(color.balance.adjustment!="none") {
   dat3<-lumiMethyB(dat2, method=background.correction, separateColor=FALSE)
} else {
   dat3<-lumiMethyB(dat, method=background.correction, separateColor=TRUE)
}

# Normalization
dat4<-lumiMethyN(dat3, method=normalization)

# QC plots
if(QCplots=="yes") {
   pdf(file="QC-plot.pdf", width=w/72, height=h/72)
   par(mfrow=c(2,2))
   plotColorBias1D(dat, main="Unpreprocessed")
   plotColorBias1D(dat4, main="Preprocessed")
   boxplotColorBias(dat, main="Unpreprocessed")
   boxplotColorBias(dat4, main="Preprocessed")
   dev.off()
}

# Convert sample names to Chipster style
dat5<-exprs(dat4)
sample.names<-colnames(dat5)
sample.names<-paste("chip.", sample.names, sep="")
names(dat5)<-sample.names
colnames(dat5)<-sample.names

dat6<-methylated(dat4)
sample.names<-colnames(dat6)
sample.names<-paste("chip.", sample.names, sep="")
names(dat6)<-sample.names
colnames(dat6)<-sample.names

dat7<-unmethylated(dat4)
sample.names<-colnames(dat7)
sample.names<-paste("chip.", sample.names, sep="")
names(dat7)<-sample.names
colnames(dat7)<-sample.names

# Annotations
library(chiptype, character.only=T)
symbols <- unlist (lookUp(rownames(dat5), chiptype, what="SYMBOL"))
genenames <- unlist (lookUp(rownames(dat5), chiptype, what="GENENAME"))
symbols <- gsub("#", "", symbols)
genenames <- gsub("#", "", genenames)
symbols <- gsub("'", "", symbols)
genenames <- gsub("'", "", genenames)

# Write out a phenodata
group<-c(rep("", ncol(dat5)))
training<-c(rep("", ncol(dat5)))
write.table(data.frame(sample=sample.names, chiptype=chiptype, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# Write out expression data
write.table(data.frame(symbol=symbols, description=genenames, dat5), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
write.table(data.frame(symbol=symbols, description=genenames, dat6), file="methylated.tsv", col.names=T, quote=F, sep="\t", row.names=T)
write.table(data.frame(symbol=symbols, description=genenames, dat7), file="unmethylated.tsv", col.names=T, quote=F, sep="\t", row.names=T)

# TOOL plot-histogram.R: Histogram (Creates a histogram for every chip using normalized data.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT histogram.pdf: histogram.pdf 
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Histogram
# JTT 4.10.2007

# Parameter settings (default) for testing purposes
#image.width<-600
#image.height<-600

# Renaming variables
w<-image.width
h<-image.height

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Loads phenodata
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Draws the histograms
s<-ceiling(sqrt(ncol(dat2)))
titles<-gsub(" ", "", phenodata$description)

if(length(titles)==ncol(dat2)) {
   pdf(file="histogram.pdf", width=w/72, height=h/72)
   par(mfrow=c(s,s))
   for(i in 1:ncol(dat2)) {
      par(mar=c(2,2,3,0))
      hist(dat2[,i], main=titles[i], cex.main=0.80, br=100, col=1, border=1)
   }
   dev.off()
} else {
   pdf(file="histogram.pdf", width=w/72, height=h/72)
   par(mfrow=c(s,s))
   for(i in 1:ncol(dat2)) {
      par(mar=c(2,2,3,0))
      hist(dat2[,i], cex.main=0.80, br=100, col=1, border=1)
   }
   dev.off()
}

# TOOL filter-sd.R: "Filter by standard deviation" (Filtering the genes according to their standard deviation. Specify the cut-off in percents. Deviation is expressed as a percentage of data to filter out. These can be made to approximately correspond to SDs assuming normality of the data: 1SD=67%, 2SDs=95%, 3SDs=99.7%.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT sd-filter.tsv: sd-filter.tsv 
# PARAMETER percentage.to.filter.out: percentage.to.filter.out TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.997 (Percent of values to filter out)

# JTT, 13.7.2005
# Heavily modified on 7.6.2006
# Even heavier modifications on 20.9.2007
# modified, IS, 16.10.2012, to cope with tables with gene descriptions (that typically contain 's)

# Parameter settings (default) for testing purposes
#percentage.to.filter.out<-c(0.997)

# Renaming variables
percentage<-percentage.to.filter.out

# Loads the normalized data
file <- c('normalized.tsv')
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, check.names=FALSE)

# Sanity checks
if(ncol(dat)==1) {
   stop("You need to have at least two chips to apply filtering by genes!")
}

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]
calls<-data.frame(calls)
dat2<-data.frame(dat2)

# Filter
sds<-apply(as.data.frame(dat2), MARGIN=1, FUN="sd")
sel<-(sds>quantile(sds,percentage))
set<-dat[sel, ]

# Saving the results
options(scipen=10)
write.table(data.frame(set), file=("sd-filter.tsv"), sep="\t", row.names=T, col.names=T, quote=F)

# EOF

# TOOL mothur-generate-count-table: mothur-generate-count-table (Generate a table of count per taxonomic group from the combined results.)
# INPUT all.grp: "groups file" TYPE GENERIC
# INPUT all.tax: "taxonomy file" TYPE GENERIC
# OUTPUT counttable.tsv: counttable.tsv
# PARAMETER cutlevel: cutlevel TYPE INTEGER FROM 0 TO 9 DEFAULT 0 (Cut levels for taxonomic names. 0 mean retain full names, e.g. Bacteria;Actinobacteria;Actinobacteria;Coriobacteridae;Coriobacteriales;Coriobacterineae;Coriobacteriaceae;Slackia;unclassified.)


# JTT 2012-11-05


# Reads the data and tabulates it
grp<-read.table("all.grp", header=F, sep="\t")
tax<-read.table("all.tax", header=F, sep="\t")
dat<-merge(tax, grp, by.x="V1", by.y="V1")
dat2<-dat
dat2$V2.y<-gsub(".[[:digit:]]{1,}.?[[:digit:]]?)", "", as.character(dat2$V2.y))

# Cutting the taxonomic names
if(cutlevel==0) {
	dat2$newnames<-dat2$V2.y
} else {
	sp<-strsplit(dat2$V2.y, ";")
	sp2<-rep(NA, nrow(dat2))
	for(i in 1:nrow(dat2)) {
		sp2[i]<-paste(sp[[i]][1:cutlevel], collapse=";")
	}
	dat2$newnames<-sp2
}

# Creating the count table
tab<-table(dat2$V2.x, dat2$newnames)
tab2<-as.data.frame.matrix(tab)

# Writing the table to disk
write.table(tab, "counttable.tsv", col.names=T, row.names=T, sep="\t", quote=FALSE)

# TOOL ordination-nmds.R: NMDS (Non-metric multidimensional scaling. Creates a 2-dimensional representation of the arrays using Euclidean distances. Can be used for quality control.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT nmds.pdf: nmds.pdf 
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Non-metric multidimensional scaling
# JTT 14.1.2008

# MG, 15.9.2011
# Updated colors and legend

# Parameter settings (default) for testing purposes
#image.width<-c(600)
#image.height<-c(600)

# Renaming variables
w<-image.width
h<-image.height

# Loads the libraries
library(MASS)

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Loads phenodata
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")

# Calculating the distance matrix
dat2.dist<-dist(t(dat2))

# Calculating the MDS
mds<-isoMDS(dat2.dist)


# Setup sample colors according to group
if (length(levels(as.factor(phenodata$group))) > 0) {
	sample_colors <- numeric(length(phenodata$group))
	group_levels <- levels(as.factor(phenodata$group))
	group_identity <- as.character(phenodata$group)
	for (count_levels in 1:length(group_levels)) {
		for (count_samples in 1:length(phenodata$group)) {
			if(group_identity[count_samples]==group_levels[count_levels]) sample_colors[count_samples] <- 1+count_levels
		}
	}
	level_colors <- levels(as.factor(sample_colors))
}
if (length(levels(as.factor(phenodata$group))) == 0) {
	sample_colors <- rep(2,length(phenodata$group))
}


# Plotting the image
pdf(file="nmds.pdf", width=w/72, height=h/72)
plot(mds$points[,1], mds$points[,2], main="NMDS", pch=19, xlab="Dimension 1", ylab="Dimension 2", type="n")
text(mds$points[,1], mds$points[,2], phenodata$description, cex=0.75, col=sample_colors)
if (length(levels(as.factor(phenodata$group))) > 0) {
	legend (x="topleft", legend=group_levels, col=level_colors, cex=0.5, pch=19)
}
dev.off()

# TOOL qc-affy-exon-rle-nuse.R: "Affymetrix exon arrays - using RLE and NUSE" (Affymetrix quality control using NUSE and RLE. This tool should be run on RAW data, i.e., CEL-files, for exon arrays. The chip type and the summary feature have to be specified.)
# INPUT microarray{...}.cel: microarray{...}.cel TYPE AFFY 
# OUTPUT rle-plot.png: rle-plot.png 
# OUTPUT nuse-plot.png: nuse-plot.png 
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)
# PARAMETER chiptype: chiptype TYPE [empty: empty, human: human, mouse: mouse, rat: rat] DEFAULT empty ()
# PARAMETER summary.feature: summary.feature TYPE [gene: gene, exon: exon] DEFAULT gene (Output summary type)

# Affymetrix quality control
# MG 12.1.2010

# Loading the libraries
library(affy)
library(affyPLM)

# Renaming variables
w<-image.width
h<-image.height

# Reading in data
dat<-ReadAffy()

# Set up proper cdf package information

if(chiptype=="empty") {
	stop("You need to specify the chiptype. Please run the script again.")
}
if(chiptype=="human" & summary.feature=="exon") {
	dat@cdfName<-"exon.pmcdf"
	dat@annotation<-"exon.pmcdf"
}
if(chiptype=="mouse" & summary.feature=="exon") {
	dat@cdfName<-"mouseexonpmcdf"
	dat@annotation<-"mouseexonpmcdf"
}
if(chiptype=="rat" & summary.feature=="exon") {
	dat@cdfName<-"ratexonpmcdf"
	dat@annotation<-"ratexonpmcdf"
}

if(chiptype=="human" & summary.feature=="gene") {
	dat@cdfName<-"huex10stv2hsentrezgcdf"
	dat@annotation<-"huex10stv2hsentrezg.db"
}
if(chiptype=="mouse" & summary.feature=="gene") {
	dat@cdfName<-"moex10stv1mmentrezgcdf"
	dat@annotation<-"moex10stv1mmentrezg.db"
}
if(chiptype=="rat" & summary.feature=="gene") {
	dat@cdfName<-"raex10stv1rnentrezgcdf"
	dat@annotation<-"raex10stv1rnentrezg.db"
}
chiptype<-dat@annotation


# Calculating quality control values
aqc<-fitPLM(dat)

# Plotting the QC-values
par(mar=c(7, 4, 4, 2) + 0.1)
title <- paste("RLE\n(", summary.feature, " level)", sep="")
bitmap(file="rle-plot.png", width=w/72, height=h/72)
Mbox(aqc, main=title, las=2)
dev.off()

par(mar=c(7, 4, 4, 2) + 0.1)
title <- paste("NUSE\n(", summary.feature, " level)", sep="")
bitmap(file="nuse-plot.png", width=w/72, height=h/72)
boxplot(aqc, main=title, las=2)
dev.off()

#
# SMart Install Packages (SMIP)
#
# User friendly interface into install.packages(...) and biocLite(...)
#

# Usage examples:
#
#smart.install.bioconductor.group("lite")
#smart.install.bioconductor.repo(repo.index = 4)
#smart.install.packages(package="Matrix")
#smart.install.packages(package="pökälestatistics") # should fail
#smart.install.packages(bioconductor.package="Matrix")
#smart.install.packages(bioconductor.package="biopökäle") # should fail
#smart.install.packages(package="Matrix", bioconductor.package="biopökäle") # should fail
#smart.install.packages(url.package="http://cran.r-project.org/src/contrib/00Archive/hdrcde/hdrcde_2.15.tar.gz")


smart.install.bioconductor.group <- function(groupName = "lite", mirror=NA) {
	for (package in biocinstallPkgGroups(groupName)) {
		smart.install.packages(bioconductor.package = package, mirror = mirror)
	}
}

smart.install.bioconductor.repo <- function(repo.index, mirror=NA) {
	
	# Select the given repository
	orig.repos <- setRepositories(ind=c(repo.index))
	
	for (package in available.packages()) {
		smart.install.packages(bioconductor.package = package[1], mirror = mirror)
	}
	
	# Restore original repositories
	setRepositories(orig.repos)		
}

smart.install.packages <- function(package=NA, bioconductor.package=NA, url.package=NA, mirror=NA) {
	
	# Check parameters
	package.defs <- c(package, bioconductor.package, url.package)
	if (sum(!is.na(package.defs)) != 1) {
		stop("Must use exactly one of the alternative ways to specify the package to install")
	}

	# Check that not already installed		
	if (is.na(url.package)) {
		package.name <- package.defs[!is.na(package.defs)]
	} else {
		package.name <- gsub(".*/(.*)_.*", "\\1", url.package)
	}
	
	if (!is.installed(package.name)) {
		cat(paste("Will now install", package.name, "\n"))
	} else {
		cat(paste("Already installed", package.name, "\n"))
		return(TRUE)
	}
	
	if (!is.na(package)) {
		
		repos = ifelse(is.na(mirror), getOption("repos"), mirror)
		install.packages(packages=c(package), repos)
	
	} else if (!is.na(bioconductor.package)) {
		
		source("http://www.bioconductor.org/biocLite.R")
		if (!is.na(mirror)) {
			options("BioC_mirror" = c("Mirror"=mirror))
		}
		biocLite(bioconductor.package)
		
	} else if (!is.na(url.package)) {
		
		# Download URL to temp file, install and remove
		tempfile.path <- tempfile("package", fileext=".tar.gz")
		download.file(url=url.package, destfile=tempfile.path)
		install.packages(packages=c(tempfile.path))
		unlink(tempfile.path)
		
		
	} else {
		stop("Must specify something to install");
	}

	# Install was successfull
	return(TRUE)
}

is.installed <- function(package) {
	
	return(suppressWarnings(require(package, character.only=TRUE, warn.conflicts=FALSE, quietly=TRUE))) 		
}

# TOOL fastx-clipper.R: "Filter reads for adapters, length and Ns" (Filters reads according to user-defined adapter sequence. Clips away the adapter,
# and optionally filters out reads that are too short after clipping or contain unknown nucleotides. Adapter-only sequences are removed in the process. This tool is based on the FASTA/Q Clipper tool of the FASTX package.)
# INPUT reads.fastq TYPE GENERIC
# OUTPUT clipped.fastq
# OUTPUT clipped.log
# PARAMETER adapter: "Adapter to be removed" TYPE STRING DEFAULT CCTTAAGG (Adapter sequence that is used for filtering and that is subsequently removed.)
# PARAMETER output.options: "Output options" TYPE [clipped: "Keep only clipped reads", unclipped: "Keep only non-clipped reads", both: "Keep both clipped and non-clipped reads"] DEFAULT clipped (You can choose to keep only clipped reads (reads that contained adapter\), only non-clipped reads (reads that did not contain an adapter\) or both clipped and non-clipped reads.)
# PARAMETER minimum.alignment: "Minimum adapter alignment length" TYPE INTEGER FROM 0 DEFAULT 0 (Required minimum adapter alignment length. Maximum is adapter length. 0 means option is ignored.)
# PARAMETER OPTIONAL short: "Discard sequences shorter than" TYPE INTEGER FROM 1 DEFAULT 15 (Minimum length of sequences to keep.)
# PARAMETER OPTIONAL discard.n: "Discard sequences with Ns" TYPE [yes, no] DEFAULT yes (Keep sequences with unknown nucleotides. Default is to discard such sequences.)
# PARAMETER OPTIONAL quality.format: "Quality value format used" TYPE [sanger: Sanger, illuminaold: "Illumina GA v1.3-1.5"] DEFAULT sanger (What quality encoding is used in your FASTQ file. Select Sanger if your data comes from Illumina 1.8 or later, SOLiD or 454.)

# EK 27.6.2011
# AMS 01.11.2012: Added minimum.alignement and output.options options

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads.fastq")

# binary
binary <- c(file.path(chipster.tools.path, "fastx", "bin", "fastx_clipper"))

# options
options <- paste("")
options <- paste(options, "-a", adapter)
if (minimum.alignment > 0) {
	options <- paste(options, "-M", minimum.alignment)
}
options <- paste(options, "-l", short)
if (quality.format == "sanger") {
	options <- paste(options, "-Q 33")
}
if (discard.n == "no") {
	options <- paste(options, "-n")
}
if (output.options == "clipped") {
	options <- paste(options, "-c")
}
if (output.options == "unclipped") {
	options <- paste(options, "-C")
}

# command
command <- paste(binary, "-v", options, "-i reads.fastq -o clipped.fastq  > clipped.log")

# run
system(command)

# TOOL classification.R: Classification (Performs a classification analysis using the selected data set.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT classification.txt: classification.txt 
# PARAMETER method: method TYPE [knn: knn, lda: lda, dlda: dlda, slda: slda, qda: qda, rpart: rpart, svm: svm, lvq: lvq, naiveBayes: naiveBayes, nnet: nnet, bagging: bagging] DEFAULT knn (Analysis method)
# PARAMETER standardize: standardize TYPE [yes: yes, no: no] DEFAULT yes (Standardize genes before analysis)
# PARAMETER validation.type: validation.type TYPE [crossvalidate: crossvalidate, predict: predict] DEFAULT crossvalidate (Use crossvalidation)
# PARAMETER crossvalidation.type: crossvalidation.type TYPE [LOO: LOO] DEFAULT LOO (How to crossvalidate)
# PARAMETER feature.selection.in.crossvalidation: feature.selection.in.crossvalidation TYPE [yes: yes, no: no] DEFAULT no (Include a feature selection step in crossvalidation)
# PARAMETER feature.selection.threshold: feature.selection.threshold TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.75 (What percentage of the t-test values to discard)
# PARAMETER group.column: group.column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to test)
# PARAMETER training.column: training.column TYPE METACOLUMN_SEL DEFAULT EMPTY (Phenodata column describing the samples in the training groups)


# JTT 22.1.2009
# Prediction has not yet been implemented!

# Parameter settings (default) for testing purposes
#method<-"knn"
#standardize<-"yes"
#validation.type<-"crossvalidate"
#crossvalidation.type<-"LOO"
#feature.selection.in.crossvalidation<-"no"
#feature.selection.threshold<-0.75
#group.column<-"group"
#training.column<-"EMPTY"

# Loads the libraries
library(MLInterfaces)
library(genefilter)

# Transforming variable names
feature.sel.in.crossval<-feature.selection.in.crossvalidation

# Loads the data
file<-c("normalized.tsv")
dat<-read.table(file, sep="\t", header=T, row.names=1)

# Reads the phenodata table
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

date()
# Standardization
if(standardize=="yes") {
   dat2<-genescale(dat2, axis=1, method=c("Z"))
}
date()

# Creating a suitable dataset
dat3<-data.frame(group=phenodata[,grep(group.column, colnames(phenodata))], t(dat2))

# Assessory function from MLInterfaces
fsFun.rowtQ3 = function(formula, data) {
 mf = model.frame(formula, data)
 mm = model.matrix(formula, data)
 respind = attr( terms(formula, data=data), "response" )
 x = mm
 if ("(Intercept)" %in% colnames(x)) x = x[,-which(colnames(x) == "(Intercept)")]
 y = mf[, respind]
 respname = names(mf)[respind]
 nuy = length(unique(y))
 if (nuy > 2) warning("number of unique values of response exceeds 2")
 ans = abs( rowttests(t(x), factor(y), tstatOnly=TRUE)[[1]] )
 names(ans) = colnames(x)
 ans = names( ans[ which(ans > quantile(ans, feature.selection.threshold) ) ] )
 btick = function(x) paste("`", x, "`", sep="")  # support for nonsyntactic varnames
 as.formula( paste(respname, paste(btick(ans), collapse="+"), sep="~"))
}

# Performing the analysis
if(method=="knn") {
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="no") {
      fit<-MLearn(as.factor(group)~., data=dat3, knnI(k=5, l=1), xvalSpec("LOO"))
   }
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="yes") {
      fit<-MLearn(as.factor(group)~., data=dat3, knnI(k=5, l=1), xvalSpec("LOO", fsFun=fsFun.rowtQ3))
   }
}

if(method=="lda") {
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="no") {
      fit<-MLearn(as.factor(group)~., data=dat3, ldaI, xvalSpec("LOO"))
   }
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="yes") {
      fit<-MLearn(as.factor(group)~., data=dat3, ldaI, xvalSpec("LOO", fsFun=fsFun.rowtQ3))
   }
}

if(method=="dlda") {
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="no") {
      fit<-MLearn(as.factor(group)~., data=dat3, dldaI, xvalSpec("LOO"))
   }
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="yes") {
      fit<-MLearn(as.factor(group)~., data=dat3, dldaI, xvalSpec("LOO", fsFun=fsFun.rowtQ3))
   }
}

if(method=="slda") {
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="no") {
      fit<-MLearn(as.factor(group)~., data=dat3, sldaI, xvalSpec("LOO"))
   }
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="yes") {
      fit<-MLearn(as.factor(group)~., data=dat3, sldaI, xvalSpec("LOO", fsFun=fsFun.rowtQ3))
   }
}

if(method=="qda") {
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="no") {
      fit<-MLearn(as.factor(group)~., data=dat3, qdaI, xvalSpec("LOO"))
   }
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="yes") {
      fit<-MLearn(as.factor(group)~., data=dat3, qdaI, xvalSpec("LOO", fsFun=fsFun.rowtQ3))
   }
}

if(method=="rpart") {
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="no") {
      fit<-MLearn(as.factor(group)~., data=dat3, rpartI, xvalSpec("LOO"))
   }
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="yes") {
      fit<-MLearn(as.factor(group)~., data=dat3, rpartI, xvalSpec("LOO", fsFun=fsFun.rowtQ3))
   }
}

if(method=="svm") {
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="no") {
      fit<-MLearn(as.factor(group)~., data=dat3, svmI, xvalSpec("LOO"))
   }
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="yes") {
      fit<-MLearn(as.factor(group)~., data=dat3, svmI, xvalSpec("LOO", fsFun=fsFun.rowtQ3))
   }
}

if(method=="lvq") {
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="no") {
      fit<-MLearn(as.factor(group)~., data=dat3, lvqI, xvalSpec("LOO"))
   }
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="yes") {
      fit<-MLearn(as.factor(group)~., data=dat3, lvqI, xvalSpec("LOO", fsFun=fsFun.rowtQ3))
   }
}

if(method=="naiveBayes") {
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="no") {
      fit<-MLearn(as.factor(group)~., data=dat3, naiveBayesI, xvalSpec("LOO"))
   }
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="yes") {
      fit<-MLearn(as.factor(group)~., data=dat3, naiveBayesI, xvalSpec("LOO", fsFun=fsFun.rowtQ3))
   }
}

if(method=="nnet") {
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="no") {
      fit<-MLearn(as.factor(group)~., data=dat3, nnetI, xvalSpec("LOO"))
   }
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="yes") {
      fit<-MLearn(as.factor(group)~., data=dat3, nnetI, xvalSpec("LOO", fsFun=fsFun.rowtQ3))
   }
}

if(method=="bagging") {
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="no") {
      fit<-MLearn(as.factor(group)~., data=dat3, baggingI, xvalSpec("LOO"))
   }
   if(validation.type=="crossvalidate" & feature.sel.in.crossval=="yes") {
      fit<-MLearn(as.factor(group)~., data=dat3, baggingI, xvalSpec("LOO", fsFun=fsFun.rowtQ3))
   }
}

# Writing output
sink("classification.txt")
confuMat(fit)
sink()

# TOOL bedtools-fastafrombed.R: "FASTA from BED" (Extracts sequences from a FASTA file for each of the intervals defined in a BED file. The headers in the input FASTA file must exactly match the chromosome column in the BED file. This tool is based on the BEDTools package.)
# INPUT f.file: "FASTA file" TYPE GENERIC
# INPUT b.file: "BED/GFF/VCF file" TYPE GENERIC
# OUTPUT fastafrombed.txt
# PARAMETER OPTIONAL name: "Use the name field for the FASTA header" TYPE [yes, no] DEFAULT no (Use the name field for the FASTA header)
# PARAMETER OPTIONAL tab: "Write output in TAB delimited format" TYPE [yes, no] DEFAULT no (Write output in TAB delimited format. Default is FASTA format.)
# PARAMETER OPTIONAL s: "Force strandedness" TYPE [yes, no] DEFAULT no (Force strandedness. If the feature occupies the antisense strand, the sequence will be reverse complemented. By default, strand information is ignored.) 

# AMS 23.4.2012

# binary
binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "fastaFromBed"))

# options
options <- paste("")
if (name == "yes") {options <- paste(options, "-name")}
if (tab == "yes") {options <- paste(options, "-tab")}
if (s == "yes") {options <- paste(options, "-s")}

# input files
options <- paste(options, "-fi f.file", "-bed b.file", "-fo fastafrombed.txt")

# command
command <- paste(binary, options)

# run
system("dos2unix f.file")
system(command)

# TOOL dichotomize-continious-data.R: "Dichotomize continious data" (Dichotomize the data into values 0 and 1 based on a single cut-off value.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT dichotomized.tsv: dichotomized.tsv
# PARAMETER what.mode: "what mode" TYPE [absolute: absolute, relative: relative] DEFAULT relative (Determines whether to apply an absolute or relative level cut-off. If relative level is used the cut-off represents a percentile of the data distribution.)
# PARAMETER cut.off: cut-off TYPE DECIMAL FROM 0 TO 1000000 DEFAULT 50 (The absolute or relative percentage cut-off defining the data to be assigned the value of 1. The remainder of the data will be assigned the value of 0.)

# MG, 23.9.2011

# Parameter settings (default) for testing purposes
# what.mode <- "absolute"
# cut.off <- 0.2

# Loading the libraries
library(genefilter)

# Loads the normalized data
file <- c("normalized.tsv")
dat <- read.table(file, header=T, sep="\t", row.names=1)

# Extract the data and keep the rest for a while
dat2 <-dat[,grep("chip", names(dat))]
dat2 <- as.matrix(dat2)
the.rest <- dat[,-grep("chip",names(dat))]

# Sanity checks
if (what.mode == "relative" && cut.off > 100) {
	stop("CHIPSTER-NOTE: In relative mode the cut-off cannot by definition be outside the range 0-100")
}
if (ncol(dat2) == 1) {
	stop("CHIPSTER-NOTE: You need to have at least two chips to apply filtering by genes!")
}

# Figure out what value the cut-off percentile corresponds to and dichotomize
dat3 <- as.vector(dat2)
if (what.mode == "relative") {
	cutoff.value <- quantile(dat3, probs=cut.off/100)
} else {
	cutoff.value <- cut.off
}
dat4 <- ifelse((dat3>cutoff.value),1,0) 
dat5 <- matrix(dat4, ncol=dim(dat2)[2], nrow=dim(dat2)[1])
colnames(dat5) <- colnames(dat2)
rownames(dat5) <- rownames(dat2)


# Join the transformed data and the rest
if (ncol(the.rest)==0) {
	output.table <- dat5
} else {
	output.table <- cbind (as.data.frame(dat5), the.rest)
}

# Saving the results
write.table(data.frame(output.table), file=("dichotomized.tsv"), sep="\t", row.names=T, col.names=T, quote=F)

# TOOL promoter-ensembl-clover.R: "Clover with Ensembl" (Clover Cis eLement OVERrepresentation, see cagt.bu.edu page Clover_about for more information. Includes Ensembl database for Human and Mouse. Made by Mandy.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT outputclover.txt: outputclover.txt 
# PARAMETER species: species TYPE [human: human, mouse: mouse, rat: rat, drosophila: drosophila, yeast: yeast] DEFAULT human ()
# PARAMETER size: size TYPE [small: small, medium: medium, large: large] DEFAULT small (Length of upstream sequences)
# PARAMETER RCrawS: RCrawS TYPE INTEGER FROM 0 TO 100 DEFAULT 0 (Number of randomized control raw scores to calculate for comparison with each target raw score. Setting zero will disclude this function)
# PARAMETER Pvalue: Pvalue TYPE INTEGER FROM 0 TO 100 DEFAULT 0 (P-value threshold: only print results for motifs whose P-values don't exceed this amount. Setting zero will disclude this function)
# PARAMETER STPrintingLoc: STPrintingLoc TYPE INTEGER FROM 0 TO 200 DEFAULT 0 (Score threshold for printing locations of significant motifs. This parameter doesn't affect raw score and P-value calculations, just which motif instances get printed. Setting zero will disclude this function)
# PARAMETER nucShuffles: nucShuffles TYPE [yes: yes, no: no] DEFAULT no (Perform sequence shuffles)
# PARAMETER DenucRandomization: DenucRandomization TYPE [yes: yes, no: no] DEFAULT no (Perform dinucleotide randomizations.)
# PARAMETER MotifShuffles: MotifShuffles TYPE [yes: yes, no: no] DEFAULT no (Perform Motif Shuffles.)
# PARAMETER MaskLowercase: MaskLowercase TYPE [yes: yes, no: no] DEFAULT no (Mask any lowercase letters in the target sequences and background sequences, if any. Lowercase letters are often used to indicate repetitive elements)
# PARAMETER Database.Selection: Database.Selection TYPE [ucsc: ucsc] DEFAULT ucsc (Database to query)
# PARAMETER upstreamc: upstreamc TYPE INTEGER FROM 1 TO 2000 DEFAULT 500 (How many upstream)
# PARAMETER downstreamc: downstreamc TYPE INTEGER FROM 0 TO 1500 DEFAULT 0 (How many downstream)
# PARAMETER Motifs: Motifs TYPE [jaspar: jaspar] DEFAULT jaspar ( What form you would like the motifs to be in, Jasper MAO or regular)

# MbyM 2-2-09

# Sets up the path to the promoter sequences
path.seq<-c("/home/s2686739/Desktop/Dataforchipster/promodata/")

# Sets up the path to ClusterBuster executable
path.cbust<-c("/home/s2686739/Desktop/Dataforchipster/clover")


# Sets up the path to Jaspar Core matrix file
path.jaspar<-c("/home/s2686739/Desktop/Dataforchipster/jaspar2005core.txt")
if(Motifs=="regular"){
	path.jaspar<-c("/home/s2686739/Desktop/Dataforchipster/jaspar2005coredifnames.txt")
}


# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Read phenodata and extracts chip information
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
chip<-phenodata$chiptype[1]
if (Database.Selection=="ensembl"){
	env<-chip
}else{
	if(species=="drosophila") {
  		 env<-paste(chip, "ACCNUM", sep="")
	} else {
   		env<-paste(chip, "REFSEQ", sep="")
	}
}
env <- sub( ".db", "", env) # if chip contained ".db", remove it

genes<-row.names(dat2)
lib<-as.character(chip)

# Account for the fact that annotation packages are from version 2.3 of Bioconductor
# named with an ".db" suffix. Add the suffix when missing to support data files
# from Chipster 1.3 and earlier. 
if (length(grep(".db", lib)) == 0 & length(grep("pmcdf", lib)) == 0) {
        lib <- paste(lib, ".db", sep="")
}

library(package=lib, character.only=T)
if (Database.Selection=="ucsc"){
	refseq<-as.vector(unlist(mget(genes, envir=get(env))))
	refseq<-unique(refseq)
}else{
	refseq<-row.names(dat)
}
if(Database.Selection=="ensembl"){
	if (species=="mouse"){
		upstream<-read.table(file.path(path.seq, "Ensemblpromodata/MouseEnsembl2000up1700down.tsv"), header=T, sep="\t")	
	}else{
		upstream<-read.table(file.path(path.seq, "Ensemblpromodata/HumanEnsembl2000up1700down.tsv"), header=T, sep="\t")
	}
	w<-c()
	for(i in 1:length(refseq)) {
		if (species=="human"){
   			w<-c(w, which(upstream@row.names==refseq[i]))
		}else{
			w<-c(w, which(upstream[,1]==refseq[i]))
		}
	}
	# Making Seq files
	for(i in 1:length(w)) {
		up<-(2000 - upstreamc)
		down<-(2000 + downstreamc)
		print(w)
		#unlink("seqs.txt")
		if (species=="mouse"){
			d<-(upstream[w[i],2])
  			write(file="seqs.txt", paste(">", upstream[w[i],1], sep=""), append=TRUE)
   			write(file="seqs.txt", paste(substr(d,up,down), sep=""), append=TRUE)
		}else{
			d<-(upstream[w[i],1])
  		 	write(file="seqs.txt", paste(">", upstream@row.names[w[i]], sep=""), append=TRUE)
   			write(file="seqs.txt", paste(substr(d,up,down), sep=""), append=TRUE)
		}
	}

}else{

	if(species=="human" & size=="small") {
   		upstream<-read.table(file.path(path.seq, "hg18/UCSC_Build_36.1_hg18_upstream1000.tsv"), header=T, sep="\t")
	}
	if(species=="human" & size=="medium") {
   		upstream<-read.table(file.path(path.seq, "hg18/UCSC_Build_36.1_hg18_upstream2000.tsv"), header=T, sep="\t")
	}
	if(species=="human" & size=="large") {
   		upstream<-read.table(file.path(path.seq, "hg18/UCSC_Build_36.1_hg18_upstream5000.tsv"), header=T, sep="\t")
	}
	if(species=="mouse" & size=="small") {
   		upstream<-read.table(file.path(path.seq, "mm8/UCSC_Build_36_mm8_upstream1000.tsv"), header=T, sep="\t")
	}
	if(species=="mouse" & size=="medium") {
  		 upstream<-read.table(file.path(path.seq, "mm8/UCSC_Build_36_mm8_upstream2000.tsv"), header=T, sep="\t")
	}
	if(species=="mouse" & size=="large") {
   		upstream<-read.table(file.path(path.seq, "mm8/UCSC_Build_36_mm8_upstream5000.tsv"), header=T, sep="\t")
	}
	if(species=="rat" & size=="small") {
   		upstream<-read.table(file.path(path.seq, "Rat/UCSC_rn4_upstream1000.tsv"), header=T, sep="\t")
	}
	if(species=="rat" & size=="medium") {
   		upstream<-read.table(file.path(path.seq, "Rat/UCSC_rn4_upstream2000.tsv"), header=T, sep="\t")
	}
	if(species=="rat" & size=="large") {
   		upstream<-read.table(file.path(path.seq, "Rat/UCSC_rn4_upstream5000.tsv"), header=T, sep="\t")
	}
	if(species=="drosophila" & size=="small") {
   		upstream<-read.table(file.path(path.seq, "Drosophila_upstream1000.tsv"), header=T, sep="\t")
	}
	if(species=="drosophila" & size=="medium") {
   		upstream<-read.table(file.path(path.seq, "Drosophila_upstream2000.tsv"), header=T, sep="\t")
	}
	if(species=="drosophila" & size=="large") {
   		upstream<-read.table(file.path(path.seq, "Drosophila_upstream5000.tsv"), header=T, sep="\t")
	}
	if(species=="yeast" & size=="small") {
   		upstream<-read.table(file.path(path.seq, "yeast/NCBI_sc_upstream500.tsv"), header=T, sep="\t")
	}
	if(species=="yeast" & size=="medium") {
   		upstream<-read.table(file.path(path.seq, "yeast/NCBI_sc_upstream1000.tsv"), header=T, sep="\t")
	}
	if(species=="yeast" & size=="large") {
   		upstream<-read.table(file.path(path.seq, "yeast/NCBI_sc_upstream2500.tsv"), header=T, sep="\t")
	}
	w<-c()
	for(i in 1:length(refseq)) {
  		w<-c(w, which(upstream$RefSeq==refseq[i]))
	
	}
	#unlink("seqs.txt")
	for(i in 1:length(w)) {
  		write(file="seqs.txt", paste(">", upstream[w[i],]$RefSeq, sep=""), append=T)
   		write(file="seqs.txt", paste(upstream[w[i],]$Sequence, sep=""), append=T)
		print(upstream[w[i],]$RefSeq)
	}
}
args<-" "
if (nucShuffles=="yes"){
	args<-paste(args," -n ")
	}
if (DenucRandomization=="yes"){
	args<-paste(args," -d ")
	}
if (MotifShuffles=="yes"){
	args<-paste(args," -m ")
	}
if (MaskLowercase=="yes"){
	args<-paste(args," -l ")
	}
if (RCrawS>0){
args<-paste(args," -r ", RCrawS," ",sep="")
}
if (Pvalue>0){
args<-paste(args," -t ", Pvalue," ",sep="")
}
if (STPrintingLoc>0){
args<-paste(args," -u ", STPrintingLoc," ",sep="")
}
system("head -n 20 seqs.txt")
system(paste(path.cbust, args, path.jaspar, " seqs.txt > outputclover.txt", sep=""))

# TOOL fastx-collapser.R: "Remove duplicate reads from FASTQ or FASTA" (Collapses identical sequences in a FASTQ/FASTA file into a single sequence. The sequences are renamed with sequence number and the multiplicity value. This tool is based on the FASTA/Q Collapser tool of the FASTX package.)
# INPUT reads.fastq TYPE GENERIC
# OUTPUT duplicates-removed.fastq 
# PARAMETER quality.format: "Quality value format used" TYPE [sanger: Sanger, illuminaold: "Illumina GA v1.3-1.5"] DEFAULT sanger (What quality encoding is used in your FASTQ file. Select Sanger if your data comes from Illumina 1.8 or later, SOLiD or 454.)



# EK 12.1.2012

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads.fastq")

# binary
binary <- c(file.path(chipster.tools.path, "fastx", "bin", "fastx_collapser"))

# command
quality.scale <- ifelse(quality.format == "sanger", "-Q 33", "")
command <- paste(binary, quality.scale, "-i reads.fastq -o duplicates-removed.fastq")

# run
system(command)

# TOOL dea-cufflinks.R: "Differential expression analysis using Cufflinks"  (This tool will perform an analysis for differentially expressed genes and isoforms using the Cufflinks algorithm.)
# INPUT treatment.bam: "BAM data file for the treatment sample" TYPE GENERIC
# INPUT control.bam: "BAM data file for the control sample" TYPE GENERIC
# OUTPUT cufflinks-log.txt
# OUTPUT de-cds.tsv
# OUTPUT de-genes.tsv
# OUTPUT de-isoforms.tsv
# OUTPUT de-promoters.tsv
# OUTPUT de-splicing.tsv
# OUTPUT de-tss.tsv
# PARAMETER genome: "Genome or transcriptome" TYPE [hg19: "Human genome (hg19\)", mm9: "Mouse genome (mm9\)", rn4: "Rat genome (rn4\)"] DEFAULT mm9 (Genome or transcriptome that your reads were aligned against.)


############################################################
#                                                          #
# Analaysis workflow using Cufflinks for normalization and #
# statistical testing for finding differentially expressed #
# sequence tags mapping to novel genes, transcript         #
# isoforms and splice junctions.                           #
#                                                          #
# The tool assumes that all samples belonging to each      #
# experiment condition have been merged into one single    #
# BAM file.                                                #
#                                                          #
# MG, 21.6.2011                                            #
#                                                          #
############################################################



# Map the reads to reference genome using TopHat
tophat -r 50 -o tophat_brain /seqdata/indexes/hg19 brain_1.fq brain_2.fq
tophat -r 50 -o tophat_liver /seqdata/indexes/hg19 liver_1.fq liver_2.fq
tophat -r 50 -o tophat_heart /seqdata/indexes/hg19 heart_1.fq heart_2.fq 

# Assemble genes and transcript info for each sample using Cufflinks
cufflinks -o cufflinks_brain tophat_brain/accepted_hits.bam
cufflinks -o cufflinks_liver tophat_liver/accepted_hits.bam
cufflinks -o cufflinks_heart tophat_liver/accepted_hits.bam

# Merge the assemblies into a single gtf file
cufflinks_brain/transcripts.gtf
cufflinks_liver/transcripts.gtf
cufflinks_heart/transcripts.gtf
cuffmerge -s /seqdata/fastafiles/hg19/hg19.fa assemblies.txt

# Optional, compare merged assembly to known genes from ENSEMBL annotations
cuffcompare -s /seqdata/fastafiles/hg19/hg19.fa -r known_annotation.gtf merged_asm/merged.gtf

# Run differential expression analysis with gene and transcript discovery
# Take the merged assembly from produced in step 3 of the discovery protocol and provide it to cuffdiff along with the BAM files from TopHat:
cuffdiff merged_asm/merged.gtf liver1.bam,liver2.bam brain1.bam,brain2.bam

# Cufflinks tools setup
cufflinks.binary <- c(file.path(chipster.tools.path, "cufflinks", "cuffdiff"))
command.start <- cufflinks.binary

# Annotation file setup
annotation.path <- c(file.path(chipster.tools.path, "genomes"))
if (genome == "hg19") {
	annotation.file <- "Homo_sapiens.GRCh37.62.chr.gtf"
}
if (genome == "mm9") {
	annotation.file <- "Mus_musculus.NCBIM37.62.chr.gtf"
}
if (genome == "rn4") {
	annotation.file <- "Rattus_norvegicus.RGSC3.4.62.chr.gtf"
}
annotation.file <- c(file.path(chipster.tools.path, "genomes", annotation.file))

# Run differential expression analysis for known genes and transcript isoforms
cufflinks.parameters <- annotation.file
cufflinks.input.treatment <- "treatment.bam"
cufflinks.input.control <- "control.bam"
cufflinks.command <- paste(command.start, cufflinks.parameters, cufflinks.input.treatment, cufflinks.input.control, " > cufflinks-log.txt")
system(cufflinks.command)




# Rename output files for Chipster
system ("mv cds_exp.diff de-cds.tsv")
system ("mv gene_exp.diff de-genes.tsv")
system ("mv isoform_exp.diff de-isoforms.tsv")
system ("mv promoters.diff de-promoters.tsv")
system ("mv splicing.diff de-splicing.tsv")
system ("mv tss_group_exp.diff de-tss.tsv")

# EOF

# TOOL bedtools-overlap.R: "Overlap BED" (Computes the amount of overlap (positive values\) or distance (negative values\) between genome features and reports the result at the end of the same line. This tool is based on the BEDTools package.)
# INPUT file.a: "BED file A" TYPE GENERIC
# OUTPUT overlap.bed 
# PARAMETER cols: "Columns to use" TYPE STRING DEFAULT "2,3,6,7" (Specify the columns (1-based\) for the starts and ends of the features for which you'd like to compute the overlap/distance. The columns must be listed in the following order: start1,end1,start2,end2.)

# AMS 23.4.2012

# binary
binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "overlap"))

# optional options
options <- paste("")
options <- paste(options, "-cols", cols)

# input files
options <- paste(options,"-i file.a")

# command
command <- paste(binary, options, " > overlap.bed")

# run
system(command)
if (file.info("overlap.bed")$size == 0) {system("echo \"No results found\" > overlap.bed")}

# TOOL stat-linear-modelling.R: "Linear modelling" (Analyzes the data using linear modelling as implemented in the R package limma. You can have a maximum of three main effects and their interactions in the model. In addition, you can specify technical replication and pairing of the samples. Main effects can be fitted as such or as categorical variables, i.e., factors. Fold changes and p-values are reported for all effects and interactions.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT limma.tsv: limma.tsv 
# OUTPUT limma-design.tsv: limma-design.tsv 
# OUTPUT foldchange.tsv: foldchange.tsv 
# OUTPUT pvalues.tsv: pvalues.tsv 
# PARAMETER main.effect1: main.effect1 TYPE METACOLUMN_SEL DEFAULT group (Main effect 1)
# PARAMETER main.effect2: main.effect2 TYPE METACOLUMN_SEL DEFAULT EMPTY (Main effect 2)
# PARAMETER main.effect3: main.effect3 TYPE METACOLUMN_SEL DEFAULT EMPTY (Main effect 3)
# PARAMETER technical.replication: technical.replication TYPE METACOLUMN_SEL DEFAULT EMPTY (Technical replication)
# PARAMETER pairing: pairing TYPE METACOLUMN_SEL DEFAULT EMPTY (Paired samples)
# PARAMETER treat.main.effect1.as.factor: treat.main.effect1.as.factor TYPE [no: no, yes: yes] DEFAULT no (Should main.effect1 be treated as a factor)
# PARAMETER treat.main.effect2.as.factor: treat.main.effect2.as.factor TYPE [no: no, yes: yes] DEFAULT no (Should main.effect2 be treated as a factor)
# PARAMETER treat.main.effect3.as.factor: treat.main.effect3.as.factor TYPE [no: no, yes: yes] DEFAULT no (Should main.effect3 be treated as a factor)
# PARAMETER adjust.p.values: adjust.p.values TYPE [yes: yes, no: no] DEFAULT yes (Should the p-values be adjusted for multiple comparisons)
# PARAMETER p.value.adjustment.method: p.value.adjustment.method TYPE [none: none, bonferroni: bonferroni, holm: holm, hochberg: hochberg, BH: BH, BY: BY] DEFAULT BH (Multiple testing correction method)
# PARAMETER interactions: interactions TYPE [main: "main effects", two-way: "main effects and interactions"] DEFAULT main (What to include in the model)

# PARAMETER significance [main, interactions] DEFAULT main (Which p-values to return)


# Linear Modelling using limma
# 
# JTT, 22.10.2007
# MG, 28.3.2012, modified to handle NUID:s

#main.effect1<-"group"
#main.effect2<-"gender"
#main.effect3<-"EMPTY"
#technical.replication<-"EMPTY"
#pairing<-"EMPTY"
#treat.main.effect1.as.factor<-"yes"
#treat.main.effect2.as.factor<-"yes"
#treat.main.effect3.as.factor<-"no"
#adjust.p.values<-"yes"
#p.value.adjustment.method<-"BH"
#interactions<-"two-way"
#significance<-"interactions"


# Loads the libraries
library(limma)

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Loads phenodata
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")

# Sanity checks
if(main.effect1=="EMPTY" & main.effect2=="EMPTY" & main.effect3=="EMPTY") {
   stop("You need to specify at least one main effect! Please modify the setting accordingly, and rerun.")
}
if((main.effect2=="EMPTY" & main.effect3=="EMPTY" & interactions=="two-way") | (main.effect2=="EMPTY" & interactions=="three-way") | (main.effect3=="EMPTY" & interactions=="three-way")) {
   print("Only one main effect specified with interactions! No interactions specified for the model.")
   interactions<-c("main")
}
#if(interactions=="main" & significance=="interactions") {
#   print("Interactions can't be tested, since only main effect specified for the model!")
#   interactions<-c("main")
#}

# Extracting the variables from phenodata
main1<-phenodata[,grep(main.effect1, colnames(phenodata))]
main2<-phenodata[,grep(main.effect2, colnames(phenodata))]
main3<-phenodata[,grep(main.effect3, colnames(phenodata))]
techrep<-phenodata[,grep(technical.replication, colnames(phenodata))]
pair<-phenodata[,grep(pairing, colnames(phenodata))]

# Converting vectors to factor, if needed
if(treat.main.effect1.as.factor=="yes") {
   main1<-factor(main1)
}
if(treat.main.effect2.as.factor=="yes") {
   main2<-factor(main2)
}
if(treat.main.effect3.as.factor=="yes") {
   main3<-factor(main3)
}

# Specifying the models

# The basic models

# One main effect
if(main.effect1!="EMPTY" & main.effect2=="EMPTY" & main.effect3=="EMPTY" & technical.replication=="EMPTY" & pairing=="EMPTY") {
   design<-model.matrix(~main1)
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}
if(main.effect1=="EMPTY" & main.effect2!="EMPTY" & main.effect3=="EMPTY" & technical.replication=="EMPTY" & pairing=="EMPTY") {
   design<-model.matrix(~main2)
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}
if(main.effect1=="EMPTY" & main.effect2=="EMPTY" & main.effect3!="EMPTY" & technical.replication=="EMPTY" & pairing=="EMPTY") {
   design<-model.matrix(~main3)
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}

# Two main effects
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3=="EMPTY" & technical.replication=="EMPTY" & pairing=="EMPTY") {
   design<-model.matrix(~main1+main2)
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}
if(main.effect1!="EMPTY" & main.effect2=="EMPTY" & main.effect3!="EMPTY" & technical.replication=="EMPTY" & pairing=="EMPTY") {
   design<-model.matrix(~main1+main3)
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}
if(main.effect1=="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication=="EMPTY" & pairing=="EMPTY") {
   design<-model.matrix(~main2+main3)
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}

# Three main effects
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication=="EMPTY" & pairing=="EMPTY") {
   design<-model.matrix(~main1+main2+main3)
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}

# Two main effects and interactions
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3=="EMPTY" & technical.replication=="EMPTY" & pairing=="EMPTY" & interactions=="two-way") {
   design<-model.matrix(~main1*main2)
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}
if(main.effect1!="EMPTY" & main.effect2=="EMPTY" & main.effect3!="EMPTY" & technical.replication=="EMPTY" & pairing=="EMPTY" & interactions=="two-way") {
   design<-model.matrix(~main1*main3)
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}
if(main.effect1=="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication=="EMPTY" & pairing=="EMPTY" & interactions=="two-way") {
   design<-model.matrix(~main2*main3)
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}

# Three main effects
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication=="EMPTY" & pairing=="EMPTY") {
   design<-model.matrix(~main1+main2+main3)
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}

# Three main effects and interactions
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication=="EMPTY" & pairing=="EMPTY" & interactions=="two-way") {
   design<-model.matrix(~main1*main2*main3)
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}


# The basic models and biological replication

# Only technical replication
if(main.effect1=="EMPTY" & main.effect2=="EMPTY" & main.effect3=="EMPTY" & technical.replication!="EMPTY" & pairing=="EMPTY") {
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, block=techrep, cor=corfit$consensus) 
   fit<-eBayes(fit)
}

# One main effect and technical replication
if(main.effect1!="EMPTY" & main.effect2=="EMPTY" & main.effect3=="EMPTY" & technical.replication!="EMPTY" & pairing=="EMPTY") {
   design<-model.matrix(~main1)
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}
if(main.effect1=="EMPTY" & main.effect2!="EMPTY" & main.effect3=="EMPTY" & technical.replication!="EMPTY" & pairing=="EMPTY") {
   design<-model.matrix(~main2)
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}
if(main.effect1=="EMPTY" & main.effect2=="EMPTY" & main.effect3!="EMPTY" & technical.replication!="EMPTY" & pairing=="EMPTY") {
   design<-model.matrix(~main3)
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}

# Two main effects and technical replication
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3=="EMPTY" & technical.replication!="EMPTY" & pairing=="EMPTY") {
   design<-model.matrix(~main1+main2)
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}
if(main.effect1!="EMPTY" & main.effect2=="EMPTY" & main.effect3!="EMPTY" & technical.replication!="EMPTY" & pairing=="EMPTY") {
   design<-model.matrix(~main1+main3)
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}
if(main.effect1=="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication!="EMPTY" & pairing=="EMPTY") {
   design<-model.matrix(~main2+main3)
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}

# Three main effects and technical replication
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication!="EMPTY" & pairing=="EMPTY") {
   design<-model.matrix(~main1+main2+main3)
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}

# Two main effects and interactions and technical replication
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3=="EMPTY" & technical.replication!="EMPTY" & pairing=="EMPTY" & interactions=="two-way") {
   design<-model.matrix(~main1*main2)
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}
if(main.effect1!="EMPTY" & main.effect2=="EMPTY" & main.effect3!="EMPTY" & technical.replication!="EMPTY" & pairing=="EMPTY" & interactions=="two-way") {
   design<-model.matrix(~main1*main3)
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}
if(main.effect1=="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication!="EMPTY" & pairing=="EMPTY" & interactions=="two-way") {
   design<-model.matrix(~main2*main3)
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}

# Three main effects and technical replication
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication!="EMPTY" & pairing=="EMPTY") {
   design<-model.matrix(~main1+main2+main3)
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}

# Three main effects and interactions and technical replication
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication!="EMPTY" & pairing=="EMPTY" & interactions=="two-way") {
   design<-model.matrix(~main1*main2*main3)
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}


# Paired models

# One main effect
if(main.effect1!="EMPTY" & main.effect2=="EMPTY" & main.effect3=="EMPTY" & technical.replication=="EMPTY" & pairing!="EMPTY") {
   design<-model.matrix(~main1+factor(pair))
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}
if(main.effect1=="EMPTY" & main.effect2!="EMPTY" & main.effect3=="EMPTY" & technical.replication=="EMPTY" & pairing!="EMPTY") {
   design<-model.matrix(~main2+factor(pair))
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}
if(main.effect1=="EMPTY" & main.effect2=="EMPTY" & main.effect3!="EMPTY" & technical.replication=="EMPTY" & pairing!="EMPTY") {
   design<-model.matrix(~main3+factor(pair))
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}

# Two main effects
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3=="EMPTY" & technical.replication=="EMPTY" & pairing!="EMPTY") {
   design<-model.matrix(~main1+main2+factor(pair))
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}
if(main.effect1!="EMPTY" & main.effect2=="EMPTY" & main.effect3!="EMPTY" & technical.replication=="EMPTY" & pairing!="EMPTY") {
   design<-model.matrix(~main1+main3+factor(pair))
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}
if(main.effect1=="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication=="EMPTY" & pairing!="EMPTY") {
   design<-model.matrix(~main2+main3+factor(pair))
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}

# Three main effects
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication=="EMPTY" & pairing!="EMPTY") {
   design<-model.matrix(~main1+main2+main3+factor(pair))
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}

# Two main effects and interactions
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3=="EMPTY" & technical.replication=="EMPTY" & pairing!="EMPTY" & interactions=="two-way") {
   design<-model.matrix(~main1*main2+factor(pair))
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}
if(main.effect1!="EMPTY" & main.effect2=="EMPTY" & main.effect3!="EMPTY" & technical.replication=="EMPTY" & pairing!="EMPTY" & interactions=="two-way") {
   design<-model.matrix(~main1*main3+factor(pair))
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}
if(main.effect1=="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication=="EMPTY" & pairing!="EMPTY" & interactions=="two-way") {
   design<-model.matrix(~main2*main3+factor(pair))
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}

# Three main effects
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication=="EMPTY" & pairing!="EMPTY") {
   design<-model.matrix(~main1+main2+main3+factor(pair))
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}

# Three main effects and interactions
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication=="EMPTY" & pairing!="EMPTY" & interactions=="two-way") {
   design<-model.matrix(~main1*main2*main3+factor(pair))
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
}

# The basic models and biological replication

# Only technical replication
if(main.effect1=="EMPTY" & main.effect2=="EMPTY" & main.effect3=="EMPTY" & technical.replication!="EMPTY" & pairing!="EMPTY") {
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, block=techrep, cor=corfit$consensus) 
   fit<-eBayes(fit)
}

# One main effect and technical replication
if(main.effect1!="EMPTY" & main.effect2=="EMPTY" & main.effect3=="EMPTY" & technical.replication!="EMPTY" & pairing!="EMPTY") {
   design<-model.matrix(~main1+factor(pair))
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}
if(main.effect1=="EMPTY" & main.effect2!="EMPTY" & main.effect3=="EMPTY" & technical.replication!="EMPTY" & pairing!="EMPTY") {
   design<-model.matrix(~main2+factor(pair))
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}
if(main.effect1=="EMPTY" & main.effect2=="EMPTY" & main.effect3!="EMPTY" & technical.replication!="EMPTY" & pairing!="EMPTY") {
   design<-model.matrix(~main3+factor(pair))
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}

# Two main effects and technical replication
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3=="EMPTY" & technical.replication!="EMPTY" & pairing!="EMPTY") {
   design<-model.matrix(~main1+main2+factor(pair))
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}
if(main.effect1!="EMPTY" & main.effect2=="EMPTY" & main.effect3!="EMPTY" & technical.replication!="EMPTY" & pairing!="EMPTY") {
   design<-model.matrix(~main1+main3+factor(pair))
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}
if(main.effect1=="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication!="EMPTY" & pairing!="EMPTY") {
   design<-model.matrix(~main2+main3+factor(pair))
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}

# Three main effects and technical replication
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication!="EMPTY" & pairing!="EMPTY") {
   design<-model.matrix(~main1+main2+main3+factor(pair))
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}

# Two main effects and interactions and technical replication
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3=="EMPTY" & technical.replication!="EMPTY" & pairing!="EMPTY" & interactions=="two-way") {
   design<-model.matrix(~main1*main2+factor(pair))
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}
if(main.effect1!="EMPTY" & main.effect2=="EMPTY" & main.effect3!="EMPTY" & technical.replication!="EMPTY" & pairing!="EMPTY" & interactions=="two-way") {
   design<-model.matrix(~main1*main3+factor(pair))
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}
if(main.effect1=="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication!="EMPTY" & pairing!="EMPTY" & interactions=="two-way") {
   design<-model.matrix(~main2*main3+factor(pair))
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}

# Three main effects and technical replication
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication!="EMPTY" & pairing!="EMPTY") {
   design<-model.matrix(~main1+main2+main3+factor(pair))
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}

# Three main effects and interactions and technical replication
if(main.effect1!="EMPTY" & main.effect2!="EMPTY" & main.effect3!="EMPTY" & technical.replication!="EMPTY" & pairing!="EMPTY" & interactions=="two-way") {
   design<-model.matrix(~main1*main2*main3+factor(pair))
   corfit<-duplicateCorrelation(dat2, ndups=1, block=techrep)
   fit<-lmFit(dat2, design, block=techrep, cor=corfit$consensus)
   fit<-eBayes(fit)
}


# Extracting data
## New method ##
m<-matrix(nrow=nrow(dat2), ncol=ncol(design))
mm<-matrix(nrow=nrow(dat2), ncol=ncol(design))
for(i in 1:ncol(design)) {
   pp<-toptable(fit, coef=i, number=nrow(dat2), adjust.method=p.value.adjustment.method, sort.by="p")
   if(adjust.p.values=="yes") {
      pp2<-pp$adj.P.Val
   }
   if(adjust.p.values=="no") {
      pp2<-pp$P.Value
   }
   pp3<-pp$logFC
   pp2<-pp2[order(as.numeric(rownames(pp)))]
   pp3<-pp3[order(as.numeric(rownames(pp)))]
   m[,(i)]<-pp2
   mm[,(i)]<-pp3
   rownames(pp)<-rownames(dat2[as.numeric(rownames(pp)),])
}


# Writing the data to disk
m<-data.frame(m)
mm<-data.frame(mm)

# Fold change
fc<-mm
colnames(fc)<-paste("FC.", colnames(design), sep="")
fc2<-mm
fc2<-data.frame(round(fc2[,-1], digits=2))
colnames(fc2)<-paste("chip.", colnames(design)[-1], sep="")
rownames(fc2)<-rownames(dat)

# P-values
pvalues<-m
colnames(pvalues)<-paste("p.adjusted.", colnames(design), sep="")
pvalues2<-data.frame(pvalues)
pvalues2<-data.frame(round(pvalues2[,-1], digits=6))
colnames(pvalues2)<-paste("chip.p.adjusted.", colnames(design)[-1], sep="")
rownames(pvalues2)<-rownames(dat)
pvaluesrounded<-round(pvalues, digits=6)
fcrounded<-round(fc, digits=2)

# Create data frames
dat3<-cbind(dat, pvaluesrounded, fcrounded)

# Write data to disk
write.table(dat3, file="limma.tsv", sep="\t", row.names=T, col.names=T, quote=F)
write.table(design, file="limma-design.tsv", sep="\t", row.names=F, col.names=T, quote=F)
write.table(fc2, file="foldchange.tsv", sep="\t", row.names=T, col.names=T, quote=F)
write.table(pvalues2, file="pvalues.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL filter-by-column-value.R: "Filter using a column value" (Allows the user to filter the genes on the basis of one numerical column.)
# INPUT normalized.tsv: normalized.tsv TYPE GENERIC 
# OUTPUT column-value-filter.tsv: column-value-filter.tsv
# PARAMETER column: column TYPE COLUMN_SEL (Data column to filter by)
# PARAMETER cutoff: cutoff TYPE DECIMAL DEFAULT 1 (Cut-off for filtering)
# PARAMETER smaller.or.larger: smaller.or.larger TYPE [equal-to: equal-to, smaller-than: smaller-than, larger-than: larger-than, within: within, outside: outside] DEFAULT smaller-than (Smaller or larger than the cutoff is filtered.
# Use the "within" or "outside" options to filter symmmetrically around two cut-offs, useful for example when searching for 2-fold up- and down-regulated genes.)

# Filter on the basis of continuous values in a column
# JTT 31.1.2008
#
# MG, 2.3.2010 added the option to filter "withn" and "outside" a symmetrical
# range of values
# IS, 12.10.2010 removed the restrictive range from the cutoff parameter
# IS, 7.4.2011 fixed a bug where certain column names (e.g. 'p-value' did not work)
# modified, IS, 12.10.2012, to cope with tables with gene descriptions (that typically contain 's)

# Loads the normalized data
file <- 'normalized.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, check.names=FALSE)

# Extract the data to a vector
f <- dat[, column]
# Filters the data
if(smaller.or.larger=="equal-to") {
	dat2<-dat[which(f==cutoff),]
}
if(smaller.or.larger=="smaller-than") {
	dat2<-dat[which(f<=cutoff),]
}
if(smaller.or.larger=="larger-than") {
	dat2<-dat[which(f>=cutoff),]
}
if(smaller.or.larger=="outside") {
	cutoff_2 <- -cutoff
	dat2<-dat[which(f>=cutoff | f<=cutoff_2),]
}
if(smaller.or.larger=="within") {
	cutoff_2 <- -cutoff
	dat2<-dat[-which(f>=cutoff | f <=cutoff_2),]
}

# Writing the data to disk
options(scipen=10)
write.table(dat2, "column-value-filter.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# EOF

# TOOL norm-affy-snp.R: "Affymetrix SNP arrays" (Affymetrix SNP array preprocessing using CEL-files. Probe sets are automatically flagged using P M flags.)
# INPUT microarray{...}.cel: microarray{...}.cel TYPE AFFY 
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 


# Affymetrix SNP array normalization
# JTT 24.4.2008
#
# modified by MG, 26.10.2009
# to cope with Affymetrix Human SNP 5.0 and 6.0 arrays

# setwd(paste(getwd(), "/affy-snp", sep=""))

# Loading the libraries
library(oligo)
library(pd.mapping50k.hind240)
library(pd.mapping50k.xba240)
library(pd.mapping250k.nsp)
library(pd.mapping250k.sty)
library(pd.genomewidesnp.5)
library(pd.genomewidesnp.6)

# Setting up the path to the data files
fullFilenames <- list.celfiles(path = getwd(), full.names = TRUE)

# Calculating the genotype calls
crlmm(fullFilenames, file.path(getwd(), "crlmmResults"))
crlmmOut <- getCrlmmSummaries(file.path(getwd(), "crlmmResults"))

# Putting the data in a correct format
genotypes<-calls(crlmmOut)
flags<-confs(crlmmOut)
flags2<-flags
flags2[flags<=quantile(flags, 0.95)]<-"P"
flags2[flags>quantile(flags, 0.95)]<-"M"
colnames(genotypes)<-paste("chip.", colnames(genotypes), sep="")
colnames(flags2)<-paste("flags.", colnames(flags), sep="")

# Writes out a phenodata table
chiptype<-c(rep("affy-SNP", ncol(genotypes)))
sample<-colnames(genotypes)
group<-c(rep("", ncol(genotypes)))
write.table(data.frame(sample=sample, chiptype=chiptype, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# Writing the results into files
write.table(data.frame(genotypes, flags2), "normalized.tsv", row.names=T, col.names=T, quote=F, sep="\t")

# TOOL annotate-agilent-miRNA.R: "miRNA annotations" (Annotates the miRNA probes, and creates a web-page of links to databases with additional information.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT annot.html: annot.html 


# Agilent miRNA annotation
# JTT 20.3.2009
# modified MG 21.10.2009

#Reads the data
dat<-read.table("normalized.tsv", sep="\t", header=T)

# Extracts the identifiers
id<-as.character(rownames(dat))


# Creates an HTML page
id[id=="empty"]<-""
id2<-gsub("\\*", "", id)

write(x="<HTML>", file="annot.html", append=T) 
write(x="<BODY>", file="annot.html", append=T)
write(x="<TABLE border=1>", file="annot.html", append=T)
write(x="<CAPTION> Annotations </CAPTION>", file="annot.html", append=T)
write(x="<TR> <TH>miRBase</TH> <TH>MicroCosm predictions</TH> <TH>TargetScan predictions</TH></TR>", file="annot.html", append=T)

for(i in 1:length(id)) {
   mirbase<-paste("http://microrna.sanger.ac.uk/cgi-bin/sequences/mirna_entry.pl?acc=", id2[i], sep="")
   miranda<-paste("http://microrna.sanger.ac.uk/cgi-bin/targets/v5/hit_list.pl?genome_id=native&mirna_id=", id2[i], sep="")
   targetscan<-paste("http://www.targetscan.org/cgi-bin/vert_50/targetscan.cgi?mirg=", id2[i], sep="")

   write(x=paste("<TR> <TD><A HREF=", '"', mirbase, '"', ">", id[i], "</A> </TD> <TD><A HREF=", '"', miranda, '"', ">", id[i], "</A> </TD> <TD><A HREF=", '"', targetscan, '"', ">", id[i], "</A> </TD> </TR>", sep=""), file="annot.html", append=T)
}

write(x="</TABLE>", file="annot.html", append=T)
write(x="</BODY>", file="annot.html", append=T)
write(x="</HTML>", file="annot.html", append=T)      

# ANALYSIS Utilities/"Merge tables" (Merge two tables using row, i.e., gene names.)
# INPUT GENERIC normalized.tsv, GENERIC normalized-too.tsv OUTPUT combined.tsv
# PARAMETER include.everything [yes, no] DEFAULT no (include not matching lines into result)

# Combines two different tables using gene names
# JTT 22.10.2007

# Name of the first table
name1<-c("normalized.tsv")

# Name of the second table
name2<-c("normalized-too.tsv")

# Loads the tables
table1<-read.table(file=name1, sep="\t", header=T, row.names=1)
table2<-read.table(file=name2, sep="\t", header=T, row.names=1)

for (i in 1:ncol(table1)) {
	table1[,i] <- gsub("\t+", " ", table1[,i], perl=T)
	table1[,i] <- gsub("\n+", " ", table1[,i], perl=T)
	table1[,i] <- gsub(" +", " ", table1[,i], perl=T)
	
	table1[,i] <- gsub("\"+", ",", table1[,i], perl=T)
	table1[,i] <- gsub("\'+", ",", table1[,i], perl=T)
}

# Combines tables using row names
include=FALSE
if( include.everything == "yes" ) include=TRUE
table3<-merge(table1, table2, by.x="row.names", by.y="row.names", all=include)
row.names(table3)<-table3$Row.names
table3<-table3[-1]

# Writes out the combined table
write.table(table3, "combined.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL plot-volcano.R: "Volcano plot" (Tests whether the genes are differentially expressed using one-sample t-test, and plots the result in a form of a Volcano plot, but a table with the original data, the scaled fold change values and the adjusted p-values is also output. This tool is best suited for 2-color array data, where the comparison to a common reference is done on the array.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT volcanoP.pdf: volcanoP.pdf 
# OUTPUT volcanoSE.pdf: volcanoSE.pdf 
# OUTPUT one-sample.tsv: one-sample.tsv 
# PARAMETER p.value.threshold: p.value.threshold TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (P-value cut-off for significant results)
# PARAMETER expression.threshold: expression.threshold TYPE DECIMAL FROM -10 TO 10 DEFAULT 1 (Expression threshold for plotting)
# PARAMETER p.value.adjustment.method: p.value.adjustment.method TYPE [none: none, Bonferroni: Bonferroni, Holm: Holm, Hochberg: Hochberg, BH: BH, BY: BY] DEFAULT BH (Multiple testing correction method)
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)

# Volcano plot
# JTT 19.9.2007
#
# MG. 10.2.2011
# Added table with FC and p-values to the output
# Added p-value adjustment capability

# Renaming variables
w<-image.width
h<-image.height

# Load the libraries
library(genefilter)

# Renaming variables
pcut<-p.value.threshold
ecut<-expression.threshold

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=TRUE, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Sanity checks
if(ncol(dat2)==1) {
   stop("You need to have at least two chips to run this analysis!")
}

# Scaling the chip to a mean of 0
dat2<-genescale(dat2)

# Testing
n<-ncol(dat2)
d<-sqrt(n)
s<-rowSds(dat2)/d
m<-rowSums(dat2)/n
T<-(m-0)/s
p.raw<-(1-pt(abs(T), df=n-1))*2
p.adj <- p.adjust(p.raw, method=p.value.adjustment.method)

# Coloring the dot
cols<-rep(1, length(m))
cols[which(p.adj<=pcut & m<(-ecut))] <- 3
cols[which(p.adj<=pcut & m>ecut)] <- 2

# Plotting
pdf(file="volcanoP.pdf", width=w/72, height=h/72)
plot(m, -log10(p.adj), xlim=c(-max(m), max(m)), ylim=c(0,ceiling (max(-log10(p.adj)))), col=cols, main="Volcano plot", pch=19, xlab="Mean expression", ylab="-log10 (p)")
dev.off()

pdf(file="volcanoSE.pdf", width=w/72, height=h/72)
symbols(m, -log10(p.adj), rectangles=cbind(rep(0, length(p.adj)), s), fg=cols, xlim=c(-max(m), max(m)), ylim=c(0,ceiling (max(-log10(p.adj)))), main="Volcano plot", xlab="Mean expression", ylab="-log10 (p)")
dev.off()

# Printing output table
write.table(data.frame(dat, p.adjusted=round(p.adj, digits=6), FC=m), file="one-sample.tsv", sep="\t", row.names=TRUE, col.names=TRUE, quote=FALSE)

# TOOL tagcleaner-predict.R: "Predict primers/adaptors" (Tool will attempt to predict the tag (i.e. the primer/adapter\) at either or both sites, if possible. The algorithm implemented for the tag prediction assumes the randomness of a typical metagenome. Datasets that do not contain random sequences from organisms in an environment, but rather contain, for example, 16S data may cause incorrect detection of the tag sequences. However, the tag sequences will most likely be over-predicted and can be redefined by the user prior to data processing. The tag sequence prediction uses filtered base frequencies instead of raw base frequencies. This allows a more accurate prediction as it accounts for incomplete and shifted tag sequences. If no tags are reported, then no tags could be identified in the data set. No trimming will be performed. This tool is based on TagCleaner.)
# INPUT reads: "FASTQ/FASTA file" TYPE GENERIC
# OUTPUT OPTIONAL tag.predict.tsv
# PARAMETER input.type: "Input type" TYPE [FASTQ, FASTA] DEFAULT FASTQ (Input type.)

# AMS 2013.02.18

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads")

# binary
tagcleaner.binary <- c(file.path(chipster.tools.path, "tagcleaner", "tagcleaner.pl"))

# options
# options for input type
options <- paste("")
if (input.type == "FASTQ"){
	options <- paste(options, "-fastq reads")
}
if (input.type == "FASTA"){
	options <- paste(options, "-fasta reads")
}
# common options
options <- paste(options, "-64")
options <- paste(options, "-predict")

# command
command <- paste(tagcleaner.binary, options, "> tag.predict.tsv")

#stop(paste('CHIPSTER-NOTE: ', command))
# run
system(command)

# TOOL cluster-kmeans.R: K-Means (K-means clustering of genes. Divides the genes in the selected data set into a specified number of clusters.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT kmeans.tsv: kmeans.tsv 
# OUTPUT kmeans.pdf: kmeans.pdf 
# PARAMETER number.of.clusters: number.of.clusters TYPE INTEGER FROM 2 TO 100000 DEFAULT 5 (Number of clusters)
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the resampling image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the resampling image)


# K-means clustering
# JTT 22.6.2006

# Parameter settings (default) for testing purposes
#number.of.clusters<-10
#image.width<-600
#image.height<-600

# Renaming variables
k<-number.of.clusters
w<-image.width
h<-image.height

# Loads the data file
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Sanity checks
if(k>=nrow(dat2)) {
   stop("You have specified as many clusters as there are genes! Use a smaller number of clusters.")
}

# Calculates the K-means clustering result
# Needs a parameter k, the number of clusters
# k<-c(5)
km<-kmeans(dat2, k, iter.max=100000, nstart=min(10, nrow(dat2)))

# Plotting the clustering
max.dat2<-max(dat2)
min.dat2<-min(dat2)
pdf(file="kmeans.pdf", width=w/72, height=h/72)
par(mfrow=c(ceiling(sqrt(k)), ceiling(sqrt(k))))
for(i in 1:k) {
   matplot(t(dat2[km$cluster==i,]), type="l", main=paste("cluster:", i), ylab="log expression", col=1, lty=1, ylim=c(min.dat2, max.dat2))
}
dev.off()

# Writing a table
# Creates a table with column giving the cluster membership
dat2<-data.frame(dat, cluster=km$cluster)
write.table(dat2, "kmeans.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL mothur-process-data.R: "Mothur - process data" (This tool preprocesses the sequence files. Primers and adapters are removed, sequences are aligned against templates, chimeric sequences are removed, and finally, sequences are classified to OTUs.)
# INPUT all.fasta: "Input sequences in fasta format" TYPE GENERIC
# INPUT META phenodata.tsv: "Phenodata table phenodata.tsv" TYPE GENERIC
# INPUT all.qual: "Quality data" TYPE GENERIC
# OUTPUT OPTIONAL all.groups: all.groups
# OUTPUT OPTIONAL all.trim.unique.good.filter.unique.precluster.pick.silva.taxonomy: all.trim.unique.good.filter.unique.precluster.pick.silva.taxonomy
# OUTPUT OPTIONAL mothur-logfile.txt: mothur-logfile.txt
# PARAMETER primers: "primers" TYPE [forward: "forward-only", reverse: "reverse-only", both: "both", neither: "neither"] DEFAULT both (Primer direction)
# PARAMETER use.quality: "use.quality" TYPE [yes: "yes", no: "no"] DEFAULT yes (If the quality is turned off, the sequence quality file is not used at all, but other quality options are still enforced.)
# PARAMETER qaverage: "qaverage" TYPE INTEGER FROM 0 TO 40 DEFAULT 20 (Minimum average quality of the sequence. Sequences that have a lower average quality are dropped.)
# PARAMETER maxambig: "maxambig" TYPE INTEGER FROM 0 TO 10 DEFAULT 0 (Maximum number of ambiguous bases allowed in any sequence)
# PARAMETER maxhomop: "maxhomop" TYPE INTEGER FROM 0 TO 50 DEFAULT 8 (Maximum length of a homopolymere allowed in any sequence)
# PARAMETER minlength: "minlength" TYPE INTEGER FROM 0 TO 1000 DEFAULT 250 (Minimum length of an allowed sequence)
# PARAMETER pdiffs: "pdiffs" TYPE INTEGER FROM 0 TO 10 DEFAULT 0 (Maximum number of allowed differences to primer sequences)
# PARAMETER bdiffs: "bdiffs" TYPE INTEGER FROM 0 TO 10 DEFAULT 0 (Maximum number of allowed differences to barcode sequences)
# PARAMETER minlength.screen: "minlength.screen" TYPE INTEGER FROM 0 TO 1000 DEFAULT 0 ()
# PARAMETER maxlength.screen: "maxlength.screen" TYPE INTEGER FROM 0 TO 1000 DEFAULT 500 ()
# PARAMETER chimera.method: "chimera.method" TYPE [uchime: "uchime", chimeraslayer: "slayer", perseus: "perseus"] DEFAULT uchime ()

# JTT 2012-10-02
# KM all.groups tiedostoa ei löydi vaiheessa screen.seqs 
# Missä vika
# oligos-fitteräinti kommentoitu pois päältä.
# aikaisempi vaihe prepare data ei tee kunnollista phenodata-tiedostoa

# Set the path to the mothur executable
mothur.path<-c("/opt/chipster/tools/mothur/1.28.0")
mothur.exe<-c("mothur")
align.template.path<-c("/opt/chipster/tools/mothur/data")

# Reads the phenodata and prepares the oligos file for mothur
phenodata<-read.table("phenodata.tsv", header=T, sep="\t", comment.char="")
pdata<-data.frame(phenodata$oligo, phenodata$sequence)
pdata[,1]<-as.character(pdata[,1])
if(primers=="forward") {
	o<-which(pdata[,1]=="reverse")
	pdata[o,1]<-paste("#", pdata[o,1], sep="")
}
if(primers=="reverse") {
	o<-which(pdata[,1]=="forward")
	pdata[o,1]<-paste("#", pdata[o,1], sep="")
}
if(primers=="neither") {
	o<-which(pdata[,1]=="reverse")
	pdata[o,1]<-paste("#", pdata[o,1], sep="")
	o<-which(pdata[,1]=="forward")
	pdata[o,1]<-paste("#", pdata[o,1], sep="")
}

pdata$sample<-c(as.character(phenodata$sample))
write.table(pdata, "oligos", col.names=FALSE, row.names=FALSE, sep="\t", quote=FALSE)

####################################
#
# Prepare the batch file for mothur
#
####################################

# Remove primers, linkers, etc., and control quality
unlink("batch.mth")
write("summary.seqs(fasta=all.fasta)", "batch.mth", append=T)
if(use.quality=="yes") {
	#write(paste("trim.seqs(fasta=all.fasta, qaverage=", qaverage, ", qfile=all.qual, maxambig=", maxambig, ", maxhomop=", maxhomop, ", minlength=", minlength, ", pdiffs=", pdiffs, ", bdiffs=", bdiffs, ")", sep=""), "batch.mth", append=T)
	write(paste("trim.seqs(fasta=all.fasta, oligos=oligos, qaverage=", qaverage, ", qfile=all.qual, maxambig=", maxambig, ", maxhomop=", maxhomop, ", minlength=", minlength, ", pdiffs=", pdiffs, ", bdiffs=", bdiffs, ")", sep=""), "batch.mth", append=T)
}
if(use.quality=="no") {
	write(paste("trim.seqs(fasta=all.fasta, oligos=oligos, maxambig=", maxambig, ", maxhomop=", maxhomop, ", minlength=", minlength, ", pdiffs=", pdiffs, ", bdiffs=", bdiffs, ")", sep=""), "batch.mth", append=T)
}
write("summary.seqs(fasta=all.trim.fasta)", "batch.mth", append=T)
write("unique.seqs(fasta=all.trim.fasta)", "batch.mth", append=T)
write("summary.seqs(fasta=all.trim.unique.fasta, name=all.trim.names)", "batch.mth", append=T)
# Align sequences
write(paste("align.seqs(candidate=all.trim.unique.fasta, template=", align.template.path, "/silva.bacteria.fasta)", sep=""), "batch.mth", append=T)
write("summary.seqs(fasta=all.trim.unique.align, name=all.trim.names)", "batch.mth", append=T)
write(paste("screen.seqs(fasta=all.trim.unique.align, name=all.trim.names, group=all.groups, minlength=", minlength.screen, ", maxlength=", maxlength.screen, ")", sep=""), "batch.mth", append=T)
write("summary.seqs(fasta=all.trim.unique.good.align, name=all.trim.good.names)", "batch.mth", append=T)

# Filter and precluster
write("filter.seqs(fasta=all.trim.unique.good.align, vertical=T, trump=.)", "batch.mth", append=T)
write("unique.seqs(fasta=all.trim.unique.good.filter.fasta, name=all.trim.good.names)", "batch.mth", append=T)
write("summary.seqs(fasta=current, name=current)", "batch.mth", append=T)
write("pre.cluster(fasta=all.trim.unique.good.filter.unique.fasta, name=all.trim.unique.good.filter.names, diffs=1)", "batch.mth", append=T)
write("summary.seqs(fasta=current, name=current)", "batch.mth", append=T)

# Remove chimeric sequences
if(chimera.method=="slayer") {
	write(paste("chimera.slayer(fasta=all.trim.unique.good.filter.unique.precluster.fasta, template=", align.template.path, "/silva.gold.align, blastlocation=", mothur.path, "\\blast\\bin\\", ")", sep=""), "batch.mth", append=T)
	write("remove.seqs(accnos=all.trim.unique.good.filter.unique.precluster.slayer.accnos, fasta=all.trim.unique.good.filter.unique.precluster.fasta, name=all.trim.unique.good.filter.unique.precluster.names)", "batch.mth", append=T)
}
if(chimera.method=="perseus") {
	write(paste("chimera.perseus(fasta=all.trim.unique.good.filter.unique.precluster.fasta)", sep=""), "batch.mth", append=T)
	write("remove.seqs(accnos=all.trim.unique.good.filter.unique.precluster.perseus.accnos, fasta=all.trim.unique.good.filter.unique.precluster.fasta, name=all.trim.unique.good.filter.unique.precluster.names)", "batch.mth", append=T)
}
if(chimera.method=="uchime") {
	write(paste("chimera.uchime(fasta=all.trim.unique.good.filter.unique.precluster.fasta, template=", align.template.path, "/silva.gold.align)", sep=""), "batch.mth", append=T)
}
write("summary.seqs(fasta=all.trim.unique.good.filter.unique.precluster.pick.fasta, name=all.trim.unique.good.filter.unique.precluster.pick.names)", "batch.mth", append=T) 

# Classifying sequences
write(paste("classify.seqs(fasta=all.trim.unique.good.filter.unique.precluster.pick.fasta, template=", align.template.path, "/silva.bacteria.fasta, taxonomy=", align.template.path, "/silva.bacteria.silva.tax, iters=1000)", sep=""), "batch.mth", append=T)
#remove.lineage(fasta=stool.trim.unique.good.filter.unique.precluster.pick.fasta, name=stool.trim.unique.good.filter.unique.precluster.pick.names, group=stool.good.pick.groups, taxonomy=stool.trim.unique.good.filter.unique.precluster.pick.rdp.taxonomy, taxon=Cyanobacteria)

# Ensure that mothur quits when the run is done
write("quit()", "batch.mth", append=T)

# Runs mothur 
system(paste(mothur.path, "/", mothur.exe, " batch.mth", sep=""))
system("cat *.logfile > mothur-logfile.txt ")
system("sleep 100")
# Renames the logfile
#file.rename(dir()[grep("logfile", dir())], "mothur-logfile.txt")

# TOOL stat-sam.R: SAM (SAM analysis for one or more groups. You probably need to run this tool several times in order to get an idea of the results, since the results are reported for one delta-value at a time.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT sam.tsv: sam.tsv 
# OUTPUT sam.png: sam.png 
# OUTPUT sam-delta.pdf: sam-delta.pdf 
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to test)
# PARAMETER p.value.adjustment.method: p.value.adjustment.method TYPE [none: none, Bonferroni: Bonferroni, BH: BH] DEFAULT BH (Multiple testing correction method)
# PARAMETER p.value.threshold: p.value.threshold TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (P-value cut-off for significant results)
# PARAMETER random.number: random.number TYPE INTEGER FROM 1 TO 1000 DEFAULT 1 (Random number)
# PARAMETER number.of.delta: number.of.delta TYPE INTEGER FROM 1 TO 100 DEFAULT 10 (How many different delta values are used)
# PARAMETER delta.to.plot: delta.to.plot TYPE DECIMAL FROM 0.1 TO 100 DEFAULT 1 (Which delta value to plot or to use for reporting)


# SAM analysis

# Parameter settings (default) for testing purposes
#column<-"group"
#p.value.adjustment.method<-"BH"
#p.value.threshold<-0.05
#random.number<-1
#number.of.delta<-10
#delta.to.plot<-1

#Loading the libraries
library(multtest)
library(siggenes)

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Test needs a parameter "groups" that specifies the grouping of the samples
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
groups<-phenodata[,pmatch(column,colnames(phenodata))]

# Sanity checks
if(column=="empty") {
   print("You haven't selected a phenodata column! Using group instead.")
   groups<-phenodata$group
}

# Runs the test
samout<-sam(dat2, groups, rand=random.number, control=samControl(n.delta=number.of.delta))

# Plots the results
bitmap(file="sam.png", width=600/72, height=600/72)
plot(samout)
dev.off()

pdf(file="sam-delta.pdf", width=600/72, height=600/72)
plot(samout, delta.to.plot)
dev.off()

# Generates report
samsum<-summary(samout,delta.to.plot)
if(nrow(samsum@mat.sig)>=1) {
   dat3<-dat2[samsum@row.sig.genes,]
   dat.sig<-samsum@mat.sig[,c(1,5,6)]
   dat.sig<-dat.sig[order(dat.sig$Row),]
   dat3<-data.frame(dat3, p.adjusted=dat.sig$q.value, FoldChange=dat.sig$R.fold)
   write.table(dat3, file="sam.tsv", sep="\t", row.names=T, col.names=T, quote=F)
} else {
   write("No significant genes found *with this delta value*!", file="sam.tsv")
}

# TOOL bowtie-paired-end.R: "Bowtie for paired end reads" (Bowtie aligns reads to genomes or transcriptomes. There are two modes: mismatches are considered either throughout the read, or only in the user-defined left part of the read. In the latter case also quality values are taken into account.
# Results are sorted and indexed bam files, which are ready for viewing in the Chipster genome browser. 
# Note that this Bowtie tool uses publicly available genomes. If you would like to align reads against your own datasets, please use the tool \"Bowtie for paired-end reads and own genome\".)
# INPUT reads1.fq: "No 1 mate reads" TYPE GENERIC
# INPUT reads2.fq: "No 2 mate reads" TYPE GENERIC
# OUTPUT bowtie.bam 
# OUTPUT bowtie.bam.bai 
# OUTPUT bowtie.log 
# OUTPUT OPTIONAL unaligned_1.fq
# OUTPUT OPTIONAL unaligned_2.fq
# OUTPUT OPTIONAL multireads_1.fq
# OUTPUT OPTIONAL multireads_2.fq
# PARAMETER genome: "Genome or transcriptome" TYPE [hg19: "Human genome (hg19\)", mm9: "Mouse genome (mm9\)", mm10: "Mouse genome (mm10\)", Rattus_norvegicus.Rnor_5.0.70.dna.toplevel: "Rat genome (rn5\)", rn4: "Rat genome (rn4\)", Halorubrum_lacusprofundi_ATCC_49239: "Halorubrum lacusprofundi ATCC 49239 genome", canFam2: "Dog genome (UCSC canFam2\)", Gasterosteus_aculeatus.BROADS1.67: "Gasterosteus aculeatus genome (BROADS1.67\)", athaliana.TAIR10: "A. thaliana genome (TAIR10\)", ovis_aries_texel: "Sheep genome"] DEFAULT hg19 (Genome or transcriptome that you would like to align your reads against.)
# PARAMETER max.mismatches: "Number of mismatches allowed" TYPE [0, 1, 2, 3] DEFAULT 2 (How many mismatches are the alignments allowed to have?)
# PARAMETER limit.to.seed: "Consider mismatches only in the seed region" TYPE [yes, no] DEFAULT no (Should the mismatch limit be applied only to the left, good quality part of the read? You can define the length of this seed region with the next parameter.)
# PARAMETER seed: "Length of the seed region" TYPE INTEGER FROM 5 TO 50 DEFAULT 28 (If you have chosen to apply the mismatch limit only to the left, good quality part of the read, how many bases should be considered? The minimum length of seed region is 5.)
# PARAMETER multiread: "How many places is a read allowed to align to" TYPE [1, 2, 1000000: "no limit"] DEFAULT 1000000 (If you want to have alignments only for uniquely mapping reads, select 1.)
# PARAMETER OPTIONAL min.insert.size: "Minimum insert size" TYPE INTEGER FROM 0 TO 1000 DEFAULT 0 (The minimum insert size for valid paired-end alignments. E.g. if 60 is specified and a paired-end alignment consists of two 20-bp alignments in the appropriate orientation with a 20-bp gap between them, that alignment is considered valid.)
# PARAMETER OPTIONAL max.insert.size: "Maximum insert size" TYPE INTEGER FROM 50 TO 1500 DEFAULT 250 (The maximum insert size for valid paired-end alignments. E.g. if 100 is specified and a paired-end alignment consists of two 20-bp alignments in the proper orientation with a 60-bp gap between them, that alignment is considered valid.)
# PARAMETER OPTIONAL orientation: "Upstream-downstream mate orientation" TYPE [fr: "mate1 upstream of reverse complement of mate2 or vice versa", rf: "upstream mate1 reverse-complemented and mate2 forward-oriented"] DEFAULT fr (The upstream-downstream mate orientations for a valid paired-end alignment against the forward reference strand.)
# PARAMETER OPTIONAL quality: "Allowed total of mismatch qualities" TYPE INTEGER FROM 10 TO 100 DEFAULT 70 (What is the maximum permitted total of quality values of ALL mismatch positions throughout the read (not just in the seed region\)? Note that this parameter is taken into account only if you have chosen to apply the mismatch limit to the seed region.)
# PARAMETER OPTIONAL quality.format: "Quality value format used" TYPE [solexa1_3: "Illumina GA v1.3-1.5", sanger: Sanger] DEFAULT sanger (Note that this parameter is taken into account only if you chose to apply the mismatch limit to the seed region. Are the quality values in the Sanger format (ASCII characters equal to the Phred quality plus 33\) or in the Illumina Genome Analyzer Pipeline v1.3 or later format (ASCII characters equal to the Phred quality plus 64\)? Please see the manual for details.)
# PARAMETER OPTIONAL alignment.no: "How many valid alignments are reported per read" TYPE [1, 2, 3] DEFAULT 1 (If there are several, equally good alignments, how many should be reported?)
# PARAMETER OPTIONAL multiread.file: "Put multireads to a separate file" TYPE [yes, no] DEFAULT no (If you chose not to have alignments for reads which map to multiple positions, would you like to store these reads to a separate fastq file?)
# PARAMETER OPTIONAL unaligned.file: "Put unaligned reads to a separate file" TYPE [yes, no] DEFAULT no (Would you like to store unaligned reads to a new fastq file? Note that also multireads will be added to this file, unless you asked them to be put to a separate file.)

# EK 12.7.2011
# AMS 19.6.2012 Added unzipping
# EK 1.11.2012 fixed SAM output

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads1.fq")
unzipIfGZipFile("reads2.fq")

# bowtie
bowtie.binary <- c(file.path(chipster.tools.path, "bowtie", "bowtie"))
command.start <- paste("bash -c '", bowtie.binary)

# common parameters
common.parameters <- paste("-S", "-q", "-m", multiread, "-k", alignment.no, "-I", min.insert.size, "-X", max.insert.size)

# mode specific parameters
quality.parameter <- ifelse(quality.format == "solexa1_3", "--solexa1.3-quals", "")
orientation.parameter <- ifelse(orientation == "rf", "--rf", "")
n.mode.parameters <- paste("-n", max.mismatches, "-l", seed, "-e", quality, quality.parameter)
v.mode.parameters <- paste("-v", max.mismatches)
mode.parameters <- ifelse(limit.to.seed == "yes", n.mode.parameters, v.mode.parameters)

# output parameters
unaligned.output <- ifelse(unaligned.file == "yes", "--un unaligned.fq", "")
multiread.output <- ifelse(multiread.file == "yes", "--max multireads.fq", "")
output.parameters <- paste(unaligned.output, multiread.output)

# command ending
command.end <- paste(genome, "-1 reads1.fq -2 reads2.fq 1> alignment.sam 2> bowtie.log'")

# run bowtie
bowtie.command <- paste(command.start, common.parameters, quality.parameter, orientation.parameter, mode.parameters, output.parameters, command.end)
#stop(paste('CHIPSTER-NOTE: ', bowtie.command))
system(bowtie.command)


# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

# convert sam to bam
system(paste(samtools.binary, "view -bS -q 1 alignment.sam -o alignment.bam"))

# sort bam
system(paste(samtools.binary, "sort alignment.bam alignment.sorted"))

# index bam
system(paste(samtools.binary, "index alignment.sorted.bam"))

# rename result files
system("mv alignment.sorted.bam bowtie.bam")
system("mv alignment.sorted.bam.bai bowtie.bam.bai")

# TOOL acgh-convert-from-probes-to-genes.R: "Detect genes from called copy number data" (Using the chromosomal locations of the data points of a copy number data set, convert the data from probe/bin-based to gene-based. The probes/bins from which the copy number call for a given gene are determined as follows. If there are probes/bins overlapping with the position of the gene, they are used. In case of no overlaps, the last preceding and first tailing probe/bin are used.)
# INPUT aberrations.tsv: aberrations.tsv TYPE GENE_EXPRS 
# OUTPUT gene-aberrations.tsv: gene-aberrations.tsv 
# PARAMETER method.for.calls: "method for calls" TYPE [majority: majority, unambiguous: unambiguous] DEFAULT majority (The method majority means that if more than 50% of these probes/bins give an aberrated signal, that call is used for the gene. The unambiguous method requires that all of the probes/bins have the same call, otherwise the gene will be labeled as normal.)
# PARAMETER method.for.others: "method for others" TYPE [mean: mean, median: median] DEFAULT mean (Whether to use the mean or the median for calculating other data than copy number calls.)
# PARAMETER genome.build: "genome build" TYPE [GRCh37: GRCh37, NCBI36: NCBI36, NCBI35: NCBI35, NCBI34: NCBI34] DEFAULT GRCh37 (The genome build to use for fetching the gene coordinates.)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2013-02-24

file <- 'aberrations.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, as.is=TRUE, check.names=FALSE)

pos <- c('chromosome','start','end')
if (length(setdiff(pos, colnames(dat)))!=0)
  stop('CHIPSTER-NOTE: This script can only be run on files that have the following columns: chromosome, start, end.')

# load genes
# genes <- read.table(paste('http://www.cangem.org/download.php?platform=CG-PLM-26&flag=', genome.build, sep=''), sep='\t', header=TRUE, row.names=1, as.is=TRUE)
genes <- read.table(file.path(chipster.tools.path, 'CanGEM', 'Ensembl_Genes', paste(genome.build, '.txt', sep='')), sep='\t', header=TRUE, row.names=1, as.is=TRUE)
colnames(genes) <- tolower(colnames(genes))
colnames(genes)[colnames(genes)=='chr'] <- 'chromosome'
colnames(genes)[colnames(genes)=='band'] <- 'cytoband'
colnames(genes)[colnames(genes)=='cnv.per.mb'] <- 'cnv.per.Mb'

# remove genes from chromosomes not present in the array data
genes <- genes[genes$chromosome %in% dat$chromosome,]

# define the functions for calculating gene copy numbers from probe/bin copy numbers
unambiguous <- function(values) {
  values <- values[!is.na(values)]
  uniques <- unique(values)
  if (length(uniques) == 1)
    return(uniques)
  return(0)
}
majority <- function(values) {
  values <- values[!is.na(values)]
  amps <- mean(values==2)
  if (amps > 0.5) return(2)
  # treat amplifications as gains
  values[values==2] <- 1
  gains <- mean(values==1)
  if (gains > 0.5) return(1)
  losses <- mean(values==-1)
  if (losses > 0.5) return(-1)
  return(0)
}

calls <- dat[,grep("^flag\\.", colnames(dat))]
logratios <- dat[,grep("^chip\\.", colnames(dat))]

# identify additonal matrices (segmented, ...) present in the data
x <- colnames(dat)
suffix <- sub('^chip\\.', '', x[grep('^chip\\.', x)[1]])
matrices <- sub(suffix, '', x[grep(suffix, x)])
matrices <- matrices[matrices != 'flag.']
matrices <- matrices[matrices != 'chip.']
for (m in matrices)
  logratios <- cbind(logratios, dat[,grep(m, colnames(dat))])

get.gene.data <- function(x) {
  chr <- x['chromosome']
  start <- as.integer(x['start'])
  end <- as.integer(x['end'])
  # are there probes/bins overlapping with the position of the gene
  overlapping.probes <- which(dat$chromosome == chr &
                                     dat$end >= start &
                                   dat$start <= end)
  if (length(overlapping.probes) > 0) {
    # if yes, use those probes/bins to calculate the copy number
    gene.calls <- apply(calls[overlapping.probes,], 2, method.for.calls)
    gene.logratios <- apply(logratios[overlapping.probes,], 2, method.for.others, na.rm=TRUE)
  } else {
    # if not, use the last preceding and the first tailing probe/bin
    preceding.probes <- which(dat$chromosome == chr &
                                     dat$end <  start)
    tailing.probes <- which(dat$chromosome == chr &
                                 dat$start >  end)
    adjacent.probes <- preceding.probes[length(preceding.probes)]
    if (length(tailing.probes) > 0)
      adjacent.probes <- c(adjacent.probes, tailing.probes[1])
    if (length(adjacent.probes) > 0) {
      gene.calls <- apply(calls[adjacent.probes,], 2, method.for.calls)
      gene.logratios <- apply(logratios[adjacent.probes,], 2, method.for.others, na.rm=TRUE)
    } else {
      gene.calls <- 0
      gene.logratios <- 0
    }
  }
  c(gene.calls, gene.logratios)
}

# first try parallel computing
prob <- TRUE
try({
  library(snowfall)
  sfInit(parallel=TRUE, cpus=4)
  sfExport(list=c('dat', 'calls', 'logratios', 'method.for.calls', 'method.for.others', 'unambiguous', 'majority'))
  gene.calls.and.logratios <- t(sfApply(genes, 1, get.gene.data))
  sfStop()
  prob <- FALSE
}, silent=TRUE)
# if problems, fall back to sequential computing
if (prob)
  gene.calls.and.logratios <- t(apply(genes, 1, get.gene.data))

calls.bygene <- gene.calls.and.logratios[,1:ncol(calls)]
genes$loss.freq <- mean(as.data.frame(t(calls.bygene==-1)))
genes$gain.freq <- mean(as.data.frame(t(calls.bygene==1)))
if (2 %in% calls.bygene)
    genes$amp.freq <- mean(as.data.frame(t(calls.bygene==2)))
genes <- cbind(genes, gene.calls.and.logratios)

options(scipen=10)
write.table(genes, file='gene-aberrations.tsv', sep="\t", quote=FALSE, row.names=TRUE, col.names=TRUE)

# EOF

# TOOL sort-samples.R: "Sort samples" (Sorts samples according to a phenodata column. The column should contain numerical values, since the samples are sorted in ascending order according to the values.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT sort-samples.tsv: sort-samples.tsv 
# OUTPUT phenodata-sorted.tsv: phenodata-sorted.tsv 
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column specifying how to sort)

# Sort samples
# JTT 6.2.2008
#
# MG, 16.11.2010
# modified to also generate a re-ordered phenodata file to reflect the re-ordered data

# Default parameters
#column<-"group"
 
# Loads libraries
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")

# Loads data (which file to search)
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Extracts the column from phenodata
groups<-phenodata[,pmatch(column,colnames(phenodata))]

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Get indices
indices_calls <- grep("flag", names(dat))
indices_dat <- grep("chip", names(dat))

# Sorting both data and phenodata
dat2<-dat2[,order(groups)]
if(ncol(calls)>0) {
	calls<-calls[,order(groups)] 
}
phenodata2<-phenodata[order(groups),]

# Fill in the ordered data and flag values
dat3 <- dat
dat3[,indices_dat] <- dat2
names(dat3) [indices_dat] <- names(dat2)
if(ncol(calls)>0) {
	dat3[,indices_calls] <- calls
	names(dat3) [indices_calls] <- names(calls)
}

# Writing data and phenodata to disk
#if(ncol(calls)>0) {
#   write.table(data.frame(dat2, calls), file="sort-samples.tsv", sep="\t", row.names=T, col.names=T, quote=F)
#} else {
#   write.table(data.frame(dat2), file="sort-samples.tsv", sep="\t", row.names=T, col.names=T, quote=F)
#}
write.table(dat3, file="sort-samples.tsv", sep="\t", row.names=T, col.names=T, quote=F)
write.table(phenodata2, file="phenodata-sorted.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# TOOL prinseq-quality-trimmer.R: "Trim reads by quality" (Trims reads based on the quality values. This tool is based on the PRINSEQ package.)
# INPUT fastqfile: "Input reads set" TYPE GENERIC
# OUTPUT trimmed.fastq
# OUTPUT OPTIONAL trim.log
# PARAMETER OPTIONAL trim.qual.right: "Trim 3-prime end by quality" TYPE INTEGER (Trim reads from the 3-prime end using the given quality threshold score.)		
# PARAMETER OPTIONAL trim.qual.left: "Trim 5-prime end by quality" TYPE INTEGER (Trim reads from the 5-prime end using the given quality threshold score.)
# PARAMETER OPTIONAL trim.qual.type: "Quality score calculation method" TYPE [min: "minimum quality value", mean: "mean quality", max: "maximum quality value", sum: "total sum of quality values"] DEFAULT min (Type of quality score calculation to use.)
# PARAMETER OPTIONAL trim.qual.rule: "Quality score comparison condition" TYPE [ lt: "less than", gt: "greater than", et: "equal to"] DEFAULT lt (Rule to use to compare quality score threshold to calculated value.)
# PARAMETER OPTIONAL trim.qual.window: "Window size for quality calculation" TYPE INTEGER DEFAULT 1 (The sliding window size used to calculate quality score by type. Use a window size of 1 to stop at the first base that fails the defined rule.)
# PARAMETER OPTIONAL trim.qual.step: "Step size used to move the quality window" TYPE INTEGER DEFAULT 1 (Step size used to move the sliding window. To move the window over all quality scores without missing any, the step size should be less than or equal to the window size.)
# PARAMETER OPTIONAL phred64: "Base quality encoding" TYPE [ n: "Sanger", y: "Illumina v1.3-1.5"] DEFAULT n (Select \"Sanger" for Illumina v1.8+, Sanger, Roche/454, Ion Torrent and PacBio data.)
# PARAMETER OPTIONAL log.file: "Write a log file" TYPE [ n: "no", y: "yes"] DEFAULT y (Write a log file)

# KM 17.1.2012

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("fastqfile")

# binary
binary.prinseq <- c(file.path(chipster.tools.path, "prinseq", "prinseq-lite.pl" ))


trim.params <- paste(" ")

if (!is.na(trim.qual.right)) {
	trim.params <- paste(trim.params, "-trim_qual_right",  trim.qual.right, "-trim_qual_type", trim.qual.type, "-trim_qual_rule", trim.qual.rule, "-trim_qual_window", trim.qual.window, "-trim_qual_step",  trim.qual.step)
}

if (!is.na(trim.qual.left)) {
	trim.params <- paste(trim.params, "-trim_qual_left",  trim.qual.left, "-trim_qual_type", trim.qual.type, "-trim_qual_rule", trim.qual.rule, "-trim_qual_window", trim.qual.window, "-trim_qual_step",  trim.qual.step)
}

if ( phred64 == "y") {
	trim.params <- paste(trim.params, "-phred64")
}


trim.command <- paste(binary.prinseq, trim.params, "-fastq fastqfile -out_good trimmed")


if (log.file == "y") {
	system("echo Running PRINSEQ filtering with command: > trim.log")
	echo.command <- paste("echo '", trim.command, "'>> trim.log")
	system(echo.command)
	trim.command <- paste(trim.command, "-verbose 2>> trim.log")
}


system(trim.command)

#Make sure something is in the output
system("if [ ! -e  trimmed.fastq ] ; then echo 'Trimming produced an empty trimmed.fastq sequence set' >> trim.log ; echo '' > trimmed.fastq ; fi")

#stop

# TOOL vcftools.R: "Filter and analyse variants" (Filters and analyses variants in VCF files. This tool is based on the VCFtools package.)
# INPUT input.vcf: "VCF file" TYPE GENERIC 
# OUTPUT vcftools.log
# OUTPUT OPTIONAL vcftools.filtered.vcf
# OUTPUT OPTIONAL vcftools.frq.tsv
# OUTPUT OPTIONAL vcftools.frq.count.tsv
# OUTPUT OPTIONAL vcftools.hwe.tsv
# OUTPUT OPTIONAL vcftools.geno.ld.tsv
# OUTPUT OPTIONAL vcftools.snpden.tsv
# OUTPUT OPTIONAL vcftools.kept.sites.tsv
# OUTPUT OPTIONAL vcftools.removed.sites.tsv
# PARAMETER OPTIONAL filter.keepindels: "Keep only indels" TYPE [yes, no] DEFAULT no (Keep only indels.)
# PARAMETER OPTIONAL filter.removeindels: "Remove indels" TYPE [yes, no] DEFAULT no (Remove indels.)
# PARAMETER OPTIONAL filter.minalleles: "Minimum number of alleles" TYPE INTEGER DEFAULT 0 (Minumun number of alleles. 0 value means option is ignored.)
# PARAMETER OPTIONAL filter.maxalleles: "Maximum number of alleles" TYPE INTEGER DEFAULT 0 (Maximum number of alleles. 0 value means option is ignored.)
# PARAMETER OPTIONAL filter.minquality: "Minumum quality" TYPE DECIMAL DEFAULT 0 (Include only sites with Quality above this threshold. 0 value means option is ignored.)
# PARAMETER OPTIONAL statistics.freq: "Report per-site frequency information" TYPE [yes, no] DEFAULT no (Reports per-site frequency information.)
# PARAMETER OPTIONAL statistics.pvalue: "Report p-value" TYPE [yes, no] DEFAULT no (Reports a p-value for each site from a Hardy-Weinberg Equilibrium test.)
# PARAMETER OPTIONAL statistics.ld: "Report LD statistics" TYPE [yes, no] DEFAULT no (Report Linkage Disequilibrium (LD\) statistics.)
# PARAMETER OPTIONAL statistics.snpdensity: "Report SNP density" TYPE INTEGER DEFAULT 0 (Calculates the number and density of SNPs in bins of size. 0 value means option is ignored.)
# PARAMETER OPTIONAL output.filtered: "List removed sites" TYPE [yes, no] DEFAULT no (Creates two files listing sites that have been kept or removed after filtering. Default is to list kept files only.)

# AMS 14.9.2012
# AMS 0212.2012 Added option for minimum quality

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("input.vcf")

# binaries
vcftools.binary <- c(file.path(chipster.tools.path, "vcftools", "bin", "vcftools"))


# filtering otions
vcftools.options <- paste("")
if (filter.keepindels == "yes"){
	vcftools.options <- paste(vcftools.options, "--keep-only-indels")
}
if (filter.removeindels == "yes"){
	vcftools.options <- paste(vcftools.options, "--remove-indels")
}
if (filter.minalleles != "0"){
	vcftools.options <- paste(vcftools.options, "--min-alleles", filter.minalleles)
}
if (filter.maxalleles != "0"){
	vcftools.options <- paste(vcftools.options, "--max-alleles", filter.maxalleles)
}
if (filter.minquality > 0){
	vcftools.options <- paste(vcftools.options, "--minQ", filter.minquality)
}

# statistics options
if (statistics.freq == "yes"){
	vcftools.options <- paste(vcftools.options, "--freq", "--counts")
}
if (statistics.pvalue == "yes"){
	vcftools.options <- paste(vcftools.options, "--hardy")
}
if (statistics.ld == "yes"){
	vcftools.options <- paste(vcftools.options, "--geno-r2")
}
if (statistics.snpdensity != "0"){
	vcftools.options <- paste(vcftools.options, "--SNPdensity", statistics.snpdensity)
}
if (output.filtered == "yes"){
	vcftools.options <- paste(vcftools.options, "--filtered-sites")
}

# commands
command1 <- paste(vcftools.binary, "--vcf input.vcf", "--out vcftools", "--recode", vcftools.options)

# run
#stop(paste('CHIPSTER-NOTE: ', command1))
system(command1)

# rename result files
system("mv vcftools.recode.vcf vcftools.filtered.vcf")
system("mv vcftools.frq vcftools.frq.tsv")
system("mv vcftools.frq.count vcftools.frq.count.tsv")
system("mv vcftools.hwe vcftools.hwe.tsv")
system("mv vcftools.geno.ld vcftools.geno.ld.tsv")
system("mv vcftools.snpden vcftools.snpden.tsv")
system("mv vcftools.kept.sites vcftools.kept.sites.tsv")
system("mv vcftools.removed.sites vcftools.removed.sites.tsv")

# TOOL dea-deseq.R: "Differential expression using DESeq" (Differential expression analysis using the DESeq Bioconductor package. You can create the input count table and phenodata file using the tool \"Utilities - Define NGS experiment\".)
# INPUT data.tsv TYPE GENERIC
# INPUT phenodata.tsv TYPE GENERIC
# OUTPUT OPTIONAL de-list-deseq.tsv
# OUTPUT OPTIONAL de-list-deseq.bed
# OUTPUT OPTIONAL ma-plot-deseq.pdf
# OUTPUT OPTIONAL dispersion-plot-deseq.pdf
# OUTPUT OPTIONAL p-value-plot-deseq.pdf
# PARAMETER column: "Column describing groups" TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to test.)
# PARAMETER OPTIONAL normalization: "Apply normalization" TYPE [yes, no] DEFAULT yes (Should effective library size be estimated. This corrects for RNA composition bias. Note that if you have supplied library size in phenodata, size factors are calculated based on the library size total, and composition bias is not corrected.)
# PARAMETER OPTIONAL dispersion_estimate:"Dispersion estimation method" TYPE [parametric: "parametric", local: "local"] DEFAULT local (Dispersion can be estimated using a local fit or a two-coefficient parametric model. Local fit is suitable in most cases, including when there are no biological replicates. The parametric model may be preferable under certain circumstances.)
# PARAMETER OPTIONAL fitting_method: "Use fitted dispersion values" TYPE [maximum: "when higher than original values", fit-only: "always"] DEFAULT maximum (Should the dispersion of counts for a gene be replaced with the fitted value always, or only when the fitted value is larger? Replacing always optimises the balance between false positives and false negatives. Replacing only when the fitted value is higher is more conservative and minimizes false positives.)
# PARAMETER OPTIONAL p.value.adjustment.method: "Multiple testing correction" TYPE [none, bonferroni: "Bonferroni", holm: "Holm", hochberg: "Hochberg", BH: "BH", BY: "BY"] DEFAULT BH (Multiple testing correction method.)
# PARAMETER OPTIONAL p.value.cutoff: "P-value cutoff" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (The cutoff for adjusted p-value.)
# PARAMETER OPTIONAL image_width: "Plot width" TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image.)
# PARAMETER OPTIONAL image_height: "Plot height" TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image.)

                                                          
# MG 7.2.2012                                             
# EK 6.5.2012, clarified texts
# EK 12.5.2012, fixed the fitting method parameter
# EK 30.4.2013, added BED sorting, made genomic location info optional so that external count tables can be used
# EK 6.5.2013, removed replicates parameter


# Loads the libraries
library(DESeq)

# Loads the counts data
file <- c("data.tsv")
dat <- read.table(file, header=T, sep="\t", row.names=1)

# Extracts expression values
annotations <- dat[,-grep("chip", names(dat))]
dat2 <- dat[,grep("chip", names(dat))]

# Test needs a parameter "groups" that specifies the grouping of the samples
phenodata <- read.table("phenodata.tsv", header=T, sep="\t")
groups <- as.character (phenodata[,pmatch(column,colnames(phenodata))])
group_levels <- levels(as.factor(groups))
number_samples <- length(groups)

# If the library_size column of phenodata contains data, then use that to estimate size factors
lib_size <- as.numeric(phenodata$library_size)
if (is.na(lib_size[1])) estimate_lib_size <- "TRUE" else estimate_lib_size <- "FALSE"
lib_size <- lib_size/mean(lib_size)

# Sanity check: only 2 group comparison is supported
if (length(unique(groups))==1 | length(unique(groups))>=3) {
	stop("CHIPSTER-NOTE: You need to have exactly two groups to run this analysis")
}

# Create a counts data object
counts_data <- newCountDataSet(dat2, groups)

# Calculate size factors based on estimated library size, unless it is given in phenodata
# Set size factors to 1 if normalization is turned off
if (normalization == "yes") {
	if (estimate_lib_size) {
		counts_data <- estimateSizeFactors(counts_data)
	} else {
		counts_data <- estimateSizeFactors(counts_data)
		sizeFactors(counts_data) <- lib_size
	}
} else {
	sizeFactors(counts_data) <- 1
}

# For later use: filter out genes which have less than 5 counts in user-defined number of samples 
#if (filter > 0) {
#	keep <- rowSums(counts(counts_data) >5) >= filter
#	counts_data <- counts_data[keep,]
#}

# Estimate dispersion values for each gene and replace with fitted values always or only when the fitted value is higher
# Use fitType to control for parametric or local fit
if (number_samples == 2 ) {
	counts_data <- estimateDispersions(counts_data, method="blind", sharingMode="fit-only", fitType=dispersion_estimate)
} else {
	counts_data <- estimateDispersions(counts_data, method="pooled", sharingMode=fitting_method, fitType=dispersion_estimate)
}

# Function that produces a dispersion plot
plotDispEsts <- function(cds) {
	plot(rowMeans( counts(cds, normalized=TRUE)), fitInfo(cds)$perGeneDispEsts,pch = '.', 
			log="xy", main="Dispersion plot", xlab="normalized counts", ylab="dispersion")
	xg <- 10^seq( -.5, 5, length.out=300)
	lines(xg, fitInfo(cds)$dispFun(xg), col="red")
	legend(x="topright", legend="fitted dispersion", col="red", cex=1, pch="-")
}

# Make dispersion plot
pdf(file="dispersion-plot-deseq.pdf")
plotDispEsts(counts_data)
dev.off()

# Calculate statistic for differential expression
results_table <- nbinomTest(counts_data, group_levels[2], group_levels[1] )

# Merge with original data table
output_table <- cbind (dat, results_table[,-1])

# Adjust p-values
output_table$padj <- p.adjust(output_table$pval, method=p.value.adjustment.method)

# Keep significant DEGs
significant_table <- output_table[ (output_table$padj <  p.value.cutoff),]

# Remove rows with NA adjusted p-values
significant_table <- significant_table[! (is.na(significant_table$padj)),]

# Order results based on raw p-values
significant_table <- significant_table[ order(significant_table$pval), ] 


#############################


#significant_indices <- rownames (significant_table)

# If significant results are found, create an output table with the original counts per sample together with the statistical tests results
# If genomic coordinates are present, output a sorted BED file for genome browser visualization and region matching tools
#if (dim(significant_table)[1] > 0) {
#	output_table <- data.frame (dat[significant_indices,], significant_table)
#	write.table(output_table, file="de-list-deseq.tsv", sep="\t", row.names=T, col.names=T, quote=F)
#	these.colnames <- colnames(dat)
#	if("chr" %in% these.colnames) {
#		empty_column <- character(length(significant_indices))
#		bed_output <- output_table [,c("chr","start","end")]
#		bed_output <- cbind(bed_output,empty_column)
#		bed_output <- cbind(bed_output, output_table[,"log2FoldChange"])
#		source(file.path(chipster.common.path, "bed-utils.R"))
#		bed_output <- sort.bed(bed_output)
#		write.table(bed_output, file="de-list-deseq.bed", sep="\t", row.names=F, col.names=F, quote=F)
#	}	
#}

#############################


# Output the table
if (dim(significant_table)[1] > 0) {
	write.table(significant_table, file="de-list-deseq.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}

# If genomic coordinates are present, output a sorted BED file for genome browser visualization and region matching tools
source(file.path(chipster.common.path, "bed-utils.R"))
these.colnames <- colnames(dat)
if("chr" %in% these.colnames) {
	if (dim(significant_table)[1] > 0) {
		empty_column <- character(length(significant_table[1]))
		bed_output <- significant_table [,c("chr","start","end")]
		bed_output <- cbind(bed_output,empty_column)
		bed_output <- cbind(bed_output, significant_table[,"log2FoldChange"])
		bed_output <- sort.bed(bed_output)
		write.table(bed_output, file="de-list-deseq.bed", sep="\t", row.names=F, col.names=F, quote=F)
	}
}

 
# Make histogram of p-values with overlaid significance cutoff and uniform distribution
pdf (file="p-value-plot-deseq.pdf")
hist(output_table$pval, breaks=100, col="blue",
		border="slateblue", freq=FALSE,
		main="P-value distribution", xlab="p-value", ylab="proportion (%)")
hist(output_table$padj, breaks=100, col="red",
		border="slateblue", add=TRUE, freq=FALSE)
abline(h=1, lwd=2, lty=2, col="black")
abline(v=p.value.cutoff, lwd=2, lty=2, col="green")
legend (x="topright", legend=c("p-values","adjusted p-values", "uniform distribution", "significance cutoff"), col=c("blue","red","black","green"),
		cex=1, pch=15)
dev.off()

# Define function for making MA-plot of significant findings
plotDE <- function(res)
	plot(res$baseMean, res$log2FoldChange,
			log="x", pch=20, cex=.25, col = ifelse( res$padj < p.value.cutoff, "red", "black"),
			main="MA plot", xlab="mean counts", ylab="log2(fold change)") 

# Make MA-plot
pdf(file="ma-plot-deseq.pdf")
plotDE(output_table)
legend (x="topleft", legend=c("significant","not significant"), col=c("red","black"),
		cex=1, pch=19)
abline(h = c(-1, 0, 1), col = c("dodgerblue", "darkgreen", "dodgerblue"), lwd = 2)
dev.off()

# EOF

# TOOL convert-miRBase-bam-to-edger.R: "Convert miRBased BAM file to count table" (This tool takes BAM files as an input, calculates the number of times each miRNA is identified and removes the ones for which the count is under the user defined threshold.)
# INPUT bam_file.bam: "Alignment agains miRBase in BAM format" TYPE GENERIC
# OUTPUT miRNA-counts.tsv: "A converted BAM file suitable for edgeR analysis"
# PARAMETER count_limit: "Count limit" TYPE INTEGER FROM 0 TO 1000 DEFAULT 10 (Keep miRNAs which have more reads than this.)

# EK 7.7.2011
# MK 13.05.2013 fix bug in header formats

# Convert to SAM, grep miRNA name, count, filter on tag number
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))
counts.command <- paste(samtools.binary, "view bam_file.bam | awk '{print $3}' | grep -v '^*' | sort -k1 | uniq -c | awk '{if($1>", count_limit, ")print $2\"\t\"$1}'> counts.tsv")
system(counts.command)

input.file <- "counts.tsv"
dat <- read.table(input.file, header=F, sep="\t", row.names=NULL)
colnames(dat) <- c("id", "count")
write.table(data.frame(dat), file="miRNA-counts.tsv", col.names=T, quote=F, sep="\t", row.names=F)

# Add column headers
#headers <- paste("id\t","count", sep="")
#input.file <- "counts.tsv"
#header.file <- "header_file"
#system(paste("echo \"", headers, "\"", ">", header.file))
#merge.command <- paste("cat", header.file, input.file, "> miRNA-counts.tsv")
#system(merge.command)

#headers <- paste("id\t","count", sep="")
#system(paste("echo \"", headers, "\"", "> header.file"))
#merge.command <- paste("cat", header.file, "counts.tsv > edgeR-input.tsv")
#system(merge.command)

# EOF

# TOOL extract-genes-from-stattest.R: "Extract genes using a p-value" (Extracts genes from a statistical test result. Specify the p-value column you want to use for extracting the genes.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT extract.tsv: extract.tsv 
# PARAMETER p.value.threshold: p.value.threshold TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (P-value cut-off for significant results)
# PARAMETER p.value.column: p.value.column TYPE COLUMN_SEL (Column that contains the p-values)


# Extracts genes from the statistical test results
# JTT 8.11.2007

# Loads the data file
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Sanity checks
if(p.value.column=="empty") {
   stop("You haven't selected a data column for p-value! Tool cannot be executed.")
}
if(sum(grep("p.adjusted", colnames(dat)))==0) {
   stop("You don't have any P-value columns in the dataset! Please run some statistical test first.")
}

# Extracting the genes
dat2<-dat[which(dat[,grep(p.value.column, colnames(dat))]<=p.value.threshold),]

# Writing the data to disk
write.table(data.frame(dat2), file="extract.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL tophat2-single-end.R: "TopHat2 for single end reads" (Aligns Illumina RNA-Seq reads to a genome in order to identify exon-exon splice junctions. TopHat2 first identifies potential exons by mapping the reads to the genome. Using this initial mapping, TopHat2 builds a database of possible splice junctions, and then maps the reads against these junctions to confirm them. The alignment results are given in a BAM file, which is automatically indexed and hence ready to be viewed in Chipster genome browser.)
# INPUT reads1.fq: "Reads to align" TYPE GENERIC
# INPUT OPTIONAL genes.gtf: "Optional GTF file" TYPE GENERIC
# OUTPUT tophat.bam
# OUTPUT tophat.bam.bai
# OUTPUT OPTIONAL junctions.bed
# OUTPUT OPTIONAL insertions.bed
# OUTPUT OPTIONAL deletions.bed
# PARAMETER genome: "Genome" TYPE [hg19: "Human (hg19\)", mm10: "Mouse (mm10\)", mm9: "Mouse (mm9\)", rn4: "Rat (rn4\)", athaliana.TAIR10: "A. thaliana genome (TAIR10\)", Gasterosteus_aculeatus.BROADS1.67: "Gasterosteus aculeatus (BROADS1.67\)", Halorubrum_lacusprofundi_ATCC_49239: "Halorubrum lacusprofundi (ATCC 49239\)", ovis_aries_texel: "Sheep genome (oar3.1\)"] DEFAULT hg19 (Genome that you would like to align your reads against.)
# PARAMETER OPTIONAL min.anchor.length: "Minimum anchor length" TYPE INTEGER FROM 3 TO 1000 DEFAULT 8 (TopHat will report junctions spanned by reads with at least this many bases on each side of the junction. Note that individual spliced alignments may span a junction with fewer than this many bases on one side. However, every junction involved in spliced alignments is supported by at least one read with this many bases on each side.)
# PARAMETER OPTIONAL splice.mismatches: "Maximum number of mismatches allowed in the anchor" TYPE INTEGER FROM 0 TO 2 DEFAULT 0 (The maximum number of mismatches that may appear in the anchor region of a spliced alignment.)
# PARAMETER OPTIONAL min.intron.length: "Minimum intron length" TYPE INTEGER FROM 10 TO 1000 DEFAULT 70 (TopHat will ignore donor-acceptor pairs closer than this many bases apart.)
# PARAMETER OPTIONAL max.intron.length: "Maximum intron length" TYPE INTEGER FROM 1000 TO 1000000 DEFAULT 500000 (TopHat will ignore donor-acceptor pairs farther than this many bases apart, except when such a pair is supported by a split segment alignment of a long read.)
# PARAMETER OPTIONAL max.multihits: "How many hits is a read allowed to have" TYPE INTEGER FROM 1 TO 1000000 DEFAULT 20 (Instructs TopHat to allow up to this many alignments to the reference for a given read, and suppresses all alignments for reads with more than this many alignments.)
# PARAMETER OPTIONAL no.novel.juncs: "When GTF file is supplied, ignore novel junctions" TYPE [yes, no] DEFAULT yes (If you supply an optional GTF file, TopHat will use the exon records in this file to build a set of known splice site junctions for each gene, and it will attempt to align reads to these junctions even if they would not normally be covered by the initial mapping. This parameter controls if TopHat should look for reads accross the known junctions only.)

# EK 17.4.2012 added -G and -g options
# MG 24.4.2012 added ability to use gtf files from Chipster server
# AMS 19.6.2012 Added unzipping
# AMS 4.10.2012 added BED sorting

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads1.fq")

options(scipen = 10)
# max.intron.length <- formatC(max.intron.length, "f", digits = 0)

# setting up TopHat
tophat.binary <- c(file.path(chipster.tools.path, "tophat2", "tophat2"))
path.bowtie <- c(file.path(chipster.tools.path, "bowtie2"))
path.samtools <- c(file.path(chipster.tools.path, "samtools"))
set.path <-paste(sep="", "PATH=", path.bowtie, ":", path.samtools, ":$PATH")
path.bowtie.index <- c(file.path(path.bowtie, "indexes", genome))


# command start
command.start <- paste("bash -c '", set.path, tophat.binary)

# parameters
command.parameters <- paste("-a", min.anchor.length, "-m", splice.mismatches, "-i", min.intron.length, "-I", max.intron.length, "-g", max.multihits, "--library-type fr-unstranded")

# optional GTF command
command.gtf <- ""
input_files <- dir()
is_gtf <- (length(grep("genes.gtf", input_files))>0)
if (is_gtf) {
	if (no.novel.juncs == "yes") {
	command.gtf <- paste("-G", "genes.gtf", "--no-novel-juncs")
	} else {
		command.gtf <- paste("-G", "genes.gtf")
	}
}

# optional GTF command, if a GTF file has NOT been provided by user
# BUT is avaliable from Chipster server
genome_available <- FALSE
if (genome == "hg19" ||	genome == "mm9" || genome == "mm10" || genome == "rn4") genome_available <- TRUE
if (!is_gtf && genome_available) {
   # annotation file setup
   if (genome == "hg19") {
      annotation.file <- "Homo_sapiens.GRCh37.68.chr.gtf"
   }
   if (genome == "mm10") {
	  annotation.file <- "Mus_musculus.GRCm38.68.chr.gtf"
   }
   if (genome == "mm9") {
      annotation.file <- "Mus_musculus.NCBIM37.62.chr.gtf"
   }
   if (genome == "rn4") {
	  annotation.file <- "Rattus_norvegicus.RGSC3.4.62.chr.gtf"
   }
   annotation.file <- c(file.path(chipster.tools.path, "genomes", "gtf", annotation.file))
	
	if (no.novel.juncs == "yes") {
		command.gtf <- paste("-G", annotation.file, "--no-novel-juncs")
	} else {
		command.gtf <- paste("-G", annotation.file)
	}
}

# command ending
command.end <- paste(path.bowtie.index, "reads1.fq'")

# run tophat
command <- paste(command.start, command.parameters, command.gtf, command.end)
system(command)

# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

# sort bam
system(paste(samtools.binary, "sort tophat_out/accepted_hits.bam tophat"))

# index bam
system(paste(samtools.binary, "index tophat.bam"))

system("mv tophat_out/junctions.bed junctions.u.bed")
system("mv tophat_out/insertions.bed insertions.u.bed")
system("mv tophat_out/deletions.bed deletions.u.bed")


# sorting BEDs
source(file.path(chipster.common.path, "bed-utils.R"))

size <- 0
size <- file.info("junctions.u.bed")$size
if (size > 100){	
	bed <- read.table(file="junctions.u.bed", skip=1, sep="\t")
	colnames(bed)[1:2] <- c("chr", "start")
	sorted.bed <- sort.bed(bed)
	write.table(sorted.bed, file="junctions.bed", sep="\t", row.names=F, col.names=F, quote=F)
}

size <- file.info("insertions.u.bed")$size
if (size > 100){
	bed <- read.table(file="insertions.u.bed", skip=1, sep="\t")
	colnames(bed)[1:2] <- c("chr", "start")
	sorted.bed <- sort.bed(bed)
	write.table(sorted.bed, file="insertions.bed", sep="\t", row.names=F, col.names=F, quote=F)
}

size <- file.info("deletions.u.bed")$size
if (size > 100){
	bed <- read.table(file="deletions.u.bed", skip=1, sep="\t")
	colnames(bed)[1:2] <- c("chr", "start")
	sorted.bed <- sort.bed(bed)
	write.table(sorted.bed, file="deletions.bed", sep="\t", row.names=F, col.names=F, quote=F)
}

# TOOL norm-affy-snp.R: "Affymetrix SNP arrays" (Affymetrix SNP array preprocessing using CEL-files. Probe sets are automatically flagged using P M flags.)
# INPUT microarray{...}.cel: microarray{...}.cel TYPE AFFY 
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# PARAMETER version: CRLMM-version TYPE [oligo: oligo, crlmm: crlmm] DEFAULT crlmm (Use CRLMM function from the package oligo, i.e. the old version, or from the package crlmm, i.e. the new version)
# PARAMETER cdfName: cdfName TYPE [default: default, genomewidesnp5: genomewidesnp5, genomewidesnp6: genomewidesnp6] DEFAULT default (Name of the description file to be used in normalization, by defualt obtained from the CEL files. Affects only the function of the crlmm-package)
# PARAMETER SNRMin: "Signal-to-noise ratio" TYPE DECIMAL FROM 0 TO 10000 DEFAULT 5 (Value defining the minimum signal-to-noise ratio used to filter out samples, higher values mean more strict filtering. Affects only the function of the crlmm-package)

# JTT: 24.4.2008 created
# MG: 26.10.2009 to cope with Affymetrix Human SNP 5.0 and 6.0 arrays
# MK: 17.05.2013 added option to use the new

# setwd(paste(getwd(), "/affy-snp", sep=""))

# Loading the libraries
if(version == "oligo") {
	library(oligo)
} else {
	library(crlmm)
	library(oligoClasses)
	library(affyio)
}

library(pd.mapping50k.hind240)
library(pd.mapping50k.xba240)
library(pd.mapping250k.nsp)
library(pd.mapping250k.sty)
library(pd.genomewidesnp.5)
library(pd.genomewidesnp.6)
library(genomewidesnp5Crlmm)
library(genomewidesnp6Crlmm)

# Setting up the path to the data files
fullFilenames <- list.celfiles(path = getwd(), full.names = TRUE)

# Calculating the genotype calls
if(version == "oligo") {
	crlmmOut <- try(crlmm(fullFilenames, file.path(getwd(), "crlmmResults")))
	crlmmOut <- try(getCrlmmSummaries(file.path(getwd(), "crlmmResults")))
} else {
	if(cdfName != "default") {
		crlmmOut <- try(crlmm::crlmm(fullFilenames, verbose=FALSE, cdfName=cdfName, SNRMin=SNRMin))
	} else {	
		this.cdfName <- gsub("_", "", tolower(read.celfile.header(fullFilenames[1])$cdfName))
		if(this.cdfName != "genomewidesnp5" && this.cdfName != "genomewidesnp6") {
			stop("CHIPSTER-NOTE: Chip type not supported by CRLMM. Please choose a suitable description file from the drop-down box or use another pre-processing method")
		}	
			
		crlmmOut <- try(crlmm::crlmm(fullFilenames, verbose=FALSE, SNRMin=SNRMin))
	}
}

if(class(crlmmOut)=="try-error") {
	if(length(grep("No arrays above quality", crlmmOut[1])) > 0) {
		stop("CHIPSTER-NOTE: No arrays above quality threshold. Please try a lower signal-to-noise ratio parameter");
	} else {
		stop("CHIPSTER-NOTE: An unexpected error has occurred. Please contact Chipster support")
	}
}
	
# Putting the data in a correct format
genotypes<-calls(crlmmOut)
flags<-confs(crlmmOut)
flags2<-flags
flags2[flags<=quantile(flags, 0.95)]<-"P"
flags2[flags>quantile(flags, 0.95)]<-"M"
colnames(genotypes)<-paste("chip.", colnames(genotypes), sep="")
colnames(flags2)<-paste("flags.", colnames(flags), sep="")

# Writes out a phenodata table
chiptype<-c(rep("affy-SNP", ncol(genotypes)))
sample<-colnames(genotypes)
group<-c(rep("", ncol(genotypes)))
write.table(data.frame(sample=sample, chiptype=chiptype, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# Writing the results into files
write.table(data.frame(genotypes, flags2), "normalized.tsv", row.names=T, col.names=T, quote=F, sep="\t")

# TOOL merge-datasets.R: "Merge data sets" (Merges two data sets. Only rows common to both are kept, and all annotation data is taken from the first data set. A new phenodata file is generated by combining the two original phenodata files.)
# INPUT normalized_1.tsv: normalized_1.tsv TYPE GENE_EXPRS 
# INPUT normalized_2.tsv: normalized_2.tsv TYPE GENE_EXPRS 
# INPUT phenodata_1.tsv: phenodata_1.tsv TYPE GENERIC 
# INPUT phenodata_2.tsv: phenodata_2.tsv TYPE GENERIC 
# OUTPUT merged.tsv: merged.tsv 
# OUTPUT phenodata-merged.tsv: phenodata-merged.tsv 

# merge-datasets.R
# Ilari Scheinin <firstname.lastname@gmail.com>
# 2010-10-05

# Parameter settings (default) for testing purposes
#dat<-read.table('normalized.tsv', header=TRUE, sep='\t', as.is=TRUE, row.names=1)
#dat2 <- read.table('imputed.tsv', header=TRUE, sep='\t', as.is=TRUE, row.names=1)
#phenodata1 <- read.table('phenodata.tsv', header=TRUE, sep='\t', as.is=TRUE)
#phenodata2 <- read.table('phenodata.tsv', header=TRUE, sep='\t', as.is=TRUE)

# read data set 1
dat <- read.table('normalized_1.tsv', header=TRUE, sep='\t', as.is=TRUE, row.names=1)

# read data set 2
dat2 <- read.table('normalized_2.tsv', header=TRUE, sep='\t', as.is=TRUE, row.names=1)

# take common rows
common.rows <- intersect(rownames(dat), rownames(dat2))
dat <- dat[common.rows,]
dat2 <- dat2[common.rows,]

# extract data
ratios <- dat[,grep('chip', colnames(dat))]
calls <- dat[,grep('flag', colnames(dat))]
ratios <- cbind(ratios, dat2[,grep('chip', colnames(dat2))])
calls <- cbind(calls, dat2[,grep('flag', colnames(dat2))])

# generate new identifiers
microarrays <- sprintf('microarray%.3i', 1:ncol(ratios))
colnames(ratios) <- paste('chip.', microarrays, sep='')
if (ncol(ratios) == ncol(calls))
  colnames(calls) <- paste('flag.', microarrays, sep='')

# remove old matrices from data set 1
dat <- dat[,-grep('chip', colnames(dat))]
if (length(grep('flag', colnames(dat))) > 0)
  dat <- dat[,-grep('flag', colnames(dat))]

# calculate new frequencies
if ('loss.freq' %in% colnames(dat) && ncol(ratios) == ncol(calls)) {
  dat$loss.freq <- round(mean(as.data.frame(t(calls==-1))), digits=3)
  dat$gain.freq <- round(mean(as.data.frame(t(calls==1))), digits=3)
  if (2 %in% calls) {
    dat$amp.freq <- round(mean(as.data.frame(t(calls==2))), digits=3)
  } else {
    dat$amp.freq <- NULL
  }
} else {
  dat$loss.freq <- NULL
  dat$gain.freq <- NULL
  dat$amp.freq <- NULL
}

# generate new table
dat <- cbind(dat, ratios)
if (ncol(ratios) == ncol(calls))
  dat <- cbind(dat, calls)

# process phenodata
phenodata1 <- read.table('phenodata_1.tsv', header=TRUE, sep='\t', as.is=TRUE)
phenodata2 <- read.table('phenodata_2.tsv', header=TRUE, sep='\t', as.is=TRUE)

# fill in columns present only in one phenodata table
for (col in setdiff(colnames(phenodata1), colnames(phenodata2)))
  phenodata2[,col] <- NA
for (col in setdiff(colnames(phenodata2), colnames(phenodata1)))
  phenodata1[,col] <- NA

# combine phenodata tables and update sample identifiers
phenodata <- rbind(phenodata1, phenodata2)
phenodata$sample <- microarrays

# write files
write.table(dat, file='merged.tsv', quote=FALSE, sep='\t', row.names=TRUE, col.names=TRUE)
write.table(phenodata, file='phenodata-merged.tsv', quote=FALSE, sep='\t', na='', row.names=FALSE, col.names=TRUE)

# EOF

# TOOL prinseq-statistics.R: "Read quality statistics with PRINSEQ" (Calculates general statistics of the reads in the given FASTQ file. This tool is based on the PRINSEQ program. Please note that if your file is larger than 4 GB, we recommend that you submit only a sample of reads for the quality statistics analysis, because PRINSEQ uses a lot of memory when producing the html report and might fail with bigger files. You can use the tool Utilities / Make a subset of FASTQ for this.)
# INPUT fastqfile: "Input reads file" TYPE GENERIC
# OUTPUT reads-stats.tsv 
# OUTPUT OPTIONAL reads-stats.html
# PARAMETER OPTIONAL input.mode: "Input file format" TYPE [ fq: "FASTQ", fa: "FASTA"] DEFAULT fq (Define the file format of the reads file)

# KM 17.1.2012
# EK 23.4.2012

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("fastqfile")

#system("
#wget http://sourceforge.net/projects/prinseq/files/standalone/prinseq-lite-0.17.3.tar.gz
#tar zxf prinseq-lite-0.17.3.tar.gz
# ")

# binary
binary.stats <- c(file.path(chipster.tools.path, "prinseq", "prinseq-lite.pl" ))
#binary.stats <- c(file.path("perl prinseq-lite-0.17.3/prinseq-lite.pl"))

# quality encoding check
#quality.scale <- ifelse(phred64 == "y", "-phred64", "")

# command to generate result table
system('printf "%s\t%s\t%s\n"  Class Feature Value > reads-stats.tsv')
if (input.mode == "fq") {
	command.stats <- paste("perl", binary.stats, " -fastq fastqfile -out_good null -out_bad null -stats_all >> reads-stats.tsv")
}
if (input.mode == "fa") {
	command.stats <- paste("perl", binary.stats, " -fasta fastqfile -out_good null -out_bad null -stats_all >> reads-stats.tsv")
}

#stop(paste('CHIPSTER-NOTE: ', command.stats))

ret <- system(command.stats)
if (ret > 0) {
	stop('Unsupported input file type, please see tool output for more details.')
}

# commands to generate graph file
if (input.mode == "fq") {
   command.graph <- paste("perl", binary.stats, " -fastq fastqfile -out_good null -out_bad null -graph_data tmp_graph_file ")
}
if (input.mode == "fa") {
   command.graph <- paste("perl", binary.stats, " -fasta fastqfile -out_good null -out_bad null -graph_data tmp_graph_file ")
}
system(command.graph)

# create html file
binary.graph <- c(file.path(chipster.tools.path, "prinseq", "prinseq-graphs.pl"))
command.graph <- paste("perl", binary.graph, " -i tmp_graph_file -html_all -o reads-stats")
system(command.graph)

# TOOL bedtools-coveragebed.R: "Coverage BED" (Returns the depth and breadth of coverage of features from A on the intervals in B. This tool is based on the BEDTools package.)
# INPUT file.a: "Input file A" TYPE GENERIC
# INPUT file.b: "Input file B" TYPE GENERIC
# OUTPUT coveragebed.bed 
# PARAMETER abam: "File A is BAM format" TYPE [yes, no] DEFAULT no (Select yes if file A is BAM format.)
# PARAMETER OPTIONAL s: "Force strandedness" TYPE [yes, no] DEFAULT no (Force strandedness. That is, only include hits in A that overlap B on the same strand. By default, hits are included without respect to strand.)
# PARAMETER OPTIONAL hist: "Report a histogram of coverage" TYPE [yes, no] DEFAULT no (Report a histogram of coverage for each feature in B as well as a summary histogram for all features in B. Output (tab delimited\) after each feature in B: 1\) depth, 2\) \# bases at depth, 3\) size of B, 4\) % of B at depth.)
# PARAMETER OPTIONAL d: "Report the depth at each position" TYPE [yes, no] DEFAULT no (Report the depth at each position in each B feature. Positions reported are one based.  Each position and depth follow the complete B feature.)
# PARAMETER OPTIONAL split: "Treat split BAM or BED12 entries as distinct BED intervals" TYPE [yes, no] DEFAULT no (Treat "split" BAM or BED12 entries as distinct BED intervals when computing coverage. For BAM files, this uses the CIGAR N and D operations to infer the blocks for computing coverage. For BED12 files, this uses the BlockCount, BlockStarts, and BlockEnds fields (i.e., columns 10,11,12\).)

# AMS 23.4.2012
# AMS 11.10.2012 Fixed BAM file support

# binary
binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "coverageBed"))

# optional options
options <- paste("")
if (s == "yes") {options <- paste(options, "-s")}
if (hist == "yes") {options <- paste(options, "-hist")}
if (d == "yes") {options <- paste(options, "-d")}
if (split == "yes") {options <- paste(options, "-split")}

# input files
if (abam == "yes") {options <- paste(options, "-abam file.a -b file.b")}
if (abam == "no") {options <- paste(options, "-a file.a -b file.b")}

# command
command <- paste(binary, options, "> coveragebed.bed")

# run
system(command)

if (file.info("coveragebed.bed")$size == 0) {system("echo \"No results found\" > coveragebed.bed")}

# TOOL search-coordinates.R: "Search by genomic coordinates" (Search by chromosome name and starting and ending base pair positions. The data must contain the corresponding columns.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT search-coordinates.tsv: search-coordinates.tsv 
# PARAMETER position: position TYPE STRING (Position to search for. Must contain three values that are separated by tabs, hyphens, colons or two dots (e.g. X:100-200 or 7:600..700\).)
# PARAMETER include.partial.overlaps: include.partial.overlaps TYPE [yes: yes, no: no] DEFAULT yes (Whether to include only features that are completely contained within the search window, or also partial overlaps.)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-12-13

# load inputs
file <- 'normalized.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, check.names=FALSE)

pos <- c('chromosome','start','end')
if (length(setdiff(pos, colnames(dat)))!=0)
  stop('CHIPSTER-NOTE: This script can only be run on files that have the following columns: chromosome, start, end.')

# parse coordinates
position <- gsub('(\t|:|-|\\.\\.)', ';', position)
items <- strsplit(position, ';')[[1]]
chromosome <- items[1]
start <- as.integer(items[2])
end <- as.integer(items[3])

# discard data from other chromosomes
dat <- dat[dat$chromosome == chromosome,]

if (include.partial.overlaps == 'no') {
  dat <- dat[dat$start >= start & dat$end <= end,]
} else {
  dat <- dat[dat$end > start & dat$start < end,]
}

# write output
options(scipen=10)
write.table(dat, file='search-coordinates.tsv', quote=FALSE, sep='\t')

# EOF

# TOOL MEDIPS_two_samples_V1.R: "MEDIPS - methylation analysis, treatment vs. control" (Analysis of MeDIP-seq data for two conditions. This tool is based on the MEDIPS package developed by Chavez et al.)
# INPUT control.tsv: "Converted BAM data file for the control" TYPE GENERIC
# INPUT treatment.tsv: "Converted BAM data file for the treatment" TYPE GENERIC
# OUTPUT OPTIONAL saturationplot.png: "Saturation plot"
# OUTPUT OPTIONAL coverageplot.png: "Coverage plot"
# OUTPUT OPTIONAL calibrationplot.png: "Calibration plot"
# OUTPUT OPTIONAL CpGdensities.png: "CpG density plot"
# OUTPUT OPTIONAL RPMsignal.png: "RPM plot"
# OUTPUT OPTIONAL AMSsignal.png: "AMS plot"
# OUTPUT OPTIONAL rois.tsv: "Promoter regions"
# OUTPUT OPTIONAL output.bed: "BED file"
# OUTPUT output.tsv: "Enrichment data"
# PARAMETER species TYPE [human] DEFAULT human (Select the species)
# PARAMETER promoters.only TYPE [yes, no] DEFAULT no (Should the analyses be restricted to promoter regions only)
# PARAMETER coverage.resolution TYPE [25,50,100,200] DEFAULT  50 (Targeted data resolution, in base pairs, when the genome-wide coverage is calculated)
# PARAMETER smoothing.extension TYPE [200,400,800,1200] DEFAULT 400 (The amount of data smoothing, in base pairs, by extending the reads)
# PARAMETER fragment.length TYPE [400,800,1600,2400] DEFAULT 800 (Length of the fragment for calculation of local CpGs)
# PARAMETER save.wiggle TYPE [yes, no] DEFAULT yes (Should the normalized data, as rpm, be saved as a wiggle file)
# PARAMETER promoter.upstream TYPE [1000,2000,5000] DEFAULT 1000 (How much upstream, in base pairs, from the transcription start site does the promoter extend)
# PARAMETER promoter.downstream TYPE [250,500,750,1000] DEFAULT 500 (How much downstream, in base pairs, from the transcription start site does the promoter extend)
# PARAMETER image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Parameters for testing purposes only
#species<-"human"
#promoters.only<-"no"
#coverage.resolution<-"100"
#smoothing.extension<-"1200"
#fragment.length<-2400
#save.wiggle<-"yes"
#promoter.upstream<-"1000"
#promoter.downstream<-"500"
#image.width<-600
#image.height<-600

# Processing of the parameters
if(species=="human") {
   genome<-c("BSgenome.Hsapiens.UCSC.hg19")
   pgenome<-"hg19"  
   library(BSgenome.Hsapiens.UCSC.hg19)
}
w<-image.width
h<-image.height




library(MEDIPS)

# Assign the files to control and treatment
cfile<-c("control.tsv")
tfile<-c("treatment.tsv")

# Reads the data
control<-MEDIPS.readAlignedSequences(BSgenome=genome, file=cfile)
treatment<-MEDIPS.readAlignedSequences(BSgenome=genome, file=tfile)

# Creating the genome vector
control<-MEDIPS.genomeVector(data=control, bin_size=as.numeric(coverage.resolution), extend=as.numeric(smoothing.extension))
treatment<-MEDIPS.genomeVector(data=treatment, bin_size=as.numeric(coverage.resolution), extend=as.numeric(smoothing.extension))

# Pattern Positions
control<-MEDIPS.getPositions(data=control, pattern="CG")
treatment<-MEDIPS.getPositions(data=treatment, pattern="CG")

# Coupling vector
control<-MEDIPS.couplingVector(data=control, fragmentLength=as.numeric(fragment.length), func="count")
treatment<-MEDIPS.couplingVector(data=treatment, fragmentLength=as.numeric(fragment.length), func="count")

# Calibration curve
control<-MEDIPS.calibrationCurve(data=control)
treatment<-MEDIPS.calibrationCurve(data=treatment)

# Normalization
control<-MEDIPS.normalize(data=control)
treatment<-MEDIPS.normalize(data=treatment)

# Comparing experiments
if(promoters.only=="yes") {
   library(rtracklayer)
   session <- browserSession()
   genome(session) <- pgenome
   query <- ucscTableQuery(session, "refGene")
   refGene<-getTable(query)
   sta<-refGene$txStart
   sta[refGene$strand=="+"]<-sta[refGene$strand=="+"]-1000
   sta[refGene$strand=="-"]<-sta[refGene$strand=="-"]-500
   sto<-refGene$txStart
   sto[refGene$strand=="+"]<-sto[refGene$strand=="+"]+500
   sto[refGene$strand=="-"]<-sto[refGene$strand=="-"]+1000
   rois<-data.frame(refGene$chrom, sta, sto, make.unique(as.character(refGene$name)))
   rois<-rois[rois[,1] %in% unique(c(control@genome_chr), treatment@genome_chr),]
   write.table(rois, "rois.tsv", sep="\t", quote=F, col.names=F, row.names=F)
   diff.meth<-MEDIPS.methylProfiling(data1=control, data2=treatment, select=2, frame_size=400, ROI_file="rois.tsv")
   write.table(diff.meth, "output.tsv", sep="\t", quote=F, col.names=T, row.names=F)
}

if(promoters.only=="no") {
   diff.meth<-MEDIPS.methylProfiling(data1=control, data2=treatment, select=2, frame_size=400)
   write.table(diff.meth, file="output.tsv", sep="\t", quote=F, col.names=T, row.names=F)
}

# TOOL intersect-lists.R: "Intersect lists" (Performs Boolean operations on 2 or 3 data tables or lists - that have one column in common - to identify the rows that intersect, are unique or form a union. The results are collected in one single table with columns for each of the operations. A Venn diagram giving a visual interpretation of the results is also returned.)
# INPUT genelist{...}.tsv: genelist{...}.tsv TYPE GENERIC 
# OUTPUT intersect-lists-operation.tsv: intersect-lists-operation.tsv 
# OUTPUT intersect-lists-summary.tsv: intersect-lists-summary.tsv 
# OUTPUT venn-diagram-plot.pdf: venn-diagram-plot.pdf 
# PARAMETER common.column: common.column TYPE STRING DEFAULT empty (The name of the column that is common to the data tables.)
# PARAMETER operation: operation TYPE [intersection: intersection, union: union] DEFAULT intersection (Defines the operation to be performed on the lists, where intersection will yield a list of only the rows that are common between lnput lists, whereas union will yield a list of the rows that appear in any of the input lists.)
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)

# INPUT GENERIC genelist[...].tsv OUTPUT intersect-lists-operation.tsv, intersect-lists-summary.tsv, venn-diagram-plot.pdf
#common.column <- "symbol"
#operation <- "intersection"
#image.width <- 5
#image.height <- 5

# Renaming variables
h <- image.height
w <- image.width 

# Sanity check the input data
files<-dir()
files<-files[grep("genelist", files)]
number_files <- length(files)
if (number_files > 3 | number_files < 2) {
	stop("CHIPSTER-NOTE: You need to have 2 or 3 input files to use this tool!")
}

# Read in data files
for (count in 1:number_files) {
	assign (paste("data_", count, sep=""), read.table(files[count], header=T, sep="\t")) 
}

# Extract the common columns from the input data and condense to unique values
# to get rid of multiple entries
for (count in 1:number_files) {
	data_temp <- get(paste("data_", count, sep=""))
	assign (paste("list_", count, sep=""), unique (data_temp [,names(data_temp)==common.column]))
}

# remove "NA" entries
if (number_files==2) {
#	list_1 <- list_1[-is.na(list_1)]
#	list_2 <- list_2[-is.na(list_2)]
list_1 <- levels(list_1)
list_2 <- levels(list_2)
list_1 <- list_1[list_1!=""]
list_2 <- list_2[list_2!=""]
}
if (number_files==3) {
#	list_1 <- list_1[-is.na(list_1)]
#	list_2 <- list_2[-is.na(list_2)]
#	list_3 <- list_3[-is.na(list_3)]	
	list_1 <- levels(list_1)
	list_2 <- levels(list_2)
	list_2 <- levels(list_3)	
	list_1 <- list_1[list_1!=""]
	list_2 <- list_2[list_2!=""]
	list_2 <- list_2[list_3!=""]	
}

if (number_files==2) {
	
	# find out intersection between all 3 lists
	intersect_1_2 <- intersect(list_1, list_2)
	if (operation=="intersection") {
		result_operation <- intersect_1_2
	}	
	
	# find out union between pairs
	union_1_2 <- union(list_1, list_2)
	if (operation=="union") {
		result_operation <- union_1_2
	}	
	
	# find out unique for each list
	unique_1 <- setdiff (list_1, intersect_1_2)
	unique_2 <- setdiff (list_2, intersect_1_2)
	
	# set up plotting area
	pdf(file="venn-diagram-plot.pdf", width=w/72, height=h/72)
	plot(-1:1, -1:1, type="n", axes = FALSE, xlab = "", ylab = "")
	
	# draw overlapping circles
	symbols(-.25,0, circles = .5, inches = FALSE, add = T, fg=3)
	symbols(.25,0, circles = .5, inches = FALSE, add = T, fg=4)
	
	# place list identifiers including length numbers 
	text(-.4,0.75, labels=paste("list_1","\n",length(list_1)), col="black", cex=1.2)
	text(.4,0.75, labels=paste("list_2","\n",length(list_2)), col="black", cex=1.2)
	
	# place length numbers for the intersections
	text(0,0, labels=length(intersect_1_2), col="black", cex=1.2)
	
	# place length numbers for the unique non-overlapping areas
	text(-.4,0, labels=length(unique_1), col="black", cex=1.2)
	text(.4,0, labels=length(unique_2), col="black", cex=1.2)
	
	# shut down plotting device
	dev.off()
	
	# output the result table
	longest_list <- length(union_1_2)
	result_table <- matrix(nrow=longest_list,ncol=6)
	list_1 <- append(as.character(list_1),rep("",longest_list-length(list_1)))
	list_2 <- append(as.character(list_2),rep("",longest_list-length(list_2)))
	unique_1 <- append(as.character(unique_1),rep("",longest_list-length(unique_1)))
	unique_2 <- append(as.character(unique_2),rep("",longest_list-length(unique_2)))
	intersect_1_2 <- append(as.character(intersect_1_2),rep("",longest_list-length(intersect_1_2)))
	union_1_2 <- append(as.character(union_1_2),rep("",longest_list-length(union_1_2)))
	result_table [,1] <- as.character(list_1)
	result_table [,2] <- as.character(list_2)
	result_table [,3] <- as.character(unique_1)
	result_table [,4] <- as.character(unique_2)
	result_table [,5] <- as.character(intersect_1_2)
	result_table [,6] <- as.character(union_1_2)
	rownames(result_table) <- as.character(1:longest_list)
	colnames(result_table) <- c(
			"list_1",
			"list_2",
			"unique_1",
			"unique_2",
			"intersect_1_2",
			"union_1_2")
	result_operation <- as.data.frame(result_operation)
	colnames(result_operation) <- common.column
	write.table(result_operation, file="intersect-lists-operation.tsv", sep="\t", row.names=T, col.names=T, quote=F)
	write.table(result_table, file="intersect-lists-summary.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}

if (number_files==3) {
	
	# find out intersection between all 3 lists
	intersect_1_2_3 <- intersect(intersect(list_1, list_2), list_3)
	if (operation=="intersection") {
		result_operation <- intersect_1_2_3
	}	
	
	# find out intersections between pairs
	intersect_1_2 <- intersect(list_1, list_2)
	intersect_1_3 <- intersect(list_1, list_3)
	intersect_2_3 <- intersect(list_2, list_3)
	intersect_1_2_plot <- setdiff(intersect(list_1, list_2), intersect_1_2_3)
	intersect_1_3_plot <- setdiff(intersect(list_1, list_3), intersect_1_2_3)
	intersect_2_3_plot <- setdiff(intersect(list_2, list_3), intersect_1_2_3)
	
	# find out union between pairs
	union_1_2 <- union(list_1, list_2)
	union_1_3 <- union(list_1, list_3)
	union_2_3 <- union(list_2, list_3)
	
	# find out the union between all 3 lists
	union_1_2_3 <- union(union(union(union_1_2, union_1_3), union_2_3), intersect_1_2_3)
	if (operation=="union") {
		result_operation <- union_1_2_3
	}	
	
	# find out unique for each list
	unique_1 <- setdiff (list_1, union(union(intersect_1_2, intersect_1_3), intersect_1_2_3))
	unique_2 <- setdiff (list_2, union(union(intersect_1_2, intersect_2_3), intersect_1_2_3))
	unique_3 <- setdiff (list_3, union(union(intersect_1_3, intersect_2_3), intersect_1_2_3))
	
	# set up plotting area
	pdf(file="venn-diagram-plot.pdf", width=w/72, height=h/72)
	plot(-1:1, -1.3:1, type="n", axes = FALSE, xlab = "", ylab = "")
	
	# draw overlapping circles
	symbols(0,-.5, circles = .5, inches = FALSE, add = T, fg=2)
	symbols(-.25,0, circles = .5, inches = FALSE, add = T, fg=3)
	symbols(.25,0, circles = .5, inches = FALSE, add = T, fg=4)
	
	# place list identifiers including length numbers 
	text(-.9,.6, labels=paste("list_1","\n",length(list_1)), col="black", cex=1.2)
	text(.8,.6, labels=paste("list_2","\n",length(list_2)), col="black", cex=1.2)
	text(0,-1.25, labels=paste("list_3","\n",length(list_3)), col="black", cex=1.2)
	
	# place length numbers for the intersections
	text(0,-.15, labels=length(intersect_1_2_3), col="black", cex=1.2)
	text(-.3,-.35, labels=length(intersect_1_3_plot), col="black", cex=1.2)
	text(.3,-.35, labels=length(intersect_2_3_plot), col="black", cex=1.2)
	text(0,.2, labels=length(intersect_1_2_plot), col="black", cex=1.2)
	
	# place length numbers for the unique non-overlapping areas
	text(0,-.8, labels=length(unique_3), col="black", cex=1.2)
	text(-.4,.3, labels=length(unique_1), col="black", cex=1.2)
	text(.4,.3, labels=length(unique_2), col="black", cex=1.2)
	
	# place length numbers for the pairwise unions 
	text(0,.7, labels=paste("Union_1_2","\n",length(union_1_2)), col="black", cex=1.2)
	text(-.85,-.65, labels=paste("Union_1_3","\n",length(union_1_3)), col="black", cex=1.2)
	text(.85,-.65, labels=paste("Union_2_3","\n",length(union_2_3)), col="black", cex=1.2)
	
	# shut down plotting device
	dev.off()
	
	# output the result table
	longest_list <- length(union_1_2_3)
	result_table <- matrix(nrow=longest_list,ncol=14)
	list_1 <- append(as.character(list_1),rep("",longest_list-length(list_1)))
	list_2 <- append(as.character(list_2),rep("",longest_list-length(list_2)))
	list_3 <- append(as.character(list_3),rep("",longest_list-length(list_3)))
	unique_1 <- append(as.character(unique_1),rep("",longest_list-length(unique_1)))
	unique_2 <- append(as.character(unique_2),rep("",longest_list-length(unique_2)))
	unique_3 <- append(as.character(unique_3),rep("",longest_list-length(unique_3)))
	intersect_1_2 <- append(as.character(intersect_1_2),rep("",longest_list-length(intersect_1_2)))
	intersect_1_3 <- append(as.character(intersect_1_3),rep("",longest_list-length(intersect_1_3)))
	intersect_2_3 <- append(as.character(intersect_2_3),rep("",longest_list-length(intersect_2_3)))
	intersect_1_2_3 <- append(as.character(intersect_1_2_3),rep("",longest_list-length(intersect_1_2_3)))
	union_1_2 <- append(as.character(union_1_2),rep("",longest_list-length(union_1_2)))
	union_1_3 <- append(as.character(union_1_3),rep("",longest_list-length(union_1_3)))
	union_2_3 <- append(as.character(union_2_3),rep("",longest_list-length(union_2_3)))
	result_table [,1] <- as.character(list_1)
	result_table [,2] <- as.character(list_2)
	result_table [,3] <- as.character(list_3)
	result_table [,4] <- as.character(unique_1)
	result_table [,5] <- as.character(unique_2)
	result_table [,6] <- as.character(unique_3)
	result_table [,7] <- as.character(intersect_1_2)
	result_table [,8] <- as.character(intersect_1_3)
	result_table [,9] <- as.character(intersect_2_3)
	result_table [,10] <- as.character(intersect_1_2_3)
	result_table [,11] <- as.character(union_1_2)
	result_table [,12] <- as.character(union_1_3)
	result_table [,13] <- as.character(union_2_3)
	result_table [,14] <- as.character(union_1_2_3)
	rownames(result_table) <- as.character(1:longest_list)
	colnames(result_table) <- c(
			"list_1",
			"list_2",
			"list_3",
			"unique_1",
			"unique_2",
			"unique_3",
			"intersect_1_2",
			"intersect_1_3",
			"intersect_2_3",
			"intersect_all",		
			"union_1_2",
			"union_1_3",
			"union_2_3",
			"union_all")
	result_operation <- as.data.frame(result_operation)
	colnames(result_operation) <- common.column
	write.table(result_operation, file="intersect-lists-operation.tsv", sep="\t", row.names=T, col.names=T, quote=F)
	write.table(result_table, file="intersect-lists-summary.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}

# TOOL import-ArrayExpress.R: "Import from ArrayExpress" (Import Affymetrix raw data directly from ArrayExpress, and normalise it using the RMA algorithm.)
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# PARAMETER accession: accession TYPE STRING DEFAULT E-MEXP-1422 (Accession number of the experiment.)


# 13.1.2010
# JTT
#
# modified by MG, 30.4.2010 to add detection calls and remove offending characters

# Parameter settings (default) for testing purposes
#accession<-"E-MEXP-1422"

# Loads the libraries
library(ArrayExpress)

# Loads the data
dat<-ArrayExpress(accession)

# Normalizes the raw data
if(class(dat)=="AffyBatch") {
   library(affy)
   dat2<-rma(dat)
   dat2<-exprs(dat2)
   calls<-exprs(mas5calls(dat))
   calls<-as.data.frame(calls)
   colnames(dat2)<-paste("chip.", colnames(dat2), sep="")
   names(calls)<-paste("flag.", names(calls), sep="")
   dat2<-data.frame(dat2, calls)
   chiptype<-dat@annotation
}

# Writing out data
a<-try(library(paste(chiptype, ".db", sep=""), character.only=T))
if(chiptype!="empty" & class(a)!="try-error") {
   # Including gene names to data
   lib2<-sub('.db','',chiptype)
   symbol<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "SYMBOL", sep="")))))[rownames(dat2),])
   genename<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "GENENAME", sep="")))))[rownames(dat2),])
   # Writes the results into a file
   write.table(data.frame(symbol, description=genename, dat2), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
} 

if(chiptype=="empty" | class(a)=="try-error") {
   write.table(data.frame(dat2), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
}

# Writes out a phenodata table
sample<-rownames(pData(dat))
# remove any comment character from phenodata info
phenodata.info <- pData(dat)
for (count in 1:dim (phenodata.info) [2]) {
	phenodata.info[,count] <- gsub("#", "", phenodata.info[,count])
}

group<-c(rep("", nrow(pData(dat))))
chiptype<-paste(chiptype, ".db", sep="")
write.table(data.frame(sample=sample, chiptype=chiptype, group=group, phenodata.info), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# TOOL annotate-add-to-data.R: "Add annotations to data" (Annotates the genes, and adds the results to the datafile. Currently, this function only works with Agilent, Affymetrix and Illumina data.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT data-with-annotations.tsv: data-with-annotations.tsv 
# PARAMETER conditional: conditional TYPE [yes: yes, no: no] DEFAULT no (When run in Conditional mode, each gene is not only annotated to the most specific GO term but also to all its parent terms up to the top of the hierarchy. This option is recommended in conjunction to the tool Hypergeometric test for GO run in the Conditional testing mode.)

# Adds the annotation to the data
# JTT 21.1.2009
#
# MG 25.10.2010
# modified to cope with annomalies in Description names
# MG 25.1.2012
# modified to allow for conditional mode for GO terms

# Reads the chiptype from phenodata table
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
if(phenodata$chiptype[1]!="cDNA" | phenodata$chiptype[1]!="Illumina") {
	# Saves the chiptype into object lib
	lib<-phenodata$chiptype[1]
	lib<-as.character(lib)
}

# Account for the fact that annotation packages are from version 2.3 of Bioconductor
# named with an ".db" suffix. Add the suffix when missing to support data files
# from Chipster 1.3 and earlier. 
if (length(grep(".db", lib)) == 0 & length(grep("pmcdf", lib)) == 0) {
	lib <- paste(lib, ".db", sep="")
}

# Loads the correct annotation library
library(package=lib, character.only=T)
library(annaffy)

# Loads the data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Creating annotations from the library
annot.cols<-aaf.handler()
annot.table<-aafTableAnn(row.names(dat), lib, annot.cols)
saveText(annot.table, "annotations.tsv")

# Merging annotations and data
annot<-read.table("annotations.tsv", header=T, sep="\t", row.names=1, quote="")
annot$Pathway<-gsub("\'", "", annot$Pathway)
annot$Gene.Ontology<-gsub("\'", "", annot$Gene.Ontology)
datannot<-merge(dat, annot, by.x="row.names", by.y="row.names")
rownames(datannot)<-datannot[,1]
datannot<-datannot[,-1]

# If Conditional mode run this
if (conditional == "yes") {

	# Extract probes in query list
	probes.query <- rownames(dat)

	# Extract the mapping info
	lib2<-sub('.db','',lib)
	lib3 <- paste(lib2, "GO2ALLPROBES", sep="")
	env <- get(lib3)
	probes.2.go <- revmap(as.list(env))[probes.query] 

	# Input the GO ids that correspond to each probe id
	for (count in 1:length(probes.query)) {
		# merge GO id and term definition
		go.list <- unique(probes.2.go[[count]])
		if (is.null(go.list)) go.list <- ""
		go.list <- paste(go.list, Term(go.list))
		# concatenate GO list into single character vector
		go.list <- paste(go.list, collapse="; ")
		datannot$Gene.Ontology[count] <- go.list
	}

}

# Fixes an issue with the ' sign appearing in the Description column
# that causes troubles for downstream tools
datannot$Description <- gsub("'", "", datannot$Description)

# Remove any NA entries and replace with empty string in case there is no match
# between a probe id and GO id
datannot$Gene.Ontology[datannot$Gene.Ontology == " NA"] <- ""

# Writing out the annotated data
write.table(datannot, file="data-with-annotations.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# EOF

# TOOL acgh-identify-regions.R: "Identify common regions from called copy number data" (Reduces dimensionality of called copy number data by identifying common breakpoints.)
# INPUT aberrations.tsv: aberrations.tsv TYPE GENE_EXPRS 
# OUTPUT regions.tsv: regions.tsv 
# OUTPUT region-frequencies.pdf: region-frequencies.pdf 
# PARAMETER max.info.loss: "maximum loss of information" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.01 (Maximal information loss allowed.)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2013-04-12

source(file.path(chipster.common.path, 'CGHcallPlus.R'))
library(CGHregions)
library(WECCA)

file <- 'aberrations.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, as.is=TRUE, check.names=FALSE)

dat$chromosome[dat$chromosome=='X'] <- '23'
dat$chromosome[dat$chromosome=='Y'] <- '24'
dat$chromosome[dat$chromosome=='MT'] <- '25'
dat$chromosome <- as.integer(dat$chromosome)

calls <- as.matrix(dat[,grep("^flag\\.", names(dat))])
logratios <- as.matrix(dat[,grep("^chip\\.", names(dat))])
segmented <- as.matrix(dat[,grep("^segmented\\.", names(dat))])

if (length(grep("^probnorm\\.", names(dat)))>0) { # input contains probabilities (is a CGHcall object)
  probdel <- as.matrix(dat[,grep("^probdel\\.", names(dat))])
  probloss <- as.matrix(dat[,grep("^probloss\\.", names(dat))])
  probnorm <- as.matrix(dat[,grep("^probnorm\\.", names(dat))])
  probgain <- as.matrix(dat[,grep("^probgain\\.", names(dat))])
  probamp <- as.matrix(dat[,grep("^probamp\\.", names(dat))])

  if (ncol(probamp)==0) { # CGHcall run with nclass=3
    cgh <- new('cghCall', assayData=assayDataNew(calls=calls, copynumber=logratios, segmented=segmented, probloss=probloss, probnorm=probnorm, probgain=probgain), featureData=new('AnnotatedDataFrame', data=data.frame(Chromosome=dat$chromosome, Start=dat$start, End=dat$end, row.names=row.names(dat))))
  } else if (ncol(probdel)==0) { # CGHcall run with nclass=4
    cgh <- new('cghCall', assayData=assayDataNew(calls=calls, copynumber=logratios, segmented=segmented, probloss=probloss, probnorm=probnorm, probgain=probgain, probamp=probamp), featureData=new('AnnotatedDataFrame', data=data.frame(Chromosome=dat$chromosome, Start=dat$start, End=dat$end, row.names=row.names(dat))))
  } else { # CGHcall run with nclass=5
    cgh <- new('cghCall', assayData=assayDataNew(calls=calls, copynumber=logratios, segmented=segmented, probloss=probloss, probnorm=probnorm, probgain=probgain, probamp=probamp, probdloss=probdel), featureData=new('AnnotatedDataFrame', data=data.frame(Chromosome=dat$chromosome, Start=dat$start, End=dat$end, row.names=row.names(dat))))
  }

  rm(calls, segmented, probdel, probloss, probnorm, probgain, probamp)
  gc()

  regions <- regioning(cgh, max.info.loss)
  dat2 <- data.frame(regions[['ann']])
  hardcalls <- regions[['hardcalls']]
  softcalls <- TRUE
} else { # input contains only calls and logratios, no probabilities
  cgh <- data.frame(Probe=row.names(dat), Chromosome=dat$chromosome, Start=dat$start, End=dat$end, calls)

  rm(calls, segmented)
  gc()

  regions <- CGHregions(cgh, max.info.loss)
  dat2 <- fData(regions)
  hardcalls <- regions(regions)
  softcalls <- FALSE
}

colnames(dat2)[1:5] <- c('chromosome', 'start', 'end', 'num.probes', 'ave.dist')
dat2$ave.dist <- NULL

# end column contains starting positions of the last probes/bin of a region
# change them to the end positions of those probes/bins
if (nrow(dat2[dat2$chromosome %in% dat$chromosome & dat2$end %in% dat$start,]) >= nrow(dat2[dat2$chromosome %in% dat$chromosome & dat2$end %in% dat$end,]))
  for (row in rownames(dat2))
    dat2[row, 'end'] <- dat[dat$chromosome == dat2[row, 'chromosome'] & dat$start == dat2[row, 'end'], 'end'][1]

# calculate frequencies
if (-2 %in% hardcalls)
  dat2$del.freq <- round(rowMeans(hardcalls == -2), digits=3)
dat2$loss.freq <- round(rowMeans(hardcalls == -1), digits=3)
dat2$gain.freq <- round(rowMeans(hardcalls == 1), digits=3)
if (2 %in% hardcalls)
  dat2$amp.freq <- round(rowMeans(hardcalls == 2), digits=3)

dat2 <- cbind(dat2, hardcalls)
colnames(dat2) <- sub('^calls\\.', 'flag.', colnames(dat2))

# calculate median logratios and segments
region.medians <- segmented.medians <- hardcalls
for (row in rownames(region.medians)) {
  index <- dat$chromosome == dat2[row, "chromosome"] &
           dat$start >= dat2[row, "start"] &
           dat$start <= dat2[row, "end"]
  region.medians[row,] <- apply(logratios[index,], 2, median, na.rm=TRUE)
  segmented.medians[row,] <- apply(logratios[index,], 2, median, na.rm=TRUE)
}
colnames(region.medians) <- sub('^flag\\.', 'chip.', colnames(region.medians))
colnames(segmented.medians) <- sub('^flag\\.', 'segmented.', colnames(segmented.medians))
dat2 <- cbind(dat2, region.medians, segmented.medians)

# append soft calls if we have them
if (softcalls) {
  colnames(regions[['softcalls']]) <- sub('_flag', '', colnames(regions[['softcalls']]))
  dat2 <- cbind(dat2, regions[['softcalls']])
  # create the cghRegions object for plotting
  regions <- new('cghRegions', assayData=assayDataNew(regions=regions[['hardcalls']]), featureData=new('AnnotatedDataFrame', data=regions[['ann']]))
}

dat2$chromosome <- as.character(dat2$chromosome)
dat2$chromosome[dat2$chromosome=='23'] <- 'X'
dat2$chromosome[dat2$chromosome=='24'] <- 'Y'
dat2$chromosome[dat2$chromosome=='25'] <- 'MT'

options(scipen=10)
write.table(dat2, file='regions.tsv', quote=FALSE, sep='\t', col.names=TRUE, row.names=TRUE)

pdf(file='region-frequencies.pdf', paper='a4r', width=0, height=0)
frequencyPlot(regions)
plot(regions)
dev.off()

# EOF

# TOOL acgh-add-cytobands.R: "Add cytogenetic bands" (Adds the cytogenetic band information using chromosome names and start end base pair positions. If this position information is not present in your data set, please first run the Fetch probe positions from CanGEM tool.)
# INPUT normalized.tsv: normalized.tsv TYPE GENERIC 
# OUTPUT cytobands.tsv: cytobands.tsv 
# PARAMETER genome.build: genome.build TYPE [GRCh37: GRCh37, NCBI36: NCBI36, NCBI35: NCBI35, NCBI34: NCBI34] DEFAULT GRCh37 (The genome build to use. GRCh37 = hg19, NCBI36 = hg18, NCBI35 = hg17, NCBI34 = hg16.)

# add-cytobands.R
# Ilari Scheinin <firstname.lastname@gmail.com>
# 2010-10-05

dat <- read.table('normalized.tsv', header=TRUE, sep='\t', as.is=TRUE, row.names=1)

pos <- c('chromosome','start','end')
if (length(setdiff(pos, colnames(dat)))!=0)
  stop('CHIPSTER-NOTE: This script can only be run on files that have the following columns: chromosome, start, end.')

# load cytobands
bands <- read.table(paste('http://www.cangem.org/download.php?platform=CG-PLM-6&flag=', genome.build, sep=''), sep='\t', header=TRUE, as.is=TRUE)
colnames(bands) <- tolower(colnames(bands))
colnames(bands)[colnames(bands)=='chr'] <- 'chromosome'
rownames(bands) <- bands[,1]

dat2 <- dat[,pos]
dat2$cytoband <- NA
dat2 <- cbind(dat2, dat[,setdiff(colnames(dat), pos)])
dat <- dat2

dat.na <- dat[is.na(dat$chromosome),]
dat <- dat[!is.na(dat$chromosome),]

for (band in rownames(bands)) {
  index <- dat$chromosome == bands[band, 'chromosome'] &
                dat$start >= bands[band, 'start'] &
                dat$start <= bands[band, 'end']
  if (length(index)>0)
    dat[index, 'startband'] <- bands[band, 'band']
  index <- dat$chromosome == bands[band, 'chromosome'] &
                  dat$end >= bands[band, 'start'] &
                  dat$end <= bands[band, 'end']
  if (length(index)>0)
    dat[index, 'endband'] <- bands[band, 'band']
}

dat[!is.na(dat$startband), 'cytoband'] <- paste(dat[!is.na(dat$startband), 'startband'], '-', dat[!is.na(dat$startband), 'endband'], sep='')
dat[!is.na(dat$startband) & dat$startband==dat$endband, 'cytoband'] <- dat[!is.na(dat$startband) & dat$startband==dat$endband, 'startband']

dat$startband <- NULL
dat$endband <- NULL

dat <- rbind(dat, dat.na)

write.table(dat, file='cytobands.tsv', quote=FALSE, sep='\t', col.names=TRUE, row.names=TRUE)

# EOF

# TOOL search-correlation.R: "Search by correlation" (Search similarly expressed genes using correlation. Genename should be the row name that appears in all data files, e.g., Affymetrix ID.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT search-correlation.tsv: search-correlation.tsv 
# PARAMETER genename: genename TYPE STRING DEFAULT empty (Gene name)
# PARAMETER correlation.cutoff: correlation.cutoff TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.95 (Correlation cut-off for similar expression)
# PARAMETER correlation.method: correlation.method TYPE [pearson: pearson, spearman: spearman] DEFAULT pearson (Correlation method)


# Search genes with correlation to another gene
# JTT 20.6.2006

# Parameter settings (default) for testing purposes
#correlation.cutoff<-0.95
#correlation.method<-"pearson"
#genename<-"1007_s_at"

# Loads the data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Renaming variables
genename<-genename
cutoff<-correlation.cutoff
meth<-correlation.method

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]
gene<-as.numeric(dat2[grep(genename, row.names(dat)),][1,])
len<-dim(dat2)[[1]]
corr<-rep(0, len)
for(i in 1:len) {
   corr[i]<-c(cor(gene, as.numeric(dat2[i,]), method=meth))
}

# Selecting only genes with a correlation coefficient of at least cuttof
dat2<-dat[which(corr<=-cutoff | corr>=cutoff),]
dat2<-data.frame(dat2, cor=corr[which(corr<=-cutoff | corr>=cutoff)])

# Saving the results into a text file
write.table(dat2, "search-correlation.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL bed-sort.R: "Sort BED" (Sorts a BED file by chromosome and then by start position. This tool is based on the BEDTools package.)
# INPUT regions.bed TYPE GENERIC 
# OUTPUT sorted.bed 



# EK 22.6.2011

# binary
binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "sortBed"))

# command
command <- paste(binary, "-i regions.bed > sorted.bed")

# run
system(command)

# TOOL acgh-expression-test.R: "Test for copy-number-induced expression changes" (Nonparametric testing for changes in expression induced by a change in DNA copy number. The copy number and expression probes of the two data sets must be matched together beforehand using the Match copy number and expression probes tool.)
# INPUT matched-cn-and-expression.tsv: matched-cn-and-expression.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT cn-induced-expression.tsv: cn-induced-expression.tsv 
# PARAMETER test.statistic: test.statistic TYPE [wcvm: wcvm, wmw: wmw] DEFAULT wcvm (The test statistic to use.)
# PARAMETER analysis.type: analysis.type TYPE [univariate: univariate, regional: regional] DEFAULT univariate (The type of the analysis.)
# PARAMETER number.of.permutations: number.of.permutations TYPE INTEGER DEFAULT 10000 (The number of permutations used for the p-value calculation.)

# test-for-cn-induced-differential-expression.R
# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-12-13

source(file.path(chipster.common.path, 'CGHcallPlus.R'))
library(intCNGEan)

# read the input files
dat <- read.table('matched-cn-and-expression.tsv', header=TRUE, sep='\t', as.is=TRUE, row.names=1)
phenodata <- read.table('phenodata.tsv', header=TRUE, sep='\t', as.is=TRUE)

# check if the matched data was produced witha n old version
if (length(grep("^exprs\\.", names(dat)))!=0)
  stop('CHIPSTER-NOTE: The input file matched-cn-and-expression.tsv has been produced with an old version of the Match copy number and expression probes script. Please re-run that script first, and use the output from the new version.')

# check that the input file seems to be coming from the script used to match the two data sets
pos <- c('chromosome','cn.start','cn.end','exp.start','exp.end')
if (length(setdiff(pos, colnames(dat)))!=0)
  stop('CHIPSTER-NOTE: This tool can only be run on the output file from the tool Match copy number and expression probes (matched-cn-and-expression.tsv).')

# build the necessary object
dat$chromosome[dat$chromosome=='X'] <- 23
dat$chromosome[dat$chromosome=='Y'] <- 24
dat$chromosome[dat$chromosome=='MT'] <- 25
dat$chromosome <- as.integer(dat$chromosome)

exprs <- as.matrix(dat[,grep("^chip\\.", names(dat))])
rownames(exprs) <- dat$exp.probe
arrays <- phenodata$description

calls <- as.matrix(dat[,grep("^flag\\.", names(dat))])
copynumber <- as.matrix(dat[,grep("^copynumber\\.", names(dat))])
segmented <- as.matrix(dat[,grep("^segmented\\.", names(dat))])
probloss <- as.matrix(dat[,grep("^probloss\\.", names(dat))])
probnorm <- as.matrix(dat[,grep("^probnorm\\.", names(dat))])
probgain <- as.matrix(dat[,grep("^probgain\\.", names(dat))])

cgh <- new('cghCall', assayData=assayDataNew(calls=calls, copynumber=copynumber, segmented=segmented, probloss=probloss, probnorm=probnorm, probgain=probgain), featureData=new('AnnotatedDataFrame', data=data.frame(Chromosome=dat$chromosome, Start=dat$cn.start, End=dat$cn.end, row.names=row.names(dat))))

exp <- new("ExpressionSet", exprs=exprs, featureData=new("AnnotatedDataFrame", data=data.frame(Chromosome=dat$chromosome, Start=dat$exp.start, End=dat$exp.end, row.names=dat$exp.probe)))

matched <- list(CNdata.matched=cgh, GEdata.matched=exp)

# tune and test
tuned <- intCNGEan.tune(matched$CNdata.matched, matched$GEdata.matched, test.statistic=test.statistic)
result <- intCNGEan.test(tuned, analysis.type=analysis.type, test.statistic=test.statistic, nperm=number.of.permutations)

# for some reason, columns in the data.frame appear as lists in R-2.12.
# convert back to vectors
if (class(result[,1]) == 'list')
  for (i in 1:ncol(result))
    result[,i] <- unlist(result[,i])

if (nrow(tuned$ann) != nrow(result))
  stop('CHIPSTER-NOTE: The number of rows for the objects tuned and result do not match. Please report this to Ilari Scheinin.')

# format and write result table
rownames(result) <- rownames(tuned$ann)
colnames(result)[1:3] <- tolower(colnames(result)[1:3])

if ('symbol' %in% colnames(dat))
  result$symbol <- dat[rownames(tuned$datafortest), 'symbol']
if ('description' %in% colnames(dat))
  result$description <- dat[rownames(tuned$datafortest), 'description']

result$probes <- rownames(tuned$datafortest)
arrays <- colnames(tuned$datafortest)[(2*tuned$nosamp+1):(3*tuned$nosamp)]
colnames(tuned$datafortest) <- c(sub('^chip\\.', 'prob1.', arrays), sub('^chip\\.', 'prob2.', arrays), arrays)
result <- cbind(result, tuned$datafortest)
result <- result[order(result$adj.p),]

result$chromosome <- as.character(result$chromosome)
result$chromosome[result$chromosome=='23'] <- 'X'
result$chromosome[result$chromosome=='24'] <- 'Y'
result$chromosome[result$chromosome=='25'] <- 'MT'

write.table(result, file='cn-induced-expression.tsv', quote=FALSE, sep='\t', col.names=TRUE, row.names=TRUE)

# EOF

# TOOL ngs-find-motifs-jaspar.R: "Find common motifs and match to JASPAR" (This tool scans a set of genomic regions for consensus sequence motifs,
# calculates the alignment score against transcription factors in the JASPAR database, and reports the 10 highest ranking for each motif.)
# INPUT results.tsv: "Results data file" TYPE GENERIC 
# OUTPUT motif-analysis-summary.txt: "A lot of analysis information collected in one single file" 
# OUTPUT logo-plot-{...}.pdf: "Logo plots for each consensus motif" 
# PARAMETER p.value.cutoff: "P-value cutoff" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.0002 (This parameter controls the false positive rate when searching for consensus sequence motifs. Lower the value for increased stringency.)
# PARAMETER e.value.cutoff: "E-value cutoff" TYPE DECIMAL FROM 0 TO 100 DEFAULT 0.01 (This parameter controls the alignment stringency, where a lower value means better alignment.)
# PARAMETER genome: Genome TYPE [BSgenome.Hsapiens.UCSC.hg17: hg17, BSgenome.Hsapiens.UCSC.hg18: hg18, BSgenome.Hsapiens.UCSC.hg19: hg19, BSgenome.Mmusculus.UCSC.mm8: mm8, BSgenome.Mmusculus.UCSC.mm9: mm9, BSgenome.Rnorvegicus.UCSC.rn4: rn4] DEFAULT BSgenome.Hsapiens.UCSC.hg18 (The genome and version used when aligning the sequences.)
# PARAMETER number.best.matches: "Number of matches" TYPE INTEGER FROM 1 TO 20 DEFAULT 10 (The number of best matching transcription factors for each consensus sequence found. This affects both the textual summary output and the LOGO plots.)

# MG, 26.5.2010
# MG, 6.10.2011, added parameter to control number of best matches per TF amd updated to changes in R-2.12.1 and a

# Load the required libraries
library(MotIV)
library(rGADEM)
library(package=genome, character.only=TRUE)

# Read in data and convert to BED format
results_file <- read.table (file="results.tsv", sep="\t", header=T)
results_bed <- results_file[,1:3]
results_bed[,1] <- paste("chr",results_bed[,1], sep="")

# Convert to Ranged data
results_ranged <- IRanges(start=results_bed[,2], end=results_bed[,3])
results_sequences <- RangedData(results_ranged, space=results_bed[,1])

# Perform unseeded GADEM analysis with default values for specific genome
if (genome == "BSgenome.Hsapiens.UCSC.hg17" | genome == "BSgenome.Hsapiens.UCSC.hg18" | genome == "BSgenome.Hsapiens.UCSC.hg19") {
	results_gadem <- GADEM(
			results_sequences,
			verbose=1,
			genome=Hsapiens,
			pValue=p.value.cutoff,
			eValue=e.value.cutoff)
}
if (genome == "BSgenome.Mmusculus.UCSC.mm8" | genome == "BSgenome.Mmusculus.UCSC.mm9") {
	results_gadem <- GADEM(
			results_sequences,
			verbose=1,
			genome=Mmusculus,
			pValue=p.value.cutoff,
			eValue=e.value.cutoff)
}
if (genome == "BSgenome.Rnorvegicus.UCSC.rn4") {
	results_gadem <- GADEM(
			results_sequences,
			verbose=1,
			genome=Rnorvegicus,
			pValue=p.value.cutoff,
			eValue=e.value.cutoff)
}

# Read in Jaspar database
# path_jaspar <- system.file(package="rGADEM")
# file_name <- paste(path_jaspar, "/extdata/jaspar2009.txt", sep="/")
# jaspar <- readPWMfile(file_name)
#
# Actually, as of veersion 1.1.6 of MotIV the Jaspar database and scores
# are loaded automatically whem MotIV is loaded
# the data is called jaspar and the scores jaspar.scores

# Get the motifs from the GADEM objects
# but first make sure that there were some motifs found
# motifs_found <- try (results_motifs <- viewPWM(results_gadem))
#if (class(motifs_found) == "try-error") {
#	stop("CHIPSTER-NOTE: No common motifs were found among the query sequences! Retry with less stringent parameter settings or provide a longer list of query sequences.")
#}
if (length(nOccurrences(results_gadem)) < 1) {
	stop("CHIPSTER-NOTE: No common motifs were found among the query sequences! Retry with less stringent parameter settings or provide a longer list of query sequences.")
}

# Extract the PWM from the motif analysis
pwm_list <- getPWM(results_gadem)

# Find out how many consensus motifs were discovered
number_motifs <- length (nOccurrences (results_gadem))

# Find our how many occurrences of each motif
number_occurrences <- nOccurrences (results_gadem)

# View the consensus sequence for each motif
consensus_sequences <- consensus (results_gadem)

# Give appropriate names to the motifs
names <- character (number_motifs)
for (count in 1:number_motifs) {
	names [count] <- paste("motif", count, sep=" ")
}
names (pwm_list) <- names

# Perform a MotIV analysis of alignment with TF:s from JASPAR, only the top 10 matches for each motif are collected
results_alignment <- motifMatch(
		inputPWM=pwm_list,
		align="SWU",
		cc="PCC",
		database=jaspar,
		DBscores=jaspar.scores,
		top=number.best.matches)

# Get a list of the TF that matched any of the motifs
matching_tf_list <- viewMotifs (results_alignment)

# Get a summary of the results and settings
results_summary <- summary (results_alignment)

# Write out a results summary file
# print out a summary of the results
sink(file="motif-analysis-summary.txt")
print("Summary of MotIV analysis", quote=FALSE)
print("", quote=FALSE)
summary(results_alignment)
print("", quote=FALSE)
print("", quote=FALSE)
print ("Consensus sequence", quote=FALSE)
print("", quote=FALSE)
consensus_sequences
print("", quote=FALSE)
print("", quote=FALSE)
print ("Number of occurrences of consensus sequence for each motif", quote=FALSE)
print("", quote=FALSE)
number_occurrences
print("", quote=FALSE)
print("", quote=FALSE)
print ("Alignments of motifs to known TFBS", quote=FALSE)
print("", quote=FALSE)
viewAlignments(results_alignment)
print("", quote=FALSE)
print("", quote=FALSE)
print ("Weighted matrices for each motif", quote=FALSE)
print("", quote=FALSE)
pwm_list
sink()

# Plot the logo of the motifs and corresponding TF:s
# Adjust y-scale to number of best matches to be plotted
if (number.best.matches < 11) { 
	for (count in 1:number_motifs) {
		file_name <- paste("logo-plot-",count,".pdf", sep="")
		pdf(file=file_name, height=1400/72, width=600/72)
		plot_name <- consensus(results_gadem) [count]
		plot (results_alignment[count], top=number.best.matches, ncol=1, main=paste("Top TF matches for motif\n", plot_name, sep=""))
		dev.off()
	}
} else {
	for (count in 1:number_motifs) {
		file_name <- paste("logo-plot-",count,".pdf", sep="")
		pdf(file=file_name, height=2000/72, width=600/72)
		plot_name <- consensus(results_gadem) [count]
		plot (results_alignment[count], top=number.best.matches, ncol=1, main=paste("Top TF matches for motif\n", plot_name, sep=""))
		dev.off()
	}
}

# EOF

# TOOL acgh-fetch-probe-positions-from-cangem.R: "Fetch probe positions from CanGEM" (Fetches microarray probe positions from the CanGEM database.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT probe-positions.tsv: probe-positions.tsv 
# PARAMETER platform: platform TYPE [other: other, Affymetrix_GeneChip_Human_Mapping_50K_Xba: Affymetrix_GeneChip_Human_Mapping_50K_Xba, Affymetrix_Human_Genome_U133_Plus_2.0: Affymetrix_Human_Genome_U133_Plus_2.0, Affymetrix_Human_Genome_U133A: Affymetrix_Human_Genome_U133A, Affymetrix_Human_Genome_U133A_2.0: Affymetrix_Human_Genome_U133A_2.0, Affymetrix_Human_Genome_U133B: Affymetrix_Human_Genome_U133B, Affymetrix_Human_Genome_U95A: Affymetrix_Human_Genome_U95A, Affymetrix_Human_Genome_U95Av2: Affymetrix_Human_Genome_U95Av2, Affymetrix_Human_Genome_U95B: Affymetrix_Human_Genome_U95B, Affymetrix_Human_Genome_U95C: Affymetrix_Human_Genome_U95C, Affymetrix_Human_Genome_U95D: Affymetrix_Human_Genome_U95D, Affymetrix_Human_Genome_U95E: Affymetrix_Human_Genome_U95E, Agilent_Human_1_cDNA_Microarray_G4100A: Agilent_Human_1_cDNA_Microarray_G4100A, Agilent_Human_1A_Microarray_G4110A: Agilent_Human_1A_Microarray_G4110A, Agilent_Human_1A_Microarray_V2_G4110B: Agilent_Human_1A_Microarray_V2_G4110B, Agilent_Human_1B_Microarray_G4111A: Agilent_Human_1B_Microarray_G4111A, Agilent_Human_Genome_CGH_Oligo_Microarray_4x44K: Agilent_Human_Genome_CGH_Oligo_Microarray_4x44K, Agilent_Human_Genome_CGH_Oligo_Microarray_Kit_244A_G4411B: Agilent_Human_Genome_CGH_Oligo_Microarray_Kit_244A_G4411B, Agilent_Human_Genome_CGH_Oligo_Microarray_Kit_44A_G4410A: Agilent_Human_Genome_CGH_Oligo_Microarray_Kit_44A_G4410A, Agilent_Human_Genome_CGH_Oligo_Microarray_Kit_44B_G4410B: Agilent_Human_Genome_CGH_Oligo_Microarray_Kit_44B_G4410B, Agilent_Human_miRNA_Microarray: Agilent_Human_miRNA_Microarray, Agilent_Human_miRNA_Microarray_V2: Agilent_Human_miRNA_Microarray_V2, Agilent_Human_miRNA_Microarray_V3: Agilent_Human_miRNA_Microarray_V3, Agilent_Human_Promoter_ChIP_on_Chip_Set_244K_Microarray_1_of_2: Agilent_Human_Promoter_ChIP_on_Chip_Set_244K_Microarray_1_of_2, Agilent_Human_Promoter_ChIP_on_Chip_Set_244K_Microarray_2_of_2: Agilent_Human_Promoter_ChIP_on_Chip_Set_244K_Microarray_2_of_2, Agilent_Oxford_2x105: Agilent_Oxford_2x105, Agilent_Whole_Human_Genome_Microarray_Kit_G4112A: Agilent_Whole_Human_Genome_Microarray_Kit_G4112A, Agilent_Whole_Human_Genome_Oligo_Microarray_4x44K: Agilent_Whole_Human_Genome_Oligo_Microarray_4x44K, Turku_HUM_16K_cDNA: Turku_HUM_16K_cDNA, VUMC_Human_30K_60mer_oligo_array: VUMC_Human_30K_60mer_oligo_array, Ensembl_Genes: Ensembl_Genes, Ensembl_Cytobands: Ensembl_Cytobands, Ensembl_Chromosomes: Ensembl_Chromosomes] DEFAULT other (The microarray platform. If the one used is not on the list, but can be found from CanGEM, please select other and specify the accession number using the next parameter.)
# PARAMETER other.platform.accession: other.platform.accession TYPE STRING DEFAULT CG-PLM- (The accession of the platform. This is used only if other is selected in the previous parameter.)
# PARAMETER genome.build: genome.build TYPE [GRCh37: GRCh37, NCBI36: NCBI36, NCBI35: NCBI35, NCBI34: NCBI34] DEFAULT GRCh37 (The genome build to use for adding the chromosome names and start and end base pair positions for the probes.)
# PARAMETER username: username TYPE STRING DEFAULT empty (Username, in case the data is password-protected. WARNING: This will store your username password in the Chipster history files. To avoid this, use the session parameter.)
# PARAMETER password: password TYPE STRING DEFAULT empty (Password, in case the data is password-protected. WARNING: This will store your username password in the Chipster history files. To avoid this, use the session parameter.)
# PARAMETER session: session TYPE STRING DEFAULT empty (Session ID. To avoid saving your username password in Chipster history files, log in at http: www.cangem.org using a web browser, then copy&paste your session ID from the lower right corner of the CanGEM website. This will allow Chipster to access your password-protected data until you log out of the web site (or the session times out\).)

# fetch-probe-positions-from-cangem.R
# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-10-12

# determine platform accession if a platform was chosen from the popup
if (platform != 'other') {
 cangem.platforms <- c(Affymetrix_GeneChip_Human_Mapping_50K_Xba='CG-PLM-18', Affymetrix_Human_Genome_U133_Plus_2.0='CG-PLM-10', Affymetrix_Human_Genome_U133A='CG-PLM-7', Affymetrix_Human_Genome_U133A_2.0='CG-PLM-9', Affymetrix_Human_Genome_U133B='CG-PLM-8', Affymetrix_Human_Genome_U95A='CG-PLM-11', Affymetrix_Human_Genome_U95Av2='CG-PLM-16', Affymetrix_Human_Genome_U95B='CG-PLM-12', Affymetrix_Human_Genome_U95C='CG-PLM-13', Affymetrix_Human_Genome_U95D='CG-PLM-14', Affymetrix_Human_Genome_U95E='CG-PLM-15', Agilent_Human_1_cDNA_Microarray_G4100A='CG-PLM-1', Agilent_Human_1A_Microarray_G4110A='CG-PLM-19', Agilent_Human_1A_Microarray_V2_G4110B='CG-PLM-20', Agilent_Human_1B_Microarray_G4111A='CG-PLM-24', Agilent_Human_Genome_CGH_Oligo_Microarray_4x44K='CG-PLM-27', Agilent_Human_Genome_CGH_Oligo_Microarray_Kit_244A_G4411B='CG-PLM-17', Agilent_Human_Genome_CGH_Oligo_Microarray_Kit_44A_G4410A='CG-PLM-2', Agilent_Human_Genome_CGH_Oligo_Microarray_Kit_44B_G4410B='CG-PLM-4', Agilent_Human_miRNA_Microarray='CG-PLM-36', Agilent_Human_miRNA_Microarray_V2='CG-PLM-33', Agilent_Human_miRNA_Microarray_V3='CG-PLM-32', Agilent_Human_Promoter_ChIP_on_Chip_Set_244K_Microarray_1_of_2='CG-PLM-34', Agilent_Human_Promoter_ChIP_on_Chip_Set_244K_Microarray_2_of_2='CG-PLM-35', Agilent_Oxford_2x105='CG-PLM-31', Agilent_Whole_Human_Genome_Microarray_Kit_G4112A='CG-PLM-5', Agilent_Whole_Human_Genome_Oligo_Microarray_4x44K='CG-PLM-28', Turku_HUM_16K_cDNA='CG-PLM-3', VUMC_Human_30K_60mer_oligo_array='CG-PLM-30', Ensembl_Genes='CG-PLM-26', Ensembl_Cytobands='CG-PLM-6', Ensembl_Chromosomes='CG-PLM-37')
  other.platform.accession <- cangem.platforms[platform]
}

# check for valid platform accession
platform.accession <- toupper(other.platform.accession)
if (length(grep('^CG-PLM-[0-9]+$', platform.accession))==0)
  stop('CHIPSTER-NOTE: Not a valid platform accession: ', platform.accession)

file <- 'normalized.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, as.is=TRUE, check.names=FALSE)

# remove probe positions if already present
dat$chromosome <- NULL
dat$start <- NULL
dat$end <- NULL
dat$cytoband <- NULL

# construct the string used in authenticating
if (session != 'empty' && session != '') {
  auth <- paste('&PHPSESSID=', session, sep='')
} else if (username != 'empty' && username != '' && password != 'empty' && password != '') {
  auth <- paste('&username=', username, '&password=', password, sep = '')
} else auth <- ''

# load platform
if (platform == 'other') {
  plat <- read.table(paste('http://www.cangem.org/download.php?platform=', platform.accession, '&flag=', genome.build, auth, sep=''), sep='\t', header=TRUE, as.is=TRUE)
} else {
  # plat <- read.table(paste('http://www.cangem.org/download.php?platform=', platform.accession, '&flag=', genome.build, auth, sep=''), sep='\t', header=TRUE, as.is=TRUE)
  plat <- read.table(file.path(chipster.tools.path, 'CanGEM', platform, paste(genome.build, '.txt', sep='')), sep='\t', header=TRUE, as.is=TRUE)
}
colnames(plat) <- tolower(colnames(plat))
colnames(plat)[colnames(plat)=='chr'] <- 'chromosome'
rownames(plat) <- plat[,1]
plat$chromosome <- factor(plat$chromosome, levels=c(1:22, "X", "Y", "MT"), ordered=TRUE)

dat2 <- cbind(plat[rownames(dat), c('chromosome', 'start', 'end')], dat, row.names=rownames(dat))
dat2 <- dat2[order(dat2$chromosome, dat2$start),]

options(scipen=10)
write.table(dat2, file='probe-positions.tsv', quote=FALSE, sep='\t', col.names=TRUE, row.names=TRUE)

# EOF

# TOOL mothur-prepare-data.R: "Mothur - prepare data" (Preprocesses the sequence and the quality data for further analysis in mothur. Select all fasta and quality files you want to process at the same time as input files. This tool appends all sequence files together and does the same for all quality files, also.)
# INPUT file{...}.txt: "Sequence or data quality files" TYPE GENERIC 
# OUTPUT all.fasta
# OUTPUT all.qual
# OUTPUT phenodata.tsv
# OUTPUT OPTIONAL prepare_data_log.txt
# PARAMETER number.to.sample: "Number to sample" TYPE INTEGER FROM 0 TO 1000000 DEFAULT 0 (Number of sequences to sample from each each sequence file. If the value is left at default, all sequences are selected.)

# JTT 2012-11-01


# Assessory function
f<-function(x) {
	seq(x[2], x[3])
}

# Checking the file types
files<-dir()
type<-rep(NA, length(files))
for(i in 1:length(files)) {
	d<-readLines(files[i], n=2)
	if(!any(names(table(strsplit(d[2], ""))) %in% c("A", "C", "G", "T"))) {
		type[i]<-"qual"
	}
	if(d[1]==".sff") {
		type[i]<-"sff"
	}
	if(any(names(table(strsplit(d[2], ""))) %in% c("A", "C", "G", "T"))) {
		type[i]<-"seq"
	}
}
qual<-files[type=="qual"]
fasta<-files[type=="seq"]

# Process the files, if no sampling is used
if(number.to.sample==0) {
	for(i in 1:length(qual)) {
		d<-readLines(qual[i])
		write(d, "all.qual", append=T)
	}
	
	for(i in 1:length(fasta)) {
		d<-readLines(fasta[i])
		write(d, "all.fasta", append=T)
	}
}

# Process the files, if sampling is used
if(number.to.sample!=0) {
	for(i in 1:length(fasta)) {
		# Sequence files
		d<-readLines(fasta[i])
		s=grep(">", d)
		h=d[s]
		e=c((s-1)[-1], length(d))
		h<-data.frame(h, s, e)
		if(nrow(h)<number.to.sample) {
			stop(paste("There are less sequences than you specified for sampling! Sample ", fasta[i], " contains only ", nrow(h), " sequences. Please use rerun the tool using a smaller number of sequences.",sep=""))
		}
		s<-sample(1:nrow(h), number.to.sample, replace=FALSE)
		hs<-h[s,]
		l<-sort(as.vector(unlist(apply(hs, 1, f))))
		write(d[l], "all.fasta", append=T)
		# Quality files
		qu<-readLines(qual[i])
		write(qu[l], "all.qual", append=T)
	}
}

# Write out phenodata table
sample<-c(" "," ", fasta)
group<-c(rep("", length(sample))) 
oligo<-c("forward", "reverse", rep("barcode", length(fasta))) 
sequence<-rep("", length(sample))
write.table(data.frame(sample=sample, oligo=oligo, sequence=sequence, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# TOOL test.R: "Parameter demo" (Demonstration of all parameter types.)
# INPUT microarray.txt: microarray.txt TYPE CDNA 
# OUTPUT results.txt: results.txt 
# PARAMETER value1: value1 TYPE INTEGER FROM 0 TO 200 DEFAULT 10 (the first value of the result set)
# PARAMETER value2: value2 TYPE DECIMAL FROM 0 TO 200 DEFAULT 20 (the second value of the result set)
# PARAMETER value3: value3 TYPE DECIMAL FROM 0 TO 200 DEFAULT 30.2 (the third value of the result set)
# PARAMETER cutoff: cutoff TYPE PERCENT DEFAULT 34 (cut-off value for selecting data points)
# PARAMETER genename: genename TYPE STRING DEFAULT at_something (which gene we are interested in)
# PARAMETER key: key TYPE COLUMN_SEL (which column we use as a key)
# PARAMETER metakey: metakey TYPE METACOLUMN_SEL (which metadata column we use as a metakey)
# PARAMETER input: input TYPE INPUT_SEL (which input we want)
# PARAMETER method: method TYPE [linear: linear, logarithmic: logarithmic, exponential: exponential] DEFAULT logarithmic (which method to apply)

write.table(c(value1, value2, value3), file="results.txt", quote=FALSE, col.names=c('EXPRS'), row.names=FALSE)

# TOOL qc-affy.R: "Affymetrix basic" (Affymetrix quality control for RNA degradation and general quality parameters, such as scaling factor. This tool should be run on RAW data, i.e., CEL-files.)
# INPUT microarray{...}.cel: microarray{...}.cel TYPE AFFY 
# OUTPUT RNA-degradation-plot.pdf: RNA-degradation-plot.pdf 
# OUTPUT simpleaffy-plot.pdf: simpleaffy-plot.pdf 
# OUTPUT spike-in-plot.pdf: spike-in-plot.pdf 
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Affymetrix quality control
# JTT 9.6.2006
#
# modified 31.12.2009 by MG

#image.width<-600
#image.height<-600

# Loading the libraries
library(affy)
library(simpleaffy)

# Renaming variables
w<-image.width
h<-image.height

# Reading in data
dat<-ReadAffy()

# Setting up coloring and line types for plotting
library (RColorBrewer)	
number_samples <- dim(pData(dat))[1]
number_colors <- number_samples
number_columns <- ceiling(number_samples/16)
color_range <- brewer.pal (n=7, name="Set1")
color_range <- c(color_range,"black")
if (number_samples >= 8) {
	color_array <- rep(color_range, 100)
}
if (number_samples < 8) {
	color_array <- rep(color_range[1:number_samples], 100)
}
line_type <- c(rep(1,8),rep(2,8),rep(3,8),rep(4,8),rep(5,8),rep(6,8))
line_type <- rep(line_type, 100)
plot_symbol <- 1:8
if (number_samples >= 8) {
	plot_symbol <- rep(plot_symbol, 100)
}
if (number_samples < 8) {
	plot_symbol <- rep(plot_symbol[1:number_samples], 100)
}


# Calculating quality control values
aqc<-qc(dat)

# Plotting the QC-values
pdf(file="simpleaffy-plot.pdf", width=w/72, height=h/72)
plot(aqc)
dev.off()

# Checking the RNA degradation
deg<-AffyRNAdeg(dat)

# Define modified function for plotting RNA degradation plot
plot_RNA_deg <-function (rna.deg.obj, transform = "shift.scale", cols = NULL,
		line_type = 1, ...) 
{
	if (!is.element(transform, c("shift.scale", "shift.only", 
					"neither"))) 
		stop("Tranform must be 'shift.scale','shift.only', or 'neither'")
	mns <- rna.deg.obj$means.by.number
	if (is.null(cols)) 
		cols = rep(4, dim(mns)[1])
	ylab = "Mean Intensity"
	if (transform == "shift.scale") {
		sds <- rna.deg.obj$ses
		mn <- mns[, 1]
		mns <- sweep(mns, 1, mn)
		mns <- mns/(sds)
		mns <- sweep(mns, 1, 1:(dim(mns)[1]), "+")
		ylab <- paste(ylab, ": shifted and scaled")
	}
	else if (transform == "shift.only") {
		mn <- mns[, 1]
		mns <- sweep(mns, 1, mn)
		mns <- sweep(mns, 1, 1:(dim(mns)[1]), "+")
		ylab <- paste(ylab, ": shifted")
	}
	plot(-2, -1, pch = "", xlim = range(-1, (dim(mns)[2])), ylim = range(min(as.vector(mns)) - 
							1, max(as.vector(mns)) + 1), xlab = "5' <-----> 3'\n Probe Number ", 
			ylab = ylab, axes = FALSE, main = "RNA degradation plot", 
			...)
	axis(1)
	axis(2)
	for (i in 1:dim(mns)[1]) lines(0:((dim(mns)[2] - 1)), mns[i, 
				], col = cols[i], lty=line_type[i])
}
# Saving the degradation result into a file
pdf(file="RNA-degradation-plot.pdf", width=w/72, height=h/72)
plot_RNA_deg(deg, col=color_array, line_type=line_type)
legend(legend=sampleNames(dat), x="topleft", lty=line_type, cex=0.75, 
	col=color_array, ncol=number_columns)
dev.off()

# Assess and plot spike-in performance
par(cex=0.75, cex.main=1.5, mar=c(5,5,4,2))
concentration <- log(c(1.5, 5, 25, 100))
x_values <- array(concentration, c(4, number_samples))
x_values <- t(x_values)
y_values <- spikeInProbes(aqc)
pdf(file="spike-in-plot.pdf", width=w/72, height=h/72)
plot(x_values, y_values, col=color_array, main="Spike-in performance",
		xlab="log10 (concentration in pM)", ylab="log2 (expression)",
		pch=plot_symbol, type="p")
legend(legend=sampleNames(dat), x="topleft",
		col=color_array, lty=line_type, ncol=number_columns, cex=0.75,
		pch=plot_symbol)

for (loop_count in 1:length(dat))
{
	y_values <- spikeInProbes(aqc) [loop_count,]
	lm_spike <- lm(y_values~concentration)
	slope <- coef(lm_spike) [2]
	intercept <- coef(lm_spike) [1]
	abline(intercept, slope, col=color_array[loop_count], lty=line_type[loop_count])
}
dev.off()

# TOOL average-replicates.R: "Average replicate chips" (Calculates averages for replicate chips.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT average-replicates.tsv: average-replicates.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to average.)
# PARAMETER averaging: averaging TYPE [mean: mean, median: median] DEFAULT mean (Averaging using the mean or median.)

# Average replicate chips
# JTT 30.7.2007
#
# modified by MG, 12.4.2010
# rewritten by IS, 6.9.2010
# modified by IS, 16.2.2011
# modified by IS,12.10.2012

# load inputs
file <- 'normalized.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, check.names=FALSE)
phenodata <- read.table('phenodata.tsv', header=TRUE, sep='\t', as.is=TRUE)

# identify replicates
replicates <- unique(phenodata[duplicated(phenodata[,column]), column])
unique.chips <- which(!phenodata[,column] %in% replicates)

# generate new phenodata
concatenate.if.not.equal <- function(x) {
	x <- unique(x)
	paste(x, collapse=';')
}
numeric.cols <- sapply(phenodata, is.numeric)
other.cols <- !sapply(phenodata, is.numeric)
phenodata2 <- phenodata[unique.chips,]
for (s in replicates) {
	ss <- phenodata[phenodata[,column] == s,]
	ss[1, numeric.cols] <- apply(as.data.frame(ss[,numeric.cols]), 2, averaging)
	ss[1, other.cols] <- apply(as.data.frame(ss[,other.cols]), 2, concatenate.if.not.equal)
	ss <- ss[1,]
	phenodata2 <- rbind(phenodata2, ss)
}
phenodata2$sample <- sprintf('microarray%.3i', 1:nrow(phenodata2))

# identify matrices (chip, flag, segmented, ...) present in the data
x <- colnames(dat)
suffix <- sub('^chip\\.', '', x[grep('^chip\\.', x)[1]])
matrices <- sub(suffix, '', x[grep(suffix, x)])

# identify annotation columns (that are not part of any of the matrices)
annotations <- 1:ncol(dat)
for (m in matrices)
	annotations <- setdiff(annotations, grep(m, x))
dat2 <- dat[,annotations]

# generate new data table
for (m in matrices) {
	m2 <- dat[,grep(m, x)]
	m3 <- as.data.frame(m2[,unique.chips])
	num <- is.numeric(as.matrix(m2))
	for (s in replicates) {
		ss <- which(phenodata[,column] == s)
		if (num) {
			ss <- apply(m2[,ss], 1, averaging, na.rm=TRUE) # what to do with the log transformation?
		} else {
			ss <- apply(m2[,ss], 1, concatenate.if.not.equal)
		}
		m3 <- cbind(m3, ss, stringsAsFactors=FALSE)
	}
	colnames(m3) <- paste(m, phenodata2$sample, sep='')
	dat2 <- cbind(dat2, m3)
}

# write output
options(scipen=10)
write.table(dat2, file='average-replicates.tsv', quote=FALSE, sep='\t')
write.table(phenodata2, file='phenodata.tsv', quote=FALSE, sep='\t', row.names=FALSE)

# EOF

# TOOL norm-illumina-methylumi.R: "Illumina - methylumi pipeline" (Illumina methylation assay normalization using FinalReport files and lumi methodology. You need to import the FinalReport file DIRECTLY, not using the Import tool. The FinalReport file has to contain sample methylation profiles, group profile will not work with this tool.)
# INPUT FinalReport_sample_methylation_profile.txt: FinalReport_sample_methylation_profile.txt TYPE GENERIC 
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT unmethylated.tsv: unmethylated.tsv 
# OUTPUT methylated.tsv: methylated.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# OUTPUT OPTIONAL QC-plot.pdf: QC-plot.pdf
# PARAMETER chiptype: Chiptype TYPE [HumanMethylation27: HumanMethylation27, HumanMethylation450: HumanMethylation450] DEFAULT HumanMethylation27 (Select the correct BeadChip type)
# PARAMETER OPTIONAL normalization: Normalization TYPE [none: none, quantile: quantile, ssn: ssn] DEFAULT quantile ()
# PARAMETER OPTIONAL color.balance.adjustment: "Color balance adjustment" TYPE [none: none, quantile: quantile, ssn: ssn] DEFAULT quantile (Adjustment of color balance)
# PARAMETER OPTIONAL background.correction: "Background correction" TYPE [none: none, bgAdjust2C: bgAdjust2C, forcePositive: forcePositive] DEFAULT none (Should background adjustment be applied)
# PARAMETER OPTIONAL QCplots: QCplots TYPE [yes: yes, no: no] DEFAULT yes (Do you want quality control plots)
# PARAMETER OPTIONAL image.width: "Image width" TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the QC image)
# PARAMETER OPTIONAL image.height: "Image height" TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the QC image)


# Illumina methylation array data preprocessing and normalization for FinalReport file
# JTT 2.2.2011
# Modified 25.9.2012 and 28.10.2012 by JTT

# setwd("C://Users//Jarno Tuimala//Desktop//methylumi data")
# color.balance.adjustment<-c("quantile")
# background.correction<-c("none")
# normalization<-c("quantile")
# chiptype<-c("HumanMethylation450")
# QCplots<-"yes"
# image.width<-c(600)
# image.height<-c(600)

# Renaming variables
w<-image.width
h<-image.height

# Loading libraries
library(lumi)
library(methylumi)
library(annotate)

# Converting to the correct chiptype
if(chiptype=="HumanMethylation27") {
	chiptype<-c("IlluminaHumanMethylation27k")
}
if(chiptype=="HumanMethylation450") {
	chiptype<-c("IlluminaHumanMethylation450k")
}
chiptype<-paste(chiptype, ".db", sep="")

# Loading data files
#dat<-lumiMethyR("chip.tsv", lib=chiptype)
dat<-methylumiR("FinalReport_sample_methylation_profile.txt", lib=chiptype)
methyLumiM <- as(dat, "MethyLumiM")
methyLumiM <- addAnnotationInfo(methyLumiM, lib = chiptype)

# Color balance adjustment
dat2<-lumiMethyC(methyLumiM, method=color.balance.adjustment)

# Background adjustment
if(color.balance.adjustment!="none") {
   dat3<-lumiMethyB(dat2, method=background.correction, separateColor=FALSE)
} else {
   dat3<-lumiMethyB(dat, method=background.correction, separateColor=TRUE)
}

# Normalization
dat4<-lumiMethyN(dat3, method=normalization)
#dat4<-normalizeMethyLumiSet(dat)

# QC plots
if(QCplots=="yes") {
   pdf(file="QC-plot.pdf", width=w/72, height=h/72)
   par(mfrow=c(2,2))
   plotColorBias1D(dat, main="Unpreprocessed")
   plotColorBias1D(dat4, main="Preprocessed")
   boxplotColorBias(dat, main="Unpreprocessed")
   boxplotColorBias(dat4, main="Preprocessed")
   dev.off()
}

# Convert sample names to Chipster style
dat5<-exprs(dat4)
sample.names<-colnames(dat5)
sample.names<-paste("chip.", sample.names, sep="")
names(dat5)<-sample.names
colnames(dat5)<-sample.names

dat6<-methylated(dat4)
sample.names<-colnames(dat6)
sample.names<-paste("chip.", sample.names, sep="")
names(dat6)<-sample.names
colnames(dat6)<-sample.names

dat7<-unmethylated(dat4)
sample.names<-colnames(dat7)
sample.names<-paste("chip.", sample.names, sep="")
names(dat7)<-sample.names
colnames(dat7)<-sample.names

# Annotations
library(chiptype, character.only=T)
symbols <- unlist (lookUp(rownames(dat5), chiptype, what="SYMBOL"))
genenames <- unlist (lookUp(rownames(dat5), chiptype, what="GENENAME"))
symbols <- gsub("#", "", symbols)
genenames <- gsub("#", "", genenames)
symbols <- gsub("'", "", symbols)
genenames <- gsub("'", "", genenames)

# Write out a phenodata
group<-c(rep("", ncol(dat5)))
training<-c(rep("", ncol(dat5)))
write.table(data.frame(sample=sample.names, chiptype=chiptype, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# Write out expression data
write.table(data.frame(symbol=symbols, description=genenames, dat5), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
write.table(data.frame(symbol=symbols, description=genenames, dat6), file="methylated.tsv", col.names=T, quote=F, sep="\t", row.names=T)
write.table(data.frame(symbol=symbols, description=genenames, dat7), file="unmethylated.tsv", col.names=T, quote=F, sep="\t", row.names=T)

# TOOL plot-idiogram.R: Idiogram (Plots the idiogram of genes on all chromosomes in the selected list. For each chromosome, the Y axis reports the position of the gene along the cytobands. On the X axis the fold changes of each gene are reported. Up-regulated genes are highlighted with red color, the down-regulated with green color. Currently, this works only for human, mouse and rat data.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT idiogram.pdf: idiogram.pdf 
# PARAMETER chip.to.plot: chip.to.plot TYPE INTEGER FROM 1 TO 1000 DEFAULT 1 (Which chip to plot)
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Plotting the idiogram of expressed genes
# DG 16.10.2006
# Modified by JTT 22.11.2006

# Loads the libraries
library(idiogram)
library(geneplotter)
library(genefilter)

# Loads the human idiogram data
data(Hs.cytoband)

# Parameter settings (default) for testing purposes
#chip.to.plot<-1
#image.width<-600
#image.height<-600

# Renaming variables
w<-image.width
h<-image.height
chip<-chip.to.plot

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Scaling the data to the same mean
scaled.dat<-genescale(dat2)

# Creating locations of genes
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
if(phenodata$chiptype[1]!="cDNA" | phenodata$chiptype[1]!="Illumina") {
   # Saves the chiptype into object lib
   lib<-phenodata$chiptype[1]
   lib<-as.character(lib)
}

# Account for the fact that annotation packages are from version 2.3 of Bioconductor
# named with an ".db" suffix. Add the suffix when missing to support data files
# from Chipster 1.3 and earlier. 
if (length(grep(".db", lib)) == 0 & length(grep("pmcdf", lib)) == 0) {
        lib <- paste(lib, ".db", sep="")
}

# Needs a parameter lib that defines the Affymetrix chip type
chromloc<-buildChromLocation(lib)

# Fold changes are stored in a named vector
fc<-scaled.dat[,chip]
names(fc)<-rownames(scaled.dat)

# Creating colors
cols<-rep("black", times=length(fc))
cols[fc>0]<-"red"
cols[fc<0]<-"green"

# What chromosomes are there for the species?
x<-get(paste(gsub(".db", "", lib), "CHR", sep=""))
mapped_probes <- mappedkeys(x)
xx <- as.list(x[mapped_probes])
chr<-unique(unlist(xx))
chr<-chr[-which(chr=="Un")]

# Fixing the chromosome locations object
chromloc@chromLocs<-chromloc@chromLocs[names(chromloc@chromLocs) %in% chr]
chromloc@chromInfo<-chromloc@chromInfo[names(chromloc@chromInfo) %in% chr]

# Plots the idiogram
pdf(file="idiogram.pdf", width=w/72, height=h/72)
midiogram(fc, chromloc, col=cols, pch=20) 
dev.off()

# TOOL  MEDIPS_one_sample_V1.R: "MEDIPS - methylation analysis, treatment only" (Analysis of MeDIP-seq data for a single condition. This tool is based on the MEDIPS package developed by Chavez et al.)
# INPUT MEDIPS-input.tsv: "Converted BAM data files in MEDIPS format" TYPE GENERIC
# OUTPUT OPTIONAL saturationplot.png: "Saturation plot"
# OUTPUT OPTIONAL coverageplot.pdf: "Coverage plot"
# OUTPUT OPTIONAL calibrationplot.pdf: "Calibration plot"
# OUTPUT OPTIONAL CpGdensities.pdf: "CpG density plot"
# OUTPUT OPTIONAL RPMsignal.pdf: "RPM plot"
# OUTPUT OPTIONAL AMSsignal.pdf: "AMS plot"
# OUTPUT OPTIONAL rois.tsv: "Promoter regions"
# OUTPUT OPTIONAL output.bed: "BED file"
# OUTPUT output.tsv: "Enrichment data"
# PARAMETER species TYPE [human] DEFAULT human (Select the species)
# PARAMETER promoters.only TYPE [yes, no] DEFAULT no (Should the analyses be restricted to promoter regions only)
# PARAMETER coverage.resolution TYPE [25,50,100,200] DEFAULT  50 (Targeted data resolution, in base pairs, when the genome-wide coverage is calculated)
# PARAMETER smoothing.extension TYPE [200,400,800,1200] DEFAULT 400 (The amount of data smoothing, in base pairs, by extending the reads)
# PARAMETER fragment.length TYPE [400,800,1600,2400] DEFAULT 800 (Length of the fragment for calculation of local CpGs)
# PARAMETER save.bam TYPE [yes, no] DEFAULT yes (Should the normalized data, as rpm, be saved as a bam file)
# PARAMETER promoter.upstream TYPE [1000,2000,5000] DEFAULT 1000 (How much upstream, in base pairs, from the transcription start site does the promoter extend)
# PARAMETER promoter.downstream TYPE [250,500,750,1000] DEFAULT 500 (How much downstream, in base pairs, from the transcription start site does the promoter extend)
# PARAMETER image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted images in pixels)
# PARAMETER image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted images in pixels)


# Parameters for testing purposes only
#species<-"human"
#promoters.only<-"no"
#coverage.resolution<-"100"
#smoothing.extension<-"1200"
#fragment.length<-2400
#save.wiggle<-"yes"
#promoter.upstream<-"1000"
#promoter.downstream<-"500"
#image.width<-600
#image.height<-600

# Processing of the parameters
if(species=="human") {
   genome<-c("BSgenome.Hsapiens.UCSC.hg19")
   pgenome<-"hg19"  
   library(BSgenome.Hsapiens.UCSC.hg19)
}
w<-image.width
h<-image.height

# Input files
files<-dir(pattern="MEDIPS-input")





# Reading the MEDIPS input file
library(MEDIPS)
dat<-MEDIPS.readAlignedSequences(BSgenome=genome, file=files)

# Creating the genome vector
dat<-MEDIPS.genomeVector(data=dat, bin_size=as.numeric(coverage.resolution), extend=as.numeric(smoothing.extension))

# Cleaning up to save some memory
gc()

# Saturation analysis
sr<-MEDIPS.saturationAnalysis(data=dat, bin_size=as.numeric(coverage.resolution), extend=as.numeric(smoothing.extension), no_iterations=10, no_random_iterations=1)
bitmap(file="saturationplot.png", width=w/72, height=h/72)
par(mar=c(5,5,5,5))
MEDIPS.plotSaturation(sr)
dev.off()

# Pattern Positions
dat<-MEDIPS.getPositions(data=dat, pattern="CG")

# Coverage analysis
cr<-MEDIPS.coverageAnalysis(data=dat, extend=as.numeric(smoothing.extension), no_iterations=10)
pdf(file="coverageplot.pdf", width=w/72, height=h/72)
par(mar=c(5,5,5,5))
MEDIPS.plotCoverage(cr)
dev.off()

# Coupling vector
dat<-MEDIPS.couplingVector(data=dat, fragmentLength=as.numeric(fragment.length), func="count")

# Calibration curve plot
dat<-MEDIPS.calibrationCurve(data=dat)
pdf(file="calibrationplot.pdf", width=w/72, height=h/72)
par(mar=c(5,5,5,5))
MEDIPS.plotCalibrationPlot(dat)
dev.off()

# Normalization
dat<-MEDIPS.normalize(data=dat)

# Save the wiggle file
if(save.bam=="yes") {
   MEDIPS.exportWIG(file="output.bed", data=dat, raw=T, descr=files)
   library(rtracklayer)
   wig<-import("output.bed", format="wig")
   export(wig, "output.bed", format="bed")
   wig<-read.table("output.bed", header=F, sep="\t")
   wig<-wig[wig[,5]>0,]
   wig <- sort.bed(wig)
   write.table(wig, "output.bed", col.names=F, row.names=F, sep="\t", quote=F)
}

if(promoters.only=="yes") {
   library(rtracklayer)
   session <- browserSession()
   genome(session) <- pgenome
   query <- ucscTableQuery(session, "refGene")
   refGene<-getTable(query)
   sta<-refGene$txStart
   sta[refGene$strand=="+"]<-sta[refGene$strand=="+"]-1000
   sta[refGene$strand=="-"]<-sta[refGene$strand=="-"]-500
   sto<-refGene$txStart
   sto[refGene$strand=="+"]<-sto[refGene$strand=="+"]+500
   sto[refGene$strand=="-"]<-sto[refGene$strand=="-"]+1000
   rois<-data.frame(refGene$chrom, sta, sto, make.unique(as.character(refGene$name)))
   rois<-rois[rois[,1] %in% unique(dat@genome_chr),]
   write.table(rois, "rois.tsv", sep="\t", quote=F, col.names=F, row.names=F)
   frames<-MEDIPS.methylProfiling(data1=dat, ROI_file="rois.tsv", math=mean, select=2)
   write.table(frames, "output.tsv", sep="\t", quote=F, col.names=T, row.names=F)
}

if(promoters.only=="no") {
   frames<-MEDIPS.methylProfiling(data1=dat, frame_size=as.numeric(smoothing.extension), step=as.numeric(smoothing.extension)/2, math=mean, select=2)
   write.table(frames, "output.tsv", sep="\t", quote=F, col.names=T, row.names=F)
}

# Some plots of the enrichment results
pdf(file="CpGdensities.pdf", width=w/72, height=h/72)
par(mar=c(5,5,5,5))
hist(frames$coupling, breaks=100, main="CpG densities", xlab="CpG coupling factors") 
dev.off()

pdf(file="RPMsignal.pdf", width=w/72, height=h/72)
par(mar=c(5,5,5,5))
hist(frames$rpm_A[frames$rpm_A!=0], breaks=100, main="RPM signals", xlab="reads/bin") 
dev.off()

pdf(file="AMSsignal.pdf", width=w/72, height=h/72)
par(mar=c(5,5,5,5))
hist(frames$ams_A[frames$ams_A!=0], breaks=100, main="AMS signals", xlab="absolute methylation score (ams)") 
dev.off()

# TOOL prinseq-trimmer.R: "Trim reads for several criteria" (Trims reads based on given criteria. This tool is based on the PRINSEQ package.)
# INPUT fastqfile: "Input reads set" TYPE GENERIC
# OUTPUT OPTIONAL trimmed.fastq
# OUTPUT OPTIONAL trimmed.fasta
# OUTPUT OPTIONAL trim.log3
# PARAMETER input.mode: "Input file format" TYPE [ fq: "FASTQ", fa: "FASTA"] DEFAULT fq (Define the file format of the reads file)
# PARAMETER OPTIONAL trim.to.len: "Trim to length" TYPE INTEGER (Trim reads from 3-prime end to this length.)
# PARAMETER OPTIONAL trim.left: "Trim left" TYPE INTEGER (Trim reads at the 5-prime end by given number of bases.)
# PARAMETER OPTIONAL trim.right: "Trim right" TYPE INTEGER (Trim reads at the 3-prime end by given number of bases.)
# PARAMETER OPTIONAL trim.tail.left: "Trim left A/T tails" TYPE INTEGER (Trim poly-A/T tail with a minimum length of the given value at the 5-prime end.)
# PARAMETER OPTIONAL trim.tail.right: "Trim right A/T tails" TYPE INTEGER (Trim poly-A/T tail with a minimum length of the given value at the 3-prime end.)
# PARAMETER OPTIONAL trim.ns.left: "Trim left poly-N tails" TYPE INTEGER (Trim poly-N tail with a minimum length of the given value at the 5-prime end.)
# PARAMETER OPTIONAL trim.ns.right: "Trim right poly-N tails" TYPE INTEGER (Trim poly-N tail with a minimum length of the given value at the 3-prime end.)		
# PARAMETER OPTIONAL trim.qual.left: "Trim 5-prime end by quality" TYPE INTEGER (Trim reads from the 5-prime end based on the given quality threshold score.)
# PARAMETER OPTIONAL trim.qual.right: "Trim 3-prime end by quality" TYPE INTEGER (Trim reads from the 3-prime end based on the given quality threshold score.)		
# PARAMETER OPTIONAL trim.qual.type: "Quality score calculation method" TYPE [min: "minimum quality value", mean: "mean quality", max: "maximum quality value", sum: "total sum of quality values"] DEFAULT min (Type of quality score calculation to use.)
# PARAMETER OPTIONAL trim.qual.rule: "Quality score comparison condition" TYPE [ lt: "less than", gr: "greater than", et: "equal to"] DEFAULT lt (Rule to use to compare quality score threshold to calculated value.)
# PARAMETER OPTIONAL trim.qual.window: "Window size for quality calculation" TYPE INTEGER DEFAULT 1 (The sliding window size used to calculate quality score by type. Use 1 to stop at the first base that fails the defined rule.)
# PARAMETER OPTIONAL trim.qual.step: "Step size used to move the quality window" TYPE INTEGER DEFAULT 1 (Step size to move the sliding window. To move the window over all quality scores without missing any, the step size should be less than or equal to the window size.)
# PARAMETER OPTIONAL phred64: "Base quality encoding" TYPE [ n: "Sanger", y: "Illumina v1.3-1.5"] DEFAULT n (Select \"Sanger" for Illumina v1.8+, Sanger, Roche/454, Ion Torrent and PacBio data.)
# PARAMETER OPTIONAL log.file: "Write a log file" TYPE [ n: "no", y: "yes"] DEFAULT y (Write a log file)


# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("fastqfile")

# binary
binary.prinseq <- c(file.path(chipster.tools.path, "prinseq", "prinseq-lite.pl"))

trim.params <- paste(" ")
if (!is.na(trim.to.len)) {
	trim.params <- paste(trim.params, "-trim_to_len", trim.to.len )
}

if (!is.na(trim.left)) {
	trim.params <- paste(trim.params, "-trim_left", trim.left )
}

if (!is.na(trim.right)) {
	trim.params <- paste(trim.params, "-trim_right", trim.right )
}

if (!is.na(trim.tail.left)) {
	trim.params <- paste(trim.params, "-trim_tail_left",  trim.tail.left)
}

if (!is.na(trim.tail.right)) {
	trim.params <- paste(trim.params, "-trim_tail_right",  trim.tail.right)
}

if (!is.na(trim.ns.left)) {
	trim.params <- paste(trim.params, "-trim_ns_left",  trim.ns.left)
}

if (!is.na(trim.ns.right)) {
	trim.params <- paste(trim.params, "-trim_ns_right",  trim.ns.right)
}

if (!is.na(trim.qual.right)) {
	trim.params <- paste(trim.params, "-trim_qual_right",  trim.qual.right, "-trim_qual_type", trim.qual.type, "-trim_qual_rule", trim.qual.rule, "-trim_qual_window", trim.qual.window, "-trim_qual_step",  trim.qual.step)
}

if (!is.na(trim.qual.left)) {
	trim.params <- paste(trim.params, "-trim_qual_left",  trim.qual.left, "-trim_qual_type", trim.qual.type, "-trim_qual_rule", trim.qual.rule, "-trim_qual_window", trim.qual.window, "-trim_qual_step",  trim.qual.step)
}

if ( phred64 == "y") {
	trim.params <- paste(trim.params, "-phred64")
}

if (input.mode == "fq") {
 trim.command <- paste(binary.prinseq, trim.params, "-fastq fastqfile -out_good trimmed")
}

if (input.mode == "fa") {
	trim.command <- paste(binary.prinseq, trim.params, "-fasta fastqfile -out_good trimmed")
}


if (log.file == "y") {
	system("echo Running PRINSEQ filtering with command: > trim.log")
	echo.command <- paste("echo '", trim.command, "'>> trim.log")
	system(echo.command)
	trim.command <- paste(trim.command, "-verbose 2>> trim.log")
}


system(trim.command)
#Make sure something is in the output
if (input.mode == "fq") {
	system("if [ ! -e  trimmed.fastq ] ; then echo 'Trimming produced an empty trimmed.fastq sequence set' >> trim.log ; echo '' > trimmed.fastq ; fi")
}

if (input.mode == "fa") {
	system("if [ ! -e  trimmed.fasta ] ; then echo 'Trimming produced an empty trimmed.fasta sequence set' >> trim.log ; echo '' > trimmed.fasta ;fi")
}


#stop(paste('CHIPSTER-NOTE: ', filter.command))

library(CGHcall)
library(CGHregions)
library(WECCA)

setMethod("plot", signature(x="cghRaw", y="missing"),
function (x, y, dotres=1, ylimit=c(-2,5), ylab=expression(log[2]~ratio), build="GRCh37",... )
{
    for (i in 1:ncol(x)) {
        cat("Plotting sample", sampleNames(x)[i], "\n")
        chrom           <- chromosomes(x)
        data            <- data.frame(chrom, bpstart(x), copynumber(x)[,i])
        colnames(data)  <- c("chromosome", "position", "ratio")
        pos             <- bpstart(x)
        uni.chrom <- unique(chrom)
        chrom.lengths <- .getChromosomeLengths(build)[as.character(uni.chrom)]
        chrom.ends <- integer()
        cumul <- 0
        for (j in uni.chrom) {
            pos[chrom > j] <- pos[chrom > j] + chrom.lengths[as.character(j)]
            cumul <- cumul + chrom.lengths[as.character(j)]
            chrom.ends <- c(chrom.ends, cumul)
        }
        names(chrom.ends) <- names(chrom.lengths)
        nclone <- length(chrom)
        whichtoplot <- seq(1,nclone,by=dotres) #added 15/06/2009
        plot(pos[whichtoplot], data[whichtoplot,3], cex=.1, main=sampleNames(x)[i], ylab=ylab, xlab="chromosomes", ylim=ylimit, xaxt="n", xaxs="i")
        if (dotres != 1)
            mtext(paste('Plot resolution: ', 100/dotres, '%', sep=''), side=3, line=0)
        abline(h=0)
        if (length(chrom.ends) > 1)
            for (j in names(chrom.ends)[-length(chrom.ends)])
                abline(v=chrom.ends[j], lty='dashed')
        ax <- (chrom.ends + c(0, chrom.ends[-length(chrom.ends)])) / 2
        axis(side=1, at=ax, labels=uni.chrom, cex=.2, lwd=.5, las=1, cex.axis=1, cex.lab=1)
        amps <- data[,3]
        amps[amps>=5] <- 5.15
        amps[amps<5] <- NA
        points(pos, amps, pch=24, col='blue', bg='blue', cex=0.5)
        dels <- data[,3]
        dels[dels<=-2] <- -2.15
        dels[dels>-2] <- NA
        points(pos, dels, pch=25, col='red', bg='red', cex=0.5)
        ### MAD
        mad.value <- round(mad(diff(copynumber(x)[,i])/sqrt(2), na.rm=TRUE), digits=2)
        mtext(paste('MAD =', mad.value), side=3, line=0, adj=1)
        ### number of data points
        str <- paste(round(nclone / 1000), 'k x ', sep='')
        probe <- median(bpend(x)-bpstart(x)+1)
        if (probe < 1000) {
            str <- paste(str, probe, ' bp', sep='')
        } else {
            str <- paste(str, round(probe / 1000), ' kbp', sep='')
        }
        mtext(str, side=3, line=0, adj=0)
    }
})

setMethod("plot", signature(x="cghSeg", y="missing"),
function (x, y, dotres=1, ylimit=c(-2,5), ylab=expression(log[2]~ratio), build="GRCh37",... )
{
    for (i in 1:ncol(x)) {
        cat("Plotting sample", sampleNames(x)[i], "\n")
        segment         <- CGHbase:::.makeSegments(cbind(chromosomes(x), segmented(x)[,i]))
        chrom           <- chromosomes(x)
        data            <- data.frame(chrom, bpstart(x), copynumber(x)[,i])
        colnames(data)  <- c("chromosome", "position", "ratio")
        pos             <- bpstart(x)
        uni.chrom <- unique(chrom)
        chrom.lengths <- .getChromosomeLengths(build)[as.character(uni.chrom)]
        chrom.ends <- integer()
        cumul <- 0
        for (j in uni.chrom) {
            pos[chrom > j] <- pos[chrom > j] + chrom.lengths[as.character(j)]
            cumul <- cumul + chrom.lengths[as.character(j)]
            chrom.ends <- c(chrom.ends, cumul)
        }
        names(chrom.ends) <- names(chrom.lengths)
        nclone <- length(chrom)
        whichtoplot <- seq(1,nclone,by=dotres) #added 15/06/2009
        plot(pos[whichtoplot], data[whichtoplot,3], cex=.1, main=sampleNames(x)[i], ylab=ylab, xlab="chromosomes", ylim=ylimit, xaxt="n", xaxs="i")
        if (dotres != 1)
            mtext(paste('Plot resolution: ', 100/dotres, '%', sep=''), side=3, line=0)
        abline(h=0) 
        if (length(chrom.ends) > 1)
            for (j in names(chrom.ends)[-length(chrom.ends)])
                abline(v=chrom.ends[j], lty='dashed')
        ax <- (chrom.ends + c(0, chrom.ends[-length(chrom.ends)])) / 2
        axis(side=1,at=ax,labels=uni.chrom,cex=.2,lwd=.5,las=1,cex.axis=1,cex.lab=1)
        for (jjj in (1:nrow(segment))) {
            segments(pos[segment[jjj,2]], segment[jjj,1], pos[segment[jjj,3]], segment[jjj,1], col="chocolate", lwd=3)        
        }
        amps <- data[,3]
        amps[amps>=5] <- 5.15
        amps[amps<5] <- NA
        points(pos, amps, pch=24, col='blue', bg='blue', cex=0.5)
        dels <- data[,3]
        dels[dels<=-2] <- -2.15
        dels[dels>-2] <- NA
        points(pos, dels, pch=25, col='red', bg='red', cex=0.5)
        ### MAD
        mad.value <- round(mad(diff(copynumber(x)[,i])/sqrt(2), na.rm=TRUE), digits=2)
        mtext(paste('MAD =', mad.value), side=3, line=0, adj=1)
        ### number of data points
        str <- paste(round(nclone / 1000), 'k x ', sep='')
        probe <- median(bpend(x)-bpstart(x)+1)
        if (probe < 1000) {
            str <- paste(str, probe, ' bp', sep='')
        } else {
            str <- paste(str, round(probe / 1000), ' kbp', sep='')
        }
        mtext(str, side=3, line=0, adj=0)
    }
})

setMethod("plot", signature(x="cghCall", y="missing"),
function (x, y, dotres=1, ylimit=c(-5,5), ylab=expression(log[2]~ratio), gaincol='blue', losscol='red', misscol=NA, build='GRCh37',... )
{
    calls           <- calls(x)
    nsamples        <- ncol(x)
    if (!is.null(probamp(x))) nclass <- 4 else nclass     <- 3
    chrom           <- chromosomes(x)
    pos             <- bpstart(x)
    pos2            <- bpend(x)
    uni.chrom <- unique(chrom)
    chrom.lengths <- .getChromosomeLengths(build)[as.character(uni.chrom)]
    chrom.ends <- integer()
    cumul <- 0
    for (j in uni.chrom) {
        pos[chrom > j] <- pos[chrom > j] + chrom.lengths[as.character(j)]
        pos2[chrom > j] <- pos2[chrom > j] + chrom.lengths[as.character(j)]
        cumul <- cumul + chrom.lengths[as.character(j)]
        chrom.ends <- c(chrom.ends, cumul)
    }
    names(chrom.ends) <- names(chrom.lengths)
    nclone          <- length(chrom)

    for (i in 1:ncol(x)) {
    
        cat("Plotting sample", sampleNames(x)[i], "\n")
    
        genomdat        <- copynumber(x)[,i]
        probsdraw       <- cbind(probloss(x)[,i], probnorm(x)[,i], probgain(x)[,i])
        if (!is.null(probamp(x))) probsdraw <- cbind(probsdraw, probamp(x)[,i])
        lt              <- 0
        
        if (nclass==4) {
            ticksamp    <- which(probsdraw[,nclass] >= 0.5)
            lt          <- length(ticksamp)        
            probsdraw   <- cbind(probsdraw[,1:2], probsdraw[,3] + probsdraw[,4])
        }
        
        segment         <- CGHbase:::.makeSegments(cbind(chromosomes(x), segmented(x)[,i]))
        
        widths          <- segment[,3] - segment[,2] + 1
        par(mar=c(5, 4, 4, 4) + 0.2)
        
        ### Plot the probability bars
        plot(NA, xlim=c(0, max(pos2)), ylim=c(0,1), xlab=NA, ylab=NA, las=1, xaxs='i', xaxt='n', yaxs='i')
        if (!is.na(misscol)) {
            rect(0, -1, max(pos2), 1, col=misscol, border=NA)
            rect(pos, -1, pos2, 1, col='white', border=NA)
        }
        rect(pos[segment[,2]], 0, pos2[segment[,3]], probsdraw[segment[,2],1], col=losscol, border=losscol)
        rect(pos[segment[,2]], 1, pos2[segment[,3]], 1-probsdraw[segment[,2],3], col=gaincol, border=gaincol)
        
        lim <- par("usr")
        lim[3:4] <- ylimit
        par(usr=lim)
        dticks <- seq(ylimit[1], ylimit[2], by=1)
        axis(4, at=dticks, labels=dticks, srt=270, las=1, cex.axis=1, cex.lab=1)
        if (lt > 0) {
            axis(3,at=pos[ticksamp], labels=FALSE, col=gaincol, col.axis="black", srt=270, las=1, cex.axis=1, cex.lab=1)
        }     
        box()   
        abline(h=0)
        
        ### Add axis labels
        mtext(ylab, side=4, line=3, srt=270)
        mtext("probability", side=2, line=3, srt=270)
        mtext('chromosomes', side=1, line=3)
        
        #### add vert lines at chromosome ends
        if (length(chrom.ends) > 1)
            for (j in names(chrom.ends)[-length(chrom.ends)])
                abline(v=chrom.ends[j], lty='dashed')

        title(sampleNames(x)[i])
        if (dotres != 1)
            mtext(paste('Plot resolution: ', 100/dotres, '%', sep=''), side=3, line=0)
        
        ### Add log2ratios
        if (dotres>0) {
            whichtoplot <- seq(1,nclone,by=dotres) #added 15/06/2009
            points(pos[whichtoplot],genomdat[whichtoplot],cex=.1)
        }
        
        ### X-axis with chromosome labels
        ax <- (chrom.ends + c(0, chrom.ends[-length(chrom.ends)])) / 2
        axis(side=1,at=ax,labels=unique(chrom),cex=.2,lwd=.5,las=1,cex.axis=1,cex.lab=1)
            
        ### segment means
        for (jjj in (1:nrow(segment)))
            segments(pos[segment[jjj,2]], segment[jjj,1], pos[segment[jjj,3]], segment[jjj,1], col="chocolate", lwd=3)        

        ### MAD
        mad.value <- round(mad(diff(copynumber(x)[,i])/sqrt(2), na.rm=TRUE), digits=2)
        mtext(paste('MAD =', mad.value), side=3, line=0, adj=1)

        ### number of data points
        str <- paste(round(nclone / 1000), 'k x ', sep='')
        probe <- median(bpend(x)-bpstart(x)+1)
        if (probe < 1000) {
            str <- paste(str, probe, ' bp', sep='')
        } else {
            str <- paste(str, round(probe / 1000), ' kbp', sep='')
        }
        mtext(str, side=3, line=0, adj=0)
    }
})

setMethod("frequencyPlot", signature(x="cghCall", y="missing"),
function (x, y, main='Frequency Plot', gaincol='blue', losscol='red', misscol=NA, build='GRCh37',... )
{
  chrom <- chromosomes(x)
  pos <- bpstart(x)
  pos2 <- bpend(x)
  uni.chrom <- unique(chrom)
  chrom.lengths <- .getChromosomeLengths(build)[as.character(uni.chrom)]
  chrom.ends <- integer()
  cumul <- 0
  for (j in uni.chrom) {
    pos[chrom > j] <- pos[chrom > j] + chrom.lengths[as.character(j)]
    pos2[chrom > j] <- pos2[chrom > j] + chrom.lengths[as.character(j)]
    cumul <- cumul + chrom.lengths[as.character(j)]
    chrom.ends <- c(chrom.ends, cumul)
  }
  names(chrom.ends) <- names(chrom.lengths)
  calls <- calls(x)
  loss.freq <- rowMeans(calls < 0)
  gain.freq <- rowMeans(calls > 0)
  plot(NA, xlim=c(0, max(pos2)), ylim=c(-1,1), type='n', xlab='chromosomes', ylab='frequency', xaxs='i', xaxt='n', yaxs='i', yaxt='n', main=main,...)
  if (!is.na(misscol)) {
    rect(0, -1, max(pos2), 1, col=misscol, border=NA)
    rect(pos, -1, pos2, 1, col='white', border=NA)
  }
  rect(pos, 0, pos2, gain.freq, col=gaincol, border=gaincol)
  rect(pos, 0, pos2, -loss.freq, col=losscol, border=losscol)
  box()
  abline(h=0)
  if (length(chrom.ends) > 1)
    for (j in names(chrom.ends)[-length(chrom.ends)])
      abline(v=chrom.ends[j], lty='dashed')
  ax <- (chrom.ends + c(0, chrom.ends[-length(chrom.ends)])) / 2
  axis(side=1,at=ax,labels=uni.chrom,cex=.2,lwd=.5,las=1,cex.axis=1,cex.lab=1)
  axis(side=2, at=c(-1, -0.5, 0, 0.5, 1), labels=c('100 %', ' 50 %', '0 %', '50 %', '100 %'), las=1)
  mtext('gains', side=2, line=3, at=0.5)
  mtext('losses', side=2, line=3, at=-0.5)
  ### number of data points
  str <- paste(round(nrow(x) / 1000), 'k x ', sep='')
  probe <- median(bpend(x)-bpstart(x)+1)
  if (probe < 1000) {
    str <- paste(str, probe, ' bp', sep='')
  } else {
    str <- paste(str, round(probe / 1000), ' kbp', sep='')
  }
  mtext(str, side=3, line=0, adj=0)
})

setMethod("frequencyPlot", signature(x="cghRegions", y="missing"),
function (x, y, main='Frequency Plot', gaincol='blue', losscol='red', misscol=NA, build='GRCh37',... )
{
  chrom <- x@featureData@data$Chromosome
  pos <- x@featureData@data$Start
  pos2 <- x@featureData@data$End
  uni.chrom <- unique(chrom)
  chrom.lengths <- .getChromosomeLengths(build)[as.character(uni.chrom)]
  chrom.ends <- integer()
  cumul <- 0
  for (j in uni.chrom) {
    pos[chrom > j] <- pos[chrom > j] + chrom.lengths[as.character(j)]
    pos2[chrom > j] <- pos2[chrom > j] + chrom.lengths[as.character(j)]
    cumul <- cumul + chrom.lengths[as.character(j)]
    chrom.ends <- c(chrom.ends, cumul)
  }
  names(chrom.ends) <- names(chrom.lengths)
  calls <- regions(x)
  loss.freq <- rowMeans(calls < 0)
  gain.freq <- rowMeans(calls > 0)
  plot(NA, xlim=c(0, max(pos2)), ylim=c(-1,1), type='n', xlab='chromosomes', ylab='frequency', xaxs='i', xaxt='n', yaxs='i', yaxt='n', main=main,...)
  if (!is.na(misscol)) {
    rect(0, -1, max(pos2), 1, col=misscol, border=NA)
    rect(pos, -1, pos2, 1, col='white', border=NA)
  }
  rect(pos, 0, pos2, gain.freq, col=gaincol, border=gaincol)
  rect(pos, 0, pos2, -loss.freq, col=losscol, border=losscol)
  box()
  abline(h=0)
  if (length(chrom.ends) > 1)
    for (j in names(chrom.ends)[-length(chrom.ends)])
      abline(v=chrom.ends[j], lty='dashed')
  ax <- (chrom.ends + c(0, chrom.ends[-length(chrom.ends)])) / 2
  axis(side=1,at=ax,labels=uni.chrom,cex=.2,lwd=.5,las=1,cex.axis=1,cex.lab=1)
  axis(side=2, at=c(-1, -0.5, 0, 0.5, 1), labels=c('100 %', ' 50 %', '0 %', '50 %', '100 %'), las=1)
  mtext('gains', side=2, line=3, at=0.5)
  mtext('losses', side=2, line=3, at=-0.5)
  ### number of data points
  mtext(paste(nrow(x), 'regions'), side=3, line=0, adj=0)
})

make_cghRawPlus <- function(input) {
    if (class(input) == "character") input  <- read.table(input, header=T, sep="\t", fill=T, quote="")
    if (class(input[,2]) == 'factor')
        input[,2] <- as.character(input[,2])
    if (class(input[,2]) == 'character') {
        input[,2] <- sub('^chr', '', input[,2])
        input[input[,2] == 'X', 2] <- '23'
        input[input[,2] == 'Y', 2] <- '24'
        input[input[,2] == 'MT', 2] <- '25'
        input[,2] <- as.integer(input[,2])
    }
    input <- input[order(input[,2], input[,3]),]
    copynumber  <- as.matrix(input[,5:ncol(input)])
    rownames(copynumber) <- input[,1]
    if (ncol(copynumber) == 1)
      colnames(copynumber) <- colnames(input)[5]
    annotation  <- data.frame(Chromosome=input[,2], Start=input[,3], End=input[,4], row.names=input[,1])
    metadata    <- data.frame(labelDescription=c("Chromosomal position", "Basepair position start", "Basepair position end"), row.names=c("Chromosome", "Start", "End"))    
    dimLabels   <- c("featureNames", "featureColumns")
    annotation  <- new("AnnotatedDataFrame", data=annotation, dimLabels=dimLabels, varMetadata=metadata)   
    result      <- new("cghRaw", copynumber=copynumber, featureData=annotation)
}
environment(make_cghRawPlus) <- environment(CGHcall:::make_cghRaw)
make_cghRaw <- make_cghRawPlus

preprocessPlus <- 
function (input, maxmiss = 30, nchrom = 23, ...) 
{
    input <- input[!is.na(chromosomes(input)) & !is.na(bpstart(input))]
    input <- input[chromosomes(input) != 0 & bpstart(input) != 
        0, ]
    input <- input[chromosomes(input) <= nchrom, ]
    countMissing <- function(x, maxMissing) {
        if (length(x[is.na(x)]) <= maxMissing) 
            return(TRUE)
        return(FALSE)
    }
    nummis <- length(copynumber(input)[is.na(copynumber(input))])
    if (nummis > 0) {
        allowed <- ncol(input) * maxmiss/100
        filter <- apply(copynumber(input), 1, countMissing, allowed)
        input <- input[filter, ]
    }
    nummis <- length(copynumber(input)[is.na(copynumber(input))])
    if (nummis > 0) {
        if (!exists("k")) 
            k <- 10
        new.k <- ceiling((1 - maxmiss/100) * ncol(input))
        new.k <- min(new.k, k)
        if (new.k != 10) 
            cat("Changing impute.knn parameter k from", k, "to", 
                new.k, "due to small sample size.\n")
        if (new.k > 1) {
            nrows <- nrow(copynumber(input))
            nrpi <- floor(nrows/100)
            resultsall <- c()
            for (i in 1:(100 - 1)) {
                datforimp <- copynumber(input)[((i - 1) * nrpi + 
                  1):(nrpi * i), ]
                result <- impute::impute.knn(datforimp, k = new.k)
                resultsall <- rbind(resultsall, result$data)
            }
            datforimp <- copynumber(input)[((100 - 1) * nrpi + 
                1):nrows, ]
            result <- impute::impute.knn(datforimp, k = new.k)
            resultsall <- rbind(resultsall, result$data)
            copynumber(input) <- CGHcall:::.assignNames(resultsall, 
                input)
        }
    }
    input
}
environment(preprocessPlus) <- environment(CGHcall:::preprocess)
preprocess <- preprocessPlus

.getChromosomeLengths <- function(build) {
    build <- as.integer(gsub('[^0-9]', '', build))
    if (build == 34 || build == 16) {
       chromosome.lengths <- c(246127941, 243615958, 199344050, 191731959, 181034922, 170914576, 158545518, 146308819, 136372045, 135037215, 134482954, 132078379, 113042980, 105311216, 100256656, 90041932, 81860266, 76115139, 63811651, 63741868, 46976097, 49396972, 153692391, 50286555)
    } else if (build == 35 || build == 17) {
       chromosome.lengths <- c(245522847, 243018229, 199505740, 191411218, 180857866, 170975699, 158628139, 146274826, 138429268, 135413628, 134452384, 132449811, 114142980, 106368585, 100338915, 88827254, 78774742, 76117153, 63811651, 62435964, 46944323, 49554710, 154824264, 57701691)
    } else if (build == 36 || build == 18) {
       chromosome.lengths <- c(247249719, 242951149, 199501827, 191273063, 180857866, 170899992, 158821424, 146274826, 140273252, 135374737, 134452384, 132349534, 114142980, 106368585, 100338915, 88827254, 78774742, 76117153, 63811651, 62435964, 46944323, 49691432, 154913754, 57772954)
    } else {
       chromosome.lengths <- c(249250621, 243199373, 198022430, 191154276, 180915260, 171115067, 159138663, 146364022, 141213431, 135534747, 135006516, 133851895, 115169878, 107349540, 102531392, 90354753, 81195210, 78077248, 59128983, 63025520, 48129895, 51304566, 155270560, 59373566)
    }
    names(chromosome.lengths) <- 1:24
    chromosome.lengths
}

.getCentromerePlus <- function(build) {
    build <- as.integer(gsub('[^0-9]', '', build))
    centromere <- matrix(NA, 23, 2);
    if (build == 34 || build == 16) {
        centromere[1,] <- c(120093537, 122333537)
        centromere[2,] <- c(91810927, 94810927)
        centromere[3,] <- c(90425755, 93325755)
        centromere[4,] <- c(49575659, 52575659)
        centromere[5,] <- c(46451142, 49451142)
        centromere[6,] <- c(58877002, 61877002)
        centromere[7,] <- c(57832528, 60832528)
        centromere[8,] <- c(43856263, 46856263)
        centromere[9,] <- c(44443361, 47443361)
        centromere[10,] <- c(39208941, 41588941)
        centromere[11,] <- c(51602318, 54602318)
        centromere[12,] <- c(34747961, 36142961)
        centromere[13,] <- c(14900000, 16768000)
        centromere[14,] <- c(15070000, 18070000)
        centromere[15,] <- c(15260000, 18260000)
        centromere[16,] <- c(36366889, 38166889)
        centromere[17,] <- c(22408570, 25408570)
        centromere[18,] <- c(15398887, 16762885)
        centromere[19,] <- c(26923622, 29923622)
        centromere[20,] <- c(26314569, 29314569)
        centromere[21,] <- c(10260000, 13260000)
        centromere[22,] <- c(11330000, 14330000)
        centromere[23,] <- c(57548803, 60548803)
        # centromere[24,] <- c(9757849, 12757849)
    } else if (build == 35 || build == 17) {
        centromere[1,] <- c(121147476, 123387476)
        centromere[2,] <- c(91748045, 94748045)
        centromere[3,] <- c(90587544, 93487544)
        centromere[4,] <- c(49501045, 52501045)
        centromere[5,] <- c(46441398, 49441398)
        centromere[6,] <- c(58938125, 61938125)
        centromere[7,] <- c(57864988, 60864988)
        centromere[8,] <- c(43958052, 46958052)
        centromere[9,] <- c(46035928, 49035928)
        centromere[10,] <- c(39244941, 41624941)
        centromere[11,] <- c(51450781, 54450781)
        centromere[12,] <- c(34747961, 36142961)
        centromere[13,] <- c(16000000, 17868000)
        centromere[14,] <- c(15070000, 18070000)
        centromere[15,] <- c(15260000, 18260000)
        centromere[16,] <- c(35143302, 36943302)
        centromere[17,] <- c(22187133, 22287133)
        centromere[18,] <- c(15400898, 16764896)
        centromere[19,] <- c(26923622, 29923622)
        centromere[20,] <- c(26267569, 28033230)
        centromere[21,] <- c(10260000, 13260000)
        centromere[22,] <- c(11330000, 14330000)
        centromere[23,] <- c(58465033, 61465033)
        # centromere[24,] <- c(11237315, 12237315)
    } else if (build == 36 || build == 18) {
        centromere[1,] <- c(121236957, 123476957)
        centromere[2,] <- c(91689898, 94689898)
        centromere[3,] <- c(90587544, 93487544)
        centromere[4,] <- c(49354874, 52354874)
        centromere[5,] <- c(46441398, 49441398)
        centromere[6,] <- c(58938125, 61938125)
        centromere[7,] <- c(58058273, 61058273)
        centromere[8,] <- c(43958052, 46958052)
        centromere[9,] <- c(47107499, 50107499)
        centromere[10,] <- c(39244941, 41624941)
        centromere[11,] <- c(51450781, 54450781)
        centromere[12,] <- c(34747961, 36142961)
        centromere[13,] <- c(16000000, 17868000)
        centromere[14,] <- c(15070000, 18070000)
        centromere[15,] <- c(15260000, 18260000)
        centromere[16,] <- c(35143302, 36943302)
        centromere[17,] <- c(22187133, 22287133)
        centromere[18,] <- c(15400898, 16764896)
        centromere[19,] <- c(26923622, 29923622)
        centromere[20,] <- c(26267569, 28033230)
        centromere[21,] <- c(10260000, 13260000)
        centromere[22,] <- c(11330000, 14330000)
        centromere[23,] <- c(58598737, 61598737)
    } else { # 37 / 19
        centromere[1,] <- c(121535434, 124535434)
        centromere[2,] <- c(92326171, 95326171)
        centromere[3,] <- c(90504854, 93504854)
        centromere[4,] <- c(49660117, 52660117)
        centromere[5,] <- c(46405641, 49405641)
        centromere[6,] <- c(58830166, 61830166)
        centromere[7,] <- c(58054331, 61054331)
        centromere[8,] <- c(43838887, 46838887)
        centromere[9,] <- c(47367679, 50367679)
        centromere[10,] <- c(39254935, 42254935)
        centromere[11,] <- c(51644205, 54644205)
        centromere[12,] <- c(34856694, 37856694)
        centromere[13,] <- c(16000000, 19000000)
        centromere[14,] <- c(16000000, 19000000)
        centromere[15,] <- c(17000000, 20000000)
        centromere[16,] <- c(35335801, 38335801)
        centromere[17,] <- c(22263006, 25263006)
        centromere[18,] <- c(15460898, 18460898)
        centromere[19,] <- c(24681782, 27681782)
        centromere[20,] <- c(26369569, 29369569)
        centromere[21,] <- c(11288129, 14288129)
        centromere[22,] <- c(13000000, 16000000)
        centromere[23,] <- c(58632012, 61632012)
        # centromere[24,] <- c(10104553, 13104553)
    }
    centromere <- apply(centromere, 1, mean);
    return(centromere);
}

.convertChromosomeToArmPlus <- function(dataframe, build) { #changed 22/06/2009; 
    cat("Dividing chromosomes into arms using centromere positions from", build, "\n\n");
    centromere  <- .getCentromerePlus(build);
    chr <- dataframe[,2]
    bp <- dataframe[,3]
    chrlev <- unique(chr)
    a<-1
    chrarms <- c()
    for(i in chrlev){
    print(i)
    chri <- which(chr==i)
    bpi <- bp[chri]
    wbpi <- length(which(bpi<=centromere[i]))
    wbpil <- length(which(bpi>centromere[i]))
    if(wbpi>0) {chrarms <- c(chrarms,rep(a,wbpi));a<-a+1}
    if(wbpil>0) {chrarms <- c(chrarms,rep(a,wbpil));a<-a+1}  
    }  
    dataframe[,2] <- chrarms
    return(dataframe)
}

CGHcallPlus <- function(inputSegmented, prior="auto", nclass=4, organism="human", robustsig="yes",nsegfit=3000,maxnumseg=100,minlsforfit=0.5, build="GRCh37") {
  #  library(CGHcall)
#    setwd("C:\\VUData\\Maria")
#    #rm(list=ls())
#    memory.limit(size = 4000)
#    load("seg.Rdata")
#    inputSegmented <- seg; prior="auto"; nclass=4; organism="human"; robustsig="yes";nsegfit=500;maxnumseg=100;minlsforfit=0.5
    timeStarted <- proc.time()
    print("changed")
    gc() #memory usage in Mb
    
 
    ## Author: Mark van de Wiel
    ## Maintainer: Mark van de Wiel
    ## Email: mark.vdwiel@vumc.nl
 
    
    ## Changes since previous version
    ## - input is of class cgh
   
    timeStarted <- proc.time()

    ## Read input data
    #normalizedData  <- copynumber(inputSegmented)
    #combined        <- data.frame(featureNames(inputSegmented), chromosomes(inputSegmented), bpstart(inputSegmented), copynumber(inputSegmented),
    #segmented(inputSegmented))
    bw <- round(20*minlsforfit*nrow(copynumber(inputSegmented))/44000) 
    ncolscl     <- ncol(copynumber(inputSegmented))
  #  datareg     <- CGHcall:::.MakeData(data.frame(featureNames(inputSegmented), chromosomes(inputSegmented), bpstart(inputSegmented), copynumber(inputSegmented), segmented(inputSegmented)))  
    whna <- !is.na(chromosomes(inputSegmented)) & !is.na(featureNames(inputSegmented))
    datmat <- cbind(copynumber(inputSegmented), segmented(inputSegmented))[whna,]
    #datmat <- cbind(c(-1.2,2.1,-0.3,-0.4),c(0,0,0,0));chr<-c(1,1,1,1);nc<-1
    posit       <- bpstart(inputSegmented)[whna]
    chr         <- chromosomes(inputSegmented)[whna]
    naam        <- featureNames(inputSegmented)[whna]
    rm(whna,inputSegmented);gc()
    nc    <- ncol(datmat)/2 
    nclone <-nrow(datmat)
    datareg  <- .MakeData(datmat[,-(1:nc),drop=FALSE],chr)  
    #datareg  <- CGHcall:::.MakeData(datmat[,-(1:nc),drop=FALSE],chr)  
   
    #rm(combined); 
    
    gc() #added 24/11/2009
              
    #datareg <- .MakeData(combined)
    #save(datareg,file="datareg.Rdata")
    #load("datareg.Rdata")
     dataprob    <- data.frame(naam, chr, posit)
    
 
    
    ## Determine method for prior probabilities
    if (prior == 'auto') {
        if (nc >  20) prior <- "not all";
        if (nc <= 20) prior <- "all";
    }
    
    ### Convert to chromosome arm if neccessary
    if (prior != "all" && organism == "human") {
       # temp            <- datareg[[1]];
        dataprob    <- .convertChromosomeToArmPlus(dataprob, build); 
       # datareg[[1]]    <- .convertChromosomeToArmPlus(temp, build);
        chr <- dataprob[,2] #BUG;repaired 22/06/09
    }

    cat("EM algorithm started ... \n");
    
    dat         <- c()
    datsm       <- c()
    datall         <- c()
    datsmall       <- c()
    regions     <- c()
    regionsall  <- c()
    regionsdat  <- c()
    regionsdatall  <- c()
    nclones     <- length(chr)
     profile     <- c()
     profileall <- c()
    countreg    <- 0
    newregions <- list()
#    nclonesj <- 0
    thr <- 2
   
    #here is the selection of regions used for fitting. First select regions long enough and with smoothed signal <= thr. Then, maximize 
    #regions per prof to maxseg
    #nc<-2
    gc() 
    datall <- as.vector(datmat[,1:nc]) #changed 16/7/10
    datsmall      <- as.vector(datmat[,-(1:nc)])
    rm(datmat);gc();
  
    for (j in (1:nc)) {
        regions1    <- datareg[[j]]
        nreg1       <- nrow(regions1)
        profileall     <- c(profileall, rep(j,nreg1))
        regionsall     <- rbind(regionsall, regions1)
        toaddall       <- (j-1)*c(nclones, nclones)
        regionsdatall  <- rbind(regionsdatall, regions1[,-3]+toaddall)

        segl        <- regions1[,2]-regions1[,1]+1
        whseg       <- which(segl>=bw)
        regions2    <- regions1[whseg,,drop=FALSE] #selects regions long enough to participate in fitting
        regions2    <- regions2[which(abs(regions2[,3]) <= thr),,drop=FALSE] #selects regions with smoothed signal small enough
        nreg2       <- nrow(regions2)
        countreg <- countreg + min(maxnumseg,nreg2)
        newregions[[j]] <- regions2
        }
        fracforfit <- min(1,nsegfit/countreg)
        
        
        for (j in (1:nc)) {
        regions2 <- newregions[[j]]
        nreg2       <- nrow(regions2)
        ordsig      <- order(regions2[,3])
        regions2b   <- data.frame(regions2,genord = 1:nreg2)
        regions2c   <- regions2b[ordsig,,drop=FALSE]
        if(nreg2 >= maxnumseg | fracforfit<1){
            takeseg     <- floor(seq(1,nreg2,length.out=round(min(nreg2,maxnumseg)*fracforfit)))
            regions2c <- regions2c[takeseg,,drop=FALSE]
            }
        regions2d <- regions2c[order(regions2c[,4]),,drop=FALSE]
        
        nreg2       <- nrow(regions2d)
        profile    <- c(profile, rep(j,nreg2))
        regions     <- rbind(regions, regions2d)
        #takerow <- c();for(k in 1:nrow(regions2d)) {takerow <- c(takerow,regions2d[k,1]:regions2d[k,2])}
#        dat <- c(dat,datareg[[1]][takerow,(3+j)])
#        datsm <- c(datsm,datareg[[1]][takerow,(3+nc+j)])
        toadd       <- (j-1)*c(nclones, nclones)
        regionsdat  <- rbind(regionsdat, regions2d[,-(3:4)]+toadd) #delete smrat value and index
        #        nclonesj <- sum((regions2d[,2]+1)-regions2d[,1]) 
    }
    gc()

    takechr     <- function(reg, chrom) {
        chrom[reg[1]]
    }
    
    chrarmreg   <- as.vector(apply(as.matrix(regions), 1, takechr, chrom=chr))
    
    nreg        <- nrow(regionsdat)
    nregall     <- nrow(regionsdatall)
    print(paste("Total number of segments present in the data:",nregall))
    print(paste("Number of segments used for fitting the model:",nreg))
    allnc       <- sapply(1:nreg, CGHcall:::.countcl, regionsdat=regionsdat)
    allsum      <- sapply(1:nreg, CGHcall:::.sumreg, dat=datall, regionsdat=regionsdat)
    allsumsq    <- sapply(1:nreg, CGHcall:::.sumsqreg, dat=datall, regionsdat=regionsdat)
    varregall   <- sapply(1:nreg, CGHcall:::.varregtimescount, counts=allnc, dat=datall, regionsdat=regionsdat)
    lev         <- 1:nc
    varprofnc   <- cbind(varregall, profile, allnc)
    varprof     <- sapply(lev, CGHcall:::.varproffun, vcnmat=varprofnc, profile=profile)
    
    gc()

    selk <- function(k, varprof,prof) {  #changed 22/06/09
        profk <- prof[k]
        return(max(0.001,varprof[profk]))
    }
    varprofall <- sapply(1:nreg, selk, varprof=varprof,prof=profile)

    allmean     <- allsum/allnc
    allmeanl    <- allmean[allmean < -0.15 & allmean > -0.7]
    allmeang    <- allmean[allmean>0.15 & allmean<0.7]
    allmean0    <- allmean[abs(allmean) <= 0.15]
    sdlst       <- if(length(allmeanl) <= 1) 0.01 else mad(allmeanl)
    meanlst     <- if(length(allmeanl) <= 0) -0.3 else mean(allmeanl)
    sdgst       <- if(length(allmeang) <= 1) 0.01 else mad(allmeang)
    meangst     <- if(length(allmeang) <= 0) 0.3 else mean(allmeang)
    sd0st       <- if(length(allmean0) <= 1) 0.01 else mad(allmean0)
    #sd0st       <- if(length(allmean0) <= 1) 0.01 else sd(allmean0)

    profchrom   <- chrarmreg
    if(robustsig=="no") {
        bstart      <- c(-log(0.2), -log(-(meanlst+0.1)), sqrt(-log(0.5)), -log(meangst-0.1), -log(0.2), 0.0001, sdlst, sd0st, sdgst, 0.0001, 0.0001)
    } else {
        bstart      <- c(-log(0.2), -log(-(meanlst+0.1)), sqrt(-log(0.5)), -log(meangst-0.1), -log(0.2), 0.0001, sdlst, sd0st+max(0,sqrt(sdgst^2/8+sdlst^2/8)-sd0st), sdgst, 0.0001, 0.0001) #robust option 
    }
    mus         <- c(-0.10-exp(-bstart[2])-0.3 - exp(-bstart[1]), -0.10-exp(-bstart[2]), -0.05+0.1*exp(-(bstart[3])^2), 0.1 + exp(-bstart[4]), 2*(0.10 + exp(-bstart[4]))+0.3+exp(-bstart[5]))
    priorp      <- matrix(rep(c(0.01, 0.09, 0.8, 0.08, 0.01, 0.01), nreg), ncol=6, byrow=TRUE)
    alpha0      <- CGHcall:::.alpha0all(nreg, profchrom, priorp, bstart, varprofall, allsum, allsumsq, allnc,robustsig,prior)

    maxiter     <- 10
    stop        <- 0
    iter        <- 1
    thrpara     <- 0.015 #changed 15/6/09
    
    gc()
    
    while (stop == 0 & iter <= maxiter) {
        print(gc())
        cat("Calling iteration", iter, ":\n")
        posterior0  <- sapply(1:nreg, CGHcall:::.posteriorp, priorp=alpha0, pm=bstart, varprofall=varprofall, allsum=allsum, allsumsq=allsumsq, allnc=allnc,robustsig=robustsig)
        likprev     <- CGHcall:::.totallik(bstart, nreg=nreg, posteriorprev=posterior0, alphaprev=alpha0, varprofall=varprofall, allsum=allsum, allsumsq=allsumsq, allnc=allnc,robustsig=robustsig)
        nlmres      <- nlm(CGHcall:::.totallik, bstart, nreg=nreg, posteriorprev=posterior0, alphaprev=alpha0, varprofall=varprofall, allsum=allsum, allsumsq=allsumsq, allnc=allnc,robustsig=robustsig)
        bprev       <- bstart
        bstart      <- nlmres$est
        alpha0      <- CGHcall:::.alpha0all(nreg, profchrom, alpha0, bstart, varprofall, allsum, allsumsq, allnc, robustsig, prior)
        rl          <- CGHcall:::.reallik4(nreg, alpha0, bstart, varprofall, allsum, allsumsq, allnc, robustsig)
        llmin       <- nlmres$min
        musprev     <- c(-0.10-exp(-bprev[2])-0.3 - exp(-bprev[1]), -0.10-exp(-bprev[2]), -0.05+0.1*exp(-(bprev[3])^2), 0.1 + exp(-bprev[4]),(log2(2)/log2(1.5))*(0.1 + exp(-bprev[4])), (log2(2)/log2(1.5))*(0.10 + exp(-bprev[4]))+0.3+exp(-bprev[5]))
        mus         <- c(-0.10-exp(-bstart[2])-0.3 - exp(-bstart[1]), -0.10-exp(-bstart[2]), -0.05+0.1*exp(-(bstart[3])^2), 0.1 + exp(-bstart[4]),(log2(2)/log2(1.5))*(0.1 + exp(-bstart[4])),(log2(2)/log2(1.5))*(0.10 + exp(-bstart[4]))+0.3+exp(-bstart[5]))
        param       <- c(mus, bstart[6], bstart[7], bstart[8], bstart[9], bstart[10],bstart[11])
        paramprev   <- c(musprev, bprev[6], bprev[7], bprev[8], bprev[9], bprev[10],bprev[11])
     
        if(robustsig=="no") {
            printmat <- matrix(c(j,rl,mus,sqrt(bstart[7]^2+(bstart[6])^2 + 0.0001),bstart[7],bstart[8],bstart[9],sqrt((bstart[10])^2+(bstart[9])^2 + 0.0001),sqrt((bstart[11])^2 + (bstart[10])^2+ (bstart[9])^2+ 0.0001)),nrow=1)
            colnames(printmat) <- c("j","rl","mudl","musl","mun","mug","mudg","mua","sddl","sdsl","sdn","sdg","sddg","sda")
            print(printmat)
        } else {
            printmat<-matrix(c(j,rl,mus,sqrt(bstart[7]^2+(bstart[6])^2 + 0.0001),bstart[7],sqrt(1/8*((bstart[7])^2 + 0.0001)+1/8*((bstart[9])^2 + 0.0001)+((bstart[8]^2)+0.0001)),bstart[9],sqrt((bstart[10])^2+(bstart[9])^2 + 0.0001),sqrt((bstart[11])^2 + (bstart[10])^2 + (bstart[9])^2 + 0.0001)),nrow=1)  #robust option
            colnames(printmat) <- c("j","rl","mudl","musl","mun","mug","mudg","mua","sddl","sdsl","sdn","sdg","sddg","sda")
            print(printmat)
        }
        if (max(abs(param[c(2:4,8)]-paramprev[c(2:4,8)])) <= thrpara) stop <- 1 #changed 15/6/09; also sdn should converge
        iter <- iter+1
    }
    mudl<-printmat[3];mul <- printmat[4];mug<-printmat[6];mudg<- printmat[7];mua<-printmat[8];sdl<-printmat[10];sdg<-printmat[12] #added 17/12
   # pm <- as.vector(printmat)
#    plot(function(x) dnorm(x,mean=pm[4],sd=pm[11]),-1,1,col="red")
#   plot(function(x) dnorm(x,mean=pm[5],sd=pm[12]),-1,1,col="black",add=TRUE)
#   plot(function(x) dnorm(x,mean=pm[6],sd=pm[13]),-1,1,col="green",add=TRUE)
    cat("EM algorithm done ...\n")
    best            <- bstart
    
    #now start computing posteriors for ALL data
    cat("Computing posterior probabilities for all segments ...\n")
    #nregall        <- nrow(regionsdatall)
    allncall       <- sapply(1:nregall, CGHcall:::.countcl, regionsdat=regionsdatall)
    allsumall      <- sapply(1:nregall, CGHcall:::.sumreg, dat=datall, regionsdat=regionsdatall)
    allmeanall     <- allsumall/allncall  
    allsumsqall    <- sapply(1:nregall, CGHcall:::.sumsqreg, dat=datall, regionsdat=regionsdatall)
    varregallall   <- sapply(1:nregall, CGHcall:::.varregtimescount, counts=allncall, dat=datall, regionsdat=regionsdatall)
    lev             <- 1:nc
    varprofncall   <- cbind(varregallall, profileall, allncall)
    varprof_all     <- sapply(lev, CGHcall:::.varproffun, vcnmat=varprofncall, profile=profileall)
    varprof_allall <- sapply(1:nregall, selk, varprof=varprof_all,prof=profileall)
    gc()
    
    if(prior!="all"){
    chrarm_alpha0 <- cbind(chrarmreg,alpha0)
    chrarm_alpha0uni <- unique(chrarm_alpha0) 
    chrarmregall   <- as.vector(apply(as.matrix(regionsall), 1, takechr, chrom=chr))
    alpha0_all      <- t(sapply(chrarmregall,function(x){chrarm_alpha0uni[chrarm_alpha0uni[,1]==x,-1]})) 
    } else alpha0_all <- matrix(rep(alpha0[1,],nregall),byrow=T,nrow=nregall)
    
    posteriorfin    <- t(sapply(1:nregall, CGHcall:::.posteriorp, priorp=alpha0_all, pm=best, varprofall=varprof_allall, allsum=allsumall, allsumsq=allsumsqall, allnc=allncall, robustsig=robustsig))
    #posteriorfin1   <- cbind(allncall, allmeanall, posteriorfin)  #REMOVED 17/12
    #amps            <- posteriorfin1[posteriorfin1[,5]+posteriorfin1[,6]>=0.5,] #REMOVED 17/12
    
    overrule <- function(id,mnall){
    #id <- 393;mnall<-allmeanall
    toret <- posteriorfin[id,]   
    mn <- mnall[id]
    row1 <- toret
    if((mn > mug+sdg) & (which.max(row1)<=3)) {
        sumr <- sum(row1[4],row1[5],row1[6]); #added 17/12/10; if max prob belongs to non-gain state, overrule; redistribute probability
        if(sumr > 10^(-10)) toret<- c(0,0,0,row1[4]/sumr,row1[5]/sumr,row1[6]/sumr) else {
            toret<- c(0,0,0,0,0,0)
            wm<-which.min(c(abs(mn-mug),abs(mn-mudg),abs(mn-mua)))+3
            toret[wm]<-1 #assigns probability 1 to status with mode closest to the mean segment value; only used if probability calculation fails.
        }
    }
    if((mn < mul-sdl) & (which.max(row1)>=3)) {
        sumr <- sum(row1[1],row1[2]); #added 17/12/10; if max prob belongs to non-loss state, overrule
         if(sumr > 10^(-10)) toret<- c(row1[1]/sumr,row1[2]/sumr,0,0,0,0) else {
            toret<- c(0,0,0,0,0,0)
            wm<-which.min(c(abs(mn-mudl),abs(mn-mul)))
            toret[wm]<-1 #assigns probability 1 to status with mode closest to the mean segment value; only used if probability calculation fails.
        } 
    }
    return(toret)
    }
    
    posteriorfin <- t(sapply(1:nregall,overrule,mnall=allmeanall)) #OVERRULE FUNCTION ADD 17/12/10 TO DEAL WITH EXTREMES
    
    amporgain <- function(row) {
        if (row[6] >= 0.5) return(c(row[1]+row[2], row[3], row[4]+row[5], row[6]))
        else return(c(row[1]+row[2], row[3], row[4]+row[5], row[6]))
    }
   
    if (nclass == 3) posteriorfin1 <- cbind(posteriorfin[,1]+posteriorfin[,2], posteriorfin[,3], posteriorfin[,4]+posteriorfin[,5]+posteriorfin[,6], posteriorfin[,6])
    if (nclass == 4) posteriorfin1 <- t(apply(posteriorfin, 1, amporgain))
    
   
    
    

    posteriorfin2   <- cbind(profileall, posteriorfin1)
    rm(posteriorfin,posteriorfin1);gc() #added24/11/2009
    regionsprof     <- cbind(profileall, regionsall)
    listcall <- list(posteriorfin2,nclone,nc,nclass,regionsprof,params = printmat[,-c(1,2)])
    #save(listcall,file="listcall.Rdata")
    gc()
    timeFinished <- round((proc.time() - timeStarted)[1] / 60)
    cat("Total time:", timeFinished, "minutes\n")
    return(listcall)
}
environment(CGHcallPlus) <- environment(CGHcall:::CGHcall)
CGHcall <- CGHcallPlus

CGHregionsPlus <- function(input, ...) {
  regions <- CGHregions:::CGHregions(input, ...)
  # End positions of regions should be the end position of the last data point of that region,
  # but instead CGHregions returns the start position of the last data point.
  # Check if that is indeed the case:
  if (class(input) == 'cghCall') {
    if (sum(regions@featureData@data$End %in% input@featureData@data$Start) > sum(regions@featureData@data$End %in% input@featureData@data$End))
      for (row in rownames(regions@featureData@data))
        regions@featureData@data[row, 'End'] <- input@featureData@data[input@featureData@data$Chromosome == regions@featureData@data[row, 'Chromosome'] & input@featureData@data$Start == regions@featureData@data[row, 'End'], 'End'][1]
  }
  regions
}
environment(CGHregionsPlus) <- environment(CGHregions:::CGHregions)
CGHregions <- CGHregionsPlus

regioningPlus <- function (cghdata.called, threshold = 0.00001) 
{
    find.reg.modus <- function(x) {
        splitter <- list()
        splitter[[1]] <- c(1)
        index.temp <- 1
        j <- 1
        for (i in 1:(dim(x)[1] - 1)) {
            if (all(x[i, ] == x[i + 1, ])) {
                index.temp <- c(index.temp, i + 1)
                splitter[[j]] <- index.temp
            }
            else {
                index.temp <- i + 1
                j <- j + 1
                splitter[[j]] <- index.temp
            }
        }
        region.details <- NULL
        for (i in 1:length(splitter)) {
            region.details <- rbind(region.details, c(min(splitter[[i]]), 
                max(splitter[[i]])))
        }
        modus <- which.max(region.details[, 2] - region.details[, 
            1] + 1)
        return(x[region.details[modus[1], 1], ])
    }
    cat("CGHregions of hard call data...")
    cghdata.regions <- CGHregionsPlus(cghdata.called, averror = threshold)
    cat("...done", "\n")
    print(paste("threshold used:", threshold, sep = " "))
    calls.annotation <- pData(featureData(cghdata.called))
    regions.annotation <- pData(featureData(cghdata.regions))
    cat("Map regions to clones...")
    reg.to.clones <- list()
    counter <- 0
    for (chr in unique(regions.annotation[, 1])) {
        reg.ann.temp <- regions.annotation[regions.annotation[, 
            1] == chr, 1:4]
        for (r in 1:dim(reg.ann.temp)[1]) {
            counter <- counter + 1
            A1 <- which(calls.annotation[, 1] == chr)
            A2 <- which(calls.annotation[, 2] >= reg.ann.temp[r, 
                2])
            A3 <- which(calls.annotation[, 3] <= reg.ann.temp[r, 
                3])
            reg.to.clones[[counter]] <- intersect(intersect(A1, 
                A2), A3)
        }
    }
    cat("...done", "\n")
    cghdata.probs <- numeric()
    for (i in 1:dim(calls(cghdata.called))[2]) {
        cghdata.probs <- cbind(cghdata.probs, cbind(probloss(cghdata.called)[, 
            i], probnorm(cghdata.called)[, i], probgain(cghdata.called)[, 
            i], probamp(cghdata.called)[, i]))
    }
    cat("Calculate mode soft call signature for each region...")
    cghdata.regprobs <- numeric()
    for (i in 1:length(reg.to.clones)) {
        cghdata.regprobs <- rbind(cghdata.regprobs, find.reg.modus(cghdata.probs[reg.to.clones[[i]], 
            , drop = FALSE]))
    }
    cat("...done", "\n")
    softcalls.samplenames <- character()
    for (i in 1:dim(calls(cghdata.called))[2]) {
        if (dim(cghdata.regprobs)[2]/dim(calls(cghdata.called))[2] == 
            3) {
            softcalls.samplenames <- c(softcalls.samplenames, 
                paste(c("probloss_", "probnorm_", "probgain_"), 
                  colnames(regions(cghdata.regions))[i], sep = ""))
        }
        if (dim(cghdata.regprobs)[2]/dim(calls(cghdata.called))[2] == 
            4) {
            softcalls.samplenames <- c(softcalls.samplenames, 
                paste(c("probloss_", "probnorm_", "probgain_", 
                  "probamp_"), colnames(regions(cghdata.regions))[i], 
                  sep = ""))
        }
    }
    colnames(cghdata.regprobs) <- softcalls.samplenames
    rownames(cghdata.regprobs) <- rownames(regions(cghdata.regions))
    regdata <- list()
    regdata$ann <- regions.annotation
    regdata$hardcalls <- regions(cghdata.regions)
    regdata$softcalls <- cghdata.regprobs
    return(regdata)
}
regioning <- regioningPlus

# EOF

# TOOL filter-flags.R: "Filter by flags" (Gene filtering using flags. If more than the specified number of chips have the specified flag for a particular gene, it passes the filter, and is saved in a new data set.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT call-filtered.tsv: call-filtered.tsv 
# PARAMETER filter.by.flag: filter.by.flag TYPE [P: P, M: M, A: A, A.or.M: A.or.M, M.or.P: M.or.P] DEFAULT P (Which flag to filter by)
# PARAMETER number.of.chips: number.of.chips TYPE INTEGER FROM 1 TO 10000 DEFAULT 2 (How many samples the should have the specified call value)


# Filtering using flags (calls)
# JTT 29.6.2006
#
# MG 14.9.2010
# Modified to allow filtering options for A or M and M or P

# Parameter settings (default) for testing purposes
#filter.by.flag<-c("P")
#number.of.chips<-c(9)

# Renaming variables
f1 <- filter.by.flag
f2 <- f1
if (filter.by.flag=="A.or.M") {
	f1 <- "A"
	f2 <- "M"
}
if (filter.by.flag=="M.or.P") {
	f1 <- "M"
	f2 <- "P"
}
p<-number.of.chips

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Sanity checks
if(ncol(as.data.frame(calls))==0) {
	stop("CHIPSTER-NOTE: You do not have any flags!")
}
if(number.of.chips==0) {
	stop("CHIPSTER-NOTE: You must specify at least one array where the flag condition is fulfilled!")
}
if(number.of.chips>ncol(as.data.frame(calls))) {
	p <- ncol(as.data.frame(calls))
}

# Converting the data to data frames
dat2<-data.frame(dat2)
calls<-data.frame(calls)
len<-length(calls)

# Apply filtering
for(i in 1:len) {
	calls[,i]<-ifelse((calls[,i]==f1 | calls[,i]==f2) , 1, 0);
}
s<-apply(calls, MARGIN=1, FUN="sum")
dat2<-dat[which(s>=p),]

# Saving the results into a text file
write.table(dat2, "call-filtered.tsv", sep="\t", row.names=T, col.names=T, quote=F)

#
# SMart Install Packages (SMIP)
#
# User friendly interface into install.packages(...) and biocLite(...)
#
# All functions check existence of packages before installation and skip installation
# if the package already exists. For group of packages, each one is checked
# individually and only missing ones are installed.
#
# Function also offer more automation compared to original ones, allowing
# installation of whole repositories, scavenging web pages for packages etc.

# Usage examples:
#
#smart.install.bioconductor.repo(repo.index = 4)
#smart.install.packages(package="Matrix")
#smart.install.packages(package="Matrix", mirror="http://ftp.sunet.se/pub/lang/CRAN")
#smart.install.packages(package="foobarstatistics") # should fail
#smart.install.packages(bioconductor.package="Matrix")
#smart.install.packages(bioconductor.package="biofoobar") # should fail
#smart.install.packages(package="Matrix", bioconductor.package="biofoobar") # should fail
#smart.install.packages(url.package="http://www.math.utu.fi/projects/software/bio/ROTS_1.1.1.tar.gz")
#smart.install.scavenge.web.packages("http://brainarray.mbni.med.umich.edu/Brainarray/Database/CustomCDF/16.0.0/entrezg.asp")

smart.install.scavenge.web.packages <- function(url) {

	# Parse URL
	url.root <- substring(url, 1, gregexpr("/[^/]*$", url)[[1]][1])
	
	# Read page that contains links
	web.page <- paste(readLines(url), collapse="")
	
	# Parse links
	links.raw <- regmatches(web.page, gregexpr("href=\"([^\"]*)\"", web.page))[[1]]
	links.stripped <- substr(links.raw, nchar("href=\"")+1, nchar(links.raw)-1)
	links <- links.stripped[grep(".tar.gz", links.stripped)]
	
	# Convert relative URL's to absolute 
	ind.relative.url <- grep("http://", links, invert=TRUE)
	links[ind.relative.url] <- paste(url.root, links[ind.relative.url], sep="")
	
	# Install each linked package
	for (link in links) {
		smart.install.packages(url.package=link)
	}
}

smart.install.bioconductor.repo <- function(repo.index, mirror=NA) {
	
	# Select the given repository
	orig.repos <- setRepositories(ind=c(repo.index))
	
	for (package in available.packages()[,"Package"]) {
		smart.install.packages(bioconductor.package = package, mirror = mirror)
	}
	
	# Restore original repositories
	setRepositories(orig.repos)		
}

smart.install.packages <- function(package=NA, bioconductor.package=NA, url.package=NA, mirror=NA) {
	
	# Check parameters
	package.defs <- c(package, bioconductor.package, url.package)
	if (sum(!is.na(package.defs)) != 1) {
		stop("Must use exactly one of the alternative ways to specify the package to install")
	}

	# Check that not already installed		
	if (is.na(url.package)) {
		package.name <- package.defs[!is.na(package.defs)]
	} else {
		package.name <- gsub(".*/(.*)_.*", "\\1", url.package)
	}
	
	if (!is.installed(package.name)) {
		cat(paste("Will now install", package.name, "\n"))
	} else {
		cat(paste("Already installed", package.name, "\n"))
		return(invisible(TRUE))
	}
	
	if (!is.na(package)) {
		
		repos = ifelse(is.na(mirror), getOption("repos"), mirror)
		install.packages(pkgs=c(package), repos=repos)
	
	} else if (!is.na(bioconductor.package)) {
		
		source("http://www.bioconductor.org/biocLite.R")
		if (!is.na(mirror)) {
			options("BioC_mirror" = c("Mirror"=mirror))
		}
		biocLite(bioconductor.package, suppressUpdates=TRUE)
		
	} else if (!is.na(url.package)) {
		
		# Download URL to temp file, install and remove
		tempfile.path <- tempfile("package", fileext=".tar.gz")
		download.file(url=url.package, destfile=tempfile.path)
		install.packages(pkgs=c(tempfile.path), repos=NULL)
		unlink(tempfile.path)
		
		
	} else {
		stop("Must specify something to install");
		return(invisible(FALSE))
	}

	# Install was successfull
	return(invisible(TRUE))
}

is.installed <- function(package) {
	sink("/dev/null") # the only way to get rid of all output (some packages don't behave)
	is.installed <- suppressPackageStartupMessages(suppressWarnings(suppressMessages(require(package, character.only=TRUE, warn.conflicts=FALSE, quietly=TRUE))))
	sink()
	return(is.installed) 		
}

# TOOL stat-hyperG-cytoband.R: "Hypergeometric test for cytobands" (Finds chromosomal locations, i.e., cytobands for which the genes in the selected dataset are either over- or under-represented.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT hypergeo.html: hypergeo.html 
# PARAMETER p.value.threshold: p.value.threshold TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (P-value threshold)
# PARAMETER over.or.under.representation: over.or.under.representation TYPE [over: over, under: under] DEFAULT over (Should over- or under-represented classes be seeked?)

# Hypergeometrix test of gene enrichment to term categories
# JTT 22.1.2009

# Loads the libraries
library(GOstats)

# Parameter settings (default) for testing purposes
#p.value.threshold<-0.05
#over.or.under.representation<-c("over")

# Renaming variables
pcut<-p.value.threshold
choisedirec<-over.or.under.representation

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Reading phenodata for chiptype
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
if(phenodata$chiptype[1]!="cDNA" | phenodata$chiptype[1]!="Illumina") {
   # Saves the chiptype into object lib
   lib<-phenodata$chiptype[1]
   lib<-as.character(lib)
}

# Account for the fact that annotation packages are from version 2.3 of Bioconductor
# named with an ".db" suffix. Add the suffix when missing to support data files
# from Chipster 1.3 and earlier. 
if (length(grep(".db", lib)) == 0 & length(grep("pmcdf", lib)) == 0) {
        lib <- paste(lib, ".db", sep="")
}

# Loads the correct Affymetrix annotation library
library(package=lib, character.only=T)

# in the next 4 rows it converts the microarray IDs into Entrez Gene IDs
lib2<-sub('.db','',lib)
env<-paste(lib2, "ENTREZID", sep="")
alleg<-get(env)
alleg<-as.list(alleg)
alleg<-unlist(alleg)
alleg<-as.data.frame(alleg)
myids<-unique(alleg[rownames(dat),])

#CHOOSE THE ANNOTATION PACKAGE
annotpkg<-lib

# Runs the tests
params<-new("ChrMapHyperGParams", geneIds=myids, annotation=annotpkg, pvalueCutoff=pcut, testDirection=choisedirec, conditional=TRUE)   
result<-hyperGTest(params)

# Writes the results to an HTML file
if(sum(pvalues(result)<pcut)>=1) {
   ID<-names(pvalues(result)[pvalues(result)<=pcut])
   Pvalue<-pvalues(result)[pvalues(result)<=pcut]
   OddsRatio<-oddsRatios(result)[pvalues(result)<=pcut]
   ExpCount<-expectedCounts(result)[pvalues(result)<=pcut]
   Count<-geneCounts(result)[pvalues(result)<=pcut]
   Size<-universeCounts(result)[pvalues(result)<=pcut]
   write(x="<HTML>", file="hypergeo.html", append=T) 
   write(x="<BODY>", file="hypergeo.html", append=T)
   write(x="<TABLE border=1>", file="hypergeo.html", append=T)
   write(x="<CAPTION> Cytoband - test for over-representation </CAPTION>", file="hypergeo.html", append=T)
   write(x="<TR> <TH>  </TH> <TH> Cytoband </TH> <TH> Pvalue </TH> <TH> OddsRatio </TH> <TH> ExpCount </TH> <TH> Count </TH> <TH> Size </TH>  </TR>", file="hypergeo.html", append=T)
   for(i in 1:length(ID)) {
      write(x=paste("<TR> <TD> ", i, " </TD> <TD> ", ID[i], " </TD> <TD> ", round(Pvalue[i], digits=6), " </TD> <TD> ", round(OddsRatio[i], digits=2), " </TD> <TD> ", round(ExpCount[i], digits=2), " </TD> <TD> ", Count[i], " </TD> <TD> ", Size[i], " </TD> </TR>", sep=""), file="hypergeo.html", append=T)
   }
   write(x="</BODY>", file="hypergeo.html", append=T)
   write(x="</HTML>", file="hypergeo.html", append=T)      
} 
if(sum(pvalues(result)<pcut)<1) {
   write(x="<HTML>", file="hypergeo.html", append=T) 
   write(x="<BODY>", file="hypergeo.html", append=T)
   write(x="No significant results found! <br>", file="hypergeo.html", append=T)
   write(x="</BODY>", file="hypergeo.html", append=T)
   write(x="</HTML>", file="hypergeo.html", append=T)      
}

# TOOL acgh-call-aberrations.R: "Call aberrations from segmented copy number data" (Call copy number aberrations from aCGH log ratios or NGS data.)
# INPUT segmented.tsv: segmented.tsv TYPE GENE_EXPRS
# OUTPUT aberrations.tsv: aberrations.tsv
# OUTPUT aberration-frequencies.pdf: aberration-frequencies.pdf
# PARAMETER number.of.copy.number.states: number.of.copy.number.states TYPE [3: 3, 4: 4] DEFAULT 3 (Whether to call loss vs. normal vs. gain or loss vs. normal vs. gain vs. amplification.)
# PARAMETER organism: organism TYPE [human: human, other: other] DEFAULT human (Organism.)
# PARAMETER genome.build: genome.build TYPE [GRCh37: GRCh37, NCBI36: NCBI36, NCBI35: NCBI35, NCBI34: NCBI34] DEFAULT GRCh37 (The genome build to use. GRCh37 = hg19, NCBI36 = hg18, NCBI35 = hg17, NCBI34 = hg16. Not used unless organism is set to human.)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-03-02

source(file.path(chipster.common.path, 'CGHcallPlus.R'))

dat <- read.table('segmented.tsv', header=TRUE, sep='\t', as.is=TRUE, row.names=1)

if (length(grep("^segmented\\.", names(dat))) == 0)
  stop('CHIPSTER-NOTE: This tool needs segmented input, so please first run the tool Segment copy number data.')

dat$chromosome[dat$chromosome=='X'] <- '23'
dat$chromosome[dat$chromosome=='Y'] <- '24'
dat$chromosome[dat$chromosome=='MT'] <- '25'
dat$chromosome <- as.integer(dat$chromosome)

logratios <- as.matrix(dat[,grep("^chip\\.", names(dat))])
segmented <- as.matrix(dat[,grep("^segmented\\.", names(dat))])

logratios[logratios==-Inf] <- -10
segmented[segmented==-Inf] <- -10

cgh.seg <- new('cghSeg', assayData=assayDataNew(copynumber=logratios, segmented=segmented), featureData=new('AnnotatedDataFrame', data=data.frame(Chromosome=dat$chromosome, Start=dat$start, End=dat$end, row.names=row.names(dat))))

remove <- rowSums(is.na(logratios)) + rowSums(is.na(segmented))
cgh.seg <- cgh.seg[remove == 0,]
cgh.seg <- cgh.seg[chromosomes(cgh.seg) < 24,]

chips <- colnames(dat)[grep("^chip\\.", names(dat))]

cgh.psn <- postsegnormalize(cgh.seg)
cgh.cal <- CGHcall(cgh.psn, nclass=as.integer(number.of.copy.number.states), organism=organism, build=genome.build)
cgh <- ExpandCGHcall(cgh.cal, cgh.psn)

dat3 <- data.frame(cgh@featureData@data)
colnames(dat3) <- c('chromosome', 'start', 'end')

for (col in c('cytoband', 'symbol', 'description', 'cnvs'))
  if (col %in% colnames(dat))
    dat3[,col] <- dat[rownames(dat3), col]

calls <- assayDataElement(cgh, 'calls')

dat3$loss.freq <- round(rowMeans(calls == -1), digits=3)
dat3$gain.freq <- round(rowMeans(calls == 1), digits=3)
if (number.of.copy.number.states=='4' && 2 %in% calls)
  dat3$amp.freq <- round(rowMeans(calls == 2), digits=3)

colnames(calls) <- sub('chip.', 'flag.', chips)
dat3 <- cbind(dat3, calls)

copynumber <- assayDataElement(cgh, 'copynumber')
colnames(copynumber) <- chips
dat3 <- cbind(dat3, copynumber)

segmented <- assayDataElement(cgh, 'segmented')
colnames(segmented) <- sub('chip.', 'segmented.', chips)
dat3 <- cbind(dat3, segmented)

probloss <- assayDataElement(cgh, 'probloss')
colnames(probloss) <- sub('chip.', 'probloss.', chips)
dat3 <- cbind(dat3, probloss)

probnorm <- assayDataElement(cgh, 'probnorm')
colnames(probnorm) <- sub('chip.', 'probnorm.', chips)
dat3 <- cbind(dat3, probnorm)

probgain <- assayDataElement(cgh, 'probgain')
colnames(probgain) <- sub('chip.', 'probgain.', chips)
dat3 <- cbind(dat3, probgain)

if (number.of.copy.number.states=='4') {
  probamp <- assayDataElement(cgh, 'probamp')
  colnames(probamp) <- sub('chip.', 'probamp.', chips)
  dat3 <- cbind(dat3, probamp)
}

dat3$chromosome <- as.character(dat3$chromosome)
dat3$chromosome[dat3$chromosome=='23'] <- 'X'
dat3$chromosome[dat3$chromosome=='24'] <- 'Y'
dat3$chromosome[dat3$chromosome=='25'] <- 'MT'

options(scipen=10)
write.table(dat3, file='aberrations.tsv', quote=FALSE, sep='\t', col.names=TRUE, row.names=TRUE)

# bitmap(file='aberration-frequencies.png', width=image.width/72, height=image.height/72)
pdf(file='aberration-frequencies.pdf', paper='a4r', width=0, height=0)
frequencyPlot(cgh)
dev.off()

# EOF

# TOOL plot-chrom-pos.R: "Chromosomal position" (Plots the chromosomal positions of genes in the selected list. Currently, this works only for human, mouse and rat data. Before plotting, chips are scaled in order to infer the up- or down-regulation status.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT chromloc.pdf: chromloc.pdf 
# PARAMETER chip.to.plot: chip.to.plot TYPE INTEGER FROM 1 TO 1000 DEFAULT 1 (Which chip to plot)
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Plotting the chromosomal position of expressed genes
# JTT 13.6.2006
# Modified by JTT on 22.11.2006 according to DG

# Parameter settings (default) for testing purposes
#chip.to.plot<-c("chip.microarray001.cel")
#image.width<-c(600)
#image.height<-c(600)

# Loads the libraries
library(geneplotter)
library(genefilter)

# Renaming variables
chip<-chip.to.plot
w<-image.width
h<-image.height

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Creating locations of genes
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
if(phenodata$chiptype[1]!="cDNA" | phenodata$chiptype[1]!="Illumina") {
   # Saves the chiptype into object lib
   lib<-phenodata$chiptype[1]
   lib<-as.character(lib)
}

# Account for the fact that annotation packages are from version 2.3 of Bioconductor
# named with an ".db" suffix. Add the suffix when missing to support data files
# from Chipster 1.3 and earlier. 
if (length(grep(".db", lib)) == 0 & length(grep("pmcdf", lib)) == 0) {
        lib <- paste(lib, ".db", sep="")
}

# Need a parameter lib that defines the Affymetrix chip type
chromloc<-buildChromLocation(gsub(".db", "", lib))

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Scaling the data to the same mean
scaled.dat<-genescale(dat2)

# Which genes are up- or down-regulated
up<-dat2[which(scaled.dat[,chip]>0),]
down<-dat2[which(scaled.dat[,chip]<0),]

# What chromosomes are there for the species?
x<-get(paste(gsub(".db", "", lib), "CHR", sep=""))
mapped_probes <- mappedkeys(x)
xx <- as.list(x[mapped_probes])
chr<-unique(unlist(xx))

# Plotting the chromosomes and genes
pdf(file="chromloc.pdf", width=w/72, height=h/72)
cPlot(chromloc, bg="White", fg="LightGrey", useChroms=chr)
cColor(rownames(up), "red", chromloc)
cColor(rownames(down), "green", chromloc)
dev.off()

# TOOL promoter-tfbs-cosmo.R: Cosmo (Finds common sequence motifs in the promoters of input genes. Promoter sequences are automatically retrieved from a central database. Currently works only for human, mouse, rat, drosophila, and yeast data.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT cosmo-output.txt: cosmo-output.txt 
# OUTPUT seqlogo.pdf: seqlogo.pdf 
# OUTPUT probs.pdf: probs.pdf 
# PARAMETER species: species TYPE [human: human, mouse: mouse, rat: rat, drosophila: drosophila, yeast: yeast] DEFAULT human ()
# PARAMETER promoter.size: promoter.size TYPE [small: small, medium: medium, large: large] DEFAULT small (Length of upstream sequences)
# PARAMETER strands: strands TYPE [single: single, both: both] DEFAULT single (Analyze both strands of DNA)
# PARAMETER appears.more.than.once: appears.more.than.once TYPE [yes: yes, no: no] DEFAULT no (Could the motif appear more than once in every sequence)
# PARAMETER percentage: percentage TYPE INTEGER FROM 1 TO 100 DEFAULT 50 (Percentage of sequences the motif should appear)
# PARAMETER tfsize: tfsize TYPE [small: small, medium: medium] DEFAULT small (Transcription factor binding site size)


# Promoter sequence analysis
# JTT 21.5.2008

# Loads the libraries
library(cosmo)

# Sets up the path to the promoter sequences
path.seq<-c(file.path(chipster.tools.path, "weeder", "seqs"))

# Renaming variable
size<-promoter.size
once<-appears.more.than.once

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Read phenodata and extracts chip information
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
chip<-phenodata$chiptype[1]

# Creates a variable for environement
if(species=="drosophila") {
   env<-paste(chip, "ACCNUM", sep="")
} else {
   env<-paste(chip, "REFSEQ", sep="")
}
env <- sub( ".db", "", env) # if chip contained ".db", remove it

# Creates a list of genes
genes<-row.names(dat)

# Loads the annotation library
lib<-as.character(chip)

# Account for the fact that annotation packages are from version 2.3 of Bioconductor
# named with an ".db" suffix. Add the suffix when missing to support data files
# from Chipster 1.3 and earlier. 
if (length(grep(".db", lib)) == 0 & length(grep("pmcdf", lib)) == 0) {
        lib <- paste(lib, ".db", sep="")
}

library(package=lib, character.only=T)

# Creating a list of RefSeq IDs for promoter retrieval
refseq<-as.vector(unlist(mget(genes, envir=get(env))))
refseq<-unique(refseq)

# Retrieving promoters
if(species=="human" & size=="small") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36.1_hg18_upstream1000.tsv"), header=T, sep="\t")
}
if(species=="human" & size=="medium") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36.1_hg18_upstream2000.tsv"), header=T, sep="\t")
}
if(species=="human" & size=="large") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36.1_hg18_upstream5000.tsv"), header=T, sep="\t")
}
if(species=="mouse" & size=="small") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36_mm8_upstream1000.tsv"), header=T, sep="\t")
}
if(species=="mouse" & size=="medium") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36_mm8_upstream2000.tsv"), header=T, sep="\t")
}
if(species=="mouse" & size=="large") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36_mm8_upstream5000.tsv"), header=T, sep="\t")
}
if(species=="rat" & size=="small") {
   upstream<-read.table(file.path(path.seq, "UCSC_rn4_upstream1000.tsv"), header=T, sep="\t")
}
if(species=="rat" & size=="medium") {
   upstream<-read.table(file.path(path.seq, "UCSC_rn4_upstream2000.tsv"), header=T, sep="\t")
}
if(species=="rat" & size=="large") {
   upstream<-read.table(file.path(path.seq, "UCSC_rn4_upstream5000.tsv"), header=T, sep="\t")
}
if(species=="drosophila" & size=="small") {
   upstream<-read.table(file.path(path.seq, "Drosophila_upstream1000.tsv"), header=T, sep="\t")
}
if(species=="drosophila" & size=="medium") {
   upstream<-read.table(file.path(path.seq, "Drosophila_upstream2000.tsv"), header=T, sep="\t")
}
if(species=="drosophila" & size=="large") {
   upstream<-read.table(file.path(path.seq, "Drosophila_upstream5000.tsv"), header=T, sep="\t")
}
if(species=="yeast" & size=="small") {
   upstream<-read.table(file.path(path.seq, "NCBI_sc_upstream500.tsv"), header=T, sep="\t")
}
if(species=="yeast" & size=="medium") {
   upstream<-read.table(file.path(path.seq, "NCBI_sc_upstream1000.tsv"), header=T, sep="\t")
}
if(species=="yeast" & size=="large") {
   upstream<-read.table(file.path(path.seq, "NCBI_sc_upstream2500.tsv"), header=T, sep="\t")
}

# Retrieving the sequences
w<-c()
for(i in 1:length(refseq)) {
   w<-c(w, which(upstream$RefSeq==refseq[i]))
}
unlink("seqs.txt")
for(i in 1:length(w)) {
   write(file="seqs.txt", paste(">", upstream[w[i],]$RefSeq, sep=""), append=T)
   write(file="seqs.txt", paste(upstream[w[i],]$Sequence, sep=""), append=T)
}

# Generating the function call
cll<-paste("cosmo(seqs='seqs.txt', ", sep="")

if(strands=="single") {
   cll<-paste(cll, "revComp=F, ", sep="")
} else {
   cll<-paste(cll, "revComp=T, ", sep="")
}

if(once=="yes") {
   cll<-paste(cll, "models=c('TCM'), ", sep="")
} else {
   cll<-paste(cll, "models=c('ZOOPS'), ", sep="")
}

pers<-floor(length(w)*percentage/100)
cll<-paste(cll, "minSites=", pers, ", ", sep="")

if(tfsize=="small") {
   cll<-paste(cll, "minW=6, maxW=8", sep="")
} else {
   cll<-paste(cll, "minW=10, maxW=10", sep="")
}

cll<-paste(cll, ")", sep="")
cll<-paste("res<-", cll, sep="")

# Running the analysis
write(cll, "cosmo-batch.txt")
source("cosmo-batch.txt") 

# Saving the results
sink("cosmo-output.txt")
summary(res)
sink()

pdf(file="seqlogo.pdf", width=600/72, height=600/72)
plot(res)
dev.off()

pdf(file="probs.pdf", width=600/72, height=600/72)
plot(res, type="prob")
dev.off()

# TOOL bedtools-slopbed.R: "Slop BED" (Increases the size of each feature in a feature file be a user-defined number of bases, but restricts the resizing to the size of the chromosome (i.e. no start < 0 and no end > chromosome size\). This tool is based on the BEDTools package.)
# INPUT bed.file: "BED/GFF/VCF file" TYPE GENERIC
# INPUT gen.file: "Genome file" TYPE GENERIC
# OUTPUT slopbed.bed
# PARAMETER OPTIONAL l: "The number of base pairs to subtract from the start coordinate" TYPE INTEGER DEFAULT 0 ()
# PARAMETER OPTIONAL r: "The number of base pairs to add to the end coordinate" TYPE INTEGER DEFAULT 0 ()
# PARAMETER OPTIONAL s: "Define additions based on strand" TYPE [yes, no] DEFAULT no (If this option is selected and for example 500 bases are subtracted from a start coordinate of a negative-stranded feature,  500 bp will be added to the end coordinate.)
# PARAMETER OPTIONAL pct: "Define additions as a fraction of the feature's length." TYPE [yes, no] DEFAULT no (Define additions as a fraction of the feature's length. E.g. if used on a 1000bp feature, 0.50 will add 500 bp.)
# PARAMETER OPTIONAL lf: "The fraction to subtract from the start coordinate" TYPE DECIMAL DEFAULT 0 ()
# PARAMETER OPTIONAL rf: "The fraction to add to the end coordinate" TYPE DECIMAL DEFAULT 0 ()

# AMS 23.4.2012

# binary
binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "slopBed"))

# options
options <- paste("")
if (pct == "no") {options <- paste(options, "-l", l, "-r", r)}
if (pct == "yes") {options <- paste(options, "-pct", "-l", lf, "-r", rf)}
if (s == "yes") {options <- paste(options, "-s")}

# input files
options <- paste(options, "-i bed.file", "-g gen.file")



# command
command <- paste(binary, options, "> slopbed.bed")

# run
system(command)
if (file.info("slopbed.bed")$size == 0) {system("echo \"No results found\" > slopbed.bed")}

# TOOL sort-genes.R: "Sort genes" (Sort genes according to the selected column in ascending or descending order.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT sort-genes.tsv: sort-genes.tsv 
# PARAMETER column: column TYPE COLUMN_SEL DEFAULT EMPTY (Data file column containing the data to sort)
# PARAMETER method: method TYPE [ascending: ascending, descending: descending] DEFAULT ascending (Sort the genes from largest to smallest or vice versa)


# Sort genes
# JTT 29.1.2009
# Loads the libraries

# Default parameters
#column<-"symbol"
#method<-"ascending"

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Extracts data to be sort
tosort<-dat[,grep(column, colnames(dat))]

# Sorting
if(method=="ascending") {
   dat<-dat[order(tosort, decreasing=F),]
} 
if(method=="descending") {
   dat<-dat[order(tosort, decreasing=T),]
} 

# Writing out data
write.table(data.frame(dat), file="sort-genes.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL stat-hyperG-GO.R: "Hypergeometric test for GO" (Finds GO ontology classes that are over- or under-represented.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT hypergeo.tsv: hypergeo.tsv 
# OUTPUT hypergeo.html: hypergeo.html 
# PARAMETER ontology: ontology TYPE [all: all, biological_process: biological_process, molecular_function: molecular_function, cellular_component: cellular_component] DEFAULT biological_process (The ontology to be analyzed.)
# PARAMETER p.value.threshold: p.value.threshold TYPE DECIMAL DEFAULT 0.05 (P-value threshold.)
# PARAMETER minimum.population: minimum.population TYPE INTEGER FROM 1 TO 1000000 DEFAULT 5 (Minimum number of genes required to be in a pathway.)
# PARAMETER conditional.testing: conditional.testing TYPE [yes: yes, no: no] DEFAULT yes (Conditional testing means that when a significant GO term is found, i.e. p-value is smaller than the specified thershold, that GO term is removed when testing the significance of its parent.)
# PARAMETER p.adjust.method: p.adjust.method TYPE [none: none, BH: BH, BY: BY] DEFAULT none (Method for adjusting the p-value in order to account for multiple testing. Because of the structure of GO, multiple testing is theoretically problematic, and using conditional.testing is a generally the preferred method. The correction can only be applied when no conditional.testing is performed.)
# PARAMETER over.or.under.representation: over.or.under.representation TYPE [over: over, under: under] DEFAULT over (Should over or under-represented classes be seeked?)

# Hypergeometrix test of gene enrichment to term categories
# Dario Greco 7.1.2007
# modified JTT 30.7.2007
# modified MG 5.2.2010
# modified IS 1.10.2010
# modified EK 2.7.2012

# Parameter settings (default) for testing purposes
#ontology<-"biological_process"
#p.value.threshold<-0.05
#minimum.population<-5
#conditional.testing<-"yes"
#p.adjust.method<-"none"
#over.or.under.representation<-"over"

# Loads the libraries
library(GOstats)
library(R2HTML)

# Loads the normalized data
dat<-read.table("normalized.tsv", header=TRUE, sep="\t", row.names=1)

# Reading phenodata for chiptype
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
if(phenodata$chiptype[1]!="cDNA" | phenodata$chiptype[1]!="Illumina") {
  # Saves the chiptype into object lib
  lib<-phenodata$chiptype[1]
  lib<-as.character(lib)
}

# Account for the fact that annotation packages are from version 2.3 of Bioconductor
# named with an ".db" suffix. Add the suffix when missing to support data files
# from Chipster 1.3 and earlier. 
if (length(grep(".db", lib)) == 0 & length(grep("pmcdf", lib)) == 0) {
  lib <- paste(lib, ".db", sep="")
}

# Loads the correct Affymetrix annotation library
library(package=lib, character.only=T)

# in the next 4 rows it converts the microarray IDs into Entrez Gene IDs
lib2<-sub('.db','',lib)
env<-paste(lib2, "ENTREZID", sep="")
alleg<-get(env)
alleg<-as.list(alleg)
alleg<-unlist(alleg)
alleg<-as.data.frame(alleg)
myids<-unique(alleg[rownames(dat),])

#CHOOSE THE ANNOTATION PACKAGE
annotpkg<-lib

#Account for the fact that alternative CDF annotation packages for some Affymetrix
#arrays are no longer supported and should be replaced with their Bioconductor counterpart 
if (annotpkg=="ath1121501hsentrezg.db") {
	annotpkg <- "ath1121501.db"
}
if (annotpkg=="aghsentrezg.db") {
	annotpkg <- "ag.db"
}
if (annotpkg=="ygs98scentrezg.db") {
	annotpkg <- "ygs98.db"
}
if (annotpkg=="yeast2scentrezg.db") {
	annotpkg <- "yeast2.db"
}


# check for conditional testing and multiple testing correction
if (conditional.testing == 'no') {
  conditional <- FALSE
} else {
  if (p.adjust.method != 'none')
    stop('CHIPSTER-NOTE: Multiple testing correction can be applied only when performing unconditional testing. Please set conditional.testing to no, or p.adjust.method to none. Usually the preferred method is to use conditional testing.')
  conditional <- TRUE
}

# define the output variable
output <- data.frame(total=integer(0), expected=numeric(0), observed=integer(0), p.value=numeric(0), description=character(0), ontology=character(0))

if (ontology == 'biological_process' || ontology == 'all') {
  params <- new('GOHyperGParams', geneIds=myids, annotation=annotpkg, ontology='BP', pvalueCutoff=p.value.threshold, conditional=conditional, testDirection=over.or.under.representation)
  go <- hyperGTest(params)
  go.table <- summary(go, pvalue=2)
  if (nrow(go.table)>0) {
    go.table$Pvalue <- p.adjust(go.table$Pvalue, method=p.adjust.method)
    go.table <- go.table[go.table$Pvalue <= p.value.threshold & go.table$Size >= minimum.population,]
    if (nrow(go.table)>0) {
      rownames(go.table) <- go.table[,1]
      go.table <- go.table[,c(6, 4, 5, 2, 7)]
      go.table$ontology <- 'biological process'
      colnames(go.table) <- colnames(output)
      output <- rbind(output, go.table)
      go.table$description <- paste('<a href="http://amigo.geneontology.org/cgi-bin/amigo/term-details.cgi?term=', rownames(go.table), '">', go.table$description, '</a>', sep='')
      HTML(go.table, file='hypergeo.html', append=TRUE, Border=0, innerBorder=1)
    }
  }
}

if (ontology == 'molecular_function' || ontology == 'all') {
  params <- new('GOHyperGParams', geneIds=myids, annotation=annotpkg, ontology='MF', pvalueCutoff=p.value.threshold, conditional=conditional, testDirection=over.or.under.representation)
  go <- hyperGTest(params)
  go.table <- summary(go, pvalue=2)
  if (nrow(go.table)>0) {
    go.table$Pvalue <- p.adjust(go.table$Pvalue, method=p.adjust.method)
    go.table <- go.table[go.table$Pvalue <= p.value.threshold & go.table$Size >= minimum.population,]
    if (nrow(go.table)>0) {
      rownames(go.table) <- go.table[,1]
      go.table <- go.table[,c(6, 4, 5, 2, 7)]
      go.table$ontology <- 'molecular function'
      colnames(go.table) <- colnames(output)
      output <- rbind(output, go.table)
      go.table$description <- paste('<a href="http://amigo.geneontology.org/cgi-bin/amigo/term-details.cgi?term=', rownames(go.table), '">', go.table$description, '</a>', sep='')
      HTML(go.table, file='hypergeo.html', append=TRUE, Border=0, innerBorder=1)
    }
  }
}

if (ontology == 'cellular_component' || ontology == 'all') {
  params <- new('GOHyperGParams', geneIds=myids, annotation=annotpkg, ontology='CC', pvalueCutoff=p.value.threshold, conditional=conditional, testDirection=over.or.under.representation)
  go <- hyperGTest(params)
  go.table <- summary(go, pvalue=2)
  if (nrow(go.table)>0) {
    go.table$Pvalue <- p.adjust(go.table$Pvalue, method=p.adjust.method)
    go.table <- go.table[go.table$Pvalue <= p.value.threshold & go.table$Size >= minimum.population,]
    if (nrow(go.table)>0) {
      rownames(go.table) <- go.table[,1]
      go.table <- go.table[,c(6, 4, 5, 2, 7)]
      go.table$ontology <- 'cellular component'
      colnames(go.table) <- colnames(output)
      output <- rbind(output, go.table)
      go.table$description <- paste('<a href="http://amigo.geneontology.org/cgi-bin/amigo/term-details.cgi?term=', rownames(go.table), '">', go.table$description, '</a>', sep='')
      HTML(go.table, file='hypergeo.html', append=TRUE, Border=0, innerBorder=1)
    }
  }
}

# write outputs
write.table(output, file='hypergeo.tsv', quote=FALSE, sep='\t')
if (nrow(output)==0)
  write('<html>\n\t<body>\n\t\tNo significant results found!</br />\n\t</body>\n</html>', file='hypergeo.html')

# EOF

# TOOL cna-define-experiment.R: "Define CNA-seq experiment" (This tool creates a phenodata file containing descriptive information about samples and experiment setup.)
# INPUT binned-hits-{...}.tsv: "Individual files with binned hits" TYPE GENERIC
# OUTPUT cna-data-table.tsv: "Data table with log-transformed read counts"
# OUTPUT META phenodata.tsv: "Experiment description file"
# PARAMETER counts: "Read counts" TYPE [count: "Original raw counts", corrected: "GC corrected counts"] DEFAULT count (Whether to use original raw read counts, or GC corrected ones.)
# PARAMETER log2.transformation: "log2 transform counts" TYPE [no: no, yes: yes] DEFAULT no (Whether the counts should be log2 transformed.)
# PARAMETER min.mappability: "mimimum mappability" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0 (The bins with lower mappability will be removed. Values are between 0 and 1.)
# PARAMETER normalization: "normalization" TYPE [none: none, median: median] DEFAULT none (Normalization method.)
# PARAMETER organism: "organism" TYPE [human: human] DEFAULT human (Organism.)
# PARAMETER genome.build: "human genome build" TYPE [GRCh37: GRCh37] DEFAULT GRCh37 (Genome build.)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-03-20

source(file.path(chipster.common.path, 'CGHcallPlus.R'))

filenames <- list.files(pattern='^binned-hits-[0-9]*\\.tsv$')
dat <- read.table(filenames[1], header=TRUE, sep='\t', row.names=1, as.is=TRUE)
total.reads <- sum(dat$count, na.rm=TRUE)
if (counts == 'corrected') {
  dat$count <- NULL
} else {
  dat$corrected <- NULL
}

if (length(filenames) > 1) {
  for (i in 2:length(filenames)) {
    x <- read.table(filenames[i], header=TRUE, sep='\t', row.names=1, as.is=TRUE)
    if (nrow(x) != nrow(dat))
      stop("CHIPSTER-NOTE: All input files need to be binned using the same bin size.")
    total.reads <- c(total.reads, sum(x$count, na.rm=TRUE))
    dat <- cbind(dat, x[,counts])
  }
}

identifiers <- gsub('tsv$', '', filenames)
identifiers <- gsub('\\.', '', identifiers)
identifiers <- gsub('-', '', identifiers)
colnames(dat)[-(1:3)] <- paste('chip.', identifiers, sep='')

if (log2.transformation == 'yes') {
  for (i in colnames(dat)[-(1:3)])
    dat[,i] <- log2(dat[,i] - min(dat[,i], na.rm=TRUE) + 1)
}

if (min.mappability > 0) {
  bin.size <- (dat$end[1] - dat$start[1] + 1) / 1000
  min.mappability <- 100 * min.mappability
  mappability <- read.table(file.path(chipster.tools.path, 'MPScall', genome.build, paste('mappability.', bin.size, 'kbp.txt.gz', sep='')), header=TRUE, sep='\t', as.is=TRUE, colClasses=c('character', 'integer', 'integer', 'numeric'))
  dat <- dat[mappability$mappability >= min.mappability,]
}

if (normalization != 'none') {
  dat2 <- data.frame(bin=rownames(dat), dat, stringsAsFactors=FALSE)
  colnames(dat2) <- c('bin', colnames(dat))
  dat2$chromosome[dat2$chromosome=='X'] <- '23'
  dat2$chromosome[dat2$chromosome=='Y'] <- '24'
  dat2$chromosome[dat2$chromosome=='MT'] <- '25'
  dat2$chromosome <- as.integer(dat2$chromosome)

  cgh.raw <- make_cghRaw(dat2)
  cgh.pre <- preprocess(cgh.raw, nchrom=24)
  cgh.nor <- normalize(cgh.pre, method=normalization)

  dat <- data.frame(cgh.nor@featureData@data, round(copynumber(cgh.nor), digits=2))
  colnames(dat) <- c('chromosome', 'start', 'end', paste('chip.', identifiers, sep=''))

  dat$chromosome <- as.character(dat$chromosome)
  dat$chromosome[dat$chromosome=='23'] <- 'X'
  dat$chromosome[dat$chromosome=='24'] <- 'Y'
  dat$chromosome[dat$chromosome=='25'] <- 'MT'
}

# generate phenodata

phenodata <- data.frame(sample=filenames, chiptype='not applicable', experiment='cna_seq', reads=total.reads, group='', stringsAsFactors=FALSE)

# write outputs

options(scipen=10)
write.table(dat, 'cna-data-table.tsv', quote=FALSE, sep='\t', na='')

write.table(phenodata, file='phenodata.tsv', quote=FALSE, sep='\t', row.names=FALSE)

# EOF

# TOOL filter-expression.R: "Filter by expression" (Filtering the genes by their expression. Note that chips are by default NOT scaled to have a mean of zero, which is most appropriate when applied to 1-color data, where this tool can be used for filtering out low quality or saturated probes. For 2-color data, the tool is most useful for filtering out invariant genes.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT expression-filter.tsv: expression-filter.tsv 
# PARAMETER over.expressed.cutoff: over.expressed.cutoff TYPE DECIMAL FROM -100000 TO 100000 DEFAULT 100 (Cut-off for over-expressed genes. For 1-color data this value should be a positive number, useful for excluding probes whoose expression level has reached the saturation limit. For 2-color data this threshold can be used to determine the lowest level of up-regulation.)
# PARAMETER under.expressed.cutoff: under.expressed.cutoff TYPE DECIMAL FROM -100000 TO 100000 DEFAULT 5 (Cut-off for under-expressed genes. For 1-color data this value should be a positive number, useful for excluding probes whoose expression level is under or near background level. For 2-color data this threshold can be used to determine the lowest level of down-regulation.)
# PARAMETER number.of.chips: number.of.chips TYPE INTEGER FROM 1 TO 10000 DEFAULT 1 (Number of chips)
# PARAMETER scale.to.same.mean: scale.to.same.mean TYPE [yes: yes, no: no] DEFAULT no (Scale the data to the same mean before filtering. Scaling to the mean is only recommended for 2-color arrays, where this filtering tool can be used to filter out invariant genes.)
# PARAMETER included.genes: included.genes TYPE [outside-the-range: outside-the-range, inside-the-range: inside-the-range] DEFAULT inside-the-range (Filtering method)


# Parameter settings (default) for testing purposes
#over.expressed.cutoff <-1
#under.expressed.cutoff <--1
#number.of.chips <-9
#scale.to.same.mean <-"yes"
#included.genes <-"outside-the-range"


# Filtering by expression
# JTT 9.6.2006
#
# modified by MG, 24.6.2010

# Loading the libraries
library(genefilter)

# Renaming variables
up<-over.expressed.cutoff
down<-under.expressed.cutoff
p<-number.of.chips
meth<-included.genes

# Reading data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Scaling the data to the same mean
if(scale.to.same.mean=="yes") {
   scaled.dat<-genescale(dat2)
} else {
   scaled.dat<-dat2
}

# Filter
# If a data value is smaller than up AND larger than down, recode it with 0, otherwise with 1
if(meth=="outside-the-range") {
	scaled.dat2<-ifelse(scaled.dat<=up & scaled.dat>=down, 0, 1)
}
# If a data value is smaller than up AND larger than down, recode it with 0, otherwise with 1
if(meth=="inside-the-range") {
	scaled.dat2<-ifelse(scaled.dat<=up & scaled.dat>=down, 1, 0)
}

# Calculate a sum of the number of chips the filtering criterion is fulfilled
s<-apply(as.data.frame(scaled.dat2), MARGIN=1, FUN="sum")

# Select only the rows for which the rowsum exceeds the number of chips (p)
#if(meth=="outside-the-range") {
#   dat2<-dat[which(s>=p),]
#}
#if(meth=="inside-the-range") {
#   dat2<-dat[which(s<p),] 
#}
dat2<-dat[which(s>=p),]

# Writing out the data
write.table(dat2, "expression-filter.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL acgh-plot-combined-expression.R: "Plot copy-number-induced gene expression" (Plot the expression levels of individual genes for a copy number vs. expression comparison. This tool must be run on the output from the tool Test for copy number induced expression changes - cn-induced-expression.tsv.)
# INPUT cn-induced-expression.tsv: cn-induced-expression.tsv TYPE GENE_EXPRS 
# OUTPUT cn-induced-expression-plot.pdf: cn-induced-expression-plot.pdf 
# PARAMETER gene.ids: gene.ids TYPE STRING DEFAULT 1 (The gene.ids of the genes to be plotted, separated by commas. Ranges are also supported (e.g. 1,3,7-10\).)
# PARAMETER genes: genes TYPE STRING DEFAULT empty (Gene symbols or probe names to be plotted, separated by commas. If this field is filled, the gene.ids parameter will be ignored.)

# plot-cn-induced-gene-expression.R
# Ilari Scheinin <firstname.lastname@gmail.com>
# 2011-05-25

library(intCNGEan)

# read input file
dat <- read.table('cn-induced-expression.tsv', header=TRUE, sep='\t', as.is=TRUE, row.names=1)

# parse the input string
if (genes == '' || genes == 'empty') {
  gene.ids <- gsub('[^0-9,-]', ',', gene.ids)
  items <- strsplit(gene.ids, ',')[[1]]
  to.plot <- integer()
  for (item in items) {
    item <- item[item!='']
    if (length(item)==0) next
    range <- strsplit(item, '-')[[1]]
    range <- range[range!='']
    if (length(range)==0) next
    to.plot <- c(to.plot, seq(range[1], range[length(range)]))
  }
  to.plot <- unique(to.plot)
} else {
  items <- strsplit(genes, ',', genes)[[1]]
  to.plot <- integer()
  for (item in items) {
    to.plot <- c(to.plot, dat[gsub(' ', '', item), 'gene.id'])
    to.plot <- c(to.plot, dat[dat$symbol == gsub(' ', '', item), 'gene.id'])
  }
  to.plot <- unique(to.plot)
}

# if testing was done with analysis.type='regional', the resulting table contains four more columns
# those are removed so that we can calculate the number of samples from the number of columns
dat$reg.id <- NULL
dat$begin.reg <- NULL
dat$end.reg <- NULL
dat$shrinkage <- NULL
if ('symbol' %in% colnames(dat))
  dat$probes <- paste(dat$symbol, dat$probes, sep='\n')
dat$symbol <- NULL
dat$description <- NULL

# return the data to the original order
# not sure if necessary, but just in case
dat <- dat[order(dat$gene.id),]
nosamp <- (ncol(dat)-12)/3
tuned <- list(datafortest=as.matrix(dat[,13:ncol(dat)]), lossorgain=dat$comparison, genestotest=dat$gene.id, callprobs=as.matrix(dat[,c('av.probs.1','av.probs.2')]), alleffects=dat$effect.size, ann=dat[,c('chromosome','start','end')], nosamp=nosamp)
rownames(tuned$datafortest) <- dat$probes
colnames(tuned$datafortest) <- sub('^chip\\.', '', colnames(tuned$datafortest))
colnames(tuned$datafortest)[1:(2*nosamp)] <- ''
rownames(tuned$callprobs) <- dat$probes
colnames(tuned$callprobs) <- NULL
colnames(tuned$ann) <- c('Chromosome','Start','End')
names(tuned$lossorgain) <- dat$probes
names(tuned$genestotest) <- dat$probes

# remove genes that are not present
to.plot <- intersect(to.plot, tuned$genestotest)

# check that we have something to plot
if (length(to.plot)==0)
  stop('CHIPSTER-NOTE: Nothing to plot.')

# plot
pdf(file='cn-induced-expression-plot.pdf')
for (gene in to.plot)
  intCNGEan.plot(gene.id=gene, tuned)
dev.off()

# EOF

# TOOL qc-affy-rle-nuse.R: "Affymetrix - using RLE and NUSE" (Affymetrix quality control using NUSE and RLE. This tool should be run on RAW data, i.e., CEL-files.)
# INPUT microarray{...}.cel: microarray{...}.cel TYPE AFFY 
# OUTPUT rle-plot.pdf: rle-plot.pdf 
# OUTPUT nuse-plot.pdf: nuse-plot.pdf 
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Affymetrix quality control
# JTT 9.6.2006

# Loading the libraries
library(affy)
library(affyPLM)

# Renaming variables
w<-image.width
h<-image.height

# Reading in data
dat<-ReadAffy()

# Calculating quality control values
aqc<-fitPLM(dat)

# Plotting the QC-values
par(mar=c(7, 4, 4, 2) + 0.1)
pdf(file="rle-plot.pdf", width=w/72, height=h/72)
Mbox(aqc, main="RLE", las=2)
dev.off()

par(mar=c(7, 4, 4, 2) + 0.1)
pdf(file="nuse-plot.pdf", width=w/72, height=h/72)
boxplot(aqc, main="NUSE", las=2)
dev.off()

# TOOL acgh-match-probes.R: "Match copy number and expression probes" (Matches the probes of a copy number data set with probes of an expression data set, using their chromosomal locations. Running this tool is a prerequisite for testing copy-number-induced effects on expression.)
# INPUT aberrations.tsv: aberrations.tsv TYPE GENE_EXPRS 
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT phenodata_cgh.tsv: phenodata_cgh.tsv TYPE GENERIC 
# INPUT phenodata_exp.tsv: phenodata_exp.tsv TYPE GENERIC 
# OUTPUT matched-cn-and-expression.tsv: matched-cn-and-expression.tsv 
# OUTPUT matched-cn-and-expression-heatmap.pdf: matched-cn-and-expression-heatmap.pdf 
# OUTPUT META phenodata-matched.tsv: phenodata-matched.tsv 
# PARAMETER sample.identifiers.1: sample.identifiers.1 TYPE METACOLUMN_SEL DEFAULT Sample (The phenodata column for data set 1 used to link the two data sets together.)
# PARAMETER sample.identifiers.2: sample.identifiers.2 TYPE METACOLUMN_SEL DEFAULT Sample (The phenodata column for data set 2 used to link the two data sets together.)
# PARAMETER method: method TYPE [distance: distance, overlap: overlap, overlapplus: overlapplus] DEFAULT distance (The method for linking copy number and expression probes together.)

# match-cn-and-expression-probes.R
# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-12-13

source(file.path(chipster.common.path, 'CGHcallPlus.R'))
library(intCNGEan)

dat1 <- read.table('aberrations.tsv', header=TRUE, sep='\t', as.is=TRUE, row.names=1)
dat2 <- read.table('normalized.tsv', header=TRUE, sep='\t', as.is=TRUE, row.names=1)
phenodata1 <- read.table("phenodata_cgh.tsv", header=T, sep='\t', as.is=TRUE)
phenodata2 <- read.table("phenodata_exp.tsv", header=T, sep='\t', as.is=TRUE)

# determine which dataset is cgh
if (length(grep("^probnorm\\.", names(dat1)))!=0) {
  cgh <- dat1
  exp <- dat2
  phenodata_cgh <- phenodata1
  phenodata_exp <- phenodata2
  samples_cgh <- sample.identifiers.1
  samples_exp <- sample.identifiers.2
} else if (length(grep("^probnorm\\.", names(dat2)))!=0) {
  cgh <- dat2
  exp <- dat1
  phenodata_cgh <- phenodata2
  phenodata_exp <- phenodata1
  samples_cgh <- sample.identifiers.2
  samples_exp <- sample.identifiers.1
} else {
  stop('CHIPSTER-NOTE: Could not detect the aCGH data set.')
}

# check that both data sets have the probe position information
pos <- c('chromosome','start','end')
if (length(setdiff(pos, colnames(cgh)))!=0)
  stop('CHIPSTER-NOTE: Both data sets must have the following columns: chromosome, start, end.')
if (length(setdiff(pos, colnames(exp)))!=0)
  stop('CHIPSTER-NOTE: Both data sets must have the following columns: chromosome, start, end.')

# check for unambiguity of sample identifiers
if (nrow(phenodata_cgh)!=length(unique(phenodata_cgh[,samples_cgh])))
  stop('CHIPSTER-NOTE: Unambigous aCGH sample identifiers: ', paste(phenodata_cgh[duplicated(phenodata_cgh[,samples_cgh]),samples_cgh], collapse=', ')) 
if (nrow(phenodata_exp)!=length(unique(phenodata_exp[,samples_exp])))
  stop('CHIPSTER-NOTE: Unambigous expression sample identifiers: ', paste(phenodata_exp[duplicated(phenodata_exp[,samples_exp]),samples_exp], collapse=', ')) 

common.samples <- intersect(phenodata_cgh[,samples_cgh], phenodata_exp[,samples_exp])
rownames(phenodata_cgh) <- phenodata_cgh[,samples_cgh]
rownames(phenodata_exp) <- phenodata_exp[,samples_exp]
phenodata_cgh$n <- 1:nrow(phenodata_cgh)
phenodata_exp$n <- 1:nrow(phenodata_exp)
index_cgh <- phenodata_cgh[common.samples, 'n']
index_exp <- phenodata_exp[common.samples, 'n']

# build a cghCall object from the cgh data
cgh$chromosome[cgh$chromosome=='X'] <- 23
cgh$chromosome[cgh$chromosome=='Y'] <- 24
cgh$chromosome[cgh$chromosome=='MT'] <- 25
cgh$chromosome <- as.integer(cgh$chromosome)
cgh <- cgh[!is.na(cgh$chromosome),]
calls <- as.matrix(cgh[,grep("^flag\\.", names(cgh))])[,index_cgh]
copynumber <- as.matrix(cgh[,grep("^chip\\.", names(cgh))])[,index_cgh]
segmented <- as.matrix(cgh[,grep("^segmented\\.", names(cgh))])[,index_cgh]
probloss <- as.matrix(cgh[,grep("^probloss\\.", names(cgh))])[,index_cgh]
probnorm <- as.matrix(cgh[,grep("^probnorm\\.", names(cgh))])[,index_cgh]
probgain <- as.matrix(cgh[,grep("^probgain\\.", names(cgh))])[,index_cgh]
if (2 %in% calls) {
  probamp <- as.matrix(cgh[,grep("^probamp\\.", names(cgh))])[,index_cgh]
  probgain <- probgain + probamp
  calls[calls==2] <- 1
}
cgh <- new('cghCall', assayData=assayDataNew(calls=calls, copynumber=copynumber, segmented=segmented, probloss=probloss, probnorm=probnorm, probgain=probgain), featureData=new('AnnotatedDataFrame', data=data.frame(Chromosome=cgh$chromosome, Start=cgh$start, End=cgh$end, row.names=row.names(cgh))))
sampleNames(cgh) <- phenodata_cgh[common.samples, samples_cgh]

# build an ExpressionSet object from the expression data
dat_exp <- exp
exp$chromosome[exp$chromosome=='X'] <- 23
exp$chromosome[exp$chromosome=='Y'] <- 24
exp$chromosome[exp$chromosome=='MT'] <- 25
exp$chromosome <- as.integer(exp$chromosome)
exp <- exp[!is.na(exp$chromosome),]
exprs <- as.matrix(exp[,grep("^chip\\.", names(exp))])[,index_exp]
exp <- new("ExpressionSet", exprs=exprs, featureData=new("AnnotatedDataFrame", data=data.frame(Chromosome=exp$chromosome, Start=exp$start, End=exp$end, row.names=row.names(exp))))
sampleNames(exp) <- phenodata_exp[common.samples, samples_exp]

# match probes
matched <- intCNGEan.match(cgh, exp, CNbpend='yes', GEbpend='yes', method=method)

# bugfix version of the plotting function
intCNGEan.heatmaps.modified <- function (CNdata, GEdata, location = "mode", colorbreaks = "equiquantiles") 
{
    makeSegments <- function(data) {
        previous <- 2000
        values <- c()
        start <- c()
        end <- c()
        for (i in 1:length(data)) {
            if (data[i] != previous) {
                start <- c(start, i)
                last <- i - 1
                if (last > 0) 
                  end <- c(end, last)
                values <- c(values, data[i])
            }
            previous <- data[i]
        }
        end <- c(end, length(data))
        result <- cbind(values, start, end)
        return(result)
    }
    makeRegions <- function(CNprobs) {
        splitter <- list()
        splitter[[1]] <- c(1)
        index.temp <- 1
        j <- 1
        for (i in 1:(dim(CNprobs)[1] - 1)) {
            if (all(CNprobs[i, ] == CNprobs[i + 1, ])) {
                index.temp <- c(index.temp, i + 1)
                splitter[[j]] <- index.temp
            }
            else {
                index.temp <- i + 1
                j <- j + 1
                splitter[[j]] <- index.temp
            }
        }
        regDetails <- NULL
        for (i in 1:length(splitter)) {
            regDetails <- rbind(regDetails, c(min(splitter[[i]]), 
                max(splitter[[i]])))
        }
        return(regDetails)
    }
    if (dim(fData(CNdata))[1] != dim(fData(GEdata))[1]) {
        stop("CN and GE data have different number of rows.")
    }
    if (!all(fData(CNdata)[, 1] == fData(GEdata)[, 1])) {
        stop("chrosome annotation between CN and GE does not match.")
    }
    if (!(location %in% c("mode", "median", "mean"))) {
        stop("location parameter ill-specified.")
    }
    if (!(colorbreaks %in% c("equidistant", "equiquantiles"))) {
        stop("colorbreaks parameter ill-specified.")
    }
    exprsTemp <- as.numeric(exprs(GEdata))
    histres <- hist(as.numeric(exprs(GEdata)), plot = FALSE, 
        n = 511)
    if (location == "median") {
        exprsMode <- median(exprsTemp)
    }
    if (location == "mean") {
        exprsMode <- mean(exprsTemp)
    }
    if (location == "mode") {
        exprsMode <- histres$mids[which.max(histres$density)]
    }
    exprsTempBelowMode <- exprsTemp[exprsTemp < exprsMode]
    exprsTempAboveMode <- exprsTemp[exprsTemp >= exprsMode]
    exprsTempBelowMode <- cbind(exprsTempBelowMode, ecdf(exprsTempBelowMode)(exprsTempBelowMode))[order(exprsTempBelowMode), 
        ]
    exprsTempAboveMode <- cbind(exprsTempAboveMode, ecdf(exprsTempAboveMode)(exprsTempAboveMode))[order(exprsTempAboveMode), 
        ]
    if (colorbreaks == "equiquantiles") {
        histresBM <- hist(exprsTempBelowMode[, 2], plot = FALSE, 
            n = 100)
        histresAM <- hist(exprsTempAboveMode[, 2], plot = FALSE, 
            n = 101)
        breaks <- c(quantile(exprsTempBelowMode[, 1], probs = histresBM$breaks), 
            exprsMode, quantile(exprsTempAboveMode[, 1], probs = histresAM$breaks))
        collist <- c(maPalette(low = "red", high = "black", k = length(histresBM$breaks)), 
            maPalette(low = "black", high = "green", k = length(histresAM$breaks)))
    }
    if (colorbreaks == "equidistant") {
        collistBelowMode <- unique(maPalette(low = "red", high = "black", 
            k = 100))
        collistAboveMode <- unique(maPalette(low = "black", high = "green", 
            k = 100))
        breaks <- c(seq(min(exprsTemp), exprsMode, length.out = length(collistBelowMode) + 
            1), seq(exprsMode, max(exprsTemp), length.out = length(collistAboveMode))[-1])
        collist <- unique(c(collistBelowMode, collistAboveMode))
    }
    CNprobs <- numeric()
    for (i in 1:dim(calls(CNdata))[2]) {
        CNprobs <- cbind(CNprobs, cbind(probloss(CNdata)[, i], 
            probnorm(CNdata)[, i], probgain(CNdata)[, i], probamp(CNdata)[, 
                i]))
    }
    nclass <- dim(CNprobs)[2]/dim(calls(CNdata))[2]
    SegExprData <- numeric()
    for (sampleNo in 1:dim(calls(CNdata))[2]) {
        SegExpr <- numeric()
        SegData <- segmented(CNdata[, sampleNo])
        segments <- makeSegments(segmented(CNdata[, sampleNo]))
        for (j in 1:dim(segments)[1]) {
            ids <- c(segments[j, 2]:segments[j, 3])
            medSegExpr <- median(exprs(GEdata)[ids, sampleNo])
            SegExpr <- c(SegExpr, rep(medSegExpr, length(ids)))
        }
        SegExprData <- cbind(SegExprData, SegExpr)
    }
    regDetails <- makeRegions(CNprobs)
    regCalls <- numeric()
    regSegExprs <- numeric()
    regChr <- numeric()
    for (j in 1:dim(regDetails)[1]) {
        regCalls <- rbind(regCalls, calls(CNdata)[regDetails[j, 
            1], ])
        regSegExprs <- rbind(regSegExprs, SegExprData[regDetails[j, 
            1], ])
        regChr <- c(regChr, fData(CNdata)[regDetails[j, 1], 1])
    }
    chrInd <- rep(0, length(regChr))
    chrInd[(regChr%%2 == 0)] <- 1
    chrColor <- rep("blue", length(regChr))
    chrColor[(regChr%%2 == 0)] <- c("yellow")
    Y <- rep(FALSE, length(regChr))
    for (i in 2:length(regChr)) {
        if ((regChr[i - 1] != regChr[i])) {
            Y[i] <- TRUE
        }
    }
    Y[1] <- TRUE
    beginChr <- rep("", length(regChr))
    beginChr[Y] <- regChr[Y]
    CNcolor.coding <- c("red", "black", "green", "white")[1:nclass]
    def.par <- par
    fl <- layout(matrix(c(1, 2, 3, 1, 2, 3, 1, 2, 3), 3, 3, byrow = TRUE), 
        width = c(1, 9, 9))
    par(mar = c(3, 2, 4, 0))
    image(z = matrix(chrInd, nrow = 1), xaxt = "n", yaxt = "n", 
        col = c("blue", "yellow"))
    axis(2, at = (which(Y) - 1)/(length(Y) - 1), labels = regChr[Y], 
        tick = FALSE, las = 1)
    par(mar = c(3, 1, 4, 1))
    image(z = t(regCalls), xaxt = "n", yaxt = "n", col = CNcolor.coding, 
        main = "copy number data")
    par(mar = c(3, 1, 4, 1))
    image(z = t(regSegExprs), xaxt = "n", yaxt = "n", col = collist, 
        breaks = breaks, main = "gene expression data")
    par(def.par)
    return(invisible(NULL))
}

# plot heatmaps
pdf(file='matched-cn-and-expression-heatmap.pdf', paper='a4r', width=0, height=0)
intCNGEan.heatmaps.modified(matched$CNdata.matched, matched$GEdata.matched, location='median')
dev.off()

# separate elements from the resulting object

dat3 <- data.frame(matched$CNdata.matched@featureData@data, matched$GEdata.matched@featureData@data)
colnames(dat3) <- c('chromosome', 'cn.start', 'cn.end', 'exp.probe','exp.start', 'exp.end')
dat3$exp.probe <- rownames(matched$GEdata.matched@featureData@data)

if ('symbol' %in% colnames(dat_exp))
  dat3$symbol <- dat_exp[dat3$exp.probe, 'symbol']
if ('description' %in% colnames(dat_exp))
  dat3$description <- dat_exp[dat3$exp.probe, 'description']

dat3$loss.freq <- round(mean(as.data.frame(t(assayDataElement(matched$CNdata.matched, "calls")==-1))), digits=3)
dat3$gain.freq <- round(mean(as.data.frame(t(assayDataElement(matched$CNdata.matched, "calls")==1))), digits=3)

exprs <- assayDataElement(matched$GEdata.matched, 'exprs')
samples <- microarrays <- sprintf('microarray%.3i', 1:ncol(exprs))
colnames(exprs) <- paste('chip.', samples, sep='')
dat3 <- cbind(dat3, exprs)

calls <- assayDataElement(matched$CNdata.matched, 'calls')
colnames(calls) <- paste('flag.', samples, sep='')
dat3 <- cbind(dat3, calls)

copynumber <- assayDataElement(matched$CNdata.matched, 'copynumber')
colnames(copynumber) <- paste('logratio.', samples, sep='')
dat3 <- cbind(dat3, copynumber)

segmented <- assayDataElement(matched$CNdata.matched, 'segmented')
colnames(segmented) <- paste('segmented.', samples, sep='')
dat3 <- cbind(dat3, segmented)

probloss <- assayDataElement(matched$CNdata.matched, 'probloss')
colnames(probloss) <- paste('probloss.', samples, sep='')
dat3 <- cbind(dat3, probloss)

probnorm <- assayDataElement(matched$CNdata.matched, 'probnorm')
colnames(probnorm) <- paste('probnorm.', samples, sep='')
dat3 <- cbind(dat3, probnorm)

probgain <- assayDataElement(matched$CNdata.matched, 'probgain')
colnames(probgain) <- paste('probgain.', samples, sep='')
dat3 <- cbind(dat3, probgain)

dat3$chromosome <- as.character(dat3$chromosome)
dat3$chromosome[dat3$chromosome=='23'] <- 'X'
dat3$chromosome[dat3$chromosome=='24'] <- 'Y'
dat3$chromosome[dat3$chromosome=='25'] <- 'MT'

# add additional phenodata columns from phenodata_cgh to phenodata_exp
phenodata_cgh <- phenodata_cgh[index_cgh,]
phenodata_exp <- phenodata_exp[index_exp,]
phenodata_exp$description_cgh <- phenodata_cgh$description
for (col in setdiff(colnames(phenodata_cgh), colnames(phenodata_exp)))
  phenodata_exp[,col] <- phenodata_cgh[,col]
phenodata_exp$sample <- samples
phenodata_exp$n <- NULL

# write output
write.table(dat3, file='matched-cn-and-expression.tsv', quote=FALSE, sep='\t')
write.table(phenodata_exp, file='phenodata-matched.tsv', quote=FALSE, sep='\t', na='', row.names=FALSE)

# EOF

# TOOL mothur-chimera-uchime.R: "Remove chimeric sequences with Mothur" (Remove chimeric sequences from a fasta-formatted alignment using the uchime method and the 16S rRNA Silva gold reference set. This tool is based on the Mothur package.)
# INPUT a.fasta: "FASTA file" TYPE FASTA
# OUTPUT OPTIONAL chimeras-removed.fasta
# OUTPUT OPTIONAL chimeras-removed-summary.tsv


# EK 18.06.2013

# binary
binary <- c(file.path(chipster.tools.path, "mothur", "mothur"))
data.path <- c(file.path(chipster.tools.path, "mothur-data"))
template.path <- c(file.path(data.path, "silva.gold.align"))

# batch file
write(paste("chimera.uchime(fasta=a.fasta, template=", template.path, ")", sep=""), "batch.mth", append=F)

# command
command <- paste(binary, "batch.mth", "> log_raw.txt 2>&1")

# run
system(command)

# batch file 2
write("remove.seqs(accnos=a.uchime.accnos, fasta=a.fasta)", "remove.mth", append=F)

# command
command2 <- paste(binary, "remove.mth", "> log_raw.txt 2>&1")

# run
system(command2)

# Post process output
system("mv a.pick.fasta chimeras-removed.fasta")

# system("grep -A 2 Removed log_raw.txt > log.txt")

# batch file 3
write("summary.seqs(fasta=chimeras-removed.fasta)", "summary.mth", append=F)

# command 3
command3 <- paste(binary, "summary.mth", "> log_raw.txt")

# run
system(command3)

# Post process output
system("grep -A 9 Start log_raw.txt > chimeras-removed-summary.tsv")

# TOOL ngs-find-peaks-zinba.R: "Find broad peaks using Zinba" (This tool provide means to find broad peaks, such as regions of open chromatin or transcription factor / histone binding sites from DNase, FAIRE or Chip-seq data. Please note that Zinba is extremely slow and analyses can last several hours.)
# INPUT alignment.txt: "Read file" TYPE GENERIC 
# OUTPUT peaks.bed: "True enriched peaks in a format compatible with the Genome Browser"
# PARAMETER file.format: "File format" TYPE [ELAND, SAM, BAM, BED] DEFAULT BAM (The format of the input files.)
# PARAMETER species: "Genome" TYPE [human, yeast] DEFAULT human (The species of the samples.)
# PARAMETER read.len: "Read length" TYPE [36, 50] DEFAULT 36 (The size of the read.)
# PARAMETER fragment.size: "Fragment length" TYPE INTEGER FROM 1 TO 8000 DEFAULT 300 (The estimated fragment length of the sequencing library.)
# PARAMETER broad.peaks: "Peak type" TYPE [broad, narrow] DEFAULT narrow (Peak type that is searched. If broad is selected, adjacent peaks are merged into a single peak over a much longer region. Otherwise only overlapping peaks are merged)
# PARAMETER max.hit: "Number of hits per read at maximum" TYPE INTEGER FROM 1 TO 100 DEFAULT 4 (Number of hits per read allowed during mapping process.)
# PARAMETER score.threshold: "FDR cutoff" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (The FDR cutoff for statistical significance. Smaller values reduce the false discovery rate and produce shorter peaks lists.)
# PARAMETER model.chr: "One chromosome to use for model selection" TYPE STRING DEFAULT chr22 (One chromosome name to use for model selection.)


######################################################
#                                                    #
# MK, 20.3.2012                                      #
#                                                    #
# Zinba is a tool to find broad peaks from pre-      #
# aligned SAM/BAM/ELAND files. The analysis needs to #
# be done for each file separately. Peaks are        #
# typically binned into categories representing      #
# exons (first, last all), introns, TSS, promoters,  #
# intergenic. Motifs can be searched from them also  #
#                                                    #
######################################################


#Export2sam.pl is a part of samtools and is used to convert ELAND outputs to SAM
eland_to_sam.binary <- c(file.path(chipster.tools.path, "samtools-0.1.18", "misc", "export2sam.pl"))
#samtools is used to convert SAM to BAM
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))
#bedtools is used to convert BAM to BED
bam_to_bed.binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "bamToBed"))

#File conversions ending to BED
input.file <- "alignment.txt";
if(file.format == "ELAND") {
	system(paste(eland_to_sam.binary, "--read1=", input.file," > alignment.sam"))
	file.format <- "SAM"
	input.file  <- "alignment.sam"
}
if (file.format == "SAM") {
	system(paste(samtools.binary, "view -bS", input.file," -o alignmentUnsorted.bam"))
	system(paste(samtools.binary, "sort alignmentUnsorted.bam alignment"))
	system(paste(samtools.binary, "index alignment.bam"))
	file.format <- "BAM"
	input.file <- "alignment.bam"
} 	
if (file.format == "BAM") {
	system(paste(bam_to_bed.binary, "-i ", input.file, ">alignment.bed"))
	input.file <- "alignment.bed"
} 

#Load ZINBA
library(zinba)

#Modify arguments to fit Zinba
if(species=="human") 		{ species_nick  = "hg19" }
if(species=="mouse") 		{ species_nick  = "mm9" }
if(species=="arabidopsis") 	{ species_nick  = "tair10" }
if(species=="yeast") 		{ species_nick  = "sacCer3" }

if(broad.peaks=="broad") 	{ 
	winGap <- 5000
	selectcovs <- c("gcPerc", "align_perc")	
} else { 
	winGap <- 0
	selectcovs <- c("gcPerc", "exp_cnvwin_log", "align_perc")
}

#Zinba writes some files to the alignability folder. To fix this, new folder is created and softs link to 
#the real index files created
dir.name	<- paste("map", read.len,"_", species_nick, sep="");
index.dir	<- file.path(chipster.tools.path, "zinba", "map", dir.name)
dir.create(dir.name);
system(paste("ln -s", file.path(index.dir,"*"), " ", file.path(dir.name,".")));

#Generate your alignability directory
generateAlignability(
		mapdir=dir.name, 	    																						# mappability directory from unpacked mappability files
		twoBitFile=c(file.path(chipster.tools.path, "zinba", "2bit", paste(species_nick, ".2bit", sep=""))),            # path to downloaded genome build file in .2bit format
		outdir="zinba_background/",                                														# directory for processed files, used later in analysis
		athresh=max.hit,                                              													# number of hits per read allowed during mapping process
		extension=fragment.size,                                       													# average fragment library length
);

#Run the basealigncount function to generate the basecount file needed to obtain exact peak boundaries through 
#peak refinement.
basealigncount(
		inputfile=input.file, 																							# mapped sample reads
		outputfile="zinba_background/zinba_basecount.txt", 																						# output path
		extension=fragment.size, 																						# average fragment library length
		filetype="bed", 																								# either "bed", "bowtie", or "tagAlign"
		twoBitFile=c(file.path(chipster.tools.path, "zinba", "2bit", paste(species_nick, ".2bit", sep=""))), 			# path to downloaded genome build file in .2bit format
);

func <- function(this, ...) { 
	k<- list(...); 
	print(k); 
}

run.zinba(
		refinepeaks=1,          	              															# refine peaks? 1 for yes, 0 for no
		seq=input.file,   		                       														# path to mapped experimental reads
		input="none",               	               														# path to mapped input reads if available (default is "none")
		filetype="bed",	                                   													# either 'bed', 'bowtie', or 'tagAlign'
		threshold=score.threshold,                     														# FDR threshold, default is 0.05
		align="zinba_background/",                            												# path to alignability directory
		numProc=1,																							# number of CPUs to use, must be less than max available   (default 1)
		twoBit=c(file.path(chipster.tools.path, "zinba", "2bit", paste(species_nick, ".2bit", sep=""))),    # path to genome build in .2bit format
		outfile="zinba.out",  																				# prefix for outputted files
		extension=fragment.size,																			# average fragment library length (size selected)
		basecountfile="zinba_background/zinba_basecount.txt",												# path to basecount file if refinepeaks is 1
		printFullOut=0,   																					# print original data with enrichment estimates, 1 for yes (more space required), 0 for no (default)
		interaction=TRUE,   																				# whether or not to considering interaction during model selection, TRUE (default) or FALSE
		FDR=TRUE, 																							# either TRUE (default) or FALSE. If false, then uses posterior probability to threshold peaks using 1-threshold
		winGap=winGap,	
		selectmodel=T,
		selectchr=model.chr,		
		selectcovs=selectcovs,																				# vector of covariate names (characters) to consider in model selection  (can be  "gcPerc", "align_perc", "exp_cnvwin_log", and "input_count")
		pWinSize=200, 																						# sliding window size for local maximum detection (default 200 bp)
		winSize=250,
		offset=125,	
		cnvWinSize=100000,
		cnvOffset=2500,
		pquant=1,
		initmethod="count",
		diff=0,
		method="mixture",
		selecttype="dirty",
);


#system(paste("cp -r ", "/tmp/matti/ce671df2-8b95-4826-8259-950c658c2d77/zinba.out3.peaks.bed ", getwd(), "/zinba.out.peaks.bed", sep=""))
#system(paste("cp -r ", getwd(), "/tmp/matti/."))
#print(list.files())

#Read Output
data <- read.table(file="zinba.out.peaks.bed", sep="\t")
colnames(data) <- c("chr", "start", "end", "ID", "score", "strand")
rownames(data) <- paste(data[,4], 1:nrow(data), sep="_");

#Sorting the BED
source(file.path(gsub("R-2.15", "R-2.12", chipster.common.path), "bed-utils.R"))
if (nrow(data) > 1){	
	data <- sort.bed(data)
}
write.table(data, file="peaks.bed", sep="\t", row.names=F, col.names=F, quote=F)

# TOOL samtools-consensus.R: "Create consensus sequence from BAM" (Create consensus sequence from a BAM file. You need to provide the reference sequence in FASTA format. This tool is based on the SAMtools package.)
# INPUT aln.bam: "BAM file to use as input" TYPE GENERIC
# INPUT ref.fa: "Reference genome in FASTA format" TYPE GENERIC
# OUTPUT OPTIONAL consensus.fasta
# OUTPUT OPTIONAL output.log



# KM 26.4.2012

# samtools path
samtools.binary <- c(file.path(chipster.tools.path, "samtools","samtools"))
bcftools.binary <- c(file.path (chipster.tools.path, "samtools","bcftools","bcftools"))
vcfutils.binary <- c(file.path (chipster.tools.path, "samtools","bcftools","vcfutils.pl"))


system("echo Running command: > output.log")
samtools.command <- paste( samtools.binary, "mpileup -uf ref.fa aln.bam |",bcftools.binary ," view -cg - |",vcfutils.binary, "vcf2fq | awk 'BEGIN {a = 1}{if ($1 == \"+\") a = 0}{if (a == 1) print $0}' | sed s/\"@\"/\">\"/  > consensus.fasta")
echo.command <- paste("echo '", samtools.command, "'>> output.log")

system(echo.command)
system(samtools.command)
system("ls -l  >> output.log")

# TOOL DEXSeq.R: "Differential exon expression using DEXSeq" (Infers differential exon usage from RNA-seq data using the Bioconductor package DEXSeq. Replicates are necessary for this tool to work properly. In order to prepare the input, run the tool \"Count aligned reads per exons for DEXSeq\" for your BAM files and combine the results to a count table using the tool \"Utilities - Define NGS experiment\". Please use the group column of the phenodata file to indicate your experimental groups.)
# INPUT countfile.tsv: "Count table" TYPE GENERIC 
# INPUT phenodata.tsv: "Phenodata" TYPE GENERIC
# OUTPUT dexseq-all-genes.tsv: dexseq-all-genes.tsv
# OUTPUT OPTIONAL dexseq-genes-with-significant-exons.tsv: dexseq-genes-with-significant-exons.tsv
# OUTPUT OPTIONAL dexseq-exons.pdf: dexseq-exons.pdf
# OUTPUT OPTIONAL dexseq-MAplot.pdf: dexseq-MAplot.pdf
# OUTPUT OPTIONAL dexseq-dispersion-plot.pdf: dexseq-dispersion-plot.pdf
# PARAMETER organism: "Organism" TYPE [Homo_sapiens.GRCh37.68.chr.DEXSeq.gtf: "Human (hg19.68)", Mus_musculus.GRCm38.68.chr.DEXSeq.gtf: "Mouse (mm10.68)", Rattus_norvegicus.RGSC3.4.68.chr.DEXSeq.gtf: "Rat (rn4.68)"] DEFAULT Homo_sapiens.GRCh37.68.chr.DEXSeq.gtf (Which organism is your data from.)
# PARAMETER pvalue: "Threshold for adjusted p-value" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (Threshold for BH adjusted p-values. If a gene has at least one exon below this p-value, all its exons will be included in the result list.)
# PARAMETER OPTIONAL dispersion: "Common dispersion" TYPE DECIMAL FROM 0 TO 100 DEFAULT 0.1 (If dispersions can not be estimated, this common dispersion value is used for all exons. In this case no graphical output is generated.)


# JTT 18.7.2013

####
####setwd("C:/Users/Jarno Tuimala/Desktop/DEXSeq")
####pvalue<-0.05
####dispersion<-0.1
####

# Loads the library 
library(DEXSeq)

# Reads the phenodata
phenodata <- read.table("phenodata.tsv", header=T, sep="\t")
phenodata$condition<-phenodata$group
pd<-phenodata[,"group", drop=FALSE]
rownames(pd)<-phenodata$sample
colnames(pd)<-"condition"
pd$condition<-factor(pd$condition)

if(any(as.vector(table(phenodata$group))<2)) {
	stop("You need to have replicates for all groups you have specified.")
}

# Path to the gff file
####
####gtf<-"C:/Users/Jarno Tuimala/Desktop/DEXSeq/Homo_sapiens.GRCh37.68.chr.DEXSeq.gtf"
####
gtf <- file.path(chipster.tools.path, "genomes", "gtf", organism)

# Reads the data
d<-read.table("countfile.tsv", header=TRUE, sep="\t")
d2<-d[,grep("chip", colnames(d))]
cn<-substr(colnames(d2), 6, nchar(colnames(d2)))
for(i in 1:ncol(d2)) {
   v<-d2[,i, drop=F]
   rownames(v)<-rownames(d2)
   write.table(v, paste(cn[i], ".jtt", sep=""), col.names=FALSE, row.names=TRUE, sep="\t", quote=FALSE)
}

ecs = read.HTSeqCounts(countfiles = dir(pattern="jtt"), design = pd, flattenedfile = gtf)
sampleNames(ecs)<-phenodata$original_name

# Normalization
ecs<-estimateSizeFactors(ecs)

# Estimate dispersion
####formuladispersion <- count ~ sample + condition * exon
####ecs<-estimateDispersions(ecs, formula = formuladispersion)
####ecs.fdf<-try(fitDispersionFunction(ecs), silent=TRUE)
ecs<-estimateDispersions(ecs)
ecs.fdf<-try(fitDispersionFunction(ecs), silent=TRUE)

if(class(ecs.fdf)=="try-error") {
   fData(ecs)$dispersion <- dispersion 
   doplot<-FALSE
} else {
   ecs<-ecs.fdf
   doplot<-TRUE
}

# Testing for differential exon usage
####formula0<-count ~ sample + condition + exon
####formula1<-count ~ sample + condition * I(exon==exonID) 
ecs <- testForDEU(ecs)
ecs <- estimatelog2FoldChanges(ecs)
res <- DEUresultTable(ecs)

siggenes<-as.character(unique(res$geneID[res$padjust<pvalue]))
res2<-res[as.character(res$geneID) %in% siggenes,]

write.table(res, "dexseq-all-genes.tsv", col.names=TRUE, row.names=TRUE, sep="\t", quote=FALSE)
write.table(res2, "dexseq-genes-with-significant-exons.tsv", col.names=TRUE, row.names=TRUE, sep="\t", quote=FALSE)

# Visualization
if(doplot & nrow(res2)>0) {
   genes<-unique(as.character(res[which(res$padjust<=pvalue),]$geneID))
   pdf("dexseq-exons.pdf", width=297/25.4, height=210/25.4)
   for(i in 1:length(genes)) {
      plottry<-try(plotDEXSeq(ecs, genes[i], displayTranscripts = FALSE, cex.axis = 1.2, cex = 1.3, lwd = 2, legend = TRUE))
      if(class(plottry)=="try-error") {
         plot(x=1, y=1, xlab="", ylab="", axes=F, type="")
         title(main=genes[i])
         text(x=1, y=1, "No results to plot for this gene")
      }
   }
   dev.off()
}

if(nrow(res)>0) {
   pdf("dexseq-MAplot.pdf", width=297/25.4, height=210/25.4)
   plot(x=log2(res[,6]), y=res[,7], xlab="mean of normalized counts (log2)", ylab="log2 fold change", type="n")
   points(x=log2(res[res[,5]>pvalue,6]), y=res[res[,5]>pvalue,7], col="black", pch=16, cex=0.5)
   points(x=log2(res[res[,5]<=pvalue,6]), y=res[res[,5]<=pvalue,7], col="#CC0000", pch=16, cex=0.5)
   dev.off()
}

plotDispEsts = function( cds, ymin, linecol="#ff000080",
  xlab = "mean of normalized counts", ylab = "dispersion",
  log = "xy", cex = 0.45, ... )
{
  px = rowMeans( counts( cds, normalized=TRUE ) )
  sel = (px>0)
  px = px[sel]

  py = fData(cds)$dispBeforeSharing[sel]
  if(missing(ymin))
      ymin = 10^floor(log10(min(py[py>0], na.rm=TRUE))-0.1)

  plot(px, pmax(py, ymin), xlab=xlab, ylab=ylab,
    log=log, pch=ifelse(py<ymin, 6, 16), cex=cex, ... )
  xg = 10^seq( -.5, 5, length.out=100 )
  fun = function(x) { cds@dispFitCoefs[1] + cds@dispFitCoefs[2] / x }
  lines( xg, fun(xg), col=linecol, lwd=4)
}

pdf("dexseq-dispersion-plot.pdf", width=297/25.4, height=210/25.4)
plotDispEsts(ecs)
dev.off()

# TOOL bedtools-genomecoveragebed.R: "Genome coverage BED" (Compute the coverage of a feature file among a genome. This tool is based on the BEDTools package.)
# INPUT file.a: "Input file" TYPE GENERIC
# INPUT file.b: "Genome file" TYPE GENERIC
# OUTPUT genomecoveragebed.txt 
# PARAMETER ibam: "Input file is BAM format" TYPE [yes, no] DEFAULT no (The input file is in BAM format. Note: BAM must be sorted by position.)
# PARAMETER output: "Output type" TYPE [histogram, depth, BedGraph, BedGraph-all] DEFAULT histogram (Set the output type. Depth = the depth at each genome position. BedGraph = depth in BedGraph format. BedGraph-all = BedGraph format with regions with zero coverage also reported.)
# PARAMETER OPTIONAL split: "Treat split BAM or BED12 entries as distinct BED intervals" TYPE [yes, no] DEFAULT no (Treat split BAM or BED12 entries as distinct BED intervals when computing coverage. For BAM files, this uses the CIGAR N and D operations to infer the blocks for computing coverage. For BED12 files, this uses the BlockCount, BlockStarts, and BlockEnds fields (i.e., columns 10,11,12\).)
# PARAMETER OPTIONAL strand: "Calculate coverage from specific strand" TYPE [both, +, -] DEFAULT both (Calculate coverage of intervals from a specific strand. With BED files, requires at least 6 columns (strand is column 6\).)
# PARAMETER OPTIONAL max: "Combine positions by depth" TYPE [yes, no] DEFAULT no (Combine all positions with a depth >= max depth into a single bin in the histogram. Option is relevant only for histogram output.)
# PARAMETER OPTIONAL maxdepth: "Max depth" TYPE INTEGER DEFAULT 1 ()

# AMS 23.4.2012

# binary
binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "genomeCoverageBed"))

# optional options
options <- paste("")
if (output == "depth") {options <- paste(options, "-d")}
if (output == "BedGraph") {options <- paste(options, "-bg")}
if (output == "BedGraph-all") {options <- paste(options, "-bga")}
if (split == "yes") {options <- paste(options, "-split")}
if (strand == "+") {options <- paste(options, "-strand +")}
if (strand == "-") {options <- paste(options, "-strand -")}
if (max == "yes" && output == "histogram"){options <- paste(options, "-max", maxdepth)}

# input files
if (ibam == "yes") {options <- paste(options, "-ibam file.a -g file.b")}
if (ibam == "no") {options <- paste(options, "-i file.a -g file.b")}

# command
command <- paste(binary, options, " > genomecoveragebed.txt")

# run
system(command)
if (file.info("genomecoveragebed.txt")$size == 0) {system("echo \"No results found\" > genomecoveragebed.txt")}

# TOOL plot-corrgram.R: Correlogram (Plots the correlations between samples in a graph.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT corrgram.pdf: corrgram.pdf 
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Correlogram
# JTT 18.10.2007

# Parameter settings (default) for testing purposes
#image.width<-c(600)
#image.height<-c(600)

# Renaming variables
w<-image.width
h<-image.height

# Loads libraries
library(corrgram)

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Loads phenodata
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")

# Generating new labels
colnames(dat2)<-gsub(" ", "", phenodata$description)

# Plotting
pdf(file="corrgram.pdf", width=w/72, height=h/72)
corrgram(x=dat2, lower.panel=panel.shade, upper.panel=panel.pts, pch=".")
dev.off()

# TOOL norm-illumina-lumi.R: "Illumina - lumi pipeline" (Illumina normalization using BeadSummaryData files, and using lumi methodology. If you have a BeadSummaryData that reports the probe identifiers as Array_Address_Id, for example 4900685, instead of Probe_Id, for example ILMN_2607609, change the setting for the parameter probe.identifier. Please note that processing the data with Array_Address_Id is slow and the normalization therefore takes a bit longer time than with the Probe_IDs. TO USE THIS TOOL, YOU NEED TO IMPORT THE BeadSummaryData FILE DIRECTLY, NOT USING THE IMPORT TOOL.)
# INPUT chip.tsv: chip.tsv TYPE GENERIC 
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# PARAMETER probe.identifier: probe.identifier TYPE [Probe_ID: Probe_ID, Array_Address_ID: Array_Address_ID] DEFAULT Probe_ID (What type of identifiers you do have)
# PARAMETER transformation: transformation TYPE [none: none, vst: vst, log2: log2] DEFAULT log2 (How to transform the data)
# PARAMETER background.correction: background.correction TYPE [none: none, bgAdjust.affy: bgAdjust.affy] DEFAULT none (Should background adjustment be applied)
# PARAMETER normalize.chips: normalize.chips TYPE [none: none, rsn: rsn, loess: loess, quantile: quantile, vsn: vsn] DEFAULT quantile (Between arrays normalization method)
# PARAMETER chiptype: chiptype TYPE [empty: empty, Human: Human, Mouse: Mouse, Rat: Rat] DEFAULT empty ()

# Illumina data preprocessing and normalization for BeadSummaryData that
# uses Array_Address_Id instead of Probe_Id 
#
# MG, 5.11.2010

# probe.identifier<-"Probe_ID"
# transformation<-"log2"
# background.correction<-"none"
# normalize.chips<-"none"
# chiptype<-"Rat"

# Loading libraries
library(lumi)

# Converting to the correct chiptype
if(chiptype=="empty") {
	chiptype<-c("Illumina")
	mapping<-c("Illumina")
}
if(chiptype=="Human") {
	chiptype<-c("lumiHumanAll")
	mapping<-c("lumiHumanIDMapping")
}
if(chiptype=="Mouse") {
	chiptype<-c("lumiMouseAll")
	mapping<-c("lumiMouseIDMapping")
}
if(chiptype=="Rat") {
	chiptype<-c("lumiRatAll")
	mapping<-c("lumiRatIDMapping")
}
chiptype<-paste(chiptype, ".db", sep="")

# Loading data files
# fileName <-dir()
# fileName<-fileName[fileName!="phenodata.tsv"]
x.lumi <- lumiR("chip.tsv", lib.mapping=mapping)

# Correct for the problems with Array_Address_IDs
if(probe.identifier=="Array_Address_ID") {

`getChipInfo` <-
		function(x, lib.mapping=NULL, species=c('Human', 'Mouse', 'Rat', 'Unknown'), chipVersion=NULL, idMapping=FALSE, returnAllMatches=FALSE, verbose=TRUE) {
	
	## Function to make sure the output mapping matches the inputID.bak
	matchInputID <- function(mapping, inputID.bak) {
		## We assume mapping IDs are a subset of the names of inputID.bak
		nc <- ncol(mapping)
		if (is.null(nc)) {
			len <- length(mapping)
			if (len == length(inputID.bak)) return(mapping)
			mapping.new <- rep(NA, length(inputID.bak))
			names(mapping.new) <- inputID.bak
			mappingID <- names(mapping)
			mapping.new[mappingID] <- mapping
			type <- 'vector'
		} else {
			nr <- nrow(mapping)
			if (nr == length(inputID.bak)) return(mapping)
			mapping.new <- matrix(NA, nrow=length(inputID.bak), ncol=nc)
			rownames(mapping.new) <- inputID.bak
			colnames(mapping.new) <- colnames(mapping)
			mappingID <- rownames(mapping)
			mapping.new[mappingID,] <- mapping[mappingID,]
			type <- 'matrix'
		}
		selID <- inputID.bak[inputID.bak %in% mappingID]
		dupInd <- which(duplicated(selID))
		if (length(dupInd) > 0) {
			dupID <- unique(selID[dupInd])
			for (dupId.i in dupID) {
				ind.i <- which(inputID.bak == dupId.i)
				if (type == 'matrix') {
					mapping.new[ind.i, ] <- mapping[dupId.i, ]
				} else {
					mapping.new[ind.i] <- mapping[dupId.i]					
				}
			}
		}
		return(mapping.new)
	}
	
	
	if (is(x, 'ExpressionSet')) {
		inputID <- featureNames(x)
	} else if (is(x, 'matrix') || is(x, 'data.frame')) {
		inputID <- rownames(x)		
	} else {
		inputID <- as.character(x)
	}
	inputID.bak <- inputID
	inputID <- unique(inputID)
	species <- match.arg(species)
	if (species == 'Unknown' && is.null(lib.mapping)) {
		human.match <- getChipInfo(inputID, species='Human', idMapping=idMapping, returnAllMatches=returnAllMatches, verbose=FALSE)
		mouse.match <- getChipInfo(inputID, species='Mouse', idMapping=idMapping, returnAllMatches=returnAllMatches, verbose=FALSE)
		rat.match <- getChipInfo(inputID, species='Rat', idMapping=idMapping, returnAllMatches=returnAllMatches, verbose=FALSE)
		bestChip <- which.max(c(length(human.match$matchedProbeNumber), length(mouse.match$matchedProbeNumber), length(rat.match$matchedProbeNumber)))
		best.match <- switch(bestChip, human.match, mouse.match, rat.match)
		return(best.match)
	} else {
		if (is.null(lib.mapping)) {
			lib.mapping <- switch(species,
					'Rat'='lumiRatIDMapping',
					'Human'='lumiHumanIDMapping',
					'Mouse'='lumiMouseIDMapping')			
		}		
		if(!require(lib.mapping, character=TRUE)) stop(paste(lib.mapping, 'is required!'))
		# dbconn <- sub("\\.db", "_dbconn", lib.mapping)
		dbconn <- paste(lib.mapping, "_dbconn", sep="")
		conn <- do.call(dbconn, list())
		
		metaInfo <- dbReadTable(conn, 'metadata')
		species <- metaInfo$value[metaInfo[,'name'] == "SPECIES"]
		
		allTableNames <- dbListTables(conn)
		allTableNames <- allTableNames[!(allTableNames %in% c('nuID_MappingInfo', 'metadata'))]
		if (!is.null(chipVersion)) {
			if (chipVersion %in% allTableNames) {
				allTableNames <- chipVersion
			} else {
				warning('The provided chipVersion does not exist in the library!\n')
			}
		}
		lenID <- length(inputID)
		if (lenID == 0 && !is.null(chipVersion)) {
			## return the entire table based on chipVersion
			mapping <- dbReadTable(conn, chipVersion)
			returnList <- list(chipVersion=chipVersion, species=species, IDType=NA, chipProbeNumber=nrow(mapping), 
					inputProbeNumber=0, matchedProbeNumber=NA)
		} else {
			matchLen <- NULL
			matchField <- NULL
			tableLen <- NULL
			cut0.probeId <- FALSE  # determine whether to cut the 0s in front of the ProbeId. E.g. 0004760445 --> 4760445
			for (i in seq(allTableNames)) {
				tableName.i <- allTableNames[i]
				table.i <- dbReadTable(conn, tableName.i)
				fieldNames.i <- names(table.i)
				## Not include the Symbol column during matching the IDs.
				fieldNames.i <- fieldNames.i[!(fieldNames.i %in% c('Symbol'))]
				len.i <- NULL
				for (fieldNames.ij in fieldNames.i) {
					field.ij <- as.character(table.i[,fieldNames.ij])
					len.ij <- length(which(inputID %in% field.ij))
					if (fieldNames.ij %in% c('ProbeId', 'Array_Address_Id')) {
						len.ij.2 <- length(which(inputID %in% as.character(as.integer(field.ij))))
						if (len.ij.2 > len.ij) {
							cut0.probeId <- TRUE
							len.ij <- len.ij.2
						}
					}
					len.i <- c(len.i, len.ij)
				}
				max.ind.i <- which.max(len.i)
				matchLen <- c(matchLen, len.i[max.ind.i])
				matchField <- c(matchField, fieldNames.i[max.ind.i])
				tableLen <- c(tableLen, nrow(table.i))
			}
			bestMatchLen <- max(matchLen)
			if (bestMatchLen == 0) {
				if (verbose) warning('No matches were found!\n')
				return(c(list(chipVersion=NULL, species=species, IDType=NULL, chipProbeNumber=NULL, 
										matchedProbeNumber=bestMatchLen), idMapping=NULL))
			} else if (bestMatchLen < lenID && verbose) {
				warning('Some input IDs can not be matched!\n')
			}			
			
			if (!returnAllMatches) {
				bestInd <- which(matchLen == bestMatchLen)
				if (length(bestInd) > 1) {
					bestInd <- bestInd[tableLen[bestInd] == min(tableLen[bestInd])]
				}
				matchLen.match <- bestMatchLen
				tableName.match <- allTableNames[bestInd]
				fieldName.match <- matchField[bestInd]
				bestTable <- dbReadTable(conn, tableName.match[1])
				probeNumber <- nrow(bestTable)			
				if (idMapping) {
					## remove duplicated IDs becasue rownames should be unique
					dupInd <- duplicated(bestTable[,fieldName.match[1]])
					bestTable <- bestTable[!dupInd,]
					nuID <- bestTable[,'nuID']
					if (fieldName.match[1] %in% c('ProbeId', 'Array_Address_Id') && cut0.probeId) {
						allID <- as.character(as.integer(bestTable[,fieldName.match[1]]))
					} else {
						allID <- bestTable[,fieldName.match[1]]					
					}
					selInputID <- inputID[inputID %in% allID]
					
					rownames(bestTable) <- allID
					mapping <- as.matrix(bestTable[selInputID, ])
					# if (fieldName.match[1] == 'nuID') {
					# 	bestTable <- bestTable[, names(bestTable) != 'nuID']
					# 	rownames(bestTable) <- nuID
					# 	mapping <- as.matrix(bestTable[selInputID, ])
					# } else {
					# 	names(nuID) <- allID
					# 	mapping <- nuID[selInputID]
					# }
					## match the original input IDs
					mapping <- matchInputID(mapping, inputID.bak)
				}
			} else {
				# if (matchField[which.max(matchLen)] != 'nuID') IDType <- 'nuID'
				matchInd <- which(matchLen > 0)
				tableName.match <- allTableNames[matchInd]
				fieldName.match <- matchField[matchInd]
				matchLen.match <- matchLen[matchInd]
				probeNumber <- NULL
				if (idMapping) mapping <- NULL
				for (i in seq(matchInd)) {
					table.i <- dbReadTable(conn, tableName.match[i])
					if (idMapping) {
						## remove duplicated IDs becasue rownames should be unique
						dupInd.i <- duplicated(table.i[,fieldName.match[i]])
						table.i <- table.i[!dupInd.i,]
						nuID.i <- table.i[,'nuID']
						if (fieldName.match[1] %in% c('ProbeId', 'Array_Address_Id') && cut0.probeId) {
							allID.i <- as.character(as.integer(table.i[,fieldName.match[i]]))
						} else {
							allID.i <- table.i[,fieldName.match[i]]				
						}
						selInputID.i <- inputID[inputID %in% allID.i]
						if (fieldName.match[which.max(matchLen.match)] == 'nuID') {
							table.i <- table.i[, names(table.i) != 'nuID']
							rownames(table.i) <- nuID.i
							mapping.i <- as.matrix(table.i[selInputID.i, ])
							mapping.i <- matchInputID(mapping.i, inputID.bak)
							mapping <- c(mapping, list(mapping.i))
						} else {
							names(nuID.i) <- allID.i
							mapping.i <- nuID[selInputID.i]
							mapping.i <- matchInputID(mapping.i, inputID.bak)
							mapping <- cbind(mapping, mapping.i)
						}
					}
					probeNumber <- c(probeNumber, nrow(table.i))
				}
				rank1 <- rank(matchLen.match)
				rank2 <- rank(-probeNumber)
				ord <- order(rank1 + rank2/length(matchInd), decreasing=TRUE)
				tableName.match <- tableName.match[ord]
				fieldName.match <- fieldName.match[ord]
				probeNumber <- probeNumber[ord]
				matchLen.match <- matchLen.match[ord]
				if (idMapping) {
					if (is(mapping, 'list')) {
						mapping <- mapping[ord]
						names(mapping) <- tableName.match	
					} else if (is(mapping, 'matrix')) {
						rownames(mapping) <- inputID
						mapping <- mapping[,ord]
						colnames(mapping) <- tableName.match		
					}
				}
			}
			returnList <- list(chipVersion=tableName.match, species=species, IDType=fieldName.match, chipProbeNumber=probeNumber, 
					inputProbeNumber=length(inputID), matchedProbeNumber=matchLen.match)
		}
		if (idMapping)  returnList <- c(returnList, list(idMapping=mapping))		
		
		return(returnList)
	}
}

`addNuID2lumi` <-
		function(x.lumi, annotationFile=NULL, sep=NULL, lib.mapping=NULL, annotationColName=c(sequence='Probe_Sequence', target='ILMN_Gene', probe='Probe_Id'), verbose=TRUE) {
	
	history.submitted <- as.character(Sys.time())
	
	## check whether the object is nuID annotated.
	exprs <- exprs(x.lumi)
	id <- rownames(exprs)
	if(all(sapply(id[1:50], is.nuID))) {
		if (verbose) cat('The lumiBatch object is already nuID annotated!\n')
		return(x.lumi)
	}
	if (!is.null(lib.mapping)) {
		if (length(grep('lumi.*\\.db', lib.mapping)) == 0 && length(grep('lumi.*IDMapping', lib.mapping)) == 0) {
			warning(paste(lib.mapping, 'does not include nuID conversion information!\n'))
			lib.mapping <- NULL
		}
	}
	
	newId <- id
	
	## ---------------------------------------
	## First check whether probe sequence information is available 
	annotation <- pData(featureData(x.lumi))
	names(annotation) <- toupper(names(annotation))
	if (toupper(annotationColName['sequence']) %in% names(annotation)) {
		sequence <- annotation[, toupper(annotationColName['sequence'])]
		cat('Directly converting probe sequence to nuIDs ...\n')
		newId <- sapply(sequence, seq2id)
		names(newId) <- id				
	} else if (!is.null(annotationFile)) {
		## identify the Metadata lines 
		info <- readLines(annotationFile, n=10)    # take the first 10 lines to have a taste
		
		## Use annotationColName[1] as an indicator of Where the metaData stops
		##   intelligently find nMetaDataLines  
		nMetaDataLines <- grep(annotationColName[1], info, ignore.case=TRUE) - 1
		
		if (is.null(sep)) {
			## Find out the separator (sep) by taking the first two line of data, and comparing them.
			##  we assume it is either "," or "\t".
			titleLine <- info[nMetaDataLines + 1]
			sepNum <- regexpr('\t', titleLine)
			if (sepNum >= 2) {
				sep <- '\t'
			} else {
				sepNum <- regexpr(',', titleLine)
				if (sepNum >= 2) {
					sep <- ','
				} else {
					stop('The seperator is not Tab or comma!\n Please sepecify the seperator used in the file!\n')
				}
			}
		}
		
		dataLine1 <- strsplit(info[nMetaDataLines + 2], sep)[[1]]
		quoteCount1 <- gregexpr('"', dataLine1[1])[[1]]
		quoteCount2 <- gregexpr('\'', dataLine1[1])[[1]]
		quote <- ''
		if (sep == ',') quote <- '"'
		if (length(quoteCount1) == 2) {
			quote <- '"'
		} else if (length(quoteCount2) == 2) {
			quote <- '\''
		}
		
		## Read in annotation data
		annotation <- read.table(annotationFile, sep=sep, colClasses="character", header=TRUE, skip=nMetaDataLines,
				blank.lines.skip=TRUE, row.names=NULL, check.names=FALSE, quote=quote, comment.char="", strip.white=TRUE, fill=TRUE)
		
		allColName <- toupper(colnames(annotation))
		colnames(annotation) <- allColName
		## Create unique Id based on 50mer sequence
		if (toupper(annotationColName['sequence']) %in% allColName) {
			nuID <- sapply(annotation[, toupper(annotationColName['sequence'])], seq2id)			
		} else {
			stop('The "sequence" column cannot be found!\nPlease check the "annotationColName" of "sequence"!\n')
		}
		## check the TargetID first
		comm_target <- NULL
		if (toupper(annotationColName['target']) %in% allColName) {
			ann_target <- annotation[, toupper(annotationColName['target'])]
			comm_target <- id[id %in% ann_target]
		}
		if (length(comm_target) == 0) {
			## check the ProbeID if id does not match the TargetID
			if (toupper(annotationColName['probe']) %in% allColName) {
				ann_target <- annotation[, toupper(annotationColName['probe'])]
				comm_target <- id[id %in% ann_target]
				if (length(comm_target) == 0) {
					width <- nchar(ann_target[1])
					id <- formatC(as.numeric(id), width=width, flag='0', format='d')
					comm_target <- id[id %in% ann_target]
					if (length(comm_target) == 0) stop('The annotation file does not match the data!\n')
				}
			}
		} 
		if (length(comm_target) < length(id)) {
			diffId.len <- length(id) - length(comm_target)
			warning(paste('The annotation file does not match the data.',  diffId.len, 'ids cannot be replaced!\n'))
		}
		names(nuID) <- ann_target
		
		newId <- id
		newId[id %in% ann_target] <- nuID[comm_target]
	} else if (!is.null(lib.mapping)) {
		if (!require(lib.mapping, character.only=TRUE)) stop(paste('Annotation library', lib.mapping, 'is not installed!\n'))
		controlId <- c('lysA','pheA','thrB','trpF', 'bla1','bla2','cat1','cat2','cre1','cre2','e1a1',
				'e1a2','gfp1','gfp2','gst1','gst2','gus1','gus2','lux1','lux2','lysA','neo1',
				'neo2','pheA','thrB','trpF')
		if (length(grep('IDMapping', lib.mapping)) == 0) {
			## check the TargetID first
			newId <- mget(id, get(paste(lib.mapping, 'TARGETID2NUID', sep=''), mode='environment'), ifnotfound=NA)
			newId <- unlist(newId)
			if (length(which(!is.na(newId))) == 0) {
				usingTargetID <- FALSE
				## check the ProbeID if id does not match the TargetID
				newId <- mget(id, get(paste(lib.mapping, 'PROBEID2NUID', sep=''), mode='environment'), ifnotfound=NA)
				if (length(which(!is.na(newId))) == 0) {
					width <- nchar(ls(envir=get(paste(lib.mapping, 'PROBEID2NUID', sep=''), mode='environment'))[1])
					id <- formatC(as.numeric(id), width=width, flag='0', format='d')
					newId <- mget(id, get(paste(lib.mapping, 'PROBEID2NUID', sep=''), mode='environment'), ifnotfound=NA)
					if (length(which(!is.na(newId))) == 0) {
						targetID <- pData(featureData(x.lumi))$TargetID
						newId <- mget(targetID, get(paste(lib.mapping, 'TARGETID2NUID', sep=''), mode='environment'), ifnotfound=NA)
						if (length(which(!is.na(newId))) == 0) stop('The library does not match the data!\n')
					}
				} 
			} else {
				usingTargetID <- TRUE
			}
			## Check for the targetIDs cannot be found in the lib.mapping.
			## Some known control genes will not be checked.
			naInd <- which(is.na(newId))
			if (!usingTargetID) {
				TargetID <- featureData(x.lumi)$TargetID
				if (is.null(TargetID)) {
					if (!all(TargetID[naInd] %in% controlId)) {
						if (length(naInd) < 10) {
							warning(paste('Identifiers:', paste(TargetID[naInd], collapse=','), ' cannot be found in the ', lib.mapping, '!\n', sep=''))
						} else {
							warning(paste('Some identifiers cannot be found in the ', lib.mapping, '!\n', sep=''))
						}
					}
				}
			} else if (!all(id[naInd] %in% controlId)) {
				if (length(naInd) < 10) {
					warning(paste('Identifiers:', paste(id[naInd], collapse=','), ' cannot be found in the ', lib.mapping, '!\n', sep=''))
				} else {
					warning(paste('Some identifiers cannot be found in the ', lib.mapping, '!\n', sep=''))
				}
			}
			newId[naInd] <- id[naInd]
		} else {
			chipInfo <- getChipInfo(featureNames(x.lumi), lib.mapping=lib.mapping, idMapping=TRUE, verbose=FALSE)
			newId <- chipInfo$idMapping[,'nuID']
			naInd <- which(is.na(newId))
			if (length(naInd) > 0) {
				newId[naInd] <- id[naInd]
				if (!all(id[naInd] %in% controlId))	{
					if (length(naInd) > 500) {
						warning(paste('More than 500 identifiers cannot be found in the library:', lib.mapping, 
										'!\n The provided library might be wrong or outdated!\n', sep=''))
					} else if (length(naInd) < 10) {
						warning(paste('Identifiers:', paste(id[naInd], collapse=','), ' cannot be found in the ', lib.mapping, '!\n', sep=''))
					} else {
						warning(paste('Some identifiers cannot be found in the ', lib.mapping, '!\n', sep=''))
					}
				}
			}
			selInfoName <- names(chipInfo)
			selInfoName <- selInfoName[selInfoName != 'idMapping']
			chipInfo.print <- paste(selInfoName, unlist(chipInfo[selInfoName]), sep=': ')
			notes(x.lumi) <- c(notes(x.lumi), list('Chip Information'=chipInfo.print))
			
			annotation(x.lumi) <- switch(chipInfo$species,
					'Human'='lumiHumanAll.db',
					'Mouse'='lumiMouseAll.db',
					'Rat'='lumiRatAll.db')
		}
	} else {
		cat('Please provide the annotation file or lumi annotation library!\n')
	}
	if (all(newId == id)) {
		conversion <- FALSE
	} else {
		conversion <- TRUE
	}
	
	if (any(duplicated(newId)))  {
		if (verbose) cat('Duplicated IDs found and were merged!\n')
		dupId <- unique(newId[duplicated(newId)])
		## determine whether the detection p-value close to 0 or 1 is significant
		if (!is.null(detection(x.lumi))) {
			detect.low <- exprs[which.max(detection(x.lumi)[,1]), 1]
			detect.high <- exprs[which.min(detection(x.lumi)[,1]), 1]
		}
		
		rmIndex <- NULL
		for (dupId.i in dupId) {
			dupIndex <- which(newId == dupId.i)
			ave.exp <- colMeans(exprs(x.lumi)[dupIndex,, drop=FALSE])
			exprs(x.lumi)[dupIndex[1],] <- ave.exp
			if (is(x.lumi, 'LumiBatch') && !is.null(beadNum(x.lumi)) && !is.null(detection(x.lumi))) {
				totalBeadNum <- colSums(beadNum(x.lumi)[dupIndex, , drop=FALSE])
				if (detect.low < detect.high) {
					maxDetection <- apply(detection(x.lumi), 2, min)
				} else {
					maxDetection <- apply(detection(x.lumi), 2, max)
				}
				
				temp <- colSums(se.exprs(x.lumi)[dupIndex, , drop=FALSE]^2 * (beadNum(x.lumi)[dupIndex,, drop=FALSE] - 1))
				temp <- temp / (totalBeadNum - length(dupIndex))
				se.exprs(x.lumi)[dupIndex[1],] <- sqrt(temp * (colSums(1/beadNum(x.lumi)[dupIndex,, drop=FALSE])))
				detection(x.lumi)[dupIndex[1],] <- maxDetection
				beadNum(x.lumi)[dupIndex[1],] <- totalBeadNum
			}
			rmIndex <- c(rmIndex, dupIndex[-1])
		}
		## remove duplicated
		x.lumi <- x.lumi[-rmIndex, ]
		newId <- newId[-rmIndex]
	}
	
	## update the feature names (probe ids)
	if (conversion) {
		names(newId) <- NULL
		featureNames(x.lumi) <- newId
		## update the feautre data
		featureData <- featureData(x.lumi)
		rownames(pData(featureData)) <- newId
		if (!is.null(pData(featureData)$'PROBE_SEQUENCE')) pData(featureData)$'PROBE_SEQUENCE' <- NULL
		featureData(x.lumi) <- featureData
		
		## Add history tracking
		if (is(x.lumi, 'LumiBatch')) {
			history.finished <- as.character(Sys.time())
			history.command <- capture.output(print(match.call(addNuID2lumi)))
			if (is.null(x.lumi@history$lumiVersion)) x.lumi@history$lumiVersion <- rep(NA, nrow(x.lumi@history))
			lumiVersion <- packageDescription('lumi')$Version
			x.lumi@history<- rbind(x.lumi@history, data.frame(submitted=history.submitted, 
							finished=history.finished, command=history.command, lumiVersion=lumiVersion))
		}
	}
	
	return(x.lumi)
}

`addNuId2lumi` <-
		function(x.lumi, annotationFile=NULL, sep=NULL, lib.mapping=NULL, annotationColName=c(sequence='Probe_Sequence', target='Target', probe='Probe_Id'), verbose=TRUE) {
	cat('Function addNuId2lumi is deprecated!\n Please use addNuID2lumi instead!\n')
	addNuID2lumi(x.lumi, annotationFile, sep, lib.mapping, annotationColName, verbose)
}

x.lumi<-addNuID2lumi(x.lumi, lib.mapping=mapping)
}


# Quality control (not run)
# QC
# q.lumi <- lumiQ(x.lumi)  

# Background correction
if(background.correction=="bgAdjust.affy") {
   x.lumi<-lumiB(x.lumi, method="bgAdjust.affy")
}

# Transformation
if(transformation=="none") {
   t.lumi<-x.lumi
}
if(transformation=="vst") {
   t.lumi<-lumiT(x.lumi, method=c("vst"))
}
if(transformation=="log2") {
   t.lumi<-lumiT(x.lumi, method=c("log2"))
}

# Normalization
if(normalize.chips=="none") {
   n.lumi<-t.lumi
}
if(normalize.chips=="rsn") {
   n.lumi<-lumiN(t.lumi, method=c("rsn"))
}
if(normalize.chips=="loess") {
   n.lumi<-lumiN(t.lumi, method=c("loess"))
}
if(normalize.chips=="quantile") {
   n.lumi<-lumiN(t.lumi, method=c("quantile"))
}
if(normalize.chips=="vsn") {
   n.lumi<-lumiN(t.lumi, method=c("vsn"))
}

# Convert sample names to Chipster style
dat2<-exprs(n.lumi)
sample.names<-colnames(dat2)
sample.names<-paste("chip.", sample.names, sep="")
names(dat2)<-sample.names
colnames(dat2)<-sample.names

# Write out a phenodata
group<-c(rep("", ncol(dat2)))
training<-c(rep("", ncol(dat2)))
write.table(data.frame(sample=sample.names, chiptype=chiptype, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

if(chiptype!="Illumina") {
   # Including gene names to data
   library(chiptype, character.only=T)
   library(annotate)
   # Write out expression data
	symbols <- unlist (lookUp(rownames(dat2), chiptype, what="SYMBOL"))
	genenames <- unlist (lookUp(rownames(dat2), chiptype, what="GENENAME"))
	symbols <- gsub("#", "", symbols)
	genenames <- gsub("#", "", genenames)
	symbols <- gsub("'", "", symbols)
	genenames <- gsub("'", "", genenames)
	write.table(data.frame(symbol=symbols, description=genenames, dat2), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
} else {
   # Write out expression data
   write.table(data.frame(dat2), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
}

# TOOL fastx-renamer.R: "Rename reads" (Renames read identifiers in a FASTQ file. The original names can be replaced by a running number or by the sequence itself. This tool is based on the Renamer tool of the FASTX package.) 
# INPUT reads.fastq TYPE GENERIC 
# OUTPUT renamed-reads.fastq
# PARAMETER rename.type: "Rename read identifiers to" TYPE [COUNT: "Running number", SEQ: "Sequence itself"] DEFAULT COUNT (Should the reads be named with running number or the sequence itself.)
# PARAMETER quality.format: "Quality value format used" TYPE [sanger: Sanger, illuminaold: "Illumina GA v1.3-1.5"] DEFAULT sanger (What quality encoding is used in your FASTQ file. Select Sanger if your data comes from Illumina 1.8 or later, SOLiD or 454.)


# EK 24.10.2011

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads.fastq")

# binary
binary <- c(file.path(chipster.tools.path, "fastx", "bin", "fastx_renamer"))

# command
quality.scale <- ifelse(quality.format == "sanger", "-Q 33", "")
command <- paste(binary, "-n", rename.type, quality.scale, "-i reads.fastq -o renamed-reads.fastq")

# run
system(command)

# TOOL stat-proportions.R: "Test proportions" (Tests for comparing proportions in dichotomized data.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT prop-test.tsv: prop-test.tsv 
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to test)
# PARAMETER p.value.adjustment.method: p.value.adjustment.method TYPE [none: none, Bonferroni: Bonferroni, Holm: Holm, Hochberg: Hochberg, BH: BH, BY: BY, Storey-Q: Storey-Q] DEFAULT BH (Multiple testing correction method)
# PARAMETER p.value.threshold: p.value.threshold TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (P-value cut-off for significant results)

# MG, 29.9.2011

# Optional parameter
# PARAMETER test [Fisher, Chisquare, hypergeometric] DEFAULT Chisquare (Test type)

# Loads the libraries
library(multtest)
library(qvalue)

# Loads the normalized data
file <- c("normalized.tsv")
dat <- read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls <- dat[,grep("flag", names(dat))]
dat_2 <- dat[,grep("chip", names(dat))]

# Test needs a parameter "groups" that specifies the grouping of the samples
phenodata <- read.table("phenodata.tsv", header=T, sep="\t")
groups <- phenodata[,pmatch(column,colnames(phenodata))]
group_levels <- (unique(groups))

# Sanity checks
num_groups <- length(unique(groups))
if(num_groups<=1) {
	stop("CHIPSTER NOTE: You need to have at least two groups to run this analysis")
}

# Calculate number of 0 and 1 occurrencies for each group of samples
dat_0 <- matrix(nrow=nrow(dat_2), ncol=length(group_levels), NA)
dat_1 <- matrix(nrow=nrow(dat_2), ncol=length(group_levels), NA)
for(group_count in 1:length(group_levels)) {
	dat_0[,group_count] <- rowSums(data.frame(dat_2[,which(groups==group_levels[group_count])]))
	dat_1[,group_count] <- ncol(dat_2)-dat_0[,group_count] 
}

# Perform test of equal proportions per row of data
results <- matrix (nrow=nrow(dat_2), ncol=2)
for (row_number in 1:nrow(dat_2)) {
	counts_table <- matrix(nrow=length(group_levels),ncol=2,data=c(dat_0[row_number,],dat_1[row_number,]), byrow=FALSE)
	results[row_number,1] <- prop.test(counts_table)$statistic
	results[row_number,2] <- prop.test(counts_table)$p.value
}

# If NAN result replace with statistic 0 and p-value 1
results[is.nan(results[,1]),1] <- 0
results[is.nan(results[,2]),2] <- 1

# Extract raw p-values
raw_p <- results[,2]

# Perform multiple testing correction
if (p.value.adjustment.method != "none") {
	if (p.value.adjustment.method == "Storey-Q") {
		adj_p <- qvalue(raw_p)
		adj_p2 <- adj_p$qvalues
	} else {
		adj_p <- mt.rawp2adjp(raw_p, proc=as.character(p.value.adjustment.method))
		adj_p2 <- adj_p$adjp[order(adj_p$index),][,2]
	}
	adj_p2df <- as.data.frame(adj_p2)
	results <- cbind(results, adj_p2df)
	colnames(results) <- c("chi_square","p_value", "adjusted_p_value")
} else {
	colnames(results) <- c("chi_square","p_value")
}

# Extract only significant results
dat_out <- data.frame(dat,results)
if (p.value.adjustment.method != "none") {
	dat_out <- dat_out[dat_out$adjusted_p_value <= p.value.threshold,]   
} else {
	dat_out <- dat_out[dat_out$p_value <= p.value.threshold,]   
}

# Writing out data
write.table(dat_out, file="prop-test.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL delete-columns.R: "Delete columns" (Delete the specified column or columns from the data.)
# INPUT normalized.tsv TYPE GENE_EXPRS
# OUTPUT deleted.tsv
# PARAMETER column1 TYPE COLUMN_SEL DEFAULT EMPTY (Data column to filter by)
# PARAMETER column2 TYPE COLUMN_SEL DEFAULT EMPTY (Data column to filter by)
# PARAMETER deletion.type TYPE [to-right, between] DEFAULT to-right (Delete columns to the right from column1 or between the specified columns)


# Deletes columns from data
# JTT 10.6.2008

# Parameter settings (default) for testing purposes
#column1<-c("chip.microarray017.cel")
#column2<-c("EMPTY")
#deletion.type<-c("to-right")

# Sanity checks
if(column1=="EMPTY" & column2=="EMPTY") {
	stop("You need to select at least one column!")
}
if((column1=="EMPTY" & deletion.type=="between") | (column2=="EMPTY" & deletion.type=="between")) {
	stop("Check the settings! Can't delete all column in between two columns, when only one column has been selected.")
}

# Loads the data
file<-c("normalized.tsv")
dat<-read.table(file, sep="\t", header=T, row.names=1)

# Filtering
if(column1!="EMPTY" & deletion.type=="to-right") {
	dat2<-dat[,1:(which(names(dat)==column1)-1)]
}

if(column2!="EMPTY" & deletion.type=="to-right") {
	dat2<-dat[,1:(which(names(dat)==column2)-1)]
}

if(column1!="EMPTY" & column2!="EMPTY" & deletion.type=="between") {
	dat2<-dat[,-(min(which(names(dat)==column1), which(names(dat)==column2)):max(which(names(dat)==column1), which(names(dat)==column2)))]
}

# Writes out the combined table
write.table(dat2, "deleted.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL na-omitted.R: "Remove missing values" (Removal of missing values. All observations, i.e., genes that have at least one missing value are excluded from the data set.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT na-omitted.tsv: na-omitted.tsv 


# Removal of missing values
# JTT 22.6.2006

# Loads the file
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Removes missing values
dat<-na.omit(dat)

# Writes a table 
write.table(dat, file=("na-omitted.tsv"), sep="\t", row.names=T, col.names=T, quote=F)

# TOOL stat-adjust-pvalues.R: "Adjust p-values" (Adjusts raw p-values in the selected column for multiple testing using a specified method.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT adjusted-p-values.tsv: adjusted-p-values.tsv 
# PARAMETER column: column TYPE COLUMN_SEL DEFAULT EMPTY (Data file column containing the p-values to adjust)
# PARAMETER p.value.adjustment.method: p.value.adjustment.method TYPE [Bonferroni: Bonferroni, Holm: Holm, Hochberg: Hochberg, BH: BH, BY: BY, Storey-Q: Storey-Q] DEFAULT BH (Multiple testing correction method)


# P-value adjustment
# JTT 12.12.2008

# Parameter settings (default) for testing purposes
#column<-c("p.adjusted")
#p.value.adjustment.method<-c("BH")

# Loads the libraries
library(multtest)
library(qvalue)

# Renaming variables
adj.method<-p.value.adjustment.method

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Extracts raw p-values
rawp<-dat[,grep(column, colnames(dat))]

# Correction
if(adj.method=="Storey-Q") {
   adjp<-qvalue(rawp)
   adjp2<-adjp$qvalues
} else {
   adjp<-mt.rawp2adjp(rawp, proc=as.character(adj.method))
   adjp2<-adjp$adjp[order(adjp$index),][,2]
}

# Small manipulations
adjp2df<-as.data.frame(adjp2)
colnames(adjp2df)<-paste(colnames(dat)[grep(column, colnames(dat))], ".", adj.method, sep="")

# Writing out data
write.table(data.frame(dat, adjp2df), file="adjusted-p-values.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL norm-prenormalized-affy.R: "Process prenormalized affy" (If you import prenormalized Affymetrix data that is not in Chipster format, you need to import it through the Import Wizard, and then use this tool for preprocessing it. During data import, make sure to mark every column containing normalized expression values as Sample and the column containing the Affymetrix probe ID:s as Identifier. If you want to be able to use annotation, you need to SPECIFY THE CHIPTYPE, e.g. hgu133a2.db.)
# INPUT microarray{...}.tsv: microarray{...}.tsv TYPE CDNA 
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# PARAMETER chiptype: chiptype TYPE STRING DEFAULT empty ()
# PARAMETER keep.annotations: keep.annotations TYPE [yes: yes, no: no] DEFAULT no (Keep or discard annotation column after preprocessing. Please note that gene symbol information associated with the given chiptype will be replaced by data-specific annotations by setting this parameter to "yes")
# PARAMETER keep.flags: keep.flags TYPE [yes: yes, no: no] DEFAULT no (Keep or discard flag-columns after preprocessing. Please note that flag columns must have been named as "flag")

# Process prenormalized affy
# MG 6.4.2010
# MK 18.2.2013
# EK 23.4.2013 added .tsv ending to expression column names so that sample renaming is possible in interactive visualizations

# Loads the libraries
library(limma)
library(affy)
library(gcrma)

# Reading data
columns<-list(R="sample")
annotation<-c("identifier")
columns.other<-c("flag", "Flag", "FLAG", "annotation", "Annotation", "ANNOTATION")

files<-dir()
files<-files[files!="phenodata.tsv"]
#seems to check columns from the first file only. If the column is not there, attribute is ignored. If the column is there, but not
#in the others, function crashes
dat<-read.maimages(files=files, columns=columns, annotation=annotation, other.columns=columns.other) 
	
#dat <- read.table(file="normalized.tsvt", header=TRUE, sep="\t")

# Extract annotations
annotation.info <- NULL;
if (keep.annotations=="yes") {
	if(length(grep("^annotation$", unlist(attributes(dat$other)), ignore.case=T))) {
		annotation.col <- unlist(attributes(dat$other))[grep("^annotation$", unlist(attributes(dat$other)), ignore.case=T)]
		annotation.info	<- dat$other[[annotation.col]];
		annotation.info <- as.character(annotation.info[,1]);
	}
}

flag.info <- NULL;
if (keep.flags=="yes") {
	if(length(grep("^flag$", unlist(attributes(dat$other)), ignore.case=T))) {
		flag.col 			<- unlist(attributes(dat$other))[grep("^flag$", unlist(attributes(dat$other)), ignore.case=T)]
		flag.info 			<- dat$other$flag;
		colnames(flag.info)	<-paste("flag.", colnames(flag.info), sep="")
	}
}

# Mock normalization
dat2<-normalizeBetweenArrays(dat$E, method="none")
sample<-colnames(dat2)
colnames(dat2)<-paste("chip.", colnames(dat2), sep="")

# Writes out a phenodata table
# sample<-paste(sample, ".tsv", sep="")
group<-c(rep("", length(sample)))
training<-c(rep("", length(sample)))
time<-c(rep("", length(sample)))
random<-c(rep("", length(sample)))
if(chiptype=="empty") {
	chiptype<-"Affy"
}
write.table(data.frame(sample=sample, chiptype=chiptype, group=group, description=sample), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# Writing out data
a<-try(library(chiptype, character.only=T))
if(class(a)=="try-error") { a<-try(library(paste(chiptype, ".db", sep=""), character.only=T)) }

if(chiptype!="empty" & class(a)!="try-error") {
	# Including gene names to data
	lib2		<-sub('.db','',chiptype)
	symbol		<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "SYMBOL", sep="")))))[unlist(dat$genes),])
	genename	<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "GENENAME", sep="")))))[unlist(dat$genes),])
	# Fxes an issue introduced in BioC2.4 where the "#" character is introduced in some gene names
	genename 	<- gsub("#", "", genename)
	symbol 		<- gsub("'", "", symbol)
	genename	<- gsub("'", "", genename)

	# Writes the results into a file
	if (keep.flags=="yes" & keep.annotations=="yes") {
		output_table <- data.frame(symbol=annotation.info, description=genename, dat2, flag.info);
	} else if (keep.flags=="yes" & keep.annotations=="no") {
		output_table <- data.frame(symbol, description=genename, dat2, flag.info);
	} else if (keep.flags=="no" & keep.annotations=="yes") {
		output_table <- data.frame(symbol=annotation.info, description=genename, dat2);
	} else {
		output_table <- data.frame(symbol, description=genename, dat2);		
	}
	
	rownames (output_table) <- unlist(dat$genes)
	write.table(output_table, file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
}

if(chiptype=="empty" | class(a)=="try-error") {

	# Writes the results into a file
	if (keep.flags=="yes" & keep.annotations=="yes") {
		output_table <- data.frame(symbol=annotation.info, dat2, flag.info);
	} else if (keep.flags=="yes" & keep.annotations=="no") {
		output_table <- data.frame(dat2, flag.info);
	} else if (keep.flags=="no" & keep.annotations=="yes") {
		output_table <- data.frame(symbol=annotation.info, dat2);	
	} else {
		output_table <- data.frame(dat2);		
	}
	
	rownames (output_table) <- unlist(dat$genes)
	write.table(output_table, file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
}

# TOOL extract-genes-from-clustering.R: "Extract genes from clustering" (Extracts genes from a clustering result. Specify the cluster you want to extract the genes from.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT extract.tsv: extract.tsv 
# PARAMETER cluster.number: cluster.number TYPE INTEGER FROM 1 TO 1000 DEFAULT 1 (Cluster number to extract genes from.)


# Extracts genes from the clustering result for a specific cluster
# JTT 15.10.2007

# Loads the data file
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Sanity checks
if(is.null(dat$cluster)==TRUE) {
   stop("You haven't clustered your data, so there are no genes to extract! Cluster the data first.")
}
if(cluster.number>max(dat$cluster)) {
   stop("The cluster number is larger than the number of cluster in the current data! Use a smaller cluster number.")
}

# Extracting the genes
dat2<-dat[which(dat$cluster==cluster.number),]

# Writing the data to disk
write.table(data.frame(dat2), file="extract.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL pathways-mirna-hyperg-kegg.R: "KEGG enrichment for miRNA targets" (Performs a statistical test for enrichmens of KEGG pathways in the predicted gene targets of a list of miRNA ID:s.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT hyperg_kegg.tsv: hyperg_kegg.tsv 
# PARAMETER p.value.threshold: p.value.threshold TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (P-value threshold)
# PARAMETER p.adjust.method: p.adjust.method TYPE [none: none, BH: BH, BY: BY] DEFAULT BH (method for adjusting the p-value in order to account for multiple testing)
# PARAMETER minimum.population: minimum.population TYPE INTEGER FROM 1 TO 1000000 DEFAULT 10 (minimum number of genes in in the reference list that map to a pathway)
# PARAMETER species: species TYPE [human: human, mouse: mouse, rat: rat] DEFAULT human (the species for which the miRNA:s have been analyzed)

# POSSIBLE summary.feature [gene, transcript] DEFAULT gene (should the targets for the miRNA:s be transcripts or genes?)

# miRNA hypergeometric test for KEGG
# MG, 4.11.2009
# modifed 16.12.2009 by MG

# force "transcript" mode
summary.feature <- "transcript"

# Reads the data
dat<-read.table("normalized.tsv", sep="\t", header=T)

# Extracts the identifiers
id<-as.character(rownames(dat))

# Translate parameter settings for biomaRt queries
if (species=="human") {
	dataset <- "hsapiens_gene_ensembl"
}
#if (species=="human" & summary.feature=="transcript") {
#        dataset <- "hsapiens_transcript_ensembl"
#}
if (species=="mouse") {
	dataset <- "mmusculus_gene_ensembl"
}
#if (species=="mouse" & summary.feature=="transcript") {
#        dataset <- "mmusculus_t_ensembl"
#}
if (species=="rat") {
	dataset <- "rnorvegicus_gene_ensembl"
}
#if (species=="rat" & summary.feature=="transcript") {
#        dataset <- "rnorvegicus_transcript_ensembl"
#}


# Read in the CORNA library, which contains the functions to map miRNA:s to targets
# and performs hypergeometric test for enrichment of GO terms
library(CORNA)

# Download the mapping of miRNA to its targets from Sanger institute
# Currently disabled becuse of unstable web-services
#if (species=="human") {
#	targets <- miRBase2df.fun(url="ftp://ftp.sanger.ac.uk/pub/mirbase/targets/v5/arch.v5.txt.homo_sapiens.zip")
#}
#if (species=="mouse") {
#	targets <- miRBase2df.fun(url="ftp://ftp.sanger.ac.uk/pub/mirbase/targets/v5/arch.v5.txt.mus_musculus.zip")
#}
#if (species=="rat") {
#	targets <- miRBase2df.fun(url="ftp://ftp.sanger.ac.uk/pub/mirbase/targets/v5/arch.v5.txt.rattus_norvegicus.zip")
#}


# Download the mapping of miRNA to its targets from locally installed files
path.mappings <- c(file.path(chipster.tools.path, "miRNA_mappings"))
if (species=="human") {
	targets <- read.table(file.path(path.mappings, "mirna_mappings_hsapiens.txt"), sep="\t")
}
if (species=="mouse") {
	targets <- read.table(file.path(path.mappings, "mirna_mappings_mmusculus.txt"), sep="\t")
}
if (species=="rat") {
	targets <- read.table(file.path(path.mappings, "mirna_mappings_rnorvegious.txt"), sep="\t")
}


# obtain a link from transcript to gene from BiomaRt
# disabled for now to avoid connection problems to BiomaRt
#tran2gene <- BioMart2df.fun(
#		biomart="ensembl",
#		dataset=dataset,
#		col.old=c("ensembl_transcript_id",
#				"ensembl_gene_id"),
#		col.new=c("tran", "gene"))

# obtain a link from transcript to gene from locally installed files
if (species=="human") {
	tran2gene <- read.table(file=file.path(path.mappings,"transcripts_to_genes_hsapiens.txt"), sep="\t")
}
if (species=="mouse") {
	tran2gene <- read.table(file=file.path(path.mappings,"transcripts_to_genes_mmusculus.txt"), sep="\t")
}
if (species=="rat") {
	tran2gene <- read.table(file=file.path(path.mappings,"transcripts_to_genes_rnorvegicus.txt"), sep="\t")
}

# link microRNAs to genes instead of transcripts
mir2gene <- corna.map.fun(targets,
		tran2gene,
		"gene",
		"mir")

# get those genes associated with a list of regulated miRNA:s
sample.list <- corna.map.fun(mir2gene,
		id,
		"mir",
		"gene")

# read pathway information from KEGG
# disabled for now to avoid connection problems to KEGG
#if (species="human") {
#	gene2path <- KEGG2df.fun(org="hsa")
#}
#if (species="mouse") {
#	gene2path <- KEGG2df.fun(org="mmu")
#}
#if (species="rat") {
#	gene2path <- KEGG2df.fun(org="rno")
#}
	
# read pathway information from local files
if (species=="human") {
	gene2path <- read.table(file=file.path(path.mappings,"genes_to_kegg_hsapiens.txt"), sep="\t")
}
if (species=="mouse") {
	gene2path <- read.table(file=file.path(path.mappings,"genes_to_kegg_mmusculus.txt"), sep="\t")
}
if (species=="rat") {
	gene2path <- read.table(file=file.path(path.mappings,"genes_to_kegg_rnorvegicus.txt"), sep="\t")
}
# define the sample of genes to test, i.e. only those gene targets that have pathway data
sample.list <- intersect(sample.list, unique(gene2path$gene))

# create data frame of pathway ids and names
path2name <- unique(gene2path[c("path", "name")])

# perform the test
test <- corna.test.fun(
		sample.list,
		unique(gene2path$gene),
		gene2path,
		hypergeometric=T,
		fisher=F,
		chi.square=F,
		#fisher.alternative="greater",
		min.pop=minimum.population,
		sort="hypergeometric",
		p.adjust.method=p.adjust.method,
		desc=path2name)

# fetch significant pathways
significant.kegg <- test[test$hypergeometric<=p.value.threshold,]

# write results table
write.table(significant.kegg, file="hyperg_kegg.tsv", sep="\t", quote=F)

# TOOL stat-chisq-snp.R: "Association analysis" (Association tests for normalized SNP array data. Runs a Chi square test for every SNP. Hardy-Weinberg equilibrium is tested in controls only. Association tests use the grouping information of sample in group column of phenodata. Association tests are run for genotype frequences and dominant and recessive models.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT assoc.tsv: assoc.tsv 
# PARAMETER test.for: test.for TYPE [Hardy-Weinberg: Hardy-Weinberg, association: association] DEFAULT association (What to test for)
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to compare)


# Association analysis with normalized SNP data
# 25.4.2008
#
# modified by MG, 14.10.2009

# Parameter settings (default) for testing purposes
#test.for<-c("association")
#column<-c("group")

# Read in data
dat<-read.table("normalized.tsv", header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Test needs a parameter "groups" that specifies the grouping of the samples
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
groups<-phenodata[,pmatch(column,colnames(phenodata))]

# Select only samples in group 1 (controls)
dat2<-dat[,which(groups==1)]

# Testing for Hardy-Weinberg in controls
if(test.for=="Hardy-Weinberg") {
   p<-rep("NA", nrow(dat))
   for(i in 1:nrow(dat)) {
      table1<-table(as.numeric(as.vector(dat2[i,])))
      if(length(table1)==1) {
         p[i]<-1
      }
      if(length(table1)==2) {
        p[i]<-1
      }
      if(length(table1)==3) {
         AA<-table1[1]
         AB<-table1[2]
         BB<-table1[3]
         s<-sum(table1)
         fa<-(AA*2+AB)/(2*s)
         fb<-(BB*2+AB)/(2*s)  
         o<-c(AA,AB,BB)
         e<-c(fa^2*s, 2*fa*fb*s, fb^2*s)
         p[i]<-chisq.test(x=o, y=e, simulate.p.value=T)$p.value
      }
   }
  # Saving the p-values
  p.hardy<-p
}

# Excluding the SNPs that violate Hardy-Weinberg
# dat2<-dat[,grep("chip", names(dat))]
# dat2<-dat2[p>=0.05,]
# dat2<-as.matrix(dat2)

# Testing for association
if(test.for=="association") {
   # Testing for difference between two groups
   library(scrime)
   
   
############################
# MG ADDED THESE TWO LINES #
############################

   dat2<-dat[,grep("chip", names(dat))]
   dat2<-as.matrix(dat2)
   
############################
   
   
   
   p<-rowChisqStats(dat2, cl=groups, compPval = TRUE)
   p<-p$rawp

   # Saving the p-values
   p.genotype<-p

   # Getting the raw data again
   dat2<-dat[,grep("chip", names(dat))]
   dat2<-as.matrix(dat2)

   # Testing the dominant model
   dat2[dat2==2]<-1
   dat2[dat2==3]<-2
   p<-rowChisqStats(dat2, cl=groups, compPval = TRUE)
   p<-p$rawp

   # Saving the p-values
   p.dominant<-p
  
   # Getting the raw data again
   dat2<-dat[,grep("chip", names(dat))]
   dat2<-as.matrix(dat2)

   # Testing the recessive model
   dat2[dat2==2]<-3
   dat2[dat2==3]<-2
   p<-rowChisqStats(dat2, cl=groups, compPval = TRUE)
   p<-p$rawp
   
   # Saving the p-values
   p.recessive<-p
}

# Writing data to disk
if(test.for=="Hardy-Weinberg") {
   write.table(data.frame(dat, p.adjusted=p.hardy), file="assoc.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}
if(test.for=="association") {
   write.table(data.frame(dat, p.genotype, p.dominant, p.recessive), file="assoc.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}

# TOOL prinseq-filter.R: "Filter reads for several criteria" (Filters reads based on several criteria. Different criterias are combined with AND operator. This tool is based on the PRINSEQ package.)
# INPUT fastqfile: "Input reads file" TYPE GENERIC
# INPUT OPTIONAL matepair_fastqfile: "Input reads mate pair file" TYPE GENERIC
# OUTPUT OPTIONAL accepted.fastq
# OUTPUT OPTIONAL accepted.fasta
# OUTPUT OPTIONAL accepted_matepair.fastq
# OUTPUT OPTIONAL rejected.fastq
# OUTPUT OPTIONAL rejected.fasta
# OUTPUT OPTIONAL filter.log
# PARAMETER OPTIONAL output.mode: "Results to write out" TYPE [ filt: "accepted sequences only", both: "accepted and rejected sequences into separate files"] DEFAULT filt (With this section you can define if the sequences that get filtered out are collected to a separate file) 
# PARAMETER OPTIONAL input.mode: "Input file format" TYPE [ fq: "FASTQ", fa: "FASTA"] DEFAULT fq (Define the file format of the reads file)
# PARAMETER OPTIONAL noniupac: "Remove reads with non-standard characters" TYPE [yes, no] DEFAULT no (Filter out reads with characters other than A, C, G, T or N.)
# PARAMETER OPTIONAL max.len: "Maximum length" TYPE INTEGER (Select only reads that are shorter than the given value.)
# PARAMETER OPTIONAL min.len: "Minimum length" TYPE INTEGER (Select only reads that are longer than the given value.)
# PARAMETER OPTIONAL max.gc: "Maximum GC content" TYPE INTEGER (Select only reads that have GC content smaller than the given value.)
# PARAMETER OPTIONAL min.gc: "Minimum GC content" TYPE INTEGER (Select only reads that have GC content larger than the given value.)
# PARAMETER OPTIONAL min.qual.score: "Minimum quality score" TYPE INTEGER (Filter reads with GC content below than the given value.)
# PARAMETER OPTIONAL max.qual.score: "Maximum quality score" TYPE INTEGER (Filter reads with GC content above then the given value.)
# PARAMETER OPTIONAL min.qual.mean: "Minimum mean quality" TYPE INTEGER ( Filter reads with quality score mean below the given value.)
# PARAMETER OPTIONAL max.qual.mean: "Maximum mean quality" TYPE INTEGER ( Filter reads with quality score mean above the given value.)
# PARAMETER OPTIONAL ns.max.p: "Maximum percentage of Ns" TYPE INTEGER (Filter reads for which the percentage of Ns is higher than the given value.)
# PARAMETER OPTIONAL ns.max.n: "Maximun count of Ns" TYPE INTEGER (Filter reads which have more Ns than the given value.)
# PARAMETER OPTIONAL seq.num: "Maximum number of reads" TYPE INTEGER (Only keep the given number number of reads that pass all other filters.)
# PARAMETER OPTIONAL derep: "Type of duplicates to filter" TYPE [0: "none", 1: "exact duplicate", 2: "5-prime duplicate", 3: "3-prime duplicate", 4: "reverse complement exact duplicate", 5:"reverse complement 5-prime/3-prime duplicate"] DEFAULT 0 (Type of duplicates to filter.)
# PARAMETER OPTIONAL derep.min: "Number of allowed duplicates" TYPE INTEGER (This option specifies the number of allowed duplicates. For example, to remove reads that occur more than 5 times, you would specify value 6.)
# PARAMETER OPTIONAL lc.dust: "DUST filter threshold" TYPE INTEGER (Use DUST method with the given maximum allowed score, between 0 and 100.)
# PARAMETER OPTIONAL lc.entropy: "ENTROPY filter threshold" TYPE INTEGER (Use ENTROPY method with the given minimum entropy value, between 0 and 100.)
# PARAMETER OPTIONAL phred64: "Base quality encoding" TYPE [ n: "Sanger", y: "Illumina v1.3-1.5"] DEFAULT n (Select \"Sanger" for Illumina v1.8+, Sanger, Roche/454, Ion Torrent and PacBio data.)
# PARAMETER OPTIONAL log.file: "Write a log file" TYPE [ n: "no", y: "yes"] DEFAULT y (Write a log file)

# Filter fastq and fasta files based on a number of criteria
# KM, EK, 16-04-2012
# MG, 18-04-2012, added matepair functionality
# KM, 22-05-2012, fixed fastq checking

# Check out if the files are compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("fastqfile")
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("matepair_fastqfile")

# Check whether input files are fastq
if (input.mode == "fq") {
	first_four_rows <- read.table(file="fastqfile", nrow=4, header=FALSE, sep="\t", check.names=FALSE, comment.char="")
	## compare sequence ID with quality score id, but discard first character
	#name_length <- nchar(as.character(first_four_rows[1,1]))
	seq_char <- substr(as.character(first_four_rows[1,1]), start=1, stop=1)
	quality_char <- substr(as.character(first_four_rows[3,1]), start=1, stop=1)
	if (seq_char != "@") {
		stop("CHIPSTER-NOTE: It appears as though the input file(s) are not in fastq format. Please check input files or rerun the tool but with the 'Input file format' parameter set to 'FASTA'.")
	}
	if (quality_char != "+") {
		stop("CHIPSTER-NOTE: It appears as though the input file(s) are not in fastq format. Please check input files or rerun the tool but with the 'Input file format' parameter set to 'FASTA'.")
	}
}

# Check if two files were given as input, and if so run the python script
# that interlaces the mate pairs into a single file
input_files <- dir()
is_paired_end <- (length(grep("matepair_fastqfile", input_files))>0)
if (is_paired_end) {
	#check if the fastqfomat is hiseq or old
	first_row_1 <- read.table(file="fastqfile", nrow=1, header=FALSE, sep=" ", check.names=FALSE, comment.char="")
	first_row_2 <- read.table(file="matepair_fastqfile", nrow=1, header=FALSE, sep=" ", check.names=FALSE, comment.char="")
	if ( ncol(first_row_1) == 2 ) { fq.hiseq <- "yes" } else { fq.hiseq <- "no" }
	

	# check that the input files are truly matepairs by comparing
	# sequence ID, discarding the last character
	name_length <- nchar(as.character(first_row_1[1,1]))
	id_1 <- substr(as.character(first_row_1[1,1]), start=1, stop=name_length-1)
	id_2 <- substr(as.character(first_row_2[1,1]), start=1, stop=name_length-1)
	if (id_1 != id_2) {
		  stop("CHIPSTER-NOTE: It appears that the two input files are not matepairs. Please check that the correct input files were selected.")
	}
	
	   # figure out which file is the first and second matepair, and issue
	   # the python script call accordingly
	if ( fq.hiseq == "no"){		
	   mate_number <- substr(as.character(first_row_1[1,1]), start=name_length, stop=name_length)
    } else {
		mate_number <- substr(as.character(first_row_1[1,2]), start=1, stop=1)
	}	
	if (mate_number == "1") {
		binary_python_scripts <- file.path(chipster.module.path, "shell", "match-mate-pairs", "interleave-fastq.py")
		system_command <- paste("python", binary_python_scripts, "fastqfile", "matepair_fastqfile", "interleaved_fastqfile")
		system(system_command)	
		system("echo Executed interleave python script with: > filter.log")
		echo.command <- paste("echo '", system_command, "'>> filter.log")
		system(echo.command)
	} else {
		binary_python_scripts <- file.path(chipster.module.path, "shell", "match-mate-pairs", "interleave-fastq.py")
		system_command <- paste("python", binary_python_scripts, "matepair_fastqfile", "fastqfile", "interleaved_fastqfile")
		system(system_command)	
		system("echo Executed interleave python script with: > filter.log")
		echo.command <- paste("echo '", system_command, "'>> filter.log")
		system(echo.command)
}	

	# remove input files to clear up disk space
	system("rm -f fastqfile")
	system("rm -f matepair_fastqfile")
	system("mv interleaved_fastqfile fastqfile")

}

# binary
binary.prinseq <- c(file.path(chipster.tools.path, "prinseq", "prinseq-lite.pl" ))

filter.params <- paste(" ")
if (!is.na(max.len)) {
	filter.params <- paste(filter.params, "-max_len",  max.len)
}

if (!is.na(min.len)) {
	filter.params <- paste(filter.params, "-min_len",  min.len)
}

if (!is.na(max.gc)) {
	filter.params <- paste(filter.params, "-max_gc",  max.gc)
}

if (!is.na(min.gc)) {
	filter.params <- paste(filter.params, "-min_gc",  min.gc)
}

if (!is.na(min.qual.score)) {
	filter.params <- paste(filter.params, "-min_qual_score",  min.qual.score)
}

if (!is.na(max.qual.score)) {
	filter.params <- paste(filter.params, "-max_qual_score",  max.qual.score)
}

if (!is.na(min.qual.mean)) {
	filter.params <- paste(filter.params, "-min_qual_mean",  min.qual.mean)
}

if (!is.na(max.qual.mean)) {
	filter.params <- paste(filter.params, "-max_qual_mean",  max.qual.mean)
}

if (!is.na(ns.max.p)) {
	filter.params <- paste(filter.params, "-ns_max_p",  ns.max.p)
}

if (!is.na(ns.max.n)) {
	filter.params <- paste(filter.params, "-ns_max_n",  ns.max.n)
}

if (!is.na(seq.num)) {
	filter.params <- paste(filter.params, "-seq_num",  seq.num)
}

if (!is.na(lc.dust)) {
	filter.params <- paste(filter.params, "-lc_method dust -lc_threshold", lc.dust )
}

if (!is.na(lc.entropy)) {
	filter.params <- paste(filter.params, "-lc_method entropy -lc_threshold", lc.entropy )
}

if (derep > 0) {	
	filter.params <- paste(filter.params, "-derep", derep )
    if (derep == "1") {
	   filter.params <- paste(filter.params, "-derep_min", derep.min )
    }
    if (derep == "4") {
	   filter.params <- paste(filter.params, "-derep_min", derep.min )
    }
}

if (noniupac == "yes") {
	filter.params <- paste(filter.params, "-noniupac" )
}

if (phred64 == "y") {
	filter.params <- paste(filter.params, "-phred64")
}

if (output.mode == "both") {
	filter.params <- paste(filter.params, "-out_bad rejected")
}

if (input.mode == "fq") {
	filter.command <- paste(binary.prinseq, filter.params, "-fastq fastqfile -out_good accepted")
}

if (input.mode == "fa") {
	filter.command <- paste(binary.prinseq, filter.params, "-fasta fastqfile -out_good accepted")
}

if (log.file == "y") {
	system("echo Running PRINSEQ filtering with command: >> filter.log")
	echo.command <- paste("echo '", filter.command, "'>> filter.log")
	system(echo.command)
	filter.command <- paste(filter.command, "-verbose 2>> filter.log")
}

system(filter.command)

# Make sure something is in the output
if (input.mode == "fq") {
	system("if [ ! -e  accepted.fastq ] ; then echo 'Filtering produced an empty accepted.fastq sequence set' > accepted.fastq ; fi")
}

if (input.mode == "fa") {
	system("if [ ! -e  accepted.fasta ] ; then echo 'Filtering produced an empty accepted.fasta sequence set' > accepted.fasta ; fi")
}

if (output.mode == "both") {
	if (input.mode == "fq") {
		system("if [ ! -e  rejected.fastq ] ; then echo 'Filtering produced an empty rejected.fastq sequence set' >> filter.log ; echo '' > rejected.fastq ; fi")
	}
	
	if (input.mode == "fa") {
		system("if [ ! -e  rejected.fasta ] ; then echo 'Filtering produced an empty rejected.fasta sequence set' >> filter.log  ; echo '' > rejected.fasta ; fi")
	}
}

# remove input files to clear up disk space
system("rm -f fastqfile")

# If filtering on paired-end data, perform matching of
# mate pairs using python script and then de-interlace them to two files
if (is_paired_end) {
	if ( fq.hiseq == "no"){	
	   binary_python_scripts <- file.path(chipster.module.path, "shell", "match-mate-pairs", "match-pairs.py")
    } else{
	   binary_python_scripts <- file.path(chipster.module.path, "shell", "match-mate-pairs", "match-pairs-hiseq.py")
    }
	
	system_command <- paste("python", binary_python_scripts, "accepted.fastq", "matched_fastqfile >> filter.log")
	system(system_command)

	system("echo Executed match_pair python script with: >> filter.log")
	echo.command <- paste("echo '", system_command, "'>> filter.log")
	system(echo.command)

	# remove input files to clear up disk space
	system("rm -f accepted.fastq")

	binary_python_scripts <- file.path(chipster.module.path, "shell", "match-mate-pairs", "deinterleave-fastq.py")
	system_command <- paste("python", binary_python_scripts, "matched_fastqfile", "accepted.fastq", "accepted_matepair.fastq")
	system(system_command)	

	system("echo Executed deinterleave python script with: >> filter.log")
	echo.command <- paste("echo '", system_command, "'>> filter.log")
	system(echo.command)
	
	# remove input files to clear up disk space
	system("rm -f matched_fastqfile")
}

# stop

# TOOL convert-bam-to-edger.R: "Convert genomic BAM file to edgeR input format" (This tool takes BAM files as an input, calculates the number of times each sequence tag is identified and removes the ones for which the count is under the user defined threshold.)
# INPUT bam_file.bam: "Alignment against genome in BAM format" TYPE GENERIC
# OUTPUT edgeR-input.tsv: "A converted BAM file suitable for edgeR analysis"
# PARAMETER count_limit: "Count limit" TYPE INTEGER FROM 0 TO 100000 DEFAULT 10 (The lowest number of times a sequence tag has to appear in the data)
# PARAMETER merge_overlapping: "Merge overlapping reads" TYPE [no, start, end, both] DEFAULT both (If enabled, reads with identical start or end position, but differing in length or nucleotide composition, will be merged into one. The count number will be summed over the merged reads and the sequence and length of the longest among the merged reads will be reported.)

# MG 15.6.2011
# modified MG, 19.8.2011, added parameter to merge reads with same start or end position

# Extract the BAM file into SAM
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))
samtools.command <- paste(samtools.binary, "view bam_file.bam > sam_file")
system(samtools.command)

# Extract the following info from the SAM file:
# nucleotide sequence
# chromosome
# start
# length of sequence
input.file <- "sam_file"
output.file <- "sam_file_extracted"
extract.command <- paste ("awk '{print $10\"\t\"$3\"\t\"$4\"\t\"length($10)+$4-1\"\t\"length($10)}'", input.file, ">", output.file)
system(extract.command)


# Sort sequence reads according to chromosome and start position
input.file <- "sam_file_extracted"
output.file <- "sam_file_sorted"
sort.command <- paste ("sort -k3n -k4n", input.file, ">", output.file)
system(sort.command)

# Find the unique reads
input.file <- "sam_file_sorted"
output.file <- "sam_file_unique"
unique.command <- paste ("uniq -c -f 1", input.file, ">", output.file)
system(unique.command)

# Create an output file with sequence reads that occur at least count_limit times
input.file <- "sam_file_unique"
output.file <- "sam_file_output"
output.command <- paste ("awk '{if($1>", count_limit, ")print $2\"\t\"$3\"\t\"$4\"\t\"$5\"\t\"$6\"\t\"$1}'", input.file, ">", output.file)
system(output.command)

# Creat sequence read ID composed of chromosome name, start position and end position
input.file <- "sam_file_output"
output.file <- "sam_file_id"
id.command <- paste ("awk '{print $2\"_\"$3\"_\"$4\"_\"$1\"\t\"$1\"\t\"$2\"\t\"$3\"\t\"$4\"\t\"$5\"\t\"$6}'", input.file, ">", output.file)
system(id.command)

# Remove sequence reads mapping to random chromosome
input.file <- "sam_file_id"
output.file <- "sam_file_trimmed"
trim.command <- paste ("grep -v \\*", input.file, ">", output.file)
system(trim.command)

# Add column headers
headers <- paste("id\t","sequence\t","chr\t","start\t","end\t","length\t","count", sep="")
input.file <- "sam_file_trimmed"
header.file <- "header_file"
output.file <- "edgeR-input.tsv"
system(paste("echo \"", headers, "\"", ">", header.file))
merge.command <- paste("cat", header.file, input.file, ">", output.file)
system(merge.command)

if (merge_overlapping != "no") {
	# Read file into R
	file <- c("edgeR-input.tsv")
	dat <- read.table(file, header=T, sep="\t", row.names=1)

	if (merge_overlapping == "start" || merge_overlapping == "both") {
	# Merge sequences with same starting position into single one and sum counts
	# Go through data chromosome by chromosome
	chr_list <- levels (dat$chr)
	chr_number <- length (chr_list)
	results_table <- dat[1,]
	results_table[1,] <- 0
	for (count in 1:chr_number) {
		dat_temp <- dat[dat$chr==chr_list[count],]
		counts_temp <- dat_temp$count
		start_temp <- dat_temp$start
		end_temp <- dat_temp$end
		length_temp <- dat_temp$length
		names (counts_temp) <- rownames(dat_temp)
		counts_temp_merged <- aggregate (counts_temp, by=(list (as.character (dat_temp$start))), FUN=sum) [,2]
		start_temp_longest <-  aggregate (start_temp, by=(list (as.character (dat_temp$start))), FUN=max) [,2]
		end_temp_longest <-  aggregate (end_temp, by=(list (as.character (dat_temp$start))), FUN=max) [,2]
		length_temp_longest <-  aggregate (length_temp, by=(list (as.character (dat_temp$start))), FUN=max) [,2]
	
		# fetch the corresponding seq_id and sequences
		id_temp <- paste(chr_list[count], "_", start_temp_longest, "_", end_temp_longest, sep="")
		sequence_id <- character(length(id_temp))
		for (count_2 in 1:length(id_temp)) {
			sequence_id[count_2] <- names (counts_temp) [grep (id_temp[count_2], names(counts_temp))]
		}
		sequence_temp_matched <- dat_temp[sequence_id,]
		sequence_temp_matched <- as.character(sequence_temp_matched$sequence)
	
		# construct the result table for the chromosome
		results_temp <- data.frame(
				sequence=sequence_temp_matched, 
				chr=chr_list[count], 
				start=start_temp_longest,
				end=end_temp_longest,
				length=length_temp_longest,
				count=counts_temp_merged, 
				row.names=sequence_id
		)
		results_table <- rbind (results_table, results_temp)
	}
	results_table <- results_table[-1,]
	}
	
	if (merge_overlapping == "end" || merge_overlapping == "both") {
	# Merge sequences with same ending position into single one and sum counts
	#Go through data chromosome by chromosome
	if (merge_overlapping == "both") {
		dat <- results_table
	}
	chr_list <- levels (dat$chr)
	chr_number <- length (chr_list)
	results_table <- dat[1,]
	results_table[1,] <- 0
	for (count in 1:chr_number) {
		dat_temp <- dat[dat$chr==chr_list[count],]
		counts_temp <- dat_temp$count
		start_temp <- dat_temp$start
		end_temp <- dat_temp$end
		length_temp <- dat_temp$length
		names (counts_temp) <- rownames(dat_temp)
		counts_temp_merged <- aggregate (counts_temp, by=(list (as.character (dat_temp$end))), FUN=sum) [,2]
		start_temp_longest <-  aggregate (start_temp, by=(list (as.character (dat_temp$end))), FUN=max) [,2]
		end_temp_longest <-  aggregate (end_temp, by=(list (as.character (dat_temp$end))), FUN=max) [,2]
		length_temp_longest <-  aggregate (length_temp, by=(list (as.character (dat_temp$end))), FUN=max) [,2]
	
		# fetch the corresponding seq_id and sequences
		id_temp <- paste(chr_list[count], "_", start_temp_longest, "_", end_temp_longest, sep="")
		sequence_id <- character(length(id_temp))
		for (count_2 in 1:length(id_temp)) {
			sequence_id[count_2] <- names (counts_temp) [grep (id_temp[count_2], names(counts_temp))]
		}
		sequence_temp_matched <- dat_temp[sequence_id,]
		sequence_temp_matched <- as.character(sequence_temp_matched$sequence)
	
		# construct the result table for the chromosome
		results_temp <- data.frame(
				sequence=sequence_temp_matched, 
				chr=chr_list[count], 
				start=start_temp_longest,
				end=end_temp_longest,
				length=length_temp_longest,
				count=counts_temp_merged, 
				row.names=sequence_id
		)
		results_table <- rbind (results_table, results_temp)
	}
	results_table <- results_table[-1,]
	}
	
	# Writing data to disk
	write.table(data.frame(id=rownames(results_table), results_table), file="edgeR-input.tsv", col.names=T, quote=F, sep="\t", row.names=F)
}

# EOF

# TOOL ngs-dea-edger-RNA.R: "Differential expression using edgeR" (Differential gene expression analysis using the exact statistical methods of the edgeR Bioconductor package. You can create the input count table and phenodata file using the tool \"Utilities - Define NGS experiment\". Please note that this tool is suitable only for two group comparisons. For multifactor experiments please use the tool \"Differential expression using edgeR for multivariate experiments\".)
# INPUT data.tsv TYPE GENERIC
# INPUT phenodata.tsv TYPE GENERIC
# OUTPUT OPTIONAL de-list-edger.tsv
# OUTPUT OPTIONAL de-list-edger.bed
# OUTPUT OPTIONAL ma-plot-raw-edger.pdf
# OUTPUT OPTIONAL ma-plot-normalized-edger.pdf
# OUTPUT OPTIONAL ma-plot-significant-edger.pdf
# OUTPUT OPTIONAL mds-plot-edger.pdf
# OUTPUT OPTIONAL edger-log.txt
# OUTPUT OPTIONAL p-value-plot-edger.pdf
# PARAMETER column: "Column describing groups" TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to test)
# PARAMETER OPTIONAL normalization: "Apply TMM normalization" TYPE [yes, no] DEFAULT yes (Should normalization based on the trimmed mean of M-values \(TMM\) be performed to reduce the RNA composition effect.)
# PARAMETER OPTIONAL dispersion_method: "Dispersion method" TYPE [common, tagwise] DEFAULT tagwise (The dispersion of counts for a gene can be moderated across several genes with similar count numbers. This default tagwise option typically yields higher sensitivity and specificity. The option Common estimates one value which is then used for all the genes. Common dispersion is used regardless of the setting if no biological replicates are available.)
# PARAMETER OPTIONAL dispersion_estimate:"Dispersion value" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.1 (The value to use for the common dispersion when no replicates are available.) 
# PARAMETER OPTIONAL p_value_adjustment_method: "Multiple testing correction" TYPE [none, Bonferroni, Holm, Hochberg, BH, BY] DEFAULT BH (Multiple testing correction method.)
# PARAMETER OPTIONAL p_value_threshold: "P-value cutoff" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (The cutoff for statistical significance.)
# PARAMETER OPTIONAL image_width: "Plot width" TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted image)
# PARAMETER OPTIONAL image_height: "Plot height" TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted image)


############################################################
#                                                          
# Analysis workflow using edgeR for normalization and statistical testing for finding differentially expressed genes 
# MG, 11.6.2011                                            
# MG, 23.8.2011, updated to include library size from phenodata file                                           
# MG, 30.1.2012 updated to allow analysis without biological replicates                                    
# MG, 22.2.2012, prettified plots, added p-value  distribution plot
# EK, 6.5.2012, clarified wording
# AMS, 5.10.2012, added sorting to BED
# EK, 28.4.2013 changes to descriptions
############################################################

# Loads the libraries
library(edgeR)

# Simplify variable names
w <- image_width
h <- image_height

# Loads the count data
file <- c("data.tsv")
dat <- read.table(file, header=T, sep="\t", row.names=1)

# Extracts expression value columns
annotations <- dat[,-grep("chip", names(dat))]
dat2 <- dat[,grep("chip", names(dat))]

# Test needs a parameter "groups" that specifies the grouping of the samples
phenodata <- read.table("phenodata.tsv", header=T, sep="\t")
groups <- as.character (phenodata[,pmatch(column,colnames(phenodata))])
group_levels <- levels(as.factor(groups))
number_samples <- length(groups)

# If the library_size column contains data then use that as estimate
lib_size <- as.numeric(phenodata$library_size)
if (is.na(lib_size[1])) estimate_lib_size <- "TRUE" else estimate_lib_size <- "FALSE"

# Sanity checks
# only 2 group comparison is supported
if (length(unique(groups))==1 | length(unique(groups))>=3) {
	stop("CHIPSTER-NOTE: You need to have exactly two groups to run this analysis")
}
# if no biological replicates, force common dispersion
if (number_samples == 2) dispersion_method <- "common" 

# Create a DGEList
# Notice that library size is calculated from column totals if no library size
# exist in the phenodata file
if (estimate_lib_size) {
	dge_list <- DGEList (count=dat2, group=groups)
} else {
	dge_list <- DGEList (count=dat2, group=groups, lib.size=lib_size)
}

# Check lib size totals
# dge_list$samples

# Calculate normalization factors
if (normalization == "yes") {
	dge_list <- calcNormFactors(dge_list) 
}

# Produce MDS plot of normalized data
# NOTE: only possible when there are more than 2 samples in total
if (number_samples > 2) {
	pdf(file="mds-plot-edger.pdf", width=w/72, height=h/72)
	sample_colors <-  ifelse (dge_list$samples$group==group_levels[1], 1, 2)
	plotMDS.dge(dge_list, main="MDS Plot", col=sample_colors)
	legend(x="topleft", legend = group_levels,col=c(1,2), pch=19)
	dev.off()
}

# MA-plot comparison before and after normalization
pdf(file="ma-plot-raw-edger.pdf", width=w/72, height=h/72)
maPlot(dge_list$counts[, 1], dge_list$counts[, 2], normalize = FALSE, pch = 19,
		cex = 0.4, ylim = c(-8, 8))
grid(col = "blue")
title("Raw counts")
abline(h = log2(dge_list$samples$norm.factors[2]/dge_list$samples$norm.factors[1]),
		col = "red", lwd = 2)
abline(h = 0, col = "darkgreen", lwd = 1)
legend (x="topleft", legend=c("not expressed in one condition","expressed in both conditions"), col=c("orange","black"),
		cex=1, pch=19)
dev.off()

if (normalization == "yes") {
	pdf(file="ma-plot-normalized-edger.pdf", width=w/72, height=h/72)
	eff.libsize <- dge_list$samples$lib.size * dge_list$samples$norm.factors
	maPlot(dge_list$counts[, 1]/eff.libsize[1], dge_list$counts[, 2]/eff.libsize[2],
			normalize = TRUE, pch = 19, cex = 0.4, ylim = c(-8, 8))
	grid(col = "blue")
	title("Normalized counts")
	legend (x="topleft", legend=c("not expressed in one condition","expressed in both conditions"), col=c("orange","black"),
			cex=1, pch=19)
	abline(h = 0, col = "darkgreen", lwd = 1)
	dev.off()
}

###################################
# Analysis using common dispersion #
###################################

if (dispersion_method == "common") {
	# Calculate common dispersion
	dge_list <- estimateCommonDisp(dge_list)
	
	# Statistical testing
	if (number_samples != 2) stat_test <- exactTest(dge_list, common.disp=TRUE) 
	if (number_samples == 2) stat_test <- exactTest(dge_list, common.disp=TRUE, dispersion=dispersion_estimate)
	
	
	# Extract results in a nice-looking table
	number_tags <- dim (dge_list$counts) [1]
	results_table <- topTags (stat_test, n=number_tags, adjust.method=p_value_adjustment_method, sort.by="p.value")
	results_table <- results_table$table
	
	# Extract the significant tags based on adjusted p-value cutoff
	cutoff <- p_value_threshold
	significant_results <- results_table[results_table$FDR<cutoff,]
	
	# Make an MA-plot displaying the significant reads
	pdf(file="ma-plot-significant-edger.pdf", width=w/72, height=h/72)	
	significant_indices <- rownames (significant_results)
	plotSmear(dge_list, de.tags = significant_indices, main = "MA plot for significantly\ndifferentially expressed genomic features")
	abline(h = c(-1, 0, 1), col = c("dodgerblue", "darkgreen", "dodgerblue"), lwd = 2)
	legend (x="topleft", legend=c("significant","not significant"), col=c("red","black"),
			cex=1, pch=19)
	dev.off()
}

##############################################
# Analysis using moderated tagwise dispersion #
##############################################

if (dispersion_method == "tagwise") {
	# Calculate the tagwise dispersion
	number_moderating_tags <- 10
	dge_list <- estimateCommonDisp(dge_list)
	dge_list <- estimateTagwiseDisp(dge_list, prior.n = number_moderating_tags)
	
	# Statistical testing
	stat_test <- exactTest(dge_list, common.disp = FALSE)
	
	# Extract results in a nice-looking table
	number_tags <- dim (dge_list$counts) [1]
	results_table <- topTags (stat_test, n=number_tags, adjust.method=p_value_adjustment_method, sort.by="p.value")
	results_table <- results_table$table
	
	# Extract the significant tags based on adjusted p-value cutoff
	cutoff <- p_value_threshold
	significant_results <- results_table[results_table$FDR<cutoff,]
	
	# Make an MA-plot displaying the significant reads
	pdf(file="ma-plot-significant-edger.pdf", width=w/72, height=h/72)	
	significant_indices <- rownames (significant_results)
	plotSmear(dge_list, de.tags = significant_indices, main = "MA plot for significantly\ndifferentially expressed genomic features")
	abline(h = c(-1, 0, 1), col = c("dodgerblue", "darkgreen", "dodgerblue"), lwd = 2)
	legend (x="topleft", legend=c("significant","not significant"), col=c("red","black"),
			cex=1, pch=19)
	dev.off()
}

# Create a table with the original counts per sample together with the statistical tests results
# ready for output in Chipster
# If there are no significant results return a message
if (dim(significant_results)[1] > 0) {
	output_table <- data.frame (dat[significant_indices,], significant_results)
}

# Output the table
if (dim(significant_results)[1] > 0) {
	write.table(output_table, file="de-list-edger.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}

# Also output a BED file for visualization and region matching tools
# source(file.path(chipster.common.path, "bed-utils.R"))
# if (dim(significant_results)[1] > 0) {
# 	empty_column <- character(length(significant_indices))
# 	bed_output <- output_table [,c("chr","start","end")]
# 	bed_output <- cbind(bed_output,empty_column)
# 	bed_output <- cbind(bed_output, output_table[,"logFC"])
# 	bed_output <- sort.bed(bed_output)
# 	write.table(bed_output, file="de-list-edger.bed", sep="\t", row.names=F, col.names=F, quote=F)
# }

# Output a message if no significant genes are found
if (dim(significant_results)[1] == 0) {
	cat("No statistically significantly expressed genes were found. Try again with a less stringent p-value cut-off or multiple testing correction method.", file="edger-log.txt")
}

# Make histogram of p-values with overlaid significance cutoff and uniform distribution
pdf (file="p-value-plot-edger.pdf")
hist(results_table$PValue, breaks=100, col="blue",
		border="slateblue", freq=FALSE,
		main="P-value distribution", xlab="p-value", ylab="proportion (%)")
hist(results_table$FDR, breaks=100, col="red",
		border="slateblue", add=TRUE, freq=FALSE)
abline(h=1, lwd=2, lty=2, col="black")
abline(v=p_value_threshold, lwd=2, lty=2, col="green")
legend (x="topright", legend=c("p-values","adjusted p-values", "uniform distribution", "significance cutoff"), col=c("blue","red","black","green"),
		cex=1, pch=15)
dev.off()

# EOF

# TOOL extract-genes.R: "Extract genes" (Extracts a specified number of genes from the top of the data.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT extract-genes.tsv: extract-genes.tsv 
# PARAMETER number.of.genes: number.of.genes TYPE INTEGER FROM 1 TO 1000000 DEFAULT 50 (Number of genes to extract)


# Extracts genes 
# JTT 29.1.2009

# Loads the data file
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Extracting the genes
dat2<-dat[c(1:number.of.genes),]

# Writing the data to disk
write.table(data.frame(dat2), file="extract-genes.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL filter-by-column.R: "Filter using a column" (Allows the user to filter the genes on the basis of one numerical column. Altered by Mandy to include discrete values)
# INPUT normalized.tsv: normalized.tsv TYPE GENERIC 
# OUTPUT column-filter3.tsv: column-filter3.tsv 
# PARAMETER column: column TYPE COLUMN_SEL (Data column to filter by)
# PARAMETER Type: Type TYPE [Discrete: Discrete, Continuous: Continuous] DEFAULT Continuous (Choose Discrete or Continuous)
# PARAMETER cutoff: cutoff TYPE DECIMAL FROM -100000 TO 100000 DEFAULT 1 (Cut-off for filtering)
# PARAMETER discrete.match: discrete.match TYPE STRING DEFAULT empty (String to search for)
# PARAMETER smaller.or.larger: smaller.or.larger TYPE [equal-to: equal-to, smaller-than: smaller-than, larger-than: larger-than, within: within, outside: outside] DEFAULT smaller-than (Smaller or larger than the cutoff is filtered. Use the within or outside options to filter symmmetrically around two cut-offs, useful for example when searching for 2-fold up- and down-regulated genes.)

# Filtering using a column
# JTT 31.1.2008
# Amanda Miotto 16.1.2009 added the discrete option
#
# MG, 2.3.2010 added the option to filter "within" and "outside" a symmetrical
# range of values

# Parameter settings (default) for testing purposes
#column<-c("chip.microarray001.cel")
#Type<-c("Continuous")
#cutoff<-c(7)
#discrete.match<-c("empty")
#smaller.or.larger<-c("larger-than")


# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

if(Type=="Continuous") {
	# Extract the data to a vector
	f<-dat[,grep(column, colnames(dat))]
	# Filters the data
	if(smaller.or.larger=="equal-to") {
		dat2<-dat[which(f==cutoff),]
	}
	if(smaller.or.larger=="smaller-than") {
		dat2<-dat[which(f<=cutoff),]
	}
	if(smaller.or.larger=="larger-than") {
		dat2<-dat[which(f>=cutoff),]
	}
	if(smaller.or.larger=="outside") {
		cutoff_2 <- -cutoff
		dat2<-dat[which(f>=cutoff | f<=cutoff_2),]
	}
	if(smaller.or.larger=="within") {
		cutoff_2 <- -cutoff
		dat2<-dat[-which(f>=cutoff | f <=cutoff_2),]
	}
	
	# Writing the data to disk
	write.table(dat2, "column-filter3.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}

if (Type=="Discrete"){
	dat2<-dat[grep(discrete.match, dat[,(as.vector(grep(column,names(dat))))]),]
	write.table(dat2, "column-filter3.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}

# TOOL acgh-group-test.R: "Group tests for called copy number data" (Statistical tests between two or more groups for called copy number data. The testing is recommended to be performed after running the Identify common regions from called copy number data tool.)
# INPUT regions.tsv: regions.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT groups-test.tsv: groups-test.tsv 
# OUTPUT groups-test.pdf: groups-test.pdf 
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to test)
# PARAMETER test.statistic: test.statistic TYPE [Chi-square: Chi-square, Wilcoxon: Wilcoxon, KW: KW] DEFAULT Chi-square (The test to use: either Chi-square, Wilcoxon, or Kruskal-Wallis.)
# PARAMETER number.of.permutations: number.of.permutations TYPE INTEGER DEFAULT 10000 (The number of permutations. At least 10000 recommended for final calculations.)
# PARAMETER test.aberrations: test.aberrations TYPE [1: gains, -1: losses, 0: both] DEFAULT 0 (Whether to test only for gains or losses, or both.) 

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2013-04-04

file <- 'regions.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, as.is=TRUE, check.names=FALSE)
phenodata <- read.table('phenodata.tsv', header=TRUE, sep='\t', check.names=FALSE)

groupnames <- unique(phenodata[,column])
groupnames <- groupnames[!is.na(groupnames)]
groupnames <- groupnames[groupnames!='']

first.data.col <- min(grep('chip', names(dat)), grep('flag', names(dat)))
data.info <- dat[,1:(first.data.col-1)]

calls <- as.matrix(dat[,grep('flag', colnames(dat))])

datacgh <- data.frame()
group.sizes <- integer()
for (group in groupnames) {
  group.samples <- which(phenodata[,column] == group & !is.na(phenodata[,column]))
  group.calls <- calls[,group.samples, drop=FALSE]
  if (nrow(datacgh)==0) {
    datacgh <- group.calls
  } else {
    datacgh <- cbind(datacgh, group.calls)
  }
  group.sizes <- c(group.sizes, length(group.samples))
  data.info[,paste('loss.freq.', group, sep='')] <- round(rowMeans(group.calls == -1), digits=3)
  data.info[,paste('gain.freq.', group, sep='')] <- round(rowMeans(group.calls == 1), digits=3)
  if (2 %in% calls)
    data.info[,paste('amp.freq.', group, sep='')] <- round(rowMeans(group.calls == 2), digits=3)
}

# first try parallel computing
prob <- TRUE
try({
  library(CGHtestpar)
  pvs <-  pvalstest(datacgh, data.info, teststat=test.statistic, group=group.sizes, groupnames=groupnames, lgonly=as.integer(test.aberrations), niter=number.of.permutations, ncpus=4)
  fdrs <- fdrperm(pvs)
  prob <- FALSE
}, silent=TRUE)
# if problems, fall back to sequential computing
if (prob) {
  library(CGHtest)
  pvs <-  pvalstest(datacgh, data.info, teststat=test.statistic, group=group.sizes, groupnames=groupnames, lgonly=as.integer(test.aberrations), niter=number.of.permutations)
  fdrs <- fdrperm(pvs)
}

options(scipen=10)
write.table(fdrs, file='groups-test.tsv', quote=FALSE, sep='\t', row.names=TRUE, col.names=TRUE)

FDRplot <- function(fdrs, which, main = 'Frequency Plot with FDR',...) {
  par(mar=c(5,4,4,5) + 0.1)
  cols <- c('blue', 'red')
  names(cols) <- c('gain', 'loss')
  chromosomes <- fdrs$chromosome
  a.freq <- fdrs[,paste(which, '.freq.', groupnames[1], sep='')]
  b.freq <- fdrs[,paste(which, '.freq.', groupnames[2], sep='')]
  fdr <- fdrs$fdr
  if ('num.probes' %in% colnames(fdrs)) {
    chromosomes <- rep(chromosomes, fdrs$num.probes)
    a.freq <- rep(a.freq, fdrs$num.probes)
    b.freq <- rep(b.freq, fdrs$num.probes)
    fdr <- rep(fdr, fdrs$num.probes)
  }
  plot(a.freq, ylim=c(-1,1), type='h', col=cols[which], xlab='chromosomes', ylab='frequency', xaxt='n', yaxt='n', main=main, ...)
  points(-b.freq, type='h', col=cols[which])
  abline(h=0)
  abline(v=0, lty='dashed')
  for(i in cumsum(table(chromosomes)))
    abline(v=i, lty='dashed')
  ax <- (cumsum(table(chromosomes)) + c(0,cumsum(table(chromosomes))[-length(cumsum(table(chromosomes)))])) / 2
  axis(side=1, at=ax, labels=unique(chromosomes))
  axis(side=2, at=c(-1, -0.5, 0, 0.5, 1), labels=c('100 %', ' 50 %', '0 %', '50 %', '100 %'), las=1)
  logfdr <- -log10(fdr)
  logfdr[logfdr == Inf] <- 10
  points(logfdr - 1, type='l')
  labels <- c(0.01, 0.05, 0.025, 0.1, 0.25, 0.5, 1)
  axis(side=4, at=-log10(labels) - 1, labels=labels, las=1)
  mtext('FDR', side=4, line=3)
  mtext(groupnames[1], side=2, line=3, at=0.5)
  mtext(groupnames[2], side=2, line=3, at=-0.5)
}

pdf('groups-test.pdf', paper='a4r', width=0, height=0)
if (test.aberrations != '-1')
  FDRplot(fdrs, 'gain')
if (test.aberrations != '1')
  FDRplot(fdrs, 'loss')
dev.off()

# EOF

# TOOL plot-heatmap.R: Heatmap (Draws a heatmap using Pearson correlation and average linkage. Clustering is done using the function hcluster in which the parameter correlation envokes computation of pearson type of distances.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT heatmap.pdf: heatmap.pdf 
# PARAMETER coloring.scheme: coloring.scheme TYPE [Green-Red: Green-Red, Blue-Yellow: Blue-Yellow, Black-White: Black-White] DEFAULT Blue-Yellow (Coloring scheme for the SOM map)
# PARAMETER cluster.samples.only: cluster.samples.only TYPE [yes: yes, no: no] DEFAULT no (Disables clustering on the genes. This option is convenient if you want to retain a predefined gene order or make a sample clustering heatmap with more than 10000 genes)
# PARAMETER hm.scale: hm.scale TYPE [default: default, none: none, row: row, column: column] DEFAULT default (Indicating if the values should be centered and scaled in either the row direction or the column direction, or none.)
# PARAMETER distance: distance TYPE [euclidean: euclidean, maximum: maximum, manhattan: manhattan, canberra: canberra, binary: binary, pearson: pearson, spearman: spearman, kendall: kendall] DEFAULT pearson (The correlation distance measure to be used for clustering.)
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Heatmap
# JTT 3.10.2007
#
# modified by MG, 21.4.2010, to increase the gene/sample limit and adjust column width to number of genes
# and have the option to cluster samples only
#
# MG 25.11.2010
# Increased the gene/sample limit to 20000
#
# OH 10.10.2012
# removed dependency library("amap")
# added library("MKmisc)
# added parameter hm.scale, see parameter scale of heatmap function, R: help(heatmap)
# added parameter distance, see parameter distfun of heatmap function, to allow for different distance measurements
#
# OH 11.06.2013
# switching back from function hclust (used by function heatmap) to pre-calc dendrogram with function hcluster:
#   visualization "plot-dendrogram.R" produced a different dendrogram than plot-heatmap.R with same parameters
#   because of usage of different functions hcluster and hclust.
#


# Parameter settings (default) for testing purposes
#coloring.scheme<-"Green-Red"
#cluster.samples.only<-"no"
#image.width<-600
#image.height<-600

# Renaming variables
colpar<-coloring.scheme
w<-image.width
h<-image.height

s<-hm.scale
d<-distance

if(d=="pearson") {
   d<-"correlation"
}

# Loading the libraries
library(amap)

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Sanity checks
if (nrow(dat2) > 20000 & cluster.samples.only=="no") {
	stop("CHIPSTER-NOTE: Hierarchical clustering can be run on a maximum of 20000 genes");
}
if (ncol(dat2) > 20000) {
	stop("CHIPSTER-NOTE: Hierarchical clustering can be run on a maximum of 20000 samples");
}

# Loads phenodata
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
colnames(dat2)<-gsub(" ", "", phenodata$description)

# Generating the colors
if(colpar=="Green-Red") {
	heatcol<-colorRampPalette(c("Green", "Red"))(32)
}
if(colpar=="Blue-Yellow") {
	heatcol<-colorRampPalette(c("Blue", "Yellow"))(32)
}
if(colpar=="Black-White") {
	heatcol<-colorRampPalette(c("Black", "LightGrey"))(32)
}

# Plotting

	# set up column margin according to number of genes
	if (nrow(dat2)>200) {
		column_margin <- 5
	}
	if (nrow(dat2)<=200 & nrow(dat2)>50) {
		column_margin <- 10
	}
	if (nrow(dat2)<=50) {
		column_margin <- 15
	}

# Does the clustering
#if (cluster.samples.only=="no") {
#	clustg<-as.dendrogram(hcluster(x=dat2, method="pearson", link="average"))
#}
#clustc<-as.dendrogram(hcluster(x=t(dat2), method="pearson", link="average"))

#library("MKmisc")
#if( d=="euclidean" || d=="maximum" || d=="manhattan" || d=="canberra" || d=="binary" || d=="minkowski" ) {
#	myCorDist=function(x){dist(x,method=d)}
#}
#if( d=="pearson" || d=="spearman" || d=="kendall" || d=="cosine" || d=="mcd" || d=="ogk" ) {
#	myCorDist=function(x){corDist(x,method=d)}
#}

if (cluster.samples.only=="no") {
	clustg<-as.dendrogram(hcluster(x=dat2, method=d, link="average"))
}
clustc<-as.dendrogram(hcluster(x=t(dat2), method=d, link="average"))

pdf(file="heatmap.pdf", width=w/72, height=h/72)
if (cluster.samples.only=="no") {
	if( hm.scale=="default" ) {
		heatmap(x=as.matrix(dat2), Rowv=clustg, Colv=clustc, col=heatcol, margins=c(15, column_margin), labCol=gsub(" ", "", phenodata$description))
		#heatmap(x=as.matrix(dat2), distfun=myCorDist, hclustfun=hclust, col=heatcol, margins=c(15, column_margin), labCol=gsub(" ", "", phenodata$description))
	} else {
		heatmap(x=as.matrix(dat2), Rowv=clustg, Colv=clustc, col=heatcol, scale=s, margins=c(15, column_margin), labCol=gsub(" ", "", phenodata$description))
		#heatmap(x=as.matrix(dat2), distfun=myCorDist, hclustfun=hclust, col=heatcol, scale=s, margins=c(15, column_margin), labCol=gsub(" ", "", phenodata$description))
	}
}
if (cluster.samples.only=="yes") {
	if( hm.scale=="default" ) {
		heatmap(x=as.matrix(dat2), Rowv=NA, Colv=clustc, col=heatcol, margins=c(15, column_margin), labCol=gsub(" ", "", phenodata$description))
		#heatmap(x=as.matrix(dat2), Rowv=NA, distfun=myCorDist, hclustfun=hclust, col=heatcol, margins=c(15, column_margin), labCol=gsub(" ", "", phenodata$description))
	} else {
		heatmap(x=as.matrix(dat2), Rowv=NA, Colv=clustc, col=heatcol, scale=s, margins=c(15, column_margin), labCol=gsub(" ", "", phenodata$description))
		#heatmap(x=as.matrix(dat2), Rowv=NA, distfun=myCorDist, hclustfun=hclust, col=heatcol, scale=s, margins=c(15, column_margin), labCol=gsub(" ", "", phenodata$description))
	}
}
dev.off()

# TOOL norm-illumina.R: Illumina (Normalization of Illumina data. The data needs to be imported to Chipster using the Import tool, which producdes one file for each sample. YOU HAVE TO SPECIFY THE CHIPTYPE.)
# INPUT microarray{...}.tsv: microarray{...}.tsv TYPE CDNA 
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# PARAMETER normalize.chips: "Normalization method" TYPE [none: none, scale: scale, quantile: quantile, vsn: vsn] DEFAULT quantile (Between arrays normalization method)
# PARAMETER beadstudio.version: "Illumina software version" TYPE [3: "GenomeStudio or BeadStudio 3", 2: "BeadStudio 2", 1: "BeadStudio 1"] DEFAULT 3 (Illumina software version)
# PARAMETER chiptype: "Chip type" TYPE [empty: empty, Human-6v1: Human-6v1, HumanRef-8v1: HumanRef-8v1, Human-6v2: Human-6v2, HumanRef-8v2: HumanRef-8v2, Human-6v3: Human-6v3, HumanRef-8v3: HumanRef-8v3, Human-HT12: Human-HT12, Human-HT12v4: Human-HT12v4, Mouse-6v1.0a: Mouse-6v1.0a, MouseRef-8v1.0a: MouseRef-8v1.0a, Mouse-6v1.1: Mouse-6v1.1, MouseRef-8v1.1: MouseRef-8v1.1, Mouse-6v2: Mouse-6v2, MouseRef-8v2: MouseRef-8v2, RatRef-12: RatRef-12] DEFAULT empty ()
# PARAMETER id.type: "Identifier type" TYPE [TargetID: TargetID, ProbeID: ProbeID] DEFAULT ProbeID (Which identifiers to use)
# PARAMETER OPTIONAL produce.flags: "Produce flags" TYPE [yes: yes, no: no] DEFAULT no (Automatic recording of Detection-value as flags)

# Illumina data preprocessing and normalization for separate files
# JTT 17.10.2007
# EK 3.4.2013 Changed parameter naming


# Loads the libraries
library(limma)

# Renaming variables
normba<-normalize.chips

# Reading data
columns<-list(R="sample", Rb="sample", G="sample", Gb="sample")
annotation<-c("identifier")
columns.other<-c("flag")

files<-dir()
files<-files[files!="phenodata.tsv"]
dat<-read.maimages(files=files, columns=columns, annotation=annotation, other.columns=columns.other) 

# Normalization
dat2<-normalizeBetweenArrays(dat$R, method=normba)
if(normba!="vsn") {
   dat2<-log2(dat2)
} else {
   dat2<-dat2
}

# Rounding expression data to two digits
dat2<-round(dat2, digits=2)
dat2<-as.data.frame(dat2)
sample.names<-colnames(dat2)
sample.names<-paste(sample.names, ".tsv", sep="")
names(dat2)<-paste("chip.", sample.names, sep="")
rownames(dat2)<-dat$genes[,1]

# Producing flags
if(produce.flags=="yes") {
   if(length(dat$other$flag)!=0) {
      flags<-as.data.frame(dat$other$flag)
      flags2<-flags
      for(i in 1:ncol(flags)) {
         flags2[,i]<-as.numeric(as.vector(flags[,i]))
      }
      flags<-flags2
      names(flags)<-paste("flag.", names(flags), sep="")
   }
   if(length(dat$other$flag)==0) {
      flags<-matrix(nrow=0, ncol=0)
   }
}

if(produce.flags=="yes" & beadstudio.version==1) {
   m<-0.95
   a<-0.90
   flags[flags>m]<-"P"
   flags[flags>a & flags<=m]<-"M"
   flags[flags<=a]<-"A"
}

if(produce.flags=="yes" & beadstudio.version>1) {
   m<-0.05
   a<-0.10
   flags[flags>m]<-"P"
   flags[flags>a & flags<=m]<-"M"
   flags[flags<=a]<-"A"
}

# Writes out a phenodata table
group<-c(rep("", ncol(dat2)))
training<-c(rep("", ncol(dat2)))
time<-c(rep("", ncol(dat2)))
random<-c(rep("", ncol(dat2)))
if(id.type=="TargetID") {
   if(chiptype=="empty") {
      chiptype<-c("Illumina")
   }
   if(chiptype=="Human-6v1" | chiptype=="HumanRef-8v1") {
      chiptype<-c("illuminaHumanv1")
   }
   if(chiptype=="Human-6v2" | chiptype=="HumanRef-8v2") {
      chiptype<-c("illuminaHumanv2")
   }
   if(chiptype=="Human-6v3" | chiptype=="HumanRef-8v3") {
      chiptype<-c("illuminaHumanv3")
   }
   if(chiptype=="Human-HT12") {
      chiptype<-c("illuminaHumanv3")
   }
   if(chiptype=="Human-HT12v4") {
      chiptype<-c("illuminaHumanv4")
   }
   if(chiptype=="Mouse-6v1.0a" | chiptype=="MouseRef-8v1.0a") {
      chiptype<-c("illuminaMousev1")
   }
   if(chiptype=="Mouse-6v1.1" | chiptype=="MouseRef-8v1.1") {
      chiptype<-c("illuminaMousev1p1")
   }
   if(chiptype=="Mouse-6v2" | chiptype=="MouseRef-8v2") {
      chiptype<-c("illuminaMousev2")
   }
   if(chiptype=="RatRef-12") {
      chiptype<-c("illuminaRatv1")
   }
}

if(id.type=="ProbeID") {
   if(chiptype=="empty") {
      chiptype<-c("Illumina")
   }
   if(chiptype=="Human-6v1" | chiptype=="HumanRef-8v1") {
      chiptype<-c("illuminaHumanv1BeadID")
   }
   if(chiptype=="Human-6v2" | chiptype=="HumanRef-8v2") {
      chiptype<-c("illuminaHumanv2BeadID")
   }
   if(chiptype=="Human-6v3" | chiptype=="HumanRef-8v3") {
      chiptype<-c("illuminaHumanv3BeadID")
   }
   if(chiptype=="Human-HT12") {
      chiptype<-c("illuminaHumanv3BeadID")
   }
   if(chiptype=="Human-HT12v4") {
      chiptype<-c("illuminaHumanv4BeadID")
   }
   if(chiptype=="Mouse-6v1.0a" | chiptype=="MouseRef-8v1.0a") {
      chiptype<-c("illuminaMousev1BeadID")
   }
   if(chiptype=="Mouse-6v1.1" | chiptype=="MouseRef-8v1.1") {
      chiptype<-c("illuminaMousev1p1BeadID")
   }
   if(chiptype=="Mouse-6v2" | chiptype=="MouseRef-8v2") {
      chiptype<-c("illuminaMousev2BeadID")
   }
   if(chiptype=="RatRef-12") {
      chiptype<-c("illuminaRatv1BeadID")
   }
}
lib<-paste(chiptype, ".db", sep="")

# Write out a phenodata
write.table(data.frame(sample=sample.names, chiptype=lib, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

if(chiptype!="Illumina") {
   # Including gene names to data
   library(lib, character.only=T)
   symbol<-gsub("\'", "", data.frame(unlist(as.list(get(paste(chiptype, "SYMBOL", sep="")))))[rownames(dat2),])
   genename<-gsub("\'", "", data.frame(unlist(as.list(get(paste(chiptype, "GENENAME", sep="")))))[rownames(dat2),])
   symbol<-gsub("#", "", symbol)
   genename<-gsub("#", "", genename)
   symbol <- gsub("'", "", symbol)
   genename <- gsub("'", "", genename)
   # Write out expression data
   if(produce.flags=="yes") {
      write.table(data.frame(symbol, description=genename, dat2, flags), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
   } else {
      write.table(data.frame(symbol, description=genename, dat2), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
   }
} else {
   if(produce.flags=="yes") {
      write.table(data.frame(dat2, flags), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
   } else {
      write.table(data.frame(dat2), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
   }
}

# TOOL dea-cufflinks.R: "Differential expression using Cufflinks"  (This tool will perform an analysis for differentially expressed known genes and isoforms using the Cufflinks algorithm. Note that only one filtering criteria should be applied for a given analysis run. When left at default settings, Cufflinks filters out unsuccessfully tested loci, as well as those with a q-value less than 0.05. The tool assumes that all samples belonging to each experiment condition have been merged into one single BAM file.)
# INPUT treatment.bam: "BAM data file for the treatment sample" TYPE GENERIC
# INPUT control.bam: "BAM data file for the control sample" TYPE GENERIC
# OUTPUT cufflinks-log.txt
# OUTPUT de-genes-cufflinks.tsv
# OUTPUT de-isoforms-cufflinks.tsv
# OUTPUT OPTIONAL de-genes-cufflinks.bed
# OUTPUT OPTIONAL de-isoforms-cufflinks.bed
# PARAMETER genome: "Genome" TYPE [hg19: "Human (hg19\)", mm10: "Mouse (mm10\)", mm9: "Mouse (mm9\)", rn4: "Rat (rn4\)"] DEFAULT hg19 (Genome that your reads were aligned against.)
# PARAMETER OPTIONAL p.value.threshold: "P-value cutoff" TYPE DECIMAL FROM 0 TO 1 DEFAULT 1 (The cutoff for statistical significance. Since the p-values are not adjusted to account for multiple testing correction, the cutoff needs to be substantially more conservative than what is usually applied.)
# PARAMETER OPTIONAL q.value.threshold: "Q-value cutoff" TYPE DECIMAL FROM 0 TO 1 DEFAULT 1 (The cutoff for statistical significance. Note that q-values are adjusted to account for multiple testing correction.)                                                
                                                         
# MG, 21.6.2011                                            
# EK, 11.5.2012
# EK, 2.6.2012
# EK, 24.9.2012 updated GTFs, added mm10

# Output that is yet to be supported
# OUTPUT de-cds.tsv
# OUTPUT de-tss.tsv
# OUTPUT de-splicing.tsv
# OUTPUT de-promoters.tsv

# Cufflinks tools setup
source(file.path(chipster.common.path, "bed-utils.R")) # bed sort
cufflinks.binary <- c(file.path(chipster.tools.path, "cufflinks", "cuffdiff"))

# Annotation file setup
if (genome == "hg19") {
	annotation.file <- "Homo_sapiens.GRCh37.68.chr.gtf"
}
if (genome == "mm10") {
	annotation.file <- "Mus_musculus.GRCm38.68.chr.gtf"
}
if (genome == "mm9") {
	annotation.file <- "Mus_musculus.NCBIM37.62.chr.gtf"
}
if (genome == "rn4") {
	annotation.file <- "Rattus_norvegicus.RGSC3.4.68.chr.gtf"
}
annotation.file <- c(file.path(chipster.tools.path, "genomes", "gtf", annotation.file))

# Run differential expression analysis for known genes and transcript isoforms
cufflinks.input.treatment <- "treatment.bam"
cufflinks.input.control <-"control.bam" 
cufflinks.command <- paste(cufflinks.binary, annotation.file, "treatment.bam", "control.bam")
system(cufflinks.command)

# Rename output files for Chipster
system ("mv gene_exp.diff de-genes.tsv")
system ("mv isoform_exp.diff de-isoforms.tsv")
# system ("mv cds_exp.diff de-cds.tsv")
# system ("mv promoters.diff de-promoters.tsv")
# system ("mv splicing.diff de-splicing.tsv")
# system ("mv tss_group_exp.diff de-tss.tsv")

# DE genes
# Extract chromosome locations and add in the first three table columns
dat <- read.table(file="de-genes.tsv", header=T, sep="\t")
regions_list <- as.character(dat$locus)
chr_list <- character(length(regions_list))
start_list <- numeric(length(regions_list))
end_list <- numeric(length(regions_list))
for (count in 1:length(regions_list)) {
	chr_list[count] <- unlist(strsplit (regions_list[count], split=":")) [1]
	start_list[count] <- unlist(strsplit(unlist(strsplit(regions_list[count], split=":"))[2], split="-")) [1]
	end_list[count] <- unlist(strsplit(unlist(strsplit(regions_list[count], split=":"))[2], split="-")) [2]	
}
dat2 <- data.frame(chr=chr_list, start=start_list, end=end_list, dat)

# Rename gene to symbol for compatibility with venn diagram
colnames (dat2) [5] <- "ensembl_id"
colnames (dat2) [6] <- "symbol"
colnames (dat2) [13] <- "ln_FC"

# Filter the gene output based on user defined cutoffs
dat2 <- dat2[dat2$status=="OK",]
results_list <- dat2
if (p.value.threshold < 1 || q.value.threshold < 1) {
	if (p.value.threshold < 1) {
		results_list <- dat2 [dat2$p_value <= p.value.threshold,]
	}
	if (q.value.threshold < 1) {
		results_list <- dat2 [dat2$q_value <= q.value.threshold,]
	}
} else {
	results_list <- results_list[results_list$significant=="yes",]
}
# order according to increasing q-value
results_list <- results_list[order(results_list$q_value, decreasing=FALSE),]
number_genes <- dim (results_list) [1]
row_names <- 1:number_genes
rownames(results_list) <- row_names
write.table(results_list, file="de-genes-cufflinks.tsv", sep="\t", row.names=TRUE, col.names=T, quote=F)

# Also output a BED file for visualization and region matching tools
if (dim(results_list)[1] > 0) {
	bed_output <- results_list[,c("chr","start","end","symbol","ln_FC")]
	# sort according to chromosome location
	bed_output <- sort.bed(bed_output)
	write.table(bed_output, file="de-genes-cufflinks.bed", sep="\t", row.names=F, col.names=F, quote=F)
}

# Report numbers to the log file
if (dim(results_list)[1] > 0) {
	sink(file="cufflinks-log.txt")
	number_genes_tested <- dim(dat)[1]
	number_filtered <- number_genes_tested-dim(results_list)[1]
	number_significant <- dim(results_list)[1]
	cat("GENE TEST SUMMARY\n")
	cat("In total,", number_genes_tested, "genes were tested for differential expression.\n")
	cat("Of these,", number_filtered, "didn't fulfill the technical criteria for testing or the significance cut-off specified.\n")
	cat(number_significant, "genes were found to be statistically significantly differentially expressed.")	
} else {
	cat("GENE TEST SUMMARY\n")
	cat("Out of the", number_genes_tested, "genes tested, there were no statistically significantly differentially expressed ones found.")
}

# DE isoforms
# Extract chromosome locations and add in the first three table columns
dat <- read.table(file="de-isoforms.tsv", header=T, sep="\t")
regions_list <- as.character(dat$locus)
chr_list <- character(length(regions_list))
start_list <- numeric(length(regions_list))
end_list <- numeric(length(regions_list))
for (count in 1:length(regions_list)) {
	chr_list[count] <- unlist(strsplit (regions_list[count], split=":")) [1]
	start_list[count] <- unlist(strsplit(unlist(strsplit(regions_list[count], split=":"))[2], split="-")) [1]
	end_list[count] <- unlist(strsplit(unlist(strsplit(regions_list[count], split=":"))[2], split="-")) [2]	
}
dat2 <- data.frame(chr=chr_list, start=start_list, end=end_list, dat)

# Rename gene to symbol for compability with venn diagram
colnames (dat2) [5] <- "ensembl_id"
colnames (dat2) [6] <- "symbol"
colnames (dat2) [13] <- "ln_FC"

# Filter the isoforms output based on user defined cutoffs
dat2 <- dat2[dat2$status=="OK",]
results_list <- dat2
if (p.value.threshold < 1 || q.value.threshold < 1) {
	if (p.value.threshold < 1) {
		results_list <- dat2 [dat2$p_value <= p.value.threshold,]
	}
	if (q.value.threshold < 1) {
		results_list <- dat2 [dat2$q_value <= q.value.threshold,]
	}
} else {
	results_list <- results_list[results_list$significant=="yes",]
}
# order according to increasing q-value
results_list <- results_list[order(results_list$q_value, decreasing=FALSE),]
number_genes <- dim (results_list) [1]
row_names <- 1:number_genes
rownames(results_list) <- row_names
write.table(results_list, file="de-isoforms-cufflinks.tsv", sep="\t", row.names=TRUE, col.names=T, quote=F)

# Also output a BED file for visualization and region matching tools
if (dim(results_list)[1] > 0) {
	bed_output <- results_list[,c("chr","start","end","symbol","ln_FC")]
	# sort according to chromosome location
	bed_output <- sort.bed(bed_output)
	write.table(bed_output, file="de-isoforms-cufflinks.bed", sep="\t", row.names=F, col.names=F, quote=F)
}

# Report numbers to the log file
if (dim(results_list)[1] > 0) {
	number_genes_tested <- dim(dat)[1]
	number_filtered <- number_genes_tested-dim(results_list)[1]
	number_significant <- dim(results_list)[1]
	cat("\n\nTRANSCRIPT ISOFORMS TEST SUMMARY\n")
	cat("In total,", number_genes_tested, "transcript isoforms were tested for differential expression.\n")
	cat("Of these,", number_filtered, "didn't fulfill the technical criteria for testing or the significance cut-off specified.\n")
	cat(number_significant, "transcripts were found to be statistically significantly differentially expressed.")	
} else {
	cat("\n\nTRANSCRIPT ISOFORMS TEST SUMMARY\n")
	cat("Out of the", number_genes_tested, "transcripts tested, there were no statistically significantly differentially expressed ones found.")
}
sink()

# EOF

# TOOL cuffmerge2.R: "Merge transcript assemblies with Cuffmerge" (Given several transcript GTF files obtained by Cufflinks, Cuffmerge merges them into one. The merged GTF file can be used in differential expression analysis with Cuffdiff.)
# INPUT annotation{...}.gtf: "GTF files" TYPE GTF
# OUTPUT OPTIONAL merged.gtf  

# AMS 21.11.2012
# AMS 11.01.2013 Removed unnecessary outputs
# EK 21.1.2013

# binary
cuffmerge.binary <- c(file.path(chipster.tools.path, "cufflinks2", "cuffmerge"))

# Set PATH so cuffmerge can find gtf_to_sam
cufflinkspath <- c(file.path(chipster.tools.path, "cufflinks2"))
setpathc1 <- c("export PATH=$PATH:", cufflinkspath, ";")
setpathcommand <- paste(setpathc1 , collapse = '')

# Make gtf list file
system("ls *.gtf > assemblies.txt")

# command
command <- paste(setpathcommand, cuffmerge.binary, "assemblies.txt")

# run
#stop(paste('CHIPSTER-NOTE: ', command))
system(command)

# Rename files
if (file.exists("merged_asm/merged.gtf") && file.info("merged_asm/merged.gtf")$size > 0) {
	system("mv merged_asm/merged.gtf merged.gtf")
}

# TOOL bowtie2.R: "Bowtie2 for single end reads" (Bowtie2 aligns reads to genomes or transcriptomes. Results are sorted and indexed bam files, which are ready for viewing in the Chipster genome browser. 
# Note that this Bowtie2 tool uses publicly available genomes. If you would like to align reads against your own datasets, please use the tool \"Bowtie2 for single end reads and own genome\".)
# INPUT reads1.fq: "Reads" TYPE GENERIC
# OUTPUT bowtie2.bam 
# OUTPUT bowtie2.bam.bai 
# OUTPUT bowtie2.log 
# OUTPUT OPTIONAL unaligned_1.fq
# PARAMETER genome: "Genome or transcriptome" TYPE [hg19: "Human genome (hg19\)", mm10: "Mouse genome (mm10\)", Rattus_norvegicus.Rnor_5.0.70.dna.toplevel: "Rat genome (rn5\)", rn4: "Rat genome (rn4\)", Halorubrum_lacusprofundi_ATCC_49239: "Halorubrum lacusprofundi ATCC 49239 genome", Canis_familiaris.CanFam3.1.71.dna.toplevel: "Dog genome (Ensembl canFam3\)", Sus_scrofa.Sscrofa10.2.69.dna.toplevel: "Pig (sus_scrofa10.2.69\)",  Gasterosteus_aculeatus.BROADS1.71.dna.toplevel: "Gasterosteus aculeatus genome (BROADS1.71\)", athaliana.TAIR10: "A. thaliana genome (TAIR10\)", Arabidopsis_lyrata.v.1.0.16: "A. lyrata genome (1.0.16\)", ovis_aries_texel: "Sheep genome (oar3.1\)", miRBase19_Rattus_norvegicus: "Rat miRBase 19", miRBase19_Mus_musculus: "Mouse miRBase 19", miRBase19_Homo_sapiens: "Human miRBase19", Escherichia_coli_n1.GCA_000303635.1.18.dna.toplevel: "E. coli gemone (GCA_000303635.1.18\)"] DEFAULT hg19 (Genome or transcriptome that you would like to align your reads against.)
# PARAMETER strategy: "Alignment strategy to use" TYPE [--very-fast: "Very fast", --fast: "Fast", --sensitive: "Sensitive", --very-sensitive: "Very sensitive", --very-fast-local: "Very fast local", -fast-local: "Fast local", --sensitive-local: "Sensitive local", --very-sensitive-local: "Very sensitive local"] DEFAULT --sensitive (The alignment strategy to be used. Bowtie2 can map the reads using end-to-end or local alignments. When local alignment is used, Bowtie2 might "trim" or "clip" some read characters from one or both ends of the alignment if doing so maximizes the alignment score. Bowtie2 uses heuristics for mapping the reads to the reference genome. Several Bowtie2 parameters affect simultaneously both to the sensitivity and to computing time. In Chipster you can choose the sensitivity level with a set of pre-defined parameter combinations that allow you to tune the balance between the computing time and mapping sensitivity.)
# PARAMETER quality.format: "Quality value format used" TYPE [--phred33: "Sanger - Phred+33", --phred64: "Illumina GA v1.3-1.5 - Phred+66", --ignore-quals: "Fixed 30 for all"] DEFAULT --phred33 (Quality scale used in the fastq-file.)
# PARAMETER alignment.no: "How many valid alignments are reported per read" TYPE [0: "Best based on the mapping quality", 1: "1", 2: "2", 3: "3", 4: "4", 5: "5", 6: "All alignments"] DEFAULT 0 (By default, Bowtie2 reports only the best alignment of the read (based on the mapping quality\). Optionally, if there are several, equally good alignments, you can choose how many of them should be reported?)
# PARAMETER OPTIONAL unaligned.file: "Put unaligned reads to a separate file" TYPE [yes, no] DEFAULT no (Would you like to store unaligned reads to a new fastq file? Note that also multireads will be added to this file, unless you asked them to be put to a separate file.)
# PARAMETER OPTIONAL ma: "Match bonus" TYPE INTEGER FROM 0 TO 10 DEFAULT 2 (Match bonus for a match in local alignment. Default value 2) 
# PARAMETER OPTIONAL mp: "Maximum penalty for mismatch" TYPE INTEGER FROM 0 TO 20 DEFAULT 6 (Maximum penalty for mismatch; lower quality = lower penalty. Default value 6)
# PARAMETER OPTIONAL np: "Penalty for non-ACGTs"  TYPE INTEGER FROM 0 TO 20 DEFAULT 1 ( Sets penalty for positions where the read, reference, or both, contain an ambiguous character such as N. Default: 1.) 
# PARAMETER OPTIONAL rdg.open: "Gap opening penalty for the reads" TYPE INTEGER FROM 0 TO 20 DEFAULT 5 (Gap opening penalty for the reads. Default value: 5. )
# PARAMETER OPTIONAL rdg.ext: "Gap extension penalty for the reads" TYPE INTEGER FROM 0 TO 20 DEFAULT 3 (Gap extension penalty for the reads. Default value: 3. )
# PARAMETER OPTIONAL rfg.open: "Gap opening penalty for the reference" TYPE INTEGER FROM 0 TO 20 DEFAULT 5 (Gap opening penalty for the reference. Default value: 5. )
# PARAMETER OPTIONAL rfg.ext: "Gap extension penalty for the reference" TYPE INTEGER FROM 0 TO 20 DEFAULT 3 (Gap extension penalty for the reference. Default value: 3. )

# KM 23.10.2012
# EK 8.5.2013 replaced samtools -q 1 with Bowtie --no-unal to remove unaligned reads from BAM


# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads1.fq")

# bowtie
bowtie.binary <- c(file.path(chipster.tools.path, "bowtie2", "bowtie2"))
bowtie.genome <- c(file.path(chipster.tools.path, "bowtie2", "indexes" , genome))
command.start <- paste("bash -c '", bowtie.binary)
rdg.value <- paste (rdg.open ,rdg.ext , sep=",")
rfg.value <- paste (rfg.open ,rfg.ext , sep=",")


parameters <- paste(strategy, "--mp", mp,"--np", np, "--rdg", rdg.value, "--rfg", rfg.value, quality.format, "--no-unal")

if ( alignment.no>0){
	if ( alignment.no==6){
		parameters <- paste(parameters, "--all")
	}
	if ( alignment.no<6){
		parameters <- paste(parameters, "-k", alignment.no )
	}
}

# Local alignment specific parameters 
if (strategy == "--very-fast-local" || strategy == "--fast-local" || strategy == "--sensitive-local" || strategy == "--very-sensitive-local" ) {
	parameters <- paste(parameters ,"--local --ma", ma)
}

if (unaligned.file== "yes"){
	parameters <- paste(parameters, "--un unaligned")
}


# output parameters
#output.parameters <- paste(unaligned.output, multiread.output)
#stop(paste('CHIPSTER-NOTE: ', parameters))
# command ending
command.end <- paste("-x", bowtie.genome, "-U reads1.fq 1> alignment.sam 2>> bowtie2.log'")

# run bowtie
bowtie.command <- paste(command.start, parameters, command.end)
#stop(paste('CHIPSTER-NOTE: ', bowtie.command))

echo.command <- paste("echo '", bowtie.command , "' > bowtie2.log" )
system(echo.command)
system(bowtie.command)
system ("ls -l >>  bowtie2.log")
# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

# convert sam to bam
system(paste(samtools.binary, "view -bS alignment.sam -o alignment.bam"))

# sort bam
system(paste(samtools.binary, "sort alignment.bam alignment.sorted"))

# index bam
system(paste(samtools.binary, "index alignment.sorted.bam"))

# rename result files
system("mv alignment.sorted.bam bowtie2.bam")
system("mv alignment.sorted.bam.bai bowtie2.bam.bai")

if (unaligned.file== "yes"){
	system("mv unaligned.1 unaligned_1.fq")
}

# TOOL bedtools-pairtobed.R: "Overlap BEDPE with BED" (Reports overlaps between a BEDPE file and a BED/GFF/VCF file. This tool is based on the BEDTools package.)
# INPUT file.a: "BEDPE file" TYPE GENERIC
# INPUT file.b: "BED file" TYPE GENERIC
# OUTPUT OPTIONAL pairtobed.bed
# OUTPUT OPTIONAL pairtobed.bam
# PARAMETER abam: "File A is BAM format" TYPE [yes, no] DEFAULT no (Select yes if file A is BAM format.)
# PARAMETER OPTIONAL ubam: "Write uncompressed BAM output" TYPE [yes,no] DEFAULT no (Write uncompressed BAM output. Default is to write compressed BAM.) 
# PARAMETER OPTIONAL bedpe: "When using BAM input, write output as BEDPE." TYPE [yes,no] DEFAULT no (When using BAM input, write output as BEDPE. The default is to write output in BAM.) 
# PARAMETER OPTIONAL ed: "Use BAM total edit distance for BEDPE score" TYPE [yes, no] DEFAULT no (Use BAM total edit distance (NM tag\) for BEDPE score. Default for BEDPE is to use the minimum of of the two mapping qualities for the pair. When this option is used the total edit distance from the two mates is reported as the score.)
# PARAMETER OPTIONAL f: "Minimum overlap" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.000000001 (Minimum overlap required as a fraction of A (e.g. 0.05\). Default is 1E-9 (effectively 1bp\))
# PARAMETER OPTIONAL s: "Force strandedness" TYPE [yes, no] DEFAULT no (Enforce strandedness when finding overlaps. Default is to ignore stand. Not applicable with  output type inspan or outspan.)
# PARAMETER type: "Approach to reporting overlaps" TYPE [either, neither, both, xor, notboth, ispan, ospan, notispan, notospan] DEFAULT either (Approach to reporting overlaps between BEDPE and BED.
# either: Report overlaps if either end of A overlaps B.
# neither: Report A if neither end of A overlaps B.
# both: Report overlaps if both ends of A overlap  B.
# xor: Report overlaps if one and only one end of A overlaps B.
# notboth: Report overlaps if neither end or one and only one end of A overlap B.  That is, xor + neither.
# ispan: Report overlaps between [end1, start2] of A and B. Note: If chrom1 <> chrom2, entry is ignored.
# ospan: Report overlaps between [start1, end2] of A and B. Note: If chrom1 <> chrom2, entry is ignored.
# notispan: Report A if ispan of A doesn't overlap B. Note: If chrom1 <> chrom2, entry is ignored.
# notospan: Report A if ospan of A doesn't overlap B. Note: If chrom1 <> chrom2, entry is ignored.)

# AMS 23.4.2012

# binary
binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "pairToBed"))

# optional options
outfile <- "pairtobed.bed"
options <- paste("")
if (abam == "yes") {
	outfile <- "pairtobed.bam"
	if (ubam == "yes") {
		options <- paste(options, "-ubam")
	}
	if (bed == "yes") {
		options <- paste(options, "-bedbe")
		outfile <- "pairtobed.bed"
	}
}

if (ed == "yes") {options <- paste(options, "-ed")}
options <- paste(options, "-f", f) 
if (s == "yes") {options <- paste(options, "-s")}
options <- paste(options, "-type", type) 

# input files
# input files
if (abam == "yes") {options <- paste(options, "-abam file.a -b file.b")}
if (abam == "no") {options <- paste(options, "-a file.a -b file.b")}


# command
command <- paste(binary, options, ">", outfile)

# run
system(command)

if (file.exists("pairtobed.bed")){
	if (file.info("pairtobed.bed")$size == 0) {
		system("echo \"# No results found\" > pairtobed.bed")
	}	
}

# TOOL ngs-filter-annotations.R: "Filter table by column term" (Allows the user to filter the table rows on the basis of terms in any text column.)
# INPUT annotations.tsv: annotations.tsv TYPE GENERIC 
# OUTPUT filtered-NGS-annotations.tsv: filtered-NGS-annotations.tsv 
# PARAMETER column: column TYPE COLUMN_SEL (Data column to filter by)
# PARAMETER match.term: match.term TYPE STRING DEFAULT empty (String to search for.)

# Filter NGS annotation tables on the basis of a text term in a column
# MG 29.5.2010

# Loads the normalized data
file<-c("annotations.tsv")
dat <- read.table(file, header=T, sep="\t", comment.char="")

# Extract the data from the column in question
dat2 <- dat[grep(match.term, dat[,(as.vector(grep(column,names(dat))))]),]

# Write the data to disk
write.table (dat2, "filtered-NGS-annotations.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# TOOL dea-deseq.R: "Differential expression using DESeq" (Differential expression analysis using the DESeq Bioconductor package. You can create the input count table and phenodata file by the tool Utilities - Define NGS experiment.)
# INPUT data.tsv TYPE GENERIC
# INPUT phenodata.tsv TYPE GENERIC
# OUTPUT OPTIONAL de-list-deseq.tsv
# OUTPUT OPTIONAL de-list-deseq.bed
# OUTPUT OPTIONAL ma-plot-significant-deseq.pdf
# OUTPUT OPTIONAL dispersion-plot-deseq.pdf
# OUTPUT OPTIONAL p-value-plot-deseq.pdf
# PARAMETER column: "Column describing groups" TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to test.)
# PARAMETER normalization: "Apply normalization" TYPE [yes, no] DEFAULT yes (Should effective library size be estimated. This corrects for RNA composition bias. Note that if you have supplied library size in phenodata, size factors are calculated based on the library size total, and composition bias is not corrected.)
# PARAMETER replicates: "Disregard replicates" TYPE [yes, no] DEFAULT no (You need to have biological replicates of each experiment condition in order to estimate the biological and experimental variability. If biological replicates are available for only one condition, DESeq will estimate variability using the replicates of that single condition. However, this is only an approximation and reduces the reliability of the results. If there are no replicates at all, the variance is estimated using the samples from the different conditions as replicates. This approximation is even less reliable and affects results accordingly.)
# PARAMETER fitting_method: "Use fitted dispersion values" TYPE [maximum: "when higher than original values", fit-only: "always"] DEFAULT maximum (Should the dispersion of counts for a gene be replaced with the fitted value from the dispersion model always, or only when the fitted value is larger? The latter option is more conservative and minimizes false positives. Replacing always optimises the balance between false positives and false negatives.)
# PARAMETER dispersion_estimate:"Dispersion estimate" TYPE [parametric: "parametric", local: "local"] DEFAULT local (The dispersion can be estimated either using a local fit, which is suitable in most cases - including when there are no biological independent replicate samples - or using a two-coefficient parametric model, which may be preferable under certain circumstances.)
# PARAMETER p.value.adjustment.method: "Multiple testing correction" TYPE [none, bonferroni: "Bonferroni", holm: "Holm", hochberg: "Hochberg", BH: "BH", BY: "BY"] DEFAULT BH (Multiple testing correction method.)
# PARAMETER p.value.cutoff: "P-value cutoff" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (The cutoff for statistical significance.)
# PARAMETER image_width: "Plot width" TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image.)
# PARAMETER image_height: "Plot height" TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image.)


############################################################
#                                                          
# Analysis workflow using DESeq for normalization and     
# statistical testing for finding differentially expressed genes                                           
#                                                          
# MG, 7.2.2012                                             
# EK, 6.5.2012, clarified texts
# EK, 12.5.2013, fixed the fitting method parameter
############################################################

# Loads the libraries
library(DESeq)

# Set parameters for testing
# column <- "group"
# replicates <- "yes"
# normalization <- "yes"
# fitting_method <- "maximum"
# dispersion_estimate <- "parametric"
# p.value.adjustment.method <- "BH"
# p.value.cutoff <- 0.1
# image_height <- 600
# image_width <- 600

# Loads the counts data
file <- c("data.tsv")
dat <- read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
annotations <- dat[,-grep("chip", names(dat))]
dat2 <- dat[,grep("chip", names(dat))]

# Test needs a parameter "groups" that specifies the grouping of the samples
phenodata <- read.table("phenodata.tsv", header=T, sep="\t")
groups <- as.character (phenodata[,pmatch(column,colnames(phenodata))])
group_levels <- levels(as.factor(groups))
number_samples <- length(groups)

# If the library_size column of phenodata contains data, then use that to estimate size factors
lib_size <- as.numeric(phenodata$library_size)
if (is.na(lib_size[1])) estimate_lib_size <- "TRUE" else estimate_lib_size <- "FALSE"
lib_size <- lib_size/mean(lib_size)


# Sanity checks
# only 2 group comparison is supported
if (length(unique(groups))==1 | length(unique(groups))>=3) {
	stop("CHIPSTER-NOTE: You need to have exactly two groups to run this analysis")
}
# if no biological replicates, force blind mode in dispersion estimation
if (number_samples == 2 && replicates == "no")  {
	stop("CHIPSTER-NOTE: You need to have independent biological replicates for at least one of the experiment conditions in order to reliably estimate dispersion. Alternatively, run the analysis with the disregard replicates parameter set to yes, but note that statistical power may be significantly reduced and the false positive rate may increase.")
}
if (number_samples == 2 && replicates == "yes")  {
	blind_dispersion <- TRUE
} else {
	blind_dispersion <- FALSE
}

# Create a counts data object
counts_data <- newCountDataSet(dat2, groups)

# Calculate scaling factors based on estimated library size, unless it is given in phenodata
# If normalization is turned off, set the size factors to 1 for all samples
if (normalization == "yes") {
	if (estimate_lib_size) {
		counts_data <- estimateSizeFactors(counts_data)
	} else {
		counts_data <- estimateSizeFactors(counts_data)
		sizeFactors(counts_data) <- lib_size
	}
} else {
	sizeFactors(counts_data) <- 1
}

# Estimate dispersion values for each gene and replace with fitted values
# Use sharingMode parameter to control how conservative the replacement will be
# Use fitType to control for parametric or local fit
if (blind_dispersion) {
	counts_data <- estimateDispersions(counts_data, method="blind", sharingMode="fit-only",
			fitType=dispersion_estimate)
} else {
	counts_data <- estimateDispersions(counts_data, method="pooled", sharingMode=fitting_method,
			fitType=dispersion_estimate)
}


# Function that produces a qc plot to check dispersion estimates
plotDispEsts <- function(cds) {
	plot(rowMeans( counts(cds, normalized=TRUE)), fitInfo(cds)$perGeneDispEsts,pch = '.', 
			log="xy", main="Dispersion plot", xlab="normalized counts", ylab="dispersion")
	xg <- 10^seq( -.5, 5, length.out=300)
	lines(xg, fitInfo(cds)$dispFun(xg), col="red")
	legend(x="topright", legend="fitted dispersion", col="red", cex=1, pch="-")
}

# Make dispersion plot
pdf(file="dispersion-plot-deseq.pdf")
plotDispEsts(counts_data)
dev.off()

# Calculate statistic for differential expression
results_table <- nbinomTest(counts_data, group_levels[2], group_levels[1] )

# Merge with original data table
output_table <- cbind (dat, results_table[,-1])

# Adjust p-values
output_table$padj <- p.adjust(output_table$pval, method=p.value.adjustment.method)

# Filter out the significant ones
significant_table <- output_table[ (output_table$padj <  p.value.cutoff),]

# Remove rows with NA adjusted p-values
significant_table <- significant_table[! (is.na(significant_table$padj)),]

# Order results based on raw p-values
significant_table <- significant_table[ order(significant_table$pval), ] 

# Output the table
if (dim(significant_table)[1] > 0) {
	write.table(significant_table, file="de-list-deseq.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}

# Also output a BED file for visualization and region matching tools
if (dim(significant_table)[1] > 0) {
	empty_column <- character(length(significant_table[1]))
	bed_output <- significant_table [,c("chr","start","end")]
	bed_output <- cbind(bed_output,empty_column)
	bed_output <- cbind(bed_output, significant_table[,"log2FoldChange"])
	write.table(bed_output, file="de-list-deseq.bed", sep="\t", row.names=F, col.names=F, quote=F)
}

# Make histogram of p-values with overlaid significance cutoff and uniform distribution
pdf (file="p-value-plot-deseq.pdf")
hist(output_table$pval, breaks=100, col="blue",
		border="slateblue", freq=FALSE,
		main="P-value distribution", xlab="p-value", ylab="proportion (%)")
hist(output_table$padj, breaks=100, col="red",
		border="slateblue", add=TRUE, freq=FALSE)
abline(h=1, lwd=2, lty=2, col="black")
abline(v=p.value.cutoff, lwd=2, lty=2, col="green")
legend (x="topright", legend=c("p-values","adjusted p-values", "uniform distribution", "significance cutoff"), col=c("blue","red","black","green"),
		cex=1, pch=15)
dev.off()

# Define function for making MA-plot of significant findings
plotDE <- function(res)
	plot(res$baseMean, res$log2FoldChange,
			log="x", pch=20, cex=.25, col = ifelse( res$padj < p.value.cutoff, "red", "black"),
			main="MA plot for significantly\ndifferentially expressed genes", xlab="mean counts", ylab="log2(fold change)") 

# Make MA-plot
pdf(file="ma-plot-significant-deseq.pdf")
plotDE(results_table)
legend (x="topleft", legend=c("significant","not significant"), col=c("red","black"),
		cex=1, pch=19)
abline(h = c(-1, 0, 1), col = c("dodgerblue", "darkgreen", "dodgerblue"), lwd = 2)
dev.off()

# EOF

# TOOL cufflinks2.R: "Assemble reads into transcripts using Cufflinks" (Given aligned RNA-seq reads as a BAM file, Cufflinks assembles the alignments into a parsimonious set of transcripts. It then estimates the relative abundances of these transcripts based on how many reads support each one. It is recommended to create the input BAM files using the TopHat aligner. You can merge the resulting GTF files of several samples using the Cuffmerge tool, and use the merged GTF file in differential expression analysis using Cuffdiff.)
# INPUT alignment.bam: "BAM file" TYPE BAM
# INPUT OPTIONAL annotation.gtf: "GTF for reference annotation based transcript assembly" TYPE GTF
# OUTPUT OPTIONAL genes.fpkm_tracking.tsv  
# OUTPUT OPTIONAL isoforms.fpkm_tracking.tsv
# OUTPUT OPTIONAL skipped.gtf
# OUTPUT OPTIONAL transcripts.gtf
# PARAMETER OPTIONAL normalize: "Upper-quartile normalization " TYPE [yes, no] DEFAULT no (Upper quartile normalization can improve robustness of differential expression calls for less abundant genes and transcripts. It excludes very abundant genes when normalizing expression values for the number of reads in each sample by using the upper quartile of the number of fragments mapping to individual loci.)
# PARAMETER OPTIONAL mmread: "Enable multi-mapped read correction" TYPE [yes, no] DEFAULT no (By default, Cufflinks will uniformly divide each multi-mapped read to all of the positions it maps to. If multi-mapped read correction is enabled, Cufflinks will re-estimate the transcript abundances dividing each multi-mapped read probabilistically based on the initial abundance estimation, the inferred fragment length and fragment bias, if bias correction is enabled.)
# PARAMETER OPTIONAL bias: "Bias correction for stranded data" TYPE [yes, no] DEFAULT no (Cufflinks can detect sequence-specific bias and correct for it in abundance estimation. Note that bias correction works only if your data was produced with a strand specific protocol.)
# PARAMETER OPTIONAL genome: "Genome used for bias correction" TYPE [hg19: "Human genome (hg19\)", mm9: "Mouse genome (mm9\)", mm10: "Mouse genome (mm10\)", rn4: "Rat genome (rn4\)"] DEFAULT hg19 (Genome used for bias correction.)


# AMS 21.11.2012

# binary
cufflinks.binary <- c(file.path(chipster.tools.path, "cufflinks2", "cufflinks"))

# options
cufflinks.options <- ""
if (normalize == "yes") {
	cufflinks.options <- paste(cufflinks.options, "-N")
}
if (mmread == "yes") {
	cufflinks.options <- paste(cufflinks.options, "-u")
}
if (bias == "yes") {
	if (genome == "hg19"){
		genomefile <- "hg19.fa"
	}
	if (genome == "mm9"){
		genomefile <- "mm9.fa"
	}
	if (genome == "mm10"){
		genomefile <- "mm10.fa"
	}
	if (genome == "rn4"){
		genomefile <- "rn4.fa"
	}
	genomefile <- c(file.path(chipster.tools.path, "genomes", "fasta", "nochr", genomefile))
	cufflinks.options <- paste(cufflinks.options, "-b", genomefile)
}
if (file.exists("annotation.gtf")){
	cufflinks.options <- paste(cufflinks.options, "-g", "annotation.gtf")
}	

# command
command <- paste(cufflinks.binary, cufflinks.options, "-q", "-o tmp", "alignment.bam")

# run
system(command)

# Rename files
if (file.exists("tmp/genes.fpkm_tracking") && file.info("tmp/genes.fpkm_tracking")$size > 0) {
	system("mv tmp/genes.fpkm_tracking genes.fpkm_tracking.tsv")
}
if (file.exists("tmp/isoforms.fpkm_tracking") && file.info("tmp/isoforms.fpkm_tracking")$size > 0) {
	system("mv tmp/isoforms.fpkm_tracking isoforms.fpkm_tracking.tsv")
}
if (file.exists("tmp/skipped.gtf") && file.info("tmp/skipped.gtf")$size > 0) {
	system("mv tmp/skipped.gtf skipped.gtf")
}
if (file.exists("tmp/transcripts.gtf") && file.info("tmp/transcripts.gtf")$size > 0) {
	system("mv tmp/transcripts.gtf transcripts.gtf")
}

# TOOL acgh-update-aberration-frequencies.R: "Update aberration frequencies for called copy number data" (Calculate frequencies of losses, gains and amplifications for called aCGH data. They are automatically calculated by the Call copy number aberrations from aCGH data tool, so normally there is no need to run this tool separately. But if you use e.g. the Extract samples from dataset tool, the frequencies should be updated using this script.)
# INPUT aberrations.tsv: aberrations.tsv TYPE GENE_EXPRS 
# OUTPUT aberration-frequencies.tsv: aberration-frequencies.tsv 

# calculate-aberration-frequencies.R
# Ilari Scheinin <firstname.lastname@gmail.com>
# 2011-12-13

# read data set
dat <- read.table('aberrations.tsv', header=TRUE, sep='\t', as.is=TRUE, row.names=1)
calls <- dat[,grep('flag', colnames(dat))]

# calculate aberration frequencies
dat$loss.freq <- round(rowMeans(calls == -1), digits=3)
dat$gain.freq <- round(rowMeans(calls == 1), digits=3)
if (2 %in% calls) {
  dat$amp.freq <- round(rowMeans(calls == 2), digits=3)
} else {
  dat$amp.freq <- NULL
}

write.table(dat, file='aberration-frequencies.tsv', quote=FALSE, sep='\t', col.names=TRUE, row.names=TRUE)

# EOF

# TOOL prinseq-AT-trimmer.R: "Trim reads for poly-A/T tails" (Removes poly-A/T tails from reads. This tool is based on the PRINSEQ package.)
# INPUT fastqfile: "Input sequence set" TYPE GENERIC
# OUTPUT trimmed.fastq
# OUTPUT OPTIONAL trim.log
# PARAMETER OPTIONAL trim.tail.left: "Trim left tails" TYPE INTEGER (Trim poly-A/T tail with a minimum length of the given value at the 5-prime end.)
# PARAMETER OPTIONAL trim.tail.right: "Trim right tails" TYPE INTEGER (Trim poly-A/T tail with a minimum length of the given value at the 3-prime end.)
# PARAMETER OPTIONAL input.mode: "Input file format" TYPE [ fq: "FASTQ", fa: "FASTA"] DEFAULT fq (Define the file format of the reads file)
# PARAMETER OPTIONAL log.file: "Write a log file" TYPE [ n: "No", y: "Yes"] DEFAULT y (Write a log file)

# KM 17.1.2012

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("fastqfile")

system("
wget http://sourceforge.net/projects/prinseq/files/standalone/prinseq-lite-0.17.3.tar.gz
tar zxf prinseq-lite-0.17.3.tar.gz
")

# binary
#binary.prinseq <- c(file.path(chipster.tools.path, "prinseq", "bin", "prinseq-lite.pl"))
binary.prinseq <- c("perl prinseq-lite-0.17.3/prinseq-lite.pl")



trim.params <- paste(" ")

if (!is.na(trim.tail.left)) {
	trim.params <- paste(trim.params, "-trim_tail_left",  trim.tail.left)
}

if (!is.na(trim.tail.right)) {
	trim.params <- paste(trim.params, "-trim_tail_right",  trim.tail.right)
}

if (input.mode == "fq") {
 trim.command <- paste(binary.prinseq, trim.params, "-fastq fastqfile -out_good trimmed")
}

if (input.mode == "fa") {
	trim.command <- paste(binary.prinseq, trim.params, "-fasta fastqfile -out_good trimmed")
}


if (log.file == "y") {
	system("echo Running PRINSEQ filtering with command: > trim.log")
	echo.command <- paste("echo '", trim.command, "'>> trim.log")
	system(echo.command)
	trim.command <- paste(trim.command, "-verbose 2>> trim.log")
}


system(trim.command)
#Make sure something is in the output
if (input.mode == "fq") {
	system("if [ ! -e  trimmed.fastq ] ; then echo 'Trimming produced an empty trimmed.fastq sequence set' >> trim.log ; echo '' > trimmed.fastq ; fi")
}

if (input.mode == "fa") {
	system("if [ ! -e  trimmed.fasta ] ; then echo 'Trimming produced an empty trimmed.fasta sequence set' >> trim.log ; echo '' > trimmed.fasta ; fi")
}


#stop(paste('CHIPSTER-NOTE: ', filter.command))

# TOOL acgh-convert-from-probes-to-genes.R: "Detect genes from called copy number data" (Using the chromosomal locations of the probes of an aCGH data set, convert the data from probe-based to gene-based. The probes from which the copy number call for a given gene are determined as follows. If there are probes overlapping with the position of the gene, they are used. In case of no overlaps, the last preceding and first tailing probe are used.)
# INPUT aberrations.tsv: aberrations.tsv TYPE GENE_EXPRS 
# OUTPUT gene-aberrations.tsv: gene-aberrations.tsv 
# PARAMETER method.for.calls: method.for.calls TYPE [majority: majority, unambiguous: unambiguous] DEFAULT majority (The method majority means that if more than 50% of these probes give an aberrated signal, that call is used for the gene. The unambiguous method requires that all of the probes have the same call, otherwise the gene will be labeled as normal.)
# PARAMETER method.for.others: method.for.others TYPE [mean: mean, median: median] DEFAULT mean (Whether to use the mean or the median for calculating other data than copy number calls.)
# PARAMETER genome.build: genome.build TYPE [GRCh37: GRCh37, NCBI36: NCBI36, NCBI35: NCBI35, NCBI34: NCBI34] DEFAULT GRCh37 (The genome build to use for fetching the gene coordinates.)

# convert-cn-probes-to-genes.R
# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-12-20

dat <- read.table('aberrations.tsv', header=TRUE, sep='\t', as.is=TRUE, row.names=1)

pos <- c('chromosome','start','end')
if (length(setdiff(pos, colnames(dat)))!=0)
  stop('CHIPSTER-NOTE: This script can only be run on files that have the following columns: chromosome, start, end.')

# load genes
# genes <- read.table(paste('http://www.cangem.org/download.php?platform=CG-PLM-26&flag=', genome.build, sep=''), sep='\t', header=TRUE, row.names=1, as.is=TRUE)
genes <- read.table(file.path(chipster.tools.path, 'CanGEM', 'Ensembl_Genes', paste(genome.build, '.txt', sep='')), sep='\t', header=TRUE, row.names=1, as.is=TRUE)
colnames(genes) <- tolower(colnames(genes))
colnames(genes)[colnames(genes)=='chr'] <- 'chromosome'
colnames(genes)[colnames(genes)=='band'] <- 'cytoband'
colnames(genes)[colnames(genes)=='cnv.per.mb'] <- 'cnv.per.Mb'

# remove genes from chromosomes not present in the array data
genes <- genes[genes$chromosome %in% dat$chromosome,]

# define the functions for calculating gene copy numbers from probe copy numbers
unambiguous <- function(values) {
  values <- values[!is.na(values)]
  uniques <- unique(values)
  if (length(uniques) == 1)
    return(uniques)
  return(0)
}
majority <- function(values) {
  values <- values[!is.na(values)]
  amps <- mean(values==2)
  if (amps > 0.5) return(2)
  # treat amplifications as gains
  values[values==2] <- 1
  gains <- mean(values==1)
  if (gains > 0.5) return(1)
  losses <- mean(values==-1)
  if (losses > 0.5) return(-1)
  return(0)
}

calls <- dat[,grep("^flag\\.", colnames(dat))]
logratios <- dat[,grep("^chip\\.", colnames(dat))]

# identify additonal matrices (segmented, ...) present in the data
x <- colnames(dat)
suffix <- sub('^chip\\.', '', x[grep('^chip\\.', x)[1]])
matrices <- sub(suffix, '', x[grep(suffix, x)])
matrices <- matrices[matrices != 'flag.']
matrices <- matrices[matrices != 'chip.']
for (m in matrices)
  logratios <- cbind(logratios, dat[,grep(m, colnames(dat))])

get.gene.data <- function(x) {
  chr <- x['chromosome']
  start <- as.integer(x['start'])
  end <- as.integer(x['end'])
  # are there probes overlapping with the position of the gene
  overlapping.probes <- which(dat$chromosome == chr &
                                     dat$end >= start &
                                   dat$start <= end)
  if (length(overlapping.probes) > 0) {
    # if yes, use those probes to calculate the copy number
    gene.calls <- apply(calls[overlapping.probes,], 2, method.for.calls)
    gene.logratios <- apply(logratios[overlapping.probes,], 2, method.for.others, na.rm=TRUE)
  } else {
    # if not, use the last preceding and the first tailing probe
    preceding.probes <- which(dat$chromosome == chr &
                                     dat$end <  start)
    tailing.probes <- which(dat$chromosome == chr &
                                 dat$start >  end)
    adjacent.probes <- preceding.probes[length(preceding.probes)]
    if (length(tailing.probes) > 0)
      adjacent.probes <- c(adjacent.probes, tailing.probes[1])
    if (length(adjacent.probes) > 0) {
      gene.calls <- apply(calls[adjacent.probes,], 2, method.for.calls)
      gene.logratios <- apply(logratios[adjacent.probes,], 2, method.for.others, na.rm=TRUE)
    } else {
      gene.calls <- 0
      gene.logratios <- 0
    }
  }
  c(gene.calls, gene.logratios)
}

# first try parallel computing
prob <- TRUE
try({
  library(snowfall)
  sfInit(parallel=TRUE, cpus=4)
  sfExport(list=c('dat', 'calls', 'logratios', 'method.for.calls', 'method.for.others', 'unambiguous', 'majority'))
  gene.calls.and.logratios <- t(sfApply(genes, 1, get.gene.data))
  sfStop()
  prob <- FALSE
}, silent=TRUE)
# if problems, fall back to sequential computing
if (prob)
  gene.calls.and.logratios <- t(apply(genes, 1, get.gene.data))

calls.bygene <- gene.calls.and.logratios[,1:ncol(calls)]
genes$loss.freq <- mean(as.data.frame(t(calls.bygene==-1)))
genes$gain.freq <- mean(as.data.frame(t(calls.bygene==1)))
if (2 %in% calls.bygene)
    genes$amp.freq <- mean(as.data.frame(t(calls.bygene==2)))
genes <- cbind(genes, gene.calls.and.logratios)

write.table(genes, file='gene-aberrations.tsv', sep="\t", quote=FALSE, row.names=TRUE, col.names=TRUE)

# EOF

## Install packages, and dependencies, from CRAN
install.packages(repos="http://ftp.sunet.se/pub/lang/CRAN", dependencies=TRUE, pkgs="locfit")

install.packages(repos="http://ftp.sunet.se/pub/lang/CRAN", dependencies=TRUE, pkgs="MKmisc")
install.packages(repos="http://ftp.sunet.se/pub/lang/CRAN", dependencies=TRUE, pkgs="e1071")
install.packages(repos="http://ftp.sunet.se/pub/lang/CRAN", dependencies=TRUE, pkgs="GeneCycle")
install.packages(repos="http://ftp.sunet.se/pub/lang/CRAN", dependencies=TRUE, pkgs="fastICA")

install.packages(repos="http://ftp.sunet.se/pub/lang/CRAN", c('flexmix', 'R2HTML', 'snowfall'))

install.packages(repos="http://ftp.sunet.se/pub/lang/CRAN", dependencies=TRUE, pkgs="png")


# zinba and dependencies
install.packages(repos="http://ftp.sunet.se/pub/lang/CRAN", dependencies=TRUE, c('multicore','doMC','foreach','quantreg','R.utils'))
system("wget http://zinba.googlecode.com/files/zinba_2.02.03.tar.gz")
install.packages("zinba_2.02.03.tar.gz", repos=NULL)


## Install packages from Bioconductor

source("http://bioconductor.org/biocLite.R")

# Bionductor core packages
biocLite()

# Bioconductor specific packages
biocLite("DESeq")
biocLite("RPA")

# hdrcde
biocLite("hdrcde")

# methylumi packages
biocLite(c("lumi", "methylumi")) # install hdrcde dependencies manually
biocLite("IlluminaHumanMethylation450k.db") # annotation package, not needed if all annotation packages from the repository are installed
biocLite("IlluminaHumanMethylation27k.db") # annotation package, not needed if all annotation packages from the repository are installed

biocLite("VariantAnnotation")
biocLite("edgeR")
biocLite("TxDb.Hsapiens.UCSC.hg19.knownGene")

biocLite("DEXSeq")

biocLite("BSgenome.Hsapiens.UCSC.hg19")

biocLite("vegan")
biocLite("rich")
biocLite("BiodiversityR")
biocLite("pegas")
biocLite("labdsv")

biocLite(c('CGHregions', 'CGHcall', 'CGHbase', 'GOstats', 'impute'))


# SNP 5.0 / 6.0
biocLite("crlmm")
biocLite("oligo")
biocLite("pd.mapping50k.hind240")
biocLite("pd.mapping50k.xba240")
biocLite("pd.mapping250k.nsp")
biocLite("pd.mapping250k.sty")
biocLite("pd.genomewidesnp.5")
biocLite("pd.genomewidesnp.6")

biocLite("genomewidesnp6Crlmm")
biocLite("genomewidesnp5Crlmm")

biocLite("human1mduov3bCrlmm")          #Illumina
biocLite("human1mv1cCrlmm")             #Illumina
biocLite("human370quadv3cCrlmm")        #Illumina
biocLite("human370v1cCrlmm")            #Illumina
biocLite("human550v3bCrlmm")            #Illumina
biocLite("human610quadv1bCrlmm")        #Illumina
biocLite("human650v3aCrlmm")            #Illumina
biocLite("human660quadv1aCrlmm")        #Illumina
biocLite("humanomni1quadv1bCrlmm")      #Illumina
biocLite("humanomniexpress12v1bCrlmm")  #Illumina

biocLite("sva")

# TOOL norm-lme.R: "Random effects" (Removes the possible effect of random effects from the normalized expression values of every gene. This can be used for removing batch effects due to day, technician, etc. from the data. You should have a column in your phenodata that defines the random effects groups, currently only two groups are allowed.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT normalized-lme.tsv: normalized-lme.tsv 
# PARAMETER column.groups: column.groups TYPE METACOLUMN_SEL DEFAULT group (Phenodata column containing group effects)
# PARAMETER column.random: column.random TYPE METACOLUMN_SEL DEFAULT random (Phenodata column containing random effects groups)
# PARAMETER error.handle: "Error handling method" TYPE [remove: remove, na: NA, add.noise: add.noise] DEFAULT remove (Should genes for which effect estimation fails be removed, marked with NAs or analysed by adding noise to them) 
# PARAMETER random.noise: random.noise TYPE DECIMAL FROM 0 TO 10000 DEFAULT 0.00001 (Random noise added to gene expression values. Use very small values like 0.00001 or less)

# JTT: 12.7.2006 Crated linear Mixed Model
# JTT: 19.10.2006: Modified to use nlme library
# MK: 22.05.2013: Noise factor parameter added 

#column.groups<-"group"
#column.random<-"age"

# Loads the libraries
library(nlme)

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Loads phenodata
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")

# Test needs a parameter "groups" that specifies the grouping of the samples
# and a parameter random that specifies the random effect such as day or technician
groups<-phenodata[,grep(column.groups, colnames(phenodata))]
random<-phenodata[,grep(column.random, colnames(phenodata))]

# Sanity check
if(length(unique(random))==1) {
   stop("CHIPSTER-NOTE: You only have one level in variable random. Specify at least two levels for the random effect")
}

# Fits a linear mixed model for every gene, and saves residuals into a table
# Assumes no interaction between random and groups
# If estimation fails for a particular gene, return NAs
dat3<-dat2
error.vec <- rep(0, nrow(dat3))
for(i in 1:nrow(dat3)) {
	gene <- as.vector(as.numeric(dat3[i,]))
	residuals <- try(resid(lme(fixed=gene~groups, random=gene~1|random, control=list(maxIter=10000), method="REML")), silent=T)
	if(class(residuals) == "try-error") { 
		dat3[i,] <- rep(NA, length(gene));	
	} else {
		dat3[i,] <- residuals;
		error.vec[i] <- 1
	}
}

# Keep genes for which batch effects were estimated
if(error.handle == "remove") {
	dat3 <- dat3[which(error.vec==1),]
	calls <- calls[which(error.vec==1),]
}

# Re-analyse genes for which batch effects could not be estimated by adding random noise to their gene expression estimates 
if(error.handle == "add.noise") {
	for(i in which(error.vec == 0)) {
		residual.counter = 0
		class(residuals) <- "try-error"
		while(residual.counter < 1000 & class(residuals) == "try-error") {
			gene <- as.vector(as.numeric(dat2[i,]))
			gene <- gene + rnorm(length(gene), 0, random.noise)
			residuals <- try(resid(lme(fixed=gene~groups, random=gene~1|random, control=list(maxIter=10000), method="REML")), silent=T)
			residual.counter <- residual.counter +1
			print(paste(i, residual.counter))
		}
		
		if(class(residuals) == "try-error") { 
			print(i)
			stop("LME failed to estimate random effects. Please choose another error handling method or increse noise-level")
		} else {
			dat3[i,] <- residuals;	
		}
		#dat3[i,] <- resid(lme(fixed=gene~groups, random=gene~1|random, control=list(maxIter=10000), method="REML"))
	}
}

# Writes a table of results
write.table(data.frame(round(dat3, digits=2), calls), file="normalized-lme.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL bedtools-mergebed.R: "Merge BED" (Combines overlapping or book-ended (that is, one base pair away\) features in a feature file into a single feature which spans all of the combined features.)
# INPUT file.a: "Input file" TYPE GENERIC
# OUTPUT mergebed.bed
# PARAMETER OPTIONAL s: "Force strandedness" TYPE [yes, no] DEFAULT no (Force strandedness.  That is, only merge features that are the same strand. By default, merging is done without respect to strand.)
# PARAMETER OPTIONAL n: "Report the number of BED entries that were merged" TYPE [yes, no] DEFAULT no (Report the number of BED entries that were merged. Note: 1 is reported if no merging occurred.)
# PARAMETER OPTIONAL d: "Maximum distance between features allowed" TYPE INTEGER DEFAULT 0 (Maximum distance between features allowed for features to be merged. Default is 0. That is, overlapping & book-ended features are merged.)
# PARAMETER OPTIONAL nms: "Report the names of the merged features separated by semicolons" TYPE [yes, no] DEFAULT no (Report the names of the merged features separated by semicolons.)
# PARAMETER OPTIONAL score: "Report the scores of the merged features" TYPE [yes, no] DEFAULT no (Report the scores of the merged features. Specify one of the following options for reporting scores: sum, min, max, mean, median, mode, antimode, collapse (i.e., print a semicolon-separated list\).)
# PARAMETER OPTIONAL score.type: "Score report type" TYPE [sum, min, max, mean, median, mode, antimode, collapse] DEFAULT sum ()

# AMS 23.4.2012

# binary
binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "mergeBed"))

# options
options <- paste("")
if (s == "yes") {options <- paste(options, "-s")}
if (n == "yes") {options <- paste(options, "-n")}
options <- paste(options, "-d", d)
if (nms == "yes") {options <- paste(options, "-nms")}
if (score == "yes") {options <- paste(options, "-score", score.type)}

# input files
options <- paste(options, "-i file.a")

# command
command <- paste(binary, options, "> mergebed.bed")

# run
system(command)
if (file.info("mergebed.bed")$size == 0) {system("echo \"No results found\" > mergebed.bed")}

# TOOL input-sleep-output.R: InputSleepOutput (Just sleep with a few inputs and outputs.)
# INPUT input{...}.cel: input{...}.cel TYPE AFFY 
# OUTPUT input1.cel: input1.cel 
# OUTPUT input2.cel: input2.cel 
# OUTPUT input3.cel: input3.cel 
# OUTPUT input4.cel: input4.cel 

system("sleep 10")

# TOOL fastx-statistics.R: "Read quality statistics with FASTX" (Calculates quality statistics of the reads. This tool is based on the FASTX Statistics tool of the FASTX package.)
# INPUT reads.fastq TYPE GENERIC 
# OUTPUT quality-stats.tsv 
# PARAMETER quality.format: "Quality value format used" TYPE [sanger: Sanger, illuminaold: "Illumina GA v1.3-1.5"] DEFAULT sanger (What quality encoding is used in your FASTQ file. Select Sanger if your data comes from Illumina 1.8 or later, SOLiD or 454.)


# EK 17.6.2011

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads.fastq")

# binary
binary.stats <- c(file.path(chipster.tools.path, "fastx", "bin", "fastx_quality_stats"))

# command
quality.scale <- ifelse(quality.format == "sanger", "-Q 33", "")
command.stats <- paste(binary.stats, quality.scale, "-i reads.fastq -o quality-stats.tsv")

# run
ret <- system(command.stats)
if (ret > 0) {
	stop('Unsupported input file type, please see tool output for more details.')
}

# binary
#binary.qualities <- c(file.path(chipster.tools.path, "fastx", "bin", "fastq_quality_boxplot_graph.sh"))

# command
#command.qualities <- paste(binary.qualities, "-i quality-stats.tsv", "-o qualities.png")

# run
#ret <- system(command.qualities)
#if (ret > 0) {
#	stop('Unsupported input file type, please see tool output for more details.')
#}

# binary
#binary.distribution <- c(file.path(chipster.tools.path, "fastx", "bin", "fastx_nucleotide_distribution_graph.sh"))

# command
#command.distribution <- paste(binary.distribution, "-i quality-stats.tsv", "-o nucleotide-distribution.png")

# run
#system(command.distribution)

# TOOL stat-timeseries.R: "Time series" (Analyses of time series data. Finds periodically expressed genes. For the ICA method, a standard deviation threshold for significantly differentially expressed genes is needed. If there are more than one replicate per time point, this tool will not work. For maSigPro:phenodata:description must be unique,add column for time information,default column group is used as edesign.abiotic column replicate,add at least one column for each experimental condition as described in http://www.bioconductor.org/packages/2.7/bioc/vignettes/maSigPro/inst/doc/maSigPro-tutorial.pdf for edesign.abiotic;all parameters are default except vars="all")
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT timeseries.tsv: timeseries.tsv 
# OUTPUT profiles.pdf: profiles.pdf 
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the time to test)
# PARAMETER analysis.type: analysis.type TYPE [periodicity: periodicity, ica: ica, maSigPro: maSigPro] DEFAULT periodicity (Analysis type)
# PARAMETER p.value.threshold: p.value.threshold TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (P-value cut-off for significant results)
# PARAMETER p.value.adjustment.method: p.value.adjustment.method TYPE [yes: yes, no: no] DEFAULT yes (Apply Benjamimi-Hochberg correction?)
# PARAMETER SD.for.ICA: SD.for.ICA TYPE DECIMAL FROM 0 TO 10 DEFAULT 2.0 (Standard deviation for ICA)
# PARAMETER k.for.maSigPro: k.for.maSigPro TYPE DECIMAL FROM 0 TO 1000 DEFAULT 9 (maSigPro see.genes k=9)
# PARAMETER degree.for.maSigPro: degree.for.maSigPro TYPE DECIMAL FROM 0 TO 1000 DEFAULT 2 (maSigPro make.design.matrix degree=2)
# PARAMETER rsq.for.maSigPro: rsq.for.maSigPro TYPE DECIMAL FROM 0 TO 10 DEFAULT 0.7 (maSigPro get.siggenes rsq=0.7)
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Analysis methods for timeseries
# JTT 21.7.2006

# OH 10.10.2012
# added maSigPro as alternative time series analysis
# parameter added: k.for.maSigPro
# see documentation of maSigPro www.bioconductor.org/packages/2.7/bioc/vignettes/maSigPro/inst/doc/maSigPro-tutorial.pdf
#

# OH 17.01.2013
# added maSigPro as alternative time series analysis
# parameter added: degree.for.maSigPro
# see documentation of maSigPro www.bioconductor.org/packages/2.7/bioc/vignettes/maSigPro/inst/doc/maSigPro-tutorial.pdf
#

# OH 17.01.2013
# added maSigPro as alternative time series analysis
# parameter added: rsq.for.maSigPro
# see documentation of maSigPro www.bioconductor.org/packages/2.7/bioc/vignettes/maSigPro/inst/doc/maSigPro-tutorial.pdf
#


# Parameter settings (default) for testing purposes
#column<-"time"
#analysis.type<-"periodicity"
#p.value.threshold<-0.05
#p.value.adjustment.method<-"yes"
#SD.for.ICA<-2.0
#image.width<-600
#image.height<-600


# Renaming variables
analysis<-analysis.type
p.cut<-p.value.threshold
multiple.correction<-p.value.adjustment.method
thresh<-SD.for.ICA
w<-image.width 
h<-image.height 

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)
symbols=list()
if( length(grep("symbol",colnames(dat)))>0 ) {
	symbols=dat["symbol"]
}
description=list()
if( length(grep("description",colnames(dat)))>0 ) {
	description=dat["description"]
}

# Reads phenodata
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
times<-phenodata[,grep(column, colnames(phenodata))]

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# How many replicates there are per time point?
if(length(times)>length(levels(as.factor(times)))) {
   repl<-c()
   for(i in 1:length(levels(as.factor(times)))) {
      repl<-c(repl, sum(as.numeric(grep(times[1], times, value=T)==times[1])))
   }
} else {
   repl<-rep(1, length(times))
}

if(analysis=="periodicity") {
  # Load the libraries
  library(e1071)
  library(GeneCycle)
  #library(fastICA)

  # Making a longitudinal object
  dat3<-as.longitudinal(t(dat2), repeats=repl, time=times)

  # Replacing missing values
  dat4<-t(na.omit(t(impute(dat3))))

   f<-fisher.g.test(dat4)
   if(multiple.correction=="yes") {
      # Estimates the proportion of null p-values, uses BH-method
      p.adj<-fdrtool(f)$lfdr
      dev.off()
   } else {
      p.adj<-f
   }
   dat5<-as.data.frame(t(dat4))
   names(dat5)<-names(dat2)
   write.table(data.frame(dat5[p.adj<=p.cut,], p.adjusted=round(p.adj[p.adj<=p.cut], digits=6)), file="timeseries.tsv", sep="\t", row.names=T, col.names=T, quote=F)
   pdf(file="profiles.pdf", width=w/72, height=h/72)
   plot(1, 1, col=0)
   text(1, 1, "This is a dummy image.", col=1)
   text(1, 0.9, "To generate an image of gene expression profiles, use ica option.", col=1)
   dev.off()
}


if(analysis=="ica") {
   # Load the libraries
   library(e1071)
   library(GeneCycle)
   library(fastICA)

   # Making a longitudinal object
   dat3<-as.longitudinal(t(dat2), repeats=repl, time=times)

   # Replacing missing values
   dat4<-t(na.omit(t(impute(dat3))))

   # Calculating independent component analysis usign a fast method
   o<-fastICA(t(dat4), n.comp=(ncol(t(dat4))-1), method="C")
   d<-c()
   g<-c()
   for(i in 1:ncol(o$S)) {
      s<-o$S[,i]
      l<-which(s>=(mean(s)+thresh*sd(s)))
      d<-c(d, l)
      g<-c(g, rep(i, length(l)))
      dg<-data.frame(dat[d,], cluster=g)
   }
   write.table(dg, file="timeseries.tsv", sep="\t", row.names=T, col.names=T, quote=F)
   a<-data.frame(times, t(o$A))
   pdf(file="profiles.pdf", width=w/72, height=h/72)
   par(mar=c(0, 1, 1, 0)+0.1)
   par(mfrow=c(ceiling(sqrt(ncol(a))), ceiling(sqrt(ncol(a)))))
   for(i in 2:ncol(a)) {
      plot(a$time, a[,i], xaxt="n", type="l", xlab=NULL, ylab=NULL, main=paste("Chip", i-1, sep=" "), cex.main=0.75, cex.axis=0.7, cex.lab=0.75, tck=-0.01, mgp=c(3,0.2,0))
   }
   dev.off()
}

if(analysis=="maSigPro") {
	library(e1071)
	library("maSigPro")

	adjust="none"
	if( multiple.correction=="yes" ) {
		adjust="BH"
	}

	samplecount=length(colnames(dat2))
	if( samplecount!=length(unique(phenodata["description"][[1]])) ) {
		stop("Provide a unique description for each sample in column description of phenodata.")
	}

	orig.colnames=colnames(dat2)
	colnames(dat2)=phenodata["description"][[1]]
	dat4=na.omit(impute(dat2))

	edesign=data.frame(Time=times)
	rownames(edesign)=phenodata["description"][[1]]
	edesign["Replicate"]=phenodata["group"][[1]]

	conditions=colnames(phenodata)[grep("sample|original_name|chiptype|group|description",colnames(phenodata),invert=TRUE)]
	conditions=conditions[grep(column,conditions,invert=TRUE)]
	if( length(conditions)==0 ) {
		stop("Provide at least one condition as a new column in phenodata.")
	}

	for( condition in conditions ) {
		edesign[condition]=phenodata[condition][[1]]
	}

	Q=p.cut
	alfa=Q
	cluster.data = 1
	k = k.for.maSigPro
	degree = degree.for.maSigPro
	rsq=rsq.for.maSigPro
	cluster.method = "hclust"
	distance = "cor"
	agglo.method = "ward"
	summary.mode = "median"
	color.mode = "rainbow"
	show.fit = TRUE
	step.method = "backward"
	nvar.correction = FALSE
	min.obs = 3
	show.lines = TRUE
	cexlab = 0.8
	legend = TRUE
	#vars="groups"
	vars="all"
	main=NULL

	design <- make.design.matrix(edesign, degree = degree)
	dis <- design$dis

	fit <- p.vector(dat4,design,Q=Q,MT.adjust=adjust,min.obs=min.obs)

	tstep <- T.fit(fit,step.method=step.method,alfa=alfa)

	sigs <- get.siggenes(tstep,rsq=rsq,vars=vars)

	summary <- sigs$summary
	sig.genes <- sigs$sig.genes
	sig.genes <- sig.genes

	#from function maSigPro
	pdf(file = "profiles.pdf")

	if (!is.null(sig.genes)) {
		#for (i in 1:length(sig.genes)) {
			if (nrow(sig.genes[[1]]) > 0) {
				print("running see.genes")
				cluster <- see.genes(data = sig.genes,
					cluster.data = cluster.data, k = k, cluster.method = cluster.method,
					distance = distance, agglo.method = agglo.method,
					show.fit = show.fit, dis = dis, step.method = step.method,
					min.obs = min.obs, alfa = alfa, nvar.correction = nvar.correction,
					summary.mode = summary.mode, color.mode = color.mode,
					show.lines = show.lines, cexlab = cexlab,
					legend = legend, newX11 = FALSE, main = main)
				sig.genes[[1]] <- cbind(sig.genes[[1]],cluster$cut)
				cluster.algorithm <- cluster$cluster.algorithm.used
				groups <- cluster$groups
			}
		#}
	}

	dev.off()

	output <- list(summary, sig.genes, fit$dat, fit$G, edesign, dis, fit$min.obs, fit$p.vector, tstep$variables, tstep$g, fit$BH.alfa, step.method, Q, alfa, tstep$influ.info, vars, cluster.algorithm, groups)
	names(output) <- c("summary", "sig.genes", "input.data", "G", "edesign", "dis", "min.obs", "p.vector", "variables", "g", "BH.alfa", "step.method", "Q", "step.alfa", "influ.info", "select.vars", "cluster.algorithm.used", "groups")

	result = output$sig.genes$sig.profiles
	colnames(result)[1:length(orig.colnames)]=orig.colnames
	result["p-value"]=round(output$sig.genes$sig.pvalues$"p-value",digits=6)

	if( length(description)>0 ) {
		result2=merge(description,result,by = "row.names")
		rownames(result2)=result2[[1]]
		result=result2[-1]
	}
	if( length(symbols)>0 ) {
		result2=merge(symbols,result,by = "row.names")
		rownames(result2)=result2[[1]]
		result=result2[-1]
	}

	write.table(result,file="timeseries.tsv",sep="\t",row.names=T,col.names=T,quote=F)

}

# TOOL convertBAMtoMEDIPS.R: "Convert BAM file to MEDIPS input format" (Converts a BAM file to the MEDIPS input format.)
# INPUT bam{...}.bam: "BAM data diles" TYPE GENERIC
# OUTPUT MEDIPS-input{...}.tsv: "A converted BAM file suitable for MEDIPS analysis"

# Reads the input files, converts them to the MEDIPS format, and writes the converted files on the disk
library(Rsamtools)
files<-dir(pattern=".bam")
outfiles<-paste("MEDIPS-input", 1:length(files), ".tsv", sep="")
for(i in 1:length(files)) {
   aln<-readBamGappedAlignments(files[i])
   toMEDIPS<-data.frame(rep(rname(aln)@values, rname(aln)@lengths), start(aln), end(aln), rep(strand(aln)@values, strand(aln)@lengths))
   write.table(toMEDIPS, outfiles[i], col.names=F, row.names=F, quote=F, sep="\t")
   rm(aln, toMEDIPS)
   gc()
}

# TOOL norm-specific-genes.R: "Normalize to specific genes" (Normalizes data to specific genes.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT normalized-too.tsv: normalized-too.tsv TYPE GENE_EXPRS 
# OUTPUT normalized2genes.tsv: normalized2genes.tsv 


# Normalize the data to specific genes
# JTT 29.1.2009

# Name of the first table
name1<-c("normalized.tsv")

# Name of the second table
name2<-c("normalized-too.tsv")

# Loads the tables
table1<-read.table(file=name1, sep="\t", header=T, row.names=1)
table2<-read.table(file=name2, sep="\t", header=T, row.names=1)

# Table2 should always hold the genelist specifying the control probes
if(nrow(table2)>nrow(table1)) {
   table3<-table1
   table1<-table2
   table2<-table3
}

# Extract the control genes/probes from the whole dataset
table1c<-table1[rownames(table2),]

# Separates expression values
table1cd<-table1c[,grep("chip", names(table1c))]

# Calculating the normalization values
means<-colMeans(table1cd)

# Performing the normalization
cols<-grep("chip", names(table1c))
for(i in 1:length(cols)) {
   table1[,cols[i]]<-table1[,cols[i]]-means[i]
}

# Write out data
write.table(table1, file="normalized2genes.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL bowtie-with-index-building.R: "Bowtie for single end reads and own genome" (Bowtie aligns reads to genome, transcriptome, miRNAs, etc. There are two modes: mismatches are considered either throughout the read, or only in the user-defined left part of the read. In the latter case also quality values are taken into account.
# Results are sorted and indexed bam files. 
# This tool allows you align reads against your own sequences, which you have to supply in fasta format.
# If you would like to align reads against public genomes supplied by Chipster, please use the tool \"Bowtie for single end reads\".)
# INPUT reads.txt: "Reads to align" TYPE GENERIC
# INPUT genome.txt: "Genome to align against" TYPE GENERIC
# OUTPUT bowtie.bam 
# OUTPUT bowtie.bam.bai 
# OUTPUT bowtie.log 
# OUTPUT OPTIONAL unaligned-reads.fastq 
# OUTPUT OPTIONAL multireads.fastq 
# PARAMETER max.mismatches: "Number of mismatches allowed" TYPE [0, 1, 2, 3] DEFAULT 2 (How many mismatches are the alignments allowed to have?)
# PARAMETER limit.to.seed: "Consider mismatches only in the seed region" TYPE [yes, no] DEFAULT no (Should the mismatch limit be applied only to the left, good quality part of the read? You can define the length of this seed region with the next parameter.)
# PARAMETER seed: "Length of the seed region" TYPE INTEGER FROM 5 TO 50 DEFAULT 28 (If you have chosen to apply the mismatch limit only to the left, good quality part of the read, how many bases should be considered? The minimum length of seed region is 5.)
# PARAMETER quality: "Allowed total of mismatch qualities" TYPE INTEGER FROM 10 TO 100 DEFAULT 70 (What is the maximum permitted total of quality values of ALL mismatch positions throughout the read (not just in the seed region\)? Note that this parameter is taken into account only if you have chosen to apply the mismatch limit to the seed region.)
# PARAMETER quality.format: "Quality value format used" TYPE [solexa1_3: "Illumina GA v1.3-1.5", sanger: Sanger] DEFAULT sanger (Note that this parameter is taken into account only if you chose to apply the mismatch limit to the seed region. Are the quality values in the Sanger format (ASCII characters equal to the Phred quality plus 33\) or in the Illumina Genome Analyzer Pipeline v1.3 or later format (ASCII characters equal to the Phred quality plus 64\)? Please see the manual for details.)
# PARAMETER OPTIONAL multiread: "How many best category hits is the read allowed to have" TYPE [1, 2, 1000000: "no limit"] DEFAULT 1000000 (If you select 1, only those reads which have a unique best category hit will be reported. Note that the read can still have other, lower category hits even if they are not reported. The hit categories are based on the number of mismatches.)
# PARAMETER OPTIONAL alignment.no: "How many valid alignments are reported per read" TYPE [1, 2, 3] DEFAULT 1 (If there are several, equally good alignments, how many should be reported?)
# PARAMETER OPTIONAL multiread.file: "Put multireads to a separate file" TYPE [yes, no] DEFAULT no (If you chose not to have alignments for reads which map to multiple positions, would you like to store these reads to a separate fastq file?)
# PARAMETER OPTIONAL unaligned.file: "Put unaligned reads to a separate file" TYPE [yes, no] DEFAULT no (Would you like to store unaligned reads to a new fastq file? Note that also multireads will be added to this file, unless you asked them to be put to a separate file.)

# EK 20.6.2011
# AMS 19.6.2012 Added unzipping

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads.txt")
unzipIfGZipFile("genome.txt")

# bowtie index building
genome.base <- "genome"
bowtie.index.binary <- c(file.path(chipster.tools.path, "bowtie", "bowtie-build"))
command.indexing <- paste(bowtie.index.binary, "-f", "genome.txt", genome.base)
system(command.indexing)


# bowtie
bowtie.binary <- c(file.path(chipster.tools.path, "bowtie", "bowtie"))
command.start <- paste("bash -c '", bowtie.binary)

# common parameters
common.parameters <- paste("-q --best -S --strata", "-m", multiread, "-k", alignment.no)

# mode specific parameters
quality.parameter <- ifelse(quality.format == "solexa1_3", "--solexa1.3-quals", "")
n.mode.parameters <- paste("-n", max.mismatches, "-l", seed, "-e", quality, quality.parameter)
v.mode.parameters <- paste("-v", max.mismatches)
mode.parameters <- ifelse(limit.to.seed == "yes", n.mode.parameters, v.mode.parameters)

# output parameters
unaligned.output <- ifelse(unaligned.file == "yes", "--un unaligned-reads.fastq", "")
multiread.output <- ifelse(multiread.file == "yes", "--max multireads.fastq", "")
output.parameters <- paste(unaligned.output, multiread.output)

# command ending
command.end <- paste(genome.base, "reads.txt 1> alignment.sam 2> bowtie.log'")

# run bowtie
bowtie.command <- paste(command.start, common.parameters, quality.parameter, mode.parameters, output.parameters, command.end)
#stop(paste('CHIPSTER-NOTE: ', bowtie.command))
system(bowtie.command)


# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

# convert sam to bam
system(paste(samtools.binary, "view -bS -q 1 alignment.sam -o alignment.bam"))

# sort bam
system(paste(samtools.binary, "sort alignment.bam alignment.sorted"))

# index bam
system(paste(samtools.binary, "index alignment.sorted.bam"))

# rename result files
system("mv alignment.sorted.bam bowtie.bam")
system("mv alignment.sorted.bam.bai bowtie.bam.bai")

# TOOL mothur-alignseqs.R: "Align sequences with Mothur" (Given a fasta file of 16S rRNA sequences, aligns them to the Silva reference set. Kmer searching with 8mers is followed by Needleman-Wunsch pairwise alignment, which penalizes the same amount for opening and extending a gap. This tool is based on the Mothur package.)
# INPUT reads.fasta: "FASTA file" TYPE FASTA
# OUTPUT aligned.fasta
# OUTPUT aligned-summary.tsv

# EK 05.06.2013

# binary
binary <- c(file.path(chipster.tools.path, "mothur", "mothur"))
data.path <- c(file.path(chipster.tools.path, "mothur-data"))
template.path <- c(file.path(data.path, "silva.bacteria.fasta"))

# batch file
write(paste("align.seqs(fasta=reads.fasta, template=", template.path, ")", sep=""), "batch.mth", append=F)

# command
command <- paste(binary, "batch.mth")

# run
system(command)

system("mv reads.align aligned.fasta")

# batch file 2
write("summary.seqs(fasta=aligned.fasta)", "summary.mth", append=F)

# command
command2 <- paste(binary, "summary.mth", "> log_raw.txt")

# run
system(command2)

# Post process output
system("grep -A 9 Start log_raw.txt > aligned-summary.tsv")

# TOOL bwasw.R: "BWA-SW for single-end reads" (BWA aligns reads to genomes and transcriptomes. Unlike Bowtie, it allows gapped alignments. This BWA version uses the BWA-SW algorithm that is designed for long, over 300pb, low-quality reads. The alignment results are sorted and indexed bam files, which are ready for viewing in the Chipster genome browser. 
# Note that this BWA tool uses publicly available genomes. If you would like to align reads against your own datasets, please use the tool \"BWA against own genomes\".)
# INPUT reads.txt: "Reads to align" TYPE GENERIC 
# OUTPUT bwa.bam 
# OUTPUT bwa.bam.bai 
# OUTPUT bwa.log 
# PARAMETER genome: "Genome or transcriptome" TYPE [hg19.fa: "Human genome (hg19\)", mm9.fa: "Mouse genome (mm9\)", rn4.fa: "Rat genome (rn4\)"] DEFAULT mm9.fa (Genome or transcriptome that you would like to align your reads against.)
# PARAMETER OPTIONAL match.score: "Score of a match" TYPE INTEGER DEFAULT 1 (Score of a matching base. Corresponds to the command line parameter -a)
# PARAMETER OPTIONAL gap.opening: "Gap opening penalty " TYPE INTEGER DEFAULT 11 (Gap opening penalty. Corresponds to the command line parameter -q)
# PARAMETER OPTIONAL gap.extension: "Gap extension penalty " TYPE INTEGER DEFAULT 4 (Gap extension penalty. Corresponds to the command line parameter -r)
# PARAMETER OPTIONAL mismatch.penalty: "Mismatch penalty" TYPE INTEGER DEFAULT 3 (Mismatch penalty. Corresponds to the command line parameter -b)
# PARAMETER OPTIONAL band.width: "Band width in the banded alignment"  TYPE INTEGER DEFAULT 33 (Band width in the banded alignment. Corresponds to the command line parameter -w .)
# PARAMETER OPTIONAL min.score: "Minimum score threshold divided by the given value"  TYPE INTEGER DEFAULT 37 (Minimum score threshold divided by the given value. Corresponds to the command line parameter -T.)
# PARAMETER OPTIONAL threshold.coeff: "Coefficient for threshold adjustment" TYPE DECIMAL DEFAULT 5.5 (Coefficient for threshold adjustment according to query length. Given an l-long query, the threshold for a hit to be retained is a*max\{T,c*log\(l\)\}. Corresponds to the command line parameter -c )
# PARAMETER OPTIONAL z.best: "Z-best heuristics" TYPE INTEGER DEFAULT 1 (Z-best heuristics. Higher -z increases accuracy at the cost of speed. Corresponds to the command line parameter -z.)
# PARAMETER OPTIONAL sa.interval: "Maximum SA interval size" TYPE INTEGER DEFAULT 3 (Maximum SA interval size for initiating a seed. Higher value increases accuracy at the cost of speed. Corresponds to the command line parameter -s.)
# PARAMETER OPTIONAL min.support: "Reverse alignment limit" TYPE INTEGER DEFAULT 5 (Minimum number of seeds supporting the resultant alignment to skip reverse alignment. Corresponds to the command line parameter -N)
# PARAMETER OPTIONAL alignment.no: "How many valid alignments are reported per read" TYPE  INTEGER DEFAULT 3 (Maximum number of alignments to report. Corresponds to the command line parameter bwa samse -n )

# KM 24.8.2011
# AMS 19.6.2012 Added unzipping

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads.txt")

# bwa
bwa.binary <- file.path(chipster.tools.path, "bwa", "bwa")
bwa.indexes <- file.path(chipster.tools.path, "bwa_indexes")
bwa.genome <- file.path(bwa.indexes, genome)
command.start <- paste("bash -c '", bwa.binary)


# algorithm parameters
mode.parameters <- paste("bwasw -t 2 -b", mismatch.penalty , "-q" , gap.opening , "-r" , gap.extension , "-a" , match.score , "-w" , band.width , "-T" , min.score , "-c" , threshold.coeff , "-z" , z.best , "-s" , sa.interval , "-N" , min.support)

# command ending
echo.command <- paste("echo '", bwa.binary , mode.parameters, bwa.genome, "reads.txt ' > bwa.log" )
system(echo.command)

command.end <- paste(bwa.genome, "reads.txt 1> alignment.sai 2>> bwa.log'")

# run bwa alignment
bwa.command <- paste(command.start, mode.parameters, command.end)

#stop(paste('CHIPSTER-NOTE: ', bwa.command))
system(bwa.command)

#system ("pwd")
#system ("ls -l >> bwa.log")
# sai to sam conversion
samse.parameters <- paste("samse -n", alignment.no )
samse.end <- paste(bwa.genome, "alignment.sai reads.txt 1> alignment.sam 2>>bwa.log'" )
samse.command <- paste( command.start, samse.parameters , samse.end )

echo.command <- paste("echo '", bwa.binary , samse.parameters, bwa.genome, "alignment.sai reads.txt ' >> bwa.log" )
system(echo.command)

system(samse.command)

		
# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

# convert sam to bam
system(paste(samtools.binary, "view -bS alignment.sam -o alignment.bam"))

# sort bam
system(paste(samtools.binary, "sort alignment.bam alignment.sorted"))

# index bam
system(paste(samtools.binary, "index alignment.sorted.bam"))

# rename result files
system("mv alignment.sorted.bam bwa.bam")
system("mv alignment.sorted.bam.bai bwa.bam.bai")

# TOOL subset-fastq.R: "Make a subset of FASTQ" (Returns a subset of N reads from a FASTQ file. If the FASTQ file is zipped, the tool will unzip it automatically.)
# INPUT reads.fastq: "FASTQ file" TYPE GENERIC
# OUTPUT subset.fastq 
# PARAMETER n.seq: "Size of subset" TYPE INTEGER DEFAULT 100000 (Number of reads to return from the start of the FASTQ file.)

# AMS 14.5.2012
# EK 15.5.2012 added unzipping

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads.fastq")

# binary
binary <- c("head")

# options
n.seq <- as.integer(n.seq)
n.lines <- n.seq * 4

l.opt <- c('-', as.integer(n.lines))
options <- paste(l.opt , collapse = '')

# input files
options <- paste(options,"reads.fastq")

# command
command <- paste(binary, options, " > subset.fastq")

# run
#stop(paste('CHIPSTER-NOTE: ', command))
system(command)

# TOOL fastqc.R: "Read quality with FastQC" (Generates plots for per base quality score and sequence content.
# You can also create plots for GC and N content, sequence length distribution, duplication levels, overrepresented sequences and Kmer content by using the \"Create all plots\" parameter.
# This tool is based on the FastQC package by Simon Andrews et al.)
# INPUT reads.fastq TYPE GENERIC
# OUTPUT per_base_quality.png
# OUTPUT per_base_sequence_content.png
# OUTPUT fastqc_data.txt
# OUTPUT OPTIONAL duplication_levels.png
# OUTPUT OPTIONAL kmer_profiles.png
# OUTPUT OPTIONAL per_base_gc_content.png
# OUTPUT OPTIONAL per_base_n_content.png
# OUTPUT OPTIONAL per_sequence_gc_content.png
# OUTPUT OPTIONAL per_sequence_quality.png
# OUTPUT OPTIONAL sequence_length_distribution.png
# PARAMETER all: "Create all plots" TYPE [yes, no] DEFAULT no (Whether to also create plots for GC and N content, sequence length distribution, duplication levels, overrepresented sequences and Kmer content.)

# FastQC detects gzipped files by file extension so we need to add .gz
# extension to compressed files.
source(file.path(chipster.common.path, "zip-utils.R"))
input.file <- "reads.fastq"
if (isGZipFile(input.file)) {
	system(paste("mv", input.file, "reads.gz"))
	input.file <- "reads.gz"
}

# binary
binary <- file.path(chipster.tools.path, "FastQC", "fastqc")

# command
command <- paste(binary, input.file)

# run
system(command)

# move outputs

system("cp reads_fastqc/Images/per_base_quality.png .")
system("cp reads_fastqc/Images/per_base_sequence_content.png .")
system("cp reads_fastqc/fastqc_data.txt .")

if (all == "yes") {
	system("cp reads_fastqc/Images/duplication_levels.png .")
	system("cp reads_fastqc/Images/kmer_profiles.png .")
	system("cp reads_fastqc/Images/per_base_gc_content.png .")
	system("cp reads_fastqc/Images/per_sequence_quality.png .")
	system("cp reads_fastqc/Images/sequence_length_distribution.png .")
}

# TOOL mothur-filterseqs.R: "Filter sequence alignment with Mothur" (Filters out columns from a fasta formatted sequence alignment. By removing empty columns, the distance calculation is accelerated. This tool is based on the Mothur package.)
# INPUT a.align: "Aligned reads in FASTA format" TYPE FASTA
# OUTPUT filtered-aligned.fasta
# OUTPUT filtered-log.txt
# OUTPUT filtered-summary.tsv

# EK 05.06.2013

# binary
binary <- c(file.path(chipster.tools.path, "mothur", "mothur"))

# batch file
write("filter.seqs(fasta=a.align, vertical=T, trump=.)", "batch.mth", append=F)

# command
command <- paste(binary, "batch.mth", "> log_raw.txt")

# run
system(command)

# result post-processing
system("mv a.filter.fasta filtered-aligned.fasta")
system("grep -A 4 filtered log_raw.txt > filtered-log.txt")

# batch file 2
write("summary.seqs(fasta=filtered-aligned.fasta)", "summary.mth", append=F)

# command 2
command2 <- paste(binary, "summary.mth", "> log_raw.txt")

# run
system(command2)

# Post process output
system("grep -A 9 Start log_raw.txt > filtered-summary.tsv")

# TOOL acgh-import-from-cangem.R: "Import from CanGEM" (Load a microarray data set from the CanGEM database, perform background-correction and normalization, and append chromosomal locations of the microarray probes.)
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# PARAMETER accession: accession TYPE STRING DEFAULT CG- (Accession of either a data set, an experiment, a series, or single microarray results.)
# PARAMETER username: username TYPE STRING DEFAULT empty (Username, in case the data is password-protected. WARNING: This will store your username password in the Chipster history files. To avoid this, use the session parameter.)
# PARAMETER password: password TYPE STRING DEFAULT empty (Password, in case the data is password-protected. WARNING: This will store your username password in the Chipster history files. To avoid this, use the session parameter.)
# PARAMETER session: session TYPE STRING DEFAULT empty (Session ID. To avoid saving your username password in Chipster history files, log in at http: www.cangem.org using a web browser, then copy&paste your session ID from the lower right corner of the CanGEM website. This will allow Chipster to access your password-protected data until you log out of the web site (or the session times out\).)
# PARAMETER agilent.filtering: agilent.filtering TYPE [yes: yes, no: no] DEFAULT yes (Whether to filter outliers from Agilent 2-color arrays. Will be ignored, if downloaded files are 1-color arrays, or not in Agilent file format. Check the help file for details about the filtering function.)
# PARAMETER background.treatment: background.treatment TYPE [none: none, subtract: subtract, normexp: normexp, rma: rma] DEFAULT normexp (Background treatment method. RMA is available only for one-color arrays.)
# PARAMETER background.offset: background.offset TYPE [0: 0, 50: 50] DEFAULT 50 (Background offset.)
# PARAMETER intra.array.normalization: intra.array.normalization TYPE [none: none, median: median, loess: loess] DEFAULT loess (Intra-array normalization method for Agilent arrays. Will be ignored, if downloaded files are not in Agilent file format.)
# PARAMETER inter.array.normalization: inter.array.normalization TYPE [none: none, quantile: quantile, scale: scale] DEFAULT none (Inter-array normalization method for Agilent arrays. Will be ignored, if downloaded files are not in Agilent file format.)
# PARAMETER affymetrix.normalization: affymetrix.normalization TYPE [gcrma: gcrma, rma: rma, mas5: mas5] DEFAULT gcrma (Normalization method for Affymetrix arrays. Will be ignored, if downloaded files are not in Affymetrix file format.)
# PARAMETER genome.build: genome.build TYPE [none: none, GRCh37: GRCh37, NCBI36: NCBI36, NCBI35: NCBI35, NCBI34: NCBI34] DEFAULT GRCh37 (The genome build to use. GRCh37 = hg19, NCBI36 = hg18, NCBI35 = hg17, NCBI34 = hg16.)

# import-from-cangem.R
# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-05-03

# check for valid accession
accession <- toupper(accession)
if (length(grep('^CG-(SET|EXP|SER|RES|SAM|PLM)-[0-9]+$', accession))==0)
  stop('CHIPSTER-NOTE: Not a valid accession: ', accession)

# construct the string used in authenticating
if (session != 'empty' && session != '') {
  auth <- paste('&PHPSESSID=', session, sep='')
} else if (username != 'empty' && username != '' && password != 'empty' && password != '') {
  auth <- paste('&username=', username, '&password=', password, sep = '')
} else auth <- ''

# fetch list of arrays from CanGEM
cangem.samples <- read.table(paste('http://www.cangem.org/scripts/listhybs.php?accession=', accession, auth, sep=''), header=TRUE, sep='\t', quote='', as.is=TRUE, comment.char='')
cangem.samples$GUID <- NULL

# check that we did get some results
if (nrow(cangem.samples)==0)
  stop('CHIPSTER-NOTE: No array data found.')

# check for single platform, array type and file format
if (length(unique(cangem.samples$PlatformAccession)) > 1)
  stop('CHIPSTER-NOTE: Multiple platforms used: ', paste(unique(cangem.samples$Platform), collapse=', '))
if (length(unique(cangem.samples$Type)) > 1)
  stop('CHIPSTER-NOTE: Multiple array types used: ', paste(unique(cangem.samples$Type), collapse=', '))
if (length(unique(cangem.samples$Format)) > 1)
  stop('CHIPSTER-NOTE: Multiple file formats used: ', paste(unique(cangem.samples$Format), collapse=', '))

microarrays <- sprintf('microarray%.3i', 1:nrow(cangem.samples)) # or .cel/.tsv ???
chips <- paste('chip.', microarrays, sep='')
arrays <- list()
probes.to.genes <- data.frame()
onecolor <- FALSE
if (cangem.samples$Format[1] == 'agilent') {
  library(limma)
  # define filtering function
  if (agilent.filtering == 'yes') {
    cangem.filter <- function(x) {
      # required fields and their values, field.name=required.value
      reqs <- c(
        ControlType=0,
        gIsBGNonUnifOL=0,
        gIsBGPopnOL=0,
        gIsFeatNonUnifOL=0,
        gIsFeatPopnOL=0,
        gIsFound=1,
        gIsPosAndSignif=1,
        gIsSaturated=0,
        gIsWellAboveBG=1,
        gSurrogateUsed=0,
        IsManualFlag=0,
        rIsBGNonUnifOL=0,
        rIsBGPopnOL=0,
        rIsFeatNonUnifOL=0,
        rIsFeatPopnOL=0,
        rIsFound=1,
        rIsPosAndSignif=1,
        rIsSaturated=0,
        rIsWellAboveBG=1,
        rSurrogateUsed=0)
      # start with a weight of 1 for every spot
      weights <- rep(1, length=nrow(x))
      # check which fields are present, and check if they have the required value
      for (req in names(reqs))
          if (req %in% colnames(x))
              weights <- weights & x[,req] == reqs[req]
      as.numeric(weights)
    }
  } else {
    cangem.filter <- function(x) { 1 }
  }
  # load arrays one by one to be able to handle with files with different number of rows
  for (i in 1:nrow(cangem.samples)) {
    prob <- TRUE
    if (!onecolor) {
      # first try to read the 'normal' columns (means), but if it fails, try medians
      try({
        array.raw <- read.maimages(paste('http://www.cangem.org/download.php?hybridization=', cangem.samples[i,'Accession'], auth, sep=''),
          source=cangem.samples[i,'Format'], wt.fun=cangem.filter)
        prob <- FALSE
      }, silent=TRUE)
      if (prob) {
        try({
          array.raw <- read.maimages(paste('http://www.cangem.org/download.php?hybridization=', cangem.samples[i,'Accession'], auth, sep=''),
            source=cangem.samples[i,'Format'], columns=list(G='gMedianSignal', Gb='gBGMedianSignal', R='rMedianSignal', Rb='rBGMedianSignal'), wt.fun=cangem.filter)
          prob <- FALSE
        }, silent=TRUE)
      }
    }
    if (prob) {
      try({
        array.raw <- read.maimages(paste('http://www.cangem.org/download.php?hybridization=', cangem.samples[i,'Accession'], auth, sep=''),
          source=cangem.samples[i,'Format'], columns=list(G='gMedianSignal', Gb='gBGMedianSignal', R='gMedianSignal', Rb='gBGMedianSignal'), wt.fun=cangem.filter)
        prob <- FALSE
        onecolor <- TRUE
      }, silent=TRUE)
    }
    if (prob) {
       stop('CHIPSTER-NOTE: Could not read file ', cangem.samples[i, 'Name'])
    }
    if (background.treatment == 'rma') {
      array.bg <- backgroundCorrect(array.raw, method='none')
    } else
      array.bg <- backgroundCorrect(array.raw, method=background.treatment, normexp.method='mle', offset=as.numeric(background.offset))
    if (onecolor) {
      array <- as.vector(array.bg$R)
    } else {
      array.ma <- normalizeWithinArrays(array.bg, method=intra.array.normalization)
      array <- as.vector(array.ma$M)
      # take inverse for dye swaps
      if (cangem.samples[i, 'SampleChannel'] == 'Cy3')
        array <- -array
    }
    #names(array) <- array.bg$genes[,cangem.samples[i,'ProbeNames']]
    names(array) <- array.bg$genes[,'ProbeName']
    # average replicate probes
    replicate.probes <- unique(names(array)[duplicated(names(array))])
    array.uniques <- array[!names(array) %in% replicate.probes]
    array.replicates <- array[names(array) %in% replicate.probes]
    array.replicates.avg <- aggregate(array.replicates, list(probe=names(array.replicates)), median, na.rm=TRUE)
    array.replicates <- array.replicates.avg$x
    names(array.replicates) <- array.replicates.avg$probe
    array <- c(array.uniques, array.replicates)
    arrays[[i]] <- array
    if (cangem.samples[i,'ProbeNames'] != 'ProbeName')
      probes.to.genes <- unique(rbind(probes.to.genes, array.bg$genes[,c('ProbeName', cangem.samples[i,'ProbeNames'])]))
  }
  # go through all the loaded arrays and build a list of all probes found.
  all.probes <- character()
  for (i in 1:length(arrays))
    all.probes <- union(all.probes, names(arrays[[i]]))
  # build a matrix of the measurement values
  dat <- matrix(nrow=length(all.probes), ncol=length(chips), dimnames=list(all.probes, chips))
  for (i in 1:length(arrays))
    dat[,chips[i]] <- arrays[[i]][all.probes]
  # if the background treatment method is RMA, perform it now.
  # otherwise it has been performed already.
  if (background.treatment == 'rma') {
    if (!onecolor)
      stop('CHIPSTER-NOTE: RMA background treatment method is only available for one-color arrays.')
    library(preprocessCore)
    dat <- rma.background.correct(dat, copy=TRUE)
    dat <- dat + abs(min(dat)) + 2
    rownames(dat) <- all.probes
    colnames(dat) <- chips
  }
  # in case of one-color arrays perform log2 transformation.
  # otherwise it has been perfomed as part of normalizeWithinArrays
  if (onecolor)
    dat <- log2(dat)
  # normalize between arrays.
  dat <- normalizeBetweenArrays(dat, method=inter.array.normalization)
  # average from probes to genes if needed
  if (cangem.samples[1,'ProbeNames'] != 'ProbeName') {
    library(affy)
    dat <- 2^dat
    rownames(probes.to.genes) <- probes.to.genes$ProbeName
    pNList <- probes.to.genes[rownames(dat), cangem.samples[1,'ProbeNames']]
    ngenes <- length(unique(pNList))
    pNList <- split(0:(length(pNList) - 1), pNList)
    dat <- .Call("rma_c_complete_copy", dat, pNList, ngenes, normalize=FALSE, background=FALSE, bgversion=2, verbose=TRUE, PACKAGE="affy")
    colnames(dat) <- chips
  }
  dat <- round(dat, digits=2)
  dat <- as.data.frame(dat)
  chiptype <- cangem.samples$BioconductorPackage[1]
  if (is.na(chiptype)) {
    if (cangem.samples$Type[1] == 'miRNA') {
      chiptype <- 'miRNA'
    } else {
      chiptype <- 'cDNA'
    }
  }
} else if (cangem.samples$Format[1] == 'affymetrix') {
  library(affy)
  library(gcrma)
  onecolor <- TRUE
  for (i in 1:nrow(cangem.samples))
    download.file(paste('http://www.cangem.org/download.php?hybridization=', cangem.samples[i,'Accession'], auth, sep=''), cangem.samples[i,'FileName'], quiet=TRUE)
  raw <- ReadAffy(filenames=cangem.samples$FileName)
  chiptype<-paste(raw@annotation, '.db', sep='')
  calls<-as.data.frame(exprs(mas5calls(raw)))
  names(calls)<-paste("flag.", microarrays, sep="") # or names(calls) ???
  if (affymetrix.normalization == 'mas5')
    dat<-as.data.frame(round(log2(exprs(mas5(raw))), digits=2))
  rm(raw)
  gc()
  if (affymetrix.normalization == 'rma')
    dat <- as.data.frame(round(exprs(justRMA(filenames=cangem.samples$FileName)), digits=2))
  if (affymetrix.normalization == 'gcrma')
    dat <- as.data.frame(round(exprs(justGCRMA(filenames=cangem.samples$FileName, type='fullmodel', fast=TRUE, optimize.by='speed')), digits=2))
  names(dat) <- chips # or names(dat) ???
  dat <- data.frame(dat, calls)
  unlink(cangem.samples$FileName)
} else {
  stop('CHIPSTER-NOTE: Unsupported file format: ', cangem.samples$Format[1])
}

phenodata <- data.frame(sample=microarrays)
phenodata$original_name <- cangem.samples$FileName
phenodata$chiptype <- chiptype
phenodata$group <- ''
phenodata$description <- cangem.samples$Name
cangem.samples$ProbeNames <- NULL
cangem.samples$BioconductorPackage <- NULL
if (onecolor) {
  cangem.samples$SampleChannel <- NULL
  cangem.samples$ReferenceSample <- NULL
  cangem.samples$ReferenceSex <- NULL
  cangem.samples$ReferenceAccession <- NULL
}

for (col in colnames(cangem.samples))
  if (all(is.na(cangem.samples[,col])))
    cangem.samples[,col] <- NULL

phenodata <- cbind(phenodata, cangem.samples)

dat2 <- data.frame(probe=rownames(dat), stringsAsFactors=FALSE)
rownames(dat2) <- dat2$probe

if (genome.build != 'none') {
  # load platform
  platform <- read.table(paste('http://www.cangem.org/download.php?platform=', cangem.samples$PlatformAccession[1], '&flag=', genome.build, auth, sep=''), sep='\t', header=TRUE, as.is=TRUE)
  colnames(platform) <- tolower(colnames(platform))
  colnames(platform)[colnames(platform)=='chr'] <- 'chromosome'
  rownames(platform) <- platform[,1]
  platform$chromosome <- factor(platform$chromosome, levels=c(1:22, "X", "Y", "MT"), ordered=TRUE)
  dat2 <- cbind(dat2, platform[dat2$probe, c('chromosome', 'start', 'end')])
  dat2 <- dat2[order(dat2$chromosome, dat2$start),]
}

if (chiptype != 'cDNA' && chiptype != 'miRNA') {
  # including gene names to data
  library(chiptype, character.only=T)
  lib2<-sub('.db','',chiptype)
  symbol<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "SYMBOL", sep="")))))[dat2$probe,])
  genename<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "GENENAME", sep="")))))[dat2$probe,])
  symbol<-gsub("#", "", symbol)
  genename<-gsub("#", "", genename)
  dat2 <- cbind(dat2, symbol, description=genename)
}

dat2 <- cbind(dat2, dat[dat2$probe,])
if (ncol(dat)==1)
  colnames(dat2)[ncol(dat2)] <- chips[1]
dat2$probe <- NULL

options(scipen=10)
write.table(dat2, file='normalized.tsv', quote=FALSE, sep='\t', col.names=TRUE, row.names=TRUE)
write.table(phenodata, file='phenodata.tsv', quote=FALSE, sep='\t', col.names=TRUE, row.names=FALSE)

# EOF

# TOOL stat-several-groups.R: "Several groups tests" (Tests for comparing the mean gene expression of several groups. Other than empiricalBayes might be slow, if run on unfiltered data.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT multiple-sample.tsv: multiple-sample.tsv 
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to test)
# PARAMETER test: test TYPE [empiricalBayes: empiricalBayes, ANOVA: ANOVA, Kruskal-Wallis: Kruskal-Wallis] DEFAULT empiricalBayes (Test type)
# PARAMETER p.value.adjustment.method: p.value.adjustment.method TYPE [none: none, Bonferroni: Bonferroni, Holm: Holm, Hochberg: Hochberg, BH: BH, BY: BY] DEFAULT BH (Multiple testing correction method)
# PARAMETER p.value.threshold: p.value.threshold TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (P-value cut-off for significant results)
# PARAMETER use.simple.analysis: use.simple.analysis TYPE [yes: yes, no: no] DEFAULT no (Use simple analysis: if no significant genes are found, a hundred most significant genes are reported)


# column<-"group"
# test<-"empiricalBayes"
# p.value.adjustment.method <-"none"
# p.value.threshold <-0.05
# use.simple.analysis<-"no"


# Several groups parametric and non-parametric tests
# JTT 4.7.2006

# Loads the libraries
library(multtest)

# Renaming variables
meth<-test
if(test=="empiricalBayes" & (p.value.adjustment.method!="BH" & p.value.adjustment.method!="BY") ) {
   adj.method<-tolower(p.value.adjustment.method)
} else {
   adj.method<-p.value.adjustment.method
}
p.cut<-p.value.threshold

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Test needs a parameter "groups" that specifies the grouping of the samples
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
groups<-phenodata[,pmatch(column,colnames(phenodata))]

# Sanity checks
if(ncol(dat2)<4) {
   stop("You need to have at least four chips to run this analysis")
}

# Testing

if(use.simple.analysis=="no") {
# Empirical Bayes
if(meth=="empiricalBayes") {
   library(limma)
   design<-model.matrix(~groups)
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
   tab<-toptable(fit, coef=2, number=nrow(fit), adjust.method=adj.method)
   rows<-as.numeric(row.names(tab))
   rows<-rows[tab$adj.P.Val<=p.cut]
   p<-tab$adj.P.Val[tab$adj.P.Val<=p.cut]
   dat<-dat[rows,]
   write.table(data.frame(dat, p.adjusted=round(p, digits=6)), file="multiple-sample.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}

# ANOVA test
if(meth=="ANOVA") {
   p<-c()
   len<-length(dat2[,1])
   for(i in 1:len) {
      p<-c(p, na.omit((anova(lm(t(dat2)[,i]~groups)))$Pr)[1])
   }
   p.raw<-p
   # Multiple testing correction
   if(adj.method=="none") {
      p.adjusted<-p.raw
   }
   if(adj.method=="Bonferroni" | adj.method=="BH") {
      p.adjusted<-mt.rawp2adjp(p.raw, adj.method)
      p.adjusted<-p.adjusted$adjp[order(p.adjusted$index),][,2]
   }
   dat<-dat[p.adjusted<=p.cut,]   
   p.adjusted<-p.adjusted[p.adjusted<=p.cut]
   write.table(data.frame(dat, p.adjusted=round(p.adjusted, digits=6)), file="multiple-sample.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}

# Kruskal-Wallis test
if(meth=="Kruskal-Wallis") {
   p<-c()
   for(i in 1:nrow(dat2)) {
      p<-c(p, kruskal.test(dat2[i,], groups))
   }
   p.raw<-p
   if(adj.method=="none") {
      p.adjusted<-p.raw
   }
   if(adj.method=="Bonferroni" | adj.method=="BH") {
      p.adjusted<-mt.rawp2adjp(p.raw, adj.method)
      p.adjusted<-p.adjusted$adjp[order(p.adjusted$index),][,2]
   }
   dat<-dat[p.adjusted<=p.cut,]   
   p.adjusted<-p.adjusted[p.adjusted<=p.cut]
   write.table(data.frame(dat, p.adjusted=round(p.adjusted, digits=6)), file="multiple-sample.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}
}

if(use.simple.analysis=="yes") {
# Empirical Bayes
if(meth=="empiricalBayes") {
   library(limma)
   design<-model.matrix(~groups)
   fit<-lmFit(dat2, design)
   fit<-eBayes(fit)
   if(adj.method=="none") {
      tab<-toptable(fit, coef=2, number=nrow(fit), adjust.method="none")
      p.adjusted<-tab$adj.P.Val
      p<-tab$P.Value
   }
   if(adj.method=="BH") {
      tab<-toptable(fit, coef=2, number=nrow(fit), adjust.method="BH")
      p.adjusted<-tab$adj.P.Val
      p<-tab$P.Value
   }
   p.adjusted[p.adjusted>p.cut]<-NA
}

# ANOVA test
if(meth=="ANOVA") {
   p<-c()
   len<-length(dat2[,1])
   for(i in 1:len) {
      p<-c(p, na.omit((anova(lm(t(dat2)[,i]~groups)))$Pr)[1])
   }
   p.raw<-p
   if(adj.method=="none") {
      p.adjusted<-p.raw
   }
   if(adj.method=="Bonferroni" | adj.method=="BH") {
      p.adjusted<-mt.rawp2adjp(p.raw, adj.method)
      p.adjusted<-p.adjusted$adjp[order(p.adjusted$index),][,2]
   }
   p.adjusted[p.adjusted>p.cut]<-NA
}

# Kruskal-Wallis test
if(meth=="Kruskal-Wallis") {
   p<-c()
   for(i in 1:nrow(dat2)) {
      p<-c(p, kruskal.test(dat2[i,], groups))
   }
   p.raw<-p
   if(adj.method=="none") {
      p.adjusted<-p.raw
   }
   if(adj.method=="Bonferroni" | adj.method=="BH") {
      p.adjusted<-mt.rawp2adjp(p.raw, adj.method)
      p.adjusted<-p.adjusted$adjp[order(p.adjusted$index),][,2]
   }
   p.adjusted[p.adjusted>p.cut]<-NA
}

# Writing the data to disk
if(nrow(na.omit(data.frame(dat, p.adjusted=round(p.adjusted, digits=6))))==0) {
   dat<-data.frame(dat[order(p),], p.raw=round(p[order(p)], digits=6))
   dat<-dat[1:100,]
} else {
   dat<-na.omit(data.frame(dat, p.adjusted=round(p.adjusted, digits=6)))
}
write.table(dat, file="multiple-sample.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}

# TOOL samtools-subset.R: "Make a subset of BAM" (Retrieves alignments for a specified chromosome or a region, taking the mapping quality into account if needed. For retrieving regions within chromosomes, please use the format chr1:1-100. Please note that in addition to BAM file you have to provide an index file for it. You can create the index file using the tool Index BAM. This tool is based on the SAMtools package.)
# INPUT alignment.bam: "BAM file" TYPE GENERIC 
# INPUT alignment.bai: "Index file .bai" TYPE GENERIC
# OUTPUT alignment-subset.bam
# PARAMETER region: "Region to retrieve alignments for" TYPE STRING DEFAULT chr1 (The genomic region for which you would like to retrieve the alignments for.)
# PARAMETER OPTIONAL mapping.quality: "Minimum mapping quality" TYPE INTEGER FROM 0 TO 1000 DEFAULT 0 (Retrieves only alignments which have a mapping quality higher than this. Note that Bowtie doesn't calculate mapping quality, but just inserts 255 to the field 5 of BAM file if the read aligns, and 0 if it doesn't align.)


# EK 26.10.2011

# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

system(paste(samtools.binary, "view -b -q", mapping.quality, "-o alignment-subset.bam alignment.bam", region))


#test.command <- paste(samtools.binary, "view -b -q", mapping.quality, "-o alignment-subset.bam alignment.bam", region)
#stop(paste('CHIPSTER-NOTE: ', test.command))

# TOOL norm-agilent-one-color.R: "Agilent 1-color" (Agilent one-color data preprocessing. Automatically averages all the rows, i.e., genes that have the same name. YOU HAVE TO SPECIFY THE CHIPTYPE.)
# INPUT microarray{...}.tsv: microarray{...}.tsv TYPE CDNA 
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# PARAMETER background.treatment: background.treatment TYPE [none: none, subtract: subtract, edwards: edwards, normexp: normexp] DEFAULT normexp (Background treatment method)
# PARAMETER background.offset: background.offset TYPE [0: 0, 50: 50] DEFAULT 50 (Background offset)
# PARAMETER normalize.chips: normalize.chips TYPE [none: none, scale: scale, scale-75: scale-75, quantile: quantile, vsn: vsn] DEFAULT quantile (Between arrays normalization method)
# PARAMETER remove.control.probes: remove.control.probes TYPE [yes: yes, no: no] DEFAULT no (Remove control probes from the dataset)
# PARAMETER chiptype: chiptype TYPE [empty: empty, Human-1(4100a): "Human-1 (4100a)", Human-2(4101a): "Human-2 (4101a)", Human-1A(4110b): "Human-1A (4110b)", Human-1B(4111a): "Human-1B (4111a)", Human-Whole-Genome(4112a): "Human-Whole-Genome (4112a)", Human-Whole-Genome(4851a): "Human-Whole-Genome (4851a)", Mouse(4104a): "Mouse (4104a)", Mouse(4120a): "Mouse (4120a)", Mouse(4121a): "Mouse (4121a)", Mouse(4122a): "Mouse (4122a)", Rat(4105a): "Rat (4105a)", Rat(4130a): "Rat (4130a)", Rat(4131): "Rat (4131)",  Zebrafish-1(2519f):  "Zebrafish-1 (2519f)"] DEFAULT empty ()

# cDNA chip normalization
# JTT 15.10.2007

# modified
# MG
# 20.10.2009

#background.treatment<-"normexp"
#background.offset<-c(50)
#normalize.chips<-"quantile"
#remove.control.probes<-"no"
#chiptype<-"Human-Whole-Genome (4112a)"

# Loads the libraries
library(limma)

# Renaming variables
bg<-background.treatment
normba<-normalize.chips

# Reading data
columns<-list(R="sample", Rb="samplebg", G="sample", Gb="samplebg")
annotation<-c("identifier")
columns.other<-c("flag", "annotation")

files<-dir()
files<-files[files!="phenodata.tsv"]
dat<-read.maimages(files=files, columns=columns, annotation=annotation, other.columns=columns.other) 

# Background correction
dat2<-backgroundCorrect(dat, bg, offset=as.numeric(background.offset))

# Normalization across arrays
if(normba=="scale-75") {
   dat3<-normalizeBetweenArrays(dat2$R, method="none")
   normfact<-apply(dat3, 2, quantile)["75%",]
   for(i in 1:ncol(dat3)) {
      dat3[,i]<-dat3[,i]/normfact[i]
   }
} else {
   dat3<-normalizeBetweenArrays(dat2$R, method=normba)
}

# Log-transforming the data
dat3<-log2(dat3)

# Writes out a phenodata table
sample<-paste(colnames(dat3), ".tsv", sep="")
group<-c(rep("", length(sample)))
training<-c(rep("", length(sample)))
time<-c(rep("", length(sample)))
random<-c(rep("", length(sample)))
if(chiptype=="empty") {
   chiptype<-c("cDNA")
}
if(chiptype=="Human-1(4100a)") {
   chiptype<-c("hgug4100a.db")
}
if(chiptype=="Human-2(4101a)") {
   chiptype<-c("hgug4101a.db")
}
if(chiptype=="Human-1A(4110b)") {
   chiptype<-c("hgug4110b.db")
}
if(chiptype=="Human-1B(4111a)") {
   chiptype<-c("hgug4111a.db")
}
if(chiptype=="Human-Whole-Genome(4112a)") {
   chiptype<-c("hgug4112a.db")
}
if(chiptype=="Human-Whole-Genome(4851a)") {
	chiptype<-c("hgug4851a.db")
}
if(chiptype=="Mouse(4104a)") {
   chiptype<-c("mgug4104a.db")
}
if(chiptype=="Mouse(4120a)") {
   chiptype<-c("mgug4120a.db")
}
if(chiptype=="Mouse(4121a)") {
   chiptype<-c("mgug4121a.db")
}
if(chiptype=="Mouse(4122a)") {
   chiptype<-c("mgug4122a.db")
}
if(chiptype=="Rat(4105a)") {
   chiptype<-c("rgug4105a.db")
}
if(chiptype=="Rat(4130a)") {
   chiptype<-c("rgug4130a.db")
}
if(chiptype=="Rat(4131)") {
   chiptype<-c("rgug4131unigene.db")
}
if(chiptype=="Zebrafish-1(2519f") {
	chiptype<-c("AZFV1gb.db")
}

# chiptype<-paste(chiptype, ".db", sep="")

write.table(data.frame(sample=sample, chiptype=chiptype, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# Removes control probes
rownames(dat3)<-dat$genes$identifier
if(remove.control.probes=="yes") {
   if(is.null(dim(dat$other$annotation))==FALSE) {
      dat3<-dat3[rowSums(dat$other$annotation)==0,]
   }
}

# Constructs and writes out a table
M<-dat3
M<-aggregate(M, list(rownames(M)), mean)
rownames(M)<-M$Group.1
genes<-rownames(M)
M<-M[,-1]
if(length(dat$other$flag)!=0) {
   flags<-as.data.frame(dat$other$flag)
   names(flags)<-paste("flag.", names(flags), sep="")
}
if(length(dat$other$flag)==0) {
   flags<-matrix(nrow=0, ncol=0)
}
names(M)<-paste("chip.", names(M), sep="")
M<-data.frame(M)
rownames(M)<-genes

if(chiptype!="cDNA") {
   # Including gene names to data
   library(chiptype, character.only=T)
   lib2<-sub('.db','',chiptype)
   symbol<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "SYMBOL", sep="")))))[rownames(M),])
   genename<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "GENENAME", sep="")))))[rownames(M),])
   symbol<-gsub("#", "", symbol)
   genename<-gsub("#", "", genename)
   symbol <- gsub("'", "", symbol)
   genename <- gsub("'", "", genename)
}

if(chiptype!="cDNA") {
   # Conditional on whether flags are included or not, write the data to disk
   if(nrow(flags)!=nrow(M)) {
      write.table(data.frame(symbol, description=genename, round(M, digits=2)), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
   } else {
     write.table(data.frame(symbol, description=genename, round(M, digits=2), flags), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
   }
}

if(chiptype=="cDNA") {
   if(nrow(flags)!=nrow(M)) {
      write.table(data.frame(round(M, digits=2)), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
   } else {
     write.table(data.frame(round(M, digits=2), flags), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
   }
}

# TOOL acgh-normalize.R: "Normalize copy number data" (Normalize copy number data before segmentation.)
# INPUT raw.tsv: raw.tsv TYPE GENE_EXPRS 
# OUTPUT normalized.tsv: normalized.tsv
# PARAMETER normalization: normalization TYPE [median: median, mode: mode, none: none] DEFAULT median (Normalization method.)
# PARAMETER number.of.chromosomes: number.of.chromosomes TYPE INTEGER DEFAULT 23 (Number of chromosomes. Usually 23 for sex-matched reference samples and 22 otherwise.)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-12-19

source(file.path(chipster.common.path, 'CGHcallPlus.R'))

file <- 'raw.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, as.is=TRUE, check.names=FALSE)

pos <- c('chromosome','start','end')
if (length(setdiff(pos, colnames(dat)))!=0)
  stop('CHIPSTER-NOTE: This script can only be run on files that have the following columns: chromosome, start, end.')

anno <- dat[,-grep("^chip\\.", colnames(dat))]
logratios <- dat[,grep("^chip\\.", colnames(dat))]
logratios[logratios == -Inf] <- -10

dat2 <- data.frame(probe=rownames(dat), dat[,c('chromosome', 'start', 'end')], logratios, stringsAsFactors=FALSE)
chips <- grep("^chip\\.", colnames(dat), value=TRUE)

if (ncol(dat2)==4)
  stop('CHIPSTER-NOTE: No array data found. The input file must have columns labeled with "chip.".')
if (ncol(dat2)==5)
  colnames(dat2)[5] <- chips[1]

dat2 <- dat2[!is.na(dat2$chromosome),]
dat2 <- dat2[!is.na(dat2$start),]
dat2 <- dat2[!is.na(dat2$end),]

dat2$chromosome[dat2$chromosome=='X'] <- 23
dat2$chromosome[dat2$chromosome=='Y'] <- 24
dat2$chromosome <- as.integer(dat2$chromosome)

dat2 <- dat2[order(dat2$chromosome, dat2$start),]

cgh.raw <- make_cghRaw(dat2)
cgh.pre <- preprocess(cgh.raw, nchrom=number.of.chromosomes)
cgh.nor <- normalize(cgh.pre, method=normalization)

dat3 <- cbind(anno[featureNames(cgh.nor),], copynumber(cgh.nor))
colnames(dat3) <- colnames(dat)

dat3$chromosome <- as.character(dat3$chromosome)
dat3$chromosome[dat3$chromosome=='23'] <- 'X'
dat3$chromosome[dat3$chromosome=='24'] <- 'Y'

options(scipen=10)
write.table(dat3, file='normalized.tsv', quote=FALSE, sep='\t', col.names=TRUE, row.names=TRUE)

# EOF

# TOOL ngs-find-unique-genes.R: "Find unique and annotated genes" (This tool takes a list of ENSEMBL gene identifiers, removes duplicates and fetches annotation information. The output file is compatible with downstream tools used for example for pathway analysis.)
# INPUT ensembl-list.tsv: "Table with ENSEMBL identifiers" TYPE GENERIC 
# OUTPUT unique-genes.tsv: "Table listing the unique genes that can be mapped with gene symbols and entrez gene ids." 
# PARAMETER species: "Genome" TYPE [Human: "Human", Mouse: "Mouse", Rat: "Rat"] DEFAULT Human (The genome to use for fetching annotations.)

#######################################################
#                                                     
# MG, 13.7.2011                                       
# EK, 17.5.2012 fixed parameters
# EK, 22.5.2012 fixed parameters
# Removes duplicate ENSEMBL identifiers, converts them to unique Entrez identifiers, and adds gene annotations to the output 
#                                                     
#######################################################

# Set up testing parameters
# species <- "Human"

# Load the libraries
library(ChIPpeakAnno)
library(biomaRt)

# Load the annotation data
if (species == "Human") {
	data(TSS.human.GRCh37)
	annotations <- TSS.human.GRCh37
	ensembl_dataset <- "hsapiens_gene_ensembl"
	filter <- "ens_hs_gene"
}
if (species == "Mouse") {
	data(TSS.mouse.NCBIM37)
	annotations <- TSS.mouse.NCBIM37
	ensembl_dataset <- "mmusculus_gene_ensembl"
	filter <- "ens_mm_gene"
}
if (species == "Rat") {
	data(TSS.rat.RGSC3.4)
	annotations <- TSS.rat.RGSC3.4
	ensembl_dataset <- "rnorvegicus_gene_ensembl"
	filter <- "ens_rn_gene"
}

# Read in data and extract the identifiers
ensembl_list <- read.table (file="ensembl-list.tsv", sep="\t", header=T)
if("ensembl_id" %in% colnames(ensembl_list)) {
	ensembl_id_list <- as.character(unique(ensembl_list$ensembl_id))
} else {
	ensembl_id_list <- rownames(ensembl_list)
}

print(ensembl_id_list[1:10])

# Fetch additional gene info from BioMart database
ensembl_annotations <- useMart("ensembl", dataset=as.character(ensembl_dataset))
gene_annotations <- getBM(filters="ensembl_gene_id", values=ensembl_id_list, attributes=c("ensembl_gene_id","external_gene_id","description","entrezgene"), mart=ensembl_annotations)

# Keep only the ones that have a unique ensembl gene id and actually map to unique entrez id:s
gene_annotations_na <- na.omit(gene_annotations)
unique_ensembl_id <- unique(levels(as.factor(gene_annotations_na[,1])))
matches <- na.omit(match (unique_ensembl_id, gene_annotations_na[,1], nomatch=NA))
gene_annotations_unique <- gene_annotations_na[matches,]
unique_entrez_id <- unique(levels(as.factor(gene_annotations_unique[,4])))
matches <- na.omit(match (unique_entrez_id, gene_annotations_unique[,4], nomatch=NA))
gene_annotations_unique <- gene_annotations_unique[matches,]
rownames(gene_annotations_unique) <- gene_annotations_unique[,1]
gene_annotations_unique <- gene_annotations_unique[,2:4]
names(gene_annotations_unique)[1] <- "symbol"

# Write output
write.table(gene_annotations_unique, file="unique-genes.tsv", sep="\t", col.names=T, row.names=T, quote=F)

# EOF

# TOOL sampling.R: "Random sampling" (Generates a random sample of the data.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT sample.tsv: sample.tsv 
# PARAMETER what.to.sample: what.to.sample TYPE [genes: genes, chips: chips] DEFAULT genes (Sample genes or chips)
# PARAMETER sample.size: sample.size TYPE DECIMAL FROM 0 TO 100 DEFAULT 10 (Percentage of the data to sample)


# Random sampling
# JTT 20.10.2008

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Sanity checks
if(ncol(dat)<2 | nrow(dat)<2) {
   stop("You need to have at least 2 data points from which to sample!")
}

# Sampling
if(what.to.sample=="genes") {
   v<-sample(1:nrow(dat), floor(nrow(dat)*sample.size/100))
   dat2<-dat[v,]
}

if(what.to.sample=="chips") {
   v<-sample(1:ncol(dat), floor(ncol(dat)*sample.size/100))
   dat2<-dat[,v]
}

# Writing data to disk
write.table(data.frame(dat2), file="sample.tsv", col.names=T, quote=F, sep="\t", row.names=T)

# TOOL ngs-correlation-analysis-mirna.R: "Correlate miRNA with target expression" (Performs a statistical test to detect miRNA targets whose expression is significantly positively or negatively correlated to the expression of the miRNA.)
# INPUT normalized_mirna.tsv: normalized_mirna.tsv TYPE GENE_EXPRS 
# INPUT normalized_gene.tsv: normalized_gene.tsv TYPE GENE_EXPRS 
# INPUT phenodata_mirna.tsv: phenodata_mirna.tsv TYPE GENERIC 
# INPUT phenodata_gene.tsv: phenodata_gene.tsv TYPE GENERIC 
# OUTPUT mirna-gene-positive-correlation.tsv: mirna-gene-positive-correlation.tsv 
# OUTPUT mirna-gene-negative-correlation.tsv: mirna-gene-negative-correlation.tsv 
# PARAMETER order.column.mirna: order.column.mirna TYPE METACOLUMN_SEL DEFAULT EMPTY (Phenodata column describing the order of the samples, so that the gene expression and miRNA expression arrays can be correctly matched in the analysis. For time course experiments the actual time can be used, for multiple-condition type of experiments it is adviced to encode the different conditions with a number, e.g. 1, 2, 3, 4 and 5 for an experiment where five different conditions have been assessed. NOTE: If a custom array was used for assessing the gene expression it is crucial that ENTREZ gene ID or HUGO gene symbols have been specified as identifier when importing the data into CHIPSTER.)
# PARAMETER order.column.gene: order.column.gene TYPE METACOLUMN_SEL DEFAULT EMPTY (Phenodata column describing the order of the samples, so that the gene expression and miRNA expression arrays can be correctly matched in the analysis. For time course experiments the actual time can be used, for multiple-condition type of experiments it is adviced to encode the different conditions with a number, e.g. 1, 2, 3, 4 and 5 for an experiment where five different conditions have been assessed. NOTE: If a custom array was used for assessing the gene expression it is crucial that ENTREZ gene ID have been specified as identifier when importing the data into CHIPSTER.)
# PARAMETER id.type: id.type TYPE [probe_id: probe_id, entrez_id: entrez_id] DEFAULT probe_id (Defines the type of gene identifier to use. For supported array types from Affymetrix, Agilent or Illumina probe_id should be used, whereas for custom arrays entrez_id should be used.)
# PARAMETER correlation.method: correlation.method TYPE [pearson: pearson, spearman: spearman, kendall: kendall] DEFAULT pearson (Method for calculating the correlation. Peasron's method is parametric, whereas Spearman's correlation is a non-parametric rank-based method that is less sensitive to outliers. Kendall's method is suitable in those cases one is interested in the sign of the changes in expression between adjacent data points, rather than the magnitude.)
# PARAMETER p.value.threshold: p.value.threshold TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (P-value cut-off for significant results)
# PARAMETER p.value.adjustment.method: p.value.adjustment.method TYPE [none: none, Bonferroni: Bonferroni, Holm: Holm, Hochberg: Hochberg, BH: BH, BY: BY] DEFAULT BH (Multiple testing correction method)

# Correlation analysis of miRNA targets
# MG, 11.2.2010
# IS, 8.6.2010, bugfix
# IS, 28.7.2010, now allows additional samples in the two data sets, but only those ones with a pair are used in the analysis
# MG, 10.2.2011, now gets the gene symbols from the org.HS.eg.db package and adds rownames the output tables to allow use of Venn diagram

# Loads the libraries
library(RmiR)
library(org.Hs.eg.db)

# Loads the normalized data and phenodata files
data_1 <- read.table(file="normalized_mirna.tsv", header=T, sep="\t", row.names=1)
data_2 <- read.table(file="normalized_gene.tsv", header=T, sep="\t", row.names=1)
phenodata_1 <- read.table("phenodata_mirna.tsv", header=T, sep="\t")
phenodata_2 <- read.table("phenodata_gene.tsv", header=T, sep="\t")

# Figure out which is the miRNA data
if (phenodata_1$chiptype[1] == "miRNA") {
	mirna.phenodata <- phenodata_1
	mirna.data <- data_1
	gene.phenodata <- phenodata_2
	gene.data <- data_2
}
if (phenodata_2$chiptype[1] == "miRNA") {
	mirna.phenodata <- phenodata_2
	mirna.data <- data_2
	gene.phenodata <- phenodata_1
	gene.data <- data_1
}

# Separates expression values and flags
mirna.data.2 <- mirna.data[,grep("chip", names(mirna.data))]
gene.data.2 <- gene.data[,grep("chip", names(gene.data))]

# Get sample order for matching the datasets
#mirna.order <- mirna.phenodata[,grep(order.column.mirna, colnames(mirna.phenodata))]
#gene.order <- gene.phenodata[,grep(order.column.gene, colnames(gene.phenodata))]

# check for unambiguity of sample identifiers
if (nrow(mirna.phenodata)!=length(unique(mirna.phenodata[,order.column.mirna])))
	stop('CHIPSTER-NOTE: Unambigous sample identifiers: ', paste(mirna.phenodata[,order.column.mirna], collapse=', ')) 
if (nrow(gene.phenodata)!=length(unique(gene.phenodata[,order.column.gene])))
	stop('CHIPSTER-NOTE: Unambigous sample identifiers: ', paste(gene.phenodata[,order.column.gene], collapse=', ')) 

# pick those samples that do have a matching pair
common.samples <- intersect(mirna.phenodata[,order.column.mirna], gene.phenodata[,order.column.gene])
rownames(mirna.phenodata) <- mirna.phenodata[,order.column.mirna]
rownames(gene.phenodata) <- gene.phenodata[,order.column.gene]
mirna.phenodata$n <- 1:nrow(mirna.phenodata)
gene.phenodata$n <- 1:nrow(gene.phenodata)
mirna.order <- mirna.phenodata[common.samples, 'n']
gene.order <- gene.phenodata[common.samples, 'n']

# Read the chiptype that was used for the gene expression data
if (id.type=="probe_id") {
	chip.type <- as.character(gene.phenodata[1,grep("chiptype", names(gene.phenodata))])
	if (length(grep(".db", chip.type)) == 0 & length(grep("pmcdf", chip.type)) == 0) {
		chip.type <- paste(chip.type, ".db", sep="")
	}
}
if (id.type=="entrez_id") {
	chip.type <- "org.Hs.eg.db"
}

# Sanity checks to make sure the experiment have enough conditions
if(length(unique(mirna.order))==1 | length(unique(gene.order))==1) {
	stop("You need to have at least 2 conditions or time points to run this analysis!")
}

# Sanity checks to make sure that the mirna and gene expression data sets
# have the same number of conditions
if(length(unique(mirna.order))!=length(unique(gene.order))) {
	stop("You need to have the same number of conditions, or time points, in the two data sets!")
}

# Define number of conditions
number.conditions <- length(mirna.order)

# Arrange the columns in the two datset so they match
mirna.data.3 <- mirna.data.2[,order(mirna.order)]
gene.data.3 <- gene.data.2[,order(gene.order)]

# Create data set appropriate for correlation testing
mirna.data.4 <- data.frame(mirna=rownames(mirna.data.3), exprs=mirna.data.3[,1])
gene.data.4 <- data.frame(gene=rownames(gene.data.3), exprs=gene.data.3[,1])

# check that the gene list actually contain at least one miRNA target
try(merged.table <- read.mir(gene=gene.data.4, mirna=mirna.data.4,
				annotation=chip.type), silent=TRUE)

if (match("merged.table",ls(),nomatch=0)==0) {
	stop("There were no targets found in either TarBase or PicTar databases for the supplied list of miRNA:s in the gene list selected. Try again by selecting a longer list of genes!")
}
merged.table <- read.mir(gene=gene.data.4, mirna=mirna.data.4,
		annotation=chip.type, verbose=TRUE)

for (count in 2:number.conditions) {
	mirna.data.4 <- data.frame(mirna=rownames(mirna.data.3), exprs=mirna.data.3[,count])
	gene.data.4 <- data.frame(gene=rownames(gene.data.3), exprs=gene.data.3[,count])
	temp.table <- read.mir(gene=gene.data.4, mirna=mirna.data.4,
			annotation=chip.type, verbose=TRUE)
	temp.table
	merged.table <- cbind (merged.table, temp.table)
}

# Change the symbols that come from the read.mir() function into
# the ones that come from the org.Hs.eg.db package
all_genes <- org.Hs.egSYMBOL
mapped_genes <- mappedkeys(all_genes)
mapped_genes  <- as.list(all_genes[mapped_genes])
symbols_list <- unlist(mapped_genes[as.character(merged.table$gene_id) ])
merged.table$symbol <- symbols_list

# Extract the matching mirna and gene expression values into two vectors
mirna.expression <- merged.table[, grep("mirExpr", names(merged.table))]
gene.expression <- merged.table[, grep("geneExpr", names(merged.table))]

# Calculate the pearson correlation value for each mirna-gene pair
results.table <- data.frame(merged.table$mature_miRNA, merged.table$gene_id, merged.table$symbol, correlation.coefficient=NA, correlation.p.value=NA)
names (results.table) <- c("miRNA", "entrez_id", "symbol", "correlation_coefficient", "p-value")
number.mirna <- dim(merged.table)[1]
for (mirna.count in 1:number.mirna) {
	correlation.coefficient <- cor (as.numeric(mirna.expression[mirna.count,]),as.numeric(gene.expression[mirna.count,]), method=correlation.method)
	correlation.p.value <- cor.test (as.numeric(mirna.expression[mirna.count,]),as.numeric(gene.expression[mirna.count,]), method=correlation.method)
	correlation.p.value <- correlation.p.value$p.value
	results.table[mirna.count,4] <- correlation.coefficient
	results.table[mirna.count,5] <- correlation.p.value
}
results.table[,5] <- p.adjust(results.table[,5], method=p.value.adjustment.method)

# Add rownames to allow use of Venn diagrams
# Construct the names from combining the miRNA nameand the target gene symbol
rownames (results.table) <- paste (results.table[,1],"_",results.table[,3],sep="")

# Find genes with statistically significant positive correlation
results.positive <- results.table[results.table[,4]>0,]
results.positive.significant <- results.positive[results.positive[,5]<=p.value.threshold,]

# Find genes with statistically significant negative correlation
results.negative <- results.table[results.table[,4]<=0,]
results.negative.significant <- results.negative[results.negative[,5]<=p.value.threshold,]

# Write the results to tables to be read into Chipster
write.table(results.positive.significant, file="mirna-gene-positive-correlation.tsv", sep="\t", quote=FALSE, row.names=TRUE)
write.table(results.negative.significant, file="mirna-gene-negative-correlation.tsv", sep="\t", quote=FALSE, row.names=TRUE)

# EOF

# TOOL search-queryword.R: "Search by gene name" (Search genes using gene names, rownames or chromosome locations. Gene name must be the gene's HUGO name, such as XRCC1. Rowname must the name of the gene that appears on the rows of all data files. Chrosomome location must be a chromosome name, such as X. The mode option determines whether the queried gene name or chromosome should be included or excluded in the output data table.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT search.tsv: search.tsv 
# PARAMETER search.for: search.for TYPE [rowname: rowname, Genename: Genename, ChromosomeLocation: ChromosomeLocation] DEFAULT rowname (What to search with)
# PARAMETER query: query TYPE STRING DEFAULT empty (Query word)
# PARAMETER mode: mode TYPE [include: include, exclude: exclude] DEFAULT include (Defines whether the found genes should be included or excluded from the resulting data table.)

# Search genes by name, AffyID, correlation or chromosome location
# JTT 4.7.2006
#
# modified, MG, 23.2.2010, to allow option to exclude query genes or chromosomes

# Renaming variables
meth<-search.for
query<-query

# Loads libraries
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
if(phenodata$chiptype[1]!="cDNA" & phenodata$chiptype[1]!="Illumina" & phenodata$chiptype[1]!="miRNA" ) {
   lib<-phenodata$chiptype[1]
   lib<-as.character(lib)
   
   # Account for the fact that annotation packages are from version 2.3 of Bioconductor
   # named with an ".db" suffix. Add the suffix when missing to support data files
   # from Chipster 1.3 and earlier. 
   if (length(grep(".db", lib)) == 0 & length(grep("pmcdf", lib)) == 0) {
        lib <- paste(lib, ".db", sep="")
   }
   
   library(package=lib, character.only=T)
}

# Loads data (which file to search)
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

if(meth=="rowname") {
	if(mode=="include") dat2<-dat[grep(query, row.names(dat), invert=FALSE),]
	if(mode=="exclude") dat2<-dat[grep(query, row.names(dat), invert=TRUE),]
	write.table(dat2, file=("search.tsv"), sep="\t", row.names=T, col.names=T, quote=F)
}

if(meth=="Genename") {
   query<-paste("^", query, sep="")
   lib2<-sub('.db','',lib)
   env<-paste(lib2, "SYMBOL", sep="")
   env2<-get(env)
   list<-unlist(as.list(env2))[grep(query, unlist(as.list(env2)), invert=FALSE)]
	affyid<-names(list)
	matching_indices <- match(affyid, rownames(dat))
	if (mode=="include") dat2 <- dat[matching_indices,]
	if (mode=="exclude") dat2 <- dat[-matching_indices,]
   write.table(dat2, file=("search.tsv"), sep="\t", row.names=T, col.names=T, quote=F)
}

if(meth=="ChromosomeLocation") {
   lib2<-sub('.db','',lib)
   env<-paste(lib2, "CHR", sep="")
   env2<-get(env)
   if(mode=="include") affyids<-data.frame(id=names(as.list(env2))[grep(query, as.list(env2), invert=FALSE)])
   if(mode=="exclude") affyids<-data.frame(id=names(as.list(env2))[grep(query, as.list(env2), invert=TRUE)])
      dat2<-merge(dat, affyids, by.x="row.names", by.y="id")
   row.names(dat2)<-dat2$Row.names
   dat2<-dat2[,-1]
   write.table(dat2, file="search.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}

# TOOL stat-two-groups.R: "Two groups tests" (Tests for comparing the mean gene expression of two groups. LPE only works, if the whole normalized data is used, i.e., the data should not be filtered. Other than empiricalBayes might be slow, if run on unfiltered data.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT two-sample.tsv: two-sample.tsv 
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to test)
# PARAMETER OPTIONAL pairing: pairing TYPE METACOLUMN_SEL DEFAULT EMPTY (Phenodata column describing which samples form pairs. This option should be used if you have, for example, monitored your samples before and after treatment, have patient-matched data or you have expression data at multiple tissue sites from the same individuals, etc. LPE, F-test and fast-t-test do not support pairing information.)
# PARAMETER test: test TYPE [empiricalBayes: empiricalBayes, fast-t-test: fast-t-test, t-test: t-test, F-test: F-test, Mann-Whitney: Mann-Whitney, LPE: LPE] DEFAULT empiricalBayes (Test type)
# PARAMETER p.value.adjustment.method: p.value.adjustment.method TYPE [none: none, Bonferroni: Bonferroni, Holm: Holm, Hochberg: Hochberg, BH: BH, BY: BY] DEFAULT BH (Multiple testing correction method)
# PARAMETER p.value.threshold: p.value.threshold TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (P-value cut-off for significant results)
# PARAMETER show.na: show.na TYPE [yes: yes, no:no] DEFAULT yes (include results where p-value is NA)

# Two-group parametric and non-parametric tests
# JTT 4.7.2006
# OH, 7.11.2011
# EK, 8.1.2012
# JT, 28.11.2012, fixed Wilcoxon test, sped up other tests
# MK, 05.02.2013, added paired tests for limma, t-test and Wilcox

# Loads the libraries
library(multtest)

# Renaming variables
meth<-test
if(test=="empiricalBayes" & (p.value.adjustment.method!="BH" & p.value.adjustment.method!="BY") ) {
	adj.method<-tolower(p.value.adjustment.method)
} else {
	adj.method<-p.value.adjustment.method
}
p.cut<-p.value.threshold
show.p.na<-show.na

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls <- dat[,grep("flag", names(dat))]
dat2  <- as.matrix(dat[,grep("chip", names(dat))])

# Test needs a parameter "groups" that specifies the grouping of the samples
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
groups<-phenodata[,pmatch(column,colnames(phenodata))]

if(exists("pairing")) {
	if(pairing!="EMPTY") {
		pairs<-phenodata[,pmatch(pairing,colnames(phenodata))]
	}
} else {
	pairing <- "EMPTY"
}

# Sanity checks
if(length(unique(groups))==1 | length(unique(groups))>=3) {
	stop("CHIPSTER-NOTE: You need to have exactly two groups to run this analysis")
}

# Testing

# Empirical Bayes
if(meth=="empiricalBayes") {
	library(limma)
	if(pairing=="EMPTY") {
		design<-model.matrix(~as.factor(groups))
	} else {
		groups		<- factor(groups)
		pairs		<- factor(pairs)
		#the 0 means no intercept for the first factor. In this case pairs-factor must be given first
		#design		<- model.matrix(~0+pairs+groups)
		design		<- model.matrix(~groups+pairs)
	}

	#stop(as.factor(groups));
	
	fit<-lmFit(dat2, design)
	fit<-eBayes(fit)
	tab<-toptable(fit, coef=2, number=nrow(fit), adjust.method=adj.method)
	rows<-as.numeric(row.names(tab))
	rows<-rows[tab$adj.P.Val<=p.cut]
	p<-tab$adj.P.Val[tab$adj.P.Val<=p.cut]
	M<-tab$logFC[tab$adj.P.Val<=p.cut]
	dat<-dat[rows,]
	write.table(data.frame(dat, p.adjusted=round(p, digits=6), FC=M), file="two-sample.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}

if(meth=="RankProd") {
	library(RankProd)
	
	dat2.1 <-dat2[,groups==unique(groups)[1]]
	dat2.2 <-dat2[,groups==unique(groups)[2]]
			
	if(pairing =="EMPTY") {
		group_vec <- c(rep(0, ncol(dat2.1)), rep(1, ncol(dat2.1)));
		dat.rp <- cbind(dat2.1, dat2.2);
	} else {
		pairs.1 <-pairs[groups==unique(groups)[1]]
		pairs.2 <-pairs[groups==unique(groups)[2]]
		
		#find shared elements (remove elements not present in one of the arrays)
		dat2.1 <- dat2.1[, which(pairs.1 %in% intersect(pairs.1, pairs.2))]
		dat2.2 <- dat2.2[, which(pairs.2 %in% intersect(pairs.1, pairs.2))]
		
		pairs.1 <- pairs.1[which(pairs.1 %in% intersect(pairs.1, pairs.2))];
		pairs.2 <- pairs.2[which(pairs.2 %in% intersect(pairs.1, pairs.2))];
		
		#average over those that are found multiple times in one
		temp.1 <- t(rowsum(t(dat2.1), factor(pairs.1), reorder = FALSE, na.rm = TRUE));
		temp.2 <- t(rowsum(1L - is.na(t(dat2.1)), factor(pairs.1), reorder = FALSE));
		dat2.1 <- temp.1 / temp.2;
		
		temp.1 <- t(rowsum(t(dat2.2), factor(pairs.2), reorder = FALSE, na.rm = TRUE));
		temp.2 <- t(rowsum(1L - is.na(t(dat2.2)), factor(pairs.2), reorder = FALSE));
		dat2.2 <- temp.1 / temp.2;

		#sort columns so that samples have the same order
		dat2.2 <- dat2.2[,match(pairs.1, pairs.2)]
		
		if(ncol(dat2.1) != ncol(dat2.2)) { stop("Paired RankProd error: matrices differn in column number")}
		dat.rp <- dat2.1 - dat2.2;
		group_vec <- rep(0, ncol(dat.rp));
	}

	print(dat.rp[1:10,]);
	print(group_vec)
	
	RPdata 	<- RP(dat.rp, cl=group_vec, num.perm=10, logged=TRUE)
	p.raw   <- cbind(RPdata$pval[,1],  RPdata$pval[,2]);
}
		
# Fast T-test
if(meth=="fast-t-test") {
	if(pairing!="EMPTY") { stop("CHIPSTER-NOTE: Fast T-test does not support pairing information"); }
		
	fit1<-lm(t(dat2)~groups)
	p<-rep(NA, nrow(dat2))
	for(i in 1:nrow(dat2)) {
		sum(fit1$residuals[,i]^2)->sse
		sum((dat2[i,]-mean(as.numeric(dat2[i,])))^2)->sst
		r2<-1-(sse/sst)
		f<-r2/((1-r2)/(ncol(dat2)-1))
		p[i]<-1-pf(f, 1, (ncol(dat2)-1))
	}
	p.raw<-p	
}

# T-test
if(meth=="t-test") {
	dat2.1 <-dat2[,groups==unique(groups)[1]]
	dat2.2 <-dat2[,groups==unique(groups)[2]]
	p      <- rep(as.numeric(NA), nrow(dat2))
	if (pairing=="EMPTY") {
		for(i in 1:nrow(dat2)) {
			if( (sum(!is.na(dat2.1[i,])) > 1) & (sum(!is.na(dat2.2[i,])) > 1) &&
				( length(which(!dat2.1[i,]==mean(dat2.1[i,])))>0 || length(which(!dat2.2[i,]==mean(dat2.2[i,])))>0 )
			  ) { 
				p[i] <- t.test(x=dat2.1[i,], y=dat2.2[i,])$p.value
			} 
		}
	} else {
		pairs.1 <-pairs[groups==unique(groups)[1]]
		pairs.2 <-pairs[groups==unique(groups)[2]]

		#find shared elements (remove elements not present in one of the arrays)
		dat2.1 <- dat2.1[, which(pairs.1 %in% intersect(pairs.1, pairs.2))]
		dat2.2 <- dat2.2[, which(pairs.2 %in% intersect(pairs.1, pairs.2))]
		
		pairs.1 <- pairs.1[which(pairs.1 %in% intersect(pairs.1, pairs.2))];
		pairs.2 <- pairs.2[which(pairs.2 %in% intersect(pairs.1, pairs.2))];
		
		#average over those that are found multiple times in one
		temp.1 <- t(rowsum(t(dat2.1), factor(pairs.1), reorder = FALSE, na.rm = TRUE));
		temp.2 <- t(rowsum(1L - is.na(t(dat2.1)), factor(pairs.1), reorder = FALSE));
		dat2.1 <- temp.1 / temp.2;

		temp.1 <- t(rowsum(t(dat2.2), factor(pairs.2), reorder = FALSE, na.rm = TRUE));
		temp.2 <- t(rowsum(1L - is.na(t(dat2.2)), factor(pairs.2), reorder = FALSE));
		dat2.2 <- temp.1 / temp.2;

		#sort columns so that samples have the same order
		dat2.2 <- dat2.2[,match(pairs.1, pairs.2)]
		
		for(i in 1:nrow(dat2)) {
			if((sum(!is.na(dat2.1[i,])) > 1) & (sum(!is.na(dat2.2[i,])) > 1)
				( length(which(!dat2.1[i,]==mean(dat2.1[i,])))>0 || length(which(!dat2.2[i,]==mean(dat2.2[i,])))>0 )
			) { 
				p[i] <- t.test(x=dat2.1[i,], y=dat2.2[i,], paired=TRUE)$p.value
			}
		}	
	}

	p.raw<-p
}

# F-test
if(meth=="F-test") {
	#paired var.test does in fact exist in package PairedData
	if(pairing!="EMPTY") { stop("CHIPSTER-NOTE: F-test does not support pairing information"); }
	
	dat2.1 <-dat2[,groups==unique(groups)[1]]
	dat2.2 <-dat2[,groups==unique(groups)[2]]
	p 	   <- rep(as.numeric(NA), nrow(dat2))
	for(i in 1:nrow(dat2)) {
		p[i] <- var.test(x=as.numeric(dat2.1[i,]), y=as.numeric(dat2.2[i,]))$p.value
	}
	p.raw<-p
	
}

# Mann-Whitney test
if(meth=="Mann-Whitney") {
	dat2.1 <-dat2[,groups==unique(groups)[1]]
	dat2.2 <-dat2[,groups==unique(groups)[2]]
	p      <- rep(as.numeric(NA), nrow(dat2))

	if (pairing=="EMPTY") {
		for(i in 1:nrow(dat2)) {
			p[i] <- wilcox.test(x=dat2.1[i,], y=dat2.2[i,])$p.value
		}
	} else {
		pairs.1 <-pairs[groups==unique(groups)[1]]
		pairs.2 <-pairs[groups==unique(groups)[2]]
		
		#find shared elements (remove elements not present in one of the arrays)
		dat2.1 <- dat2.1[, which(pairs.1 %in% intersect(pairs.1, pairs.2))]
		dat2.2 <- dat2.2[, which(pairs.2 %in% intersect(pairs.1, pairs.2))]
		
		pairs.1 <- pairs.1[which(pairs.1 %in% intersect(pairs.1, pairs.2))];
		pairs.2 <- pairs.2[which(pairs.2 %in% intersect(pairs.1, pairs.2))];
		
		#average over those that are found multiple times in one
		temp.1 <- t(rowsum(t(dat2.1), factor(pairs.1), reorder = FALSE, na.rm = TRUE));
		temp.2 <- t(rowsum(1L - is.na(t(dat2.1)), factor(pairs.1), reorder = FALSE));
		dat2.1 <- temp.1 / temp.2;
		
		temp.1 <- t(rowsum(t(dat2.2), factor(pairs.2), reorder = FALSE, na.rm = TRUE));
		temp.2 <- t(rowsum(1L - is.na(t(dat2.2)), factor(pairs.2), reorder = FALSE));
		dat2.2 <- temp.1 / temp.2;

		#sort columns so that samples have the same order
		dat2.2 <- dat2.2[,match(pairs.1, pairs.2)]
		
		for(i in 1:nrow(dat2)) {
			p[i] <- wilcox.test(x=dat2.1[i,], y=dat2.2[i,], paired=TRUE)$p.value
		}
	}
		
	p.raw<-p
}

## these methods have a common p-value adjustment and result generation
if (meth %in% c("Mann-Whitney", "fast-t-test", "t-test", "F-test")){
	if(!exists("p.raw")) {	
		stop("Could not find p.raw object")
	}	
	
	if (adj.method %in% c("Bonferroni", "Holm", "Hochberg")) {
		p.adjusted <- p.adjust(p.raw, method=tolower(adj.method))
	} else {
		p.adjusted <- p.adjust(p.raw, method=adj.method)
	}
	if( show.p.na == "yes" ) {
		dat<-dat[which(p.adjusted<=p.cut|is.na(p.adjusted)),]   
		p.adjusted<-p.adjusted[which(p.adjusted<=p.cut|is.na(p.adjusted))]
	} else {
		dat<-dat[which(p.adjusted<=p.cut),]   
		p.adjusted<-p.adjusted[which(p.adjusted<=p.cut)]
	}
	write.table(data.frame(dat, p.adjusted=round(p.adjusted, digits=6)),
			file="two-sample.tsv", sep="\t", row.names=TRUE,
			col.names=TRUE, quote=FALSE)
}

if(meth=="RankProd") {
	if(!exists("p.raw")) {	
		stop("Could not find p.raw object")
	}	
	
	p.adjusted <- matrix(NA, ncol=ncol(p.raw), nrow=nrow(p.raw));
	if (adj.method %in% c("Bonferroni", "Holm", "Hochberg")) {
		p.adjusted[, 1] <- p.adjust(p.raw[, 1], method=tolower(adj.method));
		p.adjusted[, 2] <- p.adjust(p.raw[, 2], method=tolower(adj.method));
	} else {
		p.adjusted[, 1] <- p.adjust(p.raw[, 1], method=adj.method)
		p.adjusted[, 2] <- p.adjust(p.raw[, 2], method=adj.method)
	}
	if( show.p.na == "yes" ) {
		dat <- dat[which(apply(p.adjusted,1,min)<=p.cut|is.na(apply(p.adjusted,1,min))),]   
		p.adjusted <- p.adjusted[which(apply(p.adjusted,1,min)<=p.cut|is.na(apply(p.adjusted,1,min))), ]
		p.adjusted <- apply(p.adjusted,1,min)
	} else {
		dat <- dat[which(apply(p.adjusted,1,min)<=p.cut),]   
		p.adjusted <- p.adjusted[which(apply(p.adjusted,1,min)<=p.cut), ]
		p.adjusted <- apply(p.adjusted,1,min)
	}
	
	write.table(data.frame(dat, p.adjusted=round(p.adjusted, digits=6)),
			file="two-sample.tsv", sep="\t", row.names=TRUE,
			col.names=TRUE, quote=FALSE)
}
	
if(meth=="LPE") {
	if(pairing!="EMPTY") { stop("CHIPSTER-NOTE: LPE does not support pairing information"); }
	
	library(LPE)
	
	group1 <-dat2[,groups==unique(groups)[1]]
	group2 <-dat2[,groups==unique(groups)[2]]	
	g1.x<-baseOlig.error(group1)
	g2.x<-baseOlig.error(group2)
	lp<-data.frame(lpe(group1, group2, g1.x, g2.x, probe.set.name=row.names(dat2)))
	
	if(adj.method=="none" | adj.method=="Holm") {
		x.location <- grep("^x", names(lp))
		y.location <- grep("^y", names(lp))
		x <- lp[, x.location]
		y <- lp[, y.location]
		pnorm.diff <- pnorm(lp$median.diff, mean = 0, sd = lp$pooled.std.dev)
		
		p.adjusted <- 2 * apply(cbind(pnorm.diff, 1 - pnorm.diff), 1, min)
		
		if(adj.method=="Holm") {
			#do Holm-Bonferroni correction
			p.adjusted <- pmin(p.adjusted * seq(1,length(p.adjusted)),1) 	
		}
	}
	if(adj.method=="Hochberg") {
		stop("CHIPSTER-NOTE: LPE function does not support Hochberg's correction. Please rerun the function again after choosing another p.value.adjustment.method")
	}
	if(adj.method=="Bonferroni" | adj.method=="BH" | adj.method=="BY") {
		p.adjusted <- fdr.adjust(lp, adjp=adj.method)
		p.adjusted <- p.adjusted[order(match(rownames(p.adjusted),rownames(lp))),]
		p.adjusted <- data.frame(p.adjusted)$FDR;
		
		#dat2<-merge(dat,as.data.frame(round(fdr, digits=4)), by.x="row.names", by.y="row.names")
		#dat2<-dat2[,-ncol(dat2)] # Removes the last columns that holds Z-test values
		#names(dat2)[which(names(dat2)=="FDR")]<-"p.adjusted" # Renames "FDR" with "p.adjusted"
	}
	if( show.p.na == "yes" ) {
		dat<-dat[which(p.adjusted<=p.cut|is.na(p.adjusted)),]   
		p.adjusted<-p.adjusted[which(p.adjusted<=p.cut|is.na(p.adjusted))]
	} else {
		dat<-dat[which(p.adjusted<=p.cut),]   
		p.adjusted<-p.adjusted[which(p.adjusted<=p.cut)]
	}
	write.table(data.frame(dat, p.adjusted=round(p.adjusted, digits=6)), file="two-sample.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}

# EOF

# TOOL classification-knn.R: "KNN classification" (K-nearest neighbor classification. If you have a separate test data set, you can validate the prediction with it by setting the validation type to predict. This function does not perform any gene selection, and the analysis is run for the selected data set.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT knn-cross-validation.tsv: knn-cross-validation.tsv 
# PARAMETER number.of.nearest.neighbors: number.of.nearest.neighbors TYPE INTEGER FROM 1 TO 1000 DEFAULT 2 (Number of nearest neighbors)
# PARAMETER number.of.votes: number.of.votes TYPE INTEGER FROM 0 TO 1000 DEFAULT 2 (Number of votes needed to get a definite answer)
# PARAMETER validation.type: validation.type TYPE [crossvalidate: crossvalidate, predict: predict] DEFAULT crossvalidate (Type of analysis)


# KNN classification
# JTT 26.6.2006

# Parameter settings (default) for testing purposes
#number.of.nearest.neighbors<-2
#number.of.votes<-2
#validation.type<-"crossvalidate"

# Renaming the variables
knn.type<-validation.type
k.no<-number.of.nearest.neighbors
k.vote<-number.of.votes

# Load the libraries
library(class)

# Loads the data
file<-c("normalized.tsv")
dat<-read.table(file, sep="\t", header=T, row.names=1)

# Reads the phenodata table
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")

# Checks whether the training variable is present if phenodata
# If training part of phenodata has not been filled, but the column (header) is present, 
# all the chips belong to the training set
if(length(grep("training", names(phenodata)))>0) {
   tr<-phenodata$training
   if(tr[1]==" " | tr[1]=="" | any(is.na(tr))==T) {
	tr<-rep(1, nrow(phenodata))
   }
}

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Are the parameter values sensical?
if(k.no>length(dat2)) {
	stop("The number of neighbors is larger than the number of chips!")
}
if(k.vote>k.no) {
	stop("The number of votes needed to give a definitive answer is larger than the number of neighbors!")
}

if(validation.type=="predict") {
   # Which parts of the data are training and test sets?
   dat3<-split(as.data.frame(t(dat2)), tr) 
   train<-dat3$'1'
   test<-dat3$'2'
   # Which part of the phenodata are training and test set
   phenodata_training <- phenodata[phenodata$training==1,]
   if (knn.type=="predict") {
	phenodata_test <- phenodata[phenodata$training==2,]
   }
} else {
   train<-dat3
}

# Defines the true classification of the training set
if(validation.type=="predict") {
   cl<-phenodata_training$group
} else {
   cl<-phenodata$group
}

# Runs the KNN analysis and reports the results
if(knn.type=="crossvalidate") {
	knn.cross<-knn.cv(train=train, cl=cl, k=k.no, l=k.vote)
	# Writes a table of known versus predicted classes
	write.table(data.frame(sample=rownames(train), known.classes=cl, prediction=knn.cross), file="knn-cross-validation.tsv", sep="\t", row.names=F, col.names=T, quote=F)
}

if(knn.type=="predict") {
	cl_test<-phenodata_test$group
	knn.predict<-knn(train=train, test=test, cl=cl, k=k.no, l=k.vote)
	# Writes a table of known versus predicted classes 
	write.table(data.frame(sample=rownames(test), known.classes=cl_test, prediction=knn.predict), file="knn-cross-validation.tsv", sep="\t", row.names=F, col.names=T, quote=F)
}

# TOOL norm-illumina-SNP.R: "Illumina SNP arrays" (Illumina SNP array preprocessing. Input should be a tab-delimited text file with genotype calls. Typically such a file is created using GenCall software from Illumina.)
# INPUT chip.txt: chip.txt TYPE GENERIC 
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 

# Illumina SNP array normalization
# JTT 22.10.2008

# Reading data
firstfield <- scan(dir(), what = "", sep = ",", flush = TRUE, quiet = TRUE, blank.lines.skip = FALSE, multi.line = FALSE)
skip <- grep("[Data]", firstfield, fixed = TRUE)
samples <- read.table(dir(), skip = skip, header = TRUE, sep = "\t", as.is = TRUE, check.names = FALSE, colClasses = "character")

# Transforming the data to a wide data frame
ids<- unique(samples$"Sample ID")
dat2<-matrix(nrow=nrow(samples)/length(ids), ncol=length(ids), data=NA)
for(i in 1:length(ids)) {
   cursam<-samples[samples$"Sample ID"==ids[i],]
   dat2[,i]<-as.numeric(as.factor(paste(cursam$"Allele1 - Top", cursam$"Allele2 - Top", sep="")))
}
dat2<-data.frame(dat2)
rownames(dat2)<-cursam$"SNP Name"
colnames(dat2)<-paste("chip.", ids, sep="")

# Writes out a phenodata table
chiptype<-"Illumina"
sample<-colnames(dat2)
group<-c(rep("", ncol(dat2)))
training<-c(rep("", ncol(dat2)))
time<-c(rep("", ncol(dat2)))
random<-c(rep("", ncol(dat2)))
write.table(data.frame(sample=sample, chiptype=chiptype, group=group, training=training), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# Writing data to disk
write.table(dat2, file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)

# TOOL norm-affy-gene.R: "Affymetrix gene arrays" (Affymetrix RMA preprocessing for CEL-files. Please note that the preprocessing might take a long time. YOU HAVE TO SPECIFY THE CHIPTYPE.)
# INPUT microarray{...}.cel: microarray{...}.cel TYPE AFFY 
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# PARAMETER chiptype: chiptype TYPE [empty: empty, human-1.0-ST: human-1.0-ST, human-1.1-ST: human-1.1-ST, human-2.0-ST: human-2.0-ST, human-2.1-ST: human-2.1-ST, mouse-1.0-ST: mouse-1.0-ST, mouse-1.1-ST: mouse-1.1-ST, mouse-2.0-ST: mouse-2.0-ST, mouse-2.1-ST: mouse-2.1-ST, rat-1.0-ST: rat-1.0-ST, rat-1.1-ST: rat-1.1-ST, rat-2.0-ST: rat-2.0-ST, rat-2.1-ST: rat-2.1-ST, zebra_fish-1.0-ST: zebra_fish-1.0-ST, zebra_fish-1.1-ST: zebra_fish-1.1-ST, arabidopsis-1.0-ST-entrez: arabidopsis-1.0-ST-entrez, arabidopsis-1.1-ST-entrez: arabidopsis-1.1-ST-entrez, arabidopsis-1.0-ST-tair: arabidopsis-1.0-ST-tair, arabidopsis-1.1-ST-tair: arabidopsis-1.1-ST-tair] DEFAULT empty (Chiptype)
# PARAMETER biomart: "biomaRt annotation" TYPE [yes: annotate, no: skip] DEFAULT no (In the case where no annotation has been attached to CDF-files, attach symbol and description information to probesets using bioMart)

# Affymetrix normalization
# JTT, 3.2.2009
# MG. 18.10.2011, added version 1.1 ST arrays
# MK 15.05.2014 added new arrays

# Initializes analyses
library(affy)
library(biomaRt)

# Reads in data
dat<-ReadAffy()
if(chiptype=="empty") {
	stop("CHIPSTER-NOTE: You need to specify the chiptype. Please run the tool again.")
}

filt <- "entrezgene"
usemart <- "ensembl"

if(chiptype=="human-1.0-ST") {
	dat@cdfName<-"hugene10stv1hsentrezgcdf"
	dat@annotation<-"hugene10stv1hsentrezgcdf"
	chiptype<-"hugene10stv1hsentrezg.db"
	dataset <- "hsapiens_gene_ensembl"
}
if(chiptype=="human-1.1-ST") {
	dat@cdfName<-"hugene11stv1hsentrezgcdf"
	dat@annotation<-"hugene11stv1hsentrezgcdf"
	chiptype<-"hugene11stv1hsentrezg.db"
	dataset <- "hsapiens_gene_ensembl"
}
if(chiptype=="human-2.0-ST") {
	dat@cdfName<-"hugene20sthsentrezgcdf"
	dat@annotation<-"hugene20sthsentrezgcdf"
	chiptype<-"hugene20sthsentrezg.db"
	dataset <- "hsapiens_gene_ensembl"
}
if(chiptype=="human-2.1-ST") {
	dat@cdfName<-"hugene21sthsentrezgcdf"
	dat@annotation<-"hugene21sthsentrezgcdf"
	chiptype<-"hugene21sthsentrezg.db"
	dataset <- "hsapiens_gene_ensembl"
}
if(chiptype=="mouse-1.0-ST") {
	dat@cdfName<-"mogene10stv1mmentrezgcdf"
	dat@annotation<-"mogene10stv1mmentrezgcdf"
	chiptype<-"mogene10stv1mmentrezg.db"
	dataset <- "mmusculus_gene_ensembl"
}
if(chiptype=="mouse-1.1-ST") {
	dat@cdfName<-"mogene11stv1mmentrezgcdf"
	dat@annotation<-"mogene11stv1mmentrezgcdf"
	chiptype<-"mogene11stv1mmentrezg.db"
	dataset <- "mmusculus_gene_ensembl"
}
if(chiptype=="mouse-2.0-ST") {
	dat@cdfName<-"mogene20stmmentrezgcdf"
	dat@annotation<-"mogene20stmmentrezgcdf"
	chiptype<-"mogene20stmmentrezg.db"
	dataset <- "mmusculus_gene_ensembl"
}
if(chiptype=="mouse-2.1-ST") {
	dat@cdfName<-"mogene21stmmentrezgcdf"
	dat@annotation<-"mogene21stmmentrezgcdf"
	chiptype<-"mogene21stmmentrezg.db"
	dataset <- "mmusculus_gene_ensembl"
}
if(chiptype=="rat-1.0-ST") {
	dat@cdfName<-"ragene10stv1rnentrezgcdf"
	dat@annotation<-"ragene10stv1rnentrezgcdf"
	chiptype<-"ragene10stv1rnentrezg.db"
	dataset <- "rnorvegicus_gene_ensembl"
}
if(chiptype=="rat-1.1-ST") {
	dat@cdfName<-"ragene11stv1rnentrezgcdf"
	dat@annotation<-"ragene11stv1rnentrezgcdf"
	chiptype<-"ragene11stv1rnentrezg.db"
	dataset <- "rnorvegicus_gene_ensembl"
}
if(chiptype=="rat-2.0-ST") {
	dat@cdfName<-"ragene20strnentrezgcdf"
	dat@annotation<-"ragene20strnentrezgcdf"
	chiptype<-"ragene20strnentrezg.db"
	dataset <- "rnorvegicus_gene_ensembl"
}
if(chiptype=="rat-2.1-ST") {
	dat@cdfName<-"ragene21strnentrezgcdf"
	dat@annotation<-"ragene21strnentrezgcdf"
	chiptype<-"ragene21strnentrezg.db"
	dataset <- "rnorvegicus_gene_ensembl"
}
if(chiptype=="zebra_fish-1.0-ST") {
	dat@cdfName<-"zebgene10stdrentrezgcdf"
	dat@annotation<-"zebgene10stdrentrezgcdf"
	chiptype<-"zebgene10stdrentrezg.db"
	dataset <- "drerio_gene_ensembl"
}
if(chiptype=="zebra_fish-1.1-ST") {
	dat@cdfName<-"zebgene11stdrentrezgcdf"
	dat@annotation<-"zebgene11stdrentrezgcdf"
	chiptype<-"zebgene11stdrentrezg.db"
	dataset <- "drerio_gene_ensembl"
}
if(chiptype=="arabidopsis-1.0-ST-entrez") {
	dat@cdfName<-"aragene10statentrezgcdf"
	dat@annotation<-"aragene10statentrezgcdf"
	chiptype<-"aragene10statentrezg.db"
	usemart <- as.character(listMarts()[grep("plants_mart", listMarts()[,1]),1])
	dataset <- "athaliana_eg_gene"
}
if(chiptype=="arabidopsis-1.1-ST-entrez") {
	dat@cdfName<-"aragene11statentrezgcdf"
	dat@annotation<-"aragene11statentrezgcdf"
	chiptype<-"aragene11statentrezg.db"
	usemart <- as.character(listMarts()[grep("plants_mart", listMarts()[,1]),1])
	dataset <- "athaliana_eg_gene"
}
if(chiptype=="arabidopsis-1.0-ST-tair") {
	dat@cdfName<-"aragene10stattairgcdf"
	dat@annotation<-"aragene10stattairgcdf"
	chiptype<-"aragene10stattairg.db"
	usemart <- as.character(listMarts()[grep("plants_mart", listMarts()[,1]),1])
	dataset <- "athaliana_eg_gene"
	filt <- "ensembl_gene_id"
}
if(chiptype=="arabidopsis-1.1-ST-tair") {
	dat@cdfName<-"aragene11stattairgcdf"
	dat@annotation<-"aragene11stattairgcdf"
	chiptype<-"aragene11stattairg.db"
	usemart <- as.character(listMarts()[grep("plants_mart", listMarts()[,1]),1])
	dataset <- "athaliana_eg_gene"
	filt <- "ensembl_gene_id"
}

# Normalizations
dat2<-exprs(rma(dat))
dat2<-as.data.frame(round(dat2, digits=2))
names(dat2)<-paste("chip.", names(dat2), sep="")

# Writes out a phenodata
sample<-rownames(pData(dat))
group<-c(rep("", nrow(pData(dat))))
training<-c(rep("", nrow(pData(dat))))
time<-c(rep("", nrow(pData(dat))))
random<-c(rep("", nrow(pData(dat))))
chiptype<-chiptype
write.table(data.frame(sample=sample, chiptype=chiptype, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# Writing out data
a<-try(library(chiptype, character.only=T))
if(chiptype!="empty" & class(a)!="try-error") {
	# Including gene names to data
	lib2<-sub('.db','',chiptype)
	symbol<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "SYMBOL", sep="")))))[rownames(dat2),])
	genename<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "GENENAME", sep="")))))[rownames(dat2),])
	# Fxes an issue introduced in BioC2.4 where the "#" character is introduced in some gene names
	genename <- gsub("#", "", genename)
	symbol <- gsub("'", "", symbol)
	genename <- gsub("'", "", genename)
	# Writes the results into a file
	write.table(data.frame(symbol, description=genename, dat2), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
} 

#
#In the case where no information is attached to the cdf, BioMart is used
if(chiptype=="empty" | class(a)=="try-error") {
	gene_id <- gsub("_at", "", rownames(dat2))
	if(length(gene_id) > 0 && biomart == "yes") {
		biom <- useMart(usemart, dataset=dataset)
		annotated_genes <- getBM(mart=biom, attributes=c(filt, "ensembl_gene_id", "external_gene_id","description"), filters=filt, values=gene_id,  uniqueRows = TRUE)
		annotated_genes <- annotated_genes[!duplicated(annotated_genes[,1]), ]
		
		annotated_dataf <- data.frame(annotated_genes)
		rownames(annotated_dataf) <- annotated_genes[, 1]
		
		write.table(data.frame(symbol=annotated_dataf[gene_id, "external_gene_id"], description=annotated_dataf[gene_id, "description"], dat2), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
	} else {
		write.table(data.frame(dat2), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
	}
}

# TOOL norm-agilent.R: "Agilent 2-color" (Agilent two-color data preprocessing. Automatically averages all the rows, i.e., genes that have the same name. YOU HAVE TO SPECIFY THE CHIPTYPE.)
# INPUT microarray{...}.tsv: microarray{...}.tsv TYPE CDNA 
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# PARAMETER background.treatment: background.treatment TYPE [none: none, subtract: subtract, edwards: edwards, normexp: normexp] DEFAULT normexp (Background treatment method)
# PARAMETER background.offset: background.offset TYPE [0: 0, 50: 50] DEFAULT 50 (Background offset)
# PARAMETER normalize.arrays: normalize.arrays TYPE [none: none, median: median, loess: loess] DEFAULT loess (Within array normalization method)
# PARAMETER normalize.genes: normalize.genes TYPE [none: none, scale: scale, quantile: quantile, Aquantile: Aquantile, vsn: vsn] DEFAULT none (Between arrays normalization method. Notice that in the case of vsn then the red and green intensities are treated as if they were single channel data, i.e., red and green channels from the same array are treated as unpaired. This algorithm is therefore separate from the backgroundCorrection, normalizeWithinArrays, then normalizeBetweenArrays paradigm used elsewhere in the limma package.)
# PARAMETER remove.control.probes: remove.control.probes TYPE [yes: yes, no: no] DEFAULT no (Remove control probes from the dataset)
# PARAMETER chiptype: chiptype TYPE [empty: empty, Human-1(4100a): "Human-1 (4100a)", Human-2(4101a): "Human-2 (4101a)", Human-1A(4110b): "Human-1A (4110b)", Human-1B(4111a): "Human-1B (4111a)", Human-Whole-Genome(4112a): "Human-Whole-Genome (4112a)", Human-Whole-Genome(4851a): "Human-Whole-Genome (4851a)", Mouse(4104a): "Mouse (4104a)", Mouse(4120a): "Mouse (4120a)", Mouse(4121a): "Mouse (4121a)", Mouse(4122a): "Mouse (4122a)", Rat(4105a): "Rat (4105a)", Rat(4130a): "Rat (4130a)", Rat(4131): "Rat (4131)",  Zebrafish-1(2519f):  "Zebrafish-1 (2519f)"] DEFAULT empty ()

# cDNA chip normalization
# JTT 9.6.2006
#
# MG, 10.3.2010
# modified script to cope with manually set flags
#
# MG, 15.9.2011
# updated vsn normalization

#background.treatment<-"normexp"
#background.offset<-50
#normalize.arrays<-"loess"
#normalize.genes<-"none"
#remove.control.probes<-"no"
#chiptype<-"4101a"

# Loads the libraries
library(limma)

# Renaming variables
bg<-background.treatment
normwa<-normalize.arrays
normba<-normalize.genes

# Reading data
columns<-list(R="sample", Rb="samplebg", G="control", Gb="controlbg")
annotation<-c("identifier")
columns.other<-c("flag", "annotation")

files<-dir()
files<-files[files!="phenodata.tsv"]
dat<-read.maimages(files=files, columns=columns, annotation=annotation, other.columns=columns.other) 
# Normalization within arrays
if (normba!="vsn") {
	dat2<-normalizeWithinArrays(dat, method=normwa, bc.method=bg, offset=as.numeric(background.offset))
}

# Normalization across arrays
if (normba=="vsn") {
	dat3 <- normalizeVSN(dat)
} else {
	dat3<-normalizeBetweenArrays(dat2, method=normba)
}

# Writes out a phenodata table
sample<-paste(rownames(dat$targets), ".tsv", sep="")
group<-c(rep("", length(sample)))
training<-c(rep("", length(sample)))
time<-c(rep("", length(sample)))
random<-c(rep("", length(sample)))
if(chiptype=="empty") {
	chiptype<-c("cDNA")
}
if(chiptype=="Human-1(4100a)") {
	chiptype<-c("hgug4100a")
}
if(chiptype=="Human-2(4101a)") {
	chiptype<-c("hgug4101a")
}
if(chiptype=="Human-1A(4110b)") {
	chiptype<-c("hgug4110b")
}
if(chiptype=="Human-1B(4111a)") {
	chiptype<-c("hgug4111a")
}
if(chiptype=="Human-Whole-Genome(4112a)") {
	chiptype<-c("hgug4112a")
}
if(chiptype=="Human-Whole-Genome(4851a)") {
	chiptype<-c("hgug4851a.db")
}
if(chiptype=="Mouse(4104a)") {
	chiptype<-c("mgug4104a")
}
if(chiptype=="Mouse(4120a)") {
	chiptype<-c("mgug4120a")
}
if(chiptype=="Mouse(4121a)") {
	chiptype<-c("mgug4121a")
}
if(chiptype=="Mouse(4122a)") {
	chiptype<-c("mgug4122a")
}
if(chiptype=="Rat(4105a)") {
	chiptype<-c("rgug4105a")
}
if(chiptype=="Rat(4130a)") {
	chiptype<-c("rgug4130a")
}
if(chiptype=="Rat(4131)") {
	chiptype<-c("rgug4131unigene")
}
if(chiptype!="cDNA") {
	chiptype<-paste(chiptype, ".db", sep="")
}
# chiptype<-paste(chiptype, ".db", sep="")

write.table(data.frame(sample=sample, chiptype=chiptype, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# Removes control probes
if(remove.control.probes=="yes") {
	if(is.null(dim(dat$other$annotation))==FALSE) {
		dat3<-dat3[rowSums(dat$other$annotation)==0,]
	}
}


# Define function for averaging flags
average_flags <- function (flags.vector) {
	number_probes <- length(flags.vector)
	if (max(match(flags.vector,"P",nomatch=0))>0) {
		return("P")
	} else {
		if (max(match(flags.vector,"M",nomatch=0))>0) {
			return("M")
		} else {
			return("A")
		}
	}
}			



# Constructs and writes out a table
M<-dat3$M
A<-dat3$A
rownames(M)<-dat3$genes$identifier
rownames(A)<-dat3$genes$identifier
M<-aggregate(M, list(rownames(M)), mean)
A<-aggregate(A, list(rownames(A)), mean)
rownames(M)<-M$Group.1
rownames(A)<-A$Group.1
genes<-rownames(M)
M<-M[,-1]
A<-A[,-1]


# If flags are available aggregate those as well
if(length(dat$other$flag)!=0) {
	flags <- dat$other$flag
	if(remove.control.probes=="yes") {
		if(is.null(dim(dat$other$annotation))==FALSE) {
			flags <- flags[rowSums(dat$other$annotation)==0,]
		}
	}
	rownames(flags) <- dat3$genes$identifier
	flags2 <- aggregate(flags, list(rownames(flags)), average_flags)
	rownames(flags2) <- flags2$Group.1
	flags3 <- flags2 [,-1]
	flags4 <- as.data.frame(flags3)
	names(flags4)<-paste("flag.", names(flags4), sep="")
}
if(length(dat$other$flag)==0) {
	flags<-matrix(nrow=0, ncol=0)
}

names(M)<-paste("chip.", names(M), sep="")
names(M)<-paste(names(M), ".tsv", sep="")
names(A)<-paste("average.", names(A), sep="")
names(A)<-paste(names(A), ".tsv", sep="")
A<-data.frame(A)
M<-data.frame(M)

# Fix names for when reading single slide
if (length(files) == 1) {
	names(M) <- "chip.microarray001.tsv"
	names(A) <- "average.microarray001.tsv"
}
rownames(M)<-genes
rownames(A)<-genes

if(chiptype!="cDNA") {
	# Including gene names to data
	library(chiptype, character.only=T)
	lib2<-sub('.db','',chiptype)
	symbol<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "SYMBOL", sep="")))))[rownames(M),])
	genename<-gsub("\'", "", data.frame(unlist(as.list(get(paste(lib2, "GENENAME", sep="")))))[rownames(M),])
	symbol<-gsub("#", "", symbol)
	genename<-gsub("#", "", genename)
	symbol <- gsub("'", "", symbol)
	genename <- gsub("'", "", genename)
}

if(chiptype!="cDNA") {
	# Conditional on whether flags are included or not, write the data to disk
	if(length(dat$other$flag)==0) {
		write.table(data.frame(symbol, description=genename, round(M, digits=2), round(A, digits=2)), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
	} else {
		write.table(data.frame(symbol, description=genename, round(M, digits=2), round(A, digits=2), flags4), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
	}
}

if(chiptype=="cDNA") {
	if(length(dat$other$flag)==0) {
		write.table(data.frame(round(M, digits=2), round(A, digits=2)), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
	} else {
		write.table(data.frame(round(M, digits=2), round(A, digits=2), flags4), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
	}
}

# TOOL cna-pool-bins.R: "Pool binned read counts" (Pools binned read counts together from two or more files.)
# INPUT binned-hits-{...}.tsv: "Individual files with binned hits" TYPE GENERIC
# OUTPUT binned-hits-pooled.tsv: "Pooled read counts"

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-06-07

filenames <- list.files(pattern='^binned-hits-[0-9]*\\.tsv$')

dat <- read.table(filenames[1], header=TRUE, sep='\t', row.names=1, as.is=TRUE)

if (length(filenames) > 1) {
  for (i in 2:length(filenames)) {
    x <- read.table(filenames[i], header=TRUE, sep='\t', row.names=1, as.is=TRUE)
    if (nrow(x) != nrow(dat))
      stop("CHIPSTER-NOTE: All input files need to be binned using the same bin size.")
    dat$count <- dat$count + x$count
    dat$corrected <- dat$corrected + x$corrected
  }
}

options(scipen=10)
write.table(dat, 'binned-hits-pooled.tsv', quote=FALSE, sep='\t', na='')

# EOF

# TOOL acgh-plot-survival.R: "Plot survival curves for called copy number data" (Plotting of survival curves for called copy number data.)
# INPUT survival-test.tsv: survival-test.tsv TYPE GENE_EXPRS
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT survival.pdf: survival.pdf
# PARAMETER survival: survival TYPE METACOLUMN_SEL DEFAULT survival (Phenodata column with survival data)
# PARAMETER status: status TYPE METACOLUMN_SEL DEFAULT status (Phenodata column with patient status: alive=0, dead=1)
# PARAMETER aberrations: aberrations TYPE [gains: gains, losses: losses, both: both] DEFAULT both (Whether to test only for gains or losses, or both.) 
# PARAMETER confidence.intervals: "plot confidence intervals" TYPE [yes: yes, no: no] DEFAULT no (Whether to plot the confidence intervals.) 

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2013-04-04

library(survival)

file <- 'survival-test.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, as.is=TRUE, check.names=FALSE)
phenodata <- read.table('phenodata.tsv', header=TRUE, sep='\t', check.names=FALSE)

s <- Surv(phenodata[,survival], phenodata[,status])
reg <- as.matrix(dat[, grep('^flag\\.', colnames(dat))])
if (aberrations == 'gains') {
  reg[reg > 0] <- 1
  reg[reg < 0] <- 0
  call.legend <- c('loss', 'no-gain', 'gain')
} else if (aberrations == 'losses') {
  reg[reg > 0] <- 0
  reg[reg < 0] <- -1
  call.legend <- c('loss', 'no-loss', 'gain')
} else {
  call.legend <- c('loss', 'normal', 'gain')
}
names(call.legend) <- -1:1
call.cols <- c('red', 'black', 'blue')
names(call.cols) <- -1:1
pdf('survival.pdf', paper='a4r')
for (i in rownames(dat)) {
  f <- survfit(s ~ reg[i,])
  call <- sub('^.*=(.*)', '\\1', names(f$strata))
  n <- length(call)
  legend <- paste(call.legend[call], ' (', f$n, ')', sep='')
  cols <- call.cols[call]
  ltys <- rep(0, n)
  pchs <- rep(22, n)
  if (!is.null(dat$cytoband)) {
    main <- paste('Survival for', dat[i, 'cytoband'])
  } else {
    main <- paste('Survival for region', i)
  }
  plot(f, main=main, xlab='t', ylab=expression(hat(S)(t)), col=cols)
  if (confidence.intervals == 'yes') {
    lines(f, conf.int='only', lty=2, col=cols)
    legend <- c(legend, 'survival', '95% confidence interval')
    cols <- c(cols, 'black', 'black')
    ltys <- c(ltys, 1, 2)
    pchs <- c(pchs, NA, NA)
  }
  legend('bottomleft', legend=legend, lty=ltys, pch=pchs, pt.bg=cols, pt.cex=2, inset=0.01)
  mtext(paste(dat[i, 'chromosome'], ':', format(dat[i, 'start'], big.mark=','), '-', format(dat[i, 'end'], big.mark=','), sep=''), side=1, line=-1, adj=0.99)
  if (!is.null(dat$fdr))
    mtext(paste('FDR = ', sprintf('%.4f', dat[i, 'fdr'])), side=1, line=-2, adj=0.99)
  if (!is.null(dat$pvalue))
    mtext(paste('p = ', sprintf('%.4f', dat[i, 'pvalue'])), side=1, line=-3, adj=0.99)
}
dev.off()

# EOF

# TOOL mothur-summaryseqs.R: "Summarize sequences with Mothur" (Given a fasta file with unaligned or aligned sequences, provides summary statistics on sequence start and end coordinates, length, number of ambiguous bases, and homopolymer length. This tool is based on the Mothur package.)
# INPUT reads.fasta: "FASTA file" TYPE FASTA
# OUTPUT summary.tsv
		
# AMS 4.6.2013
# EK 27.6.2013 Changes to description and output
		
# binary
binary <- c(file.path(chipster.tools.path, "mothur", "mothur"))

# batch file
write("summary.seqs(fasta=reads.fasta)", "batch.mth", append=F)

# command
command <- paste(binary, "batch.mth", "> log_raw.txt")

# run
system(command)

# Post process output
# system("mv reads.summary summary.tsv")
system("grep -A 9 Start log_raw.txt > summary.tsv")

  # Basic CRAN packages
  install.packages(c("Matrix", "lme4", "amap", "ape", "flexclust", "kohonen", "e1071", "sma", "fastICA"), repos="http://cran.r-project.org", dependencies = T)
  install.packages(c("XML"), repos="http://cran.r-project.org", dependencies=T)
  install.packages(c("aplpack", "corrgram", "deal", "outliers", "prada", "pvclust", "zoo"), repos="http://cran.r-project.org", dependencies=T)

  # Basic Bioconductor packages
  source("http://www.bioconductor.org/biocLite.R")
  biocLite()
  biocLite(c("ctc", "ssize", "LPE", "Ruuid", "graph", "affyQCReport", "GlobalAncova", "impute", "idiogram", "GOstats", "beadarray", "GeneTS", "simpleaffy", "globaltest"))
  biocLite(c("geneplotter", "biomaRt", "lumi", "prada", "siggenes", "plier")) 

  # Annotation packages for Affymetrix
  # Human and yeast
  biocLite(c("hgu133a", "hgu133acdf", "hgu133aprobe", "ygs98", "ygs98cdf", "ygs98probe", "hgu133a2", "hgu133a2cdf", "hgu133a2probe", "hgu133plus2", "hgu133plus2cdf", "hgu133plus2probe"))
  biocLite(c("hs133ahsrefseq", "hs133ahsrefseqcdf", "hs133ahsrefseqprobe", "hs133av2hsrefseq", "hs133av2hsrefseqcdf", "hs133av2hsrefseqprobe", "hs133phsrefseq", "hs133phsrefseqcdf", "hs133phsrefseqprobe"))
  biocLite(c("GO", "KEGG"))

  # Mouse and Rat
  biocLite(c("mgu74a", "mgu74acdf", "mgu74aprobe", "mgu74av2", "mgu74av2cdf", "mgu74av2probe", "moe430a", "moe430acdf", "moe430aprobe",
             "mouse4302", "mouse4302cdf", "mouse4302probe", "mouse430a2", "mouse430a2cdf", "mouse430a2probe", 
             "rae230a", "rae230acdf", "rae230aprobe", "rat2302", "rat2302cdf", "rat2302probe", 
             "rgu34a", "rgu34acdf", "rgu34aprobe"))

  # Other organisms, arabidopsis, C. elegans, drosophila, xenopus
  biocLite(c("ag", "agcdf", "agprobe", "ath1121501", "ath1121501cdf", "ath1121501probe", "celegans", "celeganscdf", "celegansprobe",
             "drosgenome1", "drosgenome1cdf", "drosgenome1probe", "drosophila2", "drosophila2cdf", "drosophila2probe",
             "test3probe", "xenopuslaevis", "xenopuslaeviscdf", "xenopuslaevisprobe", "zebrafish", "zebrafishcdf", "zebrafishprobe",
             "yeast2", "yeast2cdf", "yeast2probe", "test3cdf"))
  biocLite(c("hgu95a", "hgu95acdf", "hgu95aprobe", "hgu95av2", "hgu95av2cdf", "hgu95av2probe"))

  # Alternative annotations
  biocLite(c(
  "hs133ahsensg", "hs133ahsensgcdf", "hs133ahsensgprobe", "hs133av2hsensg", "hs133av2hsensgcdf", "hs133av2hsensgprobe", 
  "hs133phsensg", "hs133phsensgcdf", "hs133phsensgprobe", "mm430mmensg", "mm430mmensgcdf", "mm430mmensgprobe",
  "mm74av1mmensg", "mm74av1mmensgcdf", "mm74av1mmensgprobe", "mm74av2mmensg", "mm74av2mmensgcdf", "mm74av2mmensgprobe",
  "rn230arnensg", "rn230arnensgcdf", "rn230arnensgprobe", "rn230rnensg", "rn230rnensgcdf", "rn230rnensgprobe",
  "rn34arnensg", "rn34arnensgcdf", "rn34arnensgprobe"
  )) 

  # Other organisms with no annotations
  biocLite(c("barley1cdf", "barley1probe", "bovinecdf", "bovineprobe", "canine2cdf", "canine2probe", "caninecdf", "canineprobe",
             "chickencdf", "chickenprobe", "citruscdf", "citrusprobe", "maizecdf", "maizeprobe", "medicagocdf", "medicagoprobe",
             "plasmodiumanophelescdf", "plasmodiumanophelesprobe", "poplarcdf", "poplarprobe", "porcinecdf", "porcineprobe",
             "rhesuscdf", "rhesusprobe", "ricecdf", "riceprobe", "soybeancdf", "soybeanprobe", "sugarcanecdf", "sugarcaneprobe",
             "tomatocdf", "tomatoprobe", "vitisviniferacdf", "vitisviniferaprobe", "wheatcdf", "wheatprobe"))

  # Annotation packages for Agilent
  biocLite(c("hgug4100a", "hgug4101a", "hgug4110b", "hgug4111a", "hgug4112a"))
  biocLite(c("rgug4105a", "rgug4130a"))
  biocLite(c("mgug4104a", "mgug4120a", "mgug4121a", "mgug4122a"))

  # Annotation packages for Illumina
  biocLite(c("illuminaHumanv1", "illuminaHumanv2", "illuminaMousev1", "lumiHumanV1", "lumiHumanV2", "lumiMouseV1", "lumiRatV1"))

# TOOL bedtools-bamtobed.R: "Convert BAM to BED" (Converts BAM alignments to BED6, BED12 or BEDPE format. This tool is based on the BEDTools package.)
# INPUT file.a: "BAM file" TYPE GENERIC
# OUTPUT bamtobed.bed
# PARAMETER output.type: "Output type" TYPE [BED6, BED12, BEDPE] DEFAULT "BED6" (Select the output type (BED6, BED12 or BEDPE\).)
# PARAMETER OPTIONAL split: "Report split BAM alignments as separate BED entries" TYPE [yes,no] DEFAULT no (Report each portion of a split BAM (i.e., having an N CIGAR operation\) alignment as a distinct BED intervals.)
# PARAMETER OPTIONAL ed: "Use BAM edit distance for BED score" TYPE [yes,no] DEFAULT no (Use BAM edit distance (NM tag\) for BED score. Default for BED is to use mapping quality. Default for BEDPE is to use the minimum of the two mapping qualities for the pair.)
# PARAMETER OPTIONAL color: "Color string" TYPE STRING DEFAULT "255,0,0" (An R,G,B string for the color used with BED12 format. Default is (255,0,0\).)
# PARAMETER OPTIONAL cigar: "Add the CIGAR string" TYPE [yes,no] DEFAULT no (Add the CIGAR string to the BED entry as a 7th column.)

# AMS 23.4.2012

# binary
binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "bamToBed"))

# options
options <- paste("")
if (output.type == "BEDPE") {options <- paste(optons, "-bedpe")}
if (output.type == "BED12") {
	options <- paste(options, "-bed12")
	options <- paste(options, "-color", color)
}
if (split == "yes") {options <- paste(options, "-split")}
if (ed == "yes") {options <- paste(options, "-ed")}
if (cigar == 'yes') {options <- paste(options,"-cigar")}

# input files
options <- paste(options, "-i", "file.a")

# command
command <- paste(binary, options, "> bamtobed.bed")

# run
system(command)
if (file.info("bamtobed.bed")$size == 0) {system("echo \"No results found\" > bamtobed.bed")}

# TOOL acgh-smooth.R: "Smooth waves from normalized aCGH data" (Smooths the wavy pattern typically seen in aCGH profiles. Note that you need a separate calibration data set, which is not measured from cancer samples. It should be measured with the same array platform and preprocessed with similar normalization settings. When selecting the two input files, be sure to first click on the cancer data set, then on the calibration one.)
# INPUT normalized_tumor.tsv: normalized_tumor.tsv TYPE GENE_EXPRS 
# INPUT normalized_calib.tsv: normalized_calib.tsv TYPE GENE_EXPRS 
# OUTPUT smoothed.tsv: smoothed.tsv 

# smooth-acgh.R
# Ilari Scheinin <firstname.lastname@gmail.com>
# 2011-12-09

source(file.path(chipster.common.path, 'CGHcallPlus.R'))
library(NoWaves)

pos <- c('chromosome','start','end')

# load tumor data and preprocess to deal with missing values
dat <- read.table('normalized_tumor.tsv', header=TRUE, sep='\t', as.is=TRUE, row.names=1)
if (length(setdiff(pos, colnames(dat)))!=0)
  stop('CHIPSTER-NOTE: Your cancer data set needs to have the following columns: chromosome, start, end.')
dat <- data.frame(probe=rownames(dat), dat, stringsAsFactors=FALSE)
dat$chromosome[dat$chromosome=='X'] <- 23
dat$chromosome[dat$chromosome=='Y'] <- 24
dat$chromosome[dat$chromosome=='MT'] <- 25
dat$chromosome <- as.integer(dat$chromosome)
cgh <- make_cghRaw(dat)
cgh <- preprocess(cgh, nchrom=23)
cgh <- data.frame(Probe=rownames(cgh@featureData@data), cgh@featureData@data, assayDataElement(cgh, 'copynumber'))

# load calibration data and preprocess to deal with missing values
dat2 <- read.table('normalized_calib.tsv', header=TRUE, sep='\t', as.is=TRUE, row.names=1)
if (length(setdiff(pos, colnames(dat2)))!=0)
  stop('CHIPSTER-NOTE: Your calibration data set needs to have the following columns: chromosome, start, end.')
dat2 <- data.frame(probe=rownames(dat2), dat2, stringsAsFactors=FALSE)
dat2$chromosome[dat2$chromosome=='X'] <- 23
dat2$chromosome[dat2$chromosome=='Y'] <- 24
dat2$chromosome[dat2$chromosome=='MT'] <- 25
dat2$chromosome <- as.integer(dat2$chromosome)
calib <- make_cghRaw(dat2)
calib <- preprocess(calib, nchrom=23)
calib <- data.frame(Probe=rownames(calib@featureData@data), calib@featureData@data, assayDataElement(calib, 'copynumber'))

# dewave tumor data
calib <- SmoothNormals(calib)
dewaved <- CorrectTumors(cgh, calib)

# format for output
rownames(dewaved) <- dewaved[,1]
colnames(dewaved) <- colnames(dat)
dewaved <- dewaved[,-1]
dewaved$chromosome <- as.character(dewaved$chromosome)
dewaved$chromosome[dewaved$chromosome=='23'] <- 'X'
dewaved$chromosome[dewaved$chromosome=='24'] <- 'Y'
dewaved$chromosome[dewaved$chromosome=='25'] <- 'MT'
dewaved[,-(1:4)] <- round(dewaved[,-(1:4)], digits=2)

# write results
write.table(dewaved, file='smoothed.tsv', quote=FALSE, sep='\t', col.names=TRUE, row.names=TRUE)

# EOF

# TOOL mothur-uniqueseqs.R: "Extract unique aligned sequences with Mothur" (Removes identical sequences from fasta-formatted alignment files. This tool is based on the Mothur package. In addition to the alignment, you need to supply the names file that was created by the tool \"Trim and filter reads with Mothur\". )
# INPUT a.names: "Names file" TYPE MOTHUR_NAMES
# INPUT a.fasta: "FASTA file" TYPE FASTA
# OUTPUT unique.fasta
# OUTPUT unique.names
# OUTPUT unique-summary.tsv


# EK 06.06.2013

# binary
binary <- c(file.path(chipster.tools.path, "mothur", "mothur"))

# batch file
write("unique.seqs(fasta=a.fasta, name=a.names)", "batch.mth", append=F)

# command
command <- paste(binary, "batch.mth", "> log.txt 2>&1")

# run
system(command)

# Post process output
system("mv a.unique.fasta unique.fasta")
system("mv a.unique.names unique.names")

# batch file 2
write("summary.seqs(fasta=unique.fasta)", "summary.mth", append=F)

# command 2
command2 <- paste(binary, "summary.mth", "> log_raw.txt")

# run
system(command2)

# Post process output
system("grep -A 9 Start log_raw.txt > unique-summary.tsv")

# TOOL samtools-count.R: "Count alignments in BAM" (Counts alignments in a BAM file, taking the mapping quality into account if needed. This tool is based on the SAMtools package.)
# INPUT alignment.bam TYPE GENERIC 
# OUTPUT alignment-counts.txt 
# PARAMETER OPTIONAL mapping.quality: "Minimum mapping quality required for counting" TYPE INTEGER FROM 0 TO 1000 DEFAULT 0 (Counts only alignments which have a mapping quality higher than this. Note that Bowtie doesn't calculate mapping quality, but just inserts 255 to the field 5 of BAM file if the read aligns, and 0 if it doesn't align.)


# EK 26.10.2011

# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

system(paste(samtools.binary, "view -bc -q", mapping.quality, "alignment.bam > alignment-counts.txt"))

# TOOL bwasw-with-index-building.R: "BWA-SW for single end reads and own genome" (BWA aligns reads to genomes and transcriptomes. This BWA version uses the BWA-SW algorithm that is designed for long, over 300pb, low-quality reads. Results are sorted and indexed bam files. 
# Note that this BWA tool requires that you have imported the reference genome to Chipster in fasta format. If you would like to align reads against publicly available genomes, please use the tool \"BWA-SW for single end reads\".)
# INPUT reads.txt: "Reads to align" TYPE GENERIC 
# INPUT genome.txt: "Reference genome" TYPE GENERIC
# OUTPUT bwa.bam 
# OUTPUT bwa.bam.bai 
# OUTPUT bwa.log 
# PARAMETER OPTIONAL match.score: "Score of a match" TYPE INTEGER DEFAULT 1 (Score of a matching base. Corresponds to the command line parameter -a)
# PARAMETER OPTIONAL gap.opening: "Gap opening penalty " TYPE INTEGER DEFAULT 11 (Gap opening penalty. Corresponds to the command line parameter -q)
# PARAMETER OPTIONAL gap.extension: "Gap extension penalty " TYPE INTEGER DEFAULT 4 (Gap extension penalty. Corresponds to the command line parameter -r)
# PARAMETER OPTIONAL mismatch.penalty: "Mismatch penalty" TYPE INTEGER DEFAULT 3 (Mismatch penalty. Corresponds to the command line parameter -b)
# PARAMETER OPTIONAL band.width: "Band width in the banded alignment"  TYPE INTEGER DEFAULT 33 (Band width in the banded alignment. Corresponds to the command line parameter -w .)
# PARAMETER OPTIONAL min.score: "Minimum score threshold divided by the given value"  TYPE INTEGER DEFAULT 37 (Minimum score threshold divided by the given value. Corresponds to the command line parameter -T.)
# PARAMETER OPTIONAL threshold.coeff: "Coefficient for threshold adjustment" TYPE DECIMAL DEFAULT 5.5 (Coefficient for threshold adjustment according to query length. Given an l-long query, the threshold for a hit to be retained is a*max\{T,c*log\(l\)\}. Corresponds to the command line parameter -c. )
# PARAMETER OPTIONAL z.best: "Z-best heuristics" TYPE INTEGER DEFAULT 1 (Z-best heuristics. Higher -z increases accuracy at the cost of speed. Corresponds to the command line parameter -z.)
# PARAMETER OPTIONAL sa.interval: "Maximum SA interval size" TYPE INTEGER DEFAULT 3 (Maximum SA interval size for initiating a seed. Higher value increases accuracy at the cost of speed. Corresponds to the command line parameter -s.)
# PARAMETER OPTIONAL min.support: "Reverse alignment limit" TYPE INTEGER DEFAULT 5 (Minimum number of seeds supporting the resultant alignment to skip reverse alignment. Corresponds to the command line parameter -N)
# PARAMETER OPTIONAL alignment.no: "How many valid alignments are reported per read" TYPE  INTEGER DEFAULT 3 (Maximum number of alignments to report. Corresponds to the command line parameter bwa samse -n )

# KM 24.8.2011
# AMS 19.6.2012 Added unzipping

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads.txt")
unzipIfGZipFile("genome.txt")

# bwa
bwa.binary <- file.path(chipster.tools.path, "bwa", "bwa")
bwa.index.binary <- file.path(chipster.module.path, "shell", "check_bwa_index.sh")
command.start <- paste("bash -c '", bwa.binary)

# Do indexing
print("Indexing the genome...")
system("echo Indexing the genome... > bwa.log")
check.command <- paste ( bwa.index.binary, "genome.txt| tail -1 ")
genome.dir <- system(check.command, intern = TRUE)
bwa.genome <- file.path( genome.dir , "genome.txt")


# algorithm parameters
mode.parameters <- paste("bwasw -t 2 -b", mismatch.penalty , "-q" , gap.opening , "-r" , gap.extension , "-a" , match.score , "-w" , band.width , "-T" , min.score , "-c" , threshold.coeff , "-z" , z.best , "-s" , sa.interval , "-N" , min.support)

# command ending
command.end <- paste( bwa.genome , "reads.txt 1> alignment.sai 2>> bwa.log'")

# run bwa alignment
system("echo Running the alignment with command: >> bwa.log")
bwa.command <- paste(command.start, mode.parameters, command.end)
echo.command <- paste("echo '",bwa.command ,"'  >> bwa.log")
system(echo.command)
#stop(paste('CHIPSTER-NOTE: ', bwa.command))
system(bwa.command)

# sai to sam conversion
system("echo Running sai to sam conversion with command: >> bwa.log")
samse.parameters <- paste("samse -n", alignment.no )
samse.end <- paste(bwa.genome, "-f alignment.sam alignment.sai reads.txt >> bwa.log'" )
samse.command <- paste( command.start, samse.parameters , samse.end )
echo.command <- paste("echo '",samse.command )
system(echo.command)
echo.command <- paste("echo '",samse.end," >> bwa.log" )
system(echo.command)
system(samse.command)

		
# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

# convert sam to bam
system("echo Converting sam to bam format. >> bwa.log")
system(paste(samtools.binary, "view -bS alignment.sam -o alignment.bam"))

# sort bam
system(paste(samtools.binary, "sort alignment.bam alignment.sorted"))

# index bam
system(paste(samtools.binary, "index alignment.sorted.bam"))

# rename result files
system("mv alignment.sorted.bam bwa.bam")
system("mv alignment.sorted.bam.bai bwa.bam.bai")

# TOOL acgh-survival-test.R: "Survival test for called copy number data" (Statistical test for survival and called copy number data. The testing is recommended to be performed after running the Identify common regions from called copy number data tool.)
# INPUT regions.tsv: regions.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT survival-test.tsv: survival-test.tsv 
# PARAMETER survival: survival TYPE METACOLUMN_SEL DEFAULT survival (Phenodata column with survival data)
# PARAMETER status: status TYPE METACOLUMN_SEL DEFAULT status (Phenodata column with patient status: alive=0, dead=1)
# PARAMETER number.of.permutations: number.of.permutations TYPE INTEGER DEFAULT 10000 (The number of permutations. At least 10000 recommended for final calculations.)
# PARAMETER test.aberrations: test.aberrations TYPE [1: gains, -1: losses, 0: both] DEFAULT 0 (Whether to test only for gains or losses, or both.) 

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2012-03-02

dat <- read.table('regions.tsv', header=TRUE, sep='\t', quote='', as.is=TRUE, row.names=1)
phenodata <- read.table('phenodata.tsv', header=TRUE, sep='\t')

first.data.col <- min(grep('^chip\\.', names(dat)), grep('^flag\\.', names(dat)))
data.info <- dat[,1:(first.data.col-1)]
calls <- as.matrix(dat[,grep('^flag\\.', colnames(dat))])

# first try parallel computing
prob <- TRUE
try({
  library(CGHtestpar)
  pvs <-  pvalstest_logrank(calls, data.info, dataclinvar=phenodata, whtime=survival, whstatus=status, lgonly=as.integer(test.aberrations), niter=number.of.permutations, ncpus=4)
  fdrs <- fdrperm(pvs)
  prob <- FALSE
}, silent=TRUE)
# if problems, fall back to sequential computing
if (prob) {
  library(CGHtest)
  pvs <-  pvalstest_logrank(calls, data.info, dataclinvar=phenodata, whtime=survival, whstatus=status, lgonly=as.integer(test.aberrations), niter=number.of.permutations)
  fdrs <- fdrperm(pvs)
}

fdrs <- cbind(fdrs, dat[,first.data.col:ncol(dat)])

options(scipen=10)
write.table(fdrs, file='survival-test.tsv', quote=FALSE, sep='\t')

# EOF

# TOOL fastx-fastq-to-fasta.R: "Convert FASTQ to FASTA" (Convert FASTQ files to FASTA format. This tool is based on the FASTX package.)
# INPUT reads.fastq TYPE GENERIC 
# OUTPUT reads.fasta
# OUTPUT fasta.log
# PARAMETER OPTIONAL remove.unknowns: "Remove sequences with unknown nucleotides" TYPE [yes, no] DEFAULT yes (Remove sequences with unknown nucleotides)
# PARAMETER OPTIONAL rename.identifiers: "Rename sequence identifiers as numbers" TYPE [yes, no] DEFAULT no (Rename sequence identifiers as numbers)
# PARAMETER quality.format: "Quality value format used" TYPE [sanger: Sanger, illuminaold: "Illumina GA v1.3-1.5"] DEFAULT sanger (What quality encoding is used in your FASTQ file. Select Sanger if your data comes from Illumina 1.8 or later, SOLiD or 454.)



# EK 17.6.2011

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads.fastq")

# binary
binary <- c(file.path(chipster.tools.path, "fastx", "bin", "fastq_to_fasta"))

# parameters
remove.parameter <- ifelse(remove.unknowns == "yes", "", "-n")
rename.parameter <- ifelse(rename.identifiers == "no", "", "-r")
quality.scale <- ifelse(quality.format == "sanger", "-Q 33", "")

# command
command <- paste(binary, remove.parameter, rename.parameter, quality.scale, "-v -i reads.fastq -o reads.fasta > fasta.log")

# run
system(command)

# TOOL acgh-plot-frequencies.R: "Plot copy number aberration frequencies" (Plot copy number aberration frequencies for different groups.)
# INPUT aberrations.tsv: aberrations.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT group-frequencies.pdf: group-frequencies.pdf 
# PARAMETER column: column TYPE METACOLUMN_SEL DEFAULT group (Phenodata column defining sample groups.)
# PARAMETER chromosomes: chromosomes TYPE STRING DEFAULT 0 (The numbers of the chromosomes to be plotted, separated by commas. 0 means all chromosomes. Ranges are also supported (e.g. 1,3,7-10\).)

# Ilari Scheinin <firstname.lastname@gmail.com>
# 2013-04-04

source(file.path(chipster.common.path, 'CGHcallPlus.R'))

# read input files
file <- 'aberrations.tsv'
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, as.is=TRUE, check.names=FALSE)
phenodata <- read.table("phenodata.tsv", header=TRUE, sep="\t", as.is=TRUE, check.names=FALSE)

pos <- c('chromosome','start','end')
if (length(setdiff(pos, colnames(dat)))!=0)
  stop('CHIPSTER-NOTE: This script can only be run on files that have the following columns: chromosome, start, end.')



# build a cghCall object from the data
dat$chromosome[dat$chromosome=='X'] <- 23
dat$chromosome[dat$chromosome=='Y'] <- 24
dat$chromosome[dat$chromosome=='MT'] <- 25
dat$chromosome <- as.integer(dat$chromosome)

dat <- dat[dat$chromosome %in% 1:24,]

dat <- dat[order(dat$chromosome, dat$start),]

calls <- as.matrix(dat[,grep("flag", names(dat))])
copynumber <- as.matrix(dat[,grep("chip", names(dat))])
segmented <- as.matrix(dat[,grep("segmented", names(dat))])
probloss <- as.matrix(dat[,grep("probloss", names(dat))])
probnorm <- as.matrix(dat[,grep("probnorm", names(dat))])
probgain <- as.matrix(dat[,grep("probgain", names(dat))])
probamp <- as.matrix(dat[,grep("probamp", names(dat))])

if (ncol(segmented) == 0) { # no segments
  cgh <- new('cghRaw', copynumber=copynumber, featureData=new('AnnotatedDataFrame', data=data.frame(Chromosome=dat$chromosome, Start=dat$start, End=dat$end, row.names=row.names(dat))))
} else if (ncol(calls) == 0) { # segments, but no calls
  cgh <- new('cghSeg', assayData=assayDataNew(copynumber=copynumber, segmented=segmented), featureData=new('AnnotatedDataFrame', data=data.frame(Chromosome=dat$chromosome, Start=dat$start, End=dat$end, row.names=row.names(dat))))
} else if (ncol(probnorm) == 0) { # calls, but no probabilities
  probloss <- calls == -1
  probnorm <- calls ==  0
  probgain <- calls ==  1
  cgh <- new('cghCall', assayData=assayDataNew(calls=calls, copynumber=copynumber, segmented=segmented, probloss=probloss, probnorm=probnorm, probgain=probgain), featureData=new('AnnotatedDataFrame', data=data.frame(Chromosome=dat$chromosome, Start=dat$start, End=dat$end, row.names=row.names(dat))))
} else if (ncol(probamp) == 0) { # probabilities, but not for amplifications
  cgh <- new('cghCall', assayData=assayDataNew(calls=calls, copynumber=copynumber, segmented=segmented, probloss=probloss, probnorm=probnorm, probgain=probgain), featureData=new('AnnotatedDataFrame', data=data.frame(Chromosome=dat$chromosome, Start=dat$start, End=dat$end, row.names=row.names(dat))))
} else { # probabilities even for amplifications
  cgh <- new('cghCall', assayData=assayDataNew(calls=calls, copynumber=copynumber, segmented=segmented, probloss=probloss, probnorm=probnorm, probgain=probgain, probamp=probamp), featureData=new('AnnotatedDataFrame', data=data.frame(Chromosome=dat$chromosome, Start=dat$start, End=dat$end, row.names=row.names(dat))))
}
sampleNames(cgh) <- phenodata$description

remove <- rowSums(is.na(copynumber)) + rowSums(is.na(segmented))
cgh <- cgh[remove == 0,]

# parse chromosomes to be plotted
chromosomes <- gsub('X', '23', chromosomes, ignore.case=TRUE)
chromosomes <- gsub('Y', '24', chromosomes, ignore.case=TRUE)
chromosomes <- gsub('MT', '25', chromosomes, ignore.case=TRUE)
chromosomes <- gsub('[^0-9,-]', ',', chromosomes)
items <- strsplit(chromosomes, ',')[[1]]
chrs.to.plot <- integer()
for (item in items) {
  item <- item[item!='']
  if (length(item)==0) next
  range <- strsplit(item, '-')[[1]]
  range <- range[range!='']
  if (length(range)==0) next
  chrs.to.plot <- c(chrs.to.plot, seq(range[1], range[length(range)]))
}
chrs.to.plot <- unique(chrs.to.plot)
chrs.to.plot <- chrs.to.plot[chrs.to.plot %in% dat$chromosome]
if (length(chrs.to.plot)==0)
  chrs.to.plot <- 0

if (0 %in% chrs.to.plot) {
  cond <- TRUE
} else {
  cond <- chromosomes(cgh) %in% chrs.to.plot
}

# plot
pdf(file='group-frequencies.pdf', paper='a4r', width=0, height=0)
if (column == 'EMPTY') {
  frequencyPlot(cgh[cond,])
} else {
  for (group in sort(unique(phenodata[,column]))) {
    if (is.na(group)) {
      frequencyPlot(cgh[cond,is.na(phenodata[,column])], main=paste(column, ' = ', group, sep=''))
    } else {
      frequencyPlot(cgh[cond,!is.na(phenodata[,column]) & phenodata[,column] == group], main=paste(column, ' = ', group, sep=''))
    }
  }
}
dev.off()

# EOF

# TOOL input-output.R: InputOutput (Empty analysis for testing system wide data transfer.)
# INPUT input.tsv: input.tsv TYPE GENERIC 
# OUTPUT output.tsv: output.tsv 

#input<-read.table(c("input.tsv"), header=T, sep="\t")
#system("mv input.tsv output.tsv")
write.table(c(1, 2, 3), file="output.tsv", quote=FALSE, col.names=FALSE, row.names=FALSE)

# TOOL extract-samples-from-dataset.R: "Extract samples from dataset" (Extracts samples from a dataset. Saves the extracted samples as a new dataset. If there are missing values in the specified phenodata column, the samples that do have a value are extracted. If there are no missing values, the samples to be extracted have to be coded with 1, and the samples to be deleted with 0 in the same column.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT extract.tsv: extract.tsv 
# OUTPUT META phenodata-extract.tsv: phenodata-extract.tsv 
# PARAMETER column.extract: column.extract TYPE METACOLUMN_SEL DEFAULT group (Phenodata column containing the samples to be extracted)

# Extracts subset of samples from a dataset
# JTT, 19.10.2007
#
# Modified to also include annotation info in the output dataset.
# MG, 20.4.2010
#
# Modified to first filter out samples with missing values. And in the case of no missing values, follow
# the earlier behaviour of coding samples to be extracted with 1 and samples to be removed with 0.
# IS, 28.7.2010
#
# Modified to handle 2-color array data when extracting single sample.
# MG, 17.6.2011
#
# Modified to be able to handle any matrices (chip, flag, ...) and annotation columns present in the data.
# IS, 18.3.2013

# Parameter settings (default) for testing purposes
#column.extract<-"group"

# Loads the data file
file <- c('normalized.tsv')
dat <- read.table(file, header=TRUE, sep='\t', quote='', row.names=1, as.is=TRUE, check.names=FALSE)

# Loads phenodata
phenodata <- read.table('phenodata.tsv', header=TRUE, sep='\t', as.is=TRUE)

# Extract the data from the phenodata column
extract <- as.vector(phenodata[,column.extract])
extract[extract == ''] <- NA

# If there are samples with missing values, extract the ones that do have values.
if (sum(is.na(extract)) > 0) {
  extract <- ifelse(is.na(extract), 0, 1)
}

extract <- as.integer(extract)

# Sanity checks
if(length(unique(extract))>2) {
	stop("CHIPSTER-NOTE: You have specified more than two groups! You need to define exactly two groups.")
}
if(max(extract)>1) {
	stop("CHIPSTER-NOTE: The groups should be defined with values of 0 and 1! You have numbers larger than 1 in the definitions.")
}

# identify different matrices (chip, flag, ...) present in the data
x <- colnames(dat)
suffix <- sub('^chip\\.', '', x[grep('^chip\\.', x)[1]])
matrices <- sub(suffix, '', x[grep(suffix, x)])
annotations <- 1:length(x)
for (m in matrices) {
  annotations <- setdiff(annotations, grep(m, x))
}

dat2 <- dat[,annotations]

for (m in matrices) {
  dat2 <- cbind(dat2, dat[,grep(m, x), drop=FALSE][,extract==1, drop=FALSE])
}

phenodata2<-phenodata[which(extract==1),]

# update aberration frequencies if present
if ('loss.freq' %in% x) {
  calls <- dat2[,grep('^flag\\.', colnames(dat2)), drop=FALSE]
  dat2$loss.freq <- round(rowMeans(calls < 0), digits=3)
  dat2$gain.freq <- round(rowMeans(calls == 1), digits=3)
  if (2 %in% calls) {
    dat2$amp.freq <- round(rowMeans(calls == 2), digits=3)
  } else {
    dat2$amp.freq <- NULL
  }
}

# Writing the data to disk
options(scipen=10)
write.table(dat2, file="extract.tsv", sep="\t", row.names=T, col.names=T, quote=F)
write.table(phenodata2, file="phenodata-extract.tsv", sep="\t", row.names=F, col.names=T, quote=F, na='')

# EOF

# TOOL stat-one-group.R: "One sample tests" (Tests whether genes are differentially expressed, i.e., whether their expression is significantly different from the expected.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT one-sample.tsv: one-sample.tsv 
# PARAMETER test: test TYPE [t-test: t-test, Wilcoxon: Wilcoxon] DEFAULT t-test (Test type)
# PARAMETER scale.to.same.mean: scale.to.same.mean TYPE [yes: yes, no: no] DEFAULT yes (Scale the data to the same mean before filtering)
# PARAMETER p.value.adjustment.method: p.value.adjustment.method TYPE [none: none, Bonferroni: Bonferroni, Holm: Holm, Hochberg: Hochberg, BH: BH, BY: BY] DEFAULT BH (Multiple testing correction method)
# PARAMETER p.value.threshold: p.value.threshold TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (P-value cut-off for significant results)
# PARAMETER assumed.mean: assumed.mean TYPE DECIMAL FROM -100000 TO 100000 DEFAULT 0 (Assumed mean of the data)


# One-sample parametric and non-parametric tests
# JTT 4.7.2006

# Parameter settings (default) for testing purposes
#test<-c("t-test")
#scale.to.same.mean<-c("yes")
#p.value.adjustment.method<-c("BH")
#p.value.threshold<-c(0.05)
#assumed.mean<-c(0)

# Load the libraries
library(multtest)
library(genefilter)

# Renaming variables
meth<-test
adj.method<-p.value.adjustment.method
p.cut<-p.value.threshold
mu<-assumed.mean

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Sanity checks
if(ncol(dat2)==1) {
   stop("You need to have at least two chips to run this analysis!")
}

# Scaling the data to the same mean
if(scale.to.same.mean=="yes") {
   scaled.dat2<-genescale(dat2)
} else {
   scaled.dat2<-dat2
}

# Testing
if(meth=="t-test") {
   library(genefilter)
   n<-ncol(scaled.dat2)
   d<-sqrt(n)
   s<-rowSds(scaled.dat2)/d
   m<-rowSums(scaled.dat2)/n
   t<-(m-mu)/s
   p.raw<-(1-pt(abs(t), df=n-1))*2
}

if(meth=="Wilcoxon") {
   p<-c()
   len<-length(scaled.dat2[,1])
   for(i in 1:len) {
      # Calculates the Wilcoxon test statistic for every row (gene)
      p<-c(p, wilcox.test(x=as.vector(as.numeric(scaled.dat2[i,])), mu=mu, alternative=c("two.sided"))[[3]])
   }
   p.raw<-p
}

# Multiple testing correction
if(adj.method=="none") {
   p.adjusted<-p.raw
}
if(adj.method!="none") {
   p.adjusted<-mt.rawp2adjp(p.raw, adj.method)
   p.adjusted<-p.adjusted$adjp[order(p.adjusted$index),][,2]
}

# Discarding p-values that do not fulfill the cutoff (p.cut)
dat<-dat[p.adjusted<=p.cut,]   
p.adjusted<-p.adjusted[p.adjusted<=p.cut]

# Writing out a table
write.table(data.frame(dat, p.adjusted=round(p.adjusted, digits=6)), file="one-sample.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL ngs-dea-edger-RNA.R: "Differential expression using edgeR" (Differential gene expression analysis using the exact statistical methods of the edgeR Bioconductor package. You can create the input count table and phenodata file using the tool \"Utilities - Define NGS experiment\". Please note that this tool is suitable only for two group comparisons. For multifactor experiments please use the tool \"Differential expression using edgeR for multivariate experiments\".)
# INPUT data.tsv TYPE GENERIC
# INPUT phenodata.tsv TYPE GENERIC
# OUTPUT OPTIONAL de-list-edger.tsv
# OUTPUT OPTIONAL de-list-edger.bed
# OUTPUT OPTIONAL ma-plot-edger.pdf
# OUTPUT OPTIONAL mds-plot-edger.pdf
# OUTPUT OPTIONAL edger-log.txt
# OUTPUT OPTIONAL p-value-plot-edger.pdf
# OUTPUT OPTIONAL dispersion-edger.pdf
# PARAMETER column: "Column describing groups" TYPE METACOLUMN_SEL DEFAULT group (Phenodata column describing the groups to test)
# PARAMETER OPTIONAL normalization: "Apply TMM normalization" TYPE [yes, no] DEFAULT yes (Should normalization based on the trimmed mean of M-values \(TMM\) be performed to reduce the RNA composition effect.)
# PARAMETER OPTIONAL dispersion_method: "Dispersion method" TYPE [common, tagwise] DEFAULT tagwise (The dispersion of counts for a gene can be moderated across several genes with similar count numbers. This default tagwise option typically yields higher sensitivity and specificity. The option Common estimates one value which is then used for all the genes. Common dispersion is used regardless of the setting if no biological replicates are available.)
# PARAMETER OPTIONAL dispersion_estimate:"Dispersion value used if no replicates are available" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.1 (The value to use for the common dispersion when no replicates are available.) 
# PARAMETER OPTIONAL filter: "Analyze only genes which have counts in at least this many samples" TYPE INTEGER FROM 0 TO 1000 DEFAULT 0 (Analyze only genes which have at least 5 counts in at least this many samples)
# PARAMETER OPTIONAL p_value_threshold: "P-value cutoff" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.05 (The cutoff for adjusted p-values.)
# PARAMETER OPTIONAL p_value_adjustment_method: "Multiple testing correction" TYPE [none, Bonferroni, Holm, Hochberg, BH, BY] DEFAULT BH (Multiple testing correction method.)
# PARAMETER OPTIONAL w: "Plot width" TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted image)
# PARAMETER OPTIONAL h: "Plot height" TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted image)

 
# MG 11.6.2011                                            
# MG 23.8.2011, included library size from phenodata file                                           
# MG 30.1.2012, allowed analysis without biological replicates                                    
# MG 22.2.2012, prettified plots, added p-value  distribution plot
# EK 6.5.2012, clarified wording
# AMS 5.10.2012, added sorting to BED
# EK 30.4.2013, changes to descriptions, made genomic location info optional so that external count tables can be used
# EK 2.5.2013, added dispersion plot and filtering based on counts, disabled extra MA plots
# EK 5.5.2013, modified filtering based on counts, removed fixed prior.n

# OUTPUT OPTIONAL ma-plot-raw-edger.pdf
# OUTPUT OPTIONAL ma-plot-normalized-edger.pdf

# Loads the libraries
library(edgeR)

# Loads the count data
file <- c("data.tsv")
dat <- read.table(file, header=T, sep="\t", row.names=1)

# Extracts expression value columns
annotations <- dat[,-grep("chip", names(dat))]
dat2 <- dat[,grep("chip", names(dat))]

# Test needs a parameter "groups" that specifies the grouping of the samples
phenodata <- read.table("phenodata.tsv", header=T, sep="\t")
groups <- as.character (phenodata[,pmatch(column,colnames(phenodata))])
group_levels <- levels(as.factor(groups))
number_samples <- length(groups)

# If the library_size column contains data then use that as estimate
lib_size <- as.numeric(phenodata$library_size)
if (is.na(lib_size[1])) estimate_lib_size <- "TRUE" else estimate_lib_size <- "FALSE"

# Sanity checks
# only 2 group comparison is supported
if (length(unique(groups))==1 | length(unique(groups))>=3) {
	stop("CHIPSTER-NOTE: You need to have exactly two groups to run this analysis")
}
# if no biological replicates, force common dispersion
if (number_samples == 2) dispersion_method <- "common" 

# Create a DGEList. If no library size exist in the phenodata file, it is calculated from column totals 
if (estimate_lib_size) {
	dge_list <- DGEList (count=dat2, group=groups)
} else {
	dge_list <- DGEList (count=dat2, group=groups, lib.size=lib_size)
}

# filter out genes which have less than 5 counts in user-defined number of samples 
if (filter > 0) {
	keep <- rowSums(dge_list$counts>5) >= filter
	dge_list <- dge_list[keep,]
	dge_list$lib.size <- colSums(dge_list$counts)
}

# to be considered later: filter based on counts per million
# m <- sweep(dge_list$counts, 2, 1e6 / dge_list$samples$lib.size, `*`)
# ridx <- rowSums(m > 1) >= 3
# dge_list <- dge_list[ridx,]

# Calculate normalization factors
if (normalization == "yes") {
	dge_list <- calcNormFactors(dge_list) 
}


# Produce MDS plot of normalized data (possible only when there are more than 2 samples)
if (number_samples > 2) {
	pdf(file="mds-plot-edger.pdf", width=w/72, height=h/72)
	sample_colors <-  ifelse (dge_list$samples$group==group_levels[1], 1, 2)
	plotMDS(dge_list, main="MDS Plot", col=sample_colors)
	legend(x="topleft", legend = group_levels,col=c(1,2), pch=19)
	dev.off()
}

# MA plots before and after normalization (currently disabled output)
pdf(file="ma-plot-raw-edger.pdf", width=w/72, height=h/72)
maPlot(dge_list$counts[, 1], dge_list$counts[, 2], normalize = FALSE, pch = 19, cex = 0.4, ylim = c(-8, 8))
grid(col = "blue")
title("Raw counts")
abline(h = log2(dge_list$samples$norm.factors[2]/dge_list$samples$norm.factors[1]), col = "red", lwd = 2)
abline(h = 0, col = "darkgreen", lwd = 1)
legend (x="topleft", legend=c("not expressed in one condition","expressed in both conditions"), col=c("orange","black"), cex=1, pch=19)
dev.off()

if (normalization == "yes") {
	pdf(file="ma-plot-normalized-edger.pdf", width=w/72, height=h/72)
	eff.libsize <- dge_list$samples$lib.size * dge_list$samples$norm.factors
	maPlot(dge_list$counts[, 1]/eff.libsize[1], dge_list$counts[, 2]/eff.libsize[2],
			normalize = TRUE, pch = 19, cex = 0.4, ylim = c(-8, 8))
	grid(col = "blue")
	title("Normalized counts")
	legend (x="topleft", legend=c("not expressed in one condition","expressed in both conditions"), col=c("orange","black"), cex=1, pch=19)
	abline(h = 0, col = "darkgreen", lwd = 1)
	dev.off()
}

# Analysis using common dispersion
if (dispersion_method == "common") {
	# Calculate common dispersion
	dge_list <- estimateCommonDisp(dge_list)
	
	# Statistical testing
	if (number_samples != 2) stat_test <- exactTest(dge_list) 
	if (number_samples == 2) stat_test <- exactTest(dge_list, dispersion=dispersion_estimate)
}	

# Analysis using moderated tagwise dispersion
if (dispersion_method == "tagwise") {
	# Calculate the tagwise dispersion
	dge_list <- estimateCommonDisp(dge_list)
	# dge_list <- estimateTrendedDisp(dge_list)
	dge_list <- estimateTagwiseDisp(dge_list)
	# Statistical testing
	stat_test <- exactTest(dge_list)

# Dispersion plot
	pdf(file="dispersion-edger.pdf", width=w/72, height=h/72)
	plotBCV(dge_list, main="Biological coefficient of variation")
	dev.off()
}

# Extract results in a nice-looking table
number_tags <- dim (dge_list$counts) [1]
results_table <- topTags (stat_test, n=number_tags, adjust.method=p_value_adjustment_method, sort.by="p.value")
results_table <- results_table$table
	
# Extract the significant tags based on adjusted p-value cutoff
significant_results <- results_table[results_table$FDR<p_value_threshold,]
	
# Make an MA-plot displaying the significant reads
pdf(file="ma-plot-edger.pdf", width=w/72, height=h/72)	
significant_indices <- rownames (significant_results)
plotSmear(dge_list, de.tags = significant_indices, main = "MA plot")
abline(h = c(-1, 0, 1), col = c("dodgerblue", "darkgreen", "dodgerblue"), lwd = 2)
legend (x="topleft", legend=c("significantly differentially expressed","not significant"), col=c("red","black"),cex=1, pch=19)
dev.off()

# If significant results are found, create an output table with the original counts per sample together with the statistical tests results
# If genomic coordinates are present, output a sorted BED file for genome browser visualization and region matching tools
if (dim(significant_results)[1] > 0) {
	output_table <- data.frame (dat[significant_indices,], significant_results)
	write.table(output_table, file="de-list-edger.tsv", sep="\t", row.names=T, col.names=T, quote=F)
	these.colnames <- colnames(dat)
	if("chr" %in% these.colnames) {
		empty_column <- character(length(significant_indices))
		bed_output <- output_table [,c("chr","start","end")]
		bed_output <- cbind(bed_output,empty_column)
		bed_output <- cbind(bed_output, output_table[,"logFC"])
		source(file.path(chipster.common.path, "bed-utils.R"))
		bed_output <- sort.bed(bed_output)
		write.table(bed_output, file="de-list-edger.bed", sep="\t", row.names=F, col.names=F, quote=F)
	}	
}


# Output a message if no significant genes are found
if (dim(significant_results)[1] == 0) {
	cat("No statistically significantly expressed genes were found.", file="edger-log.txt")
}


# Make histogram of p-values with overlaid significance cutoff and uniform distribution
pdf (file="p-value-plot-edger.pdf")
hist(results_table$PValue, breaks=100, col="blue",
		border="slateblue", freq=FALSE,
		main="P-value distribution", xlab="p-value", ylab="proportion (%)")
hist(results_table$FDR, breaks=100, col="red",
		border="slateblue", add=TRUE, freq=FALSE)
abline(h=1, lwd=2, lty=2, col="black")
abline(v=p_value_threshold, lwd=2, lty=2, col="green")
legend (x="topright", legend=c("p-values","adjusted p-values", "uniform distribution", "significance cutoff"), col=c("blue","red","black","green"),
		cex=1, pch=15)
dev.off()

# EOF

# TOOL cluster-qt.R: "Quality Threshold (QT\)" (Quality threshold clustering for genes. Divides the genes of the selected data set in a number of clusters. The number and tightness of the clusters is controlled by the option radius. A suitable radius is dependent on the variability of the data set, and it may vary from one data set to another.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT qt.tsv: qt.tsv 
# OUTPUT qt.pdf: qt.pdf 
# PARAMETER radius.for.similarity: radius.for.similarity TYPE DECIMAL FROM 0 TO 1000 DEFAULT 20 (A radius for similar genes)
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the resampling image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the resampling image)


# K-means clustering
# JTT 22.6.2006

# Parameter settings (default) for testing purposes
#radius.for.similarity<-20
#image.width<-600
#image.height<-600

# Renaming variables
rad<-radius.for.similarity
w<-image.width
h<-image.height

# Load the libraries
library(flexclust)

# Loads the data file
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]
dat3<-dat2

# Calculates the K-means clustering result
# Needs a parameter for groups radius
# rad<-c(20)
qtc<-qtclust(dat3, radius=rad)

# Plotting the clustering
max.dat2<-max(dat3)
min.dat2<-min(dat3)
k<-length(unique(qtc@cluster))
pdf(file="qt.pdf", width=w/72, height=h/72)
par(mfrow=c(ceiling(sqrt(k)), ceiling(sqrt(k))))
for(i in 1:k) {
   matplot(t(dat3[qtc@cluster==i,]), type="l", main=paste("cluster:", i), ylab="log expression", col=1, lty=1, ylim=c(min.dat2, max.dat2))
}
dev.off()

# Writing a table
# Creates a table with one column giving the cluster membership
dat4<-data.frame(dat3,cluster=qtc@cluster)
dat4<-na.omit(dat4)
write.table(dat4, "qt.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL norm-gene-average.R: "Normalize to gene average" (Normalizes data so that the average signal for each gene becomes equal to the value of 1.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT normalized2geneaverage.tsv: normalized2geneaverage.tsv 
# PARAMETER average.method: average.method TYPE [median: median, mean: mean] DEFAULT mean (Method for calculating the average)

# Normalize the data so that each gene has an average of 1 across the
# chips of one data set
# MG 24.11.2009

# Name of the first table
name1<-c("normalized.tsv")

# Loads the table with data
table1<-read.table(file=name1, sep="\t", header=T, row.names=1)

# Get the indices for the column with expression values
indices <- grep("chip", names(table1))

# Calculate chip means and medians
gene.means <- apply(table1[,indices],FUN=mean,MARGIN=1)
gene.medians <- apply(table1[,indices],FUN=median,MARGIN=1)

# Calculating the normalization values
if (average.method=="mean") {
	for (row in 1:length(gene.means)) {
		table1[row,indices] <- table1[row,indices]/gene.means[row]
	}
}
if (average.method=="median") {
	for (row in 1:length(gene.means)) {
		table1[row,indices] <- table1[row,indices]/gene.medians[row]
	}
}

# Write out data
write.table(table1, file="normalized2geneaverage.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# TOOL ngs-extract-target-gene-expression.R: "Extract miRNA target expression data" (Extracts the expression data for a set of target genes identified by an integrative analysis of miRNA and gene expression. Two files need to be selected: the result file from an integrative analysis and the file containing the gene expression data.)
# INPUT normalized_gene.tsv: normalized_gene.tsv TYPE GENE_EXPRS 
# INPUT normalized_mirna.tsv: normalized_mirna.tsv TYPE GENERIC 
# INPUT phenodata_gene.tsv: phenodata_gene.tsv TYPE GENERIC 
# OUTPUT target-gene-expression.tsv: target-gene-expression.tsv 
# OUTPUT phenodata-target-gene.tsv: phenodata-target-gene.tsv 
# PARAMETER common.column: common.column TYPE STRING DEFAULT empty (The name of the column that is common to the data tables.)

# Setting up test parameter settings
# common.column <- "symbol"

# Loads the normalized data and phenodata files
data_1 <- read.table(file="normalized_mirna.tsv", header=T, sep="\t", row.names=1)
data_2 <- read.table(file="normalized_gene.tsv", header=T, sep="\t", row.names=1)
phenodata <- read.table("phenodata_gene.tsv", header=T, sep="\t")

# Figure out which is the miRNA data
if (length (grep ("miRNA", names (data_1))) == 1) {
	mirna.data <- data_1
	gene.data <- data_2
}
if (length (grep ("miRNA", names (data_2))) == 1) {
	mirna.data <- data_2
	gene.data <- data_1
}

# Extract the common columns from the input data and condense
# to unique values to get rid of multiple entries
attach(mirna.data)
mirna.symbols <- get(common.column)
mirna.symbols <- unique(mirna.symbols)
detach(mirna.data)
attach(gene.data)
gene.symbols <- get(common.column)
detach(gene.data)
gene.data.2 <- gene.data [match(mirna.symbols, gene.symbols, nomatch=0),]

# write files
write.table(gene.data.2, file='target-gene-expression.tsv', quote=FALSE, sep='\t', row.names=TRUE, col.names=TRUE)
write.table(phenodata, file='phenodata-target-gene.tsv', quote=FALSE, sep='\t', na='', row.names=FALSE, col.names=TRUE)

# EOF

# TOOL process-preprocessed-counts.R: "Preprocess count table" (Converts count table to Chipster format and creates a phenodata file for it. You need to import your count table using the Import tool. Make sure to mark every count column as Sample and the column containing feature names as Identifier.)
# INPUT ngs{...}.tsv: ngs{...}.tsv TYPE CDNA 
# OUTPUT counts.tsv: counts.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv
# PARAMETER experimentype: "Experiment type" TYPE STRING DEFAULT empty (You can define experiment type, for example rna-seq.)
# PARAMETER OPTIONAL keep.annotations: "Keep annotations" TYPE [yes: yes, no: no] DEFAULT no (Keep or discard annotation columns after preprocessing.)


# MK 08.05.2013 Created based on the process prenormalized affy script


# Loads the libraries
library(limma)

# Reading data
columns<-list(R="sample")
annotation<-c("identifier")
columns.other<-c("annotation", "Annotation", "ANNOTATION")

files<-dir()
files<-files[files!="phenodata.tsv"]
#seems to check columns from the first file only. If the column is not there, attribute is ignored. If the column is there, but not
#in the others, function crashes
dat<-read.maimages(files=files, columns=columns, annotation=annotation, other.columns=columns.other) 
	
#dat <- read.table(file="normalized.tsvt", header=TRUE, sep="\t")

# Extract annotations
annotation.info <- NULL;
if (keep.annotations=="yes") {
	if(length(grep("^annotation$", unlist(attributes(dat$other)), ignore.case=T))) {
		annotation.col <- unlist(attributes(dat$other))[grep("^annotation$", unlist(attributes(dat$other)), ignore.case=T)]
		annotation.info	<- dat$other[[annotation.col]];
		annotation.info <- as.character(annotation.info[,1]);
	}
}

# Mock normalization
dat2<-normalizeBetweenArrays(dat$E, method="none")
sample<-paste(colnames(dat2), ".tsv", sep="")
colnames(dat2)<-paste("chip.", colnames(dat2), sep="")

# Writes out a phenodata table
# sample<-paste(sample, ".tsv", sep="")
org_name <- files
group <- c(rep("", length(sample)))
chiptype <-"not applicable"
experiment <- c(rep(experimentype, length(sample)))
libsize <-c(rep("", length(sample)))

#sample, original name, chiptype, experiment, group, library size, description

write.table(data.frame(sample=sample, chiptype=chiptype, experiment=experiment, group=group, library_size=libsize, description=sample), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# Writes the results into a file
if (keep.annotations=="yes") {
	output_table <- data.frame(symbol=annotation.info, dat2);	
} else {
	output_table <- data.frame(dat2);		
}
	
rownames (output_table) <- unlist(dat$genes)
write.table(output_table, file="counts.tsv", col.names=T, quote=F, sep="\t", row.names=T)

# TOOL fastx-quality-filter.R: "Filter reads for quality" (Filters out reads which contain quality scores below the user-specified criteria. This tool is based on the FASTQ Quality Filter tool of the FASTX package.)
# INPUT reads.fastq TYPE GENERIC
# OUTPUT quality-filtered.fastq
# OUTPUT quality-filtered.log
# PARAMETER quality: "Quality cut-off value" TYPE INTEGER FROM 1 TO 100 DEFAULT 20 (What is the minimum quality score to keep.)
# PARAMETER percentage: "Minimum percent of bases that must have that quality" TYPE INTEGER FROM 1 TO 100 DEFAULT 90 (Percent of bases in sequence that must have quality equal to or higher than the cut-off value.)
# PARAMETER quality.format: "Quality value format used" TYPE [sanger: Sanger, illuminaold: "Illumina GA v1.3-1.5"] DEFAULT sanger (What quality encoding is used in your FASTQ file. Select Sanger if your data comes from Illumina 1.8 or later, SOLiD or 454.)


# EK 28.6.2011

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads.fastq")

# binary
binary <- c(file.path(chipster.tools.path, "fastx", "bin", "fastq_quality_filter"))

# command
quality.scale <- ifelse(quality.format == "sanger", "-Q 33", "")
command <- paste(binary, "-v", "-q", quality, "-p", percentage, quality.scale, "-i reads.fastq -o quality-filtered.fastq > quality-filtered.log")

# run
system(command)

# TOOL plot-venn-diagram.R: "Venn diagram" (Draws a Venn diagram for the three selected gene lists. Select the gene lists from the Workflow view of Datasets before running this tool.)
# INPUT normalized1.tsv: normalized1.tsv TYPE GENE_EXPRS 
# INPUT normalized2.tsv: normalized2.tsv TYPE GENE_EXPRS 
# INPUT normalized3.tsv: normalized3.tsv TYPE GENE_EXPRS 
# OUTPUT venn.pdf: venn.pdf 
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Parameter settings (default) for testing purposes
#image.width<-600
#image.height<-600

# Renaming variables
w<-image.width
h<-image.height

# Loads the libraries
library(limma)

# Loads the data
files<-dir()
set1<-read.table(files[1], header=T, sep="\t")
set2<-read.table(files[2], header=T, sep="\t")
set3<-read.table(files[3], header=T, sep="\t")

# Reads just the row names
set1<-unique(rownames(set1))
set2<-unique(rownames(set2))
set3<-unique(rownames(set3))

# Creates the universe
universe <- sort(unique(c(set1, set2, set3)))

# Creates a matrix of terms in every set
Counts <- matrix(0, nrow=length(universe), ncol=3)
colnames(Counts) <- c(files)
for (i in 1:length(universe)) {
   Counts[i,1] <- universe[i] %in% set1
   Counts[i,2] <- universe[i] %in% set2
   Counts[i,3] <- universe[i] %in% set3
}

# The part plotting the universe has been commented off.
# Otherwise the code is taken directly from limma
vennDiagram2<-function (object, include = "both", names, mar = rep(1, 4), cex = 1.5, 
    lwd = 1, circle.col, counts.col, show.include, ...) {
    if (!is(object, "VennCounts")) {
        if (length(include) > 2) 
            stop("Cannot plot Venn diagram for more than 2 sets of counts")
        if (length(include) == 2) 
            object.2 <- vennCounts(object, include = include[2])
        object <- vennCounts(object, include = include[1])
    }
    else if (length(include == 2)) 
        include <- include[1]
    nsets <- ncol(object) - 1
    if (nsets > 3) 
        stop("Can't plot Venn diagram for more than 3 sets")
    if (missing(names)) 
        names <- colnames(object)[1:nsets]
    counts <- object[, "Counts"]
    if (length(include) == 2) 
        counts.2 <- object.2[, "Counts"]
    if (missing(circle.col)) 
        circle.col <- par("col")
    if (length(circle.col) < nsets) 
        circle.col <- rep(circle.col, length.out = nsets)
    if (missing(counts.col)) 
        counts.col <- par("col")
    if (length(counts.col) < length(include)) 
        counts.col <- rep(counts.col, length.out = length(include))
    if (missing(show.include)) 
        show.include <- as.logical(length(include) - 1)
    theta <- 2 * pi * (1:360)/360
    xcentres <- list(0, c(-1, 1), c(-1, 1, 0))[[nsets]]
    ycentres <- list(0, c(0, 0), c(1/sqrt(3), 1/sqrt(3), -2/sqrt(3)))[[nsets]]
    r <- c(1.5, 1.5, 1.5)[nsets]
    xtext <- list(-1.2, c(-1.2, 1.2), c(-1.2, 1.2, 0))[[nsets]]
    ytext <- list(1.8, c(1.8, 1.8), c(2.4, 2.4, -3))[[nsets]]
    old.par <- par(mar = mar)
    on.exit(par(old.par))
    plot(x = 0, y = 0, type = "n", xlim = c(-4, 4), ylim = c(-4, 
        4), xlab = "", ylab = "", axes = FALSE, ...)
    for (circle in 1:nsets) {
        lines(xcentres[circle] + r * cos(theta), ycentres[circle] + 
            r * sin(theta), lwd = lwd, col = circle.col[circle])
        text(xtext[circle], ytext[circle], names[circle], cex = cex)
    }
    switch(nsets, {
        rect(-3, -2.5, 3, 2.5)
        printing <- function(counts, cex, adj, col, leg) {
            text(2.3, -2.1, counts[1], cex = cex, col = col, 
                adj = adj)
            text(0, 0, counts[2], cex = cex, col = col, adj = adj)
            if (show.include) 
                text(-2.3, -2.1, leg, cex = cex, col = col, adj = adj)
        }
    }, {
        rect(-3, -2.5, 3, 2.5)
        printing <- function(counts, cex, adj, col, leg) {
            text(2.3, -2.1, counts[1], cex = cex, col = col, 
                adj = adj)
            text(1.5, 0.1, counts[2], cex = cex, col = col, adj = adj)
            text(-1.5, 0.1, counts[3], cex = cex, col = col, 
                adj = adj)
            text(0, 0.1, counts[4], cex = cex, col = col, adj = adj)
            if (show.include) 
                text(-2.3, -2.1, leg, cex = cex, col = col, adj = adj)
        }
    }, {
        rect(-3, -3.5, 3, 3.3)
        printing <- function(counts, cex, adj, col, leg) {
            #text(2.5, -3, counts[1], cex = cex, col = col, adj = adj)
            text(0, -1.7, counts[2], cex = cex, col = col, adj = adj)
            text(1.5, 1, counts[3], cex = cex, col = col, adj = adj)
            text(0.75, -0.35, counts[4], cex = cex, col = col, 
                adj = adj)
            text(-1.5, 1, counts[5], cex = cex, col = col, adj = adj)
            text(-0.75, -0.35, counts[6], cex = cex, col = col, 
                adj = adj)
            text(0, 0.9, counts[7], cex = cex, col = col, adj = adj)
            text(0, 0, counts[8], cex = cex, col = col, adj = adj)
            if (show.include) 
                text(-2.5, -3, leg, cex = cex, col = col, adj = adj)
        }
    })
    adj <- c(0.5, 0.5)
    if (length(include) == 2) 
        adj <- c(0.5, 0)
    printing(counts, cex, adj, counts.col[1], include[1])
    if (length(include) == 2) 
        printing(counts.2, cex, c(0.5, 1), counts.col[2], include[2])
    invisible()
}

# Plotting the diagram
cols<-c("Red", "Green", "Blue")
pdf(file="venn.pdf", width=w/72, height=h/72)
vennDiagram2(vennCounts(Counts), circle.col=cols)
dev.off()

# TOOL ngs-filter-results-column.R: "Filter table by column value" (Allows the user to filter the results on the basis of values in any numerical column.)
# INPUT results.tsv: results.tsv TYPE GENERIC 
# OUTPUT filtered-NGS-results.tsv: filtered-NGS-results.tsv 
# PARAMETER column: column TYPE COLUMN_SEL (Data column to filter by)
# PARAMETER has.rownames: "data with rownames" TYPE [yes: yes, no: no] DEFAULT no (Specifies whether the data has unique identifiers as rownmaes or lacks them.)
# PARAMETER cutoff: cutoff TYPE DECIMAL FROM -10000000 TO 10000000 DEFAULT 1 (Cut-off for filtering)
# PARAMETER smaller.or.larger: "filtering criteria" TYPE [equal-to: equal-to, smaller-than: smaller-than, larger-than: larger-than, within: within, outside: outside] DEFAULT smaller-than (Smaller or larger than the cutoff is filtered.
# Use the "within" or "outside" options to filter symmmetrically around two cut-offs, useful for example when searching for 2-fold up- and down-regulated genes.)

# Filter NGS results on the basis of a continuous parameter in a column
# MG 26.5.2010

# Loads the data
file <- c("results.tsv")
if (has.rownames == "yes") {
	dat <- read.table(file, header=TRUE, sep="\t", row.names=1, check.names=FALSE)
}
if (has.rownames == "no") {
	dat <- read.table(file, header=T, sep="\t") 
}

# Extract the data to a vector
f <- dat[,grep(column, colnames(dat))]

# Filters the data
if(smaller.or.larger=="equal-to") {
	dat2<-dat[which(f==cutoff),]
}
if(smaller.or.larger=="smaller-than") {
	dat2<-dat[which(f<=cutoff),]
}
if(smaller.or.larger=="larger-than") {
	dat2<-dat[which(f>=cutoff),]
}
if(smaller.or.larger=="outside") {
	cutoff_2 <- -cutoff
	dat2<-dat[which(f>=cutoff | f<=cutoff_2),]
}
if(smaller.or.larger=="within") {
	cutoff_2 <- -cutoff
	dat2<-dat[-which(f>=cutoff | f <=cutoff_2),]
}

# Writing the data to disk
if (has.rownames == "yes") {
	write.table(dat2, "filtered-NGS-results.tsv", sep="\t", row.names=T, col.names=T, quote=F)
}
if (has.rownames == "no") {
	write.table(dat2, "filtered-NGS-results.tsv", sep="\t", row.names=F, col.names=T, quote=F)
}

# TOOL bedtools-windowbed.R: "Window BED" (Examines a window around each feature in A and reports all features in B that overlap the window. For each overlap the entire entry in A and B are reported. This tool is based on the BEDTools package.)
# INPUT file.a: "Input file A" TYPE GENERIC
# INPUT file.b: "Input file B" TYPE GENERIC
# OUTPUT OPTIONAL windowbed.bed 
# OUTPUT OPTIONAL windowbed.bam
# PARAMETER abam: "The A input file is in BAM format" TYPE [yes,no] DEFAULT no (The A input file is in BAM format. By default output will be BAM as well.) 
# PARAMETER OPTIONAL ubam: "Write uncompressed BAM output" TYPE [yes,no] DEFAULT no (Write uncompressed BAM output. Default is to write compressed BAM.) 
# PARAMETER OPTIONAL bed: "When using BAM input, write output as BED." TYPE [yes,no] DEFAULT no (When using BAM input, write output as BED. The default is to write output in BAM.) 
# PARAMETER OPTIONAL l: "Base pairs added upstream" TYPE INTEGER DEFAULT 1000 (Base pairs added upstream (left of\) of each entry in A when searching for overlaps in B. Allows one to define assymterical windows.) 
# PARAMETER OPTIONAL r: "Base pairs added downstream" TYPE INTEGER DEFAULT 1000 (Base pairs added downstream (right of\) of each entry in A when searching for overlaps in B. Allows one to define assymterical windows.) 
# PARAMETER OPTIONAL sw: "Define window based on strand" TYPE [yes,no] DEFAULT no (Define window based on strand.  For example if used, upstream window size 500 for a negative-stranded feature will add 500 bp downstream.) 
# PARAMETER OPTIONAL sm: "Only report hits in B that overlap A on the same strand" TYPE [yes,no] DEFAULT no (Only report hits in B that overlap A on the same strand.) 
# PARAMETER OPTIONAL u: "Write the original A entry once if any overlaps found in B" TYPE [yes,no] DEFAULT no (Write the original A entry once if any overlaps found in B. In other words, just report the fact >=1 hit was found.) 
# PARAMETER OPTIONAL c: "For each entry in A, report the number of overlaps with B" TYPE [yes,no] DEFAULT no (For each entry in A, report the number of overlaps with B. Reports 0 for A entries that have no overlap with B.) 
# PARAMETER OPTIONAL v: "Only report those entries in A that have no overlaps with B" TYPE [yes,no] DEFAULT no (Only report those entries in A that have _no overlaps_ with B) 

# AMS 23.4.2012
# AMS 11.10.2012 Fixed BAM file support

# binary
binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "windowBed"))

# options
outfile <- "windowbed.bed"
options <- paste("")
if (abam == "yes") {
	outfile <- "windowbed.bam"
	if (ubam == "yes") {
		options <- paste(options, "-ubam")
	}
	if (bed == "yes") {
		options <- paste(options, "-bed")
		outfile <- "windowbed.bed"
	}
}

options <- paste(options, "-l", l)
options <- paste(options, "-r", r)
if (sw == "yes") {options <- paste(options, "-sw")}
if (sm == "yes") {options <- paste(options, "-sm")}
if (u == "yes") {options <- paste(options, "-u")}
if (c == "yes") {options <- paste(options, "-c")}
if (v == "yes") {options <- paste(options, "-v")}

# input files
if (abam == "yes") {options <- paste(options, "-abam file.a -b file.b")}
if (abam == "no") {options <- paste(options, "-a file.a -b file.b")}

# command
command <- paste(binary, options, ">", outfile)

# run
system(command)

if (file.exists("windowbed.bed")){
	if (file.info("windowbed.bed")$size == 0) {
		system("echo \"# No results found\" > windowbed.bed")
	}	
}

# TOOL bedtools-intersectbed.R: "Intersect BED" (Report overlaps between two feature files. This tool is based on the BEDTools package.)
# INPUT file.a: "Input file A" TYPE GENERIC
# INPUT file.b: "Input file B" TYPE GENERIC
# OUTPUT OPTIONAL intersectbed.bed 
# OUTPUT OPTIONAL intersectbed.bam
# PARAMETER abam: "File A is BAM format" TYPE [yes, no] DEFAULT no (Select yes if file A is BAM format.)
# PARAMETER OPTIONAL ubam: "Write uncompressed BAM output" TYPE [yes, no] DEFAULT no (Write uncompressed BAM output. Default is to write compressed BAM.)
# PARAMETER OPTIONAL bed: "Write output as BED" TYPE [yes, no] DEFAULT no (When using BAM input, write output as BED. The default is to write output in BAM when using BAM input.)
# PARAMETER OPTIONAL wa: "Write the original entry in A for each overlap" TYPE [yes, no] DEFAULT no (Report the original A feature when an overlap is found. The entire A feature is reported, not just the portion that overlaps with the B feature.)
# PARAMETER OPTIONAL wb: "Write the original entry in B for each overlap" TYPE [yes, no] DEFAULT no (Report the original B feature when an overlap is found. The entire B feature is reported, not just the portion that overlaps with the A feature.)
# PARAMETER OPTIONAL wo: "Write the original A and B entries for overlapped A features" TYPE [yes, no] DEFAULT no (Write the original A and B entries plus the number of base pairs of overlap between the two feature. Only A features with overlap are reported.)
# PARAMETER OPTIONAL wao: "Write the original A and B entries for all A features" TYPE [yes, no] DEFAULT no (Write the original A and B entries plus the number of base pairs of overlap between the two features. However, A features w/o overlap are also reported with a NULL B feature and overlap = 0.)
# PARAMETER OPTIONAL u: "Write the original A entry once if any overlaps found in B" TYPE [yes, no] DEFAULT no (Write the original A entry once if any overlaps found in B)
# PARAMETER OPTIONAL c: "For each entry in A, report the number of overlaps with B" TYPE [yes, no] DEFAULT no (For each entry in A, report the number of overlaps with B)
# PARAMETER OPTIONAL v: "Only report those entries in A that have no overlaps with B" TYPE [yes, no] DEFAULT no (Only report those entries in A that have no overlaps with B)
# PARAMETER OPTIONAL f: "Minimum overlap required as a fraction of A" TYPE DECIMAL FROM 0 TO 1 DEFAULT 0.000000001 (Minimum overlap required as a fraction of A. Default is 1E-9 (effectively 1bp\))
# PARAMETER OPTIONAL r: "Require that the fraction overlap be reciprocal for A and B" TYPE [yes, no] DEFAULT no (Require that the fraction overlap be reciprocal for A and B. In other words, if minumum overlap is 0.90 and this option is selected, this requires that B overlap 90% of A and A also overlaps 90% of B.)
# PARAMETER OPTIONAL s: "Force strandedness" TYPE [yes, no] DEFAULT no (Only report hits in B that overlap A on the same strand. By default, overlaps are reported without respect to strand.)
# PARAMETER OPTIONAL split: "Treat split BAM or BED12 entries as distinct BED intervals" TYPE [yes, no] DEFAULT no (Treat "split" BAM (i.e., having an “N” CIGAR operation\) or BED12 entries as distinct BED intervals.)

# AMS 23.4.2012
# AMS 11.10.2012 Fixed BAM file support

# binary
binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "intersectBed"))

# options
outfile <- "intersectbed.bed"
options <- paste("")
if (abam == "yes") {
	outfile <- "intersectbed.bam"
	if (ubam == "yes") {
		options <- paste(options, "-ubam")
	}
	if (bed == "yes") {
		options <- paste(options, "-bed")
		outfile <- "intersectbed.bed"
	}
}
if (wa == "yes") {options <- paste(options,"-wa")}
if (wb == "yes") {options <- paste(options,"-wb")}
if (wo == "yes") {options <- paste(options,"-wo")}
if (wao == "yes") {options <- paste(options,"-wao")}
if (u == "yes") {options <- paste(options, "-u")}
if (c == "yes") {options <- paste(options, "-c")}
if (v == "yes") {options <- paste(options, "-v")}
options <- paste(options, "-f", f)
if (r == "yes") {options <- paste(options, "-r")}
if (s == "yes") {options <- paste(options, "-s")}
if (split == "yes") {options <- paste(options, "-split")}

# input files
if (abam == "yes") {options <- paste(options, "-abam file.a -b file.b")}
if (abam == "no") {options <- paste(options, "-a file.a -b file.b")}

# command
command <- paste(binary, options, ">", outfile)

#stop(paste('CHIPSTER-NOTE: ', command))

# run
system(command)

if (file.exists("intersectbed.bed")){
	if (file.info("intersectbed.bed")$size == 0) {
		system("echo \"# No results found\" > intersectbed.bed")
	}	
}

# TOOL prinseq-duplicate-filter.R: "Filter reads for duplicates" (Removes duplicate reads. This tool is based on the PRINSEQ package.)
# INPUT fastqfile: "Input sequence set" TYPE GENERIC
# OUTPUT OPTIONAL accepted.fastq
# OUTPUT OPTIONAL accepted.fasta
# OUTPUT OPTIONAL rejected.fastq
# OUTPUT OPTIONAL rejected.fasta
# OUTPUT OPTIONAL filter.log
# PARAMETER derep: "Type of duplicates to filter" TYPE [1: "exact duplicate", 2: "5-prime duplicate", 3: "3-prime duplicate", 4: "reverse complement exact duplicate", 5:"reverse complement 5-prime/3-prime duplicate"] DEFAULT 1 (Type of duplicates to filter.)
# PARAMETER derep.min: "Number of allowed duplicates" TYPE INTEGER DEFAULT 2 (This option specifies the number of allowed duplicates. For example, to remove sequences that occur more than 5 times, you would specify value 6. Note that this option is used only for filtering exact duplicates or reverse complement exact duplicates.)
# PARAMETER OPTIONAL output.mode: "Results to write out" TYPE [ filt: "accepted reads only", both: "accepted and rejected reads into separate files"] DEFAULT filt (With this section you can define if the reads that get filtered out are collected to a separate file.) 
# PARAMETER OPTIONAL input.mode: "Input file format" TYPE [ fq: "FASTQ", fa: "FASTA"] DEFAULT fq (Define the file format of the reads file.)
# PARAMETER OPTIONAL log.file: "Write a log file" TYPE [ n: "no", y: "yes"] DEFAULT y (Write a log file.)


# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("fastqfile")

# binary
binary.prinseq <- c(file.path(chipster.tools.path, "prinseq", "prinseq-lite.pl" ))

filter.params <- paste( "-derep", derep )

if (derep == "1") {
	filter.params <- paste(filter.params, "-derep_min", derep.min )
}

if (derep == "4") {
	filter.params <- paste(filter.params, "-derep_min", derep.min )
}

if (output.mode == "both") {
	filter.params <- paste(filter.params, "-out_bad rejected")
}

if (input.mode == "fq") {
	filter.command <- paste(binary.prinseq, filter.params, "-fastq fastqfile -out_good accepted")
}

if (input.mode == "fa") {
	filter.command <- paste(binary.prinseq, filter.params, "-fasta fastqfile -out_good accepted")
}


if (log.file == "y") {
  system("echo Running PRINSEQ filtering with command: > filter.log")
  echo.command <- paste("echo '", filter.command, "'>> filter.log")
  system(echo.command)
  filter.command <- paste(filter.command, "-verbose 2>> filter.log")
}
  
system(filter.command)

#Make sure that something is given as an output
if (input.mode == "fq") {
	system("if [ ! -e  accepted.fastq ] ; then echo 'Filtering produced an empty accepted.fastq sequence set.' >> filter.log ; echo '' > accepted.fastq ; fi")
}

if (input.mode == "fa") {
	system("if [ ! -e  accepted.fasta ] ; then echo 'Filtering produced an empty accepted.fasta sequence set.' >> filter.log  ; echo '' > accepted.fasta ; fi")
}

if (output.mode == "both") {
	if (input.mode == "fq") {
		system("if [ ! -e  rejected.fastq ] ; then echo 'Filtering produced an empty rejected.fastq sequence set.' >> filter.log ; echo '' > rejected.fastq ; fi")
	}
	
	if (input.mode == "fa") {
		system("if [ ! -e  rejected.fasta ] ; then echo 'Filtering produced an empty rejected.fasta sequence set.' >> filter.log  ; echo '' > rejected.fasta ; fi")
	}
}
#stop

# TOOL convert-RNA-bam-to-edger.R: "Map aligned reads to genes with coverageBed using own BED" (Calculates how many reads in a BAM file map to each gene. You have to provide the gene locations in the BED format. Please note that the chromosome names have to be same in the BED and BAM files. This tool is based on the coverageBed tool of the BEDTools package. In order to use the output in edgeR, you need to select all samples and run the tool \"Utilities - Define NGS experiment\".)
# INPUT file.a: "BAM file" TYPE GENERIC
# INPUT file.b: "BED file" TYPE GENERIC
# OUTPUT edgeR-input.tsv
# PARAMETER OPTIONAL s: "Force strandedness" TYPE [yes, no] DEFAULT no (Force strandedness. That is, only count reads in BAM that overlap genes on the same strand in the BED file. By default, hits are counted regardless of strand.)
# PARAMETER OPTIONAL split: "Treat split BAM or BED12 entries as distinct BED intervals" TYPE [yes, no] DEFAULT no (Treat "split" BAM or BED12 entries as distinct BED intervals when computing coverage. For BAM files, this uses the CIGAR N and D operations to infer the blocks for computing coverage. For BED12 files, this uses the BlockCount, BlockStarts, and BlockEnds fields (i.e., columns 10,11,12\).)

# MG 22.8.2011
# modified from the coveragebed tool by AMS
# EK 10.1.2012

# setup parameters
abam <- "yes"

# binary
binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "coverageBed"))

# optional options
options <- paste("")
if (s == "yes") {options <- paste(options, "-s")}
# if (hist == "yes") {options <- paste(options, "-hist")}
# if (d == "yes") {options <- paste(options, "-d")}
if (split == "yes") {options <- paste(options, "-split")}

# input files
if (abam == "yes") {options <- paste(options, "-abam file.a -b file.b")}
if (abam == "no") {options <- paste(options, "-a file.a -b file.b")}

# command
command <- paste(binary, options, " > coveragebed.tsv")

# run
system(command)

# bring in file to R environment for formating
file <- c("coveragebed.tsv")
dat <- read.table(file, header=F, sep="\t")
id_list <- paste(dat$V1,dat$V2,dat$V3,dat$V4, sep="_")
length_list <- dat$V3-dat$V2+1
results_table <- data.frame	(
		id=id_list,
		sequence=dat$V4,
		chr=dat$V1,
		start=dat$V2,
		end=dat$V3,
		length=length_list,
		count=dat$V5
)

# write result table to output
write.table(results_table, file="edgeR-input.tsv", col.names=T, quote=F, sep="\t", row.names=F)

# EOF

# TOOL ngs-create-experiment.R: "Define NGS experiment" (This tool creates a combined count table for all the samples, and phenodata file which allows you to describe the samples and experiment setup. Please fill in the group column to describe the experiment groups to be compared.
# You have also the option to give the library size for each sample. If you fill in this information, the edgeR and DESeq tools will use these numbers rather than summing the counts from the count table.)
# INPUT sample{...}.tsv: "Individual sample files with counts" TYPE GENERIC 
# OUTPUT ngs-data-table.tsv: "Data table with read counts" 
# OUTPUT META phenodata.tsv: "Experiment description file" 
# PARAMETER experiment_type: "Type of experiment" TYPE [chip_seq: ChIP-seq, rna_seq: RNA-seq, mirna_seq: miRNA-seq] DEFAULT rna_seq (Experiment type.)
# PARAMETER alignment_type: "Does your data contain genomic coordinates" TYPE [genome: yes, other: no] DEFAULT other (Does your data table contain genomic coordinates.)
# PARAMETER impute_with: "Impute missing data" TYPE INTEGER FROM 0 TO 1000000 DEFAULT 0 (The value that is used for a sequence read that is not present in a sample.)
# PARAMETER count_column: "Count column" TYPE COLUMN_SEL DEFAULT EMPTY (Data column containing count data)

# MG 21.3.2011, takes as an input a set of files with read counts. Can also take read sequence, genomic location (chr, start, end) and length 
# MG, modified to deal with data that was aligned to other than a genome
# MK 30.04.2013, added ability to leave out genomic location data
# MK 13.05.2013, fix a fatal bug dealing with files having a chr-column

# Sanity check the input data
files <- dir()
files <- files[grep("sample", files)]
number_files <- length(files)
if (number_files < 1) {
	stop("CHIPSTER-NOTE: You need to have at least 1 data file to run this tool!")
}

if (count_column == "EMPTY") {
	stop("CHIPSTER-NOTE: You must define the column containing count data!")
}

# Read in data files
for (count in 1:number_files) {
	assign (paste("data_", count, sep=""), read.table(files[count], header=T, sep="\t")) 
}

# Merge into single data table
# When there are no count data for some samples for a given sequence read impute the number requested by the
# impute_with parameter

# Make a union of all identifiers
identifiers <- data_1[,1]
for (count in 2:number_files) {
	identifiers <- (union (identifiers, get (paste ("data_", count, sep=""))[,1]))
}
identifiers <- as.character(unique(identifiers))

if("chr" %in% colnames(data_1)) {
	identifier_table <- data_1
	#for (count in 2:number_files) {
	#	this.identifier <- identifier_table[,1]
	#}

	for (count in 2:number_files) {
		identifier_table <- rbind(identifier_table, get (paste ("data_", count, sep="")))
	}
	
	identifier_table <- identifier_table[!duplicated(identifier_table[,1]), ]	
	rownames(identifier_table) <- identifier_table[,1]
	if(length(identifiers) != nrow(identifier_table)) { stop("CHIPSTER-NOTE: An error occurred in table matching"); }
}

# Extract chromosome, start, end and length from id if aligned against genome
if (alignment_type == "genome") {
	if(!("chr" %in% colnames(data_1))) {
		extract_info <- strsplit(identifiers, "_")
		extract_info <- unlist(extract_info)
		chr_info <-  extract_info [seq(1,length(extract_info),4)]
		start_info <- extract_info [seq(2,length(extract_info),4)]
		end_info <- extract_info [seq(3,length(extract_info),4)]
		length_info <- as.numeric(end_info)-as.numeric(start_info)+1
		sequence_info <-  extract_info [seq(4,length(extract_info),4)]
	} else {
		chr_col <- grep("^chr$", colnames(identifier_table))
		start_col <- grep("^start$", colnames(identifier_table))
		end_col <- grep("^end$", colnames(identifier_table))
		
		if(length(chr_col) > 0) {
			chr_info <- identifier_table[identifiers, chr_col] 
		}
		if(length(start_col) > 0) {
			start_info <- identifier_table[identifiers, start_col]
		}
		if(length(end_col) > 0) {
			end_info <- identifier_table[identifiers, end_col]
		}
		if(length(start_col) > 0 && length(end_col) > 0) {
			length_info <- as.numeric(identifier_table[identifiers, end_col]) - as.numeric(identifier_table[identifiers, start_col])
		}
		sequence_info <-  rep(NA, length(identifiers))
	}
}

# Create table for all sample counts
annotation_columns <- 5
data_table <- array (dim = c(length(identifiers), number_files+annotation_columns))
data_table <- as.data.frame(data_table)
rownames (data_table) <- identifiers
colnames(data_table) [1:annotation_columns] <- c("chr","start","end","length","sequence")
if (alignment_type == "genome") {
	data_table$chr <- chr_info
	data_table$start <- start_info
	data_table$end <- end_info
	data_table$length <- length_info
	data_table$sequence <- sequence_info
}
if (alignment_type == "other") {
	data_table$chr <- "NA"
	data_table$start <- "NA"
	data_table$end <- "NA"
	data_table$length <- "NA"
	data_table$sequence <- "NA"
}

for (count in 1:number_files) {
	#print(count)
	# Fill in data where there is real data
	indices <- get (paste ("data_", count, sep=""))[,1]
	indices <- as.character(indices)
	#print(indices)
	#print(length(indices))
	if (alignment_type == "genome") {
		data_table[indices, (count+annotation_columns)] <- get (paste ("data_", count, sep=""))[get (paste ("data_", count, sep=""))[,1]==indices, count_column]
	}
	if (alignment_type == "other") {
		data_table[indices, (count+annotation_columns)] <- get (paste ("data_", count, sep=""))[get (paste ("data_", count, sep=""))[,1]==indices, count_column]
	}
	# Impute data where there isn't any
	indices_empty <- setdiff(identifiers, indices)
	#print(indices_empty)
	data_table[indices_empty, (count+annotation_columns)] <- impute_with
	colnames(data_table) [count+annotation_columns] <- paste("chip.", files[count], sep="")
	print (data_table [,count+annotation_columns])
}

# Generates the variables necessary to the phenodata file
# sample<-colnames(dat2)
groups <- c(rep("", number_files))
# Check whether column names contain "chip." and if so, remove from name
samples <- colnames (data_table) [(annotation_columns+1):(annotation_columns+number_files)]
if (length (grep("chip.", samples)) >= 1) {
	samples<-sub("chip.","",samples)
}

# Force identifiers to lower case if miRNA-seq data has been aligned against other than a reference genome
if (experiment_type == "mirna_seq" && alignment_type == "other") {
	rownames (data_table) <- tolower (rownames(data_table))
}

if(alignment_type == "other") {
	drops <- c("chr", "start", "end", "length", "sequence")
	data_table <- data_table[,!(names(data_table) %in% drops)]
}

# Writes out the data and the phenodata table
write.table(data_table, file="ngs-data-table.tsv", sep="\t", row.names=T, col.names=T, quote=F)
write.table(data.frame(sample=samples, chiptype="not applicable", experiment=experiment_type, group=groups, library_size=""), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# EOF

# TOOL samtools-index.R: "Index BAM" (Creates an index for a BAM file. Please rename the index file to have the same name as the BAM file. This tool is based on the SAMtools package.)
# INPUT alignment.bam TYPE GENERIC 
# OUTPUT alignment.bam.bai


# EK 30.10.2011

# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

system(paste(samtools.binary, "index alignment.bam > alignment.bam.bai"))

# TOOL export-tab2mage.R: "Export tab2mage format" (Writes out a text file in tab2mage format. This file is suitable for batch submission to ArrayExpress database. The scripts writes out a blank file, which you need to fill yourself. This file does not necessarily cover all experimental situations, and especially the hybridization section might need modifications. For more information, see tab2mage documentation at http: tab2mage.sourceforge.net docs index.html.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT tab2mage.txt: tab2mage.txt 


# Writes out a blank tab2mage description of the experiment
# JTT 7.8.2007

# Sets the data file name
file<-c("normalized.tsv")

# Reads the files
dat<-read.table(file, header=T, sep="\t", row.names=1)
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")


# Experiment section
write(file="tab2mage.txt", "Experiment section", append=T)
write(file="tab2mage.txt", paste("domain", "ebi.ac.uk", sep="\t"), append=T)
write(file="tab2mage.txt", paste("accession", "", sep="\t"), append=T)
write(file="tab2mage.txt", paste("quality_control", "", sep="\t"), append=T)
write(file="tab2mage.txt", paste("experiment_design_type", "", sep="\t"), append=T)
write(file="tab2mage.txt", paste("name", "", sep="\t"), append=T)
write(file="tab2mage.txt", paste("description", "", sep="\t"), append=T)
write(file="tab2mage.txt", paste("release_date", Sys.Date(), sep="\t"), append=T)
write(file="tab2mage.txt", paste("submission_date", Sys.Date(), sep="\t"), append=T)
write(file="tab2mage.txt", paste("submitter", "", sep="\t"), append=T)
write(file="tab2mage.txt", paste("organization", "", sep="\t"), append=T)
write(file="tab2mage.txt", paste("publication_title", "", sep="\t"), append=T)
write(file="tab2mage.txt", paste("authors", "", sep="\t"), append=T)
write(file="tab2mage.txt", paste("journal", "", sep="\t"), append=T)
write(file="tab2mage.txt", paste("volume", "", sep="\t"), append=T)
write(file="tab2mage.txt", paste("issue", "", sep="\t"), append=T)
write(file="tab2mage.txt", paste("pages", "", sep="\t"), append=T)
write(file="tab2mage.txt", paste("year", "", sep="\t"), append=T)
write(file="tab2mage.txt", paste("pubmed_id", "", sep="\t"), append=T)
write(file="tab2mage.txt", paste("\n"), append=T)

# Protocol section
write(file="tab2mage.txt", "# This section may be deleted, if all the protocols are already described in Arrayexpress", append=T)
write(file="tab2mage.txt", "Protocol section", append=T)
write(file="tab2mage.txt", paste("accession", "text", "name", "parameters", sep="\t"), append=T)
write(file="tab2mage.txt", paste("\n"), append=T)

# Hybridization section
write(file="tab2mage.txt", "Hybridization section", append=T)
write(file="tab2mage.txt", paste("File[raw]", "Array[accession]", "Array[serial]", "Protocol[treatment]", "Protocol[extraction]", "Protocol[labeling]", "Protocol[hybridization]", "Protocol[scanning]", "BioSource", "Sample", "Extract", "LabeledExtract", "Hybridization", "BioSourceMaterial", "SampleMaterial", "ExtractMaterial", "LabeledExtractMaterial", "Dye", "FactorValue[StrainOrLine]", "BioMaterialCharacteristics[Organism]", "BioMaterialCharacteristics[StrainOrLine]", "BioMaterialCharacteristics[Sex]", sep="\t"), append=T)
r<-c("\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t")
for(i in 1:length(phenodata$sample)) {
   write(file="tab2mage.txt", paste(phenodata$sample[i], r, sep=""), append=T)
}

# TOOL promoter-tfbs.R: Weeder (Finds common sequence motifs in the promoters of input genes. Promoter sequences are automatically retrieved from a central database. Currently works only for human, mouse, rat, drosophila, and yeast data.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT seqs.html: seqs.html 
# OUTPUT seqs.txt.wee: seqs.txt.wee 
# PARAMETER species: species TYPE [human: human, mouse: mouse, rat: rat, drosophila: drosophila, yeast: yeast] DEFAULT human ()
# PARAMETER promoter.size: promoter.size TYPE [small: small, medium: medium, large: large] DEFAULT small (Length of upstream sequences)
# PARAMETER strands: strands TYPE [single: single, both: both] DEFAULT single (Analyze both strands of DNA)
# PARAMETER appears.more.than.once: appears.more.than.once TYPE [yes: yes, no: no] DEFAULT no (Could the motif appear more than once in every sequence)
# PARAMETER no.of.motifs: no.of.motifs TYPE INTEGER FROM 1 TO 100 DEFAULT 10 (Number of motifs to return)
# PARAMETER percentage: percentage TYPE INTEGER FROM 1 TO 100 DEFAULT 50 (Percentage of sequences the motif should appear)
# PARAMETER tfsize: tfsize TYPE [small: small, medium: medium] DEFAULT small (Transcription factor binding site size)

# Promoter sequence analysis
# JTT 17.11.2006


# Sets up the path to the promoter sequences
path.seq<-c(file.path(chipster.tools.path, "weeder", "seqs"))

# Sets up the paths to weeder executables
path.weeder.tfbs<-c(file.path(chipster.tools.path, "weeder", "Weeder1.4.2", "weederTFBS.out"))
path.weeder.advicer<-c(file.path(chipster.tools.path, "weeder", "Weeder1.4.2", "adviser.out"))

# Sets up the paths to weeder frequency files
path.weeder.freq<-c(file.path(chipster.tools.path, "weeder", "Weeder1.4.2", "FreqFiles"))

# Renaming variable
size<-promoter.size
once<-appears.more.than.once
no<-no.of.motifs

# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Read phenodata and extracts chip information
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
chip<-phenodata$chiptype[1]

# Creates a variable for environement
if(species=="drosophila") {
   env<-paste(chip, "ACCNUM", sep="")
} else {
   env<-paste(chip, "REFSEQ", sep="")
}
env <- sub( ".db", "", env) # if chip contained ".db", remove it

# Creates a list of genes
genes<-row.names(dat)

# Loads the annotation library
lib<-as.character(chip)

# Account for the fact that annotation packages are from version 2.3 of Bioconductor
# named with an ".db" suffix. Add the suffix when missing to support data files
# from Chipster 1.3 and earlier. 
if (length(grep(".db", lib)) == 0 & length(grep("pmcdf", lib)) == 0) {
        lib <- paste(lib, ".db", sep="")
}

library(package=lib, character.only=T)

# Creating a list of RefSeq IDs for promoter retrieval
refseq<-as.vector(unlist(mget(genes, envir=get(env))))
refseq<-unique(refseq)

# Retrieving promoters
if(species=="human" & size=="small") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36.1_hg18_upstream1000.tsv"), header=T, sep="\t")
}
if(species=="human" & size=="medium") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36.1_hg18_upstream2000.tsv"), header=T, sep="\t")
}
if(species=="human" & size=="large") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36.1_hg18_upstream5000.tsv"), header=T, sep="\t")
}
if(species=="mouse" & size=="small") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36_mm8_upstream1000.tsv"), header=T, sep="\t")
}
if(species=="mouse" & size=="medium") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36_mm8_upstream2000.tsv"), header=T, sep="\t")
}
if(species=="mouse" & size=="large") {
   upstream<-read.table(file.path(path.seq, "UCSC_Build_36_mm8_upstream5000.tsv"), header=T, sep="\t")
}
if(species=="rat" & size=="small") {
   upstream<-read.table(file.path(path.seq, "UCSC_rn4_upstream1000.tsv"), header=T, sep="\t")
}
if(species=="rat" & size=="medium") {
   upstream<-read.table(file.path(path.seq, "UCSC_rn4_upstream2000.tsv"), header=T, sep="\t")
}
if(species=="rat" & size=="large") {
   upstream<-read.table(file.path(path.seq, "UCSC_rn4_upstream5000.tsv"), header=T, sep="\t")
}
if(species=="drosophila" & size=="small") {
   upstream<-read.table(file.path(path.seq, "Drosophila_upstream1000.tsv"), header=T, sep="\t")
}
if(species=="drosophila" & size=="medium") {
   upstream<-read.table(file.path(path.seq, "Drosophila_upstream2000.tsv"), header=T, sep="\t")
}
if(species=="drosophila" & size=="large") {
   upstream<-read.table(file.path(path.seq, "Drosophila_upstream5000.tsv"), header=T, sep="\t")
}
if(species=="yeast" & size=="small") {
   upstream<-read.table(file.path(path.seq, "NCBI_sc_upstream500.tsv"), header=T, sep="\t")
}
if(species=="yeast" & size=="medium") {
   upstream<-read.table(file.path(path.seq, "NCBI_sc_upstream1000.tsv"), header=T, sep="\t")
}
if(species=="yeast" & size=="large") {
   upstream<-read.table(file.path(path.seq, "NCBI_sc_upstream2500.tsv"), header=T, sep="\t")
}

# Weeder needs frequency files - copying those in place
system("mkdir FreqFiles")
if(species=="human") {
   system(paste("ln -s ", file.path(path.weeder.freq, "HS.6.freq"), " ", file.path("FreqFiles", "HS.6.freq"), sep=""))
   system(paste("ln -s ", file.path(path.weeder.freq, "HS.8.freq"), " ", file.path("FreqFiles", "HS.8.freq"), sep=""))
   system(paste("ln -s ", file.path(path.weeder.freq, "HSI.6.freq"), " ", file.path("FreqFiles", "HSI.6.freq"), sep=""))
   system(paste("ln -s ", file.path(path.weeder.freq, "HSI.8.freq"), " ", file.path("FreqFiles", "HSI.8.freq"), sep=""))
}
if(species=="mouse") {
   system(paste("ln -s ", file.path(path.weeder.freq, "MM.6.freq"), " ", file.path("FreqFiles", "MM.6.freq"), sep=""))
   system(paste("ln -s ", file.path(path.weeder.freq, "MM.8.freq"), " ", file.path("FreqFiles", "MM.8.freq"), sep=""))
   system(paste("ln -s ", file.path(path.weeder.freq, "MMI.6.freq"), " ", file.path("FreqFiles", "MMI.6.freq"), sep=""))
   system(paste("ln -s ", file.path(path.weeder.freq, "MMI.8.freq"), " ", file.path("FreqFiles", "MMI.8.freq"), sep=""))
}
if(species=="rat") {
   system(paste("ln -s ", file.path(path.weeder.freq, "RN.6.freq"), " ", file.path("FreqFiles", "RN.6.freq"), sep=""))
   system(paste("ln -s ", file.path(path.weeder.freq, "RN.8.freq"), " ", file.path("FreqFiles", "RN.8.freq"), sep=""))
}
if(species=="drosophila") {
   system(paste("ln -s ", file.path(path.weeder.freq, "DM.6.freq"), " ", file.path("FreqFiles", "RN.6.freq"), sep=""))
   system(paste("ln -s ", file.path(path.weeder.freq, "DM.8.freq"), " ", file.path("FreqFiles", "RN.8.freq"), sep=""))
}
if(species=="yeast") {
   system(paste("ln -s ", file.path(path.weeder.freq, "SC.6.freq"), " ", file.path("FreqFiles", "SC.6.freq"), sep=""))
   system(paste("ln -s ", file.path(path.weeder.freq, "SC.8.freq"), " ", file.path("FreqFiles", "SC.8.freq"), sep=""))
}

# Retrieving the sequences
w<-c()
for(i in 1:length(refseq)) {
   w<-c(w, which(upstream$RefSeq==refseq[i]))
}
unlink("seqs.txt")
for(i in 1:length(w)) {
   write(file="seqs.txt", paste(">", upstream[w[i],]$RefSeq, sep=""), append=T)
   write(file="seqs.txt", paste(upstream[w[i],]$Sequence, sep=""), append=T)
}

# Assembling Weeder arguments
arg<-c()
if(percentage!=50) {
   arg<-paste(arg, " -R ", percentage, sep="")
} else {
   arg<-paste(arg, " -R ", 50, sep="")
}
if(strands=="both") {
   arg<-paste(arg, " -S ", sep="")
}
if(once=="yes") {
   arg<-paste(arg, "-M ", sep="")
}
if(no!=10) {
   arg<-paste(arg, "-T ", no, sep="")
}


# Running Weeder to find tentative TFBSs
if(species=="human" & tfsize=="small") {
   system(paste(path.weeder.tfbs, " -f seqs.txt -O HS -W 6 -e 1", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O HS -W 8 -e 2", arg, sep=""))
   if(strands=="both") {
      system(paste(path.weeder.advicer, "  seqs.txt S",sep=""))
   } else {
      system(paste(path.weeder.advicer, "  seqs.txt",sep=""))
   }
}
if(species=="human" & tfsize=="medium") {
   system(paste(path.weeder.tfbs, " -f seqs.txt -O HS -W 6 -e 1", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O HS -W 8 -e 2", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O HS -W 10 -e 3", arg, sep=""))
   if(strands=="both") {
      system(paste(path.weeder.advicer, "  seqs.txt S",sep=""))
   } else {
      system(paste(path.weeder.advicer, "  seqs.txt",sep=""))
   }
}
if(species=="human" & tfsize=="large") {
   system(paste(path.weeder.tfbs, " -f seqs.txt -O HS -W 12 -e 4", arg, sep=""))
   if(strands=="both") {
      system(paste(path.weeder.advicer, "  seqs.txt S",sep=""))
   } else {
      system(paste(path.weeder.advicer, "  seqs.txt",sep=""))
   }
}
if(species=="human" & tfsize=="extra") {
   system(paste(path.weeder.tfbs, " -f seqs.txt -O HS -W 6 -e 1", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O HS -W 8 -e 3", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O HS -W 10 -e 4", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O HS -W 12 -e 4", arg, sep=""))
   if(strands=="both") {
      system(paste(path.weeder.advicer, "  seqs.txt S",sep=""))
   } else {
      system(paste(path.weeder.advicer, "  seqs.txt",sep=""))
   }
}


if(species=="mouse" & tfsize=="small") {
   system(paste(path.weeder.tfbs, " -f seqs.txt -O MM -W 6 -e 1", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O MM -W 8 -e 2", arg, sep=""))
   if(strands=="both") {
      system(paste(path.weeder.advicer, "  seqs.txt S",sep=""))
   } else {
      system(paste(path.weeder.advicer, "  seqs.txt",sep=""))
   }
}
if(species=="mouse" & tfsize=="medium") {
   system(paste(path.weeder.tfbs, " -f seqs.txt -O MM -W 6 -e 1", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O MM -W 8 -e 2", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O MM -W 10 -e 3", arg, sep=""))
   if(strands=="both") {
      system(paste(path.weeder.advicer, "  seqs.txt S",sep=""))
   } else {
      system(paste(path.weeder.advicer, "  seqs.txt",sep=""))
   }
}
if(species=="mouse" & tfsize=="large") {
   system(paste(path.weeder.tfbs, " -f seqs.txt -O MM -W 12 -e 4", arg, sep=""))
   if(strands=="both") {
      system(paste(path.weeder.advicer, "  seqs.txt S",sep=""))
   } else {
      system(paste(path.weeder.advicer, "  seqs.txt",sep=""))
   }
}
if(species=="mouse" & tfsize=="extra") {
   system(paste(path.weeder.tfbs, " -f seqs.txt -O MM -W 6 -e 1", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O MM -W 8 -e 3", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O MM -W 10 -e 4", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O MM -W 12 -e 4", arg, sep=""))
   if(strands=="both") {
      system(paste(path.weeder.advicer, "  seqs.txt S",sep=""))
   } else {
      system(paste(path.weeder.advicer, "  seqs.txt",sep=""))
   }
}


if(species=="rat" & tfsize=="small") {
   system(paste(path.weeder.tfbs, " -f seqs.txt -O RN -W 6 -e 1", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O RN -W 8 -e 2", arg, sep=""))
   if(strands=="both") {
      system(paste(path.weeder.advicer, "  seqs.txt S",sep=""))
   } else {
      system(paste(path.weeder.advicer, "  seqs.txt",sep=""))
   }
}
if(species=="rat" & tfsize=="medium") {
   system(paste(path.weeder.tfbs, " -f seqs.txt -O RN -W 6 -e 1", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O RN -W 8 -e 2", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O RN -W 10 -e 3", arg, sep=""))
   if(strands=="both") {
      system(paste(path.weeder.advicer, "  seqs.txt S",sep=""))
   } else {
      system(paste(path.weeder.advicer, "  seqs.txt",sep=""))
   }
}
if(species=="rat" & tfsize=="large") {
   system(paste(path.weeder.tfbs, " -f seqs.txt -O RN -W 12 -e 4", arg, sep=""))
   if(strands=="both") {
      system(paste(path.weeder.advicer, "  seqs.txt S",sep=""))
   } else {
      system(paste(path.weeder.advicer, "  seqs.txt",sep=""))
   }
}
if(species=="rat" & tfsize=="extra") {
   system(paste(path.weeder.tfbs, " -f seqs.txt -O RN -W 6 -e 1", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O RN -W 8 -e 3", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O RN -W 10 -e 4", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O RN -W 12 -e 4", arg, sep=""))
   if(strands=="both") {
      system(paste(path.weeder.advicer, "  seqs.txt S",sep=""))
   } else {
      system(paste(path.weeder.advicer, "  seqs.txt",sep=""))
   }
}


if(species=="yeast" & tfsize=="small") {
   system(paste(path.weeder.tfbs, " -f seqs.txt -O SC -W 6 -e 1", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O SC -W 8 -e 2", arg, sep=""))
   if(strands=="both") {
      system(paste(path.weeder.advicer, "  seqs.txt S",sep=""))
   } else {
      system(paste(path.weeder.advicer, "  seqs.txt",sep=""))
   }
}
if(species=="yeast" & tfsize=="medium") {
   system(paste(path.weeder.tfbs, " -f seqs.txt -O SC -W 6 -e 1", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O SC -W 8 -e 2", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O SC -W 10 -e 3", arg, sep=""))
   if(strands=="both") {
      system(paste(path.weeder.advicer, "  seqs.txt S",sep=""))
   } else {
      system(paste(path.weeder.advicer, "  seqs.txt",sep=""))
   }
}
if(species=="yeast" & tfsize=="large") {
   system(paste(path.weeder.tfbs, " -f seqs.txt -O SC -W 12 -e 4", arg, sep=""))
   if(strands=="both") {
      system(paste(path.weeder.advicer, "  seqs.txt S",sep=""))
   } else {
      system(paste(path.weeder.advicer, "  seqs.txt",sep=""))
   }
}
if(species=="yeast" & tfsize=="extra") {
   system(paste(path.weeder.tfbs, " -f seqs.txt -O SC -W 6 -e 1", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O SC -W 8 -e 3", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O SC -W 10 -e 4", arg, sep=""))
   system(paste(path.weeder.tfbs, " -f seqs.txt -O SC -W 12 -e 4", arg, sep=""))
   if(strands=="both") {
      system(paste(path.weeder.advicer, "  seqs.txt S",sep=""))
   } else {
      system(paste(path.weeder.advicer, "  seqs.txt",sep=""))
   }
}

# fix a broken HTML markup
system("sed 's/<\\/body><\\/html>//' seqs.txt.html > seqs.html")

# TOOL filter-iqr.R: "Filter by interquartile range" (Filter genes by their interquartile range.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT iqr-filter.tsv: iqr-filter.tsv 
# PARAMETER iqr.threshold: iqr.threshold TYPE DECIMAL FROM 0 TO 10 DEFAULT 0.5 (Interquartile range)


# JTT, 24.10.2007

# Parameter settings (default) for testing purposes
#iqr.threshold<-c(0.5)

# Renaming variables
iqrt<-iqr.threshold

# Loading the libraries
library(genefilter)

# Loads the normalized data
# This needs a parameter "file" that tells which data file should be loaded.
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]
calls<-data.frame(calls)
dat2<-data.frame(dat2)

# Sanity checks
if(ncol(dat2)==1) {
   stop("You need to have at least two chips to apply filtering by genes!")
}

# Filter

f<-function(x) {
   (IQR(x)>=iqrt)
}
ff<-filterfun(f)
sel<-genefilter(dat2, ff)
set<-dat[sel, ]

# Saving the results
write.table(data.frame(set), file=("iqr-filter.tsv"), sep="\t", row.names=T, col.names=T, quote=F)

# TOOL bwa.R: "BWA for single end reads" (BWA aligns reads to genomes and transcriptomes. Results are sorted and indexed bam files, which are ready for viewing in the Chipster genome browser. 
# Note that this BWA tool uses publicly available genomes. If you would like to align reads against your own datasets, please use the tool \"BWA for single end reads and own genome\".)
# INPUT reads.txt: "Reads to align" TYPE GENERIC 
# OUTPUT bwa.bam 
# OUTPUT bwa.bam.bai 
# OUTPUT bwa.log 
# PARAMETER genome: "Genome or transcriptome" TYPE [hg19.fa: "Human genome (hg19\)", mm10.fa: "Mouse genome (mm10\)", mm9.fa: "Mouse genome (mm9\)", Rattus_norvegicus.Rnor_5.0.70.dna.toplevel.fa: "Rat genome (rn5\)", rn4.fa: "Rat genome (rn4\)", Canis_familiaris.CanFam3.1.71.dna.toplevel.fa: "Dog genome (Ensembl canFam3\)", Gasterosteus_aculeatus.BROADS1.71.dna.toplevel: "Gasterosteus aculeatus genome (BROADS1.71\)",  ovis_aries_texel.fa: "Sheep (oar3.1\)", Sus_scrofa.Sscrofa10.2.69.dna.toplevel.fa: "Pig (10.2\)", athaliana.TAIR10.fa: "A. thaliana genome (TAIR10\)", Arabidopsis_lyrata.v.1.0.16.fa: "A. Lyrata (1.0.16\)", Escherichia_coli_n1.GCA_000303635.1.18.dna.toplevel.fa: "E. coli gemone (GCA_000303635.1.18\)" ] DEFAULT hg19.fa (Genome or transcriptome that you would like to align your reads against.)
# PARAMETER seed.length: "Length of the seed region" TYPE INTEGER DEFAULT 32 (How many bases of the left, good quality part of the read should be used as the seed region. If the seed length is longer than the reads, the seeding will be disabled.) 
# PARAMETER seed.edit: "Maximum number of differences in the seed region" TYPE INTEGER DEFAULT 2 (Maximum number of differences such as mismatches or indels in the seed region.)
# PARAMETER total.edit: "Maximum edit distance for the whole read" TYPE DECIMAL DEFAULT 0.04 ( Maximum edit distance if the value is more than one. If the value is between 1 and 0 then it defines the fraction of missing alignments given 2% uniform base error rate. In the latter case, the maximum edit distance is automatically chosen for different read lengths. Corresponds to the command line parameter -n.)
# PARAMETER quality.format: "Quality value format used" TYPE [solexa1_3: "Illumina GA v1.3-1.5", sanger: Sanger] DEFAULT sanger (Note that this parameter is taken into account only if you chose to apply the mismatch limit to the seed region. Are the quality values in the Sanger format (ASCII characters equal to the Phred quality plus 33\) or in the Illumina Genome Analyzer Pipeline v1.3 or later format (ASCII characters equal to the Phred quality plus 64\)? Please see the manual for details. Corresponds to the command line parameter -I.)
# PARAMETER OPTIONAL num.gaps: "Maximum number of gaps" TYPE INTEGER DEFAULT 1 (Maximum number of gap openings for one read. Corresponds to the command line parameter -o)
# PARAMETER OPTIONAL num.extensions: "Maximum number of gap extensions" TYPE INTEGER DEFAULT -1 (Maximum number of gap extensions, -1 for disabling long gaps. Corresponds to the command line parameter -e)
# PARAMETER OPTIONAL gap.opening: "Gap opening penalty" TYPE INTEGER DEFAULT 11 (Gap opening penalty. Corresponds to the command line parameter -O )
# PARAMETER OPTIONAL gap.extension: "Gap extension penalty" TYPE INTEGER DEFAULT 4 (Gap extension penalty. Corresponds to the command line parameter -E)
# PARAMETER OPTIONAL mismatch.penalty: "Mismatch penalty threshold" TYPE INTEGER DEFAULT 3 (BWA will not search for suboptimal hits with a score lower than the alignment score minus this. Corresponds to the command line parameter -M)
# PARAMETER OPTIONAL disallow.gaps: "Disallow gaps in region"  TYPE INTEGER DEFAULT 16 (Disallow a long deletion within the given number of bp towards the 3\'-end. Corresponds to the command line parameter -d )
# PARAMETER OPTIONAL disallow.indel: "Disallow an indel within the given number of bp towards the ends"  TYPE INTEGER DEFAULT 5 (Do not put an indel within the defined value of bp towards the ends. Corresponds to the command line parameter -i)
# PARAMETER OPTIONAL trim.threshold: "Quality trimming threshold" TYPE INTEGER DEFAULT 0 (Quality threshold for read trimming down to 35bp. Corresponds to the command line parameter -q)
# PARAMETER OPTIONAL barcode.length: "Barcode length"  TYPE INTEGER DEFAULT 0 (Length of barcode starting from the 5 prime-end. The barcode of each read will be trimmed before mapping. Corresponds to the command line parameter -B)
# PARAMETER OPTIONAL alignment.no: "How many valid alignments are reported per read" TYPE  INTEGER DEFAULT 3 (Maximum number of alignments to report. Corresponds to the command line parameter bwa samse -n )

# KM 24.8.2011
# AMS 19.6.2012 Added unzippingcd 

# check out if the file is compressed and if so unzip it
source(file.path(chipster.common.path, "zip-utils.R"))
unzipIfGZipFile("reads.txt")

# bwa
bwa.binary <- file.path(chipster.tools.path, "bwa", "bwa")
bwa.indexes <- file.path(chipster.tools.path, "bwa_indexes")
bwa.genome <- file.path(bwa.indexes, genome)
command.start <- paste("bash -c '", bwa.binary)

# mode specific parameters
if (total.edit >= 1) {
	total.edit <- round(total.edit)
}

quality.parameter <- ifelse(quality.format == "solexa1_3", "-I", "")
mode.parameters <- paste("aln -t 2 -o", num.gaps, "-e", num.extensions, "-d", disallow.gaps, "-i" , disallow.indel , "-l" , seed.length , "-k" , seed.edit , "-O" , gap.opening , "-E" , gap.extension , "-q" , trim.threshold, "-B" , barcode.length , "-M" , mismatch.penalty , "-n" , total.edit , quality.parameter)

# command ending
command.end <- paste(bwa.genome, "reads.txt 1> alignment.sai 2>> bwa.log'")

# run bwa alignment
bwa.command <- paste(command.start, mode.parameters, command.end)

echo.command <- paste("echo '", bwa.binary , mode.parameters, bwa.genome, "reads.txt ' > bwa.log" )
#stop(paste('CHIPSTER-NOTE: ', bwa.command))
system(echo.command)
system(bwa.command)

#system ("pwd")
#system ("ls -l >> bwa.log")
# sai to sam conversion
samse.parameters <- paste("samse -n", alignment.no )
samse.end <- paste(bwa.genome, "alignment.sai reads.txt 1> alignment.sam 2>>bwa.log'" )
samse.command <- paste( command.start, samse.parameters , samse.end )
paste('CHIPSTER-NOTE: ', samse.command)
system(samse.command)

		
# samtools binary
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))

# convert sam to bam
system(paste(samtools.binary, "view -bS alignment.sam -o alignment.bam"))

# sort bam
system(paste(samtools.binary, "sort alignment.bam alignment.sorted"))

# index bam
system(paste(samtools.binary, "index alignment.sorted.bam"))

# rename result files
system("mv alignment.sorted.bam bwa.bam")
system("mv alignment.sorted.bam.bai bwa.bam.bai")

# TOOL qc-agilent-one-color.R: "Agilent 1-color" (Agilent quality control using boxplots, density plots, and MA plots. This tool should be run on normalized data.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT boxplot.png: boxplot.png 
# OUTPUT densityplot.pdf: densityplot.pdf 
# PARAMETER image.width: image.width TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Width of the plotted network image)
# PARAMETER image.height: image.height TYPE INTEGER FROM 200 TO 3200 DEFAULT 600 (Height of the plotted network image)


# Quality control of Agilent chips
# 15.1.2008 JTT
# 19.4.2011, MG, modified legend in histogram

# Loads the libraries
library(limma)

# Renaming variables
w<-image.width
h<-image.height

# Reads in the data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]
A<-dat[,grep("average", names(dat))]

# Producing some basic plots of the data

# Boxplot
bitmap(file="boxplot.png", width=w/72, height=h/72)
boxplot(as.data.frame(dat2), las=2, cex.axis=0.5)
dev.off()

# Density plot
pdf(file="densityplot.pdf", width=w/72, height=h/72)
x<-c()
y<-c()
for(i in 1:ncol(dat2)) {
   x<-cbind(x, density(dat2[,i])$x)
   y<-cbind(y, density(dat2[,i])$y)
}
plot(x[,1], y[,1], col=1, ylim=c(0, max(y)), main="M intensities", type="l", lwd=2, lty=1, xlab = "M", ylab = "Density")
for(i in 2:ncol(dat2)) {
   lines(x[,i], y[,i], col=i, lwd=2, lty=1)
}
legend(legend=colnames(dat2), x="topright", lty=1, cex=0.75, col=c(1:ncol(dat2)))
dev.off()

# TOOL calculate-correlation.R: "Calculate sample correlations" (Calculates correlations between samples.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# OUTPUT cor.tsv: cor.tsv 
# PARAMETER correlation.method: correlation.method TYPE [pearson: pearson, spearman: spearman] DEFAULT pearson (Correlation measure)


# Correlogram
# JTT 18.10.2007

# Parameter settings (default) for testing purposes
#correlation.method<-c("pearson")
 
# Loads the normalized data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Separates expression values and flags
calls<-dat[,grep("flag", names(dat))]
dat2<-dat[,grep("chip", names(dat))]

# Writes a table of correlation values
write.table(as.data.frame(cor(dat2, method=correlation.method)), "cor.tsv", sep="\t", quote=F)

# TOOL mothur-analyses: Mothur-analyses (Analysis tool for metagenomic experiment. Requires both a count table and a phenodata as inputs. Count table is simple tab-delimited text file where rows are samples, and columns are taxa or equivalent.)
# INPUT counttable.tvs: counttable.tsv TYPE GENERIC
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC
# OUTPUT results.pdf: results.pdf
# OUTPUT OPTIONAL stat-results.txt: stat-results.txt
# PARAMETER decostandm: decostandm TYPE [total: total, normalize: normalize, pa: pa, chi.square: chi.square, hellinger: hellinger, log: log]



# JTT 2012-11-06

# Parameters for testing purposes
#setwd("C:\\Users\\tuimaja\\Desktop\\merged")
#decostandm<-"hellinger"

# Read the input data
dat<-read.table("counttable.tsv", header=T, sep="\t", row.names=1)
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
#phenodata$group<-sample(c(1,2), nrow(phenodata), replace=T)

# Some sanity checks
if(all(is.na(phenodata$group))) {
   stop("Specify the biological groups in the group column in the phenodata!")
}
if(any(!as.character(phenodata$group) %in% c("1", "2", "3"))) {
   stop("Biological groups in the group column of the phenodata need to be coded with 1, 2 and 3. Other characters are not allowed.")
}

# Rearrange data
dat2<-dat[phenodata$sample,]
tdat2<-t(dat2)

# Load the libraries
library(vegan)
library(rich)
library(BiodiversityR)
library(pegas)
library(labdsv)

# Open a report PDF
pdf("results.pdf")

# Rarefaction curves
if(length(unique(phenodata$group))==1) {
   plot(specaccum(dat2, method="rarefaction"), ci.type="polygon", ci.col="lightblue", ci.lty=0, lwd=4, col="blue", main="Rarefaction curve(s)")
}
if(length(unique(phenodata$group))==2) {
   r1<-specaccum(dat2[phenodata$group==1,], method="rarefaction")
   r2<-specaccum(dat2[phenodata$group==2,], method="rarefaction")
   plot(r1, ci.type="polygon", ci.col="#ADD8E688", ci.lty=0, lwd=4, col="blue", ylim=c(0, max(r1$richness, r2$richness)+1), xlim=c(0,max(length(r1$richness), length(r2$richness))), main="Rarefaction curve(s)")
   plot(r2, ci.type="polygon", ci.col="#FFB6C188", ci.lty=0, lwd=4, col="red", add=TRUE)
}
if(length(unique(phenodata$group))==3) {
   r1<-specaccum(dat2[phenodata$group==1,], method="rarefaction")
   r2<-specaccum(dat2[phenodata$group==2,], method="rarefaction")
   r3<-specaccum(dat2[phenodata$group==3,], method="rarefaction")
   plot(r1, ci.type="polygon", ci.col="#ADD8E688", ci.lty=0, lwd=4, col="blue", ylim=c(0, max(r1$richness, r2$richness, r3$richness)+1), xlim=c(0,max(length(r1$richness), length(r2$richness), length(r3$richness))), main="Rarefaction curve(s)")
   plot(r2, ci.type="polygon", ci.col="#FFB6C188", ci.lty=0, lwd=4, col="red", add=TRUE)
   plot(r3, ci.type="polygon", ci.col="#90EE9088", ci.lty=0, lwd=4, col="green", add=TRUE)
}
legend(x="bottomright", lwd=4, lty=1, col=c("blue", "red", "green"), legend=c("Group 1","Group 2","Group 3"))


# Rank abundance curves
opar<-par()
par(mfrow=c(2,2))
rankabunplot(rankabundance(dat2), main="Rank - abundance plot, all samples")
ymax<-max(rankabundance(dat2))
if(length(unique(phenodata$group))==2) {
   rankabunplot(rankabundance(dat2[phenodata$group==1,]), main="Rank - abundance plot, group 1", ylim=c(0,ymax))
   rankabunplot(rankabundance(dat2[phenodata$group==2,]), main="Rank - abundance plot, group 2", ylim=c(0,ymax))
}
if(length(unique(phenodata$group))==3) {
   rankabunplot(rankabundance(dat2[phenodata$group==1,]), main="Rank - abundance plot, group 1", ylim=c(0,ymax))
   rankabunplot(rankabundance(dat2[phenodata$group==2,]), main="Rank - abundance plot, group 2", ylim=c(0,ymax))
   rankabunplot(rankabundance(dat2[phenodata$group==3,]), main="Rank - abundance plot, group 3", ylim=c(0,ymax))
}
par(opar)

# RDA plot
dat3<-decostand(dat2, method="hellinger")
group<-phenodata$group
if(length(unique(phenodata$group))==1) {
   rda1<-rda(dat3)
   l<-round(c(rda1$CA$eig/rda1$tot.chi*100)[1:2], digits=2)
   plot(rda1, type="n", scaling=3, main=paste("RDA -", decostandm),  xlab=paste("PCA1 - ", l[1], "%", sep=""), ylab=paste("PCA2 - ", l[2], "%", sep=""))
   #text(rda1, display="bp", lwd=4)
   points(rda1, display="species", pch="+", scaling=3, col="grey75")
   points(rda1, display="sites", scaling=3, pch=16, cex=2, col=ifelse(group==1, "#0066CC", "#CC0000"))
   text(rda1, display="sites", scaling=3, cex=0.5)
   sc<-scores(rda1, choises=c(1,2), display="sp", scaling=3)
}

if(length(unique(phenodata$group))>=2) {
   rda1<-rda(dat3~group, data.frame(group))
   l<-round(c(rda1$CCA$eig/rda1$tot.chi*100, rda1$CA$eig[1]/rda1$tot.chi*100), digits=2)
   plot(rda1, type="n", scaling=3, main=paste("RDA -", decostandm),  xlab=paste("RDA1 - ", l[1], "%", sep=""), ylab=paste("PC1 - ", l[2], "%", sep=""))
   text(rda1, display="bp", lwd=4)
   points(rda1, display="species", pch="+", scaling=3, col="grey75")
   points(rda1, display="sites", scaling=3, pch=16, cex=2, col=ifelse(group==1, "#0066CC", "#CC0000"))
   text(rda1, display="sites", scaling=3, cex=0.5)
   sc<-scores(rda1, choises=c(1,2), display="sp", scaling=3)
   legend(x="topright", bty="n", legend=paste("p-value for group = ", round(anova(rda1, by="margin")$'Pr(>F)'[1], digits=3), sep=""))
}

# Close the report PDF
dev.off()


# Statistical test will only be run, if there are two or three groups
if(length(unique(phenodata$group))>=2) {
   group<-phenodata$group

   res1<-contribdiv(t(dat2))

   dd<-dist(dat3)
   res2<-adonis(dd~group, permutations=9999)
   res3<-amova(dd~group, nperm=9999)
   res4<-anova(betadisper(dd, group))

   ind<-indval(dat2, group, numitr=9999)
   isa<-isamic(dat2, group)

   sink("stat-results.txt")
      cat("\n\n\n")
      cat("######################################\n")
      cat("### CONTRIBUTED DIVERSITY ANALYSIS ###\n")
      cat("######################################\n")
      cat("\n\n\n")
      print(res1)
      cat("\n\n\n")
      cat("###############################################################################\n")
      cat("### Permutational Multivariate Analysis of Variance Using Distance Matrices ###\n")
      cat("###############################################################################\n")
      cat("\n\n\n")
      print(res2)
      cat("\n\n\n")
      cat("######################################\n")
      cat("### Analysis of Molecular Variance ###\n")
      cat("######################################\n")
      cat("\n\n\n")
      print(res3)
      cat("\n\n\n")
      cat("##################################################################\n")
      cat("### Multivariate homogeneity of groups dispersions (variances) ###\n")
      cat("##################################################################\n")
      cat("\n\n\n")
      print(res4)
      cat("\n\n\n")
      cat("###################################################\n")
      cat("### Dufrene-Legendre Indicator Species Analysis ###\n")
      cat("###################################################\n")
      cat("\n\n\n")
      print(ind)
      cat("\n\n\n")
      cat("######################################################################\n")
      cat("### Indicator Species Analysis Minimizing Intermediate Occurrences ###\n")
      cat("######################################################################\n")
      cat("\n\n\n")
      print(isa)
   sink()
}

# TOOL norm-agilent-miRNA.R: "Agilent miRNA" (Agilent miRNA chip data preprocessing. Automatically averages all the rows,
# i.e., miRNA:s that have the same name. YOU HAVE TO SPECIFY THE CHIPTYPE.
# To be able to remove the control probes, the column labelled "ControlType" in the raw data file should be marked as
# "Annotation" during importing.)
# INPUT microarray{…}.tsv: "Raw data files" TYPE CDNA
# OUTPUT normalized.tsv: "Normalized data"
# OUTPUT phenodata.tsv: "Experiment description"
# PARAMETER background.treatment: "Background treatment" TYPE [none, subtract, edwards, normexp] DEFAULT normexp (Background treatment method)
# PARAMETER background.offset: "Background offset" TYPE [0, 50] DEFAULT 50 (Background offset)
# PARAMETER normalize.chips: "Normalize chips" TYPE [none, scale, scale-75, quantile, vsn] DEFAULT quantile (Between arrays normalization method)
# PARAMETER remove.control.probes: "Remove control probes" TYPE [yes, no] DEFAULT no (Remove control probes from the dataset)
# PARAMETER chiptype: "Chiptype" TYPE [empty, "Human-miRNA (v1)", "Human-miRNA (v2)", "Human-miRNA (v3)", "Mouse-miRNA (v1)", "Mouse-miRNA (v2)", "Rat-miRNA"]  DEFAULT empty (Chiptype)

# Agilent miRNA chip normalization
# MG 
# 21.10.2010


# Loads the libraries
library(limma)

# Renaming variables
bg<-background.treatment
normba<-normalize.chips

# Reading data
columns<-list(R="sample", Rb="samplebg", G="sample", Gb="samplebg")
annotation<-c("identifier")
columns.other<-c("flag", "annotation")

files<-dir()
files<-files[files!="phenodata.tsv"]
dat<-read.maimages(files=files, columns=columns, annotation=annotation, other.columns=columns.other) 

# Background correction
dat2<-backgroundCorrect(dat, bg, offset=as.numeric(background.offset))

# Normalization across arrays
if(normba=="scale-75") {
   dat3<-normalizeBetweenArrays(dat2$R, method="none")
   normfact<-apply(dat3, 2, quantile)["75%",]
   for(i in 1:ncol(dat3)) {
      dat3[,i]<-dat3[,i]/normfact[i]
   }
} else {
   dat3<-normalizeBetweenArrays(dat2$R, method=normba)
}

# Log-transforming the data
dat3<-log2(dat3)

# Writes out a phenodata table
sample<-paste(colnames(dat3), ".tsv", sep="")
group<-c(rep("", length(sample)))
training<-c(rep("", length(sample)))
time<-c(rep("", length(sample)))
random<-c(rep("", length(sample)))
if(chiptype=="empty") {
   chiptype<-c("cDNA")
}

# Annotation package name conversions}
if(chiptype=="Human-miRNA(v1)") {
	chiptype<-c("miRNA")
}
if(chiptype=="Human-miRNA(v2)") {
	chiptype<-c("miRNA")
}
if(chiptype=="Human-miRNA(v3)") {
	chiptype<-c("miRNA")
}
if(chiptype=="Mouse-miRNA(v1)") {
	chiptype<-c("miRNA")
}
if(chiptype=="Mouse-miRNA(v2)") {
	chiptype<-c("miRNA")
}
if(chiptype=="Rat-miRNA(v1)") {
	chiptype<-c("miRNA")
}
write.table(data.frame(sample=sample, chiptype=chiptype, group=group), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# Removes control probes
rownames(dat3)<-dat$genes$identifier
if(remove.control.probes=="yes") {
   if(is.null(dim(dat$other$annotation))==FALSE) {
      dat3<-dat3[rowSums(dat$other$annotation)==0,]
   }
}

# Constructs and writes out a table
M<-dat3
M<-aggregate(M, list(rownames(M)), mean)
rownames(M)<-M$Group.1
genes<-rownames(M)
M<-M[,-1]
if(length(dat$other$flag)!=0) {
   flags<-as.data.frame(dat$other$flag)
   names(flags)<-paste("flag.", names(flags), sep="")
}
if(length(dat$other$flag)==0) {
   flags<-matrix(nrow=0, ncol=0)
}
names(M)<-paste("chip.", names(M), sep="")
names(M)<-paste(names(M), ".tsv", sep="")
M<-data.frame(M)
rownames(M)<-genes

if(chiptype=="cDNA") {
   if(nrow(flags)!=nrow(M)) {
      write.table(data.frame(round(M, digits=2)), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
   } else {
     write.table(data.frame(round(M, digits=2), flags), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
   }
}

if(chiptype=="miRNA") {
	if(nrow(flags)!=nrow(M)) {
		write.table(data.frame(round(M, digits=2)), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
	} else {
		write.table(data.frame(round(M, digits=2), flags), file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)
	}
}

# TOOL ngs-find-peaks-fseq.R: "Find broad peaks using F-seq" (This tool will search for statistically significantly enriched broad peaks, such as regions of open chromatin or transcription factor / histone binding sites, in sequencing data. Peaks are identified by smoothing read count data to a continuous sequence density estimation-based probabilites that are directly proportional to the probability of seeing a sequence read at that location.) 
# INPUT alignment.txt: "Read file" TYPE GENERIC 
# OUTPUT peaks.bed: "True enriched peaks in a format compatible with the Genome Browser"
# PARAMETER file.format: "File format" TYPE [ELAND, SAM, BAM, BED] DEFAULT BAM (The format of the input files.)
# PARAMETER score.threshold: "Score cutoff" TYPE DECIMAL FROM 0 TO 100 DEFAULT 4 (The cutoff for statistical significance. Larger values reduce the false discovery rate and produce shorter peaks lists.)
# PARAMETER fragment.size: "Fragment size" TYPE INTEGER FROM -1 TO 8000 DEFAULT -1 (Fragment size of the sequencing library. Set to -1, if your data contains more than 50000 mappable reads, in which case the fragment size is inferred from data.)
# PARAMETER feature.size: "Feature length" TYPE INTEGER FROM 0 TO 8000 DEFAULT 800 (The estimated feature length. The parameter controls the smoothness of the kernel density estimates. Larger values will lead to smoother kernel density estimation. In the case of DNase-seq, set this parameter to 0.)
# PARAMETER extend.reads: "Extend alignments" TYPE INTEGER FROM 0 TO 8000 DEFAULT 0 (Artificially extend each mapped read to a desired length, typically to the mean fragment length.)

######################################################
#                                                    #
# MK, 20.3.2012                                      #
#                                                    #
# F-seq is a tool to find broad peaks from pre-      #
# aligned SAM/BAM/ELAND files. The analysis needs to #
# be done for each file separately. Peaks are        #
# typically binned into categories representing      #
# exons (first, last all), introns, TSS, promoters,  #
# intergenic. Motifs can be searched from them also  #
#                                                    #
######################################################

#Export2sam.pl is a part of samtools and is used to convert ELAND outputs to SAM
eland_to_sam.binary <- c(file.path(chipster.tools.path, "samtools-0.1.18", "misc", "export2sam.pl"))
#samtools is used to convert SAM to BAM
samtools.binary <- c(file.path(chipster.tools.path, "samtools", "samtools"))
#bedtools is used to convert BAM to BED
bam_to_bed.binary <- c(file.path(chipster.tools.path, "bedtools", "bin", "bamToBed"))
#In-house perl script to extend reads from 5'
read_ex.binary <- c(file.path(chipster.tools.path, "fseq", "bin", "read_extend_bed.pm"))
#Binary file for F-seq which is used to call peaks
fseq.binary <- c(file.path(chipster.tools.path, "fseq", "bin", "fseq"))

#File conversions ending to BED
input.file <- "alignment.txt";
if(file.format == "ELAND") {
	system(paste(eland_to_sam.binary, "--read1=", input.file," > alignment.sam"))
	file.format <- "SAM"
	input.file  <- "alignment.sam"
}

if (file.format == "SAM") {
	system(paste(samtools.binary, "view -bS", input.file," -o alignmentUnsorted.bam"))
	system(paste(samtools.binary, "sort alignmentUnsorted.bam alignment"))
	file.format <- "BAM"
	input.file <- "alignment.bam"
} 	

if (file.format == "BAM") {
	system(paste(bam_to_bed.binary, "-i ", input.file, ">alignment.bed"))
	input.file <- "alignment.bed"
} 

#In some articles, reads have been artifically extended to full fragment length. 
if (extend.reads > 0) {
	system(paste(read_ex.binary, " ",  input.file, " ", extend.reads, ">alignment.extend.bed"))
	input.file <- "alignment.extend.bed"
	#system(paste("cp -r ", getwd(), "/tmp/xxx/."))
}

#Count number of aligned reads from the BED-file
data <- read.table(file=input.file, sep="\t");
nread <- ncol(data);

#Output of F-seq is printed to a folder that must exists before F-seq is executed
dir.create("alignment_fseq")

#Execution of F-seq. Human data could benefit from background files that filter off uncertain areas. 
#However, no script exists for creating background files at the moment. Default background files may be suboptimal
if(fragment.size == -1) {
	if(nread < 50000) { stop("CHIPSTER-NOTE: F-seq needs at least 50000 aligned reads for fragment size estimation")  }
	system(paste(fseq.binary, "-l", feature.size," -t ", score.threshold," -of bed -o alignment_fseq", input.file));	
} else {
	system(paste(fseq.binary, "-f", fragment.size," -l", feature.size," -t ", score.threshold," -of bed -o alignment_fseq", input.file));	
}

#Output of F-seq is a bunch of files stored in folder -o. 
files 	<- list.files(path="alignment_fseq", pattern=".bed")
data 	<- NULL;
for(i in 1:length(files)) {
	chr_file <- files[i];
	chr_data <- read.table(paste("alignment_fseq/",chr_file, sep=""), sep="\t")
	data <- rbind(data, chr_data)
}
colnames(data) <- c("chr", "start", "end", "ID", "score")
rownames(data) <- data[,4]

#Sorting the BED
source(file.path(chipster.common.path, "bed-utils.R"))
if (nrow(data) > 1){	
	data <- sort.bed(data)
}
write.table(data, file="peaks.bed", sep="\t", row.names=F, col.names=F, quote=F)

# TOOL extract-genes-from-kegg.R: "Extract genes from KEGG pathway" (Fetches the genes that belong to a given KEGG pathway, defined either by ID or description.)
# INPUT normalized.tsv: normalized.tsv TYPE GENE_EXPRS 
# INPUT META phenodata.tsv: phenodata.tsv TYPE GENERIC 
# OUTPUT extracted-from-KEGG.tsv: extracted-from-KEGG.tsv 
# PARAMETER match.term: match.term TYPE STRING DEFAULT empty (The identifier for the KEGG pathway to extract genes from.)

# Extract the rows from a table that contain probes that map genes annotated
# to a given KEGG pathway
#
# MG 26.11.2010

# Parameter settings (default) for testing purposes
#match.term<-"04210"

# Reads the chiptype from phenodata table
phenodata<-read.table("phenodata.tsv", header=T, sep="\t")
if(phenodata$chiptype[1]!="cDNA" | phenodata$chiptype[1]!="Illumina") {
	# Saves the chiptype into object lib
	lib<-phenodata$chiptype[1]
	lib<-as.character(lib)
}

# Account for the fact that annotation packages are from version 2.3 of Bioconductor
# named with an ".db" suffix. Add the suffix when missing to support data files
# from Chipster 1.3 and earlier. 
if (length(grep(".db", lib)) == 0 & length(grep("pmcdf", lib)) == 0) {
	lib <- paste(lib, ".db", sep="")
}

# Loads the correct annotation library
lib2<-sub('.db','',lib)
library(package=lib, character.only=T)

# Loads the data
file<-c("normalized.tsv")
dat<-read.table(file, header=T, sep="\t", row.names=1)

# Extract the mapping info
lib3 <- paste(lib2, "PATH2PROBE", sep="")
env <- get(lib3)
kegg.2.probes <- as.list(env) 

# Extract all probes belonging to query
probes.list <- kegg.2.probes[match.term]
probes.kegg <- unlist(probes.list)

# Extract probes in query list
probes.query <- rownames(dat)

# Extract common probes
match.indices <- match (probes.kegg, probes.query, nomatch=0)
match.indices <- unique (match.indices[match.indices>0])

# Extract data
dat2 <- dat[match.indices,]

# Writing out the extracted data
write.table(dat2, file="extracted-from-KEGG.tsv", sep="\t", row.names=T, col.names=T, quote=F)

# EOF

# TOOL norm-illumina-SNP.R: "Illumina SNP arrays" (Illumina SNP array preprocessing. Input should be a tab-delimited text file with genotype calls. Typically such a file is created using GenCall software from Illumina.)
# INPUT chip.txt: chip.txt TYPE GENERIC 
# OUTPUT normalized.tsv: normalized.tsv 
# OUTPUT META phenodata.tsv: phenodata.tsv 
# PARAMETER method: "Allel calling method" TYPE [illumina: illumina, crlmm: CRLMM] DEFAULT illumina (Allel calling method. Choosing Illumina, allels calls given in the input are accepted. For CRLMM, columns X Raw and Y Raw should be available in the file)
# PARAMETER cdfName: cdfName TYPE [default: default, human1mduov3b: human1mduov3b, human1mv1c: human1mv1c, human370quadv3c: human370quadv3c, human370v1c: human370v1c, human550v3b: human550v3b, human610quadv1b: human610quadv1b, human650v3a: human650v3a, human660quadv1a: human660quadv1a, humanomni1quadv1b: humanomni1quadv1b, humanomniexpress12v1b: humanomniexpress12v1b] DEFAULT default (Name of the description file to be used in normalization, by defualt obtained from data)
# PARAMETER SNRMin: "Signal-to-noise ratio" TYPE DECIMAL FROM 0 TO 10000 DEFAULT 5 (Value defining the minimum signal-to-noise ratio used to filter out samples, higher values mean more strict filtering. Affects only the CRLMM-function)

# Illumina SNP array normalization
# JTT 22.10.2008
# MK 21.05.2013 added crlmm normalization

# Reading data
if(method = "illumina") {
	#allel calls
	firstfield <- scan(dir(), what = "", sep = ",", flush = TRUE, quiet = TRUE, blank.lines.skip = FALSE, multi.line = FALSE)
	skip <- grep("[Data]", firstfield, fixed = TRUE)
	samples <- read.table(dir(), skip = skip, header = TRUE, sep = "\t", as.is = TRUE, check.names = FALSE, colClasses = "character")

	# Transforming the data to a wide data frame
	ids<- unique(samples$"Sample ID")
	dat2<-matrix(nrow=nrow(samples)/length(ids), ncol=length(ids), data=NA)
	for(i in 1:length(ids)) {
   		cursam<-samples[samples$"Sample ID"==ids[i],]
   		dat2[,i]<-as.numeric(as.factor(paste(cursam$"Allele1 - Top", cursam$"Allele2 - Top", sep="")))
	}
	dat2<-data.frame(dat2)
	rownames(dat2)<-cursam$"SNP Name"
	colnames(dat2)<-paste("chip.", ids, sep="")
} else {	
	library(crlmm)
	library(oligoClasses)
	library(human1mduov3bCrlmm)          #Illumina
	library(human1mv1cCrlmm)             #Illumina
	library(human370quadv3cCrlmm)        #Illumina
	library(human370v1cCrlmm)            #Illumina
	library(human550v3bCrlmm)            #Illumina
	library(human610quadv1bCrlmm)        #Illumina
	library(human650v3aCrlmm)            #Illumina
	library(human660quadv1aCrlmm)        #Illumina
	library(humanomni1quadv1bCrlmm)      #Illumina
	library(humanomniexpress12v1bCrlmm)  #Illumina
	
	if(cdfName == "default") {
		XY = readGenCallOutput(file="chip.txt", colnames=list("SampleID"="Sample ID", "SNPID"="SNP Name", "XRaw"="X Raw", "YRaw"="Y Raw"), type=list("SampleID"="character", "SNPID"="character", "XRaw"="integer", "YRaw"="integer"))
		crlmmOut <- try(crlmm::crlmmIllumina(XY=XY, verbose=FALSE, SNRMin=SNRMin))
	} else {
		XY = readGenCallOutput(file="chip.txt", cdfName=cdfName, colnames=list("SampleID"="Sample ID", "SNPID"="SNP Name", "XRaw"="X Raw", "YRaw"="Y Raw"), type=list("SampleID"="character", "SNPID"="character", "XRaw"="integer", "YRaw"="integer"))
		crlmmOut <- try(crlmm::crlmmIllumina(XY=XY, verbose=FALSE, cdfName=cdfName, SNRMin=SNRMin))
	}
	
	#Below commands allow to run crlmm on idat (scanner output) data 
	#samples <- read.csv("../idat/sampleSheet.csv", as.is=TRUE)			
	#readIdatFiles -method provide functionality to read idat files 
	#RG <- readIdatFiles(sampleSheet=samples, path= "../idat", arrayInfoColNames=list(barcode="SentrixBarcode_A", position="SentrixPosition_A"), fileExt=list(green="Grn.idat", red="Red.idat"))
	#crlmmOut <- try(crlmm::crlmmIllumina(RG=RG, verbose=FALSE, cdfName=cdfName, SNRMin=SNRMin))
				
	if(class(crlmmOut)=="try-error") {
		if(length(grep("No arrays above quality", crlmmOut[1])) > 0) {
			stop("CHIPSTER-NOTE: No arrays above quality threshold. Please try a lower signal-to-noise ratio parameter");
		} else {
			stop("CHIPSTER-NOTE: An unexpected error has occurred. Please contact Chipster support")
		}
	}
	
	genotypes<-calls(crlmmOut)
	flags<-callProbability(crlmmOut)
	flags2<-flags
	flags2[flags<=quantile(flags, 0.95)]<-"P"
	flags2[flags>quantile(flags, 0.95)]<-"M"
	colnames(genotypes)<-paste("chip.", colnames(genotypes), sep="")
	colnames(flags2)<-paste("flags.", colnames(flags), sep="")
	
	dat2 <- data.frame(genotypes, flags2)
}

# Writes out a phenodata table
chiptype<-"Illumina"
sample<-colnames(dat2)
group<-c(rep("", ncol(dat2)))
training<-c(rep("", ncol(dat2)))
time<-c(rep("", ncol(dat2)))
random<-c(rep("", ncol(dat2)))
write.table(data.frame(sample=sample, chiptype=chiptype, group=group, training=training), file="phenodata.tsv", sep="\t", row.names=F, col.names=T, quote=F)

# Writing data to disk
write.table(dat2, file="normalized.tsv", col.names=T, quote=F, sep="\t", row.names=T)

#!/bin/sh

INSTALL_SCRIPT="shared/lib/install.R"
R_PARAMS="--vanilla"
DEFAULT_R_COMMAND="R"
R_VERSION="2.6.1"

echo "Chipster R package installer"
echo
echo "No changes are written before you verify them"
echo

# CHECK

echo "Before proceeding you must have:"
echo "  1) R version $R_VERSION installed" 
echo "  2) permissions for installing R packages (usually you have to be root)"
echo "Are these conditions met [yes/no]?"
read answer

if [ "$answer" != "yes" ]; then
    echo "User decided to abort, no changes made"
    exit
fi

# GATHER INFO

echo "Please specify R command [R]: "
read command

command=${command## } # trim (remove leading white space)
command=${command%% } # trim (remove trailing white space)
if [ "$command" = "" ]; then
    command=$DEFAULT_R_COMMAND
fi
echo


# VERIFY CHANGES

echo "Using R command \"$command\""
echo "Using the following install script ($INSTALL_SCRIPT):"
cat $INSTALL_SCRIPT
echo 

echo "Please verify the install script. Should the script be run [yes/no]?"
read answer

if [ "$answer" != "yes" ]; then
    echo "User decided to abort, no changes made"
    exit
fi
       

# MAKE CHANGES

cat $INSTALL_SCRIPT | $command $R_PARAMS
echo "All changes successfully made!"

@echo off
setlocal

rem Copyright (c) 1999, 2009 Tanuki Software, Ltd.
rem http://www.tanukisoftware.com
rem All rights reserved.
rem
rem This software is the proprietary information of Tanuki Software.
rem You shall use it only in accordance with the terms of the
rem license agreement you entered into with Tanuki Software.
rem http://wrapper.tanukisoftware.org/doc/english/licenseOverview.html
rem
rem Java Service Wrapper general startup script.
rem Optimized for use with version 3.3.3 of the Wrapper.
rem

rem
rem Resolve the real path of the wrapper.exe
rem  For non NT systems, the _REALPATH and _WRAPPER_CONF values
rem  can be hard-coded below and the following test removed.
rem
if "%OS%"=="Windows_NT" goto nt
echo This script only works with NT-based versions of Windows.
goto :eof

:nt
rem
rem Find the application home.
rem
rem %~dp0 is location of current script under NT
set _REALPATH=%~dp0

rem Decide on the wrapper binary.
set _WRAPPER_BASE=wrapper
set _WRAPPER_EXE=%_REALPATH%%_WRAPPER_BASE%-windows-x86-32.exe
if exist "%_WRAPPER_EXE%" goto conf
set _WRAPPER_EXE=%_REALPATH%%_WRAPPER_BASE%-windows-x86-64.exe
if exist "%_WRAPPER_EXE%" goto conf
set _WRAPPER_EXE=%_REALPATH%%_WRAPPER_BASE%.exe
if exist "%_WRAPPER_EXE%" goto conf
echo Unable to locate a Wrapper executable using any of the following names:
echo %_REALPATH%%_WRAPPER_BASE%-windows-x86-32.exe
echo %_REALPATH%%_WRAPPER_BASE%-windows-x86-64.exe
echo %_REALPATH%%_WRAPPER_BASE%.exe
pause
goto :eof

rem
rem Find the wrapper.conf
rem
:conf
set _WRAPPER_CONF="%~f1"
if not %_WRAPPER_CONF%=="" goto startup
set _WRAPPER_CONF="%_REALPATH%..\..\conf\wrapper.conf"

rem
rem Start the Wrapper
rem
:startup
"%_WRAPPER_EXE%" -c %_WRAPPER_CONF%
if not errorlevel 1 goto :eof
pause

#!/bin/bash 
#
#Automatic index cheking and indexing toold for bwa indexes
#NOTE! Does not do color space indexes
#K.M. 12.1. 2012

bwa_path=("/opt/chipster/tools/bwa")


if [ -d "/scratch/tmp" ]; then
   mkdir -p "/scratch/tmp/bwa_indexes/tmp"
   index_path=("/scratch/tmp/bwa_indexes/tmp")
else
   index_path=("./")
fi

genome=($1)
size=(`ls -l $genome | awk '{print $5}' `)
checksum=(`md5sum $genome | awk '{print $1}'`)
location=(`pwd`)

if [ ! -d $index_path/genome_0 ]; then
  mkdir $index_path/genome_0
fi


#look for matching size and md5sum
genome_dir=(`grep -h $size $index_path/genome_*/size_and_md5 | grep $checksum | awk '{print $1}' | tail -1`)


#
if [ ! $genome_dir == "" ]; then
   echo "Pre-indexed genome found"
else
   echo "Calculating indexes"
   cd $index_path
   genome_dir=(`ls -d genome_* | awk -F "_" '{ print $NF }' | sort -n | tail -1 | awk '{ a = ( $1 + 1 ) }{print "genome_"a}'`)
   mkdir $genome_dir
   cd $genome_dir
   cp "$location"/"$genome" ./$genome
  
   size_mb=(` expr $size / 1000000 ` )     
   #Choose the indextype based on the genome size
   if [ $size_mb -gt 2000 ] 
   then
     indextype=("bwtsw")
   else
     indextype=("is")
   fi
   $bwa_path/bwa index -a $indextype $genome 
   
   #check that idexes are found
   for f in ann amb bwt pac sa ; do
       echo "$genome.$f"
       if [ -e "$genome"."$f" ]; then
         echo "$genome.$f OK"
       else
         echo "Indexing failed"
         echo "Index file $genome.$f not found"
         exit 1
       fi
   done
   echo "$genome_dir $size $checksum" > size_and_md5
   cd $location
fi

echo "The bwa_indexes are in directory:"
echo "$index_path/$genome_dir"
exit 

#!/bin/bash

# Bootstrap script for updating Chipster installation.
# Updates between minor versions, always to latest (e.g. 2.0.1 -> 2.0.4, if 2.0.4 was latest 2.0.x).
# This script only downloads the actual update script, allowing the update mechanism to be updated also.
 

# Update file web location and name
UPDATE_URL_PREFIX=http://www.nic.funet.fi/pub/sci/molbio/chipster/dist/virtual_machines/updates
MAIN_UPDATE_FILE=update-exec.sh

# Figure out Chipster major version and corresponding URL
CHIPSTER_VERSION=`ls -1 shared/lib | grep ^chipster-[0-9\\.]*.jar | gawk 'match($0, "chipster-([0-9\\\\.]*).jar", g) {print g[1]}'`
CHIPSTER_MAJOR_VERSION=`echo $CHIPSTER_VERSION | gawk 'match($0, "([0-9]*.[0-9]*).[0-9]*", g) {print g[1]}'`
MAIN_UPDATE_FILE_URL=$UPDATE_URL_PREFIX/$CHIPSTER_MAJOR_VERSION/$MAIN_UPDATE_FILE

# Remove old update file, if exists
if [ -e $MAIN_UPDATE_FILE ]; then
rm $MAIN_UPDATE_FILE
fi

# Download latest update file
wget -q $MAIN_UPDATE_FILE_URL

# Check if download was ok
if [ -e $MAIN_UPDATE_FILE ]; then

	# Run update
	chmod u+x $MAIN_UPDATE_FILE
	./$MAIN_UPDATE_FILE
	
	# Clean up
	rm $MAIN_UPDATE_FILE
	
	exit 0

else

	echo Failed to download latest update file from $MAIN_UPDATE_FILE_URL
	exit 1
fi

#!/bin/bash                                                                                                     
if [ "$#" -eq 0 ]
then
    java -jar shared/lib/chipster-config-tool.jar configure
elif [ "$#" -eq 1 ]
then
    if [ "$1" = "auto" ]
    then
        java -jar shared/lib/chipster-config-tool.jar auto-configure
    else
        java -jar shared/lib/chipster-config-tool.jar simple-configure $1
    fi
else
    echo "Usage: ./configure.sh <hostname or address> | auto"
fi

@echo off
setlocal

rem Copyright (c) 1999, 2009 Tanuki Software, Ltd.
rem http://www.tanukisoftware.com
rem All rights reserved.
rem
rem This software is the proprietary information of Tanuki Software.
rem You shall use it only in accordance with the terms of the
rem license agreement you entered into with Tanuki Software.
rem http://wrapper.tanukisoftware.org/doc/english/licenseOverview.html
rem
rem Java Service Wrapper command based script.
rem Optimized for use with version 3.3.3 of the Wrapper.
rem

if "%OS%"=="Windows_NT" goto nt
echo This script only works with NT-based versions of Windows.
goto :eof

:nt
rem
rem Find the application home.
rem
rem %~dp0 is location of current script under NT
set _REALPATH=%~dp0

rem Decide on the wrapper binary.
set _WRAPPER_BASE=wrapper
set _WRAPPER_EXE=%_REALPATH%%_WRAPPER_BASE%-windows-x86-32.exe
if exist "%_WRAPPER_EXE%" goto validate
set _WRAPPER_EXE=%_REALPATH%%_WRAPPER_BASE%-windows-x86-64.exe
if exist "%_WRAPPER_EXE%" goto validate
set _WRAPPER_EXE=%_REALPATH%%_WRAPPER_BASE%.exe
if exist "%_WRAPPER_EXE%" goto validate
echo Unable to locate a Wrapper executable using any of the following names:
echo %_REALPATH%%_WRAPPER_BASE%-windows-x86-32.exe
echo %_REALPATH%%_WRAPPER_BASE%-windows-x86-64.exe
echo %_REALPATH%%_WRAPPER_BASE%.exe
pause
goto :eof

:validate
rem Find the requested command.
for /F %%v in ('echo %1^|findstr "^console$ ^start$ ^pause$ ^resume$ ^stop$ ^restart$ ^install$ ^remove"') do call :exec set COMMAND=%%v

if "%COMMAND%" == "" (
    echo Usage: %0 { console : start : pause : resume : stop : restart : install : remove }
    pause
    goto :eof
) else (
    shift
)

rem
rem Find the wrapper.conf
rem
set _WRAPPER_CONF="%_REALPATH%..\..\conf\wrapper.conf"

rem
rem Run the application.
rem At runtime, the current directory will be that of wrapper.exe
rem
call :%COMMAND%
if errorlevel 1 pause
goto :eof

:console
"%_WRAPPER_EXE%" -c %_WRAPPER_CONF%
goto :eof

:start
"%_WRAPPER_EXE%" -t %_WRAPPER_CONF%
goto :eof

:pause
"%_WRAPPER_EXE%" -a %_WRAPPER_CONF%
goto :eof

:resume
"%_WRAPPER_EXE%" -e %_WRAPPER_CONF%
goto :eof

:stop
"%_WRAPPER_EXE%" -p %_WRAPPER_CONF%
goto :eof

:install
"%_WRAPPER_EXE%" -i %_WRAPPER_CONF%
goto :eof

:remove
"%_WRAPPER_EXE%" -r %_WRAPPER_CONF%
goto :eof

:restart
call :stop
call :start
goto :eof

:exec
%*
goto :eof

#!/bin/bash 

chipster_path="0"
export PATH=${PATH}:/opt/chipster4/comp/modules/admin/shell/:/opt/chipster/tools/emboss/bin/

ensembl=0
fasta=0
gtf=0
text=0
length=0
version="0.0"
location=$(pwd)
INDEX_BWA=1
INDEX_BOWTIE=1
INDEX_BOWTIE2=1


while [[ $# -ge 1 ]]
do
  case "$1" in
              '-chipster_path')
	      chipster_path="$2"
                shift
                shift
              ;;
              #
              '-species')
                species="$2"
                ensembl=0
                shift 
                shift 
              ;;
              '-fasta')
                genome_fasta="$2"
                fasta=1
                shift 
                shift 
              ;;
              '-gtf')
                genome_gtf="$2"
                gtf=1
                shift 
                shift 
              ;;
              '-version')
                genome_version="$2"
                shift 
                shift 
              ;;
              '-descfilter')
                desctext="$2"
                text="1"
                shift 
                shift 
              ;;
              '-minlength')
                length=1
                minlength="$2"
                shift
                shift
              ;;
              '-only_bwa')
                INDEX_BOWTIE=0
                INDEX_BOWTIE2=0
                shift
              ;;
	      '-only_bowtie2')
                INDEX_BOWTIE=0
                INDEX_BWA=0
                shift
              ;;

              *)
                species="$1"
                ensembl=1
                shift 
              ;; 

    esac
done

if [[ $chipster_path == "0" ]]
then
  echo ""  
  echo "Please define the location of the tools directory of Chipster with option:"
  echo "  -chipster_path /path/to/tools"
  echo
  exit 1
fi 
tools_path="$chipster_path""/tools"
comp_path="$chipster_path""/comp"
export PATH=${PATH}:$comp_path/modules/admin/shell/:$tools_path/emboss/bin/

##
#Retrieve the fasta file
##

#Check if  taxid is used in stead of name

taxid=$(echo $species | tr -d "[a-z,A-Z]" )
species=$(echo $species | sed s/" "/"_"/g )
#test for taxnumber
if [[ "$species" == "$taxid" ]]
then
  species=$(taxget taxon:$taxid -oformat excel -filter | sed s/" "/"_"/g | awk '{print $5}')
  echo "Taxid: $taxid corresponds species: $species"
else
  tax_name=$(echo $species | sed s/"_"/" "/g )
  taxid=$(grep -i "|.$tax_name.|" $tools_path/emboss/share/EMBOSS/data/TAXONOMY/names.dmp  | awk '{print $1}')
fi


echo $species $taxid

#reading the data from ensembl

echo $ensembl

if [[ $ensembl -eq 1 ]]
then
  echo "Retrtieving and indexing genome sequence for $species"

  cd ${tools_path}/genomes/fasta/nochr
  echo ensemblfetch.sh $species
  genome_fasta=$(ensemblfetch.sh $species | tail -1)

  if [[ $genome_fasta == "--------------------------------------------------------------------------------" ]]
  then
    echo Species $species was not found from the Ensembl database.
    exit 1
  fi

  genome_release=$(echo $genome_fasta | awk -F "." '{print $2}')

  #Try to find the build name
  wget "http://hgdownload.soe.ucsc.edu/admin/hgcentral.sql"
  # Take only inserts of table dbDB
  cat hgcentral.sql |grep "INSERT INTO \`dbDb\`" > dbDb.txt
  # Take only specific columns
  cat dbDb.txt | cut -d "(" -f 4- |cut -d "'" -f 1,11,16 > release-ucsc.txt
  # Remove some characters
  sed -i 's/)//g' release-ucsc.txt
  sed -i 's/;//g' release-ucsc.txt
  sed -i 's/,//g' release-ucsc.txt
  # Replace slash and quotes with tab
  sed -i 's/\//	/g' release-ucsc.txt #note tab
  sed -i "s/'/	/g" release-ucsc.txt #note tab


  version=$(awk '{if ( $1=="'$genome_release'" ) if ( $NF=="'$taxid'") print $2}' release-ucsc.txt) 
  rm -f release-ucsc.txt
  rm -f hgcentral.sql
  rm -f dbDb.txt
  if [[ $version == "" ]]
  then
    version=$genome_release
  fi

fi



if [[ $fasta -eq 1 ]]
then
  cp $genome_fasta ${tools_path}/genomes/fasta/
  cd ${tools_path}/genomes/fasta
fi


##
#Check if the fasta file as already been indexed
##

size=$(ls -l $genome_fasta | awk '{print $5}')
checksum=$(md5sum $genome_fasta | awk '{print $1}')

#look for matching size and md5sum

genome_check=$(grep -h $size $tools_path/genomes/genome_list | grep $checksum | awk '{print $1}' | tail -1)


#
if [ ! $genome_check == "" ]; then
  echo "File $genome_fasta has alredy been indexed"
  exit 0
fi


if [[ "$text" == "1" ]]
  then
  textsearch  -sequence $genome_fasta -pattern "$desctext" -outfile outfile_"$$"_list -only -usa -auto >> /dev/null
  test=$(head outfile_"$$"_list | wc -l) 
  if [[ $test -eq 0 ]] 
  then 
     echo "No sequences matching search pattern: $desctext were found" > $outfile
     rm -rf outfile_"$$"_list
     exit 1
  fi
  seqret @outfile_"$$"_list -outseq ${genome_fasta}.filtered -auto
  rm -f $genome_fasta
  mv ${genome_fasta}.filtered $genome_fasta
fi



###
#  get the gtf file
###
if [[ $ensembl -eq 1 ]]
then
  cd ${tools_path}/genomes/gtf
  ensemblfetch.sh -type gtf $species
fi

if [[ $gtf -eq 1 ]]
then
  cp $location/$genome_gtf ${tools_path}/genomes/gtf/
fi



###

#make bwa_indexes
if [[ $INDEX_BWA -eq 1 ]]
then
  echo -------------------------------------------------------
  echo Calculating BWA indexes for $genome_fasta
  cd $tools_path/bwa_indexes
  if [[ $ensembl -eq 1 ]]
  then
    ln -s $tools_path/genomes/fasta/nochr/$genome_fasta $genome_fasta
  else 
    ln -s $tools_path/genomes/fasta/$genome_fasta $genome_fasta
  fi
  $tools_path/bwa/bwa index $genome_fasta
else
  echo "Skipping BWA indexing"
fi


#make bowtie_indexes
if [[ $INDEX_BOWTIE -eq 1 ]]
then
  echo -------------------------------------------------------
  echo Calculating Bowtie indexes for $genome_fasta 
  cd $tools_path/bowtie/indexes
  if [[ $ensembl -eq 1 ]]
  then
   ln -s $tools_path/genomes/fasta/nochr/$genome_fasta $genome_fasta
  else
   ln -s $tools_path/genomes/fasta/$genome_fasta $genome_fasta
  fi
  bowtie_name=$(basename $genome_fasta .fa)
  $tools_path/bowtie/bowtie-build $genome_fasta $bowtie_name

  #check bowtie2 indexes
  n_genome=$(grep -c "^>" $genome_fasta)
  n_index=$($tools_path/bowtie/bowtie-inspect -n $bowtie_name | wc -l)

  if [[ $n_genome -ne $n_index ]]
  then
     echo "ERROR: Bowtie indexing of genome $bowtie2_name failed"
     exit 1
  else
    echo Bowtie index of genome $bowtie_name OK
  fi
else
    echo "Skipping Bowtie indexing"
fi





#make bowtie2_indexes
if [[ $INDEX_BOWTIE2 -eq 1 ]]
then
  echo -------------------------------------------------------
  echo Calculating Bowtie2 indexes for $genome_fasta 

  cd $tools_path/bowtie2/indexes
  if [[ $ensembl -eq 1 ]]
  then
   ln -s $tools_path/genomes/fasta/nochr/$genome_fasta $genome_fasta
  else
    ln -s $tools_path/genomes/fasta/$genome_fasta $genome_fasta
  fi
  bowtie2_name=$(basename $genome_fasta .fa)
  $tools_path/bowtie2/bowtie2-build $genome_fasta $bowtie2_name

  #check bowtie2 indexes
  n_genome=$(grep -c "^>" $genome_fasta)
  n_index=$($tools_path/bowtie2/bowtie2-inspect -n $bowtie2_name | wc -l)

  if [[ $n_genome -ne $n_index ]]
  then
     echo "ERROR: Bowtie2 indexing of genome $bowtie2_name failed"
     exit 1
  else
    echo Bowtie2 index of genome $bowtie2_name OK
  fi
else
    echo "Skipping Bowtie indexing"
fi

day=$(date)
echo $taxid $species $genome_fasta $version $size $day $checksum >> $tools_path/genomes/genome_list

#!/bin/bash 
while [[ $# -ge 1 ]]
do
  case "$1" in
              '-chipster_path')
	      chipster_path="$2"
                shift
                shift
              ;;
              #
              '-species')
                species="$2"
                shift 
                shift 
              ;;
              *)
                species="$1"
                shift 
              ;; 
  esac
done

tools_path="$chipster_path""/tools"
export PATH=${PATH}:"$chipster_path"/comp/modules/admin/shell/:"$tools_path"/emboss/bin/

ensembl=0
fasta=0
gtf=0
text=0
length=0
version="0.0"
location=$(pwd)
INDEX_BWA=1
INDEX_BOWTIE=1
INDEX_BOWTIE2=1


#remove bwa_indexes
if [[ $INDEX_BWA -eq 1 ]]
then
  echo -------------------------------------------------------
  echo removing BWA indexes for $species
  rm $tools_path/bwa_indexes/$species.fa.amb
  rm $tools_path/bwa_indexes/$species.fa.ann
  rm $tools_path/bwa_indexes/$species.fa.bwt
  rm $tools_path/bwa_indexes/$species.fa.pac 
  rm $tools_path/bwa_indexes/$species.fa.sa
fi

#remove bowtie_indexes
if [[ $INDEX_BOWTIE -eq 1 ]]
then
  echo -------------------------------------------------------
  echo removing Bowtie indexes for $species
  rm $tools_path/bowtie/indexes/$species.1.ebwt
  rm $tools_path/bowtie/indexes/$species.2.ebwt
  rm $tools_path/bowtie/indexes/$species.3.ebwt
  rm $tools_path/bowtie/indexes/$species.4.ebwt
  rm $tools_path/bowtie/indexes/$species.rev.1.ebwt
  rm $tools_path/bowtie/indexes/$species.rev.2.ebwt
fi

#remove bowtie2_indexes
if [[ $INDEX_BOWTIE2 -eq 1 ]]
then
  echo -------------------------------------------------------
  echo removing Bowtie2 indexes for $species
  rm $tools_path/bowtie2/indexes/$species.1.bt2
  rm $tools_path/bowtie2/indexes/$species.2.bt2
  rm $tools_path/bowtie2/indexes/$species.3.bt2
  rm $tools_path/bowtie2/indexes/$species.4.bt2
  rm $tools_path/bowtie2/indexes/$species.rev.1.bt2
  rm $tools_path/bowtie2/indexes/$species.rev.2.bt2
fi

if [[ -e $tools_path/genomes/fasta/$species.fa ]]
then
   rm $tools_path/genomes/fasta/$species.fa
fi 

if [[ -e $tools_path/genomes/fasta/nochr/$species.fa ]]
then 
   rm $tools_path/genomes/fasta/nochr/$species.fa
fi 


species_gtf=$(echo $species | sed s/".dna.toplevel"/""/g) 
if [[ -e  $tools_path/genomes/gtf/$species_gtf.gtf ]]
then
  rm $tools_path/genomes/gtf/$species_gtf.gtf
fi


awk '{ if ( $3 != "'$species.fa'" ) print $0}' $tools_path/genomes/genome_list > $tools_path/genomes/genome_list.tmp.$$
rm $tools_path/genomes/genome_list
mv $tools_path/genomes/genome_list.tmp.$$ $tools_path/genomes/genome_list

# ------------------------------------------------------------------------
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ------------------------------------------------------------------------

# ==================================================================
# Helper script to run the IBM JMS performance harness against
# the ActiveMQ message broker.
#
# Sample Usage: 
#   ./perfharness-activemq.sh -d dynamicQueues/FOO -tc jms.r11.PutGet -nt 6
#
# It assumes that the apache-activemq-5.0-SNAPSHOT.jar and 
# perfharness.jar files are in the current directory.  If they are not,
# set the ACTIVEMQ_HOME and PERFHARNESS_HOME env variable to the correct location.
#
# You can download the perfharness.jar file from:
# http://www.alphaworks.ibm.com/tech/perfharness
#
# By Default the test connects the the vm://localhost broker.  To change that, use
# set the BROKER_URL to the broker url you want to use.
#
# ==================================================================

if [ -z "$PERFHARNESS_HOME" ] ; then
   PERFHARNESS_HOME=.
fi

if [ -z "$ACTIVEMQ_HOME" ] ; then
   ACTIVEMQ_HOME=../..
fi

if [ -z "$BROKER_URL" ] ; then
   BROKER_URL='vm://(broker://()/localhost?useJmx=false)/localhost'
fi

java ${JAVA_OPTIONS} -cp ${ACTIVEMQ_HOME}/apache-activemq-5.0-SNAPSHOT.jar:${PERFHARNESS_HOME}/perfharness.jar JMSPerfHarness -pc JNDI -ii org.apache.activemq.jndi.ActiveMQInitialContextFactory -iu $BROKER_URL -cf ConnectionFactory -d dynamic$DESTINATION $@

#!/bin/bash

chipster_path="0"

while [[ $# -ge 1 ]]
do
  case "$1" in
             '-chipster_path')
	      chipster_path="$2"
                shift
                shift
              ;;
              #
  esac
done


if [[ $chipster_path == "0" ]]
then
  echo ""  
  echo "Please define the location of the tools directory of Chipster with option:"
  echo "  -chipster_path /path/to/tools"
  echo
  exit 1
fi 

tools_path="$chipster_path""/tools"
comp_path="$chipster_path""/comp"

export PATH=${PATH}:$chipster_path/comp/modules/admin/shell/:$chipster_path/tools/emboss/bin/

#echo "BWA indexes"
#ls -l $tools_path/bwa_indexes/*.bwt | awk -F "/" '{print "   "$NF}' | sed s/'.fa.bwt'/""/g 
ls -l $tools_path/bwa_indexes/*.bwt | awk -F "/" '{print "   "$NF}' | sed s/'.fa.bwt'/""/g | tr -d " " > index_list_$$.bwa.tmp
grep PARAMETER $comp_path/modules/ngs/R-2.12/bwa* | grep genome: | awk -F "[" '{print $2}' | awk -F "]" '{print $1}' | tr "," "\n" | awk -F : '{print $1}' | sort | uniq | tr -d  " " |  sed s/'\.fa$'/""/g > genomes_in_bwa_interface.$$.tmp

echo "--------------------------------------------------------------------------------------------------------------------------"
echo "BWA index summary"
cat index_list_$$.bwa.tmp genomes_in_bwa_interface.$$.tmp genomes_in_bwa_interface.$$.tmp | sort | uniq -c | \
awk '{ if ($1 == "1" ) printf "%60s\tIndexed but not in use\n", $2 }{if ($1 == "2" ) printf "%60s\tIndex missing!\n", $2}{if ( $1 == "3" ) printf "%60s\tOK\n", $2}'
echo "---------------------------------------------------------------------------------------------------------------------------"


#echo "Cheking Bowtie indexes"
ls -l $tools_path/bowtie/indexes/*.rev.2.ebwt | awk -F "/" '{print "   "$NF}' | sed s/'.rev.2.ebwt'/""/g | tr -d " " >> index_list_$$.bowtie.tmp

grep PARAMETER $comp_path/modules/ngs/R-2.12/bowtie[.-]* | grep genome: | awk -F "[" '{print $2}' | awk -F "]" '{print $1}' | tr "," "\n" | awk -F : '{print $1}' | sort | uniq | tr -d  " " |  sed s/'\.fa$'/""/g > genomes_in_bowtie_interface.$$.tmp
#echo "--------------------------------------------------------------------------------------------------------------------------"
echo "Bowtie index summary"
cat index_list_$$.bowtie.tmp genomes_in_bowtie_interface.$$.tmp genomes_in_bowtie_interface.$$.tmp | sort | uniq -c | \
awk '{ if ($1 == "1" ) printf "%60s\tIndexed but not in use\n", $2 }{if ($1 == "2" ) printf "%60s\tIndex missing!\n", $2}{if ( $1 == "3" ) printf "%60s\tOK\n", $2}'
echo "---------------------------------------------------------------------------------------------------------------------------"

#echo "Chreking Bowtie2 indexes"
ls -l $tools_path/bowtie2/indexes/*.rev.1.bt2 | awk -F "/" '{print "   "$NF}' | sed s/'.rev.1.bt2'/""/g | tr -d " " >> index_list_$$.bowtie2.tmp

grep PARAMETER $comp_path/modules/ngs/R-2.12/bowtie2* | grep genome: | awk -F "[" '{print $2}' | awk -F "]" '{print $1}' | tr "," "\n" | awk -F : '{print $1}' | sort | uniq | tr -d  " " |  sed s/'\.fa$'/""/g > genomes_in_bowtie2_interface.$$.tmp
#echo "--------------------------------------------------------------------------------------------------------------------------"
echo "Bowtie2 index summary"
cat index_list_$$.bowtie2.tmp genomes_in_bowtie2_interface.$$.tmp genomes_in_bowtie2_interface.$$.tmp | sort | uniq -c | \
awk '{ if ($1 == "1" ) printf "%60s\tIndexed but not in use\n", $2 }{if ($1 == "2" ) printf "%60s\tIndex missing!\n", $2}{if ( $1 == "3" ) printf "%60s\tOK\n", $2}'
echo "---------------------------------------------------------------------------------------------------------------------------"

#cheking gtf
ls -l $tools_path/genomes/gtf/*.gtf | grep -v DEXSeq | awk -F "/" '{print "   "$NF}' | sed s/'.gtf'/""/g | tr -d " " >> gtf_list_$$.gtf.tmp

#cheking fa
ls -l $tools_path/genomes/fasta/*.fa | awk -F "/" '{print "   "$NF}' | sed s/'\.fa$'/""/g | tr -d " " >> index_list_$$.fa.tmp

#cheking fa
ls -l $tools_path/genomes/fasta/nochr/*.fa | awk -F "/" '{print "   "$NF}' | sed s/'\.fa$'/""/g | tr -d " " >> index_list_$$.fa_nochr.tmp


echo "Summary of genome indexes and files"
echo
printf "%60s %7s %7s %7s %7s %7s %7s \n" Species BWA Bowtie Bowtie2 gtf fasta fasta_nochr
echo "----------------------------------------------------------------------------------------------------------"


for ind in $(sort index_list_$$.*.tmp | uniq)
do
 bwa_m=$(grep -c $ind index_list_$$.bwa.tmp)
 if [[ bwa_m -eq 1 ]]
 then
    bwa_m="OK"
 else
    bwa_m="-"
 fi

 bt_m=$(grep -c $ind index_list_$$.bowtie.tmp)
 if [[ bt_m -eq 1 ]]
 then
    bt_m="OK"
 else
    bt_m="-"
 fi

 bt2_m=$(grep -c $ind index_list_$$.bowtie2.tmp)
 if [[ bt2_m -eq 1 ]]
 then
    bt2_m="OK"
 else
    bt2_m="-"
 fi

 ind2=$(echo $ind | sed s/"\.dna\.toplevel"/""/g )  
 gtf_m=$(grep -c $ind2 gtf_list_$$.gtf.tmp)
 if [[ gtf_m -eq 1 ]]
 then
    gtf_m="OK"
 else
    gtf_m="-"
 fi

 fa_m=$(grep -c $ind index_list_$$.fa.tmp)
 if [[ fa_m -eq 1 ]]
 then
    fa_m="OK"
 else
    fa_m="-"
 fi

 fa_nochr_m=$(grep -c $ind index_list_$$.fa_nochr.tmp)
 if [[ fa_nochr_m -eq 1 ]]
 then
    fa_nochr_m="OK"
 else
    fa_nochr_m="-"
 fi

 printf "%60s %7s %7s %7s %7s %7s %7s \n" $ind $bwa_m $bt_m $bt2_m $gtf_m $fa_m $fa_nochr_m

# echo $ind $bwa_m $bt_m $bt2_m
done

rm -f *_$$.*.tmp 

#!/bin/bash 
# A script to fetch datasets from the ensembl website
# 23.7. 2010 KM
# Updated 4.11. 2011 KM

TMPDIR="/tmp"

if [[ "$1" == "" ]]
 then
   echo give a species name
   exit
fi


seqtype=("dna")
mode=("single")
outputmode=("single")


while [[ $# -ge 1 ]]
do
  case "$1" in
             #data type
             '-type')
                seqtype="$2"
                shift
                shift
              ;;
              #
              '-names')
                  echo "Retrieving the list of available species names:"
                   mkdir tmp_$$
                   cd tmp_$$
                   echo ftp://ftp.ensembl.org/pub/current_fasta/ > ensembl_list
                   echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/bacillus_collection/ >> ensembl_list
                   echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/borrelia_collection/ >> ensembl_list
                   echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/buchnera_collection/ >> ensembl_list
                   echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/escherichia_shigella_collection/ >> ensembl_list
                   echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/mycobacterium_collection/ >> ensembl_list
                   echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/neisseria_collection/ >> ensembl_list
                   echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/pyrococcus_collection/ >> ensembl_list
                   echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/staphylococcus_collection/ >> ensembl_list
                   echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/streptococcus_collection/ >> ensembl_list
                   echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/wolbachia_collection/ >> ensembl_list
                   echo ftp://ftp.ensemblgenomes.org/pub/fungi/current/fasta/ >> ensembl_list
                   echo ftp://ftp.ensemblgenomes.org/pub/metazoa/current/fasta/  >> ensembl_list
                   echo ftp://ftp.ensemblgenomes.org/pub/plants/current/fasta/ >> ensembl_list
                   echo ftp://ftp.ensemblgenomes.org/pub/protists/current/fasta/  >> ensembl_list
                   wget -S -o log -i ensembl_list >> /dev/null
                   if [[ -e "$TMPDIR/ensembl_urls" ]]
                   then
                     rm -rf $TMPDIR/ensembl_urls
                   fi
                   grep Directory index.html* | grep -v "ensembl.org:21/pub/current_fasta/caenorhabditis_elegans" | grep -v "ensembl.org:21/pub/current_fasta/saccharomyces_cerevisiae" | grep -v "ensembl.org:21/pub/current_fasta/drosophila_melanogaster" | awk -F \" '{print $2}' > $TMPDIR/ensembl_urls    
                   cd ..
                   cat $TMPDIR/ensembl_urls |\
                     sed s/"bacillus_collection\/b_"/"bacillus_"/g | \
                     sed s/"borrelia_collection\/b_"/"borrelia_"/g | \
                     sed s/"buchnera_collection\/b_"/"buchnera_"/g | \
                     sed s/"escherichia_shigella_collection\/e_"/"escherichia_"/g | \
                     sed s/"escherichia_shigella_collection\/s_"/"shigella_"/g | \
                     sed s/"mycobacterium_collection\/m_"/"mycobacterium_"/g | \
                     sed s/"neisseria_collection\/n_"/"neisseria_"/g | \
                     sed s/"pyrococcus_collection\/p_"/"pyrococcus_"/g |\
                     sed s/"streptococcus_collection\/s_"/"streptococcus_"/g |\
                     sed s/"staphylococcus_collection\/s_"/"staphylococcus_"/g |\
                   awk -F "/" '{print $(NF-1)}' | sort
                   rm -rf  tmp_$$/
                   exit
               ;;
              '-list')
                  namelist=($2)
                  spec="species in file $namelist"
                  if ![[ -e "$namelist" ]]
                  then
                     echo "Species name list file: $namelist not found!"
                     exit
                  fi
                  shift
                  shift
                  mode=("list")
              ;;
              '-out')
               outfile=($2)
                  if [[ -e "$outfile" ]]
                  then
                     echo "Result file: $outfile already exists!"
                     exit
                  fi
                  shift
                  shift
                  outputmode=("file")
              ;;
              '-help')
                 echo " ----------------------------------------------------------------------------------"
                 echo " ensemblfetch retrieves genomic, cDNA or peptide sequences of a given species from "
                 echo " the ensembl or ensembl genomes ftp site."
                 echo " "
                 echo " Usage:"
                 echo "   ensemblfetch [-options] species_name"
                 echo ""
                 echo " ensemblfetch options:"
                 echo "  -names  List the available species names "
                 echo "  -type   Select the data type to retrieve (Default: dna) "
                 echo "          Available data types are: dna, dna_rm, cdna, cdna_abinitio, pep, pep_abinitio"
                 echo "  -list   List of species to retrieve"
                 echo "  -out    Output file name" 
                 echo "  -help   print this help"
                 echo " "
                 exit
              ;;
              *)
                spec=($1)
                shift                       # No more switches
              ;;
    esac
done
case "$seqtype" in
    "dna")
       echo "Retrieving genomic DNA for $spec"
     ;;
     "dna_rm")
       echo "Retrieving repeat masked genomic DNA for $spec"
     ;;
     "cdna")
       echo "Retrieving sequences for all transcript (known, novel and pseudo) for $spec" 
     ;;
     "cdna_abinitio")
       echo "Retrieving sequences for ab-initio prediction transcripts for $spec"
     ;;
     "pep")
       echo "Retrieving sequences for all all known and novel peptides for $spec"
     ;;
     "pep_abinitio")
       echo "Retrieving sequences for all abinitio predicted peptides for $spec"
     ;;
     *)
         echo "Unknown data type"
         echo "Please use one of the following types:"
         echo "  dna"
         echo "  dna_rm"
         echo "  cdna"
         echo "  cdna_abinitio"
         echo "  pep"
         echo "  pep_abinitio"
         exit
     ;;
esac


mkdir tmp_$$
cd tmp_$$

if [[ ! -e $TMPDIR/ensembl_urls ]]
then
  echo ftp://ftp.ensembl.org/pub/current_fasta/ > ensembl_list
  echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/bacillus_collection/ >> ensembl_list
  echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/borrelia_collection/ >> ensembl_list
  echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/buchnera_collection/ >> ensembl_list
  echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/escherichia_shigella_collection/ >> ensembl_list
  echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/mycobacterium_collection/ >> ensembl_list
  echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/neisseria_collectio/ >> ensembl_list
  echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/pyrococcus_collection/ >> ensembl_list
  echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/staphylococcus_collection/ >> ensembl_list
  echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/streptococcus_collection/ >> ensembl_list
  echo ftp://ftp.ensemblgenomes.org/pub/bacteria/current/fasta/wolbachia_collection/ >> ensembl_list
  echo ftp://ftp.ensemblgenomes.org/pub/fungi/current/fasta/ >> ensembl_list
  echo ftp://ftp.ensemblgenomes.org/pub/metazoa/current/fasta/  >> ensembl_list
  echo ftp://ftp.ensemblgenomes.org/pub/plants/current/fasta/ >> ensembl_list
  echo ftp://ftp.ensemblgenomes.org/pub/protists/current/fasta/  >> ensembl_list

  echo "Getting the name list"
  wget -S -o log -i ensembl_list >> /dev/null
  grep Directory index.html* | grep -v "ensembl.org:21/pub/current_fasta/caenorhabditis_elegans" | grep -v "ensembl.org:21/pub/current_fasta/saccharomyces_cerevisiae" | awk -F \" '{print $2}' > $TMPDIR/ensembl_urls
fi


if [[ $seqtype == "dna" ]]
then
   awk '{print $1"dna/*.dna.toplevel.fa.gz"}' $TMPDIR/ensembl_urls > ensembl_species.txt
fi

if [[ $seqtype == "dna_rm" ]]
then
   awk '{print $1"dna/*.dna_rm.toplevel.fa.gz"}' $TMPDIR/ensembl_urls > ensembl_species.txt
fi

if [[ $seqtype == "cdna" ]]
then
   awk '{print $1"cdna/*.cdna.all.fa.gz"}' $TMPDIR/ensembl_urls > ensembl_species.txt
fi

if [[ $seqtype == "cdna_abinitio" ]]
then
   awk '{print $1"cdna/*.cdna.abinitio.fa.gz"}' $TMPDIR/ensembl_urls > ensembl_species.txt
fi

if [[ $seqtype == "pep" ]] 
then
   awk '{print $1"pep/*.pep.all.fa.gz"}' $TMPDIR/ensembl_urls > ensembl_species.txt
fi

if [[ $seqtype == "pep_abinitio" ]]
then
   awk '{print $1"pep/*.pep.abinitio.fa.gz"}' $TMPDIR/ensembl_urls > ensembl_species.txt
fi

echo $seqrype 


##Korjaus listaan koska metazoalle ei ole dna, cdna ja pep kansioita
#grep metazoa ensembl_species.txt | sed s/"\/dna\/"/"\/"/g | sed s/"\/cdna\/"/"\/"/g | sed s/"\/pep\/"/"\/"/g > ensembl_species.txt_korj
#grep -v metazoa ensembl_species.txt >> ensembl_species.txt_korj
#rm -f ensembl_species.txt
#mv ensembl_species.txt_korj ensembl_species.txt


cd ..

if [[ $mode == "single" ]]
then 
   echo "$spec" | tr "[:upper:]" "[:lower:]" | sed s/" "/"_"/g  > tmp_$$/namelist
else
   cat $namelist | tr "[:upper:]" "[:lower:]" | sed s/" "/"_"/g > tmp_$$/namelist
fi

for species in $(cat tmp_$$/namelist)
do
  #bakteerien nimet vaativat korjauksen:
  species=$(echo $species | \
                     sed s/"bacillus_"/"b_"/g | \
                     sed s/"borrelia_"/"b_"/g | \
                     sed s/"buchnera_"/"b_"/g | \
                     sed s/"escherichia_"/"e_"/g | \
                     sed s/"shigella_"/"s_"/g | \
                     sed s/"mycobacterium_"/"m_"/g | \
                     sed s/"neisseria_"/"n_"/g | \
                     sed s/"pyrococcus_"/"p_"/g |\
                     sed s/"streptococcus_"/"s_"/g |\
                     sed s/"staphylococcus_"/"s_"/g )
  numhits=$(grep -i "/$species/" tmp_$$/ensembl_species.txt| wc -l)

  if [[ $numhits -eq 0 ]]
  then
    echo "--------------------------------------------------------------------------------"
    echo "The species name: $species was not found from "
    echo "the ensembl and ensembl genomes databases"
    echo "--------------------------------------------------------------------------------"
  fi

  if [[ $numhits -eq 1 ]]
  then
    url=$(grep -i "/$species/" tmp_$$/ensembl_species.txt)
    name=$(grep -i "/$species/" tmp_$$/ensembl_species.txt | awk -F "/" '{print $(NF-2)}' )
    filename=$(grep -i "/$species/" tmp_$$/ensembl_species.txt | awk -F "/" '{print $(NF)}' )
    echo
    echo "Downloading the genomic sequece of $name"
    echo 
    wget -o log "$url" >> /dev/null
    gzipfile=$(ls $filename | grep -i $species)
    echo "Unzipping $gzipfile"
    if [[ $outputmode == "single" ]]
    then
      gunzip $gzipfile
      echo "The results have been wirtten to a file:"
      echo $gzipfile | sed s/".gz"/""/g
    else
      gunzip < $gzipfile >>! $outfile
      rm -f $gzipfile
    fi
  fi


  if [[ $numhits > 1 ]]
  then
    echo " "
    echo "Several genomes match to the given species name"
    echo "Please select a uniqe species name "
    echo ""
    echo "The list of matching species names:"
    grep -i "/$species/" tmp_$$/ensembl_species.txt | awk -F "/" '{print $(NF-2)}'

  fi
done


rm -rf tmp_$$

#!/bin/bash

CHIPSTER_HOME="$(dirname "$(readlink -f ${BASH_SOURCE[0]})")/../.."
COMPONENT=$1
COMMAND=$2

# platform, should be linux-x86-32, linux-x86-64 or macosx (autodetected if not set)
PLATFORM=""


# detect if platform not set
if [ ! $PLATFORM ]; then

	OS=`uname`
	
    if [ "$OS" = "Linux" ]; then
		ARCH=`uname -m`
		if [ "$ARCH" = "i686" ]; then
			PLATFORM="linux-x86-32"
		elif [ "$ARCH" = "x86_64" ]; then
			PLATFORM="linux-x86-64"
		fi
	else
		# assume Mac OS X
		PLATFORM="macosx"
	fi		
fi
if [ ! $PLATFORM ]; then
	echo "Could not detect hardware architecture, please set platform manually."
	exit -1;
fi


# run command
$CHIPSTER_HOME/$COMPONENT/bin/$PLATFORM/chipster-$COMPONENT $COMMAND

#!/bin/bash 
#
#Automatic index cheking and indexing toold for bwa indexes
#NOTE! Does not do color space indexes
#K.M. 12.1. 2012

bowtie2_path=("/opt/chipster/tools/bowtie2")


if [ -d "/tmp" ]; then
   mkdir -p "/tmp/bowtie2_indexes/tmp"
   index_path=("/tmp/bowtie2_indexes/tmp")
else
   index_path=("./")
fi

genome=($1)
size=(`ls -l $genome | awk '{print $5}' `)
checksum=(`md5sum $genome | awk '{print $1}'`)
location=(`pwd`)

if [ ! -d $index_path/genome_0 ]; then
  mkdir $index_path/genome_0
fi


#look for matching size and md5sum
genome_dir=(`grep -h $size $index_path/genome_*/size_and_md5 | grep $checksum | awk '{print $1}' | tail -1`)


#
if [ ! $genome_dir == "" ]; then
   echo "Pre-indexed genome found"
else
   echo "Calculating indexes"
   cd $index_path
   genome_dir=(`ls -d genome_* | awk -F "_" '{ print $NF }' | sort -n | tail -1 | awk '{ a = ( $1 + 1 ) }{print "genome_"a}'`)
   mkdir $genome_dir
   cd $genome_dir
   cp "$location"/"$genome" ./$genome
  

   $bowtie2_path/bowtie2-build $genome $genome 


   #check that idexes are found
   echo "$genome"
   for f in 1.bt2 2.bt2 3.bt2 4.bt2 rev.1.bt2 rev.2.bt2; do
       if [ -e "$genome"."$f" ]; then
         echo "$genome.$f OK"
       else
         echo "Indexing failed"
         echo "Index file $genome.$f not found"
         exit 1
       fi
   done
   echo "$genome_dir $size $checksum" > size_and_md5
   cd $location
fi

echo "The bowtie2_indexes are in directory:"
echo "$index_path/$genome_dir"
exit 
